*DECK ADJCAL
      SUBROUTINE ADJCAL(IPPROC,IPLDEV,IPGEOM,INSR,IPRT)
*
**********************************************************************
*
*     THIS SUBROUTINE COMPUTES ROD POSITION IN FRACTION
*     OF FULL INSERTION OR WITHDRAWAL
*
*     CETTE ROUTINE CALCULE LA POSITION DES BARRES EN
*     % D'INSERTION OU D'EXTRACTION
*
*     INPUT :
*              IPLDEV : INTEGER
*                       ADRESS OF DEVICE OBJECT
*              IPGEOM : INTEGER
*                       ADRESS OF GEOMETRY OBJECT
*              INSR   : LOGICAL; = .TRUE.  FOR INSERTION
*                                = .FALSE. FOR WITHDRAWAL
*              IPRT   : INTEGER
*                       PRINT FLAG
*     OUTPUT :
*              IPPROC : INTEGER
*                       ADRESS OF PROCEDE OBJECT
*
*-------------------------------------- AUTHOR: E. VARIN  95/02/10 ---
*
*
*      IMPLICIT NONE
      INTEGER      IPPROC,IPLDEV,IPRT,IPGEOM
*
*     PROCEDE STRUCTURE
*
      REAL         PAD,AUX
*
*     GEOM STRUCTURE
*
      INTEGER      NREG,ISTATE(13)
C SETARA VARIABLES
      REAL BASE
      INTEGER IBASE(1)
      COMMON BASE(1)
      EQUIVALENCE (BASE(1),IBASE(1))
*
*     DEVICE STRUCTURE
*
      REAL         POS(6,10),PMAX(6)
      CHARACTER*4  MOVDIR
*
      CHARACTER*12 TEXT,NMLCM,MYNAM,NXSEQ,FIRSTS,
     +             NMLCM1,MYNAM1,FIRST,TEXT1
      INTEGER      ITYP,ILONG,I,IXM,IXP,IYM,IYP,IZM,IZP,
     +             ITYP1,ILONG1,CPT,IPOS,IMESH,IMOV
      REAL         DIFF,DIFFM
      LOGICAL      LCM,LCM1,INSR
*
      CALL LCMSIX(IPGEOM,' ',0)
      CALL LCMGET(IPGEOM,'STATE',ISTATE)
*
      NXSEQ = ' '
      CALL LCMNXT(IPLDEV,NXSEQ,NMLCM,MYNAM,LCM)
      FIRSTS=NXSEQ
10    CALL LCMNXT(IPLDEV,NXSEQ,NMLCM,MYNAM,LCM)
      CALL LCMLEN(IPLDEV,NXSEQ,ILONG,ITYP)
      IF (ITYP.EQ.0) THEN
*  LEVEL SEQUEN
       CALL LCMSIX(IPLDEV,NXSEQ,1)
       CALL LCMSIX(IPPROC,NXSEQ,1)
       CALL LCMGET(IPLDEV,'POSITION_MAX',PMAX)
       CALL LCMGET(IPLDEV,'MOVEMENT_DIR',IMOV)
       WRITE(MOVDIR,'(A4)') IMOV
       TEXT = ' '
       CPT = 0
       I = 0
       CALL LCMNXT(IPLDEV,TEXT,NMLCM1,MYNAM1,LCM1)
       FIRST=TEXT
 20    CALL LCMNXT(IPLDEV,TEXT,NMLCM1,MYNAM1,LCM1)
       CALL LCMLEN(IPLDEV,TEXT,ILONG1,ITYP1)
       IF (ITYP1.EQ.0) THEN
*  LEVEL DESCRIPT
         I = I + 1
         CALL LCMSIX(IPLDEV,TEXT,1)
         CALL LCMSIX(IPPROC,TEXT,1)
         CALL LCMGET(IPPROC,'NPOS',IPOS)
         CALL LCMGET(IPLDEV,'POSITION',POS(1,IPOS))
         CALL LCMSIX(IPPROC,' ',2)
         CALL LCMSIX(IPLDEV,' ',2)
       ENDIF
       IF (TEXT.EQ.FIRST) GOTO 30
       GOTO 20
*
 30    CPT = I
       IF (MOVDIR.EQ.'X') THEN
         IXM = 3
         IXP = 4
         IYM = 1
         IYP = 2
         IZM = 5
         IZP = 6
         NREG = ISTATE(3)
         CALL SETARA(BASE,NREG+1,IMESH)
         CALL LCMGET(IPGEOM,'MESHX',BASE(IMESH))
       ELSEIF (MOVDIR.EQ.'Y') THEN
         IXM = 1
         IXP = 2
         IYM = 3
         IYP = 4
         IZM = 5
         IZP = 6
         NREG = ISTATE(4)
         CALL SETARA(BASE,NREG+1,IMESH)
         CALL LCMGET(IPGEOM,'MESHY',BASE(IMESH))
       ELSEIF (MOVDIR.EQ.'Z') THEN
         IXM = 1
         IXP = 2
         IYM = 5
         IYP = 6
         IZM = 3
         IZP = 4
         NREG = ISTATE(5)
         CALL SETARA(BASE,NREG+1,IMESH)
         CALL LCMGET(IPGEOM,'MESHZ',BASE(IMESH))
       ENDIF
*
*      CALCULATION OF THE ROD NXSEQ POSITION
*
       DIFFM = PMAX(IYP) - BASE(IMESH)
       DIFF  = POS(IYP,CPT) - BASE(IMESH)
       PAD   = DIFF / DIFFM
       CALL SRLIMT(PAD,0.0,1.0,1)
       TEXT1 = ' INSERTION '
       IF (.NOT.INSR) THEN
          AUX = 1. - PAD
          TEXT1 = ' WITHDRAWAL '
       ELSE
          AUX = PAD
       ENDIF
       IF (IPRT.GT.3) THEN
         WRITE(6,*) 'DEVICE ',NXSEQ,' POSITION ',
     >               AUX*100,' % OF ',TEXT1
       ENDIF
*
*     STORAGE OF INFORMATION IN L_PROCEDE
*
       CALL LCMPUT(IPPROC,'POS',1,2,PAD)
*
       CALL RLSARA(BASE(IMESH))
       CALL LCMSIX(IPPROC,' ',2)
       CALL LCMSIX(IPLDEV,' ',2)
      ENDIF
      IF(NXSEQ.EQ.FIRSTS) GOTO 100
      GOTO 10
 100  RETURN
      END
