*DECK ADJMOV
      SUBROUTINE ADJMOV(IPLDEV,IPGEOM,NAMTYP,NAMFAM,IPRT,DT)
*
**********************************************************************
*
*     THIS SUBROUTINE COMPUTES ROD NEW POSITIONS IN CM ACCORDING TO
*     SPEED. A POSITIVE SPEED FOR ROD INSERTION AND NEGATIVE
*     FOR WITHDRAWAL.
*
*     CETTE ROUTINE CALCULE LES NOUVELLES COORDONNEES DES
*     BARRES SOLIDES OU DE COMPENSATION.
*
*     LA VITESSE DES BARRES EST POSITIVE LORQU'ELLES ENTRENT
*     ET NEGATIVE LORSQU'ELLES SORTENT
*
*     INPUT :
*              IPLDEV : INTEGER
*                       ADRESS OF DEVICE OBJECT
*              IPGEOM : INTEGER
*                       ADRESS OF GEOMETRY OBJECT
*              NAMTYP : CHARACTER*12
*                       DEVICE TYPE NAME
*              NAMFAM : CHARACTER*12
*                       DEVICE FAMILY NAME
*              DT     : REEL
*                       SIMULATION TIME STEP
*              IPRT   : INTEGER
*                       PRINTING FLAG
*     OUTPUT :
*              IPLDEV : INTEGER
*                       ADRESS OF DEVICE OBJECT
*
*-------------------------------------- AUTHOR: E. VARIN  95/02/10 ---
*
*      IMPLICIT     NONE
      INTEGER      IPLDEV,IPRT,IPGEOM
*
*     GEOM STRUCTURE
*
      INTEGER      NREG,ISTATE(13)
* SETARA VARIABLES
      REAL BASE
      INTEGER IBASE(1)
      COMMON BASE(1)
      EQUIVALENCE (BASE(1),IBASE(1))
*
*     DEVICE STRUCTURE
*
      CHARACTER*12 NAMTYP,NAMFAM
      REAL         POS(6),PMAX(6),SPEED
      CHARACTER*4  MOVDIR
*
*
      INTEGER      IXM,IXP,IYM,IYP,IZM,IZP,ILONG,ITYP,ILONG1,ITYP1,
     +             IMESH,IMOV
      REAL         DT,DY,DYMAX,LENGHT,LIMINF,LIMSUP
      CHARACTER*12 NMLCM,MYNAM,FIRST,NMLCM1,MYNAM1,FIRST1,
     +             NXSEQ,NXDES
      LOGICAL      LCM,LCM1
*
      CALL LCMSIX(IPGEOM,' ',0)
      CALL LCMGET(IPGEOM,'STATE',ISTATE)
*
      CALL LCMSIX(IPLDEV,' ',0)
      CALL LCMSIX(IPLDEV,NAMTYP,1)
      CALL LCMSIX(IPLDEV,NAMFAM,1)
      NXSEQ = ' '
      CALL LCMNXT(IPLDEV,NXSEQ,NMLCM,MYNAM,LCM)
      FIRST = NXSEQ
 10   CALL LCMNXT(IPLDEV,NXSEQ,NMLCM,MYNAM,LCM)
      CALL LCMLEN(IPLDEV,NXSEQ,ILONG,ITYP)
      IF(ITYP.EQ.0) THEN
        CALL LCMSIX(IPLDEV,NXSEQ,1)
        CALL LCMGET(IPLDEV,'POSITION_MAX',PMAX)
        CALL LCMGET(IPLDEV,'MOVEMENT_DIR',IMOV)
        WRITE(MOVDIR,'(A4)') IMOV
        CALL LCMGET(IPLDEV,'SPEED',SPEED)
        IF (MOVDIR.EQ.'X') THEN
          IXM = 3
          IXP = 4
          IYM = 1
          IYP = 2
          IZM = 5
          IZP = 6
         NREG = ISTATE(3)
         CALL SETARA(BASE,NREG+1,IMESH)
         CALL LCMGET(IPGEOM,'MESHX',BASE(IMESH))
        ELSEIF (MOVDIR.EQ.'Y') THEN
          IXM = 1
          IXP = 2
          IYM = 3
          IYP = 4
          IZM = 5
          IZP = 6
         NREG = ISTATE(4)
         CALL SETARA(BASE,NREG+1,IMESH)
         CALL LCMGET(IPGEOM,'MESHY',BASE(IMESH))
        ELSEIF (MOVDIR.EQ.'Z') THEN
          IXM = 1
          IXP = 2
          IYM = 5
          IYP = 6
          IZM = 3
          IZP = 4
         NREG = ISTATE(5)
         CALL SETARA(BASE,NREG+1,IMESH)
         CALL LCMGET(IPGEOM,'MESHZ',BASE(IMESH))
        ENDIF
*
*       COMPUTE NEW DEVICE POSITION FROM ITS SPEED
*
        DY = SPEED * DT
        DYMAX = PMAX(IYP)-PMAX(IYM)
        LIMSUP = PMAX(IYP)
        LIMINF = BASE(IMESH) - DYMAX
*
        IF(IPRT.GT.3) THEN
           WRITE(6,*) ' ADJUSTER ',NXSEQ
           WRITE(6,*) ' SPEED = ',SPEED
           WRITE(6,*) ' LIMIT OF PMAX(IYP) = ',LIMSUP
           WRITE(6,*) ' LIMIT OF PMAX(IYM) = ',LIMINF
        ENDIF
        NXDES=' '
        CALL LCMNXT(IPLDEV,NXDES,NMLCM1,MYNAM1,LCM1)
        FIRST1 = NXDES
 20     CALL LCMNXT(IPLDEV,NXDES,NMLCM1,MYNAM1,LCM1)
        CALL LCMLEN(IPLDEV,NXDES,ILONG1,ITYP1)
        IF(ITYP1.EQ.0) THEN
          IF(IPRT.GT.4) WRITE(6,*) ' DESCRIPT ',NXDES
          CALL LCMSIX(IPLDEV,NXDES,1)
          CALL LCMGET(IPLDEV,'POSITION',POS)
          LENGHT = POS(IYP) - POS(IYM)
          POS(IYP) = POS(IYP) + DY
          POS(IYM) = POS(IYP) - LENGHT
*
          IF(POS(IYP).GT.LIMSUP) THEN
            POS(IYP) = LIMSUP
            POS(IYM) = POS(IYP) - LENGHT
          ENDIF
          IF(POS(IYM).LT.LIMINF) THEN
             POS(IYM) = LIMINF
             POS(IYP) = POS(IYM) + LENGHT
          ENDIF
          IF(IPRT.GT.4) WRITE(6,*) ' POS(IYM) = ',POS(IYM),
     +                             ' POS(IYP) = ',POS(IYP)
          CALL LCMPUT(IPLDEV,'POSITION',6,2,POS)
          CALL LCMSIX(IPLDEV,' ',2)
        ENDIF
        IF(NXDES.EQ.FIRST1) GOTO 30
        GOTO 20
 30     CALL LCMSIX(IPLDEV,' ',2)
      ENDIF
      CALL RLSARA(BASE(IMESH))
      IF(NXSEQ.EQ.FIRST) GOTO 40
      GOTO 10
*
 40   CONTINUE
      RETURN
      END
