*DECK ADJPAD
      SUBROUTINE ADJPAD(IPPROC,IPLDEV,IPGEOM,IPRT)
*
**********************************************************************
*
*     THIS SUBROUTINE COMPUTES ROD POSITION IN CM FROM FRACTIONAL
*     POSITION STORED IN PROCEDE OBJECT
*
*     CETTE ROUTINE CALCULE LES NOUVELLES POSITIONS DES BARRES
*     DE COMPENSATION EN FONCTION DE LA POSITION LUE, RANGEE
*     DANS L'OBJET PROCEDE
*
*     INPUT :
*              IPLDEV : INTEGER
*                       ADRESS OF DEVICE OBJECT
*              IPPROC : INTEGER
*                       ADRESS OF PROCEDE OBJECT
*              IPGEOM : INTEGER
*                       ADRESS OF GEOMETRY OBJECT
*              IPRT   : INTEGER
*                       PRINTING FLAG
*     OUTPUT :
*              IPLDEV : INTEGER
*                       ADRESS OF DEVICE OBJECT
*
*-------------------------------------- AUTHOR: E. VARIN  95/04/08 ---
*
*
      IMPLICIT     NONE
      INTEGER      IPPROC,IPLDEV,IPRT,IPGEOM
*
*     PROCEDE STRUCTURE
*
      REAL         PAD
*
*     GEOM STRUCTURE
*
      INTEGER      NREG,ISTATE(13)
C SETARA VARIABLES
      REAL BASE
      INTEGER IBASE(1)
      COMMON BASE(1)
      EQUIVALENCE (BASE(1),IBASE(1))
*
*     DEVICE STRUCTURE
*
      CHARACTER*12 NXSEQ
      REAL         POS(6,10),PMAX(6)
      CHARACTER*4  MOVDIR
*
C
      CHARACTER*12 TEXT
*
      CHARACTER*12 NMLCM1,MYNAM1,FIRST,NMLCM,MYNAM,FIRSTS
      INTEGER      I,IXM,IXP,IYM,IYP,IZM,IZP,J,ILONG,ITYP,
     +             IPOS,CPT,ITYP1,ILONG1,IMESH,IMOV
      REAL         DIFF,DIFFM,LIMSUP,LIMINF,SUP,LENGHT,DYMAX
      LOGICAL      LCM1,LCM
*
      CALL LCMSIX(IPGEOM,' ',0)
      CALL LCMGET(IPGEOM,'STATE',ISTATE)
*
      NXSEQ = ' '
      CALL LCMNXT(IPPROC,NXSEQ,NMLCM,MYNAM,LCM)
      FIRSTS=NXSEQ
10    CALL LCMNXT(IPPROC,NXSEQ,NMLCM,MYNAM,LCM)
      CALL LCMLEN(IPPROC,NXSEQ,ILONG,ITYP)
      IF (ITYP.EQ.0) THEN
       CALL LCMSIX(IPPROC,NXSEQ,1)
       CALL LCMSIX(IPLDEV,NXSEQ,1)
* LEVEL SEQUENCE
       DO 20 I=1,6
        DO 21 J=1,10
          POS(I,J) = 0.0
  21    CONTINUE
  20   CONTINUE
*
       CALL LCMGET(IPPROC,'POS',PAD)
       CALL LCMGET(IPLDEV,'POSITION_MAX',PMAX)
       CALL LCMGET(IPLDEV,'MOVEMENT_DIR',IMOV)
       WRITE(MOVDIR,'(A4)') IMOV
       TEXT = ' '
       CPT = 0
       I = 0
       CALL LCMNXT(IPLDEV,TEXT,NMLCM1,MYNAM1,LCM1)
       FIRST=TEXT
 60    CALL LCMNXT(IPLDEV,TEXT,NMLCM1,MYNAM1,LCM1)
       CALL LCMLEN(IPLDEV,TEXT,ILONG1,ITYP1)
       IF (ITYP1.EQ.0) THEN
*  LEVEL DESCRIPT
         I = I + 1
         CALL LCMSIX(IPLDEV,TEXT,1)
         CALL LCMSIX(IPPROC,TEXT,1)
         CALL LCMGET(IPPROC,'NPOS',IPOS)
         CALL LCMGET(IPLDEV,'POSITION',POS(1,IPOS))
         CALL LCMSIX(IPPROC,' ',2)
         CALL LCMSIX(IPLDEV,' ',2)
       ENDIF
       IF (TEXT.EQ.FIRST) GOTO 65
       GOTO 60
*
 65    CPT = I
       IF (MOVDIR.EQ.'X') THEN
         IXM = 3
         IXP = 4
         IYM = 1
         IYP = 2
         IZM = 5
         IZP = 6
         NREG = ISTATE(3)
         CALL SETARA(BASE,NREG+1,IMESH)
         CALL LCMGET(IPGEOM,'MESHX',BASE(IMESH))
       ELSEIF (MOVDIR.EQ.'Y') THEN
         IXM = 1
         IXP = 2
         IYM = 3
         IYP = 4
         IZM = 5
         IZP = 6
         NREG = ISTATE(4)
         CALL SETARA(BASE,NREG+1,IMESH)
         CALL LCMGET(IPGEOM,'MESHY',BASE(IMESH))
       ELSEIF (MOVDIR.EQ.'Z') THEN
         IXM = 1
         IXP = 2
         IYM = 5
         IYP = 6
         IZM = 3
         IZP = 4
         NREG = ISTATE(5)
         CALL SETARA(BASE,NREG+1,IMESH)
         CALL LCMGET(IPGEOM,'MESHZ',BASE(IMESH))
       ENDIF
       DYMAX = PMAX(IYP) - PMAX(IYM)
       DIFFM = PMAX(IYP) - BASE(IMESH)
       DIFF  = PAD * DIFFM
       LIMSUP = DIFF + BASE(IMESH)
       IF (LIMSUP.LT.BASE(IMESH)) THEN
            LIMSUP = BASE(IMESH)
       ENDIF
       IF (LIMSUP.GT.PMAX(IYP)) THEN
            LIMSUP = PMAX(IYP)
       ENDIF
       LIMINF = LIMSUP - DYMAX
       IF (IPRT.GT.3) THEN
        WRITE(6,*) ' ADJ ',NXSEQ,' PAD ',PAD*100.,' % OF INSERTION'
        WRITE(6,*) ' NEW POSITIONS, POS(IYM) = ',LIMINF,
     +            ' POS(IYP) = ',LIMSUP
       ENDIF
*
       SUP = LIMSUP
       DO 70 I=CPT,1,-1
         LENGHT = POS(IYP,I) - POS(IYM,I)
         POS(IYP,I) = SUP
         POS(IYM,I) = SUP - LENGHT
         SUP = POS(IYM,I)
  70   CONTINUE
       IF(ABS(SUP-LIMINF).GT.1.E-3) CALL XABORT('ADJPAD: WRONG LENGHT'
     +      //' OF ADJUSTER  '//NXSEQ)
*
*      NEW POSITION STORAGE
*
       TEXT = ' '
       CALL LCMNXT(IPLDEV,TEXT,NMLCM1,MYNAM1,LCM1)
       FIRST=TEXT
 75    CALL LCMNXT(IPLDEV,TEXT,NMLCM1,MYNAM1,LCM1)
       CALL LCMLEN(IPLDEV,TEXT,ILONG1,ITYP1)
       IF (ITYP1.EQ.0) THEN
*  LEVEL DESCRIPT
         CALL LCMSIX(IPLDEV,TEXT,1)
         CALL LCMSIX(IPPROC,TEXT,1)
         CALL LCMGET(IPPROC,'NPOS',IPOS)
         CALL LCMPUT(IPLDEV,'POSITION',6,2,POS(1,IPOS))
         CALL LCMSIX(IPPROC,' ',2)
         CALL LCMSIX(IPLDEV,' ',2)
       ENDIF
       IF (TEXT.EQ.FIRST) GOTO 80
       GOTO 75
*
 80    CALL RLSARA(BASE(IMESH))
       CALL LCMSIX(IPLDEV,' ',2)
       CALL LCMSIX(IPPROC,' ',2)
      ENDIF
      IF(NXSEQ.EQ.FIRSTS) GOTO 100
      GOTO 10
*
  100 RETURN
      END
