*DECK ADJRED
      SUBROUTINE ADJRED(IPPROC,IPLDEV,NAMTYP,PROCTP,IPRT)
*
**********************************************************************
*
*     THIS ROUTINE READS THE REQUIRED INFORMATION FOR A ROD
*
*     CETTE ROUTINE LIT LES INFORMATIONS POUR CHAQUE BARRE
*     QUI DOIVENT ETRE STOCKEES DANS L'OBJET PROCEDE
*
*     INPUT :
*              IPLDEV : INTEGER
*                       ADRESS OF DEVICE OBJECT
*              NAMTYP : CHARACTER*12
*                       ROD TYPE NAME
*              PROCTP : CHARACTER*12
*                       ROD FAMILY NAME
*              IPRT   : INTEGER
*                       PRINTING FLAG
*     OUTPUT :
*              IPPROC : INTEGER
*                       ADRESS OF PROCEDE OBJECT
*
*-------------------------------------- AUTHOR: E. VARIN  95/02/10 ---
*
*
*     IMPLICIT NONE
*
*     PROCEDE STRUCTURE
*
      CHARACTER PROCTP*12,DEVICE*12
      INTEGER   NUMBER,NBANC,IPPROC,IPLDEV,IPRT
*
*     DEVICE STRUCTURE
*
      CHARACTER*12 NAMTYP
      REAL         POS(6,10),POS1(6)
      CHARACTER*4  MOVDIR
*
      CHARACTER*12 TEXT
      INTEGER ITYP,NITMA,ILONG
      REAL FLOTT
      DOUBLE PRECISION DFLOTT
*
      CHARACTER*12 NMLCM1,MYNAM1,FIRST
      INTEGER      I,J,N,IMIN,IXM,IXP,IYM,IYP,IZM,IZP,INB,
     +             ITYP1,ILONG1,CPT,IMOV
      REAL         MINP,AUX,TIME
      LOGICAL      LCM1
*
*     VERIFICATION OF PROCTP TYPE IN IPPROC OBJECT
*
      CALL LCMSIX(IPPROC,' ',0)
      CALL LCMLEN(IPPROC,PROCTP,ILONG,ITYP)
      IF (ITYP.NE.0) CALL XABORT('ADJRED: '//PROCTP//
     +      ' DOES NOT EXIST IN PROCEDE OBJECT')
      CALL LCMSIX(IPPROC,PROCTP,1)
*
*     READING OF THE CONTROLLER NAME AND PARAMETERS
*
      CALL REDGET(ITYP,NITMA,FLOTT,TEXT,DFLOTT)
      IF(ITYP.EQ.3) THEN
        IF (TEXT.EQ.'NAME') THEN
         CALL REDGET(ITYP,NITMA,FLOTT,DEVICE,DFLOTT)
         IF (ITYP.NE.3) CALL XABORT('ADJRED: CHARACTER DATA EXPECTED')
         CALL LCMLEN(IPPROC,DEVICE,ILONG,ITYP)
         IF (ITYP.NE.0) CALL XABORT('ADJRED: '//DEVICE//
     +      ' DOES NOT EXIST IN PROCEDE OBJECT')
         CALL LCMSIX(IPPROC,DEVICE,1)
        ELSE
          CALL XABORT('ADJRED: KEYWORD NAME IS REQUIRED ')
        ENDIF
      ELSE
         CALL XABORT('ADJRED: CHARACTER DATA EXPECTED')
      ENDIF
*
  10  CALL REDGET(ITYP,NITMA,FLOTT,TEXT,DFLOTT)
      IF(ITYP.EQ.3) THEN
        IF (TEXT.EQ.'NB') THEN
          CALL REDGET(ITYP,NUMBER,FLOTT,TEXT,DFLOTT)
          IF (ITYP.NE.1) CALL XABORT('ADJRED: INTEGER DATA EXPECTED')
          CALL LCMPUT(IPPROC,'NUMBER',1,1,NUMBER)
        ELSEIF (TEXT.EQ.'NBANC') THEN
          CALL REDGET(ITYP,NBANC,FLOTT,TEXT,DFLOTT)
          IF (ITYP.NE.1) CALL XABORT('ADJRED: INTEGER DATA EXPECTED')
          CALL LCMPUT(IPPROC,'NBANC',1,1,NBANC)
        ELSEIF (TEXT.EQ.'TIME') THEN
          CALL REDGET(ITYP,NITMA,TIME,TEXT,DFLOTT)
          IF (ITYP.NE.2) CALL XABORT('ADJRED: REAL DATA EXPECTED')
          CALL LCMPUT(IPPROC,'TIME',1,2,TIME)
        ELSEIF (TEXT.EQ.'END') THEN
          GOTO 80
        ELSE
          CALL XABORT('ADJRED: INVALID KEYWORD')
        ENDIF
      ELSE
         CALL XABORT('ADJRED: CHARACTER DATA EXPECTED')
      ENDIF
      GOTO 10
*
  80  IF(IPRT.GT.2) WRITE(6,*) 'ADJ NAMSEQ ',DEVICE
*
*     CONSTRUCTION OF DESCRIPTOR ORDERING
*
      CALL LCMSIX(IPLDEV,' ',0)
      CALL LCMSIX(IPLDEV,NAMTYP,1)
      CALL LCMSIX(IPLDEV,PROCTP,1)
      CALL LCMSIX(IPLDEV,DEVICE,1)
      CALL LCMGET(IPLDEV,'MOVEMENT_DIR',IMOV)
      WRITE(MOVDIR,'(A4)') IMOV
      TEXT = ' '
      CPT = 0
      I = 0
      CALL LCMNXT(IPLDEV,TEXT,NMLCM1,MYNAM1,LCM1)
      FIRST=TEXT
 20   CALL LCMNXT(IPLDEV,TEXT,NMLCM1,MYNAM1,LCM1)
      CALL LCMLEN(IPLDEV,TEXT,ILONG1,ITYP1)
      IF (ITYP1.EQ.0) THEN
*  LEVEL DESCRIPT
        I = I + 1
        CALL LCMSIX(IPLDEV,TEXT,1)
        CALL LCMGET(IPLDEV,'POSITION',POS(1,I))
        CALL LCMSIX(IPLDEV,' ',2)
      ENDIF
      IF (TEXT.EQ.FIRST) GOTO 30
      GOTO 20
*
 30   CPT = I
      IF (MOVDIR.EQ.'X') THEN
          IXM = 3
          IXP = 4
          IYM = 1
          IYP = 2
          IZM = 5
          IZP = 6
      ELSEIF (MOVDIR.EQ.'Y') THEN
          IXM = 1
          IXP = 2
          IYM = 3
          IYP = 4
          IZM = 5
          IZP = 6
      ELSEIF (MOVDIR.EQ.'Z') THEN
          IXM = 1
          IXP = 2
          IYM = 5
          IYP = 6
          IZM = 3
          IZP = 4
      ENDIF
*
*     SORT Y- OF THE DEVICE
*
      DO 35 I=1,CPT
         MINP = 1.E+30
         DO 36 J=I,CPT
           IF (POS(IYM,J).LT.MINP) THEN
             IMIN = J
             MINP = POS(IYM,J)
           ENDIF
 36      CONTINUE
         DO 37 N=1,6
          AUX = POS(N,I)
          POS(N,I) = POS(N,IMIN)
          POS(N,IMIN) = AUX
 37      CONTINUE
 35   CONTINUE
*
      TEXT = ' '
      CALL LCMNXT(IPLDEV,TEXT,NMLCM1,MYNAM1,LCM1)
      FIRST=TEXT
 50   CALL LCMNXT(IPLDEV,TEXT,NMLCM1,MYNAM1,LCM1)
      CALL LCMLEN(IPLDEV,TEXT,ILONG1,ITYP1)
      IF (ITYP1.EQ.0) THEN
*  LEVEL DESCRIPT
        CALL LCMSIX(IPLDEV,TEXT,1)
        CALL LCMSIX(IPPROC,TEXT,1)
        CALL LCMGET(IPLDEV,'POSITION',POS1)
        DO 45 J=1,CPT
         IF((POS1(IYM).EQ.POS(IYM,J)).AND.(POS1(IYP).EQ.POS(IYP,J)))
     +     INB = J
 45     CONTINUE
        IF(IPRT.GT.3) WRITE(6,*) 'ADJ NAMDES ',TEXT,' NPOS ',INB
        CALL LCMPUT(IPPROC,'NPOS',1,1,INB)
        CALL LCMSIX(IPPROC,' ',2)
        CALL LCMSIX(IPLDEV,' ',2)
      ENDIF
      IF (TEXT.EQ.FIRST) GOTO 60
      GOTO 50
*
 60   RETURN
      END
