*DECK ADJSPD
      SUBROUTINE ADJSPD(IPPROC,IPLDEV,IPGEOM,IPRT)
*
**********************************************************************
*
*     THIS SUBROUTINE COMPUTE ROD SPEEDS IN CM/S WITH INFORMATION
*     STORED IN PROCEDE OBJECT
*
*     WHEN SPEED IS POSITIVE, ROD IS INSERTED
*     WHEN SPEED IS NEGATIVE, ROD IS WITHDRAWN
*
*     CETTE ROUTINE CALCULE LA VITESSE DE DEPLACEMENT
*     DES BARRES SOLIDES OU DE COMPENSATION EN UTILISANT
*     LES DONNEES DE L'OBJET PROCEDE
*
*     LA VITESSE EST POSITIVE LORSQUE LA BARRE ENTRE ET
*     NEGATIVE LORSQUE LA BARRE SORT.
*
*     INPUT :
*              IPPROC : INTEGER
*                       ADRESS OF PROCEDE OBJECT
*              IPGEOM : INTEGER
*                       ADRESS OF GEOMETRY OBJECT
*              IPLDEV : INTEGER
*                       ADRESS OF DEVICE OBJECT
*              IPRT   : INTEGER
*                       FLAG D'IMPRESSION
*     OUTPUT :
*              IPLDEV : INTEGER
*                       ADRESS OF DEVICE OBJECT
*
*-------------------------------------- AUTHOR: E. VARIN  95/02/10 ---
*
*      IMPLICIT     NONE
      INTEGER      IPPROC,IPLDEV,IPGEOM,IPRT
*
*     PROCEDE STRUCTURE
*
      REAL         VIT,SART
*
*     GEOM STRUCTURE
*
      INTEGER      NREG,ISTATE(13)
C SETARA VARIABLES
      REAL BASE
      INTEGER IBASE(1)
      COMMON BASE(1)
      EQUIVALENCE (BASE(1),IBASE(1))
*
*     DEVICE STRUCTURE
*
      CHARACTER*4  MOVDIR
      REAL         SPEED,PMAX(6)
*
*
      INTEGER      ILONG,ITYP,IMOV,
     +             IXM,IXP,IYM,IYP,IZM,IZP,IMESH
      CHARACTER*12 NXSEQ,NMLCM,MYNAM,FIRSTS
      LOGICAL      LCM
*
      CALL LCMSIX(IPGEOM,' ',0)
      CALL LCMGET(IPGEOM,'STATE',ISTATE)
*
*     RECUPERATION DE LA VITESSE EN %
*
      NXSEQ = ' '
      CALL LCMNXT(IPPROC,NXSEQ,NMLCM,MYNAM,LCM)
      FIRSTS=NXSEQ
10    CALL LCMNXT(IPPROC,NXSEQ,NMLCM,MYNAM,LCM)
      CALL LCMLEN(IPPROC,NXSEQ,ILONG,ITYP)
      IF (ITYP.EQ.0) THEN
       CALL LCMSIX(IPPROC,NXSEQ,1)
* NIVEAU SEQUENCE
       CALL LCMGET(IPPROC,'VITBC',VIT)
       CALL LCMGET(IPPROC,'TIME',SART)
*
*      CALCUL DE LA VITESSE EN CM/S ET RANGEMENT
*
       CALL LCMSIX(IPLDEV,NXSEQ,1)
       CALL LCMGET(IPLDEV,'POSITION_MAX',PMAX)
       CALL LCMGET(IPLDEV,'MOVEMENT_DIR',IMOV)
       WRITE(MOVDIR,'(A4)') IMOV
       IF (MOVDIR.EQ.'X') THEN
         IXM = 3
         IXP = 4
         IYM = 1
         IYP = 2
         IZM = 5
         IZP = 6
         NREG = ISTATE(3)
         CALL SETARA(BASE,NREG+1,IMESH)
         CALL LCMGET(IPGEOM,'MESHX',BASE(IMESH))
       ELSEIF (MOVDIR.EQ.'Y') THEN
         IXM = 1
         IXP = 2
         IYM = 3
         IYP = 4
         IZM = 5
         IZP = 6
         NREG = ISTATE(4)
         CALL SETARA(BASE,NREG+1,IMESH)
         CALL LCMGET(IPGEOM,'MESHY',BASE(IMESH))
       ELSEIF (MOVDIR.EQ.'Z') THEN
         IXM = 1
         IXP = 2
         IYM = 5
         IYP = 6
         IZM = 3
         IZP = 4
         NREG = ISTATE(5)
         CALL SETARA(BASE,NREG+1,IMESH)
         CALL LCMGET(IPGEOM,'MESHY',BASE(IMESH))
       ENDIF
       SPEED = (PMAX(IYP)-BASE(IMESH))/ SART * VIT
       IF(IPRT.GT.3) THEN
         WRITE(6,*) 'CONTROLLER ',NXSEQ
         WRITE(6,*) 'SPEED  ',SPEED,' CM/S'
       ENDIF
       CALL LCMPUT(IPLDEV,'SPEED',1,2,SPEED)
*
       CALL RLSARA(BASE(IMESH))
       CALL LCMSIX(IPLDEV,' ',2)
       CALL LCMSIX(IPPROC,' ',2)
      ENDIF
      IF(NXSEQ.EQ.FIRSTS) GOTO 100
      GOTO 10
 100  RETURN
      END
