*DECK AFMCPT
      SUBROUTINE AFMCPT (HENTRY,KENTRY,NBURN,NGRP,NISO,NL,IMPX,
     1 SMACB,XBORB,XPURB,XXENB,XT1FB,XT2FB,XT1CB,
     1 XT2CB,XT1MB,XT2MB,XD1CB,XD2CB,XD1MB,XD2MB,
     1 XSMB,XNP9B,XMFDB,XMMDB,XPF1B,XPF2B,XPF1LB,XPF2LB,
     1 DENSITB,CPW1B,CPW2B,FLUXB,OVERVB,CHIB,SMAC,
     1 IJJ,NJJ,HISO,CTITRE,NMIX,SIGMA,NTYP,TF,TC,
     1 TM,DC,DM,BOR,XEN,SM,RNP9,XI,TFR,TCR,TMR,XIR,
     1 DEL,VOL,OVERV,FLUX,CHI,DIFD,SCAT,
     1 MMIX,IDLEN,NPS,PW,CPW1,CPW2,XBRH,XBURN,
     1 LTAV,IRAV,LTAB,IDF,JTAB,IXYZ)
*
*---------------------------------------------------------------*
*
* COMPUTE THE CROSS SECTIONS .
*
*---------------------------------------------------------------*
* INPUT PARAMETERS:
*  IPLIST : ADDRESS OF THE LINKED LIST OR HANDLE TO THE XSM FILE.
*  NGRP   : NUMBER OF ENERGY GROUPS.
*  NISO   : NUMBER OF EXTRACTED ISOTOPES.
*  NL     : NUMBER OF LEGENDRE ORDERS (=1 FOR ISOTROPIC SCATTERING).
*  NBURN  : NUMBER OF BURNUP STEPS.
*  NTYP   : TOTAL NUMBER OF CROSS SECTIONS TYPE.
*  TF     : FUEL TEMPERATURE.
*  TC     : COOLANT TEMPERATURE.
*  TM     : MODERATOR TEMPERATURE.
*  DC     : COOLANT DENSITY.
*  DM     : MODERATOR DENSITY.
*  BOR    : BORON CONCENTRATION.
*  XEN    : XENON CONCENTRATION.
*  SM     : SAMARIUM CONCENTRATION.
*  RNP9   : NEPTUNIUM CONCENTRATION.
*  XI     : MODERATOR PURITY.
*  NMIX   : MIXTURE NUMBER.
*  NPS    : NPS-2 POWER SHIFT.
* OUTPUT PARAMETERS:
*---------------------------------------------------------------*
*--------------------------- AUTHOR: M.T. SISSAOUI ; 20/06/96 --*
*---------------------------------------------------------------*
*
      CHARACTER HENTRY(*)*12,HMICRO*12
      CHARACTER*72 CTITRE
      LOGICAL LTAV,LTAB
      DOUBLE PRECISION XCOF(3)
      DIMENSION KENTRY(*),SMAC(NGRP*NGRP,NTYP,*),
     1 SMACB(NGRP*NGRP,NTYP,NISO,NBURN,*),
     1 XBORB(NGRP*NGRP,NTYP,NISO,NBURN,*),
     1 XXENB(NGRP*NGRP,NTYP,NISO,NBURN,*),
     1 XT1FB(NGRP*NGRP,NTYP,NISO,NBURN,*),
     1 XT2FB(NGRP*NGRP,NTYP,NISO,NBURN,*),
     1 XT1CB(NGRP*NGRP,NTYP,NISO,NBURN,*),
     1 XT2CB(NGRP*NGRP,NTYP,NISO,NBURN,*),
     1 XT1MB(NGRP*NGRP,NTYP,NISO,NBURN,*),
     1 XT2MB(NGRP*NGRP,NTYP,NISO,NBURN,*),
     1 XD1CB(NGRP*NGRP,NTYP,NISO,NBURN,*),
     1 XD2CB(NGRP*NGRP,NTYP,NISO,NBURN,*),
     1 XD1MB(NGRP*NGRP,NTYP,NISO,NBURN,*),
     1 XD2MB(NGRP*NGRP,NTYP,NISO,NBURN,*),
     1 XSMB(NGRP*NGRP,NTYP,NISO,NBURN,*),
     1 XNP9B(NGRP*NGRP,NTYP,NISO,NBURN,*),
     1 XMFDB(NGRP*NGRP,NTYP,NISO,NBURN,*),
     1 XMMDB(NGRP*NGRP,NTYP,NISO,NBURN,*),
     1 XPF1B(NGRP*NGRP,NTYP,NISO,NBURN,*),
     1 XPF2B(NGRP*NGRP,NTYP,NISO,NBURN,*),
     1 XPF1LB(NGRP*NGRP,NTYP,NISO,NBURN,*),
     1 XPF2LB(NGRP*NGRP,NTYP,NISO,NBURN,*),
     1 XPURB(NGRP*NGRP,NTYP,NISO,NBURN,*),
     1 DENSITB(NISO,NBURN,*),CPW1B(2,NBURN,*),
     1 CPW2B(2,NBURN,*),FLUXB(NGRP,NBURN,*),
     1 CHIB(NGRP,NBURN,*),OVERVB(NGRP,NBURN,*),
     2 HISO(*),JTAB(*),
     6 DEL(NISO),ELMT(3),PW(*),CPW1(*),CPW2(*),
     7 IBASE(1),SIGMA(MMIX,NGRP,NTYP),XBRH(*),
     8 VOL(MMIX),OVERV(MMIX,*),FLUX(MMIX,*),
     7 CHI(MMIX,*),DIFD(NGRP,*),SCAT(MMIX,NL,NGRP,*),
     1 XBURN(NBURN,*),NJJ(*),IJJ(*)
      COMMON BASE(1)
      EQUIVALENCE(BASE(1),IBASE(1))
*---------------------------------------------------------------*
      IF(NBURN.EQ.0) CALL XABORT('AFMCPT: ZERO NUMBER OF MIXTURES.')
      IF(NGRP.EQ.0) CALL XABORT('AFMCPT: ZERO NUMBER OF GROUPS.')
*---------------------------------------------------------------*
      NG2=NGRP*NGRP
      NTM=4+2*IXYZ
      IF(IMPX.GT.5) WRITE(6,*) ' NTYP ',NTYP
      XECON=0.0
      TFAV=0.0
      DCAV=0.0
      CPF1=0.0
      CPF2=0.0
      CF=0.0
      DO 81 ISO=1,NISO
       DO 81 ITY=1,NTYP
        DO 81 IGR=1,NG2
          SMAC(IGR,ITY,ISO)=0.0
 81   CONTINUE
      DO 82 IGR=1,NGRP
         FLUX(NMIX,IGR)=0.0
         OVERV(NMIX,IGR)=0.0
         CHI(NMIX,IGR)=0.0
 82   CONTINUE
      DO 161 ISO=1,NISO
         DEL(ISO)=0.0
 161  CONTINUE
      DO 73 II=1,3
         XCOF(II)=0.0D0
         ELMT(II)=0.0
 73   CONTINUE
      DO 74 K=1,NPS
         CPW1(K)=0.0
         CPW2(K)=0.0
 74   CONTINUE
*
      PREF=PW(1)
      IPFBM=KENTRY(2)
*---------------------------------------------------------------*
*     COMPUTE THE HISTORY COEFFICIENTS
      NPSX=NPS+NPS-1
      DO 101 K=2,NPSX
* XSECTION FOR SNAP-SHOT OR (TIME AVERAGE-HOMOG.)
        IF(LTAV.OR.LTAB) THEN
          IRMAX=IRAV
          IRMIN=IRAV
          XCOF(1)=1.0D0
        ELSE
*
          IF(K.GT.NPS) THEN
            XIRAD=XBRH(K-NPS+1)
          ELSE
            XIRAD=XBRH(NPS)-XBRH(K-1)
          ENDIF
           CALL AFMLOC(NBURN,NTP,XIRAD,XIRAD,XBURN(1,IDF),
     1                IRMAX,IRMIN,XCOF)
        ENDIF
*
* INTERPOLATE THE HISTORY COEFFICIENTS
        IH=0
        DO 910 I = IRMIN,IRMAX
          IH=IH+1
          IF(K.LE.NPS) THEN
            IF(PW(K).GT.PREF) THEN
              CPW1(K)=CPW1B(1,I,IDF)*XCOF(IH) + CPW1(K)
              CPW2(K)=CPW2B(1,I,IDF)*XCOF(IH) + CPW2(K)
            ELSE
              CPW1(K)=CPW1B(2,I,IDF)*XCOF(IH) + CPW1(K)
              CPW2(K)=CPW2B(2,I,IDF)*XCOF(IH) + CPW2(K)
            ENDIF
*
            IF(K.GT.2) THEN
               IF(PW(K-1).GT.PREF) THEN
                 CPW1(K-1)=-CPW1B(1,I,IDF)*XCOF(IH) + CPW1(K-1)
                 CPW2(K-1)=-CPW2B(1,I,IDF)*XCOF(IH) + CPW2(K-1)
               ELSE
                 CPW1(K-1)=-CPW1B(2,I,IDF)*XCOF(IH) + CPW1(K-1)
                 CPW2(K-1)=-CPW2B(2,I,IDF)*XCOF(IH) + CPW2(K-1)
               ENDIF
            ENDIF
          ENDIF
 910    CONTINUE
 101  CONTINUE
*
      DO 111 K=2,NPS
        IF(K.EQ.2) THEN
* CORRECTE THE STURATING PSEUDO-FISSILE ISOTOPE
          IF(PW(K).GT.PREF) THEN
            XPW=ALOG(PW(K)/PW(1))
            XPWM=1.0/PW(K)-1.0/PW(1)
            YF=0.0
          ELSE
            XPW=PW(K)-PW(1)
            XPWM=(PW(K)-PW(1))**2
          ENDIF
          CPF1=CPF1 +CPW1(K)*XPW + CPW2(K)*XPWM
C
        ELSE
          IF(PW(K).GT.PREF) THEN
            XPW=ALOG(PW(K)/PW(1))
            XPWM=1.0/PW(K)-1.0/PW(1)
          ELSE
            XPW=PW(K)-PW(1)
            XPWM=(PW(K)-PW(1))**2
C
          ENDIF
          CPF1=CPF1 +CPW1(K)*XPW + CPW2(K)*XPWM
        ENDIF
 111  CONTINUE
*---------------------------------------------------------------*
*         COMPUTE THE DEVIATION OF THE PSEUDO-ISOTOPE
*         CPF1 AND CPF2
      CPF2=CPF1*CPF1
*---------------------------------------------------------------*
*  APPLY  THE FFEDBACK MODEL
      T1F=SQRT(TF)-SQRT(TFR)
      T2F=TF-TFR
      T1C=ALOG(TC/TCR)
      T2C=1.0/TC - 1.0/TCR
      T1M=ALOG(TM/TMR)
      T2M=1.0/TM - 1.0/TMR
*
* RECOVER LOCAL PARAMETER COEFFICIENT AND X-SECTIONS
      II=0
      DO 900 I = IRMIN,IRMAX
        II=II+1
        DO 249 IGR=1,NGRP
          FLUX(NMIX,IGR)=FLUX(NMIX,IGR)+XCOF(II)*FLUXB(IGR,I,IDF)
          OVERV(NMIX,IGR)=OVERV(NMIX,IGR)+XCOF(II)*OVERVB(IGR,I,IDF)
 249    CONTINUE
* COMPUTE DELTA-CONCENTRATION
        DO 49 ISO=1,NISO
          IF(DENSITB(ISO,I,IDF).EQ.0.0) GO TO 49
          WRITE(HMICRO,'(3A4)') (HISO((ISO-1)*3+IH),IH=1,3)
          IF(HMICRO.EQ.'XE135') THEN
            DEL(ISO)=XEN/(IRMAX-IRMIN+1)-DENSITB(ISO,I,IDF)*XCOF(II)
     1               +DEL(ISO)
            CX=DEL(ISO)
          ELSE IF(HMICRO.EQ.'BMOD') THEN
            DEL(ISO)=DENSITB(ISO,I,IDF)*BOR/(IRMAX-IRMIN+1)-
     1               DENSITB(ISO,I,IDF)*XCOF(II)+DEL(ISO)
            CB=DEL(ISO)*DM
          ELSE IF(HMICRO.EQ.'CWAT') THEN
            DEL(ISO)=(DC-1.0)*DENSITB(ISO,I,IDF)
            D1C=DEL(ISO)
            D2C=D1C*D1C
            D2CB=D1C*D1C
          ELSE IF(HMICRO.EQ.'MWAT') THEN
            DEL(ISO)=(DM-1.0)*DENSITB(ISO,I,IDF)
            D1M=ALOG(DM)
            D2M=1.0/(DM*DENSITB(ISO,I,IDF)) - 1.0/DENSITB(ISO,I,IDF)
            D2MB=DEL(ISO)
*         PURITY
            PUR=(XI-XIR)*DM*DENSITB(ISO,I,IDF)
          ELSE IF(HMICRO.EQ.'SM149') THEN
            DEL(ISO)=SM/(IRMAX-IRMIN+1)-DENSITB(ISO,I,IDF)*XCOF(II)
     1               +DEL(ISO)
            CSM=DEL(ISO)
          ELSE IF(HMICRO.EQ.'NP239') THEN
            DEL(ISO)=RNP9/(IRMAX-IRMIN+1)-DENSITB(ISO,I,IDF)*XCOF(II)
     1               +DEL(ISO)
            CNP9=DEL(ISO)
          ELSE IF(HMICRO.EQ.'FPC') THEN
*
            CF= CF+DENSITB(ISO,I,IDF)*XCOF(II)
            DEL(ISO)=CPF1
          ELSE IF(HMICRO.EQ.'MACR') THEN
            DEL(ISO)=DENSITB(ISO,I,IDF)
            DO 271 IGR=1,NGRP
              CHI(NMIX,IGR)=CHIB(IGR,I,IDF)*XCOF(II)+CHI(NMIX,IGR)
  271       CONTINUE
          ENDIF
   49   CONTINUE
  900 CONTINUE
*  CORRECT THE FUEL TEMPERATURE
      CQ=(CPF1+CF)/CF
      RCQ=1.0-CQ
      CQ2=CQ*CQ
      RCQ2=1.0-CQ2
      IF(JTAB(1).EQ.0) THEN
        CQ=0.0
        RCQ=0.0
        CQ2=0.0
        RCQ2=0.0
        CX=0.0
        CSM=0.0
        CNP9=0.0
        D1C=0.0
        D2C=0.0
        D2CB=0.0
        T1F=0.0
        T2F=0.0
        T1C=0.0
        T2C=0.0
      ENDIF
*
* RECOVER MACROSCOPIC X-SECTIONS
      II=0
      DO 901 I = IRMIN,IRMAX
        II=II+1
        DO 100 ISO=1,NISO
         DO 100  ITY=1,NTYP
           IF(ISO.EQ.1) THEN
             ZZ=1.0
             IF(ITY.EQ.1) THEN
               VD2M=D2MB
               VD2C=D2CB
             ELSE IF(ITY.GE.5) THEN
               VD2M=D2MB
               VD2C=D2C
             ELSE
               VD2M=D2M
               VD2C=D2C
             ENDIF
           ELSE
             ZZ=0.0
             VD2M=D2M
             VD2C=D2C
           ENDIF
           DO 100 IGR=1,NG2
             SMAC(IGR,ITY,1)=SMAC(IGR,ITY,1)+
     1        SMACB(IGR,ITY,1,I,IDF)*XCOF(II)*ZZ+
     1       (XBORB(IGR,ITY,ISO,I,IDF)*XCOF(II)*CB +
     1       XPURB(IGR,ITY,ISO,I,IDF)*XCOF(II)*PUR*ZZ +
     1       XXENB(IGR,ITY,ISO,I,IDF)*XCOF(II)*CX +
     1       XT1FB(IGR,ITY,ISO,I,IDF)*XCOF(II)*T1F*CQ +
     1       XT1FB(IGR,ITY,ISO,1,IDF)*XCOF(II)*T1F*RCQ +
     1       XT2FB(IGR,ITY,ISO,I,IDF)*XCOF(II)*T2F*CQ2 +
     1       XT2FB(IGR,ITY,ISO,1,IDF)*XCOF(II)*T2F*RCQ2 +
     1       XT1CB(IGR,ITY,ISO,I,IDF)*XCOF(II)*T1C +
     1       XT2CB(IGR,ITY,ISO,I,IDF)*XCOF(II)*T2C +
     1       XT1MB(IGR,ITY,ISO,I,IDF)*XCOF(II)*T1M +
     1       XT2MB(IGR,ITY,ISO,I,IDF)*XCOF(II)*T2M +
     1       XD1CB(IGR,ITY,ISO,I,IDF)*XCOF(II)*D1C +
     1       XD2CB(IGR,ITY,ISO,I,IDF)*XCOF(II)*VD2C +
     1       XD1MB(IGR,ITY,ISO,I,IDF)*XCOF(II)*D1M +
     1       XD2MB(IGR,ITY,ISO,I,IDF)*XCOF(II)*VD2M +
     1       XSMB(IGR,ITY,ISO,I,IDF)*XCOF(II)*CSM +
     1       XNP9B(IGR,ITY,ISO,I,IDF)*XCOF(II)*CNP9 +
     1       XMFDB(IGR,ITY,ISO,I,IDF)*XCOF(II)*T1F*D1C +
     1       XMMDB(IGR,ITY,ISO,I,IDF)*XCOF(II)*T1C*D1C +
     1       XPF1LB(IGR,ITY,ISO,I,IDF)*XCOF(II)*CPF1 +
     1       XPF2LB(IGR,ITY,ISO,I,IDF)*XCOF(II)*CPF2)*DEL(ISO)
             IF(IMPX.GT.5) THEN
                WRITE(6,*) 'I II ISO ITYP IG2 ',I,II,ISO,ITY,IGR
                WRITE(6,*) ' XCOF ',XCOF(II)
                WRITE(6,*) 'COMPOSANTE MACR ',SMACB(IGR,ITY,1,I,IDF)
                WRITE(6,*) ' BORE ET PUR ', XBORB(IGR,ITY,ISO,I,IDF),
     1                      XPURB(IGR,ITY,ISO,I,IDF)
                WRITE(6,*) ' BORE ET PUR CONC ', CB,PUR,BOR,XIR
             ENDIF
*
 100   CONTINUE
 901   CONTINUE
* STORE SCATTERING
       IL= 1
       ITY=5+2*IXYZ+IL
       IGAR=0
       DO 120 JGR=1,NGRP
          DO 120 IGR=IJJ(JGR),IJJ(JGR)-NJJ(JGR)+1,-1
            IGAR=IGAR+1
            SCAT(NMIX,IL,IGR,JGR)=SMAC(IGAR,ITY,1)
* TOTAL OR ABS
            SMAC(IGR,2,1)=SMAC(IGR,2,1)+SCAT(NMIX,IL,IGR,JGR)
 120     CONTINUE
 130  CONTINUE
* STORE X-SECTIONS
      DO 260 ITY=1,NTYP
        DO 260 IGR=1,NGRP
          SIGMA(NMIX,IGR,ITY)=SMAC(IGR,ITY,1)
 260  CONTINUE
*
      RETURN
      END
