*DECK AFMLOC
          SUBROUTINE AFMLOC (NBURN,NTP,XBMAX,XBMIN,XBURN,MAX,MIN,
     1    COF)
*
*---------------------------------------------------------------*
*
*  BURNUP LOCALISATION AND INTERPOLATION.
*
*---------------------------------------------------------------*
*
* INPUT PARAMETERS:
*  NBURN  : TOTAL NUMBER OF BURNUP STEPS.
*  XBURN  : BURNUP STEPS DIMEMSION (NBURN).
*  XBMAX  : HIGHER BURNUP VALUE.
*  XBMIN  : LOWER BURNUP VALUE.
*
*
* OUTPUT PARAMETERS:
*  MAX   : MAXIMUM BURNUP NUMBER
*  MIN   : MINIMUM BURNUP NUMBER
*  COF   : INTERPOLATION COEFFICIENT (LAGRANGE)
*
*
*---------------------------------------------------------------*
*--------------------------- AUTHOR: M.T. SISSAOUI ; 20/09/96 --*
*---------------------------------------------------------------*
*
      DIMENSION XBURN(NBURN),ELMT(3)
      DOUBLE PRECISION COF(3)
      NTP=2
      COF(1)=0.0D0
      COF(2)=0.0D0
      COF(3)=0.0D0
      IF(XBMAX.EQ.XBMIN) NTP=1
      IF(XBMAX.GT.XBURN(NBURN))
     1      CALL XABORT('AFMLOC: THE HIGHER BURNUP VALUE IS  '
     1      //' BEYOND THE MAXIMUM BURNUP IN THE DATABASE ')
      IF(NBURN.EQ.1.AND.NTP.EQ.2) THEN
         CALL XABORT('AFMDRV: TIME AVERAGE CALCULATION REQUIRE'
     1    //'AT LEAST TWO IRRADIATIONS STEPS ')
      ELSE IF(NBURN.EQ.1.AND.NTP.EQ.1) THEN
         COF(1)=1.0D0
         MIN=1
         MAX=1
      ELSE IF(NBURN.EQ.2) THEN
         MIN=1
         MAX=2
         IF(NTP.EQ.1) THEN
           XIRAD=XBMIN
           NTOX=2
           NELE=2
           ELMT(1)=XBURN(1)
           ELMT(2)=XBURN(2)
           CALL LIBLEX(NELE,XIRAD,ELMT,NTOX,XCOF)
         ENDIF
      ELSE IF(NBURN.GE.3) THEN
         DO 80 IV=1,NTP
           IF(IV.EQ.1) THEN
             XIRAD=XBMIN
           ELSE
             XIRAD=XBMAX
           ENDIF
*
           DO 80 I=2,NBURN
             IF(XIRAD.GE.XBURN(I-1).AND.XIRAD.LE.XBURN(I)) THEN
               IF(NTP.EQ.2) THEN
                 IF(IV.EQ.1) THEN
                   MIN=I-1
                 ELSE
                   IF(I+1.LE.NBURN) THEN
                     MAX=I+1
                   ELSE
                    MAX=I
                   ENDIF
                 ENDIF
               ELSE
                 IF(I+1.LE.NBURN) THEN
                   MIN=I-1
                   MAX=I+1
                 ELSE
                   MIN=I-2
                   MAX=I
                 ENDIF
               ENDIF
             ENDIF
 80      CONTINUE
         IF(NTP.EQ.1) THEN
           NTOX=3
           NELE=3
           ELMT(1)=XBURN(MAX-2)
           ELMT(2)=XBURN(MAX-1)
           ELMT(3)=XBURN(MAX)
           CALL LIBLEX(NELE,XIRAD,ELMT,NTOX,COF)
         ENDIF
      ENDIF
*
      RETURN
      END
