*DECK AFMXNC
          SUBROUTINE AFMXNC (NGRP,SIGX,SIGF,FLUX,XXE,XNP,
     1    FLUR)
*
*-----------------------------------------------------------------------
*
* COMPUTATION OF XENON AND NEPTUNIUM CONCENTRATIONS.
*
* INPUT PARAMETERS:
*  SIGX  : XENON ABSORPTION MICRO-X-SECTION DIMENSION (NGRP).
*  SIGF  : FISSION MACRO-X-SECTION DIMENSION (NGRP).
*  FLUX  : FLUX DIMENSION (NGRP)
*
*
* OUTPUT PARAMETERS:
* XXE   : XENON CONCENTRATION
* XNP   : NEPTUNIUM CONCENTRATION
*
*
*---------------------------------------------------------------*
*--------------------------- AUTHOR: M.T. SISSAOUI ; 20/06/96 --*
*---------------------------------------------------------------*
*
      DIMENSION FLUX(NGRP),SIGF(NGRP),SIGX(NGRP),FLUR(NGRP)
      REAL      CF
* SET THE YIELD AND THE DECAY CONSTANTE FOR XENON AND NEPTUNIUM
      XLAMBDAX = 2.09E-5
      XLAMBDAI = 2.85E-5
      GAMMAI = 0.0631
      GAMMAX = 0.0045
* CF=1.E-24(barn)
      CF=1.0E-24
      CINTG=1.0E+13
*  CALCUL DES TAUX DE FISSION
      TAUF=0.0
      TAUAX=0.0
      FLR=0.0
      FLX=0.0
      DO 10 IGR = 1,NGRP
        TAUF = TAUF+FLUX(IGR)*SIGF(IGR)
        TAUAX = TAUAX+FLUX(IGR)*SIGX(IGR)
        FLR=FLR+FLUR(IGR)*CINTG
        FLX=FLX+FLUX(IGR)
 10   CONTINUE
*  COMPUTE THE XENON CONCENTRATION
      XXE=CF*(GAMMAX+GAMMAI)*TAUF/(XLAMBDAX+TAUAX*CF)
*  COMPUTE THE NEPTUNIUM CONCENTRATION
      XNP=XNP*FLX/FLR
*
      RETURN
      END
