*DECK BIVACA
      SUBROUTINE BIVACA(NENTRY,HENTRY,IENTRY,JENTRY,KENTRY)
*
*-----------------------------------------------------------------------
*
* BIVAC TYPE (2-D) SYSTEM MATRIX ASSEMBLY MODULE.
*
* INPUT/OUTPUT PARAMETERS:
*  NENTRY : NUMBER OF LINKED LISTS OR FILES USED BY THE MODULE.
*  HENTRY : CHARACTER*12 NAME OF EACH LINKED LIST OR FILE.
*  IENTRY : =1 LINKED LIST; =2 XSM FILE; =3 SEQUENTIAL BINARY FILE;
*           =4 SEQUENTIAL ASCII FILE.
*  JENTRY : =0 THE LINKED LIST OR FILE IS CREATED.
*           =1 THE LINKED LIST OR FILE IS OPEN FOR MODIFICATIONS;
*           =2 THE LINKED LIST OR FILE IS OPEN IN READ-ONLY MODE.
*  KENTRY : =FILE UNIT NUMBER; =LINKED LIST ADDRESS OTHERWISE.
*           DIMENSION HENTRY(NENTRY),IENTRY(NENTRY),JENTRY(NENTRY),
*           KENTRY(NENTRY)
*
* LINKED LIST / XSM FILE:
*  HENTRY(1) : CREATE OR MODIFICATION TYPE(L_SYSTEM).
*  HENTRY(2) : READ-ONLY TYPE(L_MACROLIB)
*  HENTRY(3) : READ-ONLY LINKED LIST TYPE(L_BIVAC)
*
*-------------------------------------- AUTHOR: A. HEBERT ; 01/12/93 ---
*
      CHARACTER HENTRY(*)*12,TEXT4*4,HSIGN*12,TEXT12*12,HSMG*131
      DOUBLE PRECISION DFLOTT
      DIMENSION IENTRY(*),JENTRY(*),KENTRY(*),IGP(4),IPAR(7),KCHAR(3),
     1 IBASE(1)
      COMMON BASE(1)
      EQUIVALENCE (BASE(1),IBASE(1))
*
* PARAMETER VALIDATION.
      IF(NENTRY.LE.2) CALL XABORT('BIVACA: THREE PARAMETERS EXPECTED.')
      IF((IENTRY(1).NE.1).AND.(IENTRY(1).NE.2)) CALL XABORT('BIVACA: LI'
     1 //'NKED LIST OR XSM FILE EXPECTED AT LHS.')
      IF((JENTRY(1).NE.0).AND.(JENTRY(1).NE.1)) CALL XABORT('BIVACA: EN'
     1 //'TRY IN CREATE OR MODIFICATION MODE EXPECTED.')
      IF((JENTRY(2).NE.2).OR.((IENTRY(2).NE.1).AND.(IENTRY(2).NE.2)))
     1 CALL XABORT('BIVACA: LINKED LIST OR XSM FILE IN READ-ONLY MODE E'
     2 //'XPECTED AT SECOND RHS.')
      IF((JENTRY(3).NE.2).OR.((IENTRY(3).NE.1).AND.(IENTRY(3).NE.2)))
     1 CALL XABORT('BIVACA: LINKED LIST OR XSM FILE IN READ-ONLY MODE E'
     2 //'XPECTED AT FIRST RHS.')
      CALL LCMGET(KENTRY(3),'SIGNATURE',KCHAR)
      WRITE(HSIGN,'(3A4)') (KCHAR(I),I=1,3)
      IF(HSIGN.NE.'L_BIVAC') THEN
         TEXT12=HENTRY(3)
         CALL XABORT('BIVACA: SIGNATURE OF '//TEXT12//' IS '//HSIGN//
     1   '. L_BIVAC EXPECTED.')
      ENDIF
      HSIGN='L_SYSTEM'
      IPSYS=KENTRY(1)
      READ(HSIGN,'(3A4)') (KCHAR(I),I=1,3)
      CALL LCMPUT(IPSYS,'SIGNATURE',3,3,KCHAR)
      IPMACR=KENTRY(2)
      IPTRK=KENTRY(3)
*
* RECOVER GENERAL TRACKING INFORMATION.
      CALL LCMGET(IPTRK,'GPARAM',IGP)
      NEL=IGP(1)
      NUN=IGP(2)
      CALL SETARA(IBASE,NEL,IMAT)
      CALL SETARA(BASE,NEL,IVOL)
      CALL SETARA(IBASE,NEL,IIDL)
      CALL LCMGET(IPTRK,'MATCOD',IBASE(IMAT))
      CALL LCMGET(IPTRK,'VOLUME',BASE(IVOL))
      CALL LCMGET(IPTRK,'KEYFLX',IBASE(IIDL))
*
* RECOVER MACROLIB PARAMETERS.
      CALL LCMGET(IPMACR,'SIGNATURE',KCHAR)
      WRITE(HSIGN,'(3A4)') (KCHAR(I),I=1,3)
      IF(HSIGN.NE.'L_MACROLIB') THEN
         TEXT12=HENTRY(2)
         CALL XABORT('BIVACA: SIGNATURE OF '//TEXT12//' IS '//HSIGN//
     1   '. L_MACROLIB EXPECTED.')
      ENDIF
      CALL LCMGET(IPMACR,'IDATAXS',IPAR)
      NGRP=IPAR(1)
      MAXMIX=IPAR(2)
      IF(IGP(4).GT.MAXMIX) THEN
         WRITE(HSMG,'(46HBIVACA: THE NUMBER OF MIXTURES IN THE TRACKING,
     1   2H (,I5,51H) IS GREATER THAN THE NUMBER OF MIXTURES IN THE MAC,
     2   7HROLIB (,I5,2H).)') IGP(4),MAXMIX
         CALL XABORT(HSMG)
      ELSE IF(IPAR(4).NE.1) THEN
         CALL XABORT('BIVACA: IDATAXS(4) EXPECTED EQUAL TO 1.')
      ENDIF
*
      IMPX=1
   10 CALL REDGET(INDIC,NITMA,FLOTT,TEXT4,DFLOTT)
      IF(INDIC.EQ.10) GO TO 20
      IF(INDIC.NE.3) CALL XABORT('BIVACA: CHARACTER DATA EXPECTED.')
      IF(TEXT4.EQ.'EDIT') THEN
         CALL REDGET(INDIC,IMPX,FLOTT,TEXT4,DFLOTT)
         IF(INDIC.NE.1) CALL XABORT('BIVACA: INTEGER DATA EXPECTED(1).')
      ELSE IF(TEXT4.EQ.';') THEN
         GO TO 20
      ELSE
         CALL XABORT('BIVACA: '//TEXT4//' IS AN INVALID KEY WORD.')
      ENDIF
      GO TO 10
*
* BIVAC SYSTEM MATRIX ASSEMBLY.
   20 CALL SETARA(BASE,MAXMIX*3,ISGD)
      CALL SETARA(BASE,MAXMIX*NGRP,IWORK)
      CALL SETARA(BASE,MAXMIX,IIJJ)
      CALL SETARA(BASE,MAXMIX,INJJ)
      CALL SETARA(BASE,MAXMIX,IIPOS)
      CALL BIVSYS (IPTRK,IPMACR,IPSYS,IMPX,NGRP,NEL,NUN,IBASE(IMAT),
     1 BASE(IVOL),IBASE(IIDL),TITLE,MAXMIX,BASE(ISGD),BASE(IWORK),
     2 BASE(IIJJ),BASE(INJJ),BASE(IIPOS))
      CALL RLSARA(BASE(IIPOS))
      CALL RLSARA(BASE(INJJ))
      CALL RLSARA(BASE(IIJJ))
      CALL RLSARA(BASE(IWORK))
      CALL RLSARA(BASE(ISGD))
*
      IF(IMPX.GE.3) CALL LCMLIB(IPSYS)
*
* RELEASE GENERAL TRACKING INFORMATION.
      CALL RLSARA(IBASE(IIDL))
      CALL RLSARA(BASE(IVOL))
      CALL RLSARA(IBASE(IMAT))
      RETURN
      END
