*DECK BIVASM
      SUBROUTINE BIVASM(HNAMT,ITY,IPTRK,IPSYS,IMPX,MAXMIX,NEL,NUN,MAT,
     1 VOL,IDL,SGD,TITR,ISPARM)
*
*-----------------------------------------------------------------------
*
* ASSEMBLY OF A SINGLE-GROUP SYSTEM MATRIX FOR BIVAC.
*
* INPUT PARAMETERS:
*  HNAMT  : CHARACTER*11 NAME OF THE MATRIX.
*  ITY    : =0: LEAKAGE-REMOVAL MATRIX ASSEMBLY; =1: X-SECTION MATRIX
*           ASSEMBLY.
*  IPTRK  : L_BIVAC POINTER TO THE BIVAC TRACKING INFORMATION.
*  IPSYS  : L_SYSTEM POINTER TO SYSTEM MATRICES.
*  IMPX   : PRINT PARAMETER. EQUAL TO ZERO FOR NO PRINT.
*  MAXMIX : FIRST DIMENSION FOR MATRICES SGD AND XSGD.
*  NEL    : TOTAL NUMBER OF FINITE ELEMENTS.
*  NUN    : TOTAL NUMBER OF UNKNOWNS PER GROUP.
*  MAT    : INDEX-NUMBER OF THE MIXTURE TYPE ASSIGNED TO EACH VOLUME.
*           DIMENSION MAT(NEL)
*  VOL    : VOLUMES. DIMENSION VOL(NEL)
*  IDL    : POSITION OF THE AVERAGE FLUX COMPONENT ASSOCIATED WITH
*           EACH VOLUME. DIMENSION IDL(NEL)
*  SGD    : NUCLEAR PROPERTIES PER MATERIAL MIXTURE.
*           DIMENSION SGD(MAXMIX,3)
*  TITR   : TITLE.
*  ISPARM : PARAMETERS OF SYSTEM MATRICES.
*
*---------------------------------------------- A. HEBERT 04/06/91 -----
*
      LOGICAL CYLIND
      CHARACTER HNAMT*(*),TITR*(*),TEXT11*11
      DIMENSION MAT(*),VOL(*),IDL(*),SGD(MAXMIX,*),IBASE(1),ITP(8),
     +          ISPARM(7)
      COMMON BASE(1)
      EQUIVALENCE (BASE(1),IBASE(1))
*
* RECOVER BIVAC SPECIFIC TRACKING INFORMATION.
      CALL LCMGET(IPTRK,'BPARAM',ITP)
      ITYPE=ITP(1)
      CYLIND=(ITYPE.EQ.3).OR.(ITYPE.EQ.6)
      IELEM=ITP(3)
      ICOL=ITP(4)
      ISPLH=ITP(5)
      LL4=ITP(6)
      LX=ITP(7)
      LY=ITP(8)
      CALL LCMLEN(IPTRK,'KN',MAXKN,ITYLCM)
      CALL LCMLEN(IPTRK,'QFR',MAXQF,ITYLCM)
      CALL SETARA(BASE,LX*LY,IXX)
      CALL SETARA(BASE,LX*LY,IYY)
      CALL SETARA(BASE,LX*LY,IDD)
      CALL SETARA(IBASE,MAXKN,IKN)
      CALL SETARA(BASE,MAXQF,IQFR)
      CALL SETARA(IBASE,LL4,IMU)
      IF(ITYPE.EQ.8) THEN
         CALL LCMGET(IPTRK,'SIDE',SIDE)
      ELSE
         CALL LCMGET(IPTRK,'XX',BASE(IXX))
         CALL LCMGET(IPTRK,'YY',BASE(IYY))
         CALL LCMGET(IPTRK,'DD',BASE(IDD))
      ENDIF
      CALL LCMGET(IPTRK,'KN',IBASE(IKN))
      CALL LCMGET(IPTRK,'QFR',BASE(IQFR))
      CALL LCMGET(IPTRK,'MU',IBASE(IMU))
*
      TEXT11=HNAMT
      IF(IMPX.GT.0) WRITE(6,'(/36H BIVASM: ASSEMBLY OF SYMMETRIC MATRI,
     1 3HX '',A11,38H'' IN COMPRESSED DIAGONAL STORAGE MODE.)') TEXT11
*
* ASSEMBLY OF THE SYSTEM MATRICES.
      IIMAX=IBASE(IMU+LL4-1)
      ISPARM(2) = IIMAX
      CALL SETARA(BASE,IIMAX,ISYS)
      DO 30 I=1,IIMAX
   30 BASE(ISYS+I-1)=0.0
*
      IF((IELEM.LT.0).AND.(ITYPE.NE.8)) THEN
*        MESH CORNER FINITE DIFFERENCES OR LAGRANGIAN FINITE ELEMENTS.
         CALL LCMSIX(IPTRK,'BIVCOL',1)
         CALL LCMLEN(IPTRK,'T',LC,ITYLCM)
         CALL SETARA(BASE,LC*LC,IR)
         CALL SETARA(BASE,LC*LC,IRS)
         CALL SETARA(BASE,LC*LC,IQ)
         CALL SETARA(BASE,LC*LC,IQS)
         CALL LCMGET(IPTRK,'R',BASE(IR))
         CALL LCMGET(IPTRK,'RS',BASE(IRS))
         CALL LCMGET(IPTRK,'Q',BASE(IQ))
         CALL LCMGET(IPTRK,'QS',BASE(IQS))
         CALL LCMSIX(IPTRK,' ',2)
         CALL BIVPM2(MAXMIX,ITY,NEL,LL4,CYLIND,MAT,VOL,SGD,BASE(IXX),
     1   BASE(IYY),BASE(IDD),IBASE(IKN),BASE(IQFR),IBASE(IMU),LC,
     2   BASE(IR),BASE(IRS),BASE(IQ),BASE(IQS),BASE(ISYS))
         CALL RLSARA(BASE(IQS))
         CALL RLSARA(BASE(IQ))
         CALL RLSARA(BASE(IRS))
         CALL RLSARA(BASE(IR))
      ELSE IF((IELEM.GT.0).AND.(ITYPE.NE.8)) THEN
*        MIXED-DUAL FINITE ELEMENTS.
         CALL LCMSIX(IPTRK,'BIVCOL',1)
         CALL LCMLEN(IPTRK,'T',LC,ITYLCM)
         CALL SETARA(BASE,LC*LC,IR)
         CALL SETARA(BASE,LC*(LC-1),IV)
         CALL LCMGET(IPTRK,'R',BASE(IR))
         CALL LCMGET(IPTRK,'V',BASE(IV))
         CALL LCMSIX(IPTRK,' ',2)
         CALL BIVDM2(MAXMIX,ITY,NEL,LL4,CYLIND,IELEM,ICOL,MAT,VOL,
     1   SGD,BASE(IXX),BASE(IYY),BASE(IDD),IBASE(IKN),BASE(IQFR),
     2   IBASE(IMU),LC,BASE(IR),BASE(IV),BASE(ISYS))
         CALL RLSARA(BASE(IV))
         CALL RLSARA(BASE(IR))
      ELSE IF((IELEM.LT.0).AND.(ITYPE.EQ.8)) THEN
*        MESH CORNER FINITE DIFFERENCES FOR HEXAGONS.
         CALL LCMSIX(IPTRK,'BIVCOL',1)
         CALL SETARA(BASE,4,IR)
         CALL SETARA(BASE,36,IRH)
         CALL SETARA(BASE,36,IQH)
         CALL SETARA(BASE,9,IRT)
         CALL SETARA(BASE,9,IQT)
         CALL LCMGET(IPTRK,'R',BASE(IR))
         CALL LCMGET(IPTRK,'RH',BASE(IRH))
         CALL LCMGET(IPTRK,'QH',BASE(IQH))
         CALL LCMGET(IPTRK,'RT',BASE(IRT))
         CALL LCMGET(IPTRK,'QT',BASE(IQT))
         CALL LCMSIX(IPTRK,' ',2)
         IF(ISPLH.EQ.1) THEN
            NELEM=MAXKN/7
         ELSE
            NELEM=MAXKN/4
         ENDIF
         CALL BIVRX2(MAXMIX,ITY,ISPLH,NELEM,LL4,SGD,SIDE,MAT,VOL,
     1   IBASE(IKN),BASE(IQFR),IBASE(IMU),BASE(IR),BASE(IRH),BASE(IQH),
     2   BASE(IRT),BASE(IQT),BASE(ISYS))
         CALL RLSARA(BASE(IQT))
         CALL RLSARA(BASE(IRT))
         CALL RLSARA(BASE(IQH))
         CALL RLSARA(BASE(IRH))
         CALL RLSARA(BASE(IR))
      ELSE IF((IELEM.GT.0).AND.(ITYPE.EQ.8)) THEN
*        MESH CENTERED FINITE DIFFERENCES FOR HEXAGONS.
         CALL BIVMX2 (MAXMIX,ITY,ISPLH,LL4,MAT,VOL,SGD,SIDE,IBASE(IKN),
     1   BASE(IQFR),IBASE(IMU),BASE(ISYS))
      ENDIF
      CALL LCMPOF(IPSYS,TEXT11,IIMAX,2,ISYS)
*
* MATRIX FACTORIZATIONS.
      IF(ITY.EQ.0) THEN
         CALL SETARA(BASE,IIMAX,IASS)
         CALL LCMGET(IPSYS,TEXT11,BASE(IASS))
         CALL ALLDLF(LL4,BASE(IASS),IBASE(IMU))
         CALL LCMPOF(IPSYS,'I'//TEXT11,IIMAX,2,IASS)
      ENDIF
*
* RELEASE BIVAC SPECIFIC TRACKING INFORMATION.
      CALL RLSARA(IBASE(IMU))
      CALL RLSARA(BASE(IQFR))
      CALL RLSARA(IBASE(IKN))
      CALL RLSARA(BASE(IDD))
      CALL RLSARA(BASE(IYY))
      CALL RLSARA(BASE(IXX))
      RETURN
      END
