*DECK CALBEX
      SUBROUTINE CALBEX(NCH,NK,NZC,POWR,IZONE,BZC,FFK)
*
**********************************************************************
*
*     THIS SUBROUTINE COMPUTES AVERAGE EXIT BURNUP OF THE TOTAL CORE
*
*
*    NCH   : NUMBER OF CHANNELS                                   I
*    NK    : NUMBER OF BUNDLES PER CHANNEL                        I
*    NZC   : NUMBER OF COMBUSTION ZONES                           I
*    POWR  : FUEL POWERS. POWR(NCH,NK)                            R
*    IZONE : COMBUSTION ZONE INDICES. ZONE(NCH)                   I
*    BZC   : AVERAGE EXIT BURNUP PER COMBUSTION ZONES. BZC(NZC)   R
*
*    FFK   : WORKING VECTOR. FFK(NZC)                             D
*
*-------------------------------------- AUTHOR: E. VARIN  95/11/20 ---
*
      IMPLICIT NONE
      INTEGER  I,J,IZC
      INTEGER  NCH,NK,NZC,IZONE(NCH)
      REAL     POWR(NCH,NK),BZC(NZC)
*
      DOUBLE PRECISION  POW,FFK(NZC),FF,BEXT
*
*     POWER COMPUTATION
*
      POW = 0.0D0
      DO 10 IZC=1,NZC
        FFK(IZC) = 0.0D0
 10   CONTINUE
*
      DO 95 I=1,NCH
       IZC = IZONE(I)
       DO 96 J=1,NK
         POW = POW + POWR(I,J)
         FFK(IZC) = FFK(IZC) + POWR(I,J) / BZC(IZC)
 96    CONTINUE
 95   CONTINUE
*
      BEXT = 0.0D0
      FF = 0.0D0
      DO 110 I=1,NZC
         FFK(I) = FFK(I)/POW
         FF = FF + FFK(I)
         BEXT = BEXT + FFK(I) * BZC(I)
  110 CONTINUE
      BEXT = BEXT / FF
      WRITE(6,'(22HMEAN COMBUSTION RATE: ,F12.2,1X,9HMWDAY/T-U)')
     +    BEXT
      RETURN
      END
