*DECK CALPOW
      SUBROUTINE CALPOW(PTOT,FLUR,HFAC,NGRP,NCH,NK,NMIX,POWR,VOLR,FSTH)
*
**********************************************************************
*
*     THIS SUBROUTINE COMPUTES FUEL BUNDLE POWERS AND REACTOR
*     TOTAL POWER.
*
*    PTOT : TOTAL REACTOR POWER IN MW.                           R
*    FLUR : FUEL AVERAGE FLUXES. FLUR(NCH,NK)                    R
*    HFAC : ENERGY CONVERSION FACTORS. HFAC(NMIX,NGRP)           R
*    NGRP : NUMBER OF ENERGY GROUPS                              I
*    NCH  : NUMBER OF CHANNELS                                   I
*    NK   : NUMBER OF BUNDLES PER CHANNEL                        I
*    NMIX : NUMBER OF BUNDLES. NCH*NK                            I
*    VOLR : FUEL CELL VOLUMES. VOLR(NCH,NK)                      R
*    FSTH : THERMAL TO FISSION POWER RATIO.                      R
*
*    POWR : FUEL AVERAGE FLUXES. FLUR(NCH,NK,NGRP)               R
*
*-------------------------------------- AUTHOR: E. VARIN  95/09/20 ---
*
      IMPLICIT NONE
*
*  LOCAL VARIABLES
*
      INTEGER IGR,I,J,K
      INTEGER NCH,NK,NGRP,NMIX
      REAL    FLUR(NCH,NK,NGRP),HFAC(NMIX,NGRP),POWR(NCH,NK),
     >        VOLR(NCH,NK)
*
      REAL    PTOT,FSTH
      DOUBLE PRECISION  FACT,POW
*
*     FUEL POWER COMPUTATION
*
      POW = 0.0D0
      DO 95 I=1,NCH
      DO 95 J=1,NK
        POWR(I,J) = 0.0
        K = (J-1)*NCH + I
        DO 90 IGR=1,NGRP
           POWR(I,J) = POWR(I,J) +
     >                FLUR(I,J,IGR)*HFAC(K,IGR)*VOLR(I,J)
 90     CONTINUE
        POW = POW + DBLE(POWR(I,J))
 95   CONTINUE
*
      FACT=1.0E+03*DBLE(PTOT)/POW
      FACT= FACT/FSTH
      DO 110 I=1,NCH
       DO 110 J=1,NK
         POWR(I,J)=POWR(I,J)*FACT
         DO 120 IGR=1,NGRP
           FLUR(I,J,IGR) = FLUR(I,J,IGR)*FACT*1.0E+3
  120    CONTINUE
  110 CONTINUE
      WRITE(6,200) PTOT
*
  200 FORMAT('TOTAL POWER = ',F12.2,1X,'MW')
      RETURN
      END
