*DECK CELLAG
      SUBROUTINE CELLAG(IPRES,NCH,NK,IMOD,BINI,BFIN,F,WINT,ALCH)
*
*-----------------------------------------------------------------------
*
*  REFUEL A CHANNEL ACCORDING TO A REFUELING MODE
*
*  CALCULE LE NOUVEL ENSEMBLE DE BURNUP PAR GRAPPE SELON LE RECHARGEMENT
*
* INPUT PARAMETERS:
*  IPRES  : ADDRESS OF THE MAP LINKED LIST OR XSM FILE.
*  NCH    : NUMBER OF CHANNELS
*  NK     : NUMBER OF BUNDLES PER CHANNEL
*  IMOD   : BURNUP INTEGRATION TYPE.
*  ALCH   : INTEGER REPRESENTING CHANNEL AGE. ALCH(NCH)
*
* OUTPUT PARAMETERS:
*  IPRES  : ADDRESS OF THE MAP LINKED LIST OR XSM FILE.
*
* SCRATCH STORAGE:
*  BINI   : DIMENSION BINI(NCH,NK)
*  BFIN   : DIMENSION BFIN(NCH,NK)
*  WINT   : DIMENSION WINT(NCH*NK)
*  F      : DIMENSION F(NCH)
*
*     ROUTINE PARTLY RECOVERED FROM OPTEX-4 (COEF3E)
*
*-------------------------------------- AUTHOR: E. VARIN 02/09/97 ---
*
      INTEGER    IPRES
      INTEGER    NCH,NK,ALCH(NCH)
      REAL       WINT(NCH,NK),BINI(NCH,NK),BFIN(NCH,NK),F(NCH)
*
C LOCAL
      INTEGER    I,J,ILONG,ITYP,NCC
*
* RECOVER FUEL BURNUPS
      CALL LCMLEN(IPRES,'BURN-DEB',ILONG,ITYP)
      IF(ILONG.EQ.0) THEN
         CALL XABORT('SHIFTB: INITIAL BURNUP REQUIRED')
      ENDIF
      CALL LCMGET(IPRES,'BURN-DEB',BINI)
      CALL LCMLEN(IPRES,'BURN-END',ILONG,ITYP)
      IF(ILONG.EQ.0) THEN
         CALL XABORT('SHIFTB: FINAL BURNUP REQUIRED')
      ENDIF
      CALL LCMGET(IPRES,'BURN-END',BFIN)
      NCC = FLOAT(NCH)
*
      DO 10 I=1,NCH
        F(I) = (FLOAT(ALCH(I)) - 0.5) / NCC
        IF( ALCH(I).EQ.0 )THEN
           F(I) = 0.0
        ENDIF
        WRITE(6,*) ' AGE ',F(I)
        DO 11 J=1,NK
          WINT(I,J) = BINI(I,J) + F(I) * (BFIN(I,J) - BINI(I,J))
*
 11     CONTINUE
 10   CONTINUE
      CALL LCMPUT(IPRES,'BURN-DEB',NCH*NK,2,WINT)
*
      RETURN
      END
