*DECK CHCKDV
      SUBROUTINE CHCKDV(IPLDEV,TYPE,FAMILY,SEQUEN,POS,
     +                   MOVDIR,CPT,IRC)
*
**********************************************************************
*
*     THIS SUBROUTINE VERIFIES CONSISTENCY OF DESCRIPTOR POSITIONS
*     IN REFERENCE TO MAXIMUM POSITIONS AND THEIR CONNECTION WITH
*     ONE AN OTHER.
*     THE DEVICE IS SUPPOSED TO MOVE ALONG Y AXIS.
*
*     CETTE ROUTINE VERIFIE LA CONSISTANCE DES POSITIONS DES
*     DESCRIPTIONS DE CONTROLEURS PAR RAPPORT AUX POSITIONS
*     MAXIMALES ET ENTRE EUX
*
*     INPUT :
*              IPLDEV : INTEGER
*                       ADRESS OF DEVICE OBJECT
*              TYPE   : CHARACTER*12
*                       DEVICE TYPE NAME
*              FAMILY : CHARACTER*12
*                       DEVICE FAMILY NAME
*              SEQUEN : CHARACTER*12
*                       DEVICE SEQUENCE NAME
*              MOVDIR : CHARACTER*1
*                       DEVICE MOVEMENT AXIS. X, Y OR Z
*              CPT    : INTEGER
*                       NUMBER OF DESCRIPTORS OF THE SPECIFIED DEVICE
*     OUTPUT :
*              IRC    : INTEGER
*                       ERROR CODE;
*                       = 0 NO ERROR ;
*                       = 1 X AND Z COORDINATES INCOHERENT;
*                       = 2 Y COORDINATES INCOHERENT, Y- > Y+ ;
*                       = 3 Y COORDINATES OF DESCRIPTORS DO NOT CONNECT;
*                       = 4 Y MAX OF DESCRIPTORS DIFFERENT FROM
*                           Y MAX OF THE COMPLETE DEVICE.
*
*     VARIABLES :
*              POS    : REAL
*                       DESCRIPTOR POSITIONS. DIMENSION : 6,CPT
*
*
*
*-------------------------------------- AUTHOR: J. KOCLAS 95/02/20 ---
*                                               E. VARIN
*
*
*      IMPLICIT NONE
*
      INTEGER  IPLDEV,CPT,IRC
C
C DEVICE STRUCTURE
C
      CHARACTER TYPE*12,FAMILY*12,SEQUEN*12
      REAL POS(6,CPT),MINP
      REAL MAXPOS(6),PREC,AUX
      CHARACTER MOVDIR*4
*
      CHARACTER*12 TEXT,NAMLCM,NAMMY
      INTEGER      ITYP,ILONG,I,J,N,IMIN,IXM,IXP,IYM,IYP,IZM,IZP
      LOGICAL      LCM
      PARAMETER (PREC=1.E-4)
*
      IRC = 0
      CALL LCMSIX(IPLDEV,' ',0)
      CALL LCMSIX(IPLDEV,TYPE,1)
      CALL LCMSIX(IPLDEV,FAMILY,1)
      CALL LCMSIX(IPLDEV,SEQUEN,1)
      CALL LCMGET(IPLDEV,'POSITION_MAX',MAXPOS)
      TEXT = ' '
      I = 0
 10   CALL LCMNXT(IPLDEV,TEXT,NAMLCM,NAMMY,LCM)
      CALL LCMLEN(IPLDEV,TEXT,ILONG,ITYP)
      IF (ITYP.EQ.0) THEN
        I = I + 1
        CALL LCMSIX(IPLDEV,TEXT,1)
        CALL LCMGET(IPLDEV,'POSITION',POS(1,I))
        CALL LCMSIX(IPLDEV,' ',2)
      ENDIF
      IF (I.EQ.CPT) GOTO 20
      GOTO 10
*
 20   IF (MOVDIR.EQ.'X') THEN
         IXM = 3
         IXP = 4
         IYM = 1
         IYP = 2
         IZM = 5
         IZP = 6
      ELSEIF (MOVDIR.EQ.'Y') THEN
         IXM = 1
         IXP = 2
         IYM = 3
         IYP = 4
         IZM = 5
         IZP = 6
      ELSEIF (MOVDIR.EQ.'Z') THEN
         IXM = 1
         IXP = 2
         IYM = 5
         IYP = 6
         IZM = 3
         IZP = 4
      ENDIF
      DO 30 I=1,CPT
         IF ((POS(IXM,I).NE.MAXPOS(IXM)).OR.
     +      (POS(IXP,I).NE.MAXPOS(IXP)).OR.
     +      (POS(IZM,I).NE.MAXPOS(IZM)).OR.
     +      (POS(IZP,I).NE.MAXPOS(IZP)))  THEN
           IRC =1
           GOTO 70
         ENDIF
 30   CONTINUE
*
      DO 40 I=1,CPT
         IF ((POS(IYP,I)-POS(IYM,I)).LT.-PREC) THEN
           IRC =2
           GOTO 70
         ENDIF
 40   CONTINUE
*
*   TRI DE Y- DEVICE
*
      DO 35 I=1,CPT
         MINP = 1.E+30
         DO 36 J=I,CPT
           IF (POS(IYM,J).LT.MINP) THEN
             IMIN = J
             MINP = POS(IYM,J)
           ENDIF
 36      CONTINUE
         DO 37 N=1,6
          AUX = POS(N,I)
          POS(N,I) = POS(N,IMIN)
          POS(N,IMIN) = AUX
 37      CONTINUE
 35   CONTINUE
*
      MINP = MAXPOS(IYM)
      DO 50 I=1,CPT
           IF (ABS(POS(IYM,I)-MINP).LE.PREC) THEN
              MINP = POS(IYP,I)
           ELSE
              IRC = 3
              WRITE(6,*) 'WRONG POSITION ',POS(IYM,I),MINP
              GOTO 70
           ENDIF
 50   CONTINUE
      IF (ABS(MINP-MAXPOS(IYP)).GT.PREC) THEN
          IRC = 4
          GOTO 70
      ENDIF
 70   RETURN
      END
