*DECK CRE
      SUBROUTINE CRE(NENTRY,HENTRY,IENTRY,JENTRY,KENTRY)
*
*-----------------------------------------------------------------------
*
* RECOVER AND INTERPOLATE MACROLIB INFORMATION FROM ONE OR MANY
* COMPO LINKED LISTS OR XSM FILES.
*
* INPUT/OUTPUT PARAMETERS:
*  NENTRY : NUMBER OF LINKED LISTS OR FILES USED BY THE MODULE.
*  HENTRY : CHARACTER*12 NAME OF EACH LINKED LIST OR FILE.
*  IENTRY : =1 LINKED LIST; =2 XSM FILE; =3 SEQUENTIAL BINARY FILE;
*           =4 SEQUENTIAL ASCII FILE.
*  JENTRY : =0 THE LINKED LIST OR FILE IS CREATED.
*           =1 THE LINKED LIST OR FILE IS OPEN FOR MODIFICATIONS;
*           =2 THE LINKED LIST OR FILE IS OPEN IN READ-ONLY MODE.
*  KENTRY : =FILE UNIT NUMBER; =LINKED LIST ADDRESS OTHERWISE.
*           DIMENSION HENTRY(NENTRY),IENTRY(NENTRY),JENTRY(NENTRY),
*           KENTRY(NENTRY)
*
* LINKED LIST / XSM FILE:
*  HENTRY(1) : CREATE OR MODIFICATION TYPE(L_MACROLIB).
*  HENTRY(I) : READ-ONLY MODE TYPE(L_COMPO).
*  HENTRY(I) : READ-ONLY MODE TYPE(L_TABLE).
*  HENTRY(I) : READ-ONLY MODE TYPE(L_MAP).
*
*-------------------------------------- AUTHOR: A. HEBERT ; 16/02/94 ---
*-------------------------------------- MODIFIED: E. VARIN ; 28/08/95 --
*
      CHARACTER HENTRY(*)*12,TEXT4*4,TEXT12*12,HSMG*131,HSIGN*12,
     1   NAMPAR*12,NAMMY*12,NAMLCM*12
      LOGICAL  LCM
      INTEGER  IPRES,I1,ILONG,ITYP
      DOUBLE PRECISION DFLOTT
      DIMENSION IENTRY(*),JENTRY(*),KENTRY(*),IDATA(7),KCHAR(3),IPAR(4)
      COMMON BASE(1)
*
* PARAMETER VALIDATION.
      IF(NENTRY.LE.1) CALL XABORT('CRE: 2 PARAMETER EXPECTED.')
      IF((IENTRY(1).NE.1).AND.(IENTRY(1).NE.2)) CALL XABORT('CRE: MACRO'
     1 //'LIB LINKED LIST OR XSM FILE EXPECTED AT LHS.')
      IF((JENTRY(1).NE.0).AND.(JENTRY(1).NE.1)) CALL XABORT('CRE: MACRO'
     1 //'LIB IN CREATE OR MODIFICATION MODE EXPECTED.')
      IF((IENTRY(2).NE.1).AND.(IENTRY(2).NE.2)) CALL XABORT('CRE: COMPO'
     1 //' LINKED LIST OR XSM FILE EXPECTED AT RHS.')
      IF(JENTRY(2).NE.2) CALL XABORT('CRE: COMPO IN READ-ONLY MODE EXPE'
     1 //'CTED AT RHS.')
      ITYPE=JENTRY(1)
      IPLIST=KENTRY(1)
*
* RECOVER SOME DATA IN THE FIRST MATERIAL OF THE FIRST COMPO.
      CALL LCMGET(KENTRY(2),'SIGNATURE',KCHAR)
      WRITE(HSIGN,'(3A4)') (KCHAR(I1),I1=1,3)
      IF(HSIGN.EQ.'L_COMPO') THEN
         NAMPAR = 'PARAM'
      ELSEIF(HSIGN.EQ.'L_TABLE') THEN
         NAMPAR = 'IDIM'
      ELSE
         TEXT12=HENTRY(2)
         CALL XABORT('CRE: SIGNATURE OF '//TEXT12//' IS '//HSIGN//
     1   '. L_COMPO OR L_TABLE EXPECTED.')
      ENDIF
      TEXT12='SIGNATURE'
      CALL LCMNXT(KENTRY(2),TEXT12,NAMLCM,NAMMY,LCM)
      IF(TEXT12.EQ.'SIGNATURE') CALL XABORT('CRE: INVALID INPUT COMPO.')
      CALL LCMSIX(KENTRY(2),TEXT12,1)
      CALL LCMGET(KENTRY(2),NAMPAR,IPAR)
      CALL LCMSIX(KENTRY(2),' ',2)
      NGRP=IPAR(1)
      NL=IPAR(3)
      IF(NL.GT.1) NL=1
*
* READ THE INPUT DATA.
*     DEFAULT OPTIONS:
      IMPX=1
      ISTEP=0
      NMIXT=0
      IF(ITYPE.EQ.0) THEN
         IND=1
         NMIXT=0
*        RECOVER MATERIAL MIXTURES NUMBER
         IPRES = 0
         DO 5 I=2,NENTRY
           IF((IENTRY(I).EQ.1).OR.(IENTRY(I).EQ.2)) THEN
            CALL LCMSIX(KENTRY(I),' ',0)
            CALL LCMGET(KENTRY(I),'SIGNATURE',KCHAR)
            WRITE(HSIGN,'(3A4)') (KCHAR(I1),I1=1,3)
            IF(JENTRY(I).NE.2) CALL XABORT('CRE: READ-ONL'
     +       //'Y MODE EXPECTED FOR OBJECT'//HSIGN//'.')
            IF (HSIGN.EQ.'L_MAP') THEN
               IF (IPRES.EQ.0) IPRES=KENTRY(I)
            ENDIF
           ENDIF
   5     CONTINUE
         IF (IPRES.NE.0) THEN
           CALL LCMSIX(IPRES,' ',0)
           CALL LCMLEN(IPRES,'INDEX',ILONG,ITYP)
           IF (ITYP.EQ.0)
     +      CALL XABORT('CRE: PREVIOUS CALL TO REFRES: MODULE'
     +         //' REQUIRED')
            NMIXT = ILONG
         ENDIF
      ELSE IF(ITYPE.EQ.1) THEN
         CALL LCMGET(IPLIST,'SIGNATURE',KCHAR)
         WRITE(HSIGN,'(3A4)') (KCHAR(I1),I1=1,3)
         IF(HSIGN.NE.'L_MACROLIB') THEN
            TEXT12=HENTRY(1)
            CALL XABORT('CRE: SIGNATURE OF '//TEXT12//' IS '//HSIGN//
     1      '. L_MACROLIB EXPECTED.')
         ENDIF
         IND=2
         CALL LCMGET(IPLIST,'IDATAXS',IDATA)
         IF(IDATA(1).NE.NGRP) THEN
            WRITE(HSMG,'(40HCRE: INCONSISTENT NB OF GROUPS. IN MACRO,
     1      5HLIB =,I5,11H IN COMPO =,I5)') IDATA(1),NGRP
            CALL XABORT(HSMG)
         ELSE IF(IDATA(3).LT.NL) THEN
            WRITE(HSMG,'(40HCRE: INCONSISTENT NB OF LEGENDRE ORDERS.,
     1      14H IN MACROLIB =,I5,11H IN COMPO =,I5)') IDATA(3),NL
            CALL XABORT(HSMG)
         ENDIF
         NGRP = IDATA(1)
         NMIXT=IDATA(2)
         NL=IDATA(3)
      ENDIF
*
* READ THE $CRE MODULE OPTIONS.
   10 CALL REDGET(INDIC,NITMA,FLOTT,TEXT4,DFLOTT)
      IF(INDIC.NE.3) CALL XABORT('CRE: CHARACTER DATA EXPECTED(1).')
   20 IF(TEXT4.EQ.'EDIT') THEN
*        READ THE PRINT INDEX.
         CALL REDGET(INDIC,IMPX,FLOTT,TEXT4,DFLOTT)
         IF(INDIC.NE.1) CALL XABORT('CRE: INTEGER DATA EXPECTED(1).')
      ELSE IF(TEXT4.EQ.'NMIX') THEN
*        READ THE MAXIMUM NUMBER OF MATERIAL MIXTURES.
         IF(NMIXT.NE.0) CALL XABORT('CRE: NMIX IS ALREADY DEFINED.')
         CALL REDGET(INDIC,NMIXT,FLOTT,TEXT4,DFLOTT)
         IF(INDIC.NE.1) CALL XABORT('CRE: INTEGER DATA EXPECTED(2).')
      ELSE IF(TEXT4.EQ.'ANIS') THEN
*        READ THE SCATTERING ANISOTROPY FOR TRANSPORT THEORY CASES.
         IF(IND.EQ.2) CALL XABORT('ANIS: NMIX IS ALREADY DEFINED.')
         CALL REDGET(INDIC,NL,FLOTT,TEXT4,DFLOTT)
         IF(INDIC.NE.1) CALL XABORT('CRE: INTEGER DATA EXPECTED(3).')
      ELSE IF(TEXT4.EQ.'STEP') THEN
*        STEP TO A SON DIRECTORY AND WRITE PERTURBATION VALUES.
         CALL REDGET(INDIC,ISTEP,FLOTT,TEXT4,DFLOTT)
         IF(INDIC.NE.1) CALL XABORT('CRE: INTEGER DATA EXPECTED(4).')
         WRITE(TEXT12,'(4HSTEP,I8)') ISTEP
         IF(IND.EQ.1) THEN
            CALL LCMLEN(IPLIST,TEXT12,ILENG,ITYLCM)
            IF(ILENG.GT.0) THEN
               WRITE(HSMG,'(29HCRE: PERTURBATION DIRECTORY '',A12,
     1         21H'' ALREADY EXISTS IN '',A12,2H''.)') TEXT12,HENTRY(1)
               CALL XABORT(HSMG)
            ENDIF
         ENDIF
         CALL LCMSIX(IPLIST,TEXT12,1)
         IF(IMPX.GT.0) WRITE(6,'(/31H CRE: WRITE PERTURBATION VALUES,
     1   15H ON DIRECTORY '',A12,6H'' OF '',A12,2H''.)') TEXT12,
     2   HENTRY(1)
      ELSE IF(TEXT4.EQ.'READ') THEN
*        INPUT NON-PERTURBED OR PERTURBED DIFFUSION COEFFICIENTS AND
*        CROSS SECTIONS PER MIXTURE.
         CALL SETARA(BASE,NMIXT*NGRP,ITOTAL)
         CALL SETARA(BASE,NMIXT*NGRP,IZNUG)
         CALL SETARA(BASE,NMIXT*NGRP,INUGF)
         CALL SETARA(BASE,NMIXT*NGRP,ICHI)
         CALL SETARA(BASE,NMIXT*NGRP,IOVERV)
         CALL SETARA(BASE,NMIXT*NGRP,IDIFFX)
         CALL SETARA(BASE,NMIXT*NGRP,IDIFFY)
         CALL SETARA(BASE,NMIXT*NGRP,IDIFFZ)
         CALL SETARA(BASE,NMIXT*NGRP,IH)
         CALL SETARA(BASE,NMIXT*NL*NGRP,IIJJ)
         CALL SETARA(BASE,NMIXT*NL*NGRP,INJJ)
         CALL SETARA(BASE,NMIXT*NL*NGRP*NGRP,ISCAT)
         CALL SETARA(BASE,NMIXT*NGRP,IWORK)
         CALL SETARA(BASE,NMIXT,IIPOS)
         CALL SETARA(BASE,NMIXT,IVOLME)
         CALL SETARA(BASE,NMIXT*NGRP,IFLUX)
         CALL SETARA(BASE,NGRP+1,IENER)
         CALL CREXSI(NENTRY,HENTRY,IENTRY,JENTRY,KENTRY,IND,NMIXT,NGRP,
     1   NL,IMPX,NBMIX,JND,BASE(ITOTAL),BASE(IZNUG),BASE(INUGF),
     2   BASE(ICHI),BASE(IOVERV),BASE(IDIFFX),BASE(IDIFFY),BASE(IDIFFZ),
     3   BASE(IH),BASE(IIJJ),BASE(INJJ),BASE(ISCAT),BASE(IWORK),
     4   BASE(IIPOS),BASE(IVOLME),BASE(IFLUX),BASE(IENER))
         CALL RLSARA(BASE(IENER))
         CALL RLSARA(BASE(IFLUX))
         CALL RLSARA(BASE(IVOLME))
         CALL RLSARA(BASE(IIPOS))
         CALL RLSARA(BASE(IWORK))
         CALL RLSARA(BASE(ISCAT))
         CALL RLSARA(BASE(INJJ))
         CALL RLSARA(BASE(IIJJ))
         CALL RLSARA(BASE(IH))
         CALL RLSARA(BASE(IDIFFZ))
         CALL RLSARA(BASE(IDIFFY))
         CALL RLSARA(BASE(IDIFFX))
         CALL RLSARA(BASE(IOVERV))
         CALL RLSARA(BASE(ICHI))
         CALL RLSARA(BASE(INUGF))
         CALL RLSARA(BASE(IZNUG))
         CALL RLSARA(BASE(ITOTAL))
         IF(ISTEP.GT.0) CALL LCMSIX(IPLIST,' ',2)
         IF(JND.EQ.1) THEN
            GO TO 30
         ELSE IF(JND.EQ.2) THEN
            TEXT4='STEP'
            GO TO 20
         ENDIF
      ELSE
         CALL XABORT('CRE: '//TEXT4//' IS AN INVALID KEY-WORD.')
      ENDIF
      GO TO 10
*
   30 IF(ITYPE.EQ.0) THEN
         HSIGN='L_MACROLIB'
         READ(HSIGN,'(3A4)') (KCHAR(I1),I1=1,3)
         CALL LCMPUT(IPLIST,'SIGNATURE',3,3,KCHAR)
         IDATA(1)=NGRP
         IDATA(2)=NMIXT
         IDATA(3)=NL
         IDATA(4)=1
         IDATA(5)=0
         IDATA(6)=0
         IDATA(7)=0
         CALL LCMPUT(IPLIST,'IDATAXS',7,1,IDATA)
      ENDIF
      IF((IMPX.GT.1).AND.(ISTEP.GT.0)) CALL LCMLIB(IPLIST)
      RETURN
      END
