*DECK CRESCA
      SUBROUTINE CRESCA(IPMAC,IPMAC2,SCAT,SCAT2,WORK,IJJ,NJJ,IPOS,WORK2,
     +  IJJ2,NJJ2,IPOS2,CM,JGR,IL,MIX,NMIX,NIND,NMXOLD,NL,NGRP,PRES)
*
**********************************************************************
*
*     THIS SUBROUTINE RECOVERS SCATTERING MATRICES, TREATS THEM
*     ACCORDING TO THE INDEX AND STORES THEM IN A NEW MACROLIB
*
*     CETTE ROUTINE RECUPERE LES SECTIONS EFFICACES DE DIFFUSION
*     ET LES RANGE APRES TRAITEMENT DANS LA NOUVELLE MACROLIB
*
*     INPUT :
*              IPMAC  : INTEGER
*                       ADRESS OF THE INITIAL MACROLIB OBJECT
*              NL     : INTEGER
*                       MAXIMUM LEVEL OF ANISOTROPY
*              NGRP   : INTEGER
*                       NUMBER OF ENERGY GROUPS
*              NMXOLD : INTEGER
*                       NUMBER OF MIXTURES IN THE INITIAL MACROLIB
*              NMIX   : INTEGER
*                       NUMBER OF MIXTURES IN THE FINAL MACROLIB
*              MIX    : INTEGER
*                       INDEX OF MATERIAL MIXTURES PER REGION
*                       DIMENSION: NMIX.
*              SCAT   : REAL
*                       SCATTERING MATRICES IN INITIAL MACROLIB.
*                       DIMENSION: NMXOLD*NL*NGRP*NGRP.
*              SCAT   : REAL
*                       SCATTERING MATRICES IN FINAL MACROLIB.
*                       DIMENSION: NMIX*NL*NGRP*NGRP.
*              PRES   : LOGICAL
*                       FLAG FOR FUEL MAP.
*                       IF TRUE, MIXTURE INDICE ARE NEGATIVE
*                       FOR FUEL REGIONS
*
*     OUTPUT :
*              IPMAC2 : INTEGER
*                       ADRESS OF THE FINAL MACROLIB OBJECT
*
*
*-------------------------------------- AUTHOR: J. KOCLAS 94/04/10 ---
*                                      MODIFIED: E. VARIN 95/09/10 ---
*
*
      INTEGER  IPMAC,IPMAC2,JGR,IL,NMIX,NMXOLD,NL,NGRP,NIND,CPT
      CHARACTER CM*2
      LOGICAL   PRES
      DIMENSION SCAT(NMXOLD,NL,NGRP,*),SCAT2(NMIX,NL,NGRP,*),
     +          WORK(*),IPOS(*),IJJ(NMXOLD,NL,*),NJJ(NMXOLD,NL,*),
     +          WORK2(*),IPOS2(*),IJJ2(NMIX,NL,*),NJJ2(NMIX,NL,*),
     +          MIX(*)
*
*     RECOVER OF SCAT,IJJ,NJJ AND CONSTRUCTION OF SCATTERING MATRIX
*
      IF (PRES) THEN
       DO 1 I=1,NGRP
         DO 1 J=1,NMIX
            SCAT2(J,IL,I,JGR) = 0.0
  1    CONTINUE
       CALL LCMGET(IPMAC2,'SCAT'//CM,WORK2(1))
       CALL LCMGET(IPMAC2,'NJJ'//CM,NJJ2(1,IL,JGR))
       CALL LCMGET(IPMAC2,'IJJ'//CM,IJJ2(1,IL,JGR))
       CALL LCMGET(IPMAC2,'IPOS'//CM,IPOS2(1))
       DO 2 IBM=1,NMIX
         IJJ0=IJJ2(IBM,IL,JGR)
         IPOSDE = IPOS2(IBM)
         DO 2 IGR=IJJ0,IJJ0-NJJ2(IBM,IL,JGR)+1,-1
            SCAT2(IBM,IL,IGR,JGR)=WORK2(IPOSDE)
            IPOSDE=IPOSDE+1
  2    CONTINUE
      ELSE
*
       DO 10 I=1,NGRP
         DO 10 J=1,NMIX
            SCAT2(J,IL,I,JGR) = 0.0
  10   CONTINUE
      ENDIF
*
      CALL LCMGET(IPMAC,'SCAT'//CM,WORK(1))
      CALL LCMGET(IPMAC,'NJJ'//CM,NJJ(1,IL,JGR))
      CALL LCMGET(IPMAC,'IJJ'//CM,IJJ(1,IL,JGR))
      CALL LCMGET(IPMAC,'IPOS'//CM,IPOS(1))
      DO 20 IBM=1,NMXOLD
         IJJ0=IJJ(IBM,IL,JGR)
         IPOSDE = IPOS(IBM)
         DO 20 IGR=IJJ0,IJJ0-NJJ(IBM,IL,JGR)+1,-1
            SCAT(IBM,IL,IGR,JGR)=WORK(IPOSDE)
            IPOSDE=IPOSDE+1
  20  CONTINUE
*     CONSTRUCTION OF THE NEW MATRIX FOR THE SECOND MACROLIB
      CPT = 0
      DO 30 IBM=1,NIND
        IF(MIX(IBM).NE.0) THEN
          CPT = CPT + 1
          IF(PRES) THEN
           IF (MIX(IBM).LT.0) THEN
             J = - MIX(IBM)
             IJJ0=IJJ(J,IL,JGR)
             DO 31 IGR=IJJ0,IJJ0-NJJ(J,IL,JGR)+1,-1
              SCAT2(CPT,IL,IGR,JGR)=SCAT(J,IL,IGR,JGR)
  31         CONTINUE
           ENDIF
          ELSE
           IF (MIX(IBM).GT.0) THEN
             J = MIX(IBM)
             IJJ0=IJJ(J,IL,JGR)
             DO 41 IGR=IJJ0,IJJ0-NJJ(J,IL,JGR)+1,-1
              SCAT2(CPT,IL,IGR,JGR)=SCAT(J,IL,IGR,JGR)
  41         CONTINUE
           ENDIF
          ENDIF
        ENDIF
  30  CONTINUE
*     CALCULATION OF NEW IJJ ET NJJ
      DO 50 IBM=1,NMIX
         IGMIN = JGR
         IGMAX = JGR
         DO 60 IGR=NGRP,1,-1
            IF (SCAT2(IBM,IL,IGR,JGR).NE.0.0) THEN
               IGMIN = MIN(IGMIN,IGR)
               IGMAX = MAX(IGMAX,IGR)
            ENDIF
  60     CONTINUE
         IJJ2(IBM,IL,JGR) = IGMAX
         NJJ2(IBM,IL,JGR) = IGMAX-IGMIN+1
  50  CONTINUE
*     STORAGE OF NEW SCAT2 IJJ ET NJJ
      IPOSDE = 0
      DO 70 IBM=1,NMIX
         IPOS2(IBM) = IPOSDE+1
         DO 70 IGR=IJJ2(IBM,IL,JGR),IJJ2(IBM,IL,JGR)-
     +       NJJ2(IBM,IL,JGR)+1,-1
            IPOSDE = IPOSDE+1
            WORK2(IPOSDE)=SCAT2(IBM,IL,IGR,JGR)
  70  CONTINUE
*
      CALL LCMPUT(IPMAC2,'SCAT'//CM,IPOSDE,2,WORK2)
      CALL LCMPUT(IPMAC2,'IPOS'//CM,NMIX,1,IPOS2)
      CALL LCMPUT(IPMAC2,'NJJ'//CM,NMIX,1,NJJ2(1,IL,JGR))
      CALL LCMPUT(IPMAC2,'IJJ'//CM,NMIX,1,IJJ2(1,IL,JGR))
      CALL LCMPUT(IPMAC2,'SIGW'//CM,NMIX,2,SCAT2(1,IL,JGR,JGR))
*
      RETURN
      END
