*DECK CREXSI
      SUBROUTINE CREXSI (NENTRY,HENTRY,IENTRY,JENTRY,KENTRY,IND,NMIXT,
     1 NGRP,NL,IMPX,NBMIX,JND,TOTAL,ZNUG,SNUGF,CHI,OVERV,DIFFX,DIFFY,
     2 DIFFZ,H,IJJ,NJJ,SCAT,WORK,IPOS,VOLMER,FLUX,ENER)
*
*-----------------------------------------------------------------------
*
* RECOVER AND/OR INTERPOLATE COMPO INFORMATION AND STORE THEM IN A NEW
* OR EXISTING MACROLIB.
*
* INPUT PARAMETERS:
*  NENTRY : NUMBER OF LINKED LISTS OR FILES USED BY THE MODULE.
*  HENTRY : CHARACTER*12 NAME OF EACH LINKED LIST OR FILE.
*  IENTRY : =1 LINKED LIST; =2 XSM FILE; =3 SEQUENTIAL BINARY FILE;
*           =4 SEQUENTIAL ASCII FILE.
*  JENTRY : =0 THE LINKED LIST OR FILE IS CREATED.
*           =1 THE LINKED LIST OR FILE IS OPEN FOR MODIFICATIONS;
*           =2 THE LINKED LIST OR FILE IS OPEN IN READ-ONLY MODE.
*  KENTRY : =FILE UNIT NUMBER; =LINKED LIST ADDRESS OTHERWISE.
*           DIMENSION HENTRY(NENTRY),IENTRY(NENTRY),JENTRY(NENTRY),
*           KENTRY(NENTRY)
*  IND    : =1 CROSS SECTIONS ARE INITIALIZED; =2 ... ARE UPDATED.
*  NMIXT  : MAXIMUM NUMBER OF MATERIAL MIXTURES.
*  NGRP   : NUMBER OF ENERGY GROUPS.
*  NL     : NUMBER OF LEGENDRE ORDERS (=1 FOR ISOTROPIC SCATTERING).
*  IMPX   : PRINT PARAMETER. EQUAL TO ZERO FOR NO PRINT.
*
* OUTPUT PARAMETERS:
*  NBMIX  : MAXIMUM MATERIAL MIXTURE INDEX READ.
*  JND    : =1 ';' ENCOUNTERED; =2 'STEP' ENCOUNTERED.
*
* SCRATCH STORAGE:
*  TOTAL  : DIMENSION TOTAL(NMIXT,NGRP)
*  ZNUG   : DIMENSION ZNUG(NMIXT,NGRP)
*  SNUGF   : DIMENSION SNUGF(NMIXT,NGRP)
*  CHI    : DIMENSION CHI(NMIXT,NGRP)
*  OVERV  : DIMENSION OVERV(NMIXT,NGRP)
*  DIFFX  : DIMENSION DIFFX(NMIXT,NGRP)
*  DIFFY  : DIMENSION DIFFY(NMIXT,NGRP)
*  DIFFZ  : DIMENSION DIFFZ(NMIXT,NGRP)
*  H      : DIMENSION H(NMIXT,NGRP)
*  IJJ    : DIMENSION IJJ(NMIXT,NL,NGRP)
*  NJJ    : DIMENSION NJJ(NMIXT,NL,NGRP)
*  SCAT   : DIMENSION SCAT(NMIXT,NL,NGRP,NGRP)
*  WORK   : DIMENSION WORK(NMIXT*NGRP)
*  IPOS   : DIMENSION IPOS(NMIXT)
*  VOLMER : DIMENSION VOLMER(NMIXT)
*  FLUX   : DIMENSION FLUX(NMIXT,NGRP)
*  ENER   : DIMENSION ENER(NGRP+1)
*
* NOTE: ANY CROSS SECTION NOT READ IS SET TO ZERO.
*
*-------------------------------------- AUTHOR: A. HEBERT ; 16/02/94 ---
*-------------------------- MODIFIED : E. VARIN ; 08/09/95 ---
*
      CHARACTER HENTRY(*)*12,CGRPNM*12,CM*2,TEXT8*8,TEXT12*12,TEXT4*4,
     1 HCOMPO*12,HSMG*131,HSIGN*12
      DOUBLE PRECISION DFLOTT
      INTEGER IPRES,KFUEL,NCH,NK,NZC,RDATA(6),KCHAR(3)
      LOGICAL DERIV,UPS,TABLE
      DIMENSION IENTRY(*),JENTRY(*),KENTRY(*),IPAR(4),TOTAL(NMIXT,*),
     1 ZNUG(NMIXT,*),SNUGF(NMIXT,*),CHI(NMIXT,*),OVERV(NMIXT,*),
     2 DIFFX(NMIXT,*),DIFFY(NMIXT,*),DIFFZ(NMIXT,*),IJJ(NMIXT,NL,*),
     3 NJJ(NMIXT,NL,*),SCAT(NMIXT,NL,NGRP,*),H(NMIXT,*),WORK(*),
     4 IPOS(*),VOLMER(*),FLUX(NMIXT,*),ENER(*),IBASE(1)
      COMMON BASE(1)
      EQUIVALENCE(BASE(1),IBASE(1))
*
      IF(NMIXT.EQ.0) CALL XABORT('CREXSI: ZERO NUMBER OF MIXTURES.')
      IF(NGRP.EQ.0) CALL XABORT('CREXSI: ZERO NUMBER OF GROUPS.')
      IPLIST=KENTRY(1)
      IF((IMPX.GT.1).AND.(IND.EQ.2)) CALL LCMLIB(IPLIST)
*
* RECOVER OBJECTS FOR EVOLUTION CONTROL
*
      IPRES = 0
      DO 5 I=2,NENTRY
        IF((IENTRY(I).EQ.1).OR.(IENTRY(I).EQ.2)) THEN
         CALL LCMSIX(KENTRY(I),' ',0)
         CALL LCMGET(KENTRY(I),'SIGNATURE',KCHAR)
         WRITE(HSIGN,'(3A4)') (KCHAR(I1),I1=1,3)
         IF(JENTRY(I).NE.2) CALL XABORT('CRE: READ-ONL'
     +     //'Y MODE EXPECTED FOR OBJECT'//HSIGN//'.')
         IF (HSIGN.EQ.'L_MAP') THEN
           IF (IPRES.EQ.0) IPRES=KENTRY(I)
         ENDIF
        ENDIF
   5  CONTINUE
*
      NBMIX=0
      DO 10 IGR=1,NGRP
      DO 10 IBM=1,NMIXT
      TOTAL(IBM,IGR)=0.0
      ZNUG(IBM,IGR)=0.0
      SNUGF(IBM,IGR)=0.0
      DIFFX(IBM,IGR)=0.0
      DIFFY(IBM,IGR)=0.0
      DIFFZ(IBM,IGR)=0.0
      CHI(IBM,IGR)=0.0
      OVERV(IBM,IGR)=0.0
      H(IBM,IGR)=0.0
      FLUX(IBM,IGR)=0.0
      DO 10 IL=1,NL
      IJJ(IBM,IL,IGR)=IGR
      NJJ(IBM,IL,IGR)=1
      DO 10 JGR=1,NGRP
   10 SCAT(IBM,IL,JGR,IGR)=0.0
      DO 15 IBM=1,NMIXT
   15 VOLMER(IBM)=0.0
      IF(IND.EQ.2) THEN
*        RECOVER THE EXISTING MACROLIB DATA.
         CALL LCMLEN(IPLIST,'VOLUME',ILENGT,ITYLCM)
         IF(ILENGT.EQ.NMIXT) CALL LCMGET(IPLIST,'VOLUME',VOLMER)
         DO 40 JGR=1,NGRP
         WRITE (CGRPNM,'(5HGROUP,I3,1H/,I3)') JGR,NGRP
         CALL LCMSIX(IPLIST,CGRPNM,1)
         CALL LCMLEN(IPLIST,'TOTAL',ILENGT,ITYLCM)
         IF(ILENGT.EQ.NMIXT) THEN
            CALL LCMGET(IPLIST,'TOTAL',TOTAL(1,JGR))
         ELSE IF(ILENGT.NE.0) THEN
            CALL XABORT('CREXSI: INVALID INPUT MACROLIB(1).')
         ENDIF
         CALL LCMLEN(IPLIST,'NUSIGF',ILENGT,ITYLCM)
         IF(ILENGT.EQ.NMIXT) CALL LCMGET(IPLIST,'NUSIGF',ZNUG(1,JGR))
         CALL LCMLEN(IPLIST,'NFTOT',ILENGT,ITYLCM)
         IF(ILENGT.EQ.NMIXT) CALL LCMGET(IPLIST,'NFTOT',SNUGF(1,JGR))
         CALL LCMLEN(IPLIST,'CHI',ILENGT,ITYLCM)
         IF(ILENGT.EQ.NMIXT) CALL LCMGET(IPLIST,'CHI',CHI(1,JGR))
         CALL LCMLEN(IPLIST,'OVERV',ILENGT,ITYLCM)
         IF(ILENGT.EQ.NMIXT) CALL LCMGET(IPLIST,'OVERV',OVERV(1,JGR))
         CALL LCMLEN(IPLIST,'DIFFX',ILENGT,ITYLCM)
         IF(ILENGT.EQ.NMIXT) THEN
            CALL LCMGET(IPLIST,'DIFFX',DIFFX(1,JGR))
            CALL LCMLEN(IPLIST,'DIFFY',ILENGT,ITYLCM)
            IF(ILENGT.EQ.NMIXT) THEN
               CALL LCMGET(IPLIST,'DIFFY',DIFFY(1,JGR))
            ELSE
               CALL LCMGET(IPLIST,'DIFFX',DIFFY(1,JGR))
            ENDIF
            CALL LCMLEN(IPLIST,'DIFFZ',ILENGT,ITYLCM)
            IF(ILENGT.EQ.NMIXT) THEN
               CALL LCMGET(IPLIST,'DIFFZ',DIFFZ(1,JGR))
            ELSE
               CALL LCMGET(IPLIST,'DIFFX',DIFFZ(1,JGR))
            ENDIF
         ENDIF
         CALL LCMLEN(IPLIST,'H-FACTORS',ILENGT,ITYLCM)
         IF(ILENGT.EQ.NMIXT) CALL LCMGET(IPLIST,'H-FACTORS',H(1,JGR))
         CALL LCMLEN(IPLIST,'FLUX-INTG',ILENGT,ITYLCM)
         IF(ILENGT.EQ.NMIXT) CALL LCMGET(IPLIST,'FLUX-INTG',FLUX(1,JGR))
         DO 30 IL=1,NL
         WRITE (CM,'(I2)') IL-1
         CALL LCMLEN(IPLIST,'SCAT'//CM,ILENGT,ITYLCM)
         IF(ILENGT.GT.NMIXT*NL*NGRP*NGRP) THEN
            CALL XABORT('CREXSI: INVALID INPUT MACROLIB(2).')
         ELSE IF(ILENGT.GT.0) THEN
            CALL LCMGET(IPLIST,'SCAT'//CM,WORK)
            CALL LCMGET(IPLIST,'NJJ'//CM,NJJ(1,IL,JGR))
            CALL LCMGET(IPLIST,'IJJ'//CM,IJJ(1,IL,JGR))
            IPOSDE=0
            DO 20 IBM=1,NMIXT
            IJJ0=IJJ(IBM,IL,JGR)
            DO 20 IGR=IJJ0,IJJ0-NJJ(IBM,IL,JGR)+1,-1
            IPOSDE=IPOSDE+1
   20       SCAT(IBM,IL,IGR,JGR)=WORK(IPOSDE)
         ENDIF
   30    CONTINUE
         CALL LCMSIX(IPLIST,' ',2)
   40    CONTINUE
      ENDIF
*
      JPLIST=0
      IBM=0
      TABLE=.FALSE.
      DERIV=.FALSE.
      UPS = .FALSE.
   50 CALL REDGET(INDIC,NITMA,FLOTT,TEXT8,DFLOTT)
      IF(INDIC.NE.3) CALL XABORT('CREXSI: CHARACTER DATA EXPECTED.')
   55 IF(TEXT8.EQ.'COMPO') THEN
         CALL REDGET(INDIC,NITMA,FLOTT,TEXT12,DFLOTT)
         IF(INDIC.NE.3) CALL XABORT('CREXSI: CHARACTER DATA EXPECTED.')
         JPLIST=0
         IBM=0
         DO 60 I=2,NENTRY
         IF(TEXT12.EQ.HENTRY(I)) THEN
            CALL LCMGET(KENTRY(I),'SIGNATURE',KCHAR)
            WRITE(HSIGN,'(3A4)') (KCHAR(I1),I1=1,3)
            IF(HSIGN.NE.'L_COMPO') THEN
             CALL XABORT('CREXSI: SIGNATURE OF '//TEXT12//' IS '
     1       //HSIGN//'. L_COMPO EXPECTED.')
            ENDIF
            IF((IENTRY(I).NE.1).AND.(IENTRY(I).NE.2)) CALL XABORT('CREX'
     1      //'SI: COMPO LINKED LIST OR XSM FILE EXPECTED AT RHS.')
            IF(JENTRY(I).NE.2) CALL XABORT('CREXSI: COMPO IN READ-ONLY '
     1      //'MODE EXPECTED AT RHS.')
            HCOMPO=HENTRY(I)
            JPLIST=KENTRY(I)
            IF(IMPX.GT.1) CALL LCMLIB(JPLIST)
            TABLE = .FALSE.
            GO TO 50
         ENDIF
   60    CONTINUE
         WRITE(HSMG,'(44HCREXSI: UNABLE TO FIND THE COMPO WITH NAME '',
     1   A12,2H''.)') TEXT12
         CALL XABORT(HSMG)
      ELSE IF(TEXT8.EQ.'TABLE') THEN
         IF(JPLIST.NE.0) CALL XABORT('CREXSI: INVALID KEYWORD TABLE')
         CALL REDGET(INDIC,NITMA,FLOTT,TEXT12,DFLOTT)
         IF(INDIC.NE.3) CALL XABORT('CREXSI: CHARACTER DATA EXPECTED.')
         JPLIST=0
         IBM=0
         DO 61 I=2,NENTRY
         IF(TEXT12.EQ.HENTRY(I)) THEN
            CALL LCMGET(KENTRY(I),'SIGNATURE',KCHAR)
            WRITE(HSIGN,'(3A4)') (KCHAR(I1),I1=1,3)
            IF(HSIGN.NE.'L_TABLE') THEN
             CALL XABORT('CREXSI: SIGNATURE OF '//TEXT12//' IS '
     1       //HSIGN//'. L_TABLE EXPECTED.')
            ENDIF
            IF((IENTRY(I).NE.1).AND.(IENTRY(I).NE.2)) CALL XABORT('CREX'
     1      //'SI: TABLE LINKED LIST OR XSM FILE EXPECTED AT RHS.')
            IF(JENTRY(I).NE.2) CALL XABORT('CREXSI: TABLE IN READ-ONLY '
     1      //'MODE EXPECTED AT RHS.')
            HCOMPO=HENTRY(I)
            JPLIST=KENTRY(I)
            IF(IMPX.GT.1) CALL LCMLIB(JPLIST)
            TABLE = .TRUE.
            GO TO 50
         ENDIF
   61    CONTINUE
         WRITE(HSMG,'(44HCREXSI: UNABLE TO FIND THE TABLE WITH NAME '',
     1   A12,2H''.)') TEXT12
         CALL XABORT(HSMG)
      ELSE IF(TEXT8.EQ.'MIX') THEN
         IF(JPLIST.EQ.0) CALL XABORT('CREXSI: COMPO FILE NOT YET DEFIN'
     1   //'ED.')
         CALL REDGET(INDIC,IBM,FLOTT,TEXT4,DFLOTT)
         IF(INDIC.NE.1) CALL XABORT('CREXSI: INTEGER DATA EXPECTED.')
         NBMIX=MAX(NBMIX,IBM)
         IF(IBM.GT.NMIXT) CALL XABORT('CREXSI: INVALID MIX INDEX.')
         CALL REDGET(INDIC,NITMA,FLOTT,TEXT12,DFLOTT)
         IF(INDIC.NE.3) CALL XABORT('CREXSI: CHARACTER DATA EXPECTED.')
         IF(IMPX.GT.0) WRITE(6,'(/27H CREXSI: ACCESS DIRECTORY '',A12,
     1   17H'' IN COMPO FILE '',A12,2H''.)') TEXT12,HCOMPO
         CALL LCMSIX(JPLIST,TEXT12,1)
         IF((IMPX.GT.1).AND.(.NOT.TABLE)) THEN
            CALL LCMLIB(JPLIST)
            CALL LCMLEN(JPLIST,'TITLE',LENGT,ITYXSM)
            CALL SETARA(BASE,LENGT,ITITLE)
            CALL LCMGET(JPLIST,'TITLE',BASE(ITITLE))
            WRITE(6,'(/33H CREXSI: MIXTURE DIRECTORY TITLE:)')
            I2=0
            DO 65 J=0,LENGT/20
            I1=I2+1
            I2=MIN(I1+19,LENGT)
            WRITE(HSMG,'(20A4)') (BASE(ITITLE+I-1),I=I1,I2)
            WRITE(6,'(1X,A80)') HSMG
   65       CONTINUE
            CALL RLSARA(BASE(ITITLE))
         ENDIF
         IF (TABLE) THEN
          CALL LCMGET(JPLIST,'IDIM',IPAR)
         ELSE
          CALL LCMGET(JPLIST,'PARAM',IPAR)
         ENDIF
         IF(IPAR(1).NE.NGRP) THEN
            WRITE(HSMG,'(43HCREXSI: INCONSISTENT NB OF GROUPS. IN MACRO,
     1      5HLIB =,I5,11H IN COMPO =,I5)') NGRP,IPAR(1)
            CALL XABORT(HSMG)
         ELSE IF(IPAR(3).LT.NL) THEN
          WRITE(HSMG,'(43HCREXSI: INCONSISTENT NB OF LEGENDRE ORDERS.,
     1      14H IN MACROLIB =,I5,11H IN COMPO =,I5)') NL,IPAR(3)
            CALL XABORT(HSMG)
         ENDIF
         IF (TABLE) THEN
          NTYP = IPAR(4)
          NBURN = IPAR(2)
         ELSE
          NISO=IPAR(2)
          NBURN=IPAR(4)
          CALL SETARA(IBASE,3*NISO,IHISO)
          CALL SETARA(IBASE,NISO,IITY)
          CALL SETARA(BASE,NISO,ICONC)
          CALL LCMGET(JPLIST,'ISOTOPESNAME',IBASE(IHISO))
          IBASE(IITY)=2
          DO 70 I=2,NISO
   70     IBASE(IITY+I-1)=0
         ENDIF
         IF(IPRES.EQ.0)
     1     CALL LCMGET(JPLIST,'VOLUME',VOLMER(IBM))
         CALL LCMGET(JPLIST,'ENERGY',ENER)
         KBURN=0
         KFUEL=0
         IF(NBURN.GT.1) THEN
            CALL REDGET(INDIC,NITMA,FLOTT,TEXT12,DFLOTT)
            IF(INDIC.NE.3) CALL XABORT('CREXSI: CHARACTER DATA EXPECTE'
     1      //'D.')
            IF(TEXT12.EQ.'BURNUP') THEN
               KBURN=1
               CALL REDGET(INDIC,NITMA,BURN0,TEXT4,DFLOTT)
               IF(INDIC.NE.2) CALL XABORT('CREXSI: REAL DATA EXPECTED.')
               BURN1=BURN0
            ELSE IF(TEXT12.EQ.'N/KB') THEN
               KBURN=2
               CALL REDGET(INDIC,NITMA,BURN0,TEXT4,DFLOTT)
               IF(INDIC.NE.2) CALL XABORT('CREXSI: REAL DATA EXPECTED.')
               BURN1=BURN0
            ELSE IF(TEXT12.EQ.'T-BURNUP') THEN
               IF( TABLE )CALL XABORT('CREXSI: INVALID OPTION T-BURNUP'
     +             //' WITH TABLE INTERPOLATION')
               KBURN=1
               CALL REDGET(INDIC,NITMA,BURN0,TEXT4,DFLOTT)
               IF(INDIC.NE.2) CALL XABORT('CREXSI: REAL DATA EXPECTED.')
               CALL REDGET(INDIC,NITMA,BURN1,TEXT4,DFLOTT)
               IF(INDIC.NE.2) CALL XABORT('CREXSI: REAL DATA EXPECTED.')
               IF(BURN1.LE.BURN0) CALL XABORT('CREXSI: INVALID BURN1.')
            ELSE IF(TEXT12.EQ.'T-N/KB') THEN
               IF( TABLE )CALL XABORT('CREXSI: INVALID OPTION T-BURNUP'
     +             //' WITH TABLE INTERPOLATION')
               KBURN=2
               CALL REDGET(INDIC,NITMA,BURN0,TEXT4,DFLOTT)
               IF(INDIC.NE.2) CALL XABORT('CREXSI: REAL DATA EXPECTED.')
               CALL REDGET(INDIC,NITMA,BURN1,TEXT4,DFLOTT)
               IF(INDIC.NE.2) CALL XABORT('CREXSI: REAL DATA EXPECTED.')
               IF(BURN1.LE.BURN0) CALL XABORT('CREXSI: INVALID BURN1.')
            ELSE
               CALL XABORT('CREXSI: (T-)BURNUP OR (T-)N/KB '
     1           //' KEYWORD EXPECTED.')
            ENDIF
            IF(TABLE) THEN
             IF (KBURN.NE.0) THEN
               CALL REDGET(INDIC,NITMA,FLOTT,TEXT12,DFLOTT)
             IF(INDIC.NE.3) CALL XABORT('CREXSI: CHARACTER DATA EXPECTE'
     1       //'D.')
             ENDIF
             IF(TEXT12.EQ.'HOMG') THEN
               IF(KBURN.EQ.0) KBURN=1
               IF(IPRES.EQ.0)
     1       CALL XABORT('CREXSI: OBJECT MISSING FOR OPTION.'//TEXT12)
               KFUEL=1
             ELSE IF(TEXT12.EQ.'TAVG') THEN
               IF(KBURN.EQ.0) KBURN=1
               IF(IPRES.EQ.0)
     1       CALL XABORT('CREXSI: OBJECT MISSING FOR OPTION.'//TEXT12)
               KFUEL=2
             ELSE IF(TEXT12.EQ.'TAVGC') THEN
               IF(KBURN.EQ.0) KBURN=1
               IF(IPRES.EQ.0)
     1       CALL XABORT('CREXSI: OBJECT MISSING FOR OPTION.'//TEXT12)
               KFUEL=3
             ELSE IF(TEXT12.EQ.'DIRECTC') THEN
               IF(KBURN.EQ.0) KBURN=1
               IF(IPRES.EQ.0)
     1       CALL XABORT('CREXSI: OBJECT MISSING FOR OPTION.'//TEXT12)
               KFUEL=4
             ELSE IF(TEXT12.EQ.'DIRECT') THEN
               IF(KBURN.EQ.0) KBURN=1
               IF(IPRES.EQ.0)
     1       CALL XABORT('CREXSI: OBJECT MISSING FOR OPTION.'//TEXT12)
               KFUEL=5
             ELSE
               CALL XABORT('CREXSI: EVOLUTION'
     1           //' KEYWORD EXPECTED.')
             ENDIF
            ENDIF
         ENDIF
         IF((NISO.GT.1).AND.(.NOT.TABLE)) THEN
            CALL REDGET(INDIC,NITMA,FLOTT,TEXT12,DFLOTT)
            IF(INDIC.NE.3) CALL XABORT('CREXSI: CHARACTER DATA EXPECTE'
     1      //'D.')
            IF(TEXT12.EQ.'MICRO') THEN
   80          CALL REDGET(INDIC,NITMA,FLOTT,TEXT12,DFLOTT)
               IF(INDIC.NE.3) CALL XABORT('CREXSI: CHARACTER DATA EXPE'
     1         //'CTED.')
               IF(TEXT12.EQ.'ALL') THEN
                  DO 90 I=2,NISO
   90             IBASE(IITY+I-1)=2
               ELSEIF(TEXT12.EQ.'ENDMIX') THEN
                  TEXT8 = TEXT12
                  GO TO 55
               ELSEIF(TEXT12.EQ.'UPS') THEN
                  TEXT8 = TEXT12
                  GO TO 55
               ELSE
                  DO 100 I=1,NISO
                  WRITE(CGRPNM,'(3A4)') (IBASE(IHISO+3*(I-1)+J),J=0,2)
                  IF(CGRPNM.EQ.TEXT12) THEN
                     CALL REDGET(INDIC,NITMA,FLOTT,TEXT4,DFLOTT)
                     IF(INDIC.EQ.2) THEN
                        BASE(ICONC+I-1)=FLOTT
                        IBASE(IITY+I-1)=1
                     ELSE IF((INDIC.EQ.3).AND.(TEXT4.EQ.'*')) THEN
                        IBASE(IITY+I-1)=2
                     ELSE
                        CALL XABORT('CREXSI: REAL NUMBER OR * EXPECTED')
                     ENDIF
                     GO TO 80
                  ENDIF
  100             CONTINUE
                  CALL XABORT('CREXSI: UNABLE TO MATCH '//TEXT12//'.')
               ENDIF
            ELSEIF(TEXT12.EQ.'ENDMIX') THEN
               TEXT8 = TEXT12
               GO TO 55
            ELSEIF(TEXT12.EQ.'UPS') THEN
               TEXT8 = TEXT12
               GO TO 55
            ENDIF
         ENDIF
      ELSE IF(TEXT8.EQ.'UPS') THEN
* EV /08/08/95  ENLEVER LES UPSCATERING
           UPS = .TRUE.
      ELSE IF(TEXT8.EQ.'ENDMIX') THEN
        IF(IBM.EQ.0) CALL XABORT('CREXSI: MIX NOT YET DEFINED.')
        IF(IPRES.EQ.0) THEN
         IF (TABLE) CALL XABORT('CREXSI: SOMETHING WENT WRONG.')
         CALL SETARA(BASE,NGRP,ITOTAL)
         CALL SETARA(BASE,NGRP,IZNUG)
         CALL SETARA(BASE,NGRP,INUGF)
         CALL SETARA(BASE,NGRP,ICHI)
         CALL SETARA(BASE,NGRP,IOVERV)
         CALL SETARA(BASE,NGRP,IDIFFX)
         CALL SETARA(BASE,NGRP,IDIFFY)
         CALL SETARA(BASE,NGRP,IDIFFZ)
         CALL SETARA(BASE,NGRP,IH)
         CALL SETARA(BASE,NL*NGRP*NGRP,ISCAT)
         CALL SETARA(BASE,NGRP,IFLUX)
         CALL SETARA(BASE,NBURN,IBURNU)
         CALL SETARA(BASE,NISO,IDENSI)
         CALL CREINT(JPLIST,NISO,DERIV,NBURN,KBURN,BURN0,BURN1,NGRP,NL,
     1   IMPX,IBASE(IHISO),IBASE(IITY),BASE(ICONC),BASE(ITOTAL),
     2   BASE(IZNUG),BASE(INUGF),BASE(ICHI),BASE(IOVERV),BASE(IDIFFX),
     3   BASE(IDIFFY),BASE(IDIFFZ),BASE(IH),BASE(ISCAT),BASE(IFLUX),
     4   BASE(IBURNU),BASE(IDENSI),UPS)
         CALL RLSARA(BASE(IDENSI))
         CALL RLSARA(BASE(IBURNU))
         DO 110 JGR=1,NGRP
         TOTAL(IBM,JGR)=BASE(ITOTAL+JGR-1)
         ZNUG(IBM,JGR)=BASE(IZNUG+JGR-1)
         SNUGF(IBM,JGR)=BASE(INUGF+JGR-1)
         CHI(IBM,JGR)=BASE(ICHI+JGR-1)
         OVERV(IBM,JGR)=BASE(IOVERV+JGR-1)
         DIFFX(IBM,JGR)=BASE(IDIFFX+JGR-1)
         DIFFY(IBM,JGR)=BASE(IDIFFY+JGR-1)
         DIFFZ(IBM,JGR)=BASE(IDIFFZ+JGR-1)
         H(IBM,JGR)=BASE(IH+JGR-1)
         FLUX(IBM,JGR)=BASE(IFLUX+JGR-1)
         DO 110 IGR=1,NGRP
         DO 110 IL=1,NL
  110    SCAT(IBM,IL,IGR,JGR)=BASE(ISCAT+NL*((JGR-1)*NGRP+IGR-1)+IL-1)
         CALL RLSARA(BASE(IFLUX))
         CALL RLSARA(BASE(ISCAT))
         CALL RLSARA(BASE(IH))
         CALL RLSARA(BASE(IDIFFZ))
         CALL RLSARA(BASE(IDIFFY))
         CALL RLSARA(BASE(IDIFFX))
         CALL RLSARA(BASE(IOVERV))
         CALL RLSARA(BASE(ICHI))
         CALL RLSARA(BASE(INUGF))
         CALL RLSARA(BASE(IZNUG))
         CALL RLSARA(BASE(ITOTAL))
         CALL RLSARA(BASE(ICONC))
         CALL RLSARA(IBASE(IITY))
         CALL RLSARA(IBASE(IHISO))
*        JGR IS THE SECONDARY GROUP.
         DO 130 JGR=1,NGRP
         DO 130 IL=1,NL
         IGMIN=JGR
         IGMAX=JGR
         DO 120 IGR=NGRP,1,-1
         IF (SCAT(IBM,IL,IGR,JGR).NE.0.0) THEN
            IGMIN=MIN(IGMIN,IGR)
            IGMAX=MAX(IGMAX,IGR)
         ENDIF
  120    CONTINUE
         IJJ(IBM,IL,JGR)=IGMAX
  130    NJJ(IBM,IL,JGR)=IGMAX-IGMIN+1
        ELSE
*
         IF (.NOT.TABLE)
     1     CALL XABORT('CREXSI: SOMETHING WENT WRONG (2).')
         CALL SETARA(BASE,NBURN,IBURNU)
         CALL LCMGET(IPRES,'RES-DATA',RDATA)
         IF( RDATA(4).NE.0 )THEN
           IF( RDATA(4).NE.NGRP )CALL XABORT('CREXSI: WRONG NUMBER OF'
     1     //' ENERGY GROUPS BETWEEN TABLE AND FUEL MAP')
         ENDIF
         IMOD = RDATA(5)
         IF (KFUEL.NE.0) THEN
          IF(IMOD.NE.KFUEL) CALL XABORT('CREXSI: INVALID EVOLUTION '
     1     //'OPTION')
         ENDIF
         NK = RDATA(1)
         NCH = RDATA(2)
         NZC = RDATA(3)
         CALL SETARA(IBASE,NCH*NK,IINDX)
         CALL SETARA(IBASE,NCH,IZONEB)
         CALL SETARA(BASE,NZC,IBZC)
         IF(KFUEL.LE.1) THEN
            NW = 1
         ELSEIF((KFUEL.EQ.3).OR.(KFUEL.EQ.4)) THEN
            NW = NCH*NK
         ELSE
            NW = NZC*NK
         ENDIF
         CALL SETARA(BASE,2*NW,IWINT)
         CALL SETARA(BASE,2*NGRP*NBURN,ITOTAL)
         CALL SETARA(BASE,2*NGRP*NBURN,IZNUG)
         CALL SETARA(BASE,2*NGRP*NBURN,INUGF)
         CALL SETARA(BASE,2*NGRP*NBURN,ICHI)
         CALL SETARA(BASE,2*NGRP*NBURN,IOVERV)
         CALL SETARA(BASE,2*NGRP*NBURN,IDIFFX)
         CALL SETARA(BASE,2*NGRP*NBURN,IDIFFY)
         CALL SETARA(BASE,2*NGRP*NBURN,IDIFFZ)
         CALL SETARA(BASE,2*NGRP*NBURN,IH)
         CALL SETARA(BASE,2*NL*NGRP*NGRP*NBURN,ISCAT)
         CALL SETARA(BASE,2*NGRP*NBURN,IFLUX)
         CALL CRERGR(IPRES,JPLIST,DERIV,KFUEL,IBM,
     1   NMIXT,NBURN,KBURN,BURN0,BURN1,NGRP,NL,IMPX,
     2   TOTAL,ZNUG,SNUGF,CHI,OVERV,DIFFX,DIFFY,
     3   DIFFZ,H,SCAT,IJJ,NJJ,FLUX,BASE(ITOTAL),
     4   BASE(IZNUG),BASE(INUGF),BASE(ICHI),BASE(IOVERV),BASE(IDIFFX),
     5   BASE(IDIFFY),BASE(IDIFFZ),BASE(IH),BASE(ISCAT),BASE(IFLUX),
     6   BASE(IBURNU),IBASE(IINDX),BASE(IBZC),IBASE(IZONEB),
     7   BASE(IWINT),VOLMER,NW,NCH,NK,NZC)
         CALL RLSARA(BASE(IFLUX))
         CALL RLSARA(BASE(ISCAT))
         CALL RLSARA(BASE(IH))
         CALL RLSARA(BASE(IDIFFZ))
         CALL RLSARA(BASE(IDIFFY))
         CALL RLSARA(BASE(IDIFFX))
         CALL RLSARA(BASE(IOVERV))
         CALL RLSARA(BASE(ICHI))
         CALL RLSARA(BASE(IZNUG))
         CALL RLSARA(BASE(INUGF))
         CALL RLSARA(BASE(ITOTAL))
         CALL RLSARA(BASE(IBURNU))
         CALL RLSARA(IBASE(IINDX))
         CALL RLSARA(BASE(IBZC))
         CALL RLSARA(IBASE(IZONEB))
         CALL RLSARA(BASE(IWINT))
        ENDIF
        IBM=0
        CALL LCMSIX(JPLIST,' ',2)
      ELSE IF(TEXT8.EQ.'DERIV') THEN
         DERIV=.TRUE.
      ELSE IF(TEXT8.EQ.';') THEN
         IF(IBM.NE.0) CALL XABORT('CREXSI: NO ENDMIX ENCOUNTERED.')
         JND=1
         GO TO 160
      ELSE IF(TEXT8.EQ.'STEP') THEN
         IF(IBM.NE.0) CALL XABORT('CREXSI: NO ENDMIX ENCOUNTERED.')
         JND=2
         GO TO 160
      ELSE
         CALL XABORT('CREXSI: '//TEXT8//' IS AN INVALID KEY-WORD.')
      ENDIF
      GO TO 50
*
  160 CALL LCMPUT(IPLIST,'VOLUME',NMIXT,2,VOLMER)
      CALL LCMPUT(IPLIST,'ENERGY',NGRP+1,2,ENER)
      DO 210 JGR=1,NGRP
      WRITE (CGRPNM,'(5HGROUP,I3,1H/,I3)') JGR,NGRP
      CALL LCMSIX(IPLIST,CGRPNM,1)
      CALL LCMPUT(IPLIST,'TOTAL',NMIXT,2,TOTAL(1,JGR))
      CALL LCMPUT(IPLIST,'NUSIGF',NMIXT,2,ZNUG(1,JGR))
      CALL LCMPUT(IPLIST,'NFTOT',NMIXT,2,SNUGF(1,JGR))
      CALL LCMPUT(IPLIST,'CHI',NMIXT,2,CHI(1,JGR))
      CALL LCMPUT(IPLIST,'OVERV',NMIXT,2,OVERV(1,JGR))
      CALL LCMPUT(IPLIST,'DIFFX',NMIXT,2,DIFFX(1,JGR))
      CALL LCMPUT(IPLIST,'DIFFY',NMIXT,2,DIFFY(1,JGR))
      CALL LCMPUT(IPLIST,'DIFFZ',NMIXT,2,DIFFZ(1,JGR))
      CALL LCMPUT(IPLIST,'H-FACTORS',NMIXT,2,H(1,JGR))
      CALL LCMPUT(IPLIST,'FLUX-INTG',NMIXT,2,FLUX(1,JGR))
      DO 200 IL=1,NL
      WRITE (CM,'(I2)') IL-1
      IPOSDE=0
      DO 190 IBM=1,NMIXT
      IPOS(IBM)=IPOSDE+1
      DO 190 IGR=IJJ(IBM,IL,JGR),IJJ(IBM,IL,JGR)-NJJ(IBM,IL,JGR)+1,-1
      IPOSDE=IPOSDE+1
  190 WORK(IPOSDE)=SCAT(IBM,IL,IGR,JGR)
      CALL LCMPUT(IPLIST,'SCAT'//CM,IPOSDE,2,WORK)
      CALL LCMPUT(IPLIST,'IPOS'//CM,NMIXT,1,IPOS)
      CALL LCMPUT(IPLIST,'NJJ'//CM,NMIXT,1,NJJ(1,IL,JGR))
      CALL LCMPUT(IPLIST,'IJJ'//CM,NMIXT,1,IJJ(1,IL,JGR))
      CALL LCMPUT(IPLIST,'SIGW'//CM,NMIXT,2,SCAT(1,IL,JGR,JGR))
  200 CONTINUE
      IF(IMPX.GT.1) CALL LCMLIB(IPLIST)
      CALL LCMSIX(IPLIST,' ',2)
  210 CONTINUE
      IF(IMPX.GT.1) CALL LCMLIB(IPLIST)
      RETURN
      END
