*DECK DEVRES
      SUBROUTINE DEVRES(TOTAL,ZNUSIG,ZSIGF,DIFFX,DIFFY,DIFFZ,
     +           SCAT,MAPG,MAPR,MAPD,VF,XFAC,NGRP,NL,NMIXT,LSIG)
C
C THIS SUBOUTINE CALCULATES THE USEFUL CROSS SECTIONS
C AS MODIFIED BY THE PRESENCE OF RODS OR LZC
C
C INPUTS - NGRP : NUMBER OF GROUPS
C          NL : ORDER OF LEGENDRE EXPANSION OF SCATTERING CROSS-SECTIONS
C          NMIXT : NUMBER OF MIX ON L_MACROLIB2
C          MAPG : MIXTURE INDEX FOR PHYSICAL REGION
C          MAPD : MIXTURE INDEX FOR REGION WITH DEVICE
C          MAPR : MIXTURE INDEX FOR REGION WITHOUT DEVICE
C          XFAC : FACTEUR DE CORRECTION DES DELTA SIGMA
C          LSIG : ADDITION OF FISSION INCREMENTS IN NON_FISSILE REGION
C          TOTAL ... SCAT : UNCORRECTED VALUES FROM L_MACROLIB2
C OUTPUTS
C          TOTAL ... SCAT : NEW VALUES TO PUT BACK IN L_MACROLIB3
*
*-------------------------------------- AUTHOR: J. KOCLAS-94/04/11  ---
*- MODIFIED: E. VARIN-95/04/11
C
*
      IMPLICIT NONE
*
      INTEGER NGRP,NL,NMIXT
*
      REAL TOTAL((NMIXT+1),NGRP),ZNUSIG((NMIXT+1),NGRP),
     +     ZSIGF((NMIXT+1),NGRP)
      REAL DIFFX((NMIXT+1),NGRP),DIFFY((NMIXT+1),NGRP),
     +     DIFFZ((NMIXT+1),NGRP)
      REAL SCAT((NMIXT+1),NL,NGRP,NGRP)
C LOCAL
      INTEGER MAPG,MAPR,MAPD
      INTEGER IG,INL,IG1,IG2
*
*     FACTEUR DE CORRECTION DES SECT. EFFICACES
      REAL XFAC,VF,PREC,DDIFFX,DDIFFY,DDIFFZ
      LOGICAL LSIG
      PARAMETER ( PREC= 1.E-4 )
*
C TOTAL,NUSF,DIFFX,DIFFY,DIFFZ
      DO 145 IG=1,NGRP
        TOTAL(MAPG,IG)=TOTAL(MAPG,IG)+
     +    VF*(TOTAL(MAPR,IG)-TOTAL(MAPD,IG))*XFAC
        IF(LSIG.OR.ZNUSIG(MAPG,IG).NE.0.0) THEN
          ZNUSIG(MAPG,IG)=ZNUSIG(MAPG,IG)+
     +      VF*(ZNUSIG(MAPR,IG)-ZNUSIG(MAPD,IG))*XFAC
        ENDIF
*
        IF(LSIG.OR.ZSIGF(MAPG,IG).NE.0.0) THEN
          ZSIGF(MAPG,IG)=ZSIGF(MAPG,IG)+
     +      VF*(ZSIGF(MAPR,IG)-ZSIGF(MAPD,IG))*XFAC
        ENDIF
*
        IF((DIFFX(MAPR,IG).LT.PREC).OR.(DIFFX(MAPD,IG).LT.PREC)) THEN
          IF(DIFFX(MAPR,IG).LT.PREC) THEN
            IF(DIFFX(MAPD,IG).GT.PREC) THEN
              DDIFFX = -1./DIFFX(MAPD,IG)
            ELSE
              DDIFFX = 0.0
            ENDIF
          ELSE
            DDIFFX = 1./DIFFX(MAPR,IG)
          ENDIF
        ELSE
          DDIFFX = 1./DIFFX(MAPR,IG)-1./DIFFX(MAPD,IG)
        ENDIF
        DIFFX(MAPG,IG)=1./DIFFX(MAPG,IG)+
     +     VF*DDIFFX*XFAC
        DIFFX(MAPG,IG)=1./DIFFX(MAPG,IG)
*
         IF (DIFFY(MAPG,IG).GT.PREC) THEN
        IF((DIFFY(MAPR,IG).LT.PREC).OR.(DIFFY(MAPD,IG).LT.PREC)) THEN
           IF(DIFFY(MAPR,IG).LT.PREC) THEN
            IF(DIFFY(MAPD,IG).GT.PREC) THEN
              DDIFFY = -1./DIFFY(MAPD,IG)
            ELSE
              DDIFFY = 0.0
            ENDIF
           ELSE
            DDIFFY = 1./DIFFY(MAPR,IG)
           ENDIF
          ELSE
           DDIFFY = 1./DIFFY(MAPR,IG)-1./DIFFY(MAPD,IG)
          ENDIF
          DIFFY(MAPG,IG)=1./DIFFY(MAPG,IG)+
     +       VF*DDIFFY*XFAC
          DIFFY(MAPG,IG)=1./DIFFY(MAPG,IG)
         ENDIF
*
         IF (DIFFZ(MAPG,IG).GT.PREC) THEN
        IF((DIFFZ(MAPR,IG).LT.PREC).OR.(DIFFZ(MAPD,IG).LT.PREC)) THEN
           IF(DIFFZ(MAPR,IG).LT.PREC) THEN
            IF(DIFFZ(MAPD,IG).GT.PREC) THEN
              DDIFFZ = -1./DIFFZ(MAPD,IG)
            ELSE
              DDIFFZ = 0.0
            ENDIF
           ELSE
            DDIFFZ = 1./DIFFZ(MAPR,IG)
           ENDIF
          ELSE
           DDIFFZ = 1./DIFFZ(MAPR,IG)-1./DIFFZ(MAPD,IG)
          ENDIF
           DIFFZ(MAPG,IG)=1./DIFFZ(MAPG,IG)+
     +       VF*DDIFFZ*XFAC
           DIFFZ(MAPG,IG)=1./DIFFZ(MAPG,IG)
         ENDIF
 145  CONTINUE
C SCATTERING
      DO 150 INL=1,NL
       DO 150 IG1=1,NGRP
        DO 150 IG2=1,NGRP
         SCAT(MAPG,INL,IG1,IG2)=SCAT(MAPG,INL,IG1,IG2)+
     +     VF*(SCAT(MAPR,INL,IG1,IG2)-SCAT(MAPD,INL,IG1,IG2))*XFAC
 150  CONTINUE
*
      RETURN
      END
