*DECK DMAC
      SUBROUTINE DMAC(NENTRY,HENTRY,IENTRY,JENTRY,KENTRY)
*
**********************************************************************
*
*     THIS MODULE COMPUTES A NEW MACROLIB AS THE DIFFERENCE OR THE
*     ADDITION OF TWO OTHER ONES.
*     MAC1 - MAC2 OR MAC1 + MAC2 ( THE INPUT ORDER IS IMPORTANT )
*
*     CE MODULE CREE L_MACROLIB4 PAR DIFFERENCE DE 2 MACROLIB.
*     MAC1 - MAC2 OU PAR ADDITION MAC1 + MAC2
*
*     INPUT/OUTPUT PARAMETERS:
*      NENTRY : NUMBER OF LINKED LISTS AND FILES USED BY THE MODULE.
*      HENTRY : CHARACTER*12 NAME OF EACH LINKED LIST OR FILE.
*      IENTRY : =1 LINKED LIST; =2 XSM FILE; =3 SEQUENTIAL BINARY FILE;
*               =4 SEQUENTIAL ASCII FILE; =5 DIRECT ACCESS FILE.
*      JENTRY : =0 THE LINKED LIST OR FILE IS CREATED.
*               =1 THE LINKED LIST OR FILE IS OPEN FOR MODIFICATIONS;
*               =2 THE LINKED LIST OR FILE IS OPEN IN READ-ONLY MODE.
*      KENTRY : FILE UNIT NUMBER OR LINKED LIST ADDRESS.
*
*      DIMENSION HENTRY(NENTRY),IENTRY(NENTRY),JENTRY(NENTRY),
*      KENTRY(NENTRY)
*
*     REQUIRED LINKED LISTS:
*        KENTRY(1)   : OBJECT TYPE L_MACROLIB IN CREATION MODE
*        KENTRY(2-4) : OBJECT TYPE L_MACROLIB IN READ-ONLY MODE
*                                  L_MACROLIB IN READ-ONLY MODE
*
*     PROCEDURES CALLED :  SUBMAC, IQSADD
*
*-------------------------------------- AUTHORS: E. VARIN 95/05/26 ---
*
      IMPLICIT NONE
* DRVDRV VARIABLES
      INTEGER NENTRY
      CHARACTER HENTRY(*)*12
      INTEGER IENTRY,JENTRY,KENTRY
      DIMENSION IENTRY(*),JENTRY(*),KENTRY(*)
* SETARA VARIABLES
      REAL BASE
      INTEGER IBASE(1)
      COMMON BASE(1)
      EQUIVALENCE (BASE(1),IBASE(1))
* REDGET TYPES
      INTEGER ITYP,NITMA
      REAL FLOTT,FACT
      DOUBLE PRECISION DFLOTT
*
* SIGNATURE INFORMATION
*
      CHARACTER*12 SGNTUR,TEXT,LEVEL
      INTEGER      ISGNTR(3)
*
      INTEGER  IPMAC3,IPMAC2,IPMAC1
*
      INTEGER I,IENERG,IPRT
* MAC2
      INTEGER DATXS1(7),DATXS2(7)
* LOCAL VARIABLES
      INTEGER NGRP,NMIXT,NL,NGRP2,NMIXT2,NL2,NDG,NDG2,ILONG,ITYLM
*
      INTEGER ITOTAL,INUSIG,ICHI,IOVERV,IDIFFX,IIJJP,INJJP,ICHIDL
      INTEGER IDIFFY,IDIFFZ,IH,IS,IIJJ,INJJ,ISCAT,IWORK,IIPOS,ISIGF
      LOGICAL DDIF,ADD
*
*
*     INPUT OBJECT CONTROL
*
      IPMAC2 = 0
      IPMAC1 = 0
      IF(NENTRY.LT.3) CALL XABORT('DMAC: PARAMETER EXPECTED.')
      IF((IENTRY(1).NE.1).AND.(IENTRY(1).NE.2)) CALL XABORT('DM'
     + //'AC: LINKED LIST OR XSM FILE EXPECTED AT LHS.')
      IF((IENTRY(2).NE.1).AND.(IENTRY(2).NE.2)) CALL XABORT('DM'
     + //'AC: LINKED LIST OR XSM FILE EXPECTED AT LHS.')
      IF((IENTRY(3).NE.1).AND.(IENTRY(3).NE.2)) CALL XABORT('DM'
     + //'AC: LINKED LIST OR XSM FILE EXPECTED AT LHS.')
      IF(JENTRY(1).NE.0) CALL XABORT('DM'
     + //'AC: CREATE MODE EXPECTED.')
      IF(JENTRY(2).NE.2) CALL XABORT('DM'
     + //'AC: READ-ONLY MODE EXPECTED.')
      IF(JENTRY(2).NE.2) CALL XABORT('DM'
     + //'AC: READ-ONLY MODE EXPECTED.')
*
      IPMAC3=KENTRY(1)
*
      IPMAC1=KENTRY(2)
      IPMAC2=KENTRY(3)
*
      LEVEL= ' '
      FACT = 1.0
      IPRT = 0
      DDIF = .FALSE.
      ADD = .FALSE.
 10   CALL REDGET(ITYP,NITMA,FLOTT,TEXT,DFLOTT)
      IF (ITYP.EQ.10) GOTO 20
      IF (ITYP.NE.3) THEN
        CALL XABORT('DMAC: CHARACTER DATA EXPECTED')
      ELSE IF(TEXT.EQ.'STEP') THEN
        CALL REDGET(ITYP,NITMA,FLOTT,TEXT,DFLOTT)
        IF (ITYP.NE.1) THEN
         CALL XABORT('DMAC: INTEGER DATA EXPECTED')
        ENDIF
        WRITE(LEVEL,'(4HSTEP,I8)') NITMA
      ELSE IF(TEXT.EQ.'EDIT') THEN
        CALL REDGET(ITYP,IPRT,FLOTT,TEXT,DFLOTT)
        IF (ITYP.NE.1) THEN
         CALL XABORT('DMAC: INTEGER DATA EXPECTED')
        ENDIF
      ELSE IF(TEXT.EQ.'SUB') THEN
        ADD = .FALSE.
      ELSE IF(TEXT.EQ.'ADD') THEN
        ADD = .TRUE.
      ELSE IF(TEXT.EQ.'NODIF') THEN
        DDIF = .FALSE.
      ELSE IF(TEXT.EQ.'FRAC') THEN
        CALL REDGET(ITYP,NITMA,FACT,TEXT,DFLOTT)
        IF (ITYP.NE.2) THEN
         CALL XABORT('DMAC: REAL DATA EXPECTED')
        ENDIF
      ELSE IF(TEXT.EQ.'DDIF') THEN
        IF (.NOT.ADD) WRITE(6,*) '*** ATTENTION *** IN USING THIS '
     +   //'OPTION YOU WILL OBTAIN DELTA D = 1/( 1/D1 - 1/D2) ***** '
        DDIF = .TRUE.
      ELSE IF(TEXT.EQ.';') THEN
        GOTO 20
      ELSE
        CALL XABORT('DMAC: INVALID INPUT OPTION')
      ENDIF
      GOTO 10
*
 20   CALL LCMSIX(IPMAC2,' ',0)
      CALL LCMSIX(IPMAC1,' ',0)
*
* NOW COPY MAC1 TO MAC3
* NB : ONLY THE CROSS-SECTIONS NEED TO BE MODIFIED
*
      CALL LCMGET(IPMAC2,'IDATAXS',DATXS2)
      NGRP2=DATXS2(1)
      NMIXT2=DATXS2(2)
      NL2=DATXS2(3)
      NDG2=DATXS2(7)
*
      CALL LCMGET(IPMAC1,'IDATAXS',DATXS1)
      NGRP=DATXS1(1)
      NMIXT=DATXS1(2)
      NL=DATXS1(3)
      NDG=DATXS1(7)
*
      IF (NL.NE.NL2) CALL XABORT('DMAC: ILLEGAL LEGENDRE ORDER')
      IF (NDG.NE.NDG2) CALL XABORT('DMAC: ILLEGAL PRECURSOR GROUP')
      IF (NGRP.NE.NGRP2) CALL XABORT('DMAC: ILLEGAL GROUP NUMBER')
      IF (NMIXT.NE.NMIXT2) CALL XABORT('DMAC: ILLEGAL MIXTURE NUMBER')
*
      CALL SETARA(BASE,NMIXT*NGRP,ITOTAL)
      CALL SETARA(BASE,NMIXT*NGRP,INUSIG)
      CALL SETARA(BASE,NMIXT*NGRP,ISIGF)
      CALL SETARA(BASE,NMIXT*NGRP,ICHI)
      IF(NDG.NE.0) CALL SETARA(BASE,NMIXT*NGRP*NDG,ICHIDL)
      CALL SETARA(BASE,NMIXT*NGRP,IOVERV)
      CALL SETARA(BASE,NMIXT*NGRP,IDIFFX)
      CALL SETARA(BASE,NMIXT*NGRP,IDIFFY)
      CALL SETARA(BASE,NMIXT*NGRP,IDIFFZ)
      CALL SETARA(BASE,NMIXT*NGRP,IH)
      CALL SETARA(BASE,NMIXT*NGRP,IS)
      CALL SETARA(IBASE,NMIXT*NGRP*NL,IIJJ)
      CALL SETARA(IBASE,NMIXT*NGRP*NL,INJJ)
      CALL SETARA(IBASE,NMIXT*NGRP*NL,IIJJP)
      CALL SETARA(IBASE,NMIXT*NGRP*NL,INJJP)
      CALL SETARA(BASE,NMIXT*NL*NGRP*NGRP,ISCAT)
      CALL SETARA(BASE,NMIXT*NGRP,IWORK)
      CALL SETARA(IBASE,NMIXT,IIPOS)
*
      CALL LCMSIX(IPMAC2,' ',0)
      CALL LCMLEN(IPMAC2,LEVEL,ILONG,ITYLM)
      IF(ITYLM.EQ.0) CALL LCMSIX(IPMAC2,LEVEL,1)
      CALL LCMSIX(IPMAC1,' ',0)
      CALL LCMLEN(IPMAC1,LEVEL,ILONG,ITYLM)
      IF(ITYLM.EQ.0) CALL LCMSIX(IPMAC1,LEVEL,1)
      IF( .NOT.ADD )THEN
         CALL SUBMAC(IPMAC1,IPMAC2,IPMAC3,LEVEL,NMIXT,NGRP,NDG,NL,
     X   BASE(ITOTAL),BASE(INUSIG),BASE(ISIGF),BASE(ICHI),BASE(ICHIDL),
     X   BASE(IOVERV),BASE(IDIFFX),BASE(IDIFFY),BASE(IDIFFZ),BASE(IH),
     X   BASE(IS),BASE(IIJJ),BASE(INJJ),BASE(ISCAT),BASE(IWORK),
     X   BASE(IIPOS),BASE(IIJJP),BASE(INJJP),IPRT,DDIF)
      ELSE
         CALL LCMSIX(IPMAC3,' ',0)
         CALL IQSADD(IPMAC1,IPMAC2,IPMAC3,NMIXT,NGRP,NDG,NL,
     1   BASE(ITOTAL),BASE(INUSIG),BASE(ISIGF),BASE(ICHI),BASE(ICHIDL),
     x   BASE(IOVERV),BASE(IDIFFX),BASE(IDIFFY),BASE(IDIFFZ),BASE(IH),
     x   BASE(IS),BASE(IIJJ),BASE(INJJ),BASE(ISCAT),BASE(IWORK),
     x   BASE(IIPOS),BASE(IIJJP),BASE(INJJP),DDIF,FACT)
      ENDIF
*
      CALL RLSARA(BASE(ITOTAL))
      CALL RLSARA(BASE(INUSIG))
      CALL RLSARA(BASE(ISIGF))
      CALL RLSARA(BASE(ICHI))
      IF(NDG.NE.0) CALL RLSARA(BASE(ICHIDL))
      CALL RLSARA(BASE(IOVERV))
      CALL RLSARA(BASE(IDIFFX))
      CALL RLSARA(BASE(IDIFFY))
      CALL RLSARA(BASE(IDIFFZ))
      CALL RLSARA(BASE(IH))
      CALL RLSARA(BASE(IS))
      CALL RLSARA(IBASE(IIJJ))
      CALL RLSARA(IBASE(INJJ))
      CALL RLSARA(IBASE(IIJJP))
      CALL RLSARA(IBASE(INJJP))
      CALL RLSARA(BASE(ISCAT))
      CALL RLSARA(BASE(IWORK))
      CALL RLSARA(IBASE(IIPOS))
*
      CALL LCMSIX(IPMAC3,' ',0)
      SGNTUR='L_MACROLIB'
      READ(SGNTUR,'(3A4)') (ISGNTR(I),I=1,3)
      CALL LCMPUT(IPMAC3,'SIGNATURE',3,3,ISGNTR)
      CALL LCMPUT(IPMAC3,'IDATAXS',7,1,DATXS1)
      CALL LCMLEN(IPMAC1,'ENERGY',ILONG,ITYLM)
      IF (ILONG.EQ.(NGRP+1)) THEN
        CALL SETARA(BASE,ILONG,IENERG)
        CALL LCMGET(IPMAC1,'ENERGY',BASE(IENERG))
        CALL LCMPUT(IPMAC3,'ENERGY',ILONG,2,BASE(IENERG))
        CALL RLSARA(BASE(IENERG))
      ENDIF
      CALL LCMLEN(IPMAC1,'VOLUME',ILONG,ITYLM)
      IF (ILONG.EQ.NMIXT) THEN
        CALL SETARA(BASE,ILONG,IENERG)
        CALL LCMGET(IPMAC1,'VOLUME',BASE(IENERG))
        CALL LCMPUT(IPMAC3,'VOLUME',ILONG,2,BASE(IENERG))
        CALL RLSARA(BASE(IENERG))
      ENDIF
      CALL LCMSIX(IPMAC3,' ',0)
      CALL LCMSIX(IPMAC2,' ',0)
      CALL LCMSIX(IPMAC1,' ',0)
*
 100  RETURN
      END
