*DECK DONJON
      PROGRAM DONJON
      IMPLICIT         NONE
C----
C  INPUT/OUTPUT UNITS
C----
      INTEGER          IINP,IOUT
      CHARACTER        NAMSBR*6
      PARAMETER       (IINP=5,IOUT=6,NAMSBR='DONJON')
C----
C  MEMORY ALLOCATION
C----
      INTEGER          IBASE(1)
      REAL             RBASE
      COMMON           RBASE(1)
      EQUIVALENCE     (RBASE(1),IBASE(1))
C----
C  VARIABLES FOR DONJON VERSION
C----
      INTEGER          IMVERS,ISVERS,IVDATE(3),IYMD
C----
C  VARIABLES FOR DATA STRUCTURES
C----
      INTEGER          MAXENT
      PARAMETER       (MAXENT=64)
      CHARACTER        HENTRY(MAXENT)*12
      INTEGER          IENTRY(MAXENT),JENTRY(MAXENT),KENTRY(MAXENT)
C----
C  GAN-2000 PARAMETERS
C----
      INTEGER          CLECST
      EXTERNAL         CLECST
      INTEGER          KERNEL
C----
C  DIMENSION FOR MODULE DATA
C----
      INTEGER          NMODXT
      PARAMETER       (NMODXT=32)
      CHARACTER        CMODXT(NMODXT)*12, NAMMOD*12
C----
C  LOCAL VARIABLES
C----
      CHARACTER        NAMOUT*20
      INTEGER          IMODUL,NENTRY,ILEVEL,IPRINT,IOS,IBLANK
C----
C  DATA
C----
      DATA             CMODXT
     > / 'AFM:   ','BIVACA:','BIVADT:','CRE:   ','DELTA: ',
     >   'DETECT:','DMAC:  ','ERROR: ','FLUD:  ','FLUNRM:',
     >   'FLXAXC:','GEOD:  ','INIDEV:','INIDET:','INIMAC:',
     >   'INPROC:','INIRES:','IQS:   ','LINKDS:','MACD:  ',
     >   'MOVDEV:','NEWMAC:','OUT:   ','POWER: ','REFRES:',
     >   'REFUEL:','SORKEF:','SURVEY:','TRIVAT:','TRIVAA:',
     >   'USPLIT:','XSCONS:'/
C----
C  VARIABLES INITIALISATION
C----
      NAMOUT=' '
      IMODUL=0
      NENTRY=0
      ILEVEL= 0
      IPRINT= 0
      IOS=0
      IBLANK=0
C-----
      CALL XDOVER(IMVERS,ISVERS,IVDATE)
      WRITE(IOUT,6000) NAMSBR,IMVERS,ISVERS,(IVDATE(IYMD),IYMD=1,3)
      WRITE(IOUT,6010) NAMSBR
C----
C  WHILE LOOP UNTIL ILEVEL = 0
C----
 100  CONTINUE
        IMODUL= KERNEL(CMODXT,NMODXT,ILEVEL,MAXENT,
     >                 CLECST,IPRINT,
     >                 NENTRY,HENTRY,IENTRY,JENTRY,KENTRY)
C----
C  RUN FINISHED IF ILEVEL = 0
C----
        IF(ILEVEL .EQ. 0) GO TO 105
        IF(IMODUL .LE. 0 .OR. IMODUL .GT. NMODXT) THEN
C----
C  ILLEGAL VALUE FOR IMODUL RETURNED
C  RETURN VALUE OF IMODUL AND ABORT
C----
          WRITE(IOUT,9000) NAMSBR,IMODUL
          CALL XABORT(NAMSBR//': KERNEL ERROR')
        ELSE
          NAMMOD=CMODXT(IMODUL)
C----
C  CALL APPROPRIATE MODULE
C----
          IF(      IMODUL .EQ.  1 ) THEN
            WRITE(6,*) "EXEC: ",NAMMOD," BY M.T. SISSAOUI"
            CALL AFM(NENTRY,HENTRY,IENTRY,JENTRY,KENTRY)
          ELSE IF( IMODUL .EQ.  2 ) THEN
            WRITE(6,*) "EXEC: ",NAMMOD," BY A. HEBERT"
            CALL BIVACA(NENTRY,HENTRY,IENTRY,JENTRY,KENTRY)
          ELSE IF( IMODUL .EQ.  3 ) THEN
            WRITE(6,*) "EXEC: ",NAMMOD," BY A. HEBERT"
            CALL BIVADT(NENTRY,HENTRY,IENTRY,JENTRY,KENTRY)
          ELSE IF( IMODUL .EQ.  4 ) THEN
            WRITE(6,*) "EXEC: ",NAMMOD," BY A. HEBERT"
            CALL CRE(NENTRY,HENTRY,IENTRY,JENTRY,KENTRY)
          ELSE IF( IMODUL .EQ.  5 ) THEN
            WRITE(6,*) "EXEC: ",NAMMOD," BY A. HEBERT"
            CALL DELTA(NENTRY,HENTRY,IENTRY,JENTRY,KENTRY)
          ELSE IF( IMODUL .EQ.  6 ) THEN
            WRITE(6,*) "EXEC: ",NAMMOD," BY J. KOCLAS"
            CALL DETECT(NENTRY,HENTRY,IENTRY,JENTRY,KENTRY)
          ELSE IF( IMODUL .EQ.  7 ) THEN
            WRITE(6,*) "EXEC: ",NAMMOD," BY A. HEBERT"
            CALL DMAC(NENTRY,HENTRY,IENTRY,JENTRY,KENTRY)
          ELSE IF( IMODUL .EQ.  8 ) THEN
            WRITE(6,*) "EXEC: ",NAMMOD," BY A. HEBERT"
            CALL ERROR(NENTRY,HENTRY,IENTRY,JENTRY,KENTRY)
          ELSE IF( IMODUL .EQ.  9 ) THEN
            WRITE(6,*) "EXEC: ",NAMMOD," BY A. HEBERT"
            CALL FLUD(NENTRY,HENTRY,IENTRY,JENTRY,KENTRY)
          ELSE IF( IMODUL .EQ. 10 ) THEN
            WRITE(6,*) "EXEC: ",NAMMOD," BY E. VARIN"
            CALL FLUNRM(NENTRY,HENTRY,IENTRY,JENTRY,KENTRY)
          ELSE IF( IMODUL .EQ. 11 ) THEN
            WRITE(6,*) "EXEC: ",NAMMOD," BY E. VARIN"
            CALL FLXAXC(NENTRY,HENTRY,IENTRY,JENTRY,KENTRY)
          ELSE IF( IMODUL .EQ. 12 ) THEN
            WRITE(6,*) "EXEC: ",NAMMOD," BY A. HEBERT"
            CALL GEOD(NENTRY,HENTRY,IENTRY,JENTRY,KENTRY)
          ELSE IF( IMODUL .EQ. 13 ) THEN
            WRITE(6,*) "EXEC: ",NAMMOD," BY J. KOCLAS"
            CALL INIDEV(NENTRY,HENTRY,IENTRY,JENTRY,KENTRY)
          ELSE IF( IMODUL .EQ. 14 ) THEN
            WRITE(6,*) "EXEC: ",NAMMOD," BY J. KOCLAS"
            CALL INIDET(NENTRY,HENTRY,IENTRY,JENTRY,KENTRY)
          ELSE IF( IMODUL .EQ. 15 ) THEN
            WRITE(6,*) "EXEC: ",NAMMOD," BY J. KOCLAS"
            CALL INIMAC(NENTRY,HENTRY,IENTRY,JENTRY,KENTRY)
          ELSE IF( IMODUL .EQ. 16 ) THEN
            WRITE(6,*) "EXEC: ",NAMMOD," BY J. KOCLAS"
            CALL INPROC(NENTRY,HENTRY,IENTRY,JENTRY,KENTRY)
          ELSE IF( IMODUL .EQ. 17 ) THEN
            WRITE(6,*) "EXEC: ",NAMMOD," BY R. ROY, E. VARIN"
            CALL INIRES(NENTRY,HENTRY,IENTRY,JENTRY,KENTRY)
          ELSE IF( IMODUL .EQ. 18 ) THEN
            WRITE(6,*) "EXEC: ",NAMMOD," BY A. MONNIER, M.T. SISSAOUI"
            CALL IQS(NENTRY,HENTRY,IENTRY,JENTRY,KENTRY)
          ELSE IF( IMODUL .EQ. 19 ) THEN
            WRITE(6,*) "EXEC: ",NAMMOD," BY J. KOCLAS"
            CALL LINKDS(NENTRY,HENTRY,IENTRY,JENTRY,KENTRY)
          ELSE IF( IMODUL .EQ. 20 ) THEN
            WRITE(6,*) "EXEC: ",NAMMOD," BY A. HEBERT"
            CALL MACD(NENTRY,HENTRY,IENTRY,JENTRY,KENTRY)
          ELSE IF( IMODUL .EQ. 21 ) THEN
            WRITE(6,*) "EXEC: ",NAMMOD," BY J. KOCLAS"
            CALL MOVDEV(NENTRY,HENTRY,IENTRY,JENTRY,KENTRY)
          ELSE IF( IMODUL .EQ. 22 ) THEN
            WRITE(6,*) "EXEC: ",NAMMOD," BY J. KOCLAS"
            CALL NEWMAC(NENTRY,HENTRY,IENTRY,JENTRY,KENTRY)
          ELSE IF( IMODUL .EQ. 23 ) THEN
            WRITE(6,*) "EXEC: ",NAMMOD," BY A. HEBERT"
            CALL OUT(NENTRY,HENTRY,IENTRY,JENTRY,KENTRY)
          ELSE IF( IMODUL .EQ. 24 ) THEN
            WRITE(6,*) "EXEC: ",NAMMOD," BY E. VARIN"
            CALL POWER(NENTRY,HENTRY,IENTRY,JENTRY,KENTRY)
          ELSE IF( IMODUL .EQ. 25 ) THEN
            WRITE(6,*) "EXEC: ",NAMMOD," BY R. ROY, E. VARIN"
            CALL REFRES(NENTRY,HENTRY,IENTRY,JENTRY,KENTRY)
          ELSE IF( IMODUL .EQ. 26 ) THEN
            WRITE(6,*) "EXEC: ",NAMMOD," BY E. VARIN"
            CALL REFUEL(NENTRY,HENTRY,IENTRY,JENTRY,KENTRY)
          ELSE IF( IMODUL .EQ. 27 ) THEN
            WRITE(6,*) "EXEC: ",NAMMOD," BY A. HEBERT"
            CALL SORKEF(NENTRY,HENTRY,IENTRY,JENTRY,KENTRY)
          ELSE IF( IMODUL .EQ. 28 ) THEN
            WRITE(6,*) "EXEC: ",NAMMOD," BY E. VARIN"
            CALL SURVEY(NENTRY,HENTRY,IENTRY,JENTRY,KENTRY)
          ELSE IF( IMODUL .EQ. 29 ) THEN
            WRITE(6,*) "EXEC: ",NAMMOD," BY A. HEBERT"
            CALL TRIVAT(NENTRY,HENTRY,IENTRY,JENTRY,KENTRY)
          ELSE IF( IMODUL .EQ. 30 ) THEN
            WRITE(6,*) "EXEC: ",NAMMOD," BY A. HEBERT, R. ROY"
            CALL TRIVAA(NENTRY,HENTRY,IENTRY,JENTRY,KENTRY)
          ELSE IF( IMODUL .EQ. 31 ) THEN
            WRITE(6,*) "EXEC: ",NAMMOD," BY J. KOCLAS"
            CALL USPLIT(NENTRY,HENTRY,IENTRY,JENTRY,KENTRY)
          ELSE IF( IMODUL .EQ. 32 ) THEN
            WRITE(6,*) "EXEC: ",NAMMOD," BY E. VARIN"
            CALL XSCONS(NENTRY,HENTRY,IENTRY,JENTRY,KENTRY)
          ENDIF
C----
C  GO TO PROCESS NEXT MODULE
C----
        ENDIF
      GO TO 100
C----
C  ALL MODULES PROCESSED
C----
 105  CONTINUE
      WRITE(IOUT,6030) NAMSBR,IMVERS,ISVERS
      STOP
C----
C  FORMATS
C----
 6000 FORMAT(
     > ' DDDDDD   OOOOO  NN     NN    JJJJ  OOOOO  NN     NN'/
     > ' DDDDDDD OOOOOOO NNN    NN     JJ  OOOOOOO NNN    NN'/
     > ' DD   DD OO   OO NNNN   NN     JJ  OO   OO NNNN   NN'/
     > ' DD   DD OO   OO NN NN  NN     JJ  OO   OO NN NN  NN'/
     > ' DD   DD OO   OO NN  NN NN     JJ  OO   OO NN  NN NN'/
     > ' DD   DD OO   OO NN   NNNN     JJ  OO   OO NN   NNNN'/
     > ' DDDDDDD OOOOOOO NN    NNN JJ  JJ  OOOOOOO NN    NNN'/
     > ' DDDDDD   OOOOO  NN     NN  JJJJ    OOOOO  NN     NN'/
     > ' VERSION ',A6,I2,'.',I2.2,' (',I4,'/',I2.2,'/',I2.2,')'/
     > ' GROUPE D''ANALYSE NUCLEAIRE'/
     > ' ECOLE POLYTECHNIQUE DE MONTREAL'///)
 6010 FORMAT(
     > ' COPYRIGHT NOTICE FOR THIS VERSION OF ',A6,':'/
     > ' --------------------------------------------'/
     > ' PERMISSION IS GRANTED TO THE PUBLIC TO COPY DONJON '/
     > ' WITHOUT CHARGE PROVIDED THAT THIS NOTICE IS REPRODUCED'/
     > ' ON ALL COPIES. ECOLE POLYTECHNIQUE DE MONTREAL MAKES NO'/
     > ' WARRANTY, EXPRESS OR IMPLIED, AND ASSUMES NO LIABILITY OR'/
     > ' RESPONSIBILITY FOR THE USE OF DONJON.'///)
 6030 FORMAT(//1X,'NORMAL END OF EXECUTION FOR ',A6,I2,'.',I2.2/
     >         1X,'CHECK FOR WARNING IN LISTING'/
     >         1x,'BEFORE ASSUMING YOUR RUN WAS SUCCESSFUL')
 9000 FORMAT('->@ERROR FROM KERNEL IN ',A6,' CODE = ',I10)
      END
