*DECK ERRDRV
      SUBROUTINE ERRDRV(IPMAC1,IPMAC2,NREG,NGRP,TRA1,TRA2,VOL1,VOL2,
     1 TOTAL,GAR,FLUX,QUAN1,QUAN2)
*
*-----------------------------------------------------------------------
*
* PERFORM REACTION RATE STATISTICS BETWEEN TWO EXTENDED MACROLIBS.
*
* INPUTS PARAMETERS:
*  IPMAC1 : L_MACROLIB POINTER TO THE REFERENCE EXTENDED MACROLIB.
*  IPMAC2 : L_MACROLIB POINTER TO THE APPROXIMATE EXTENDED MACROLIB.
*  NREG   : NUMBER OF REGIONS IN THE MACROLIB.
*  NGRP   : NUMBER OF ENERGY GROUPS.
*
* SCRATCH STORAGE:
*  TRA1   : DIMENSION TRA1(NREG,NGRP)
*  TRA2   : DIMENSION TRA2(NREG,NGRP)
*  VOL1   : DIMENSION VOL1(NREG)
*  VOL2   : DIMENSION VOL2(NREG)
*  TOTAL  : DIMENSION TOTAL(NREG)
*  GAR    : DIMENSION GAR(NREG)
*  FLUX   : DIMENSION FLUX(NREG)
*  QUAN1  : DIMENSION QUAN1(NREG)
*  QUAN2  : DIMENSION QUAN2(NREG)
*
*--------------------------------------------- A. HEBERT ; 21/07/94 ----
*
      CHARACTER CGRPNM*12,HSMG*131
      DIMENSION TRA1(NREG,*),TRA2(NREG,*),VOL1(*),VOL2(*),TOTAL(*),
     1 GAR(*),FLUX(*),QUAN1(*),QUAN2(*),IDATA(7)
*
* RECOVER REFERENCE REACTION RATES:
      CALL LCMGET(IPMAC1,'IDATAXS',IDATA)
      IF((NREG.NE.IDATA(2)).OR.(NGRP.NE.IDATA(1))) THEN
         CALL XABORT('ERRDRV: INVALID VALUE OF NREG OR NGRP.')
      ENDIF
      CALL LCMGET(IPMAC1,'VOLUME',VOL1)
      VOL1T=0.0
      PWR1T=0.0
      DO 10 I=1,NREG
      QUAN1(I)=0.0
   10 VOL1T=VOL1T+VOL1(I)
      DO 40 IGR=1,NGRP
      WRITE(CGRPNM,'(5HGROUP,I3,1H/,I3)') IGR,NGRP
      CALL LCMSIX(IPMAC1,CGRPNM,1)
      CALL LCMGET(IPMAC1,'TOTAL',TOTAL)
      CALL LCMGET(IPMAC1,'SIGW 0',GAR)
      CALL LCMGET(IPMAC1,'FLUX-INTG',FLUX)
      DO 20 I=1,NREG
   20 TRA1(I,IGR)=(TOTAL(I)-GAR(I))*FLUX(I)
      CALL LCMGET(IPMAC1,'H-FACTORS',GAR)
      DO 30 I=1,NREG
      QUAN1(I)=QUAN1(I)+GAR(I)*FLUX(I)
   30 PWR1T=PWR1T+QUAN1(I)
      CALL LCMSIX(IPMAC1,' ',2)
   40 CONTINUE
*
* RECOVER APPROXIMATE REACTION RATES:
      CALL LCMGET(IPMAC2,'IDATAXS',IDATA)
      IF((NREG.NE.IDATA(2)).OR.(NGRP.NE.IDATA(1))) THEN
         CALL XABORT('ERRDRV: INVALID VALUE OF NREG OR NGRP.')
      ENDIF
      CALL LCMGET(IPMAC2,'VOLUME',VOL2)
      VOL2T=0.0
      PWR2T=0.0
      DO 50 I=1,NREG
      QUAN2(I)=0.0
   50 VOL2T=VOL2T+VOL2(I)
      DO 80 IGR=1,NGRP
      WRITE(CGRPNM,'(5HGROUP,I3,1H/,I3)') IGR,NGRP
      CALL LCMSIX(IPMAC2,CGRPNM,1)
      CALL LCMGET(IPMAC2,'TOTAL',TOTAL)
      CALL LCMGET(IPMAC2,'SIGW 0',GAR)
      CALL LCMGET(IPMAC2,'FLUX-INTG',FLUX)
      DO 60 I=1,NREG
   60 TRA2(I,IGR)=(TOTAL(I)-GAR(I))*FLUX(I)
      CALL LCMGET(IPMAC2,'H-FACTORS',GAR)
      DO 70 I=1,NREG
      QUAN2(I)=QUAN2(I)+GAR(I)*FLUX(I)
   70 PWR2T=PWR2T+QUAN2(I)
      CALL LCMSIX(IPMAC2,' ',2)
   80 CONTINUE
*
* COMPUTE QUANDRY TYPE NORMALIZED POWER DENSITIES.
      DO 90 I=1,NREG
      IF(VOL1(I).NE.0.0) QUAN1(I)=QUAN1(I)/VOL1(I)
      IF(VOL2(I).NE.0.0) QUAN2(I)=QUAN2(I)/VOL2(I)
      IF(PWR1T.NE.0.0) QUAN1(I)=QUAN1(I)*VOL1T/PWR1T
      IF(PWR2T.NE.0.0) QUAN2(I)=QUAN2(I)*VOL2T/PWR2T
   90 CONTINUE
*
* PRINT STATISTICS ON QUANDRY TYPE NORMALIZED POWER DENSITIES.
      WRITE(6,'(/51H ERRDRV: STATISTICS ON QUANDRY TYPE NORMALIZED POWE,
     1 12HR DENSITIES:)')
      ERRMAX=0.0
      ERRSUM=0.0
      VOLTOT=0.0
      DO 100 I=1,NREG
      ERR=ABS(VOL1(I)/VOL1T-VOL2(I)/VOL2T)
      IF(ERR.GT.1.0E-5*ABS(VOL1(I)/VOL1T)) THEN
         WRITE(HSMG,'(37HERRDRV: INCONSISTENT VOLUME IN REGION,I5,
     1   3H BY,F7.2,2H %)') I,ERR*100.0
         CALL XABORT(HSMG)
      ENDIF
      GAR(I)=0.0
      IF(QUAN1(I).EQ.0.0) GO TO 100
      VOLTOT=VOLTOT+VOL1(I)
      GAR(I)=100.0*(QUAN2(I)-QUAN1(I))/QUAN1(I)
      ERRSUM=ERRSUM+VOL1(I)*ABS(QUAN1(I)-QUAN2(I))/QUAN1(I)
      ERRMAX=MAX(ERRMAX,ABS(GAR(I)))
  100 CONTINUE
      IF(VOLTOT.NE.0.0) ERRSUM=100.0*ERRSUM/VOLTOT
      WRITE(6,'(/8X,9HREFERENCE,7X,6HAPPROX,7X,5HERROR)')
      DO 110 I=1,NREG
      IF((QUAN1(I).NE.0.0).OR.(QUAN2(I).NE.0.0)) THEN
         WRITE(6,'(4X,I4,1X,1P,2E13.5,0P,F9.3,2H %)') I,QUAN1(I),
     1   QUAN2(I),GAR(I)
      ENDIF
  110 CONTINUE
      WRITE(6,'(/10X,14HMAXIMUM ERROR=,F9.3,2H %,F9.2,2H %)') ERRMAX,
     1 ERRMAX
      WRITE(6,'(10X,14HAVERAGE ERROR=,F9.3,2H %,F9.2,2H %)') ERRSUM,
     1 ERRSUM
*
* PRINT STATISTICS ON GROUPWISE REMOVAL RATES.
      WRITE(6,'(/47H ERRDRV: STATISTICS ON GROUPWISE REMOVAL RATES:)')
      SUMREF=0.0
      SUM=0.0
      DO 120 IGR=1,NGRP
      DO 120 I=1,NREG
      SUMREF=SUMREF+TRA1(I,IGR)
  120 SUM=SUM+TRA2(I,IGR)
      DO 150 IGR=1,NGRP
      WRITE (6,'(/17H PROCESSING GROUP,I3)') IGR
      ZMAX=0.0
      SUMERR=0.0
      DO 130 I=1,NREG
      TRA2(I,IGR)=TRA2(I,IGR)*SUMREF/SUM
      GAR(I)=100.0*(TRA2(I,IGR)-TRA1(I,IGR))/TRA1(I,IGR)
      SUMERR=SUMERR+ABS(GAR(I))
  130 ZMAX=MAX(ZMAX,ABS(GAR(I)))
      SUMERR=SUMERR/REAL(NREG)
      WRITE (6,'(/8X,9HREFERENCE,7X,6HAPPROX,7X,5HERROR)')
      DO 140 I=1,NREG
      WRITE (6,'(4X,I4,1X,1P,2E13.5,0P,F9.3,2H %)') I,TRA1(I,IGR),
     1 TRA2(I,IGR),GAR(I)
  140 CONTINUE
      WRITE (6,'(/10X,14HMAXIMUM ERROR=,F9.3,2H %,F9.2,2H %)') ZMAX,
     1 ZMAX
      WRITE (6,'(10X,14HAVERAGE ERROR=,F9.3,2H %,F9.2,2H %/)') SUMERR,
     1 SUMERR
  150 CONTINUE
*
* PRINT STATISTICS ON K-EFFECTIVE.
      CALL LCMLEN(IPMAC1,'K-EFFECTIVE',LENGT,ITYLCM)
      IF(LENGT.EQ.1) THEN
         CALL LCMGET(IPMAC1,'K-EFFECTIVE',FKEFF1)
         CALL LCMGET(IPMAC2,'K-EFFECTIVE',FKEFF2)
         WRITE(6,'(/5X,22HREFERENCE K-EFFECTIVE=,F9.6/8X,11HAPPROX K-EF,
     1   8HFECTIVE=,F9.6,8H  ERROR=,F9.1,4H PCM)') FKEFF1,FKEFF2,
     2   (FKEFF2-FKEFF1)*1.0E5
      ENDIF
      RETURN
      END
