*DECK ERROR
      SUBROUTINE ERROR(NENTRY,HENTRY,IENTRY,JENTRY,KENTRY)
*
*-----------------------------------------------------------------------
*
* REACTION RATE COMPARISON MODULE FOR TRIVAC-3.
*
* INPUT/STATPUT PARAMETERS:
*  NENTRY : NUMBER OF LINKED LISTS OR FILES USED BY THE MODULE.
*  HENTRY : CHARACTER*12 NAME OF EACH LINKED LIST OR FILE.
*  IENTRY : =1 LINKED LIST; =2 XSM FILE; =3 SEQUENTIAL BINARY FILE;
*           =4 SEQUENTIAL ASCII FILE.
*  JENTRY : =0 THE LINKED LIST OR FILE IS CREATED.
*           =1 THE LINKED LIST OR FILE IS OPEN FOR MODIFICATIONS;
*           =2 THE LINKED LIST OR FILE IS OPEN IN READ-ONLY MODE.
*  KENTRY : =FILE UNIT NUMBER; =LINKED LIST ADDRESS OTHERWISE.
*           DIMENSION HENTRY(NENTRY),IENTRY(NENTRY),JENTRY(NENTRY),
*           KENTRY(NENTRY)
*
* LINKED LIST / XSM FILE:
*  HENTRY(1) : READ-ONLY REFERENCE TYPE(L_MACROLIB) (EXTENDED)
*  HENTRY(2) : READ-ONLY TYPE(L_MACROLIB) (EXTENDED)
*
*-------------------------------------- AUTHOR: A. HEBERT ; 16/12/93 ---
*
      CHARACTER HENTRY(*)*12,TITLE*72,TEXT12*12,HSIGN*12
      DIMENSION IENTRY(*),JENTRY(*),KENTRY(*),KCHAR(18),IDATA(7)
      COMMON BASE(1)
*
* PARAMETER VALIDATION.
      IF(NENTRY.LE.1) CALL XABORT('STAT: TWO PARAMETERS EXPECTED.')
      IF((JENTRY(1).NE.2).OR.(IENTRY(1).LT.1).OR.(IENTRY(1).GT.4))
     1 CALL XABORT('STAT: LINKED LIST OR FILE IN READ-ONLY MODE EXPEC'
     2 //'TED AT FIRST RHS.')
      IF((JENTRY(2).NE.2).OR.(IENTRY(2).LT.1).OR.(IENTRY(2).GT.4))
     1 CALL XABORT('STAT: LINKED LIST OR FILE IN READ-ONLY MODE EXPEC'
     2 //'TED AT SECOND RHS.')
*
* PROCESS FIRST AND SECOND RHS.
      IF(IENTRY(1).GE.3) THEN
         CALL LCMOP(IPMAC1,'COPY1',0,1,0)
         CALL LCMEXP(IPMAC1,0,KENTRY(1),IENTRY(1)-2,2)
      ELSE
         IPMAC1=KENTRY(1)
      ENDIF
      CALL LCMGET(IPMAC1,'SIGNATURE',KCHAR)
      WRITE(HSIGN,'(3A4)') (KCHAR(I),I=1,3)
      IF(HSIGN.NE.'L_MACROLIB') THEN
         TEXT12=HENTRY(1)
         CALL XABORT('ERROR: SIGNATURE OF '//TEXT12//' IS '//HSIGN//
     1   '. L_MACROLIB EXPECTED.')
      ENDIF
      IF(IENTRY(2).GE.3) THEN
         CALL LCMOP(IPMAC2,'COPY2',0,1,0)
         CALL LCMEXP(IPMAC2,0,KENTRY(2),IENTRY(2)-2,2)
      ELSE
         IPMAC2=KENTRY(2)
      ENDIF
      CALL LCMGET(IPMAC2,'SIGNATURE',KCHAR)
      WRITE(HSIGN,'(3A4)') (KCHAR(I),I=1,3)
      IF(HSIGN.NE.'L_MACROLIB') THEN
         TEXT12=HENTRY(2)
         CALL XABORT('ERROR: SIGNATURE OF '//TEXT12//' IS '//HSIGN//
     1   '. L_MACROLIB EXPECTED.')
      ENDIF
      CALL LCMLEN(IPMAC2,'TITLE',LENGT,ITYLCM)
      IF(LENGT.GT.0) THEN
         CALL LCMGET(IPMAC2,'TITLE',KCHAR)
         WRITE(TITLE,'(18A4)') (KCHAR(I),I=1,18)
      ELSE
         TITLE='*** NO TITLE PROVIDED ***'
      ENDIF
      WRITE(6,'(/1X,A72)') TITLE
*
      CALL LCMGET(IPMAC1,'IDATAXS',IDATA)
      NGRP=IDATA(1)
      NREG=IDATA(2)
      CALL LCMGET(IPMAC2,'IDATAXS',IDATA)
      IF((NREG.NE.IDATA(2)).OR.(NGRP.NE.IDATA(1))) THEN
         WRITE (6,'(/16H REFERENCE NREG=,I7,6H NGRP=,I7)') NREG,NGRP
         WRITE (6,'(/16H   APPROX. NREG=,I7,6H NGRP=,I7)') IDATA(2),
     1   IDATA(1)
         CALL XABORT('ERROR: REFERENCE AND APPROX. DATA ARE NOT COMPAT'
     1   //'IBLE.')
      ENDIF
      CALL SETARA(BASE,NREG*NGRP,ITRA1)
      CALL SETARA(BASE,NREG*NGRP,ITRA2)
      CALL SETARA(BASE,NREG,IVOL1)
      CALL SETARA(BASE,NREG,IVOL2)
      CALL SETARA(BASE,NREG,ITOTAL)
      CALL SETARA(BASE,NREG,IGAR)
      CALL SETARA(BASE,NREG,IFLUX)
      CALL SETARA(BASE,NREG,IQUAN1)
      CALL SETARA(BASE,NREG,IQUAN2)
      CALL ERRDRV(IPMAC1,IPMAC2,NREG,NGRP,BASE(ITRA1),BASE(ITRA2),
     1 BASE(IVOL1),BASE(IVOL2),BASE(ITOTAL),BASE(IGAR),BASE(IFLUX),
     2 BASE(IQUAN1),BASE(IQUAN2))
      CALL RLSARA(BASE(IQUAN2))
      CALL RLSARA(BASE(IQUAN1))
      CALL RLSARA(BASE(IFLUX))
      CALL RLSARA(BASE(IGAR))
      CALL RLSARA(BASE(ITOTAL))
      CALL RLSARA(BASE(IVOL2))
      CALL RLSARA(BASE(IVOL1))
      CALL RLSARA(BASE(ITRA2))
      CALL RLSARA(BASE(ITRA1))
      IF(IENTRY(1).GE.3) THEN
         CALL LCMCL(IPMAC1,2)
      ENDIF
      IF(IENTRY(2).GE.3) THEN
         CALL LCMCL(IPMAC2,2)
      ENDIF
      RETURN
      END
