*DECK FLSCHM
      SUBROUTINE FLSCHM (NNS,NW,NMCYCL,NK,NRF)
*                                                                      *
*----------------------------------------------------------------------*
*                                                                      *
*     ***********************************************************      *
*     * CETTE SOUS-ROUTINE PERMET DE LIRE LES DONNEES RELATIVES *      *
*     * AU MODE DE RECHARGEMENT GENERALISE OU MULTICYCLE ET DE  *      *
*     * PRODUIRE LE VECTEUR CONCERNANT LE PATRON DE RECHARGEMENT*      *
*     ***********************************************************      *
*                                                                      *
*                                                                      *
*     NNS     : NUMERO REFERANT AU MODE DE RECHARGEMENT                *
*     NW     : VECTEUR CONTENANT LE PATRON DE RECHARGEMENT             *
*              NW > 0  : POSITION DE LA GRAPPE AVANT RECHARGEMENT      *
*              NW = 0  : INSERTION D'UNE GRAPPE NEUVE                  *
*     NMCYCL : NUMERO DU CYCLE DE RECHARGEMENT A EFFECTUE (CAS MULTI)  *
*     NK     : NOMBRE DE GRAPPE PAR CANAL                              *
*     NRF    : NUMERO DU CANAL A RECHARGER                             *
*                                                                      *
*                                                                      *
*     NW     : VECTEUR CONTENANT LE PATRON DE RECHARGEMENT             *
*              NW > 0  : POSITION DE LA GRAPPE AVANT RECHARGEMENT      *
*              NW = 0  : INSERTION D'UNE GRAPPE NEUVE                  *
*                                                                      *
*                                                                      *
*----------------------------------------------------------------------*
*
      IMPLICIT    NONE
*
      INTEGER     NNS,NMCYCL,NK,NW(NK),MODEID,I,NRF,IP,NL
*
      MODEID = NNS
*
*---- MODE DE RECHARGEMENT GENERALISE
*
      IF (MODEID.GT.NK) THEN
       CALL XABORT('FLSCHM: ONLY BI-DIRECTIONNAL REFUELING ')
*
      ELSE
*
*------- MODE DE RECHARGEMENT DIRECT
*
         DO 10 I=1,MODEID
            NW(I) = 0
 10      CONTINUE
*
         IF (MODEID.NE.NK) THEN
            NL = NK - MODEID
            DO 20 I=1,NL
               IP = MODEID + I
               NW(IP) = I
  20        CONTINUE
          ENDIF
*
      ENDIF
*
      RETURN
      END
