*DECK FLUD
      SUBROUTINE FLUD(NENTRY,HENTRY,IENTRY,JENTRY,KENTRY)
*
*-----------------------------------------------------------------------
*
* MULTIGROUP FLUX SOLUTION MODULE FOR TRIVAC-3.
*
* INPUT/OUTPUT PARAMETERS:
*  NENTRY : NUMBER OF LINKED LISTS OR FILES USED BY THE MODULE.
*  HENTRY : CHARACTER*12 NAME OF EACH LINKED LIST OR FILE.
*  IENTRY : =1 LINKED LIST; =2 XSM FILE; =3 SEQUENTIAL BINARY FILE;
*           =4 SEQUENTIAL ASCII FILE.
*  JENTRY : =0 THE LINKED LIST OR FILE IS CREATED.
*           =1 THE LINKED LIST OR FILE IS OPEN FOR MODIFICATIONS;
*           =2 THE LINKED LIST OR FILE IS OPEN IN READ-ONLY MODE.
*  KENTRY : =FILE UNIT NUMBER; =LINKED LIST ADDRESS OTHERWISE.
*           DIMENSION HENTRY(NENTRY),IENTRY(NENTRY),JENTRY(NENTRY),
*           KENTRY(NENTRY)
*
* LINKED LIST / XSM FILE:
*  HENTRY(1) : CREATE OR MODIFICATION TYPE(L_FLUX).
*  HENTRY(2) : READ-ONLY TYPE(L_SYSTEM).
*  HENTRY(3) : READ-ONLY TYPE(L_TRIVAC) OR (L_BIVAC).
*
*-------------------------------------- AUTHOR: A. HEBERT ; 14/12/93 ---
*                                     MODIFIED: E. VARIN  ; 02/10/96 ---
*
      CHARACTER HENTRY(*)*12,TEXT12*12,TITLE*72,CMODUL*12,HSIGN*12
      LOGICAL   REC
      DIMENSION IENTRY(*),JENTRY(*),KENTRY(*),IGP(4),IBASE(1),KCHAR(18),
     +          ISPARM(7),IFPARM(5),ITP(19)
      COMMON BASE(1)
      EQUIVALENCE (BASE(1),IBASE(1))
*
* PARAMETER VALIDATION.
      IF(NENTRY.LT.3) CALL XABORT('FLUD: THREE PARAMETERS EXPECTED.')
      IF((IENTRY(1).NE.1).AND.(IENTRY(1).NE.2)) CALL XABORT('FLUD: LI'
     1 //'NKED LIST OR XSM FILE EXPECTED AT LHS.')
      IF((JENTRY(1).NE.0).AND.(JENTRY(1).NE.1)) CALL XABORT('FLUD: EN'
     1 //'TRY IN CREATE OR MODIFICATION MODE EXPECTED.')
      IF((JENTRY(2).NE.2).OR.((IENTRY(2).NE.1).AND.(IENTRY(2).NE.2)))
     1 CALL XABORT('FLUD: LINKED LIST OR XSM FILE IN READ-ONLY MODE E'
     2 //'XPECTED AT RHS.')
      IF((JENTRY(3).NE.2).OR.(IENTRY(3).NE.1))
     1 CALL XABORT('FLUD: LINKED LIST IN READ-ONLY MODE E'
     2 //'XPECTED AT RHS.')
*
* L_FLUX
      IF(JENTRY(1).EQ.1) THEN
         CALL LCMGET(KENTRY(1),'SIGNATURE',KCHAR)
         WRITE(HSIGN,'(3A4)') (KCHAR(I1),I1=1,3)
         IF(HSIGN.NE.'L_FLUX') THEN
            TEXT12=HENTRY(1)
            CALL XABORT('FLUD: SIGNATURE OF '//TEXT12//' IS '//HSIGN//
     1      '. L_FLUX EXPECTED.')
         ENDIF
      ELSE
         HSIGN='L_FLUX'
         READ(HSIGN,'(3A4)') (KCHAR(I1),I1=1,3)
         CALL LCMPUT(KENTRY(1),'SIGNATURE',3,3,KCHAR)
      ENDIF
* L_SYSTEM
      CALL LCMGET(KENTRY(2),'SIGNATURE',KCHAR)
      WRITE(HSIGN,'(3A4)') (KCHAR(I1),I1=1,3)
      IF(HSIGN.NE.'L_SYSTEM') THEN
         TEXT12=HENTRY(2)
         CALL XABORT('FLUD: SIGNATURE OF '//TEXT12//' IS '//HSIGN//
     1   '. L_SYSTEM EXPECTED.')
      ENDIF
* L_TRIVAC OR L_BIVAC
      CALL LCMGET(KENTRY(3),'SIGNATURE',KCHAR)
      WRITE(HSIGN,'(3A4)') (KCHAR(I1),I1=1,3)
      IF((HSIGN.NE.'L_BIVAC').AND.(HSIGN.NE.'L_TRIVAC')) THEN
         TEXT12=HENTRY(3)
         CALL XABORT('FLUD: SIGNATURE OF '//TEXT12//' IS '//HSIGN//
     1      '. L_BIVAC OR L_TRIVAC EXPECTED.')
      ELSE IF(HSIGN.EQ.'L_BIVAC') THEN
            CMODUL='BIVAC'
      ELSE IF(HSIGN.EQ.'L_TRIVAC') THEN
            CMODUL='TRIVAC'
      ENDIF
*
      IPFLUX=KENTRY(1)
      IPSYS=KENTRY(2)
      IPTRK=KENTRY(3)
      REC=(JENTRY(1).EQ.1)
*
* RECOVER GENERAL TRACKING INFORMATION.
   20 CALL LCMGET(IPTRK,'GPARAM',IGP)
      NEL=IGP(1)
      NUN=IGP(2)
      CALL SETARA(IBASE,NEL,IMAT)
      CALL SETARA(BASE,NEL,IVOL)
      CALL SETARA(IBASE,NEL,IIDL)
      CALL LCMGET(IPTRK,'MATCOD',IBASE(IMAT))
      CALL LCMGET(IPTRK,'VOLUME',BASE(IVOL))
      CALL LCMGET(IPTRK,'KEYFLX',IBASE(IIDL))
      CALL LCMLEN(IPTRK,'TITLE',LENGT,ITYLCM)
      IF(LENGT.GT.0) THEN
         CALL LCMGET(IPTRK,'TITLE',KCHAR)
         WRITE(TITLE,'(18A4)') (KCHAR(I),I=1,18)
      ELSE
         TITLE='*** NO TITLE PROVIDED ***'
      ENDIF
      IF(CMODUL.EQ.'BIVAC') THEN
        CALL LCMGET(IPTRK,'BPARAM',ITP)
        CALL SETARA(IBASE,ITP(6),IMU)
        CALL LCMGET(IPTRK,'MU',IBASE(IMU))
        LL4 = IBASE(IMU+ITP(6)-1)
        CALL RLSARA(IBASE(IMU))
      ELSE
        CALL LCMGET(IPTRK,'TPARAM',ITP)
        LL4 = ITP(8)
      ENDIF
*
      CALL LCMGET(IPSYS,'SYS-PARAM',ISPARM)
      NGRP = ISPARM(1)
      IF( ISPARM(2).NE.LL4 )CALL XABORT('IQS: SYSTEM '
     +   //' AND TRACKING HAVE DIFFERENT NUMBER OF LINEAR ORDER.')
*
      IF (REC) THEN
        CALL LCMGET(IPFLUX,'FLUX-PARAM',IFPARM)
        IF( IFPARM(5).NE.0 )CALL XABORT('FLUD: PREVIOUS FLUX CONTAINS'
     +     //' SOLUTION OF A GPT PROBLEM')
        IF( IFPARM(4).NE.0 )CALL XABORT('FLUD: PREVIOUS FLUX CONTAINS'
     +     //' SOLUTION OF HARMONIC SEARCH')
        IF( IFPARM(1).NE.NGRP )CALL XABORT('FLUD: L_SYSTEM AND L_FLUX'
     +     //' HAVE DIFFERENT NUMBER OF GROUPS')
        IF( IFPARM(2).NE.NUN )CALL XABORT('FLUD: TRACKING AND PREVIOUS '
     +     //'FLUX HAVE DIFFERENT NUMBER OF UNKNOWS')
      ENDIF
*
* COMPUTE THE FLUX.
      CALL SETARA(BASE,NUN*NGRP,IEVECT)
      CALL FLDRIV(CMODUL,IPTRK,IPSYS,REC,NEL,NUN,IBASE(IMAT),BASE(IVOL),
     1 IBASE(IIDL),NGRP,TITLE,IPFLUX,BASE(IEVECT))
      CALL RLSARA(BASE(IEVECT))
*
* RELEASE GENERAL TRACKING INFORMATION.
      CALL RLSARA(IBASE(IIDL))
      CALL RLSARA(BASE(IVOL))
      CALL RLSARA(IBASE(IMAT))
      RETURN
      END
