*DECK FLUNRM
      SUBROUTINE FLUNRM(NENTRY,HENTRY,IENTRY,JENTRY,KENTRY)
*
**********************************************************************
*
*     THIS ROUTINE NORMALIZES FLUXES TO A SPECIFIC TOTAL POWER IN WATT
*     FROM A NORMALIZATION FACTOR, IT CAN ALSO COMPUTE NEW TOTAL POWER
*
*     CETTE SOUS ROUTINE NORMALISE LE FLUX A UNE VALEUR DE PUISSANCE
*     A PARTIR D'UN FACTEUR DE NORMALISATION, ON PEUT AUSSI CALCULER
*     UNE NOUVELLE PUISSANCE EN WATTS
*
*     INPUT/OUTPUT PARAMETERS:
*      HMODUL : CHARACTER*12 NAME OF THE MODULE.
*      NENTRY : NUMBER OF LINKED LISTS AND FILES USED BY THE MODULE.
*      HENTRY : CHARACTER*12 NAME OF EACH LINKED LIST OR FILE.
*      IENTRY : =1 LINKED LIST; =2 XSM FILE; =3 SEQUENTIAL BINARY FILE;
*               =4 SEQUENTIAL ASCII FILE; =5 DIRECT ACCESS FILE.
*      JENTRY : =0 THE LINKED LIST OR FILE IS CREATED.
*               =1 THE LINKED LIST OR FILE IS OPEN FOR MODIFICATIONS;
*               =2 THE LINKED LIST OR FILE IS OPEN IN READ-ONLY MODE.
*      KENTRY : FILE UNIT NUMBER OR LINKED LIST ADDRESS.
*
*      DIMENSION HENTRY(NENTRY),IENTRY(NENTRY),JENTRY(NENTRY),
*      KENTRY(NENTRY)
*
*      REQUIRED LINKED LISTS ARE:
*        KENTRY(1-3)   : OBJECT OF TYPE L_FLUX     IN MODIFICATION
*                                       L_TRACK    IN READ ONLY MODE
*                                       L_MACROLIB IN READ ONLY MODE
*
*
*-------------------------------------- AUTHOR: E. VARIN  95/05/09 ---
*
      IMPLICIT NONE
*  DRVDRV VARIABLES
      INTEGER NENTRY
      CHARACTER HENTRY(*)*12
      INTEGER IENTRY,JENTRY,KENTRY
      DIMENSION IENTRY(*),JENTRY(*),KENTRY(*)
*  SETARA VARIABLES
      REAL BASE
      INTEGER IBASE(1)
      COMMON BASE(1)
      EQUIVALENCE (BASE(1),IBASE(1))
*  REDGET TYPES
      INTEGER ITYP,NITMA
      REAL FLOTT
      DOUBLE PRECISION DFLOTT
      CHARACTER*12 TEXT
*
*  SIGNATURE INFORMATION
*
      CHARACTER*12 SGNTUR
      INTEGER ISGNTR(3)
      LOGICAL TRK,FLU,MAC,CALC
*
      INTEGER IPTRK,IPMAC,IPFLU
*
      INTEGER I,I1
*
*  MACRO
      INTEGER IDATXS(7)
*  TRK
      INTEGER GPARAM(4)
*
*  LOCAL VARIABLES
*
      INTEGER ILONG,ITYLCM,IGR,KC
      INTEGER NUN,NEL,IPRT,NGRP,NMIX
*
      CHARACTER*12  CGMPR,CGMPM
      INTEGER       IKEYF,IFLU,IVOL,IMAT,IHFAC
      REAL          POWER
*
*  VERIFICATION OF OBJECT IN NPUT
*
      IF(NENTRY.LE.2) CALL XABORT('FLUNRM: THREE PARAMETER EXPECTED.')
      IF(JENTRY(1).NE.1) CALL XABORT('FLU'
     + //'NRM: FIRST OBJECT IN MODIFICATION MODE EXPECTED.')
      IF(JENTRY(2).NE.2) CALL XABORT('FLUNRM'
     + //': SECOND OBJECT IN READ-ONLY MODE EXPECTED.')
      IF(JENTRY(3).NE.2) CALL XABORT('FLUNRM'
     + //': THIRD OBJECT IN READ-ONLY MODE EXPECTED.')
*
*     SEARCH FOR OBJECT TYPE WITH THEIR SIGNATURE
*
      TRK = .FALSE.
      FLU = .FALSE.
      MAC = .FALSE.
      DO 10 I=1,NENTRY
        IF((IENTRY(I).EQ.1).OR.(IENTRY(I).EQ.2)) THEN
         CALL LCMSIX(KENTRY(I),' ',0)
         CALL LCMGET(KENTRY(I),'SIGNATURE',ISGNTR)
         WRITE(SGNTUR,'(3A4)') (ISGNTR(I1),I1=1,3)
         IF (SGNTUR.EQ.'L_FLUX') THEN
           IF(.NOT.FLU) IPFLU=KENTRY(I)
           FLU = .TRUE.
           IF(JENTRY(I).NE.1) CALL XABORT('FLUNRM'
     +     //': MODIFICATION MODE EXPECTED FOR OBJECT'//SGNTUR//'.')
         ELSEIF (SGNTUR.EQ.'L_MACROLIB') THEN
           IPMAC=KENTRY(I)
           MAC = .TRUE.
           IF(JENTRY(I).NE.2) CALL XABORT('DET'
     +      //'ECT: READ-ONLY MODE EXPECTED FOR OBJECT'//SGNTUR//'.')
         ELSEIF (SGNTUR.EQ.'L_TRIVAC') THEN
          IF (.NOT.TRK) THEN
           IPTRK=KENTRY(I)
           TRK = .TRUE.
           IF(JENTRY(I).NE.2) CALL XABORT('FLUNRM'
     +      //': READ-ONLY MODE EXPECTED FOR OBJECT'//SGNTUR//'.')
          ELSE
            CALL XABORT('FLUNRM: ONLY ONE L_TRACK FILE IS REQUIRED')
          ENDIF
         ELSEIF (SGNTUR.EQ.'L_BIVAC') THEN
          IF (.NOT.TRK) THEN
           IPTRK=KENTRY(I)
           TRK = .TRUE.
           IF(JENTRY(I).NE.2) CALL XABORT('FLUNRM'
     +      //': READ-ONLY MODE EXPECTED FOR OBJECT'//SGNTUR//'.')
          ELSE
            CALL XABORT('FLUNRM: ONLY ONE L_TRACK FILE IS REQUIRED')
          ENDIF
         ENDIF
        ENDIF
  10  CONTINUE
      IF (.NOT.(FLU.AND.MAC.AND.TRK))
     +   CALL XABORT('FLUNRM: BAD TYPE OF PARAMETER')
*
*     READ INPUT DATA FOR THIS MODULE
*
      IPRT = 1
      CALC = .FALSE.
 15   CALL REDGET(ITYP,NITMA,FLOTT,TEXT,DFLOTT)
      IF(ITYP.EQ.3) THEN
        IF (TEXT.EQ.'EDIT') THEN
*   READ PRINTING FLAG
          CALL REDGET(ITYP,IPRT,FLOTT,TEXT,DFLOTT)
          IF (ITYP.NE.1)
     +      CALL XABORT('FLUNRM: INTEGER DATA EXPECTED')
        ELSEIF (TEXT.EQ.'POWER') THEN
*   READ TOTAL POWER TO WHICH NORMALIZED
          CALL REDGET(ITYP,NITMA,POWER,TEXT,DFLOTT)
          IF (ITYP.NE.2)
     +      CALL XABORT('FLUNRM: REAL DATA EXPECTED')
        ELSEIF (TEXT.EQ.'REF') THEN
*  READ TYPE OF CALCULATION INDICATOR
          CALL REDGET(ITYP,KC,FLOTT,TEXT,DFLOTT)
          IF (ITYP.NE.1)
     +      CALL XABORT('FLUNRM: INTEGER DATA EXPECTED')
        ELSEIF (TEXT.EQ.'CALC') THEN
*   READ OPTION FOR FLUX DENORMALIZATION
            CALC = .TRUE.
        ELSEIF (TEXT.EQ.';') THEN
          GOTO 70
        ELSE
          CALL XABORT('FLUNRM: WRONG KEYWORD '//TEXT)
        ENDIF
      ELSE
        CALL XABORT('FLUNRM: CHARACTER DATA EXPECTED')
      ENDIF
      GOTO 15
*
*     RECOVER USEFUL INFORMATIONS
*
 70   CALL LCMGET(IPTRK,'GPARAM',GPARAM)
      NEL = GPARAM(1)
      NUN = GPARAM(2)
      CALL SETARA(IBASE,NEL,IKEYF)
      CALL LCMGET(IPTRK,'KEYFLX',IBASE(IKEYF))
      CALL SETARA(IBASE,NEL,IMAT)
      CALL LCMGET(IPTRK,'MATCOD',IBASE(IMAT))
      CALL SETARA(BASE,NEL,IVOL)
      CALL LCMGET(IPTRK,'VOLUME',IBASE(IVOL))
*
      CALL LCMGET(IPMAC,'IDATAXS',IDATXS)
      NGRP = IDATXS(1)
      NMIX = IDATXS(2)
      CALL SETARA(BASE,NMIX*NGRP,IHFAC)
*
      CALL SETARA(BASE,NUN*NGRP,IFLU)
      CALL LCMSIX(IPMAC,' ',0)
      CALL LCMSIX(IPFLU,' ',0)
      DO 11 IGR=1,NGRP
        WRITE(CGMPR,'(4HFLUX,I3)') IGR
        CALL LCMLEN(IPFLU,CGMPR,ILONG,ITYLCM)
        IF (ILONG.EQ.0)
     +    CALL XABORT('FLUNRM: BLOCK '//CGMPR//' DOES NOT EXIST')
        CALL LCMGET(IPFLU,CGMPR,BASE(IFLU+(IGR-1)*NUN))
        WRITE(CGMPM,'(5HGROUP,I3,1H/,I3)') IGR,NGRP
        CALL LCMSIX(IPMAC,CGMPM,1)
        CALL LCMLEN(IPMAC,'H-FACTORS',ILONG,ITYLCM)
        IF (ILONG.EQ.0)
     +    CALL XABORT('FLUNRM: BLOCK H-FACTORS DOES NOT EXIST')
        CALL LCMGET(IPMAC,'H-FACTORS',BASE(IHFAC+(IGR-1)*NMIX))
        CALL LCMSIX(IPMAC,' ',2)
 11   CONTINUE
*
      IF(IPRT.GE.1) THEN
          WRITE(6,*) 'FLUNRM: TOTAL POWER WILL BE'
     +            //' NORMALIZED TO ',POWER
      ENDIF
*
*
      CALL FLUPOW(IPFLU,POWER,BASE(IFLU),BASE(IVOL),BASE(IHFAC),
     +            IBASE(IKEYF),IBASE(IMAT),CALC,KC,IPRT,NGRP,NUN,NEL,
     +            NMIX)
*
      CALL RLSARA(IBASE(IKEYF))
      CALL RLSARA(IBASE(IMAT))
      CALL RLSARA(BASE(IFLU))
      CALL RLSARA(BASE(IHFAC))
      CALL RLSARA(BASE(IVOL))
      RETURN
      END
