*DECK FLUPOW
      SUBROUTINE FLUPOW(IPFLU,POWER,FLU,VOL,HFAC,
     +            KEYF,MAT,CALC,KC,IPRT,NGRP,NUN,NEL,NMIX)
*
**********************************************************************
*
*     COMPUTES REACTOR POWER AND MAY NORMALIZE FLUXES
*
*     CETTE SOUS ROUTINE NORMALISE LE FLUX A UNE VALEUR DE PUISSANCE
*     LA PUISSANCE POWER DOIT ETRE DONNEE EN WATTS.
*
*
*-------------------------------------- AUTHOR: E. VARIN  95/05/09 ---
*
      IMPLICIT NONE
*
      LOGICAL CALC
      INTEGER IPFLU,I
*
*  LOCAL VARIABLES
*
      INTEGER ILONG,ITYLCM,IGR,KC
      INTEGER NUN,NEL,IPRT,NGRP,NMIX
      REAL    FLU(NUN,NGRP),HFAC(NMIX,NGRP),VOL(NEL)
*
      CHARACTER*12  CGMPR
      INTEGER       KEYF(NEL),MAT(NEL)
      REAL          POWER
      DOUBLE PRECISION  FACT,POW
*
*     OPTION CALC FOR FLUX DENORMALIZATION
*
      IF (CALC) THEN
       CALL LCMSIX(IPFLU,' ',0)
       CALL LCMLEN(IPFLU,'FACT-NORM',ILONG,ITYLCM)
       IF (ILONG.EQ.0)
     +    CALL XABORT('FLUNRM: OPTION KC=0 REQUIRED BEFORE CALC')
       CALL LCMGET(IPFLU,'FACT-NORM',FACT)
       DO 112 I=1,NUN
       DO 112 IGR=1,NGRP
         FLU(I,IGR)=FLU(I,IGR)/FACT
  112  CONTINUE
      ELSE
       IF (KC.EQ.0) THEN
         FACT = 0.0D0
         DO 95 IGR=1,NGRP
         DO 95 I=1,NEL
           IF(MAT(I).EQ.0) GO TO 95
           FACT=FACT+VOL(I)*FLU(KEYF(I),IGR)*HFAC(MAT(I),IGR)
 95      CONTINUE
         FACT=POWER/FACT
         DO 110 I=1,NUN
         DO 110 IGR=1,NGRP
           FLU(I,IGR)=FLU(I,IGR)*FACT
  110    CONTINUE
         WRITE(6,*) 'INITIAL REACTOR TOTAL POWER = ',POWER
         CALL LCMSIX(IPFLU,' ',0)
         CALL LCMPUT(IPFLU,'FACT-NORM',2,4,FACT)
       ELSE
         CALL LCMSIX(IPFLU,' ',0)
         CALL LCMLEN(IPFLU,'FACT-NORM',ILONG,ITYLCM)
         IF (ILONG.EQ.0)
     +     CALL XABORT('FLUNRM: OPTION KC=0 REQUIRED')
         CALL LCMGET(IPFLU,'FACT-NORM',FACT)
         DO 111 I=1,NUN
         DO 111 IGR=1,NGRP
           FLU(I,IGR)=FLU(I,IGR)*FACT
  111    CONTINUE
         POW = 0.0D0
         DO 100 IGR=1,NGRP
         DO 100 I=1,NEL
           IF(MAT(I).EQ.0) GO TO 100
           POW=POW+VOL(I)*FLU(KEYF(I),IGR)*HFAC(MAT(I),IGR)
 100     CONTINUE
         WRITE(6,*) 'REACTOR TOTAL POWER  = ',POW
       ENDIF
      ENDIF
* STORE RESULTING FLUXES
      CALL LCMSIX(IPFLU,' ',0)
      DO 12 IGR=1,NGRP
        WRITE(CGMPR,'(4HFLUX,I3)') IGR
        CALL LCMLEN(IPFLU,CGMPR,ILONG,ITYLCM)
        IF (ILONG.EQ.0)
     +    CALL XABORT('FLUNRM: BLOCK '//CGMPR//' DO NOT EXIST')
        CALL LCMPUT(IPFLU,CGMPR,NUN,2,FLU(1,IGR))
 12   CONTINUE
*
      RETURN
      END
