*DECK GEOD
      SUBROUTINE GEOD(NENTRY,HENTRY,IENTRY,JENTRY,KENTRY)
*
*-----------------------------------------------------------------------
*
* GEOMETRY DEFINITION MODULE FOR TRIVAC-3.
*
* INPUT/OUTPUT PARAMETERS:
*  NENTRY : NUMBER OF LINKED LISTS OR FILES USED BY THE MODULE.
*  HENTRY : CHARACTER*12 NAME OF EACH LINKED LIST OR FILE.
*  IENTRY : =1 LINKED LIST; =2 XSM FILE; =3 SEQUENTIAL BINARY FILE;
*           =4 SEQUENTIAL ASCII FILE.
*  JENTRY : =0 THE LINKED LIST OR FILE IS CREATED.
*           =1 THE LINKED LIST OR FILE IS OPEN FOR MODIFICATIONS;
*           =2 THE LINKED LIST OR FILE IS OPEN IN READ-ONLY MODE.
*  KENTRY : =FILE UNIT NUMBER; =LINKED LIST ADDRESS OTHERWISE.
*           DIMENSION HENTRY(NENTRY),IENTRY(NENTRY),JENTRY(NENTRY),
*           KENTRY(NENTRY)
*
* LINKED LISTS / XSM FILES:
*  HENTRY(1) : CREATE OR MODIFICATION TYPE(L_GEOM).
*  HENTRY(2) : READ-ONLY OPTIONAL TYPE(L_GEOM).
*
*-------------------------------------- AUTHOR: A. HEBERT ; 25/11/93 ---
*-------------------------------------- MODIFIED: E. VARIN ; 25/08/95 --
*
      PARAMETER (MAXCOD=9,MAXHEX=9,MAXTYP=9)
      CHARACTER HENTRY(*)*12,TEXT4*4,GEONAM*12,COND(MAXCOD)*4,
     1 CHEX(MAXHEX)*8,TYPE(0:MAXTYP)*16,TEXT12*12,TEXT13*12,HSMG*131
      DIMENSION IENTRY(*),JENTRY(*),KENTRY(*)
      SAVE COND,CHEX,TYPE
      LOGICAL LHEX,SWANG,TOT,LCOUR
      DOUBLE PRECISION DFLOTT
      INTEGER   NR0
      DIMENSION ISTATE(13),NCODE(6),ZCODE(6),ICODE(6),KCHAR(3),IBASE(1)
      COMMON BASE(1)
      EQUIVALENCE (BASE(1),IBASE(1))
      EQUIVALENCE (LR,ISTATE(2)),(LX,ISTATE(3)),(LY,ISTATE(4)),
     1 (LZ,ISTATE(5)),(LREG,ISTATE(6))
      DATA COND/'VOID','REFL','DIAG','TRAN','SYME','ALBE','ZERO',
     1 'CYLI','ACYL'/
      DATA CHEX/'S30','SA60','SB60','S90','R120','R180','SA180',
     1 'SB180','COMPLETE'/
      DATA TYPE/'VIRTUAL','HOMOGENEOUS','CARTESIAN 1-D','TUBE 1-D',
     1 'SPHERE 1-D','CARTESIAN 2-D','TUBE 2-D','CARTESIAN 3-D',
     2 'HEXAGONAL 2-D','HEXAGONAL 3-D'/
*
* PARAMETER VALIDATION.
      IF(NENTRY.EQ.0) CALL XABORT('GEOD: PARAMETER EXPECTED.')
      IF((IENTRY(1).NE.1).AND.(IENTRY(1).NE.2)) CALL XABORT('GEOD: LINK'
     1 //'ED LIST OR XSM FILE EXPECTED AT LHS.')
      IF((JENTRY(1).NE.0).AND.(JENTRY(1).NE.1)) CALL XABORT('GEOD: CREA'
     1 //'TE OR MODIFICATION MODE EXPECTED.')
      ITYPE=JENTRY(1)
      IPLIST=KENTRY(1)
      GEONAM=HENTRY(1)
*
      IMPX=1
      MINMIX=0
      MINICO=1
      IF(ITYPE.EQ.0) THEN
*        INPUT A NEW GEOMETRY.
         DO 10 I=1,13
   10    ISTATE(I)=0
         LHEX=.FALSE.
         LCOUR=.FALSE.
         DO 20 I=1,6
         NCODE(I)=0
         ZCODE(I)=0.0
   20    ICODE(I)=0
      ELSE IF(ITYPE.EQ.1) THEN
*        MODIFY AN EXISTING GEOMETRY USING THE SAME NAME.
         CALL LCMGET(IPLIST,'SIGNATURE',KCHAR)
         WRITE(TEXT12,'(3A4)') (KCHAR(I1),I1=1,3)
         IF(TEXT12.NE.'L_GEOM') THEN
            CALL XABORT('GEOD: SIGNATURE OF '//GEONAM//' IS '//TEXT12//
     1      '. L_GEOM EXPECTED.')
         ENDIF
         CALL LCMGET(IPLIST,'STATE',ISTATE)
         LHEX=(ISTATE(1).EQ.8).OR.(ISTATE(1).EQ.9).OR.(ISTATE(1).EQ.24)
     1   .OR.(ISTATE(1).EQ.25)
         LCOUR= .FALSE.
         IF(LHEX)THEN
            CALL LCMGET(IPLIST,'IHEX',IHEX)
            LCOUR= IHEX.EQ.9
         ENDIF
         CALL LCMGET(IPLIST,'NCODE',NCODE)
         CALL LCMGET(IPLIST,'ZCODE',ZCODE)
         CALL LCMGET(IPLIST,'ICODE',ICODE)
         GO TO 30
      ENDIF
*
   25 CALL REDGET(INDC,NITMA,FLOTT,TEXT12,DFLOTT)
      IF(INDC.NE.3) CALL XABORT('GEOD: CHARACTER DATA EXPECTED(1).')
      IF(TEXT12.EQ.'VIRTUAL') THEN
         ISTATE(1)=0
      ELSE IF(TEXT12.EQ.'HOMOGE') THEN
         ISTATE(1)=1
         LREG=1
      ELSE IF(TEXT12.EQ.'CAR1D') THEN
         ISTATE(1)=2
         CALL REDGET(INDC,LX,FLOTT,TEXT12,DFLOTT)
         IF(INDC.NE.1) CALL XABORT('GEOD: INTEGER DATA EXPECTED(1).')
         LREG=LX
      ELSE IF(TEXT12.EQ.'TUBE') THEN
         ISTATE(1)=3
         CALL REDGET(INDC,LR,FLOTT,TEXT12,DFLOTT)
         IF(INDC.NE.1) CALL XABORT('GEOD: INTEGER DATA EXPECTED(2).')
         LREG=LR
      ELSE IF(TEXT12.EQ.'SPHERE') THEN
         ISTATE(1)=4
         CALL REDGET(INDC,LR,FLOTT,TEXT12,DFLOTT)
         IF(INDC.NE.1) CALL XABORT('GEOD: INTEGER DATA EXPECTED(3).')
         LREG=LR
      ELSE IF(TEXT12.EQ.'CAR2D') THEN
         ISTATE(1)=5
         CALL REDGET(INDC,LX,FLOTT,TEXT12,DFLOTT)
         IF(INDC.NE.1) CALL XABORT('GEOD: INTEGER DATA EXPECTED(4).')
         CALL REDGET(INDC,LY,FLOTT,TEXT12,DFLOTT)
         IF(INDC.NE.1) CALL XABORT('GEOD: INTEGER DATA EXPECTED(5).')
         LREG=LX*LY
      ELSE IF(TEXT12.EQ.'TUBEZ') THEN
         ISTATE(1)=6
         CALL REDGET(INDC,LR,FLOTT,TEXT12,DFLOTT)
         IF(INDC.NE.1) CALL XABORT('GEOD: INTEGER DATA EXPECTED(6).')
         CALL REDGET(INDC,LZ,FLOTT,TEXT12,DFLOTT)
         IF(INDC.NE.1) CALL XABORT('GEOD: INTEGER DATA EXPECTED(7).')
         LREG=LR*LZ
      ELSE IF(TEXT12.EQ.'CAR3D') THEN
         ISTATE(1)=7
         CALL REDGET(INDC,LX,FLOTT,TEXT12,DFLOTT)
         IF(INDC.NE.1) CALL XABORT('GEOD: INTEGER DATA EXPECTED(8).')
         CALL REDGET(INDC,LY,FLOTT,TEXT12,DFLOTT)
         IF(INDC.NE.1) CALL XABORT('GEOD: INTEGER DATA EXPECTED(9).')
         CALL REDGET(INDC,LZ,FLOTT,TEXT12,DFLOTT)
         IF(INDC.NE.1) CALL XABORT('GEOD: INTEGER DATA EXPECTED(10).')
         LREG=LX*LY*LZ
      ELSE IF(TEXT12.EQ.'HEX') THEN
         ISTATE(1)=8
         LHEX=.TRUE.
         CALL REDGET(INDC,LX,FLOTT,TEXT12,DFLOTT)
         IF(INDC.NE.1) CALL XABORT('GEOD: INTEGER DATA EXPECTED(11).')
         LREG=LX
      ELSE IF(TEXT12.EQ.'HEXZ') THEN
         ISTATE(1)=9
         LHEX=.TRUE.
         CALL REDGET(INDC,LX,FLOTT,TEXT12,DFLOTT)
         IF(INDC.NE.1) CALL XABORT('GEOD: INTEGER DATA EXPECTED(12).')
         CALL REDGET(INDC,LZ,FLOTT,TEXT12,DFLOTT)
         IF(INDC.NE.1) CALL XABORT('GEOD: INTEGER DATA EXPECTED(13).')
         LREG=LX*LZ
      ELSE
*        COPY ATTRIBUTES FROM AN EXISTING GEOMETRY.
         IF(NENTRY.LE.1) CALL XABORT('GEOD: RHS GEOMETRY EXPECTED.')
         IF(JENTRY(2).NE.2) CALL XABORT('GEOD: RHS GEOMETRY EXPECTED OP'
     1   //'EN IN READ-ONLY MODE.')
         IF((IENTRY(2).NE.1).AND.(IENTRY(2).NE.2)) CALL XABORT('GEOD: '
     1   //'LINKED LIST OR XSM FILE EXPECTED AT RHS.')
         CALL LCMGET(KENTRY(2),'SIGNATURE',KCHAR)
         TEXT13=HENTRY(2)
         WRITE(TEXT12,'(3A4)') (KCHAR(I1),I1=1,3)
         IF(TEXT12.NE.'L_GEOM') THEN
            CALL XABORT('GEOD: SIGNATURE OF '//TEXT13//' IS '//TEXT12//
     1      '. L_GEOM EXPECTED.')
         ENDIF
         IF(IMPX.GT.0) WRITE(6,'(/26H GEOD: COPY RHS GEOMETRY '',A12,
     1   8H'' INTO '',A12,2H''.)') TEXT13,GEONAM
         IFILE=KDROPN('DUMMYSQ',0,2,0,0)
         IF(IFILE.LT.0) THEN
            WRITE(HSMG,'(26HGEOD: KDROPN FAILURE. IER=,I3)') IFILE
            CALL XABORT(HSMG)
         ENDIF
         CALL LCMEXP(KENTRY(2),0,IFILE,1,1)
         REWIND(IFILE)
         CALL LCMEXP(IPLIST,0,IFILE,1,2)
         IRC=KDRCLS(IFILE,2)
         IF(IRC.LT.0) CALL XABORT('GEOD: KDRCLS FAILURE.')
         CALL LCMGET(IPLIST,'STATE',ISTATE)
         LHEX=(ISTATE(1).EQ.8).OR.(ISTATE(1).EQ.9).OR.(ISTATE(1).EQ.24)
     1   .OR.(ISTATE(1).EQ.25)
         CALL LCMGET(IPLIST,'NCODE',NCODE)
         CALL LCMGET(IPLIST,'ZCODE',ZCODE)
         CALL LCMGET(IPLIST,'ICODE',ICODE)
         GO TO 35
      ENDIF
*
   30 CALL REDGET(INDC,NITMA,FLOTT,TEXT12,DFLOTT)
      IF(INDC.NE.3) CALL XABORT('GEOD: CHARACTER DATA EXPECTED(2).')
   35 IF(TEXT12.EQ.'MIX') THEN
*        INPUT MIXTURE NUMBERS.
         CALL SETARA(IBASE,LREG,IMIX)
         TOT = .FALSE.
         I=0
   40    I=I+1
         CALL REDGET(INDC,NITMA,FLOTT,TEXT12,DFLOTT)
         IF(INDC.EQ.3) THEN
          IF(TEXT12.EQ.'PLAN') THEN
            IF (TOT) GO TO 500
            IF (ISTATE(1).EQ.7.OR.ISTATE(1).EQ.9) THEN
             IF (ISTATE(1).EQ.9) LY= 1
             CALL GEOMIX(IBASE(IMIX),LX,LY,LZ,MINMIX,ISTATE(7),LCOUR)
            ELSE
             CALL XABORT('GEOD: INVALID KEY WORD PLAN FOR NON 3-D CART'
     +         //' ESIAN GEOMETRY')
            ENDIF
          ELSE
             GO TO 50
          ENDIF
         ELSEIF(INDC.EQ.1) THEN
          TOT = .TRUE.
          IF(I.GT.LREG) GO TO 500
          IBASE(IMIX+I-1)=NITMA
          ISTATE(7)=MAX(ISTATE(7),IBASE(IMIX+I-1))
          MINMIX=MIN(MINMIX,IBASE(IMIX+I-1))
         ELSE
          CALL XABORT('GEOD: INTEGER DATA EXPECTED(15).')
         ENDIF
         GO TO 40
   50    IF(TOT) LREG = I-1
         CALL LCMPUT(IPLIST,'MIX',LREG,1,IBASE(IMIX))
         CALL RLSARA(IBASE(IMIX))
         GO TO 35
      ELSE IF(TEXT12(1:4).EQ.'MESH') THEN
*        INPUT CARTESIAN COORDINATES.
         IF(TEXT12(5:5).EQ.'X') THEN
            IF(LX.EQ.0) GO TO 500
            LMESH=LX+1
         ELSE IF(TEXT12(5:5).EQ.'Y') THEN
            IF(LY.EQ.0) GO TO 500
            LMESH=LY+1
         ELSE IF(TEXT12(5:5).EQ.'Z') THEN
            IF(LZ.EQ.0) GO TO 500
            LMESH=LZ+1
         ELSE
            GO TO 500
         ENDIF
         CALL SETARA(BASE,LMESH,IMESH)
         DO 60 I=1,LMESH
         CALL REDGET(INDC,NITMA,BASE(IMESH+I-1),TEXT13,DFLOTT)
         IF(INDC.NE.2) CALL XABORT('GEOD: REAL DATA EXPECTED.')
         IF(I.GT.1) THEN
            IF(BASE(IMESH+I-1).LE.BASE(IMESH+I-2)) GO TO 500
         ENDIF
   60    CONTINUE
         CALL LCMPUT(IPLIST,TEXT12,LMESH,2,BASE(IMESH))
         CALL RLSARA(BASE(IMESH))
      ELSE IF(TEXT12.EQ.'RADIUS') THEN
*        INPUT TUBE RADIUS.
         IF(LR.EQ.0) GO TO 500
         LCYL=LR+1
         CALL SETARA(BASE,LCYL,ICYL)
         DO 70 I=1,LCYL
         CALL REDGET(INDC,NITMA,BASE(ICYL+I-1),TEXT12,DFLOTT)
         IF(INDC.NE.2) CALL XABORT('GEOD: REAL DATA EXPECTED.')
         IF(I.GT.1) THEN
            IF(BASE(ICYL+I-1).LE.BASE(ICYL+I-2)) GO TO 500
         ENDIF
   70    CONTINUE
         IF(BASE(ICYL).NE.0.0) GO TO 500
         CALL LCMPUT(IPLIST,'RADIUS',LCYL,2,BASE(ICYL))
         CALL RLSARA(BASE(ICYL))
      ELSE IF(TEXT12.EQ.'SIDE') THEN
*        INPUT THE SIDE LENGTH IN HEXAGONAL GEOMETRY.
         IF(.NOT.LHEX) CALL XABORT('GEOD: SIDE PROHIBITED.')
         CALL REDGET(INDC,NITMA,SIDE,TEXT12,DFLOTT)
         IF(INDC.NE.2) CALL XABORT('GEOD: REAL DATA EXPECTED.')
         CALL LCMPUT(IPLIST,'SIDE',1,2,SIDE)
      ELSE IF (TEXT12.EQ.'RADS') THEN
*        OPTIONS FOR CYLINDRICAL CORRECTION IN CARTESIAN GEOMETRY.
         IF((ISTATE(1).NE.5).AND.(ISTATE(1).NE.7)) CALL XABORT('GEO'
     1   //': OPTION RADS IS LIMITED TO CARTESIAN GEOMETRIES.')
         CALL REDGET(INDIC,NR0,FLOTT,TEXT4,DFLOTT)
         SWANG=TEXT4.EQ.'ANG'
         IF(SWANG) CALL REDGET(INDIC,NR0,FLOTT,TEXT4,DFLOTT)
         IF(INDIC.NE.1) CALL XABORT('GEOD: INTEGER DATA EXPECTED(16).')
         IF(NR0.EQ.0) CALL XABORT('GEOD: NON ZERO INTEGER EXPECTED.')
         ISTATE(8) = NR0
         CALL SETARA (BASE,NR0,IXR0)
         CALL SETARA (BASE,NR0,IRR0)
         CALL SETARA (BASE,NR0,IANG)
         DO 75 I=1,NR0
         CALL REDGET(INDIC,NITMA,BASE(IXR0+I-1),TEXT4,DFLOTT)
         IF(INDIC.NE.2) CALL XABORT('GEOD: REAL DATA EXPECTED.')
         CALL REDGET(INDIC,NITMA,BASE(IRR0+I-1),TEXT4,DFLOTT)
         IF(INDIC.NE.2) CALL XABORT('GEOD: REAL DATA EXPECTED.')
         IF(SWANG) THEN
            CALL REDGET(INDIC,NITMA,BASE(IANG+I-1),TEXT4,DFLOTT)
            IF(INDIC.NE.2) CALL XABORT('GEOD: REAL DATA EXPECTED.')
         ELSE
*           USE PI/2 + 0.1
            BASE(IANG+I-1)=1.670796327
         ENDIF
   75    CONTINUE
         CALL LCMPUT(IPLIST,'XR0',NR0,2,BASE(IXR0))
         CALL LCMPUT(IPLIST,'RR0',NR0,2,BASE(IRR0))
         CALL LCMPUT(IPLIST,'ANG',NR0,2,BASE(IANG))
         CALL RLSARA (BASE(IANG))
         CALL RLSARA (BASE(IRR0))
         CALL RLSARA (BASE(IXR0))
      ELSE IF(TEXT12(1:5).EQ.'SPLIT') THEN
*        INPUT MESH SPLITTING FACTORS.
         ISTATE(11)=1
         IF(TEXT12(6:6).EQ.'X') THEN
            IF(LX.EQ.0) GO TO 500
            LMESH=LX
         ELSE IF(TEXT12(6:6).EQ.'Y') THEN
            IF(LY.EQ.0) GO TO 500
            LMESH=LY
         ELSE IF(TEXT12(6:6).EQ.'Z') THEN
            IF(LZ.EQ.0) GO TO 500
            LMESH=LZ
         ELSE IF(TEXT12(6:6).EQ.'R') THEN
            IF(LR.EQ.0) GO TO 500
            LMESH=LR
         ELSE
            GO TO 500
         ENDIF
         CALL SETARA(IBASE,LMESH,IMESH)
         DO 80 I=1,LMESH
         CALL REDGET(INDC,IBASE(IMESH+I-1),FLOTT,TEXT13,DFLOTT)
         IF(INDC.NE.1) CALL XABORT('GEOD: INTEGER DATA EXPECTED(17).')
         IF(((IBASE(IMESH+I-1).LE.0).AND.(TEXT12.NE.'SPLITR')).OR.(
     1   IBASE(IMESH+I-1).EQ.0)) CALL XABORT('GEOD: INVALID MESH-SPL'
     2   //'ITTING INDEX.')
   80    CONTINUE
         CALL LCMPUT(IPLIST,TEXT12,LMESH,1,IBASE(IMESH))
         CALL RLSARA(IBASE(IMESH))
      ELSE IF((TEXT12(2:2).EQ.'+').OR.(TEXT12(2:2).EQ.'-').OR.
     1   (TEXT12.EQ.'HBC')) THEN
*        INPUT BOUNDARY CONDITIONS.
         IF(TEXT12.EQ.'X-') THEN
            ISURF=1
            IF(LX.EQ.0) GO TO 500
         ELSE IF(TEXT12.EQ.'X+') THEN
            ISURF=2
            IF(LX.EQ.0) GO TO 500
         ELSE IF(TEXT12.EQ.'R+') THEN
            ISURF=2
            IF(LR.EQ.0) GO TO 500
         ELSE IF(TEXT12.EQ.'Y-') THEN
            ISURF=3
            IF(LY.EQ.0) GO TO 500
         ELSE IF(TEXT12.EQ.'Y+') THEN
            ISURF=4
            IF(LY.EQ.0) GO TO 500
         ELSE IF(TEXT12.EQ.'Z-') THEN
            ISURF=5
            IF(LZ.EQ.0) GO TO 500
         ELSE IF(TEXT12.EQ.'Z+') THEN
            ISURF=6
            IF(LZ.EQ.0) GO TO 500
         ELSE IF(TEXT12.EQ.'HBC') THEN
            ISURF=1
            IF(.NOT.LHEX) CALL XABORT('GEOD: HBC PROHIBITED.')
            CALL REDGET(INDC,NITMA,FLOTT,TEXT12,DFLOTT)
            IF(INDC.NE.3) CALL XABORT('GEOD: CHARACTER DATA EXPECTE'
     1      //'D.')
            DO 280 I=1,MAXHEX
            IF(TEXT12.EQ.CHEX(I)) THEN
               IHEX=I
               GO TO 285
            ENDIF
  280       CONTINUE
            CALL XABORT('GEOD: INVALID TYPE OF HEXAGONAL SYMMETRY.')
  285       CALL LCMPUT(IPLIST,'IHEX',1,1,IHEX)
            LCOUR= IHEX.EQ.9
         ELSE
            GO TO 500
         ENDIF
         CALL REDGET(INDC,NITMA,FLOTT,TEXT4,DFLOTT)
         IF(INDC.NE.3) CALL XABORT('GEOD: CHARACTER DATA EXPECTED(3).')
         DO 290 I=1,MAXCOD
           IF(TEXT4.EQ.COND(I)) THEN
              NCODE(ISURF)=I
              IF(TEXT4.EQ.'ACYL') NCODE(ISURF)=I-1
              GO TO 295
           ENDIF
  290    CONTINUE
         CALL XABORT('GEOD: INVALID TYPE OF BOUNDARY CONDITION.')
  295    IF(TEXT4.EQ.'ALBE') THEN
            CALL REDGET(INDC,NITMA,FLOTT,TEXT4,DFLOTT)
            IF(INDC.EQ.1) THEN
               ICODE(ISURF)=NITMA
               MINICO=MIN(MINICO,NITMA)
            ELSE IF(INDC.EQ.2) THEN
               ZCODE(ISURF)=FLOTT
            ELSE
               CALL XABORT('GEOD: INTEGER OR REAL DATA EXPECTED.')
            ENDIF
         ELSEIF(TEXT4.EQ.'ACYL') THEN
            CALL REDGET(INDC,NITMA,FLOTT,TEXT4,DFLOTT)
            IF(INDC.EQ.1) THEN
               ICODE(ISURF)=NITMA
               MINICO=MIN(MINICO,NITMA)
            ELSE IF(INDC.EQ.2) THEN
               ZCODE(ISURF)=FLOTT
            ELSE
               CALL XABORT('GEOD: INTEGER OR REAL DATA EXPECTED '
     >           //'AFTER ACYL.')
            ENDIF
         ELSE IF(TEXT4.EQ.'REFL') THEN
            ZCODE(ISURF)=1.0
         ELSE IF(TEXT4.EQ.'VOID') THEN
            ZCODE(ISURF)=0.0
         ENDIF
      ELSE IF(TEXT12.EQ.';') THEN
*        END-OF-GEOMETRY.
         GO TO 320
      ELSE IF(TEXT12.EQ.'EDIT') THEN
         CALL REDGET(INDC,IMPX,FLOTT,TEXT12,DFLOTT)
         IF(INDC.NE.1) CALL XABORT('GEOD: INTEGER DATA EXPECTED(18).')
      ELSE
         CALL XABORT('GEOD: '//TEXT12//' IS AN INVALID KEY WORD.')
      ENDIF
      GO TO 30
*
  320 TEXT12='L_GEOM'
      READ(TEXT12,'(3A4)') (KCHAR(I1),I1=1,3)
      CALL LCMPUT(IPLIST,'SIGNATURE',3,3,KCHAR)
      CALL LCMPUT(IPLIST,'STATE',13,1,ISTATE)
      CALL LCMPUT(IPLIST,'NCODE',6,1,NCODE)
      CALL LCMPUT(IPLIST,'ZCODE',6,2,ZCODE)
      CALL LCMPUT(IPLIST,'ICODE',6,1,ICODE)
      IF(MINMIX.LT.0)
     1  CALL XABORT('GEOD: NEGATIVE MIXTURE NUMBERS INVALID.')
      IF(MINICO.LT.1)
     1  CALL XABORT('GEOD: ALBEDO NUMBER MUST BE GREATER THAN 0.')
      IF((IMPX.GT.0).AND.(ITYPE.EQ.0)) THEN
         WRITE (6,510) GEONAM,TYPE(ISTATE(1))
      ELSE IF((IMPX.GT.0).AND.(ITYPE.EQ.1)) THEN
         WRITE (6,515) GEONAM,TYPE(ISTATE(1))
      ENDIF
      IF(IMPX.GT.1) THEN
         WRITE (6,520) ISTATE(1),TYPE(ISTATE(1)),(ISTATE(I),I=2,7),
     1   ISTATE(11)
      ENDIF
      RETURN
  500 CALL XABORT('GEOD: INVALID DATA.')
*
  510 FORMAT(/37H GEOD: CREATION OF A GEOMETRY NAMED ',A12,
     1 12H' WITH TYPE ,A16,1H.)
  515 FORMAT(/41H GEOD: MODIFICATION OF A GEOMETRY NAMED ',A12,
     1 12H' WITH TYPE ,A16,1H.)
  520 FORMAT(/14H STATE VECTOR:/
     1 7H ITYPE ,I6, 4H   (,A16,1H)/
     2 7H LR    ,I6,20H   (NUMBER OF TUBES)/
     3 7H LX    ,I6,22H   (X-DIMENSION INDEX)/
     4 7H LY    ,I6,22H   (Y-DIMENSION INDEX)/
     5 7H LZ    ,I6,22H   (Z-DIMENSION INDEX)/
     6 7H LREG  ,I6,22H   (NUMBER OF REGIONS)/
     7 7H MAXMIX,I6,48H   (MAX. NB. OF MIXTURES/0=TRANSPARENT GEOMETRY)/
     8 7H ISPLIT,I6,28H   (1=MESH-SPLITTING/0=ELSE)/)
      END
