*DECK GETMAC
      SUBROUTINE GETMAC (IPLIST,NMIXT,NGRP,NL,TOTAL,ZNUSIG,ZSIGF,
     1   CHI,OVERV,DIFFX,DIFFY,DIFFZ,H,IJJ,NJJ,SCAT,WORK,IPOS)
*
*-----------------------------------------------------------------------
*
*  READ CROSS SECTIONS FROM A LINKED LIST AND STORE THEM IN MEMORY.
*  ( PROCEDURE SOMEHOW IDENTICAL TO MAKXSI SUBROUTINE)
*
* INPUT PARAMETERS:
*  IPLIST : ADDRESS OF THE LINKED LIST OR HANDLE TO THE XSM FILE.
*  NMIXT  : MAXIMUM NUMBER OF MATERIAL MIXTURES.
*  NGRP   : NUMBER OF ENERGY GROUPS.
*  NL     : NUMBER OF LEGENDRE ORDERS (=1 FOR ISOTROPIC SCATTERING).
*
* OUTPUT PARAMETER:
*  TOTAL  : DIMENSION TOTAL(NMIXT,NGRP)
*  ZNUSIG : DIMENSION ZNUSIG(NMIXT,NGRP)
*  ZSIGF  : DIMENSION ZSIGF(NMIXT,NGRP)
*  CHI    : DIMENSION CHI(NMIXT,NGRP)
*  OVERV  : DIMENSION OVERV(NMIXT,NGRP)
*  DIFFX  : DIMENSION DIFFX(NMIXT,NGRP)
*  DIFFY  : DIMENSION DIFFY(NMIXT,NGRP)
*  DIFFZ  : DIMENSION DIFFZ(NMIXT,NGRP)
*  H      : DIMENSION H(NMIXT,NGRP)
*  IJJ    : DIMENSION IJJ(NMIXT,NL,NGRP)
*  NJJ    : DIMENSION NJJ(NMIXT,NL,NGRP)
*  SCAT   : SCAT(NMIXT,NL,NGRP,NGRP)
*  WORK   : WORK(NMIXT*NGRP)
*  IPOS   : IPOS(NMIXT)
*
* NOTE: ANY CROSS SECTION NOT READ IS SET TO ZERO.
*
*----MODIFIED BY J. KOCLAS-94/03/12---- AUTHOR: A. HEBERT ; 26/07/93 ---
*    MODIFIED BY E. VARIN-94/10/19
*
*      IMPLICIT NONE
*
      INTEGER IGR,IBM,IL,JGR,ILENGT,IPLIST,ITYLCM,NMIXT,NL,NGRP
      INTEGER IPOSDE,IJJ0
      CHARACTER CGRPNM*12,CM*2
      REAL TOTAL((NMIXT+1),*),ZNUSIG((NMIXT+1),*),ZSIGF((NMIXT+1),*),
     1 CHI((NMIXT+1),*),OVERV((NMIXT+1),*),DIFFX((NMIXT+1),*),
     2 DIFFY((NMIXT+1),*),DIFFZ((NMIXT+1),*),
     3 SCAT((NMIXT+1),NL,NGRP,*),H((NMIXT+1),*),
     4 WORK(*)
      INTEGER IJJ(NMIXT,NL,*),NJJ(NMIXT,NL,*),IPOS(*)
*
      DO 10 IGR=1,NGRP
      DO 10 IBM=1,NMIXT+1
      TOTAL(IBM,IGR)=0.0
      ZNUSIG(IBM,IGR)=0.0
      ZSIGF(IBM,IGR)=0.0
      DIFFX(IBM,IGR)=0.0
      DIFFY(IBM,IGR)=0.0
      DIFFZ(IBM,IGR)=0.0
      CHI(IBM,IGR)=0.0
      OVERV(IBM,IGR)=0.0
      H(IBM,IGR)=0.0
      DO 10 IL=1,NL
      DO 10 JGR=1,NGRP
 10   SCAT(IBM,IL,JGR,IGR)=0.0
      DO 15 IGR=1,NGRP
      DO 15 IBM=1,NMIXT
      DO 15 IL=1,NL
      IJJ(IBM,IL,IGR)=IGR
      NJJ(IBM,IL,IGR)=1
 15   CONTINUE
*
*        RECOVER THE EXISTING MACROLIB DATA.
         DO 40 JGR=1,NGRP
*
         WRITE (CGRPNM,'(5HGROUP,I3,1H/,I3)') JGR,NGRP
         CALL LCMSIX(IPLIST,CGRPNM,1)
         CALL LCMLEN(IPLIST,'TOTAL',ILENGT,ITYLCM)
         IF(ILENGT.EQ.NMIXT) THEN
            CALL LCMGET(IPLIST,'TOTAL',TOTAL(1,JGR))
         ELSE IF(ILENGT.NE.0) THEN
            CALL XABORT('GETMAC: INVALID INPUT MACROLIB(1).')
         ENDIF
         CALL LCMLEN(IPLIST,'NUSIGF',ILENGT,ITYLCM)
         IF(ILENGT.EQ.NMIXT)
     +     CALL LCMGET(IPLIST,'NUSIGF',ZNUSIG(1,JGR))
         CALL LCMLEN(IPLIST,'NFTOT',ILENGT,ITYLCM)
         IF(ILENGT.EQ.NMIXT)
     +     CALL LCMGET(IPLIST,'NFTOT',ZSIGF(1,JGR))
         CALL LCMLEN(IPLIST,'CHI',ILENGT,ITYLCM)
         IF(ILENGT.EQ.NMIXT) CALL LCMGET(IPLIST,'CHI',CHI(1,JGR))
         CALL LCMLEN(IPLIST,'OVERV',ILENGT,ITYLCM)
         IF(ILENGT.EQ.NMIXT) CALL LCMGET(IPLIST,'OVERV',OVERV(1,JGR))
         CALL LCMLEN(IPLIST,'DIFFX',ILENGT,ITYLCM)
         IF(ILENGT.EQ.NMIXT) CALL LCMGET(IPLIST,'DIFFX',DIFFX(1,JGR))
         CALL LCMLEN(IPLIST,'DIFFY',ILENGT,ITYLCM)
         IF(ILENGT.EQ.NMIXT) CALL LCMGET(IPLIST,'DIFFY',DIFFY(1,JGR))
         CALL LCMLEN(IPLIST,'DIFFZ',ILENGT,ITYLCM)
         IF(ILENGT.EQ.NMIXT) CALL LCMGET(IPLIST,'DIFFZ',DIFFZ(1,JGR))
         CALL LCMLEN(IPLIST,'H-FACTORS',ILENGT,ITYLCM)
         IF(ILENGT.EQ.NMIXT) CALL LCMGET(IPLIST,'H-FACTORS',H(1,JGR))
         DO 30 IL=1,NL
         WRITE (CM,'(I2)') IL-1
         CALL LCMLEN(IPLIST,'SCAT'//CM,ILENGT,ITYLCM)
         IF(ILENGT.GT.NMIXT*NL*NGRP*NGRP) THEN
            CALL XABORT('GETMAC: INVALID INPUT MACROLIB(2).')
         ELSE IF(ILENGT.GT.0) THEN
            CALL LCMGET(IPLIST,'SCAT'//CM,WORK)
            CALL LCMGET(IPLIST,'NJJ'//CM,NJJ(1,IL,JGR))
            CALL LCMGET(IPLIST,'IJJ'//CM,IJJ(1,IL,JGR))
            IPOSDE=0
            DO 20 IBM=1,NMIXT
            IJJ0=IJJ(IBM,IL,JGR)
            DO 20 IGR=IJJ0,IJJ0-NJJ(IBM,IL,JGR)+1,-1
            IPOSDE=IPOSDE+1
   20       SCAT(IBM,IL,IGR,JGR)=WORK(IPOSDE)
         ENDIF
   30    CONTINUE
         CALL LCMSIX(IPLIST,' ',2)
   40    CONTINUE
*
      RETURN
      END
