*DECK INIAXL
      SUBROUTINE INIAXL(NGRP,NZ,NCH,NK,FLC,MESHZ,FLU,FLX)
C
C THIS SUBOUTINE COMPUTES COSINUS SHAPE AS THE INITIAL AXIAL FLUX
C SHAPE
C
C INPUTS -
C          NZ  : NUMBER OF NODES IN Z DIRECTION IN MAP
C          NCH : NUMBER OF CHANNELS
C          NK  : NUMBER OF BUNDLES PER CHANNEL
C          MESHZ : Z-MESHING SPACE IN MAP
C          FLC : TYPE OF INITIALIZATION
C OUTPUTS -
C          FLU : AXIAL SHAPE ON COSINUS IF FLC = 2
C                            As 1.0     IF FLC = 1
*
*-------------------------------------- AUTHOR: E. VARIN 19/09/95 ---
C
*
      IMPLICIT NONE
*
      INTEGER NGRP,NK,NCH,NZ,FLC
      REAL MESHZ(NZ+1),FLU(NCH,NK,NGRP),FLX(NZ),PI,ALF,SUM,Z
*
C LOCAL
      INTEGER I,J,IG
*
*     COMPUTES COSINUS SHAPE
*
      IF(NK.NE.NZ) CALL XABORT('INIAXL: ILLEGAL MAP GEOMETRY')
      SUM = 0.0
      IF( FLC.EQ.2 )THEN
        PI = 3.141592654
        ALF = PI / (MESHZ(NZ+1)-MESHZ(1))
        DO 10 I=1,NZ
          Z = MESHZ(I) + (MESHZ(I+1) - MESHZ(I))/2 -MESHZ(1)
          FLX(I) = COS(- PI/2 + ALF*Z)
          SUM = SUM + FLX(I)
 10     CONTINUE
        WRITE(6,*) 'COSINUS SHAPE AS INITIALIZATION',FLX
      ELSE
        DO 11 I=1,NZ
          FLX(I) = 1.0
          SUM = SUM + FLX(I)
 11     CONTINUE
        WRITE(6,*) 'CONSTANT SHAPE AS INITIALIZATION',FLX
      ENDIF
*
*     STORAGE
*
      DO 20 IG=1,NGRP
      DO 20 I=1,NCH
       DO 20 J=1,NK
         FLU(I,J,IG) = FLX(J)/SUM
  20  CONTINUE
*
      RETURN
      END
