*DECK INIDET
      SUBROUTINE INIDET(NENTRY,HENTRY,IENTRY,JENTRY,KENTRY)
*
**********************************************************************
*
*     THIS MODULE READS DETECTOR INFORMATION AND STORES THEM.
*
*     CE MODULE LIT LES DONNEES RELATIVES AUX DETECTEURS
*     ET LES STOCKE DANS L_DETECT
*
*     INPUT/OUTPUT PARAMETERS:
*      HMODUL : CHARACTER*12 NAME OF THE MODULE.
*      NENTRY : NUMBER OF LINKED LISTS AND FILES USED BY THE MODULE.
*      HENTRY : CHARACTER*12 NAME OF EACH LINKED LIST OR FILE.
*      IENTRY : =1 LINKED LIST; =2 XSM FILE; =3 SEQUENTIAL BINARY FILE;
*               =4 SEQUENTIAL ASCII FILE; =5 DIRECT ACCESS FILE.
*      JENTRY : =0 THE LINKED LIST OR FILE IS CREATED.
*               =1 THE LINKED LIST OR FILE IS OPEN FOR MODIFICATIONS;
*               =2 THE LINKED LIST OR FILE IS OPEN IN READ-ONLY MODE.
*      KENTRY : FILE UNIT NUMBER OR LINKED LIST ADDRESS.
*
*      DIMENSION HENTRY(NENTRY),IENTRY(NENTRY),JENTRY(NENTRY),
*      KENTRY(NENTRY)
*
*     LINKED LISTS REQUIRED ARE:
*        KENTRY(1)   : OBJECT TYPE L_DETECT IN CREATION OR IN MODIF.
*                     IF IN MODIFICATION MODE, ONLY ADDING A DETECTOR
*                     IS ALLOWED, NO UPDATE OF EXISTING ONE.
*
*     PROCEDURES CALLED:  READET
*
*-------------------------------------- AUTHORS: J. KOCLAS 94/09/30 ---
*                                                E. VARIN 96/02/10 ---
*
      IMPLICIT NONE
      INTEGER NENTRY
      CHARACTER HENTRY(*)*12
      INTEGER IENTRY,JENTRY,KENTRY
      DIMENSION IENTRY(*),JENTRY(*),KENTRY(*)
* SETARA VARIABLES
      REAL BASE
      INTEGER IBASE(1)
      COMMON BASE(1)
      EQUIVALENCE (BASE(1),IBASE(1))
*
      INTEGER      I,IPRT,IHEX,IREP,IFRACT,INVCST,ISPEC
      INTEGER      IPLDET
      LOGICAL      LHEX
* REDGET TYPES
      INTEGER ITYP,NITMA
      REAL FLOTT
      DOUBLE PRECISION DFLOTT
      CHARACTER*12 TEXT
*
* DETECTEUR STRUCTURE
*
      CHARACTER TYPE*12
      INTEGER INFO(2),NREP,NDETEC,NGRP,NDETOT,PARAM(2)
*
* SIGNATURE INFORMATION
*
      CHARACTER*12 SGNTUR
      INTEGER ISGNTR(3)
*
*     INPUT PARAMETER VALIDATION
*
      IF(NENTRY.LE.0) CALL XABORT('INIDET: PARAMETER EXPECTED.')
      IF((IENTRY(1).NE.1).AND.(IENTRY(1).NE.2)) CALL XABORT('INID'
     + //'ET: LINKED LIST OR XSM FILE EXPECTED AT LHS.')
      IF((JENTRY(1).NE.0).AND.(JENTRY(1).NE.1)) CALL XABORT('INID'
     + //'ET: CREATE OR MODIFICATION MODE EXPECTED.')
*
*     SIGNATURE VERIFICATION
*
      NDETOT = 0
      NGRP = 0
      IF (JENTRY(1).EQ.1) THEN
        CALL LCMSIX(KENTRY(1),' ',0)
        CALL LCMGET(KENTRY(1),'SIGNATURE',ISGNTR)
        WRITE(SGNTUR,'(3A4)') (ISGNTR(I),I=1,3)
        IF (SGNTUR.NE.'L_DETECT')
     +     CALL XABORT('INIDET: L_DETECT OBJECT IS EXPECTED')
        CALL LCMGET(IPLDET,'DET-PARAM',PARAM)
        NGRP = PARAM(1)
        NDETOT = PARAM(2)
      ENDIF
      IPLDET=KENTRY(1)
*
*     DATA INPUT READING
*
      IPRT = 1
      LHEX = .FALSE.
      IHEX = 0
 15   CALL REDGET(ITYP,NITMA,FLOTT,TEXT,DFLOTT)
      IF(ITYP.EQ.3) THEN
        IF (TEXT.EQ.'EDIT') THEN
         CALL REDGET(ITYP,IPRT,FLOTT,TEXT,DFLOTT)
         IF (ITYP.NE.1) CALL XABORT('INIDET: INTEGER DATA EXPECTED')
        ELSEIF (TEXT.EQ.'NGRP') THEN
         IF( NGRP.EQ.0 )THEN
           CALL REDGET(ITYP,NGRP,FLOTT,TEXT,DFLOTT)
           IF (ITYP.NE.1) CALL XABORT('INIDET: INTEGER DATA EXPECTED')
         ELSE
           WRITE(6,*) 'INIDET: ENERGY GROUP NUMBER IS ALREADY SET TO ',
     +                 NGRP
           CALL XABORT('INIDET: ENERGY GROUP NUMBER REQUIRED ONLY AT'
     +      //' CREATION OF L_DETECT OBJECT')
         ENDIF
        ELSEIF (TEXT.EQ.'HEXZ') THEN
           LHEX = .TRUE.
        ELSEIF (TEXT.EQ.'TYPE') THEN
           GOTO 18
        ELSE
           CALL XABORT('INIDET: INVALID KEYWORD '//TEXT)
        ENDIF
      ELSE
        CALL XABORT('INIDET: CHARACTER DATA EXPECTED')
      ENDIF
      GOTO 15
*
 10   CALL REDGET(ITYP,NITMA,FLOTT,TEXT,DFLOTT)
 18   IF(ITYP.EQ.3) THEN
        IF (TEXT.EQ.'TYPE') THEN
         CALL REDGET(ITYP,NITMA,FLOTT,TYPE,DFLOTT)
         IF (ITYP.NE.3) CALL XABORT('INIDET: CHARACTER DATA EXPECTED')
        ELSEIF (TEXT.EQ.';')  THEN
         GOTO 20
        ELSE
           CALL XABORT('INIDET: INVALID KEYWORD '//TEXT)
        ENDIF
      ELSE
        CALL XABORT('INIDET: CHARACTER DATA EXPECTED')
      ENDIF
*
*     READING INFORMATION LINKED TO SPECIFIC DETECTOR TYPE
      CALL REDGET(ITYP,NITMA,FLOTT,TEXT,DFLOTT)
       IF(ITYP.EQ.3) THEN
        IF (TEXT.EQ.'INFO') THEN
          CALL REDGET(ITYP,NDETEC,FLOTT,TEXT,DFLOTT)
          IF (ITYP.NE.1) CALL XABORT('INIDET: INTEGER DATA EXPECTED')
          CALL REDGET(ITYP,NREP,FLOTT,TEXT,DFLOTT)
          IF( ITYP.NE.1 )CALL XABORT('INIDET: INTEGER DATA EXPECTED')
          IF( NREP.LT.2 )CALL XABORT('INIDET: AT LEAST TWO RESPONSES')
        ELSE
          CALL XABORT('INIDET: CHARACTER INFO EXPECTED')
        ENDIF
      ELSE
        CALL XABORT('INIDET: CHARACTER DATA EXPECTED')
      ENDIF
*
*     SPECTRAL INFORMATION READING
      IF( NGRP.EQ.0 )CALL XABORT('INIDET: NUMBER OF GROUPS REQUIRED')
      CALL SETARA(BASE,NGRP,ISPEC)
      CALL REDGET(ITYP,NITMA,FLOTT,TEXT,DFLOTT)
       IF(ITYP.EQ.3) THEN
        IF (TEXT.EQ.'SPECTRAL') THEN
          DO 11 I=1,NGRP
           CALL REDGET(ITYP,NITMA,BASE(ISPEC+I-1),TEXT,DFLOTT)
           IF (ITYP.NE.2) CALL XABORT('INIDET: REAL DATA EXPECTED FOR '
     +       //'SPECTRAL')
  11      CONTINUE
        ELSEIF( TEXT.EQ.'DEFAULT' )THEN
          DO 12 I=1,NGRP-1
           BASE(ISPEC+I-1) = 0.0
  12      CONTINUE
          BASE(ISPEC+NGRP-1) = 1.0
          WRITE(6,*) '**** WARINING **** ENERGY SPECTRAL INITIALIZED '
     +       //'TO 1.0 IN THE HIGHEST GROUP ONLY '
        ELSE
          CALL XABORT('INIDET: KEYWORDS FOR SPECTRAL EXPECTED')
        ENDIF
      ELSE
        CALL XABORT('INIDET: CHARACTER DATA EXPECTED')
      ENDIF
*
*     DELAY CONSTANT AND RESPONSE FRACTION READING
*     FOR PLATIMUM DETECTOR
*     LECTURE DES CONSTANTES DE TEMPS ET DES FRACTIONS DE REPONSE
*     POUR LE MODELE DE DETECTEURS PLATINE
      IF( TYPE(1:5).EQ.'PLATN' )THEN
        IF( NREP.LE.2 )CALL XABORT('INIDET: PLATINUM RESPONSES MUST '
     +   //'EXCEED 2 VALUES, CHECK YOUR PLATINUM MODEL')
        CALL REDGET(ITYP,NITMA,FLOTT,TEXT,DFLOTT)
        IF(ITYP.EQ.3) THEN
         IF (TEXT.EQ.'INVCONST') THEN
           CALL SETARA(BASE,NREP-2,INVCST)
           DO 13 I=1,NREP-2
            CALL REDGET(ITYP,NITMA,BASE(INVCST+I-1),TEXT,DFLOTT)
            IF (ITYP.NE.2) CALL XABORT('INIDET: REAL DATA EXPECTED FOR '
     +       //'INVCONST')
  13       CONTINUE
           CALL LCMSIX(IPLDET,' ',0)
           CALL LCMSIX(IPLDET,TYPE,1)
           CALL LCMPUT(IPLDET,'INV-CONST',NREP-2,2,BASE(INVCST))
           CALL LCMSIX(IPLDET,' ',0)
           CALL RLSARA(BASE(INVCST))
         ELSE
           CALL XABORT('INIDET: KEYWORDS FOR SPECTRAL EXPECTED')
         ENDIF
        ELSE
         CALL XABORT('INIDET: CHARACTER DATA EXPECTED')
        ENDIF
        CALL REDGET(ITYP,NITMA,FLOTT,TEXT,DFLOTT)
        IF(ITYP.EQ.3) THEN
         IF( TEXT.EQ.'FRACTION' )THEN
           CALL SETARA(BASE,NREP-1,IFRACT)
           DO 14 I=1,NREP-1
            CALL REDGET(ITYP,NITMA,BASE(IFRACT+I-1),TEXT,DFLOTT)
            IF (ITYP.NE.2) CALL XABORT('INIDET: REAL DATA EXPECTED FOR '
     +       //'FRACTION')
  14       CONTINUE
           CALL LCMSIX(IPLDET,' ',0)
           CALL LCMSIX(IPLDET,TYPE,1)
           CALL LCMPUT(IPLDET,'FRACTION',NREP-1,2,BASE(IFRACT))
           CALL LCMSIX(IPLDET,' ',0)
           CALL RLSARA(BASE(IFRACT))
         ELSE
           CALL XABORT('INIDET: KEYWORDS FOR SPECTRAL EXPECTED')
         ENDIF
        ELSE
         CALL XABORT('INIDET: CHARACTER DATA EXPECTED')
        ENDIF
      ENDIF
*
*     READING AND STORAGE OF DETECTOR GENERAL INFORMATION
*
      CALL SETARA(BASE,NREP,IREP)
      DO 30 I=1,NDETEC
        CALL READET(IPLDET,TYPE,NREP,BASE(IREP),IPRT,LHEX)
  30  CONTINUE
      CALL RLSARA(BASE(IREP))
*
*     STORAGE OF INFO VECTOR
*
      CALL LCMSIX(IPLDET,' ',0)
      CALL LCMSIX(IPLDET,TYPE,1)
      IF (JENTRY(1).EQ.0) THEN
        INFO(1)=NDETEC
        INFO(2)=NREP
      ELSE
        CALL LCMGET(IPLDET,'INFORMATION',INFO)
        INFO(1) = INFO(1) + NDETEC
        IF (NREP.NE.INFO(2))
     +   CALL XABORT('INIDET: RESPONS NUMBER INCONSISTENT WITH '//
     +   ' THE PREVIOUS VALUE')
      ENDIF
      CALL LCMPUT(IPLDET,'INFORMATION',2,1,INFO)
      CALL LCMPUT(IPLDET,'SPECTRAL',NGRP,2,BASE(ISPEC))
      CALL LCMSIX(IPLDET,' ',0)
      NDETOT = NDETOT + NDETEC
      CALL RLSARA(BASE(ISPEC))
      GOTO 10
C
C SIGANTURE AND STATE VECTOR STORAGE
C
 20   IF (JENTRY(1).EQ.0) THEN
        SGNTUR='L_DETECT'
        READ(SGNTUR,'(3A4)') ISGNTR
        CALL LCMSIX(IPLDET,' ',0)
        CALL LCMPUT(IPLDET,'SIGNATURE',3,3,ISGNTR)
      ENDIF
      PARAM(1)=NGRP
      PARAM(2)=NDETOT
      CALL LCMPUT(IPLDET,'DET-PARAM',2,1,PARAM)
      CALL LCMPUT(IPLDET,'HEX',1,5,LHEX)
      IF(IPRT.GT.2) CALL LCMLIB(IPLDET)
*
      RETURN
      END
