*DECK INIDEV
      SUBROUTINE INIDEV(NENTRY,HENTRY,IENTRY,JENTRY,KENTRY)
*
************************************************************************
*
*     THIS SUBROUTINE READ INFORMATION FOR DEVICES AND STORE THEM.
*
*     CETTE SOUS ROUTINE LIT LES DONNEES RELATIVES AUX CONTROLEURS
*     DANS LE REACTEUR
*
*     INPUT/OUTPUT PARAMETERS:
*      HMODUL : CHARACTER*12 NAME OF THE MODULE.
*      NENTRY : NUMBER OF LINKED LISTS AND FILES USED BY THE MODULE.
*      HENTRY : CHARACTER*12 NAME OF EACH LINKED LIST OR FILE.
*      IENTRY : =1 LINKED LIST; =2 XSM FILE; =3 SEQUENTIAL BINARY FILE;
*               =4 SEQUENTIAL ASCII FILE; =5 DIRECT ACCESS FILE.
*      JENTRY : =0 THE LINKED LIST OR FILE IS CREATED.
*               =1 THE LINKED LIST OR FILE IS OPEN FOR MODIFICATIONS;
*               =2 THE LINKED LIST OR FILE IS OPEN IN READ-ONLY MODE.
*      KENTRY : FILE UNIT NUMBER OR LINKED LIST ADDRESS.
*
*      DIMENSION HENTRY(NENTRY),IENTRY(NENTRY),JENTRY(NENTRY),
*      KENTRY(NENTRY)
*
*     REQUIRED LINKED_LISTS ARE:
*        KENTRY(1)   : OBJECT TYPE L_DEVICE IN CREATION OR IN MODIF.
*        KENTRY(2-3) : OBJECT TYPE L_INDEX  IN MODIFICATION MODE
*                                  L_GEOM   IN READ-ONLY MODE
*
*     PROCEDURES CALLED:  READEV, CHCKDV
*
*-------------------------------------- AUTHOR: J. KOCLAS 94/04/10---
*                                       MODIFIED E. VARIN  95/02/06
      IMPLICIT NONE
*
      REAL BASE
      INTEGER IBASE(1)
      COMMON BASE(1)
      EQUIVALENCE (BASE(1),IBASE(1))
*
      INTEGER NENTRY
      CHARACTER HENTRY(*)*12
      INTEGER IENTRY,JENTRY,KENTRY
      DIMENSION IENTRY(*),JENTRY(*),KENTRY(*)
*
      INTEGER      I,I1,CPT,IPOS,TOT,IRC,NGEO,ISIZE(2),NGEOT
      INTEGER      IPLDEV,IPIND,IPGEO
C REDGET TYPES
      INTEGER ITYP,NITMA
      REAL FLOTT
      DOUBLE PRECISION DFLOTT
      CHARACTER*12 TEXT
C
C DEVICE STRUCTURE
C
      CHARACTER TYPE*12,FAMILY*12,SEQUEN*12
      CHARACTER MOVDIR*4
C
C SIGNATURE INFORMATION
C
      CHARACTER*12 SGNTUR
      INTEGER ISGNTR(3)
C
C    GEOM STRUCTURE
C
      INTEGER ILONG,ITYLM
      INTEGER NMIX,IMIX,IMIX2
      INTEGER ISTATE(13)
*
      INTEGER NDVICE,DELTA,NDESC,STATUS(2),IHEX
      LOGICAL LHEX,LMIX
*
*     INPUT PARAMETER VALIDATION
*
      IPIND = 0
      IPGEO = 0
      IF(NENTRY.LT.3) CALL XABORT('INIDEV: PARAMETER EXPECTED.')
      IF((IENTRY(1).NE.1).AND.(IENTRY(1).NE.2)) CALL XABORT('INID'
     + //'EV: LINKED LIST OR XSM FILE EXPECTED AT LHS.')
      IF((JENTRY(1).NE.0).AND.(JENTRY(1).NE.1)) CALL XABORT('INID'
     + //'EV: CREATE OR MODIFICATION MODE EXPECTED.')
*
      IF (JENTRY(1).EQ.1) THEN
        CALL LCMSIX(KENTRY(1),' ',0)
        CALL LCMGET(KENTRY(1),'SIGNATURE',ISGNTR)
        WRITE(SGNTUR,'(3A4)') (ISGNTR(I),I=1,3)
        IF (SGNTUR.NE.'L_DEVICE')
     +     CALL XABORT('INIDEV: L_DEVICE OBJECT IS EXPECTED')
      ENDIF
      IPLDEV=KENTRY(1)
*
      DO 5 I=2,NENTRY
        IF((IENTRY(I).EQ.1).OR.(IENTRY(I).EQ.2)) THEN
         CALL LCMSIX(KENTRY(I),' ',0)
         CALL LCMGET(KENTRY(I),'SIGNATURE',ISGNTR)
         WRITE(SGNTUR,'(3A4)') (ISGNTR(I1),I1=1,3)
         IF (SGNTUR.EQ.'L_INDEX') THEN
           IF (IPIND.EQ.0) IPIND=KENTRY(I)
           IF(JENTRY(I).NE.1) CALL XABORT('INID'
     +     //'EV: MODIFICATION MODE EXPECTED FOR OBJECT '//SGNTUR//'.')
         ELSEIF (SGNTUR.EQ.'L_GEOM') THEN
           IF (IPGEO.EQ.0) IPGEO=KENTRY(I)
           IF(JENTRY(I).NE.2) CALL XABORT('INIDEV: READ-ONL'
     +       //'Y MODE EXPECTED FOR OBJECT '//SGNTUR//'.')
         ENDIF
        ENDIF
  5   CONTINUE
      IF ((IPIND.EQ.0).OR.(IPGEO.EQ.0)) CALL XABORT('INIDEV: ILLEGAL'
     +     //' OR MISSING TYPE OF OBJECTS')
*
*    DATA INPUT FOR DEVICE
*
      LHEX = .FALSE.
      LMIX = .FALSE.
      DELTA = 0
      TOT   = 0
 10   CALL REDGET(ITYP,NITMA,FLOTT,TEXT,DFLOTT)
      IF (ITYP.EQ.3) THEN
        IF (TEXT.EQ.'NDESC') THEN
           IF(DELTA.EQ.0) CALL XABORT('INIDEV: DELTA OR NODEL'
     +        //' KEYWORD NEEDED')
           CALL REDGET(ITYP,NITMA,FLOTT,TEXT,DFLOTT)
           IF(ITYP.NE.1) THEN
             CALL XABORT('INIDEV: INTEGER DATA EXPECTED')
           ELSE
            NDESC=NITMA
            WRITE(6,*) 'NDESC ',NDESC
            CALL LCMGET(IPGEO,'STATE',ISTATE)
            IF(.NOT.LHEX) THEN
C
C           MEMORY ALLOCATION FOR INDEX VECTOR
C
              IF(ISTATE(11).EQ.1) CALL XABORT('INIDEV: INVALID DEVICE'
     +               //' DEFINITION FOR GEOMETRY NOT SPLIT')
              IF (JENTRY(1).EQ.0) THEN
                 NGEO = ISTATE(6)
              ELSE
                 CALL LCMLEN(IPIND,'MIX',ILONG,ITYLM)
                 NGEO = ILONG
              ENDIF
              NGEOT = NGEO + NDESC*DELTA
              CALL LCMGET(IPIND,'SIZE',ISIZE)
              NMIX = ISIZE(2)
              CALL SETARA(IBASE,NGEOT,IMIX)
              CALL LCMLEN(IPIND,'MIX',ILONG,ITYLM)
              CALL SETARA(IBASE,ILONG,IMIX2)
              CALL LCMGET(IPIND,'MIX',IBASE(IMIX2))
              CPT = 0
              DO 100 I=1,ILONG
                CPT = CPT + 1
                IBASE(IMIX+CPT-1) = IBASE(IMIX2+I-1)
 100          CONTINUE
              IF (CPT.LT.ISTATE(6)) CALL XABORT('INIDEV: L_INDEX'
     +         //' AND L_GEOM INCOMPATIBLE ')
              CALL RLSARA(IBASE(IMIX2))
            ELSE
              WRITE(6,*) ' DEVICE IN HEXAGONAL 3-D GEOMETRY '
              IF(ISTATE(1).NE.9) CALL XABORT('INIDEV: INVALID DEVICE'
     +               //' HEXAGONAL IN GEOMETRY NOT HEXAGONAL 3-D')
              IF(ISTATE(11).EQ.1) CALL XABORT('INIDEV: INVALID DEVICE'
     +               //' HEXAGONAL IN GEOMETRY NOT SPLITTED')
              CALL LCMGET(IPGEO,'IHEX',IHEX)
              IF(IHEX.NE.9) WRITE(6,*) ('INIDEV: WARNING** GEOMETRY '
     +          //'HEXAGONAL 3-D NOT COMPLETE, CHECK FOR CONSISTENCY')
* NGEO GREATER THAN LX
              NGEO = ISTATE(3)
              CALL SETARA(IBASE,NGEO,IMIX)
              CALL LCMGET(IPIND,'SIZE',ISIZE)
              NMIX = ISIZE(2)
            ENDIF
           ENDIF
           IF (NDVICE.EQ.0) CALL XABORT('INIDEV: INVALID'
     +     //' NUMBER OF DEVICES')
        ELSEIF (TEXT.EQ.'NDEV') THEN
           CALL REDGET(ITYP,NITMA,FLOTT,TEXT,DFLOTT)
           IF(ITYP.NE.1) THEN
             CALL XABORT('INIDEV: INTEGER DATA EXPECTED')
           ELSE
            NDVICE=NITMA
            WRITE(6,*) 'NUMBER OF DEVICE ',NDVICE
           ENDIF
        ELSEIF (TEXT.EQ.'HEXZ') THEN
            LHEX = .TRUE.
            IF(JENTRY(1).NE.0) CALL XABORT('INIDEV: NO DEVICE '
     +        //'MODIFICATION ALLOWED IN HEXAGONAL 3-D GEOMETRY')
        ELSEIF (TEXT.EQ.'MIXM') THEN
            LMIX = .TRUE.
            IF(JENTRY(1).NE.1) CALL XABORT('INIDEV: NO DEVICE '
     +        //'CREATION ALLOWED FOR MIXTURE MODIFICATION')
        ELSEIF (TEXT.EQ.'DELTA') THEN
            DELTA = 2
        ELSEIF (TEXT.EQ.'NODEL') THEN
            DELTA = 1
        ELSEIF (TEXT.EQ.'DEVICE') THEN
            CPT   = 0
            CALL READEV(IPLDEV,TYPE,FAMILY,SEQUEN,MOVDIR,
     +            DELTA,NGEO,NMIX,IBASE(IMIX),CPT,TOT,LHEX,LMIX)
            CALL SETARA(BASE,CPT*6,IPOS)
            CALL CHCKDV(IPLDEV,TYPE,FAMILY,SEQUEN,BASE(IPOS),
     +              MOVDIR,CPT,IRC)
            IF( LMIX ) IRC = 0
            IF (IRC.EQ.1) THEN
             CALL XABORT('INIDEV: WRONG X OR Z POSITIONS IN DEVICE '
     +         //SEQUEN)
            ELSE IF (IRC.EQ.2) THEN
             CALL XABORT('INIDEV: Y- GREATER THEN Y+ IN DEVICE '
     +         //SEQUEN)
            ELSE IF (IRC.EQ.3) THEN
             CALL XABORT('INIDEV: WRONG Y POSITIONS IN DEVICE '
     +         //'IN LOOP '//SEQUEN)
            ELSE IF (IRC.EQ.4) THEN
             CALL XABORT('INIDEV: WRONG Y POSITIONS IN DEVICE '
     +         //'VS MAXPOS '//SEQUEN)
            ENDIF
            CALL RLSARA(BASE(IPOS))
            TOT = TOT + CPT
        ELSEIF (TEXT.EQ.';') THEN
            GOTO 20
        ELSE
         CALL XABORT('INIDEV: INVALID KEYWORD'//TEXT)
        ENDIF
      ELSE
        CALL XABORT('INIDEV: CHARACTER DATA EXPECTED')
      ENDIF
      GOTO 10
*
 20   IF (TOT.LT.NDESC) THEN
        CALL XABORT('INIDEV: WRONG NUMBER OF DEVICES OR DESCRIPTIONS')
      ENDIF
*
*     INFROMATION STORAGE
*
      CALL LCMSIX(IPLDEV,' ',0)
      IF (JENTRY(1).EQ.0) THEN
       STATUS(1) = NDVICE
       STATUS(2) = NDESC
       CALL LCMPUT(IPLDEV,'STATUS',2,1,STATUS)
      ELSE
       CALL LCMGET(IPLDEV,'STATUS',STATUS)
       IF( LMIX )THEN
*         IF( STATUS(1).NE.NDVICE )CALL XABORT('WRONG NUMBER OF DEVICES'
*         IF( STATUS(2).NE.NDESC )CALL XABORT('WRONG NUMBER OF DESCRIP')
       ELSE
         STATUS(1) = STATUS(1) + NDVICE
         STATUS(2) = STATUS(2) + NDESC
         CALL LCMPUT(IPLDEV,'STATUS',2,1,STATUS)
       ENDIF
      ENDIF
      CALL LCMPUT(IPLDEV,'HEX',1,5,LHEX)
C
C  SIGNATURE WRITING
C
      SGNTUR='L_DEVICE'
      READ(SGNTUR,'(3A4)') ISGNTR
      CALL LCMPUT(IPLDEV,'SIGNATURE',3,3,ISGNTR)
      CALL LCMSIX(IPLDEV,' ',0)
*
*     STORAGE NEW MIXTURE INDICE IN INDEX
*
      CALL LCMSIX(IPIND,' ',0)
      IF (LHEX) THEN
         ISIZE(2) = NMIX + NDESC
      ELSE
         ISIZE(2) = NMIX + NDESC*DELTA
         CALL LCMPUT(IPIND,'MIX',NGEOT,1,IBASE(IMIX))
      ENDIF
      CALL LCMPUT(IPIND,'SIZE',2,1,ISIZE)
      CALL LCMSIX(IPIND,' ',0)
      CALL RLSARA(IBASE(IMIX))
*
      RETURN
      END
