*DECK INIMAC
      SUBROUTINE INIMAC(NENTRY,HENTRY,IENTRY,JENTRY,KENTRY)
*
**********************************************************************
*
*     THIS MODULE CONSTRUCTS A NEW MACROLIB FROM A PREVIOUS ONE AND
*     THE INDEX REFERENCE. IT WILL CONTAIN ONE MIXTURE PER MATERIAL
*     REGION.
*
*     CE MODULE CONSTRUIT UNE NOUVELLE MACROLIB A PARTIR DE
*     L'ANCIENNE ET DE L'INDEX. ELLE CONTIENDRA UN MELANGE
*     PAR REGION MATERIELLE.
*
*     INPUT/OUTPUT PARAMETERS:
*      HMODUL : CHARACTER*12 NAME OF THE MODULE.
*      NENTRY : NUMBER OF LINKED LISTS AND FILES USED BY THE MODULE.
*      HENTRY : CHARACTER*12 NAME OF EACH LINKED LIST OR FILE.
*      IENTRY : =1 LINKED LIST; =2 XSM FILE; =3 SEQUENTIAL BINARY FILE;
*               =4 SEQUENTIAL ASCII FILE; =5 DIRECT ACCESS FILE.
*      JENTRY : =0 THE LINKED LIST OR FILE IS CREATED.
*               =1 THE LINKED LIST OR FILE IS OPEN FOR MODIFICATIONS;
*               =2 THE LINKED LIST OR FILE IS OPEN IN READ-ONLY MODE.
*      KENTRY : FILE UNIT NUMBER OR LINKED LIST ADDRESS.
*
*      DIMENSION HENTRY(NENTRY),IENTRY(NENTRY),JENTRY(NENTRY),
*      KENTRY(NENTRY)
*
*     LINKED LIST REQUIRED ARE:
*        KENTRY(1)   : OBJECT TYPE L_MACROLIB IN CREATION MODE
*        KENTRY(2-4) : OBJECT TYPE L_INDEX IN READ-ONLY MODE
*                                  L_MACROLIB IN READ-ONLY MODE
*                                  L_MACROLIB IN READ-ONLY MODE
*
*     PROCEDURES CALLED:  NEOMAC
*
*-------------------------------------- AUTHOR: J. KOCLAS 94/04/10 ---
*                                     MODIFIED: E. VARIN 95/09/10 ---
*
*      IMPLICIT NONE
*
      REAL BASE
      INTEGER IBASE(1)
      COMMON BASE(1)
      EQUIVALENCE (BASE(1),IBASE(1))
*
      INTEGER NENTRY
      CHARACTER HENTRY(*)*12,TEXT*4
      INTEGER IENTRY,JENTRY,KENTRY
      DIMENSION IENTRY(*),JENTRY(*),KENTRY(*)
*
      INTEGER      IPMAC2,IPIND,IPMAC,IPMRES,I,ISIZE(2),NIND
C
C SIGNATURE INFORMATION
C
      CHARACTER*12 SGNTUR,SGNTUR1
      INTEGER ISGNTR(3)
C
C     MACROLIB ET GEOM STRUCTURE
C
      INTEGER ILONG,ITYLM
      INTEGER NGRP,NMXOLD,NL,NMIX,IMIX,IENERG
      INTEGER IDATXS(7)
      LOGICAL PRES
*
*     INPUT PARAMETER VALIDATION
*
      IPMRES = 0
      IPMAC = 0
      IPIND = 0
      IF(NENTRY.LT.3) CALL XABORT('INIMAC: PARAMETER EXPECTED.')
      IF((IENTRY(1).NE.1).AND.(IENTRY(1).NE.2)) CALL XABORT('INIM'
     + //'AC: LINKED LIST OR XSM FILE EXPECTED AT LHS.')
      IF (JENTRY(1).NE.0) CALL XABORT('INIM'
     + //'AC: CREATE EXPECTED FOR OBJECT L_MACROLIB.')
*
      IPMAC2=KENTRY(1)
*
      DO 10 I=2,NENTRY
       IF((IENTRY(I).EQ.1).OR.(IENTRY(I).EQ.2)) THEN
        CALL LCMSIX(KENTRY(I),' ',0)
        CALL LCMGET(KENTRY(I),'SIGNATURE',ISGNTR)
        WRITE(SGNTUR,'(3A4)') (ISGNTR(I1),I1=1,3)
        IF (SGNTUR.EQ.'L_MACROLIB') THEN
           IF (IPMAC.EQ.0) IPMAC=KENTRY(I)
           IF (IPMRES.EQ.0) THEN
            IF((IENTRY(I+1).EQ.1).OR.(IENTRY(I+1).EQ.2)) THEN
             CALL LCMSIX(KENTRY(I+1),' ',0)
             CALL LCMGET(KENTRY(I+1),'SIGNATURE',ISGNTR)
             WRITE(SGNTUR1,'(3A4)') (ISGNTR(I1),I1=1,3)
             IF (SGNTUR1.EQ.'L_MACROLIB') THEN
              IPMRES=KENTRY(I+1)
             ENDIF
            ENDIF
           ENDIF
           IF(JENTRY(I).NE.2) CALL XABORT('INIMAC: READ-ONL'
     +       //'Y MODE EXPECTED FOR OBJECT'//SGNTUR//'.')
        ELSEIF (SGNTUR.EQ.'L_INDEX') THEN
           IPIND =KENTRY(I)
           IF(JENTRY(I).NE.2) CALL XABORT('INIMAC: READ-ONL'
     +      //'Y MODE EXPECTED FOR OBJECT'//SGNTUR//'.')
        ENDIF
       ENDIF
  10  CONTINUE
      IF ((IPIND.EQ.0).OR.(IPMAC.EQ.0)) CALL XABORT('INIMAC: ILLEGAL'
     +     //' OR MISSING TYPE OF OBJECTS')
      IF (IPMRES.NE.0) THEN
        CALL LCMSIX(IPMRES,' ',0)
        CALL LCMGET(IPMRES,'SIGNATURE',ISGNTR)
        WRITE(SGNTUR,'(3A4)') (ISGNTR(I1),I1=1,3)
        IF (SGNTUR.NE.'L_MACROLIB')
     +    CALL XABORT('INIMAC: THE TWO MACROLIB MUST BE FOLLOWED')
      ENDIF
*
*     NEW MACROLIB CREATION
*
      CALL LCMSIX(IPIND,' ',0)
      CALL LCMGET(IPIND,'SIZE',ISIZE)
      NMIX = ISIZE(2)
      CALL LCMLEN(IPIND,'MIX',ILONG,ITYLM)
      IF (ITYLM.EQ.1) THEN
         NIND = ILONG
      ELSE
         CALL XABORT('INIMAC: WRONG TYPE OF DATA IN INDEX')
      ENDIF
      CALL SETARA(IBASE,NIND,IMIX)
      CALL LCMGET(IPIND,'MIX',BASE(IMIX))
*
      CALL LCMGET(IPMAC,'IDATAXS',IDATXS)
      NGRP   = IDATXS(1)
      NMXOLD = IDATXS(2)
      NL     = IDATXS(3)
*
      PRES = .FALSE.
      CALL NEOMAC(IPMAC,IPMAC2,NL,NGRP,NMXOLD,NMIX,NIND,
     +        IBASE(IMIX),PRES)
      CALL LCMSIX(IPMAC2,' ',0)
      CALL LCMSIX(IPMAC,' ',0)
*
      IF (IPMRES.NE.0) THEN
       CALL LCMGET(IPMRES,'IDATAXS',IDATXS)
       IF((NGRP.NE.IDATXS(1)).OR.(NL.NE.IDATXS(3)))
     +    CALL XABORT('INIMAC: ILLEGAL MACROLIB')
       NMXRES = IDATXS(2)
       IF (NMXRES.LE.NMXOLD)
     +    CALL XABORT('INIMAC: SECOND MACROLIB MUST BE MAP MACROLIB')
*
       PRES = .TRUE.
       CALL NEOMAC(IPMRES,IPMAC2,NL,NGRP,NMXRES,NMIX,NIND,
     +        IBASE(IMIX),PRES)
       CALL LCMSIX(IPMRES,' ',0)
      ENDIF
*
      CALL LCMSIX(IPMAC2,' ',0)
      CALL LCMSIX(IPMAC,' ',0)
      IDATXS(2)=NMIX
      CALL LCMPUT(IPMAC2,'IDATAXS',7,1,IDATXS)
*
      CALL LCMLEN(IPMAC,'ENERGY',ILONG,ITYLM)
      IF (ILONG.EQ.(NGRP+1)) THEN
        CALL SETARA(BASE,ILONG,IENERG)
        CALL LCMGET(IPMAC,'ENERGY',BASE(IENERG))
        CALL LCMPUT(IPMAC2,'ENERGY',ILONG,2,BASE(IENERG))
        CALL RLSARA(BASE(IENERG))
      ENDIF
*
      SGNTUR='L_MACROLIB'
      READ(SGNTUR,'(3A4)') (ISGNTR(I),I=1,3)
      CALL LCMPUT(IPMAC2,'SIGNATURE',3,3,ISGNTR)
      CALL RLSARA(IBASE(IMIX))
      CALL LCMSIX(IPMAC,' ',0)
      CALL LCMSIX(IPMAC2,' ',0)
      CALL LCMLIB(IPMAC2)
C
C READ THE ";" TO FINISH INIMAC
C
      CALL REDGET(ITYP,NITMA,FLOTT,TEXT,DFLOTT)
      IF (ITYP.EQ.10) GOTO 20
      IF (ITYP.NE.3) THEN
        CALL XABORT('INIMAC: CHARACTER DATA EXPECTED')
      ELSE IF(TEXT.NE.';') THEN
        CALL XABORT('INIMAC: ; EXPECTED TO END MODULE')
      ENDIF
*
 20   RETURN
      END
