*DECK INIRES
      SUBROUTINE INIRES(NENTRY,HENTRY,IENTRY,JENTRY,KENTRY)
*
*-----------------------------------------------------------------------
*
*     THIS MODULE CONSTRUCTS FUEL MAP OBJECT.
*
*     INPUT/OUTPUT PARAMETERS:
*      NENTRY : NUMBER OF LINKED LISTS OR FILES USED BY THE MODULE.
*      HENTRY : CHARACTER*12 NAME OF EACH LINKED LIST OR FILE.
*      IENTRY : =1 LINKED LIST; =2 XSM FILE; =3 SEQUENTIAL BINARY FILE;
*               =4 SEQUENTIAL ASCII FILE.
*      JENTRY : =0 THE LINKED LIST OR FILE IS CREATED.
*               =1 THE LINKED LIST OR FILE IS OPEN FOR MODIFICATIONS;
*               =2 THE LINKED LIST OR FILE IS OPEN IN READ-ONLY MODE.
*      KENTRY : =FILE UNIT NUMBER; =LINKED LIST ADDRESS OTHERWISE.
*
*      DIMENSION HENTRY(NENTRY),IENTRY(NENTRY),JENTRY(NENTRY),
*                KENTRY(NENTRY)
*
*     REQUIRED LINKED LISTS:
*        KENTRY(1) : OBJECT TYPE L_MAP IN CREATION OR IN MODIFICATION MO
*        KENTRY(2) : OBJECT TYPE L_GEOM IN READ-ONLY MODE.
*
*     PROCEDURE CALLED:   GEOD
*
*-------------------------------------- AUTHOR: E. VARIN ; 25/08/95 ---
*
*      IMPLICIT NONE
      CHARACTER HENTRY(*)*12,HENT(1)*12,TEXT12*12,HSIGN*12,GDOOR*6,
     +          TEXT4*4
      DIMENSION IENTRY(*),JENTRY(*),KENTRY(*),IENT(1),JENT(1),
     +          KENT(1)
      DOUBLE PRECISION DFLOTT
      REAL     FLOTT
      INTEGER  IPRES,ITYP,NX,NY,KCHAR(3),NITMA,NK,NCH,NZC,
     +         ILONG,NENTRY,NENT,ISTATE(13),I,INAM,INAM1,I1,INDIC,
     +         GEOTYP,RDATA(6),IMOD,IPOW,NGRP
      LOGICAL  REC
      DIMENSION IBASE(1)
      COMMON BASE(1)
      EQUIVALENCE (BASE(1),IBASE(1))
*
* PARAMETER VALIDATION.
*
      IF(NENTRY.LT.1) CALL XABORT('INIRES: PARAMETER EXPECTED.')
      IF((IENTRY(1).NE.1).AND.(IENTRY(1).NE.2)) CALL XABORT('INIR'
     + //'ES: LINKED LIST OR XSM FILE EXPECTED AT LHS.')
      IF((JENTRY(1).NE.0).AND.(JENTRY(1).NE.1)) CALL XABORT('INIR'
     + //'ES: CREATE OR MODIFICATION MODE EXPECTED.')
*
*     VERIFICATION OF THE OBJECT TYPES WITH SIGNATURE
*
      IF(JENTRY(1).EQ.1) THEN
       CALL LCMSIX(KENTRY(1),' ',0)
       CALL LCMGET(KENTRY(1),'SIGNATURE',KCHAR)
       WRITE(HSIGN,'(3A4)') (KCHAR(I1),I1=1,3)
       TEXT12=HENTRY(1)
       IF (HSIGN.NE.'L_MAP') CALL XABORT('INIRES:'
     +  //'SIGNATURE OF '//TEXT12//' IS '//HSIGN//'. '
     +  //'L_MAP EXPECTED.')
        CALL LCMGET(KENTRY(1),'RES-DATA',RDATA)
        NK = RDATA(1)
        NCH = RDATA(2)
        NZC = RDATA(3)
        IMOD = RDATA(5)
        REC = .TRUE.
      ELSE
       HSIGN='L_MAP'
       READ(HSIGN,'(3A4)') (KCHAR(I1),I1=1,3)
       CALL LCMPUT(KENTRY(1),'SIGNATURE',3,3,KCHAR)
       NZC= 0
       NK = 0
       NCH = 0
       IMOD = 0
       NGRP = 0
       REC = .FALSE.
      ENDIF
      IPRES = KENTRY(1)
*
*     OPTION READING
*
 10   CALL REDGET(INDIC,NITMA,FLOTT,TEXT12,DFLOTT)
      IF(INDIC.NE.3) CALL XABORT('INIRES: CHARACTER DATA EXPECTED(1).')
      IF(TEXT12.EQ.'NBUND') THEN
         IF(REC) CALL XABORT('INIRES: NUMBER OF BUNDLES CAN NOT BE'
     +           //' MODIFIED')
         CALL REDGET(INDIC,NK,FLOTT,TEXT12,DFLOTT)
         IF(INDIC.NE.1) CALL XABORT('INIRES: INTEGER DATA EXPECTED(2).')
         IF(NK.LE.0) CALL XABORT('INIRES: POSITIVE AND NON ZERO VALUE'
     +       //' EXPECTED FOR NBUND')
      ELSE IF(TEXT12.EQ.'NCHAN') THEN
         IF(REC) CALL XABORT('INIRES: NUMBER OF CHANNELS CAN NOT BE'
     +           //' MODIFIED')
         CALL REDGET(INDIC,NCH,FLOTT,TEXT12,DFLOTT)
         IF(INDIC.NE.1) CALL XABORT('INIRES: INTEGER DATA EXPECTED(3).')
         IF(NCH.LE.0) CALL XABORT('INIRES: POSITIVE AND NON ZERO VALUE'
     +       //' EXPECTED FOR NCHAN')
      ELSE IF(TEXT12.EQ.'NZONE') THEN
         IF(REC) CALL XABORT('INIRES: NUMBER OF ZONES CAN NOT BE'
     +           //' MODIFIED')
         CALL REDGET(INDIC,NZC,FLOTT,TEXT12,DFLOTT)
         IF(INDIC.NE.1) CALL XABORT('INIRES: INTEGER DATA EXPECTED(4).')
         IF(NZC.LE.0) CALL XABORT('INIRES: POSITIVE AND NON ZERO VALUE'
     +       //' EXPECTED FOR NZONE')
      ELSE IF(TEXT12.EQ.'IMOD') THEN
         CALL REDGET(INDIC,IMOD,FLOTT,TEXT12,DFLOTT)
         IF(INDIC.NE.1) CALL XABORT('INIRES: INTEGER DATA EXPECTED(4).')
         IF(IMOD.LE.0 .OR. IMOD.GT.5 ) CALL XABORT('INIRES: INVALID'
     +       //'VALUE FOR IMOD, BETWEEN 1 AND 5')
      ELSE IF(TEXT12.EQ.'NGRP') THEN
         CALL REDGET(INDIC,NGRP,FLOTT,TEXT12,DFLOTT)
         IF(INDIC.NE.1) CALL XABORT('INIRES: INTEGER DATA EXPECTED(4).')
         IF(NGRP.LE.0) CALL XABORT('INIRES: INVALID'
     +       //'VALUE FOR NGRP POSITIVE VALUE')
      ELSE IF(TEXT12.EQ.':::') THEN
         CALL REDGET(INDIC,NITMA,FLOTT,GDOOR,DFLOTT)
         IF(INDIC.NE.3) CALL XABORT('INIRES: CHARACTER DATA '
     +                    //'EXPECTED(1).')
         IF (GDOOR.EQ.'GEOD:') THEN
*
*     PARAMETER CONSTRUCTION FOR GEOD CALL
*
          CALL LCMLEN(IPRES,'GEO:RES',ILONG,ITYP)
          IF(ILONG.EQ.0) THEN
           JENT(1)=0
          ELSE IF(ITYP.NE.0) THEN
           CALL XABORT('INIRES: INVALID RECORD GEO:RES.')
          ELSE
           JENT(1)=1
          ENDIF
          CALL LCMSIX(IPRES,'GEO:RES',1)
          HENT(1)='GEO:RES'
          IENT(1)=IENTRY(1)
          NENT=1
          KENT(1) = IPRES
          CALL GEOD(NENT,HENT,IENT,JENT,KENT)
          CALL LCMLIB(IPRES)
          CALL LCMGET(IPRES,'STATE',ISTATE)
          GEOTYP = ISTATE(1)
          IF (GEOTYP.EQ.7) THEN
           NX = ISTATE(3)
           NY = ISTATE(4)
          ELSEIF( GEOTYP.EQ.9 )THEN
           NX = ISTATE(3)
          ELSE
            CALL XABORT('INIRES: ONLY CARTESIAN/HEXAGONAL'
     +              //' 3-D SUPPORTED')
          ENDIF
          CALL LCMSIX(IPRES,' ',0)
         ELSE
          CALL XABORT('INIRES: INVALID EMBEDDED MODULE.')
         ENDIF
      ELSE IF(TEXT12.EQ.'NXNAME') THEN
*
*      LENGTH RECOVERY IN GEO:RES DIRECTORY
*
         CALL LCMLEN(IPRES,'GEO:RES',ILONG,ITYP)
         IF(ILONG.EQ.0) THEN
           CALL XABORT('INIRES: GEOMETRY INFORMATIONS ARE REQUIRED')
         ENDIF
         IF( GEOTYP.EQ.9 )CALL XABORT('INIRES: NO X-NAME FOR HEX-3D')
         CALL SETARA(IBASE,NX,INAM1)
         DO 11 I=1,NX
          CALL REDGET(INDIC,NITMA,FLOTT,TEXT4,DFLOTT)
          IF(INDIC.NE.3) CALL XABORT('INIRES: CHARACTER DATA '
     +                    //'EXPECTED(2).')
           READ(TEXT4,'(A4)') IBASE(INAM1+I-1)
 11      CONTINUE
         CALL LCMPUT(IPRES,'XNAME',NX,3,IBASE(INAM1))
         CALL RLSARA(IBASE(INAM1))
      ELSE IF(TEXT12.EQ.'NYNAME') THEN
*
*      LENGTH RECOVERY IN GEO:RES DIRECTORY
*
         CALL LCMLEN(IPRES,'GEO:RES',ILONG,ITYP)
         IF(ILONG.EQ.0) THEN
             CALL XABORT('INIRES: GEOMETRY INFORMATIONS ARE REQUIRED')
         ENDIF
         IF( GEOTYP.EQ.9 )CALL XABORT('INIRES: NO Y-NAME FOR HEX-3D')
         CALL SETARA(IBASE,NY,INAM1)
         DO 12 I=1,NY
          CALL REDGET(INDIC,NITMA,FLOTT,TEXT4,DFLOTT)
          IF(INDIC.NE.3) CALL XABORT('INIRES: CHARACTER DATA '
     +                    //'EXPECTED(2).')
          READ(TEXT4,'(A4)') IBASE(INAM1+I-1)
 12      CONTINUE
         CALL LCMPUT(IPRES,'YNAME',NY,3,IBASE(INAM1))
         CALL RLSARA(IBASE(INAM1))
      ELSE IF(TEXT12.EQ.'ZONE') THEN
*
         MAXZC = 0
         IF(NCH.EQ.0)  CALL XABORT('INIRES: NUMBER OF'
     +         //' CHANNELS MUST BE SPECIFIED')
         CALL SETARA(IBASE,NCH,INAM)
         DO 13 I=1,NCH
            CALL REDGET(INDIC,IBASE(INAM+I-1),FLOTT,TEXT12,DFLOTT)
            IF(INDIC.NE.1) CALL XABORT('INIRES: INTEGER DATA '
     +                    //'EXPECTED(2).')
            MAXZC = MAX(MAXZC,IBASE(INAM+I-1))
 13      CONTINUE
         IF (MAXZC.NE.NZC)
     +     CALL XABORT('INIRES: WRONG NUMBER OF ZONES')
         CALL LCMPUT(IPRES,'ZONE',NCH,1,IBASE(INAM))
         CALL RLSARA(IBASE(INAM))
      ELSE IF(TEXT12.EQ.'BURN-ZC') THEN
         IF (NZC.EQ.0) CALL XABORT('INIRES: ZONE NUMBER NOT SPECIFIED')
         CALL SETARA(BASE,NZC,INAM)
         DO 15 I=1,NZC
            CALL REDGET(INDIC,NITMA,BASE(INAM+I-1),TEXT12,DFLOTT)
            IF(INDIC.NE.2) CALL XABORT('INIRES: REAL DATA '
     +                    //'EXPECTED(2).')
 15      CONTINUE
         CALL LCMPUT(IPRES,'BURN-ZONE',NZC,2,BASE(INAM))
         CALL RLSARA(IBASE(INAM))
         IF(.NOT.REC) IMOD = 1
      ELSE IF(TEXT12.EQ.'BURN-FUEL') THEN
         IF (NCH*NK.EQ.0)
     +     CALL XABORT('INIRES: NCH NK NUMBER NOT SPECIFIED')
         CALL SETARA(BASE,NCH*NK,INAM)
         DO 16 I=1,NCH*NK
            CALL REDGET(INDIC,NITMA,BASE(INAM+I-1),TEXT12,DFLOTT)
            IF(INDIC.NE.2) CALL XABORT('INIRES: REAL DATA '
     +                    //'EXPECTED(2).')
 16      CONTINUE
         CALL LCMPUT(IPRES,'BURN-DEB',NCH*NK,2,BASE(INAM))
         CALL RLSARA(BASE(INAM))
         IMOD = 4
      ELSE IF(TEXT12.EQ.'BUNDLE-PW') THEN
         IF (NCH*NK.EQ.0)
     +     CALL XABORT('INIRES: NCH NK NUMBER NOT SPECIFIED')
         CALL SETARA(BASE,NCH*NK,IPOW)
         DO 17 I=1,NCH*NK
            CALL REDGET(INDIC,NITMA,BASE(IPOW+I-1),TEXT12,DFLOTT)
            IF(INDIC.NE.2) CALL XABORT('INIRES: REAL DATA '
     +                    //'EXPECTED(2).')
 17      CONTINUE
         CALL LCMPUT(IPRES,'POWER-BUN',NCH*NK,2,BASE(IPOW))
         CALL RLSARA(BASE(IPOW))
         IMOD = 3
      ELSE IF(TEXT12.EQ.'CPPF-ZONE') THEN
*
         IF(NCH.EQ.0)  CALL XABORT('INIRES: NUMBER OF'
     +         //' CHANNELS MUST BE SPECIFIED')
         CALL SETARA(IBASE,NCH,INAM)
         DO 18 I=1,NCH
            CALL REDGET(INDIC,IBASE(INAM+I-1),FLOTT,TEXT12,DFLOTT)
            IF(INDIC.NE.1) CALL XABORT('INIRES: INTEGER DATA '
     +                    //'EXPECTED(2).')
 18      CONTINUE
         CALL LCMPUT(IPRES,'CPPF-ZONE',NCH,1,IBASE(INAM))
         CALL RLSARA(IBASE(INAM))
      ELSE IF(TEXT12.EQ.'CONTR-ZONE') THEN
*
         IF(NCH.EQ.0)  CALL XABORT('INIRES: NUMBER OF'
     +         //' CHANNELS MUST BE SPECIFIED')
         CALL SETARA(IBASE,NCH,INAM)
         DO 19 I=1,NCH
            CALL REDGET(INDIC,IBASE(INAM+I-1),FLOTT,TEXT12,DFLOTT)
            IF(INDIC.NE.1) CALL XABORT('INIRES: INTEGER DATA '
     +                    //'EXPECTED(2).')
 19      CONTINUE
         CALL LCMPUT(IPRES,'CONTR-ZONE',NCH,1,IBASE(INAM))
         CALL RLSARA(IBASE(INAM))
      ELSE IF(TEXT12.EQ.';') THEN
         GOTO 20
      ELSE
         CALL XABORT('INIRES: '//TEXT12//' INVALID KEYWORD')
      ENDIF
      GOTO 10
*
*     STORAGE OF FUEL MAP STATE VECTOR
*
 20   IF( REC )THEN
        RDATA(5) = IMOD
      ELSE
        IF(IMOD.EQ.0) CALL XABORT('INIRES: MISSING INFORMATIONS ON'
     +         //' BURNUP INTERPOLATION')
        RDATA(1) = NK
        RDATA(2) = NCH
        RDATA(3) = NZC
        RDATA(4) = NGRP
        RDATA(5) = IMOD
        RDATA(6) = 0
      ENDIF
      CALL LCMPUT(IPRES,'RES-DATA',6,1,RDATA)
      RETURN
      END
