*DECK INPROC
      SUBROUTINE INPROC(NENTRY,HENTRY,IENTRY,JENTRY,KENTRY)
*
************************************************************************
*
*     THIS MODULE READS THE PARTICULAR INFORMATION OF LIQUID
*     ZONE CONTROLLERS AND CONTROL RODS FOR CREATING PROCEDE OBJECT
*     AND TO BE USED IN THE REACTOR REGULATING SYSTEM. CROSS REFERENCE
*     WITH THE EXISTING DEVICE OBJECT IS MADE.
*
*     CE MODULE LIT LES DONNEES RELATIVES AUX CONTROLEURS
*     LIQUIDES ET AUX BARRES DE CONTROLE INTERVENANT DANS LE CALCUL
*     DE L'OBJET PROCEDE ET DU SYSTEME DE REGULATION. IL VERIFIE
*     AUSSI L'INPUT PAR RAPPORT A L'OBJET DEVICE DEJA EXISTANT
*
*     INPUT/OUTPUT PARAMETERS:
*      HMODUL : CHARACTER*12 NAME OF THE MODULE.
*      NENTRY : NUMBER OF LINKED LISTS AND FILES USED BY THE MODULE.
*      HENTRY : CHARACTER*12 NAME OF EACH LINKED LIST OR FILE.
*      IENTRY : =1 LINKED LIST; =2 XSM FILE; =3 SEQUENTIAL BINARY FILE;
*               =4 SEQUENTIAL ASCII FILE; =5 DIRECT ACCESS FILE.
*      JENTRY : =0 THE LINKED LIST OR FILE IS CREATED.
*               =1 THE LINKED LIST OR FILE IS OPEN FOR MODIFICATIONS;
*               =2 THE LINKED LIST OR FILE IS OPEN IN READ-ONLY MODE.
*      KENTRY : FILE UNIT NUMBER OR LINKED LIST ADDRESS.
*
*      DIMENSION HENTRY(NENTRY),IENTRY(NENTRY),JENTRY(NENTRY),
*      KENTRY(NENTRY)
*
*     REQUIRED LINKED_LISTS ARE:
*        KENTRY(1)   : OBJECT TYPE L_PROCEDE IN CREATION OR IN MODIFIC M
*        KENTRY(2)   : OBJECT TYPE L_DEVICE  IN READ-ONLY MODE
*
*     PROCEDURES CALLED :  LZCRED, ADJRED
*
*-------------------------------------- AUTHOR: E. VARIN  95/02/06 ---
*
*
*      IMPLICIT NONE
*
      REAL BASE
      INTEGER IBASE(1)
      COMMON BASE(1)
      EQUIVALENCE (BASE(1),IBASE(1))
*
      INTEGER NENTRY
      CHARACTER HENTRY(*)*12
      INTEGER IENTRY,JENTRY,KENTRY
      DIMENSION IENTRY(*),JENTRY(*),KENTRY(*)
*
      INTEGER      IPPROC,IPLDEV
* REDGET TYPES
      INTEGER NITMA
      REAL FLOTT
      DOUBLE PRECISION DFLOTT
      CHARACTER*12 TEXT
*
* DEVICE STRUCTURE
*
      CHARACTER*12 NAMTYP
      INTEGER      STATUS(2)
*
* SIGNATURE INFORMATION
*
      CHARACTER*12 SGNTUR
      INTEGER ISGNTR(3)
*
      CHARACTER*12 NXFAM,NMLCM,MYNAM,NXSEQ,NMLCM1,MYNAM1,
     +             FIRSTF,FIRSTS
      INTEGER      ILONG,ILONG1,ITYP,ITYP1,I,I1
      INTEGER      NDVICE,IPRT
      LOGICAL      LCM,LCM1
*
*     INPUT PARAMETER CONTROL
*
      IPPROC = 0
      IPLDEV = 0
      IF(NENTRY.LT.2) CALL XABORT('INPROC: PARAMETER EXPECTED.')
      IF((IENTRY(1).NE.1).AND.(IENTRY(1).NE.2)) CALL XABORT('INPR'
     + //'OC: LINKED LIST OR XSM FILE EXPECTED AT LHS.')
      IF((JENTRY(1).NE.0).AND.(JENTRY(1).NE.1)) CALL XABORT('INPR'
     + //'OC: CREATE OR MODIFICATION MODE EXPECTED.')
*
      IF (JENTRY(1).EQ.1) THEN
        CALL LCMSIX(KENTRY(1),' ',0)
        CALL LCMGET(KENTRY(1),'SIGNATURE',ISGNTR)
        WRITE(SGNTUR,'(3A4)') (ISGNTR(I),I=1,3)
        IF (SGNTUR.NE.'L_PROCEDE')
     +     CALL XABORT('INPROC: L_PROCEDE OBJECT IS EXPECTED')
      ENDIF
      IPPROC=KENTRY(1)
*
      DO 5 I=2,NENTRY
        IF((IENTRY(I).EQ.1).OR.(IENTRY(I).EQ.2)) THEN
         CALL LCMSIX(KENTRY(I),' ',0)
         CALL LCMGET(KENTRY(I),'SIGNATURE',ISGNTR)
         WRITE(SGNTUR,'(3A4)') (ISGNTR(I1),I1=1,3)
         IF (SGNTUR.EQ.'L_DEVICE') THEN
           IF (IPLDEV.EQ.0) IPLDEV=KENTRY(I)
           IF(JENTRY(I).NE.2) CALL XABORT('INPROC: READ-ONL'
     +      //'Y MODE EXPECTED.')
         ENDIF
        ENDIF
  5   CONTINUE
      IF (IPLDEV.EQ.0) CALL XABORT('INPROC: ILLEGAL'
     +     //' OR MISSING TYPE OF OBJECTS')
*
      IPRT = 1
 100  CALL REDGET(ITYP,NITMA,FLOTT,TEXT,DFLOTT)
      IF(ITYP.EQ.3) THEN
        IF (TEXT.EQ.'EDIT') THEN
*   PRINTING FLAG READING
            CALL REDGET(ITYP,IPRT,FLOTT,TEXT,DFLOTT)
            IF (ITYP.NE.1)
     +         CALL XABORT('INPROC: INTEGER DATA EXPECTED')
        ELSEIF (TEXT.EQ.'TYPE') THEN
*   DEVICE TYPE READING
            CALL REDGET(ITYP,NITMA,FLOTT,NAMTYP,DFLOTT)
            IF (ITYP.NE.3)
     +         CALL XABORT('INPROC: CHARACTER DATA EXPECTED')
        ELSEIF (TEXT.EQ.'END') THEN
           GOTO 90
        ELSEIF (TEXT.EQ.';') THEN
           GOTO 60
        ELSE
          CALL XABORT('INPROC: CONTROLLED TYPE EXPECTED'//TEXT)
        ENDIF
      ELSE
        CALL XABORT('INPROC: CHARACTER DATA EXPECTED')
      ENDIF
      GOTO 100
*
*     CREATION OF IPPROC FROM IPLDEV
*
 90   CALL LCMSIX(IPLDEV,' ',0)
      CALL LCMGET(IPLDEV,'STATUS',STATUS)
      NDVICE = STATUS(1)
      CALL LCMSIX(IPLDEV,NAMTYP,1)
      NXFAM = ' '
      CALL LCMNXT(IPLDEV,NXFAM,NMLCM,MYNAM,LCM)
      FIRSTF=NXFAM
10    CALL LCMNXT(IPLDEV,NXFAM,NMLCM,MYNAM,LCM)
      CALL LCMLEN(IPLDEV,NXFAM,ILONG,ITYP)
      IF (ITYP.EQ.0) THEN
*  FAMILY LEVEL
        CALL LCMSIX(IPPROC,NXFAM,1)
        CALL LCMSIX(IPLDEV,NXFAM,1)
        NXSEQ = ' '
        CALL LCMNXT(IPLDEV,NXSEQ,NMLCM1,MYNAM1,LCM1)
        FIRSTS=NXSEQ
20      CALL LCMNXT(IPLDEV,NXSEQ,NMLCM1,MYNAM1,LCM1)
        CALL LCMLEN(IPLDEV,NXSEQ,ILONG1,ITYP1)
        IF (ITYP1.EQ.0) THEN
*  SEQUEN LEVEL
          CALL LCMSIX(IPPROC,NXSEQ,1)
          CALL LCMSIX(IPPROC,' ',2)
        ENDIF
        IF(NXSEQ.EQ.FIRSTS) THEN
          GOTO 30
        ENDIF
        GOTO 20
 30   ENDIF
      CALL LCMSIX(IPPROC,' ',2)
      CALL LCMSIX(IPLDEV,' ',2)
      IF(NXFAM.EQ.FIRSTF) GOTO 40
      GOTO 10
 40   IF(IPRT.GT.1) WRITE(6,*) 'TRANSFERT IS COMPLETE BETWEEN DEVICE'
     +                         //' AND PROCEDE'
*
*     READING OF DEVICE INFORMATION
*
 50   CALL REDGET(ITYP,NITMA,FLOTT,TEXT,DFLOTT)
      IF(ITYP.EQ.3) THEN
        IF (TEXT.EQ.'LZC') THEN
*   READING FOR LIQUID ZONE CONTROLLER DATA
            CALL REDGET(ITYP,NITMA,FLOTT,TEXT,DFLOTT)
            IF (ITYP.NE.3)
     +         CALL XABORT('INPROC: CHARACTER DATA EXPECTED')
            CALL LZCRED(IPPROC,IPLDEV,NAMTYP,TEXT,IPRT)
        ELSEIF (TEXT.EQ.'ROD') THEN
*   READING FOR ROD DATA
            CALL REDGET(ITYP,NITMA,FLOTT,TEXT,DFLOTT)
            IF (ITYP.NE.3)
     +         CALL XABORT('INPROC: CHARACTER DATA EXPECTED')
            CALL ADJRED(IPPROC,IPLDEV,NAMTYP,TEXT,IPRT)
        ELSEIF (TEXT.EQ.';') THEN
           GOTO 60
        ELSEIF (TEXT.EQ.'END') THEN
           GOTO 100
        ELSE
          CALL XABORT('INPROC: KEYWORD EXPECTED'//TEXT)
        ENDIF
      ELSE
        CALL XABORT('INPROC: CHARACTER DATA EXPECTED')
      ENDIF
      GOTO 50
*
 60   CALL LCMSIX(IPPROC,' ',0)
      SGNTUR='L_PROCEDE'
      READ(SGNTUR,'(3A4)') (ISGNTR(I),I=1,3)
      CALL LCMPUT(IPPROC,'SIGNATURE',3,3,ISGNTR)
      CALL LCMSIX(IPPROC,' ',0)
*
      IF (IPRT.GT.3) THEN
        NXFAM = ' '
        CALL LCMNXT(IPPROC,NXFAM,NMLCM1,MYNAM1,LCM1)
        FIRSTS=NXFAM
 70     CALL LCMNXT(IPPROC,NXFAM,NMLCM1,MYNAM1,LCM1)
        CALL LCMLEN(IPPROC,NXFAM,ILONG1,ITYP1)
        IF (ITYP1.EQ.0) THEN
*   SEQUEN LEVEL
          CALL LCMSIX(IPPROC,NXFAM,1)
          CALL LCMLIB(IPPROC)
          CALL LCMSIX(IPPROC,NXFAM,2)
        ENDIF
        IF(NXFAM.EQ.FIRSTS) THEN
          GOTO 80
        ENDIF
        GOTO 70
 80   ENDIF
*
      RETURN
      END
