*DECK INTLIM
      SUBROUTINE INTLIM(NK,NN,XX,PSI,DW,W1,W2,ADW,NW,NSL)
*                                                                      *
*----------------------------------------------------------------------*
*                                                                      *
*        *******************************************************       *
*        * MODULE FOR COMPUTING INTEGRATION LIMITS FOR XS      *       *
*        * TIME-AVERAGED CORRESPONDING TO A REFUELING SCHEME   *       *
*        * OF NN BUNDLES, AN AXIAL FLUX SHAPE PSI(K) AND       *       *
*        * AN AVERAGE EXIT BURNUP OF XX  (MWD/T)               *       *
*        *******************************************************       *
*                                                                      *
*        *******************************************************       *
*        * MODULE DE CALCUL DES LIMITES D'INTEGRATION POUR LES *       *
*        * XS T-A CORRESPONDANT A UN MODE DE RECHARGEMENT NN   *       *
*        * ET DE FORME AXIALE PSI(K) ET D'IRRADIATION XX       *       *
*        *******************************************************       *
*                                                                      *
*                                                                      *
*   SUBROUTINE FROM OPTEX-4: AUTHORS M. BEAUDET ET D. ROZON            *
*                                                                      *
*                                                                      *
*                                                                      *
*                                                                      *
*                                                                      *
*                                                                      *
*                                                                      *
      IMPLICIT NONE
*
      INTEGER   NK,NN,NSL
      REAL      DW(NK),W1(NK),W2(NK),PSI(NK), XX,
     >          ADW(NK)
      INTEGER   NW(NK),K,KK,KA
*
      DO 10 K=1,NK
         DW(K) = NN*XX*PSI(K)
         W1(K)=0.0
         W2(K)=0.0
   10 CONTINUE
*
      IF(NSL.LT.0) THEN
         DO 14 K=1,NK
          KK=NK-K+1
          KA=NK-NW(K)+1
          IF(NW(K).LE.0) THEN
           W1(KK)=0.0
          ELSE
           W1(KK)=W2(KA)
          ENDIF
          W2(KK) = W1(KK)+ DW(KK)
   14    CONTINUE
      ELSE
         DO 12 K=1,NK
          IF(NW(K).LE.0) THEN
            W1(K)=0.0
          ELSE
            W1(K) = W2(NW(K))
          ENDIF
          W2(K) = W1(K)+ DW(K)
   12    CONTINUE
      ENDIF
*
      RETURN
      END
