*DECK IQSADD
      SUBROUTINE IQSADD (IPMAC1,IPMAC2,IPMAC3,NMIXT,NGRP,NDG,NL,
     1 TOTAL,ZNUG,ZSIGF,CHI,CHDL,OVERV,DIFFX,DIFFY,DIFFZ,H,S,IJJ,NJJ,
     2 SCAT,WORK,IPOS,IJJP,NJJP,DDIF,FACT)
*
*-----------------------------------------------------------------------
*
* READ AND ADD CROSS SECTIONS AND STORE THEM IN A LINKED LIST.
*
* INPUT PARAMETERS:
*  IPMAC1 : ADDRESS OF THE LINKED LIST OR HANDLE TO THE XSM FILE.
*  IPMAC2 : ADDRESS OF THE LINKED LIST OR HANDLE TO THE XSM FILE.
*  NMIXT  : MAXIMUM NUMBER OF MATERIAL MIXTURES.
*  NGRP   : NUMBER OF ENERGY GROUPS.
*  NL     : NUMBER OF LEGENDRE ORDERS (=1 FOR ISOTROPIC SCATTERING).
*  NDG    : NUMBER OF DELAYED NEUTRON SPECTRUM.
*
*
* SCRATCH STORAGE:
*  TOTAL  : DIMENSION TOTAL(NMIXT,NGRP)
*  ZNUG   : DIMENSION ZNUG(NMIXT,NGRP)
*  CHI    : DIMENSION CHI(NMIXT,NGRP)
*  CHDL   : DIMENSION CHDL(NMIXT,NDG,NGRP)
*  OVERV  : DIMENSION OVERV(NMIXT,NGRP)
*  DIFFX  : DIMENSION DIFFX(NMIXT,NGRP)
*  DIFFY  : DIMENSION DIFFY(NMIXT,NGRP)
*  DIFFZ  : DIMENSION DIFFZ(NMIXT,NGRP)
*  H      : DIMENSION H(NMIXT,NGRP)
*  S      : DIMENSION S(NMIXT,NGRP)
*  IJJ    : DIMENSION IJJ(NMIXT,NL,NGRP)
*  NJJ    : DIMENSION NJJ(NMIXT,NL,NGRP)
*  SCAT   : SCAT(NMIXT,NL,NGRP,NGRP)
*  WORK   : WORK(NMIXT*NGRP)
*  IPOS   : IPOS(NMIXT)
*
* NOTE: ANY CROSS SECTION NOT READ IS SET TO ZERO.
*
*------------------------------ AUTHOR: M.T. SISSAOUI ; 10/03/95 ---
*
      LOGICAL LTO,LFI,LNFI,LCH,LOV,LDX,LDY,LDZ,LHF,LSC,LSO,LBI,DDIF
      REAL    FACT
      CHARACTER CGRPNM*12,CM*2,TEXT*8
      DIMENSION TOTAL(NMIXT,*),ZNUG(NMIXT,*),ZSIGF(NMIXT,*),
     1 CHI(NMIXT,*),OVERV(NMIXT,*),DIFFX(NMIXT,*),DIFFY(NMIXT,*),
     2 SCAT(NMIXT,NL,NGRP,*),H(NMIXT,*),DIFFZ(NMIXT,*),IJJ(NMIXT,NL,*),
     3 NJJ(NMIXT,NL,*),S(NMIXT,*),WORK(*),IPOS(*),CHDL(NMIXT,NDG,*),
     4 IJJP(NMIXT,NL,*),NJJP(NMIXT,NL,*)
      COMMON BASE(1)
*
      IF(NMIXT.EQ.0) CALL XABORT('IQSADD: ZERO NUMBER OF MIXTURES.')
      IF(NGRP.EQ.0) CALL XABORT('IQSADD: ZERO NUMBER OF GROUPS.')
*
      LTO=.FALSE.
      LFI=.FALSE.
      LNFI=.FALSE.
      LCH=.FALSE.
      LOV=.FALSE.
      LDX=.FALSE.
      LDY=.FALSE.
      LDZ=.FALSE.
      LHF=.FALSE.
      LSC=.FALSE.
      LSO=.FALSE.
      LBI=.FALSE.
*
      DO 10 IGR=1,NGRP
      DO 10 IBM=1,NMIXT
      TOTAL(IBM,IGR)=0.0
      ZNUG(IBM,IGR)=0.0
      ZSIGF(IBM,IGR)=0.0
      OVERV(IBM,IGR)=0.0
      CHI(IBM,IGR)=0.0
      DIFFX(IBM,IGR)=0.0
      DIFFY(IBM,IGR)=0.0
      DIFFZ(IBM,IGR)=0.0
      H(IBM,IGR)=0.0
      S(IBM,IGR)=0.0
      DO 10 IL=1,NL
      IJJ(IBM,IL,IGR)=IGR
      NJJ(IBM,IL,IGR)=1
      DO 10 JGR=1,NGRP
   10 SCAT(IBM,IL,JGR,IGR)=0.0
*
*        RECOVER THE UNPERTURBED DATA
       DO 40 JGR=1,NGRP
         WRITE (CGRPNM,'(5HGROUP,I3,1H/,I3)') JGR,NGRP
         CALL LCMSIX(IPMAC1,CGRPNM,1)
         CALL LCMLEN(IPMAC1,'TOTAL',ILENGT,ITYLCM)
         IF(ILENGT.EQ.NMIXT) THEN
            LTO=.TRUE.
            CALL LCMGET(IPMAC1,'TOTAL',TOTAL(1,JGR))
         ELSE IF(ILENGT.NE.0) THEN
            CALL XABORT('MACXSI: INVALID INPUT MACROLIB(1).')
         ENDIF
         CALL LCMLEN(IPMAC1,'NUSIGF',ILENGT,ITYLCM)
          IF(ILENGT.EQ.NMIXT) THEN
          LNFI=.TRUE.
          CALL LCMGET(IPMAC1,'NUSIGF',ZNUG(1,JGR))
          ENDIF
         CALL LCMLEN(IPMAC1,'NFTOT',ILENGT,ITYLCM)
          IF(ILENGT.EQ.NMIXT) THEN
          LFI=.TRUE.
          CALL LCMGET(IPMAC1,'NFTOT',ZSIGF(1,JGR))
          ENDIF
         CALL LCMLEN(IPMAC1,'CHI',ILENGT,ITYLCM)
         IF(ILENGT.EQ.NMIXT) THEN
         LCH=.TRUE.
         CALL LCMGET(IPMAC1,'CHI',CHI(1,JGR))
         ENDIF
         DO 900 I=1,NDG
         WRITE (TEXT,'(4HCHDL,I3)') I
         CALL LCMLEN(IPMAC1,TEXT,ILENGT,ITYLCM)
          IF(ILENGT.EQ.NMIXT) THEN
          LBI=.TRUE.
          CALL LCMGET(IPMAC1,TEXT,CHDL(1,I,JGR))
          ENDIF
 900     CONTINUE
         CALL LCMLEN(IPMAC1,'OVERV',ILENGT,ITYLCM)
         IF(ILENGT.EQ.NMIXT) THEN
          LOV=.TRUE.
          CALL LCMGET(IPMAC1,'OVERV',OVERV(1,JGR))
         ENDIF
         CALL LCMLEN(IPMAC1,'DIFFX',ILENGT,ITYLCM)
         IF(ILENGT.EQ.NMIXT) THEN
           IF(DDIF) LDX=.TRUE.
           CALL LCMGET(IPMAC1,'DIFFX',DIFFX(1,JGR))
         ENDIF
         CALL LCMLEN(IPMAC1,'DIFFY',ILENGT,ITYLCM)
         IF(ILENGT.EQ.NMIXT) THEN
          IF(DDIF) LDY=.TRUE.
          CALL LCMGET(IPMAC1,'DIFFY',DIFFY(1,JGR))
         ENDIF
         CALL LCMLEN(IPMAC1,'DIFFZ',ILENGT,ITYLCM)
         IF(ILENGT.EQ.NMIXT) THEN
           IF(DDIF) LDZ=.TRUE.
           CALL LCMGET(IPMAC1,'DIFFZ',DIFFZ(1,JGR))
         ENDIF
         CALL LCMLEN(IPMAC1,'H-FACTORS',ILENGT,ITYLCM)
         IF(ILENGT.EQ.NMIXT) THEN
            LHF=.TRUE.
            CALL LCMGET(IPMAC1,'H-FACTORS',H(1,JGR))
         ENDIF
         CALL LCMLEN(IPMAC1,'FIXE',ILENGT,ITYLCM)
         IF(ILENGT.EQ.NMIXT) THEN
           LSO=.TRUE.
           CALL LCMGET(IPMAC1,'FIXE',S(1,JGR))
         ENDIF
         DO 30 IL=1,NL
           WRITE (CM,'(I2)') IL-1
           CALL LCMLEN(IPMAC1,'SCAT'//CM,ILENGT,ITYLCM)
           IF(ILENGT.GT.NMIXT*NL*NGRP*NGRP) THEN
              CALL XABORT('MACXSI: INVALID INPUT MACROLIB(2).')
           ELSE IF(ILENGT.GT.0) THEN
            LSC=.TRUE.
            CALL LCMGET(IPMAC1,'SCAT'//CM,WORK)
            CALL LCMGET(IPMAC1,'NJJ'//CM,NJJ(1,IL,JGR))
            CALL LCMGET(IPMAC1,'IJJ'//CM,IJJ(1,IL,JGR))
            IPOSDE=0
            DO 20 IBM=1,NMIXT
              IJJ0=IJJ(IBM,IL,JGR)
              DO 20 IGR=IJJ0,IJJ0-NJJ(IBM,IL,JGR)+1,-1
                IPOSDE=IPOSDE+1
   20           SCAT(IBM,IL,IGR,JGR)=WORK(IPOSDE)
           ENDIF
   30    CONTINUE
         CALL LCMSIX(IPMAC1,' ',2)
   40  CONTINUE
*
* RECOVER THE PERTURBED DATA
       DO 940 JGR=1,NGRP
         WRITE (CGRPNM,'(5HGROUP,I3,1H/,I3)') JGR,NGRP
         CALL LCMSIX(IPMAC2,CGRPNM,1)
         CALL LCMLEN(IPMAC2,'TOTAL',ILENGT,ITYLCM)
         IF(ILENGT.EQ.NMIXT) THEN
           CALL SETARA(BASE,ILENGT,ITOT)
           CALL LCMGET(IPMAC2,'TOTAL',BASE(ITOT))
           DO 100 IMX=1,ILENGT
             TOTAL(IMX,JGR)=TOTAL(IMX,JGR)+BASE(ITOT-1+IMX)*FACT
 100       CONTINUE
           CALL RLSARA(BASE(ITOT))
         ELSE IF(ILENGT.NE.0) THEN
            CALL XABORT('IQSADD: INVALID INPUT MACROLIB(1).')
         ENDIF
*
         CALL LCMLEN(IPMAC2,'NUSIGF',ILENGT,ITYLCM)
         IF(ILENGT.EQ.NMIXT) THEN
           CALL SETARA(BASE,ILENGT,INUS)
           CALL LCMGET(IPMAC2,'NUSIGF',BASE(INUS))
           DO 110 IMX=1,ILENGT
             ZNUG(IMX,JGR)=ZNUG(IMX,JGR)+BASE(INUS-1+IMX)*FACT
 110       CONTINUE
           CALL RLSARA(BASE(INUS))
         ENDIF
*
         CALL LCMLEN(IPMAC2,'NFTOT',ILENGT,ITYLCM)
         IF(ILENGT.EQ.NMIXT) THEN
           CALL SETARA(BASE,ILENGT,INUS)
           CALL LCMGET(IPMAC2,'NFTOT',BASE(INUS))
           DO 111 IMX=1,ILENGT
             ZSIGF(IMX,JGR)=ZSIGF(IMX,JGR)+BASE(INUS-1+IMX)*FACT
 111       CONTINUE
           CALL RLSARA(BASE(INUS))
         ENDIF
*
         CALL LCMLEN(IPMAC2,'CHI',ILENGT,ITYLCM)
         IF(ILENGT.EQ.NMIXT) THEN
           CALL SETARA(BASE,ILENGT,ICHI)
           CALL LCMGET(IPMAC2,'CHI',BASE(ICHI))
           DO 120 IMX=1,ILENGT
             CHI(IMX,JGR)=CHI(IMX,JGR)+BASE(ICHI-1+IMX)*FACT
 120       CONTINUE
           CALL RLSARA(BASE(ICHI))
         ENDIF
*
         DO 990 I=1,NDG
           WRITE (TEXT,'(4HCHDL,I3)') I
           CALL LCMLEN(IPMAC2,TEXT,ILENGT,ITYLCM)
           IF(ILENGT.EQ.NMIXT) THEN
             CALL SETARA(BASE,ILENGT,ICHD)
             CALL LCMGET(IPMAC2,TEXT,BASE(ICHD))
             DO 220 IMX=1,ILENGT
               CHDL(IMX,I,JGR)=CHDL(IMX,I,JGR)+BASE(ICHD-1+IMX)*FACT
 220         CONTINUE
             CALL RLSARA(BASE(ICHD))
           ENDIF
 990     CONTINUE
*
*
         CALL LCMLEN(IPMAC2,'OVERV',ILENGT,ITYLCM)
         IF(ILENGT.EQ.NMIXT) THEN
           CALL SETARA(BASE,ILENGT,IOVR)
           CALL LCMGET(IPMAC2,'OVERV',BASE(IOVR))
           DO 130 IMX=1,ILENGT
             OVERV(IMX,JGR)=OVERV(IMX,JGR)+BASE(IOVR-1+IMX)*FACT
 130       CONTINUE
           CALL RLSARA(BASE(IOVR))
         ENDIF
*
         IF( DDIF )THEN
           CALL LCMLEN(IPMAC2,'DIFFX',ILENGT,ITYLCM)
           IF(ILENGT.EQ.NMIXT) THEN
             CALL SETARA(BASE,ILENGT,IDFX)
             CALL LCMGET(IPMAC2,'DIFFX',BASE(IDFX))
             DO 140 IMX=1,ILENGT
               IF(BASE(IDFX-1+IMX).NE.0.0) THEN
                 DIFFX(IMX,JGR)=1./DIFFX(IMX,JGR)
     1                 +1./BASE(IDFX-1+IMX)*FACT
                 DIFFX(IMX,JGR)=1./DIFFX(IMX,JGR)
               ENDIF
 140         CONTINUE
             CALL RLSARA(BASE(IDFX))
           ENDIF
*
           CALL LCMLEN(IPMAC2,'DIFFY',ILENGT,ITYLCM)
           IF(ILENGT.EQ.NMIXT) THEN
             CALL SETARA(BASE,ILENGT,IDFY)
             CALL LCMGET(IPMAC2,'DIFFY',BASE(IDFY))
             DO 150 IMX=1,ILENGT
               IF(BASE(IDFY-1+IMX).NE.0.0) THEN
                 DIFFY(IMX,JGR)=1./DIFFY(IMX,JGR)
     1                  +1./BASE(IDFY-1+IMX)*FACT
                 DIFFY(IMX,JGR)=1./DIFFY(IMX,JGR)
               ENDIF
 150         CONTINUE
             CALL RLSARA(BASE(IDFY))
           ENDIF
*
           CALL LCMLEN(IPMAC2,'DIFFZ',ILENGT,ITYLCM)
           IF(ILENGT.EQ.NMIXT) THEN
             CALL SETARA(BASE,ILENGT,IDFZ)
             CALL LCMGET(IPMAC2,'DIFFZ',BASE(IDFZ))
             DO 160 IMX=1,ILENGT
               IF(BASE(IDFZ-1+IMX).NE.0.0) THEN
                 DIFFZ(IMX,JGR)=1./DIFFZ(IMX,JGR)
     1                 +1./BASE(IDFZ-1+IMX)*FACT
                 DIFFZ(IMX,JGR)=1./DIFFZ(IMX,JGR)
               ENDIF
 160         CONTINUE
             CALL RLSARA(BASE(IDFZ))
           ENDIF
         ENDIF
*
         CALL LCMLEN(IPMAC2,'H-FACTORS',ILENGT,ITYLCM)
         IF(ILENGT.EQ.NMIXT) THEN
           CALL SETARA(BASE,ILENGT,IH)
           CALL LCMGET(IPMAC2,'H-FACTORS',BASE(IH))
           DO 270 IMX=1,ILENGT
             H(IMX,JGR)=H(IMX,JGR)+BASE(IH-1+IMX)*FACT
 270       CONTINUE
           CALL RLSARA(BASE(IH))
         ENDIF
*
         CALL LCMLEN(IPMAC2,'FIXE',ILENGT,ITYLCM)
         IF(ILENGT.EQ.NMIXT) THEN
           CALL SETARA(BASE,ILENGT,IS)
           CALL LCMGET(IPMAC2,'FIXE',BASE(IS))
           DO 280 IMX=1,ILENGT
             S(IMX,JGR)=S(IMX,JGR)+BASE(IS-1+IMX)*FACT
 280       CONTINUE
           CALL RLSARA(BASE(IS))
         ENDIF
*
         DO 930 IL=1,NL
           WRITE (CM,'(I2)') IL-1
           CALL LCMLEN(IPMAC2,'SCAT'//CM,ILENGT,ITYLCM)
           IF(ILENGT.GT.NMIXT*NL*NGRP*NGRP) THEN
              CALL XABORT('MACXSI: INVALID INPUT MACROLIB(2).')
           ELSE IF(ILENGT.GT.0) THEN
              CALL LCMGET(IPMAC2,'SCAT'//CM,WORK)
              CALL LCMGET(IPMAC2,'NJJ'//CM,NJJP(1,IL,JGR))
              CALL LCMGET(IPMAC2,'IJJ'//CM,IJJP(1,IL,JGR))
              IPOSDE=0
              DO 920 IBM=1,NMIXT
                IJJ0=IJJP(IBM,IL,JGR)
                IJ=IJJ0-IJJ(IBM,IL,JGR)
                IN=NJJP(IBM,IL,JGR)-NJJ(1,IL,JGR)
                IF(IJ.EQ.0.AND.IN.EQ.0) THEN
                  DO 820 IGR=IJJ0,IJJ0-NJJP(IBM,IL,JGR)+1,-1
                    IPOSDE=IPOSDE+1
                    SCAT(IBM,IL,IGR,JGR)=SCAT(IBM,IL,IGR,JGR)
     +                    + WORK(IPOSDE)*FACT
 820               CONTINUE
                ENDIF
 920          CONTINUE
           ENDIF
 930     CONTINUE
         CALL LCMSIX(IPMAC2,' ',2)
  940 CONTINUE
C
      DO 190 JGR=1,NGRP
        WRITE (CGRPNM,'(5HGROUP,I3,1H/,I3)') JGR,NGRP
        CALL LCMSIX(IPMAC3,CGRPNM,1)
        IF(LTO) CALL LCMPUT(IPMAC3,'TOTAL',NMIXT,2,TOTAL(1,JGR))
        IF(LNFI) CALL LCMPUT(IPMAC3,'NUSIGF',NMIXT,2,ZNUG(1,JGR))
        IF(LFI) CALL LCMPUT(IPMAC3,'NFTOT',NMIXT,2,ZSIGF(1,JGR))
        IF(LCH) CALL LCMPUT(IPMAC3,'CHI',NMIXT,2,CHI(1,JGR))
        IF(LOV) CALL LCMPUT(IPMAC3,'OVERV',NMIXT,2,OVERV(1,JGR))
        IF(LDX) CALL LCMPUT(IPMAC3,'DIFFX',NMIXT,2,DIFFX(1,JGR))
        IF(LDY) CALL LCMPUT(IPMAC3,'DIFFY',NMIXT,2,DIFFY(1,JGR))
        IF(LDZ) CALL LCMPUT(IPMAC3,'DIFFZ',NMIXT,2,DIFFZ(1,JGR))
        IF(LHF) CALL LCMPUT(IPMAC3,'H-FACTORS',NMIXT,2,H(1,JGR))
        IF(LSO) CALL LCMPUT(IPMAC3,'FIXE',NMIXT,2,S(1,JGR))
        IF(LBI) THEN
          DO 901 I=1,NDG
            WRITE (TEXT,'(4HCHDL,I3)') I
            CALL LCMPUT(IPMAC3,TEXT,NMIXT,2,CHDL(1,I,JGR))
 901      CONTINUE
        ENDIF
        IF(LSC) THEN
           DO 180 IL=1,NL
             WRITE (CM,'(I2)') IL-1
             IPOSDE=0
             DO 170 IBM=1,NMIXT
              IPOS(IBM)=IPOSDE+1
              DO 171 IGR=IJJ(IBM,IL,JGR),
     +               IJJ(IBM,IL,JGR)-NJJ(IBM,IL,JGR)+1,-1
                IPOSDE=IPOSDE+1
                WORK(IPOSDE)=SCAT(IBM,IL,IGR,JGR)
 171          CONTINUE
 170         CONTINUE
             CALL LCMPUT(IPMAC3,'SCAT'//CM,IPOSDE,2,WORK)
             CALL LCMPUT(IPMAC3,'IPOS'//CM,NMIXT,1,IPOS)
             CALL LCMPUT(IPMAC3,'NJJ'//CM,NMIXT,1,NJJ(1,IL,JGR))
             CALL LCMPUT(IPMAC3,'IJJ'//CM,NMIXT,1,IJJ(1,IL,JGR))
             CALL LCMPUT(IPMAC3,'SIGW'//CM,NMIXT,2,SCAT(1,IL,JGR,JGR))
 180       CONTINUE
        ENDIF
        CALL LCMSIX(IPMAC3,' ',2)
 190  CONTINUE
      RETURN
      END
