*DECK IQSANG
      SUBROUTINE IQSANG(ANGLE,CONTAM,XVEC,YVEC,RM,VM,
     1 LL4,VELO,V,NGRP,DPXVC,DPYVC,DPXYV)
********************************************************************
* THIS SUBROUTINE COMPUTE THE CONTAMINATION AND THE ANGLE.
*
*
* INPUT PARAMETERS:
*  XVEC   : VECTOR TO BE DECONTAMINATED IE CONTRAINED TO HYPERPLANE
*  YVEC   : VECTOR TO HYPER PLANE
*  LL4    : TOTAL NUMBER OF UNKNOWNS PER GROUP.
*  NGRP   : TOTAL NUMBER OF ENERGY GROUP.
*  VM     : VELOCITY PER ENERGY GROUP. DIMENSION VM(NGRP)
*  V      : VELOCITY PER REGION. DIMENSION V(LL4,NGRP)
*  RM     : UNIT MATRIX.  DIMENSION RM(LL4)
*  VELO   : LOGICAL VARIABLE TO SET 'VM' OR 'V'
**
* OUTPUT PARAMETER:
*  CONTAM : CONTAMINATION
*  ANGLE  : ANGLE
**
*  SCRATCH STORAGE:
*  DPXVC  : DIMENSION DPXVC(NGRP)
*  DPYVC  : DIMENSION DPYVC(NGRP)
*  DPXYV  : DIMENSION DPXYV(NGRP)
***
* MODIFIED BY M.T. SISSAOUI ; 27/07/94
***************************************************************
*
      DIMENSION XVEC(LL4,NGRP),YVEC(LL4,NGRP),RM(LL4),VM(NGRP),
     1 V(LL4,NGRP)
      DOUBLE PRECISION DPXVC(NGRP),DPYVC(NGRP),DPXYV(NGRP)
      LOGICAL VELO
*
      DO 60 IGR=1,NGRP
      DPXVC(IGR) = 0.0D0
      DPYVC(IGR) = 0.0D0
      DPXYV(IGR)= 0.0D0
  60  CONTINUE
      DPXVCS= 0.0
      DPYVCS= 0.0
      DPXYVS= 0.0
      DO  100 IGR=1,NGRP
      DO 10 I=1,LL4
   10 DPXVC(IGR)=XVEC(I,IGR)*RM(I)*XVEC(I,IGR)+DPXVC(IGR)
 100  CONTINUE
      DO 11 IGR=1,NGRP
      DPXVCS = DPXVCS + DPXVC(IGR)
  11  CONTINUE
      IF(VELO) THEN
       DO 31 IGR=1,NGRP
       DO 20 I=1,LL4
      DPYVC(IGR)=YVEC(I,IGR)*V(I,IGR)*V(I,IGR)*YVEC(I,IGR)
     1 +DPYVC(IGR)
      DPXYV(IGR) = YVEC(I,IGR)*V(I,IGR)*XVEC(I,IGR)
     1  + DPXYV(IGR)
   20 CONTINUE
   31 CONTINUE
      DO 15 IGR=1,NGRP
      DPYVCS = DPYVCS + DPYVC(IGR)
      DPXYVS = DPXYVS + DPXYV(IGR)
  15  CONTINUE
      ELSE
       DO 40 IGR=1,NGRP
       DO 30 I=1,LL4
      DPYVC(IGR)=YVEC(I,IGR)*RM(I)*YVEC(I,IGR)/(VM(IGR)*VM(IGR))
     1  + DPYVC(IGR)
      DPXYV(IGR) = YVEC(I,IGR)*RM(I)*XVEC(I,IGR)/VM(IGR)
     1  + DPXYV(IGR)
   30 CONTINUE
   40 CONTINUE
      DO 50 IGR=1,NGRP
      DPYVCS = DPYVCS + DPYVC(IGR)
      DPXYVS = DPXYVS + DPXYV(IGR)
  50  CONTINUE
      ENDIF
      ANGLE = DPXYVS/( SQRT(DPXVCS)*SQRT(DPYVCS) )
      ANGLE = ACOS(ANGLE)
      ANGLE = ANGLE/ACOS(0.)*90.
      CONTAM = DPXYVS /DPYVCS
      RETURN
      END
