*DECK IQSNIN
      SUBROUTINE IQSNIN (IPTRK,IPSYS0,IPSYSP,IPFLUP,NUN,NGRP,ADECT,
     1 ITRANA,ITRANB,FKEFF,NDG,LBI)
*
*-----------------------------------------------------------------------
*
* TRANSIENT INITIALIZATION.
*
* INPUT PARAMETERS:
*  IPTRK  : L_TRACK POINTER TO THE TRACKING INFORMATION.
*  IPSYS0 : L_SYSTEM POINTER TO UNPERTURBED SYSTEM MATRICES.
*  IPSYSP : L_SYSTEM POINTER TO DELTA SYSTEM MATRICES. EQUAL TO ZERO IF
*           NO PERTURBATION IS SET.
*  IPFLUP : L_IQS POINTER TO THE IQS SOLUTION.
*  NUN    : TOTAL NUMBER OF UNKNOWNS PER GROUP.
*  NGRP   : NUMBER OF ENERGY GROUPS.
*  NDG    : NUMBER OF DELAYED NEUTRON GROUPS.
*  LBI    : LOGICAL VARIABLE FOR NEUTRON FISSION SPECTRUM.
*  ADECT  :  ADJOINT FLUX. DIMENSION ADECT(NUN,NGRP)
*  ITRANA : TYPE OF PERTURBATION FOR A-SYSTEM MATRICES. =1: STEP;
*           =2: RAMP; =3 CERB.
*  ITRANB : TYPE OF PERTURBATION FOR B-SYSTEM MATRICES. =1: STEP;
*           =2: RAMP; =3 CERB.
*  FKEFF  : INITIAL EFFECTIVE MULTIPLICATION FACTOR.
*
* INFORMATION STORED ON LCM OR XSM (POINTED BY IPFLUP):
*  PVA01, PVA02, .... : LINEAR PRODUCTS BEFORE PERTURBATION.
*  PVA11, PVA12, .... : LINEAR PRODUCTS AFTER PERTURBATION.
*  PVB01, PVB02, .... : LINEAR PRODUCTS BEFORE PERTURBATION.
*  PVA00, PVA01, .... : LINEAR PRODUCTS AFTER PERTURBATION.
****
* MODIFIED BY M.T. SISSAOUI ; 28/07/94
*---------------------------------------------- A. MONIER --------------
*
      DIMENSION ADECT(NUN,NGRP)
      CHARACTER*12 NAME,NAMLCM,NAMMY,NAMA,TEXT,NAMB
      LOGICAL LCM,LBI
      COMMON BASE(1)
*
* RECOVER THE NON-PERTURBED SYSTEM MATRICES.
      NAME=' '
      CALL LCMNXT(IPSYS0,NAME,NAMLCM,NAMMY,LCM)
      DO 10 IGR= 1,NGRP
      DO 11 JGR=1,NGRP
      WRITE(NAMA,'(1HA,I3,I3)') IGR,JGR
      WRITE(NAMB,'(1HB,I3,I3)') IGR,JGR
         CALL LCMLEN(IPSYS0,NAMA,LENGA,ITYLCM)
         CALL LCMLEN(IPSYS0,NAMB,LENGB,ITYLCM)
      IF(LCM) THEN
*        IN-CORE STORAGE.
           IF(LENGA.GT.0) IA=LCMIOF(IPSYS0,NAMA)
           IF(LENGB.GT.0) IB=LCMIOF(IPSYS0,NAMB)
      ELSE
*        XSM STORAGE.
          IF(LENGA.GT.0) CALL SETARA(BASE,LENGA,IA)
          IF(LENGB.GT.0) CALL SETARA(BASE,LENGB,IB)
          IF(LENGA.GT.0) CALL LCMGET(IPSYS0,NAMA,BASE(IA))
          IF(LENGB.GT.0) CALL LCMGET(IPSYS0,NAMB,BASE(IB))
      ENDIF
*
* COMPUTE THE LINEAR PRODUCTS BEFORE PERTURBATION.
      IF(ITRANA.NE.0) THEN
         CALL SETARA(BASE,NUN,IV0A)
*
        IF(IGR.EQ.JGR) THEN
        CALL MTLDLM(NAMA,IPTRK,IPSYS0,ADECT(1,IGR),BASE(IV0A))
        ELSE
         IF(LENGA.GT.0) THEN
        DO 101 I=1,NUN
 101       BASE(IV0A+I-1)=BASE(IA+I-1)*ADECT(I,IGR)
         ENDIF
        ENDIF
         IF(LENGA.GT.0.OR.IGR.EQ.JGR) THEN
         WRITE(TEXT,'(4HPV0A,I3,I3)') IGR,JGR
         CALL LCMPUT(IPFLUP,TEXT,NUN,2,BASE(IV0A))
         ENDIF
         CALL RLSARA(BASE(IV0A))
      ENDIF
      IF(ITRANB.NE.0) THEN
        IF(LENGB.GT.0) THEN
         CALL SETARA(BASE,NUN,IV0B)
        DO 15 I=1,NUN
   15   BASE(IV0B+I-1)=BASE(IB+I-1)*ADECT(I,IGR)/FKEFF
        WRITE(TEXT,'(4HPV0B,I3,I3)') IGR,JGR
        CALL LCMPUT(IPFLUP,TEXT,NUN,2,BASE(IV0B))
        CALL RLSARA(BASE(IV0B))
        ENDIF
      ENDIF
      IF(.NOT.LCM) THEN
       IF(LENGB.GT.0) CALL RLSARA(BASE(IB))
       IF(LENGA.GT.0) CALL RLSARA(BASE(IA))
      ENDIF
*
* RECOVER THE DELTA SYSTEM MATRICES.
      IF(IPSYSP.EQ.0) THEN
          LAP=0
          LBP=0
         LCM=.TRUE.
      ELSE
         NAME=' '
         CALL LCMNXT(IPSYSP,NAME,NAMLCM,NAMMY,LCM)
          CALL LCMLEN(IPSYSP,NAMA,LAP,ITYLCM)
          CALL LCMLEN(IPSYSP,NAMB,LBP,ITYLCM)
         IF(LCM) THEN
*           IN-CORE STORAGE.
            IF(LAP.GT.0) IAP=LCMIOF(IPSYSP,NAMA)
            IF(LBP.GT.0) IBP=LCMIOF(IPSYSP,NAMB)
         ELSE
*           XSM STORAGE.
             IF(LAP.GT.0) CALL SETARA(BASE,LAP,IAP)
             IF(LBP.GT.0) CALL SETARA(BASE,LBP,IBP)
             IF(LAP.GT.0) CALL LCMGET(IPSYSP,NAMA,BASE(IAP))
             IF(LBP.GT.0) CALL LCMGET(IPSYSP,NAMB,BASE(IBP))
         ENDIF
      ENDIF
*
* COMPUTE THE LINEAR PRODUCTS AFTER PERTURBATION
      IF(ITRANA.NE.0) THEN
         CALL SETARA(BASE,NUN,IV1A)
*
        IF(IGR.EQ.JGR) THEN
         IF(IPSYSP.NE.0) THEN
           CALL MTLDLM(NAMA,IPTRK,IPSYSP,ADECT(1,JGR),BASE(IV1A))
         ELSE
           DO 20 I=1,NUN
   20      BASE(IV1A+I-1)=0.0
         ENDIF
        ELSE
        IF(LAP.GT.0) THEN
           DO 30 I=1,NUN
   30      BASE(IV1A+I-1)=BASE(IAP+I-1)*ADECT(I,IGR)
        ELSE
           DO 35 I=1,NUN
   35      BASE(IV1A+I-1)=0.0
        ENDIF
        ENDIF
          IF(LAP.GT.0.OR.IGR.EQ.JGR) THEN
        WRITE(TEXT,'(4HPV1A,I3,I3)') IGR,JGR
        CALL LCMPUT(IPFLUP,TEXT,NUN,2,BASE(IV1A))
          ENDIF
         CALL RLSARA(BASE(IV1A))
      ENDIF
      IF(ITRANB.NE.0) THEN
        CALL SETARA(BASE,NUN,IV1B)
        IF(LBP.GT.0) THEN
           DO 50 I=1,NUN
   50      BASE(IV1B+I-1)=BASE(IBP+I-1)*ADECT(I,IGR)/FKEFF
        ELSE
           DO 55 I=1,NUN
   55      BASE(IV1B+I-1)=0.0
        ENDIF
        WRITE(TEXT,'(4HPV1B,I3,I3)') IGR,JGR
        CALL LCMPUT(IPFLUP,TEXT,NUN,2,BASE(IV1B))
        CALL RLSARA(BASE(IV1B))
      ENDIF
      IF(.NOT.LCM) THEN
         IF(LBP.GT.0) CALL RLSARA(BASE(IBP))
         IF(LAP.GT.0) CALL RLSARA(BASE(IAP))
      ENDIF
* BILINEAR PRODUCT FOR PRECURSOR
      IF(LBI) THEN
      DO 900 II=1,NDG
      WRITE(NAMB,'(1HB,I3,I3,I3)') II,IGR,JGR
         CALL LCMLEN(IPSYS0,NAMB,LENGB,ITYLCM)
      IF(LCM) THEN
*        IN-CORE STORAGE.
           IF(LENGB.GT.0) IB=LCMIOF(IPSYS0,NAMB)
      ELSE
*        XSM STORAGE.
          IF(LENGB.GT.0) CALL SETARA(BASE,LENGB,IB)
          IF(LENGB.GT.0) CALL LCMGET(IPSYS0,NAMB,BASE(IB))
      ENDIF
*
      IF(ITRANB.NE.0) THEN
        IF(LENGB.GT.0) THEN
         CALL SETARA(BASE,NUN,IV0B)
        DO 915 I=1,NUN
  915   BASE(IV0B+I-1)=BASE(IB+I-1)*ADECT(I,IGR)/FKEFF
        WRITE(TEXT,'(3HP0B,I3,I3,I3)') II,IGR,JGR
        CALL LCMPUT(IPFLUP,TEXT,NUN,2,BASE(IV0B))
        CALL RLSARA(BASE(IV0B))
        ENDIF
      ENDIF
      IF(.NOT.LCM) THEN
       IF(LENGB.GT.0) CALL RLSARA(BASE(IB))
      ENDIF
*
* RECOVER THE DELTA SYSTEM MATRICES.
      IF(IPSYSP.EQ.0) THEN
          LBP=0
         LCM=.TRUE.
      ELSE
         NAME=' '
         CALL LCMNXT(IPSYSP,NAME,NAMLCM,NAMMY,LCM)
          CALL LCMLEN(IPSYSP,NAMB,LBP,ITYLCM)
         IF(LCM) THEN
*           IN-CORE STORAGE.
            IF(LBP.GT.0) IBP=LCMIOF(IPSYSP,NAMB)
         ELSE
*           XSM STORAGE.
             IF(LBP.GT.0) CALL SETARA(BASE,LBP,IBP)
             IF(LBP.GT.0) CALL LCMGET(IPSYSP,NAMB,BASE(IBP))
         ENDIF
      ENDIF
*
      IF(ITRANB.NE.0) THEN
        CALL SETARA(BASE,NUN,IV1B)
        IF(LBP.GT.0) THEN
           DO 950 I=1,NUN
  950      BASE(IV1B+I-1)=BASE(IBP+I-1)*ADECT(I,IGR)/FKEFF
        ELSE
           DO 955 I=1,NUN
  955      BASE(IV1B+I-1)=0.0
        ENDIF
        WRITE(TEXT,'(3HP1B,I3,I3,I3)') II,IGR,JGR
        CALL LCMPUT(IPFLUP,TEXT,NUN,2,BASE(IV1B))
        CALL RLSARA(BASE(IV1B))
      ENDIF
      IF(.NOT.LCM) THEN
         IF(LBP.GT.0) CALL RLSARA(BASE(IBP))
      ENDIF
 900  CONTINUE
      ENDIF
*
  11  CONTINUE
  10  CONTINUE
      RETURN
      END
