*DECK LINPER
      SUBROUTINE LINPER(IPPROC,NAMFAM,NAMREC)
*
**********************************************************************
*
*    THIS MODULE IS USED TO READ INFORMATIONS ABOUT DEVICE POSITION
*    OR SPEED MODIFICATION ( OPTION DEVC )
*
*
*
*     INPUT :
*              IPPROC : INTEGER
*                       ADDRESS OF PROCEDE OBJECT
*              NAMFAM : CHARACTER*12
*                       DEVICE FAMILY NAME
*              DT     : REAL
*                       TIME STEP FOR LZC VALVE
*              NAMREC : CHARACTER*12
*                       RECORD NAME TO UPDATE
*     OUTPUT :
*              IPPROC : INTEGER
*                       ADDRESS OF PROCEDE OBJECT
*
*-------------------------------------- AUTHOR: E. VARIN  95/02/10 ---
*
      IMPLICIT     NONE
      INTEGER      IPPROC
      CHARACTER*12 NAMFAM,NAMREC
*
*     PROCEDE STRUCTURE
*
      REAL         NIV
*
C
      CHARACTER*12 TEXT
      INTEGER NITMA
      REAL FLOTT
      DOUBLE PRECISION DFLOTT
*
      CHARACTER*12 NMLCM,MYNAM,FIRSTS,NXSEQ
      INTEGER      ITYP,ILONG
      LOGICAL      LCM,ALL,SOME,DIR
*
*     READ INPUT DATA VALUES
*
      DIR = .FALSE.
      ALL = .FALSE.
      SOME = .FALSE.
  10  CALL REDGET(ITYP,NITMA,FLOTT,TEXT,DFLOTT)
      IF(ITYP.NE.3) CALL XABORT('LINPER: CHARACTER DATA EXPECTED')
      IF (TEXT.EQ.'ALL') THEN
          ALL = .TRUE.
          IF( SOME.OR.DIR )CALL XABORT('LINPER: CHOOSE ONLY ONE '
     1     //'OPTION BETWEEN SOME, ALL AND DIRECT ')
          CALL REDGET(ITYP,NITMA,NIV,TEXT,DFLOTT)
          IF (ITYP.NE.2)
     +      CALL XABORT('LINPER: REAL DATA EXPECTED')
          NXSEQ = ' '
          CALL LCMNXT(IPPROC,NXSEQ,NMLCM,MYNAM,LCM)
          FIRSTS=NXSEQ
 30       CALL LCMNXT(IPPROC,NXSEQ,NMLCM,MYNAM,LCM)
          CALL LCMLEN(IPPROC,NXSEQ,ILONG,ITYP)
          IF (ITYP.EQ.0) THEN
*  SEQUENCE LEVEL
            CALL LCMSIX(IPPROC,NXSEQ,1)
            CALL LCMPUT(IPPROC,NAMREC,1,2,NIV)
            CALL LCMSIX(IPPROC,' ',2)
          ENDIF
          IF(NXSEQ.EQ.FIRSTS) GOTO 100
          GOTO 30
*
      ELSEIF (TEXT.EQ.'SOME') THEN
          IF( ALL.OR.DIR )CALL XABORT('LINPER: CHOOSE ONLY ONE '
     1     //'OPTION BETWEEN SOME, ALL AND DIRECT ')
          SOME = .TRUE.
          CALL REDGET(ITYP,NITMA,FLOTT,TEXT,DFLOTT)
          IF (ITYP.NE.3) CALL XABORT('LINPER: CHARACTER DATA EXPECTED')
          IF(TEXT.EQ.'NAME') THEN
            CALL REDGET(ITYP,NITMA,FLOTT,NXSEQ,DFLOTT)
            IF (ITYP.NE.3)
     +       CALL XABORT('LINPER: CHARACTER DATA EXPECTED')
          ELSE
            CALL XABORT('LINPER: ILLEGAL KEYWORD '//TEXT)
          ENDIF
          CALL REDGET(ITYP,NITMA,NIV,TEXT,DFLOTT)
          IF (ITYP.NE.2)
     +      CALL XABORT('LINPER: REAL DATA EXPECTED')
          CALL LCMLEN(IPPROC,NXSEQ,ILONG,ITYP)
          IF (ITYP.EQ.0) THEN
*  SEQUENCE LEVEL
            CALL LCMSIX(IPPROC,NXSEQ,1)
            CALL LCMPUT(IPPROC,NAMREC,1,2,NIV)
            CALL LCMSIX(IPPROC,' ',2)
          ELSE
            CALL XABORT('LINPER: INVALID DEVICE NAME '//NXSEQ)
          ENDIF
          GOTO 10
*
      ELSEIF (TEXT.EQ.'DIRECT') THEN
          DIR = .TRUE.
          IF( ALL.OR.SOME )CALL XABORT('LINPER: CHOOSE ONLY ONE '
     1     //'OPTION BETWEEN SOME, ALL AND DIRECT ')
      ELSEIF (TEXT.EQ.'END') THEN
          GOTO 100
      ELSE
         CALL XABORT('LINPER: INVALID KEYWORD '//TEXT)
      ENDIF
*
 100  RETURN
      END
