*DECK LZCCAL
      SUBROUTINE LZCCAL(IPPROC,IPLDEV,IPRT)
*
**********************************************************************
*
*     THIS SUBROUTINE COMPUTES LIQUID ZONE FILLING FRACTION
*     IN REFERENCE TO FULL DESCRIPTOR
*
*     CETTE ROUTINE CALCULE LE NIVEAU DE REMPLISSAGE DES BARRES
*     LIQUIDES EN UTILISANT LA DESCRIPTION DE LA BARRE PLEINE
*
*     INPUT :
*              IPLDEV : INTEGER
*                       ADRESS OF DEVICE OBJECT
*              IPRT   : INTEGER
*                       PRINT FLAG
*     OUTPUT :
*              IPPROC : INTEGER
*                       ADRESS OF PROCEDE OBJECT
*
*-------------------------------------- AUTHOR: E. VARIN  95/02/10 ---
*
*
      IMPLICIT     NONE
      INTEGER      IPPROC,IPLDEV,IPRT
*
*     PROCEDE STRUCTURE
*
      REAL         NIV,YFULL
*
*     DEVICE STRUCTURE
*
      CHARACTER*12 NXSEQ,NAMDES
      REAL         POS(6),PMAX(6)
      CHARACTER*4  MOVDIR
*
*
      CHARACTER*12 NMLCM,MYNAM,FIRSTS
      INTEGER      ITYP,ILONG,I,IXM,IXP,IYM,IYP,IZM,IZP,
     +             KCHAR(3),ILG,ITP,IMOV
      REAL         DIFF,DIFFM
      LOGICAL      LCM
*
      NXSEQ = ' '
      CALL LCMNXT(IPLDEV,NXSEQ,NMLCM,MYNAM,LCM)
      FIRSTS=NXSEQ
10    CALL LCMNXT(IPLDEV,NXSEQ,NMLCM,MYNAM,LCM)
      CALL LCMLEN(IPLDEV,NXSEQ,ILONG,ITYP)
      IF (ITYP.EQ.0) THEN
*  LEVEL SEQUEN
       CALL LCMSIX(IPLDEV,NXSEQ,1)
       CALL LCMSIX(IPPROC,NXSEQ,1)
       CALL LCMGET(IPLDEV,'POSITION_MAX',PMAX)
       CALL LCMGET(IPLDEV,'MOVEMENT_DIR',IMOV)
       WRITE(MOVDIR,'(A4)') IMOV
       CALL LCMGET(IPPROC,'NAMFUL',KCHAR)
       WRITE(NAMDES,'(3A4)') (KCHAR(I),I=1,3)
       CALL LCMSIX(IPLDEV,NAMDES,1)
       CALL LCMGET(IPLDEV,'POSITION',POS)
       IF (MOVDIR.EQ.'X') THEN
         IXM = 3
         IXP = 4
         IYM = 1
         IYP = 2
         IZM = 5
         IZP = 6
       ELSEIF (MOVDIR.EQ.'Y') THEN
         IXM = 1
         IXP = 2
         IYM = 3
         IYP = 4
         IZM = 5
         IZP = 6
       ELSEIF (MOVDIR.EQ.'Z') THEN
         IXM = 1
         IXP = 2
         IYM = 5
         IYP = 6
         IZM = 3
         IZP = 4
       ENDIF
       CALL LCMLEN(IPPROC,'YFULL',ILG,ITP)
       IF (ILG.NE.0) THEN
         CALL LCMGET(IPPROC,'YFULL',YFULL)
       ELSE
         YFULL = PMAX(IYM)
       ENDIF
       DIFFM = PMAX(IYP) - YFULL
       DIFF  = POS(IYP) - POS(IYM)
       NIV   = DIFF / DIFFM
       IF (IPRT.GT.3) THEN
        WRITE(6,*) ' LZC ',NXSEQ,' LEVEL ',
     >              NIV*100,' % OF FULL FILLING'
       ENDIF
*
*     STORAGE OF INFORMATION IN L_PROCEDE
*
       CALL LCMPUT(IPPROC,'NIV',1,2,NIV)
*
       CALL LCMSIX(IPPROC,' ',2)
       CALL LCMSIX(IPLDEV,' ',2)
       CALL LCMSIX(IPLDEV,' ',2)
      ENDIF
      IF(NXSEQ.EQ.FIRSTS) GOTO 100
      GOTO 10
*
 100  RETURN
      END
