*DECK LZCMOV
      SUBROUTINE LZCMOV(IPLDEV,IPPROC,NAMTYP,NAMFAM,IPRT,DT)
*
*
**********************************************************************
*
*     THIS SUBROUTINE COMPUTES THE NEW COORDINATES OF THE FULL
*     AND EMPTY DESCRIPTOR PARTS ACCORDING TO SPEED.
*
*     CETTE ROUTINE CALCULE LES NOUVELLES COORDONNEES DU NIVEAU
*     DE REMPLISSAGE DES BARRES LIQUIDES SELON LEUR VITESSE
*     DE DEPLACEMENT
*
*     INPUT :
*              IPLDEV : INTEGER
*                       ADRESS OF DEVICE OBJECT
*              NAMTYP : CHARACTER*12
*                       DEVICE TYPE NAME
*              NAMFAM : CHARACTER*12
*                       DEVICE FAMILY NAME
*              DT     : REEL
*                       SIMULATION TIME STEP
*              IPRT   : INTEGER
*                       PRINTING FLAG
*     OUTPUT :
*              IPLDEV : INTEGER
*                       ADRESS OF DEVICE OBJECT
*
*-------------------------------------- AUTHOR: E. VARIN  95/02/10 ---
*
*
*      IMPLICIT     NONE
      INTEGER      IPLDEV,IPRT,IPPROC
*
*     DEVICE STRUCTURE
*
      CHARACTER*12 NAMTYP,NAMFAM,NXSEQ,NXDES
      REAL         POS(6),PMAX(6),SPEED
      CHARACTER*4  MOVDIR
*
*
      INTEGER      IXM,IXP,IYM,IYP,IZM,IZP,ILONG,ITYP,I,KCHAR(3),
     +             ILG,ITP,IMOV
      REAL         DT,DY,POSINT,YFULL
      CHARACTER*12 NMLCM,MYNAM,FIRST
      LOGICAL      LCM
*
*
      CALL LCMSIX(IPLDEV,' ',0)
      CALL LCMSIX(IPLDEV,NAMTYP,1)
      CALL LCMSIX(IPLDEV,NAMFAM,1)
      CALL LCMSIX(IPPROC,' ',0)
      CALL LCMSIX(IPPROC,NAMFAM,1)
      NXSEQ = ' '
      CALL LCMNXT(IPLDEV,NXSEQ,NMLCM,MYNAM,LCM)
      FIRST = NXSEQ
 10   CALL LCMNXT(IPLDEV,NXSEQ,NMLCM,MYNAM,LCM)
      CALL LCMLEN(IPLDEV,NXSEQ,ILONG,ITYP)
      IF(ITYP.EQ.0) THEN
        CALL LCMSIX(IPPROC,NXSEQ,1)
        CALL LCMSIX(IPLDEV,NXSEQ,1)
        CALL LCMGET(IPLDEV,'MOVEMENT_DIR',IMOV)
        WRITE(MOVDIR,'(A4)') IMOV
        CALL LCMGET(IPLDEV,'POSITION_MAX',PMAX)
        CALL LCMGET(IPLDEV,'SPEED',SPEED)
        IF (MOVDIR.EQ.'X') THEN
          IXM = 3
          IXP = 4
          IYM = 1
          IYP = 2
          IZM = 5
          IZP = 6
        ELSEIF (MOVDIR.EQ.'Y') THEN
          IXM = 1
          IXP = 2
          IYM = 3
          IYP = 4
          IZM = 5
          IZP = 6
        ELSEIF (MOVDIR.EQ.'Z') THEN
          IXM = 1
          IXP = 2
          IYM = 5
          IYP = 6
          IZM = 3
          IZP = 4
        ENDIF
        CALL LCMLEN(IPPROC,'YFULL',ILG,ITP)
        IF (ILG.NE.0) THEN
         CALL LCMGET(IPPROC,'YFULL',YFULL)
        ELSE
         YFULL = PMAX(IYM)
        ENDIF
*
*       COMPUTE NEW DEVICE POSITION FROM ITS SPEED
*
        CALL LCMGET(IPPROC,'NAMFUL',KCHAR)
        WRITE(NXDES,'(3A4)') (KCHAR(I),I=1,3)
        CALL LCMSIX(IPLDEV,NXDES,1)
        CALL LCMGET(IPLDEV,'POSITION',POS)
        CALL LCMSIX(IPLDEV,' ',2)
        DY = SPEED * DT
        POSINT = POS(IYM) - DY
        IF (POSINT.LT.YFULL) THEN
            POSINT = YFULL
        ENDIF
        IF (POSINT.GT.PMAX(IYP)) THEN
            POSINT = PMAX(IYP)
        ENDIF
        IF(IPRT.GT.3) THEN
          WRITE(6,*) ' LZC ',NXSEQ
          WRITE(6,*) ' SPEED = ',SPEED
          WRITE(6,*) ' PMAX(IYM) PMAX(IYP) = ',YFULL,PMAX(IYP)
          WRITE(6,*) ' POSINT = ',POSINT
        ENDIF
*
*       NEW POSITION STORAGE
*
        NXDES = ' '
        CALL LCMGET(IPPROC,'NAMFUL',KCHAR)
        WRITE(NXDES,'(3A4)') (KCHAR(I),I=1,3)
        CALL LCMSIX(IPLDEV,NXDES,1)
        CALL LCMGET(IPLDEV,'POSITION',POS)
        POS(IYM) = POSINT
        CALL LCMPUT(IPLDEV,'POSITION',6,2,POS)
        CALL LCMSIX(IPLDEV,' ',2)
*
        NXDES = ' '
        CALL LCMGET(IPPROC,'NAMEMP',KCHAR)
        WRITE(NXDES,'(3A4)') (KCHAR(I),I=1,3)
        CALL LCMSIX(IPLDEV,NXDES,1)
        CALL LCMGET(IPLDEV,'POSITION',POS)
        POS(IYP) = POSINT
        CALL LCMPUT(IPLDEV,'POSITION',6,2,POS)
        CALL LCMSIX(IPLDEV,' ',2)
*
        CALL LCMSIX(IPPROC,' ',2)
        CALL LCMSIX(IPLDEV,' ',2)
      ENDIF
      IF(NXSEQ.EQ.FIRST) GOTO 20
      GOTO 10
*
 20   RETURN
      END
