*DECK LZCNIV
      SUBROUTINE LZCNIV(IPPROC,IPLDEV,IPRT)
*
**********************************************************************
*
*     THIS SUBROUTINE COMPUTES NEW LIQUID ZONE POSITIONS
*     ACCORDING TO FULL FILLING FRACTION STORED IN PROCEDE
*     OBJECT
*
*     CETTE ROUTINE CALCULE LES NOUVEAUX NIVEAUX DES BARRES
*     LIQUIDES EN FONCTION DU NIVEAU LUE, RANGEE
*     DANS L'OBJET PROCEDE
*
*     INPUT :
*              IPLDEV : INTEGER
*                       ADRESS OF DEVICE OBJECT
*              IPPROC : INTEGER
*                       ADRESS OF PROCEDE OBJECT
*              IPRT   : INTEGER
*                       PRINTING FLAG
*     OUTPUT :
*              IPLDEV : INTEGER
*                       ADRESS OF DEVICE OBJECT
*
*-------------------------------------- AUTHOR: E. VARIN  95/04/08 ---
*
*
      IMPLICIT     NONE
      INTEGER      IPPROC,IPLDEV,IPRT
*
*     PROCEDE STRUCTURE
*
      REAL         NIV,YFULL
*
*     DEVICE STRUCTURE
*
      CHARACTER*12 NXSEQ,NMLCM,MYNAM,FIRSTS,NXDES
      REAL         POS(6),PMAX(6)
      CHARACTER*4  MOVDIR
      LOGICAL      LCM
*
      INTEGER      I,IXM,IXP,IYM,IYP,IZM,IZP,
     +             KCHAR(3),ILG,ITP,IMOV,ILONG,ITYP
      REAL         DIFF,DIFFM,POSINT
*
      NXSEQ = ' '
      CALL LCMNXT(IPPROC,NXSEQ,NMLCM,MYNAM,LCM)
      FIRSTS=NXSEQ
10    CALL LCMNXT(IPPROC,NXSEQ,NMLCM,MYNAM,LCM)
      CALL LCMLEN(IPPROC,NXSEQ,ILONG,ITYP)
      IF (ITYP.EQ.0) THEN
       CALL LCMSIX(IPPROC,NXSEQ,1)
       CALL LCMSIX(IPLDEV,NXSEQ,1)
* LEVEL SEQUENCE
       CALL LCMGET(IPLDEV,'POSITION_MAX',PMAX)
       CALL LCMGET(IPLDEV,'MOVEMENT_DIR',IMOV)
       WRITE(MOVDIR,'(A4)') IMOV
       CALL LCMGET(IPPROC,'NIV',NIV)
       CALL LCMGET(IPPROC,'NAMFUL',KCHAR)
       WRITE(NXDES,'(3A4)') (KCHAR(I),I=1,3)
       CALL LCMSIX(IPLDEV,NXDES,1)
       CALL LCMGET(IPLDEV,'POSITION',POS)
       CALL LCMSIX(IPLDEV,' ',2)
       IF (MOVDIR.EQ.'X') THEN
         IXM = 3
         IXP = 4
         IYM = 1
         IYP = 2
         IZM = 5
         IZP = 6
       ELSEIF (MOVDIR.EQ.'Y') THEN
         IXM = 1
         IXP = 2
         IYM = 3
         IYP = 4
         IZM = 5
         IZP = 6
       ELSEIF (MOVDIR.EQ.'Z') THEN
         IXM = 1
         IXP = 2
         IYM = 5
         IYP = 6
         IZM = 3
         IZP = 4
       ENDIF
       CALL LCMLEN(IPPROC,'YFULL',ILG,ITP)
       IF (ILG.NE.0) THEN
         CALL LCMGET(IPPROC,'YFULL',YFULL)
       ELSE
         YFULL = PMAX(IYM)
       ENDIF
       DIFFM = PMAX(IYP) - YFULL
       DIFF  = NIV * DIFFM
       POSINT = POS(IYP) - DIFF
       IF (POSINT.LT.YFULL) THEN
            POSINT = YFULL
       ENDIF
       IF (POSINT.GT.PMAX(IYP)) THEN
            POSINT = PMAX(IYP)
       ENDIF
       IF (IPRT.GT.3) THEN
        WRITE(6,*) ' LZC ',NXSEQ,' LEVEL ',NIV*100.,' % OF FULL FILLING'
        WRITE(6,*) ' NEW POSITIONS FOR FILLING LZC '
        WRITE(6,*) ' POS(IYM) = ',POSINT,' POS(IYP) = ',PMAX(IYP)
       ENDIF
*
*      NEW POSITION STORAGE
*
        NXDES = ' '
        CALL LCMGET(IPPROC,'NAMFUL',KCHAR)
        WRITE(NXDES,'(3A4)') (KCHAR(I),I=1,3)
        CALL LCMSIX(IPLDEV,NXDES,1)
        CALL LCMGET(IPLDEV,'POSITION',POS)
        POS(IYM) = POSINT
        CALL LCMPUT(IPLDEV,'POSITION',6,2,POS)
        CALL LCMSIX(IPLDEV,' ',2)
*
        NXDES = ' '
        CALL LCMGET(IPPROC,'NAMEMP',KCHAR)
        WRITE(NXDES,'(3A4)') (KCHAR(I),I=1,3)
        CALL LCMSIX(IPLDEV,NXDES,1)
        CALL LCMGET(IPLDEV,'POSITION',POS)
        POS(IYP) = POSINT
        CALL LCMPUT(IPLDEV,'POSITION',6,2,POS)
        CALL LCMSIX(IPLDEV,' ',2)
*
       CALL LCMSIX(IPLDEV,' ',2)
       CALL LCMSIX(IPPROC,' ',2)
      ENDIF
      IF(NXSEQ.EQ.FIRSTS) GOTO 100
      GOTO 10
  100 RETURN
      END
