*DECK LZCRED
      SUBROUTINE LZCRED(IPPROC,IPLDEV,NAMTYP,PROCTP,IPRT)
*
**********************************************************************
*
*     THIS ROUTINE READS LIQUID ZONE CONTROLLER INFORMATION AND
*     STORE THEM IN PROCEDE OBJECT
*
*     CETTE ROUTINE LIT LES INFORMATIONS POUR CHAQUE BARRE LIQUIDE
*     QUI DOIVENT ETRE STOCKEES DANS L'OBJET PROCEDE
*
*     INPUT :
*              IPLDEV : INTEGER
*                       ADRESS OF DEVICE OBJECT
*              NAMTYP : CHARACTER*12
*                       ROD TYPE NAME
*              PROCTP : CHARACTER*12
*                       ROD FAMILY NAME
*              IPRT   : INTEGER
*                       PRINTING FLAG
*     OUTPUT :
*              IPPROC : INTEGER
*                       ADRESS OF PROCEDE OBJECT
*
*
*-------------------------------------- AUTHOR: E. VARIN  95/02/10 ---
*
*
* PROCEDE STRUCTURE
*
      CHARACTER PROCTP*12,DEVICE*12,NAMFUL*12,NAMEMP*12,NAMTYP*12
      INTEGER   NUMBER,IPRT,IPPROC,IPLDEV
      REAL      BIAS,TIME(2),ZFLOW(2),YFULL
*
      CHARACTER*12 TEXT
      INTEGER ITYP,NITMA,I,ILONG,INAME(3)
      REAL FLOTT
      DOUBLE PRECISION DFLOTT
*
*     VERIFICATION OF PROCTP TYPE IN IPPROC OBJECT
*
      CALL LCMSIX(IPPROC,' ',0)
      CALL LCMLEN(IPPROC,PROCTP,ILONG,ITYP)
      IF (ITYP.NE.0) CALL XABORT('LZCRED: '//PROCTP//
     +      ' DOES NOT EXIST IN PROCEDE OBJECT')
      CALL LCMSIX(IPPROC,PROCTP,1)
*
*     READING OF THE CONTROLLER NAME AND PARAMETERS
*
      CALL REDGET(ITYP,NITMA,FLOTT,TEXT,DFLOTT)
      IF(ITYP.EQ.3) THEN
        IF (TEXT.EQ.'NAME') THEN
         CALL REDGET(ITYP,NITMA,FLOTT,DEVICE,DFLOTT)
         IF (ITYP.NE.3) CALL XABORT('LZCRED: CHARACTER DATA EXPECTED')
         CALL LCMLEN(IPPROC,DEVICE,ILONG,ITYP)
         IF (ITYP.NE.0) CALL XABORT('LZCRED: '//DEVICE//
     +      ' DOES NOT EXIST IN PROCEDE OBJECT')
         CALL LCMSIX(IPPROC,DEVICE,1)
        ELSE
         CALL XABORT('LZCRED: KEYWORD NAME IS REQUIRED')
        ENDIF
      ELSE
         CALL XABORT('LZCRED: CHARACTER DATA EXPECTED')
      ENDIF
*
  10  CALL REDGET(ITYP,NITMA,FLOTT,TEXT,DFLOTT)
      IF(ITYP.EQ.3) THEN
        IF (TEXT.EQ.'NAMFUL') THEN
         CALL REDGET(ITYP,NITMA,FLOTT,NAMFUL,DFLOTT)
         IF (ITYP.NE.3) CALL XABORT('LZCRED: CHARACTER DATA EXPECTED')
        ELSEIF (TEXT.EQ.'NAMEMP') THEN
         CALL REDGET(ITYP,NITMA,FLOTT,NAMEMP,DFLOTT)
         IF (ITYP.NE.3) CALL XABORT('LZCRED: CHARACTER DATA EXPECTED')
        ELSEIF (TEXT.EQ.'NB') THEN
          CALL REDGET(ITYP,NUMBER,FLOTT,TEXT,DFLOTT)
          IF (ITYP.NE.1) CALL XABORT('LZCRED: INTEGER DATA EXPECTED')
          CALL LCMPUT(IPPROC,'NUMBER',1,1,NUMBER)
        ELSEIF (TEXT.EQ.'BIAS') THEN
          CALL REDGET(ITYP,NITMA,BIAS,TEXT,DFLOTT)
          IF (ITYP.NE.2) CALL XABORT('LZCRED: REAL DATA EXPECTED')
          CALL LCMPUT(IPPROC,'BIAS',1,2,BIAS)
        ELSEIF (TEXT.EQ.'YFULL') THEN
          CALL REDGET(ITYP,NITMA,YFULL,TEXT,DFLOTT)
          IF (ITYP.NE.2) CALL XABORT('LZCRED: REAL DATA EXPECTED')
          CALL LCMPUT(IPPROC,'YFULL',1,2,YFULL)
        ELSEIF (TEXT.EQ.'TIME') THEN
          DO 40 I=1,2
           CALL REDGET(ITYP,NITMA,TIME(I),TEXT,DFLOTT)
           IF (ITYP.NE.2) CALL XABORT('LZCRED: REAL DATA EXPECTED')
  40      CONTINUE
          CALL LCMPUT(IPPROC,'TIME',2,2,TIME)
        ELSEIF (TEXT.EQ.'ZFLOW') THEN
          DO 50 I=1,2
           CALL REDGET(ITYP,NITMA,ZFLOW(I),TEXT,DFLOTT)
           IF (ITYP.NE.2) CALL XABORT('LZCRED: REAL DATA EXPECTED')
  50      CONTINUE
          CALL LCMPUT(IPPROC,'ZFLOW',2,2,ZFLOW)
        ELSEIF (TEXT.EQ.'END') THEN
          GOTO 30
        ELSE
          CALL XABORT('LZCRED: INVALID KEYWORD  '//TEXT)
        ENDIF
      ELSE
         CALL XABORT('LZCRED: CHARACTER DATA EXPECTED')
      ENDIF
      GOTO 10
*
*     STORAGE INFORMATION IN PROCEDE OBJECT
*
  30  CALL LCMSIX(IPLDEV,' ',0)
      CALL LCMSIX(IPLDEV,NAMTYP,1)
      CALL LCMSIX(IPLDEV,PROCTP,1)
      CALL LCMSIX(IPLDEV,DEVICE,1)
      IF(IPRT.GT.2) WRITE(6,*) 'LZC NAME ',DEVICE,
     +             ' NAMFUL ',NAMFUL,' NAMEMP ',NAMEMP
      CALL LCMLEN(IPLDEV,NAMFUL,ILONG,ITYP)
      IF (ITYP.NE.0) CALL XABORT('LZCRED: '//NAMFUL//
     +      ' DOES NOT EXIST IN DEVICE OBJECT')
      READ(NAMFUL,'(3A4)') (INAME(I),I=1,3)
      CALL LCMPUT(IPPROC,'NAMFUL',3,3,INAME)
      CALL LCMLEN(IPLDEV,NAMEMP,ILONG,ITYP)
      IF (ITYP.NE.0) CALL XABORT('LZCRED: '//NAMEMP//
     +      ' DOES NOT EXIST IN DEVICE OBJECT')
      READ(NAMEMP,'(3A4)') (INAME(I),I=1,3)
      CALL LCMPUT(IPPROC,'NAMEMP',3,3,INAME)
      CALL LCMSIX(IPLDEV,' ',0)
      CALL LCMSIX(IPPROC,' ',0)
*
      RETURN
      END
