*DECK LZCSPD
      SUBROUTINE LZCSPD(IPPROC,IPLDEV,IPRT,DT)
*
**********************************************************************
*
*     THIS SUBROUTINE COMPUTES FILLING SPEED OF THE
*     LIQUID ZONE CONTROLLERS AND CONVERTS IT IN CM/S.
*     FILLING CONSIGN IS GENERALLY PROVIDED BY RRS ROUTINES.
*
*     CETTE ROUTINE CALCULE LA VITESSE DE REMPLISSAGE
*     DES BARRES LIQUIDES EN UTILISANT LES DONNEES DE
*     L'OBJET PROCEDE FIXEES PAR LE SRR
*
*
*     INPUT :
*              IPPROC : INTEGER
*                       ADRESS OF PROCEDE OBJECT
*              IPLDEV : INTEGER
*                       ADRESS OF DEVICE OBJECT
*              IPRT   : INTEGER
*                       FLAG D'IMPRESSION
*              DT     : REAL
*                       SIMULATION TIME STEP
*     OUTPUT :
*              IPLDEV : INTEGER
*                       ADRESS OF DEVICE OBJECT
*
*
*-------------------------------------- AUTHOR: E. VARIN  95/02/10 ---
*
*
*      IMPLICIT     NONE
      INTEGER      IPPROC,IPLDEV,IPRT
*
*     PROCEDE STRUCTURE
*
      REAL         YVZ,ZFLOW(2),BIAS,TIME(2),YFULL
*
*     DEVICE STRUCTURE
*
      CHARACTER*4  MOVDIR
      REAL         SPEED,PMAX(6)
*
*
      INTEGER      ILONG,ITYP,IXM,IXP,IYM,IYP,IZM,IZP,ILG,ITP,IMOV
      REAL         DT,SPDVZ,LZCT
      CHARACTER*12 NXSEQ,NMLCM,MYNAM,FIRSTS
      LOGICAL      LCM
      PARAMETER    (LZCT=0.1)
*
*     RECUPERATION DU YVZ ET DES ANCIENS ZFLOW
*     POUR CALCULER LE NOUVEAU ZFLOW
*
      NXSEQ = ' '
      CALL LCMNXT(IPPROC,NXSEQ,NMLCM,MYNAM,LCM)
      FIRSTS=NXSEQ
10    CALL LCMNXT(IPPROC,NXSEQ,NMLCM,MYNAM,LCM)
      CALL LCMLEN(IPPROC,NXSEQ,ILONG,ITYP)
      IF (ITYP.EQ.0) THEN
       CALL LCMSIX(IPPROC,NXSEQ,1)
* NIVEAU SEQUENCE
       CALL LCMGET(IPPROC,'YVZ',YVZ)
       CALL LCMGET(IPPROC,'BIAS',BIAS)
       CALL LCMGET(IPPROC,'ZFLOW',ZFLOW)
       CALL SRFILT(ZFLOW(1),YVZ,ZFLOW(2),LZCT,DT,1)
       CALL LCMPUT(IPPROC,'ZFLOW',2,2,ZFLOW)
       CALL LCMGET(IPPROC,'TIME',TIME)
       SPDVZ = (ZFLOW(1) - BIAS) / (TIME(1)*(1.-BIAS))
*
*      CALCUL DE LA VITESSE EN CM/S ET RANGEMENT
*
       CALL LCMSIX(IPLDEV,NXSEQ,1)
       CALL LCMGET(IPLDEV,'POSITION_MAX',PMAX)
       CALL LCMGET(IPLDEV,'MOVEMENT_DIR',IMOV)
       WRITE(MOVDIR,'(A4)') IMOV
       IF (MOVDIR.EQ.'X') THEN
         IXM = 3
         IXP = 4
         IYM = 1
         IYP = 2
         IZM = 5
         IZP = 6
       ELSEIF (MOVDIR.EQ.'Y') THEN
         IXM = 1
         IXP = 2
         IYM = 3
         IYP = 4
         IZM = 5
         IZP = 6
       ELSEIF (MOVDIR.EQ.'Z') THEN
         IXM = 1
         IXP = 2
         IYM = 5
         IYP = 6
         IZM = 3
         IZP = 4
       ENDIF
       CALL LCMLEN(IPPROC,'YFULL',ILG,ITP)
       IF (ILG.NE.0) THEN
         CALL LCMGET(IPPROC,'YFULL',YFULL)
       ELSE
         YFULL = PMAX(IYM)
       ENDIF
*
       SPEED = (PMAX(IYP)-YFULL)*SPDVZ
       IF(IPRT.GT.3) THEN
         WRITE(6,*) 'CONTROLLER ',NXSEQ
         WRITE(6,*) 'SPEED  ',SPEED,' CM/S'
       ENDIF
       CALL LCMPUT(IPLDEV,'SPEED',1,2,SPEED)
*
       CALL LCMSIX(IPLDEV,' ',2)
       CALL LCMSIX(IPPROC,' ',2)
      ENDIF
      IF(NXSEQ.EQ.FIRSTS) GOTO 100
      GOTO 10
 100  RETURN
      END
