*DECK MACOLD
      SUBROUTINE MACOLD(MAXMIX,NGRP,ITYP,SGD)
*
*-----------------------------------------------------------------------
*
* READ CROSS SECTIONS IN THE TRIVAC-2 FORMAT AND CONVERT THEM TO THE
* DRAGON FORMAT.
*
* INPUT PARAMETERS:
*  MAXMIX : NUMBER OF MATERIAL MIXTURES.
*  NGRP   : NUMBER OF ENERGY GROUPS.
*  ITYP   : =1: READ NON-PERTURBED VALUES ; =2: READ PERTURBED VALUES.
*
* SCRATCH STORAGE:
*  SGD    : DIMENSION SGD(MAXMIX,14)
*
*-------------------------------------- AUTHOR: A. HEBERT ; 27/07/93 ---
*
      CHARACTER TEXT4*4
      DOUBLE PRECISION DFLOTT
      DIMENSION SGD(MAXMIX,*)
*
      IF(ITYP.EQ.1) THEN
         IR=0
   80    DO 120 IG=1,NGRP
         IIG=(IG-1)*7
         DO 90 J=1,6
         IF((J.EQ.2).OR.(J.EQ.3)) THEN
            SGD(IR+1,IIG+J)=SGD(IR+1,IIG+1)
         ELSE
            CALL REDGET(INDIC,NITMA,FLOTT,TEXT4,DFLOTT)
            IF((INDIC.EQ.3).AND.(J.EQ.1).AND.(IG.EQ.1)) GO TO 140
            IF(INDIC.NE.2) CALL XABORT('MACOLD: REAL DATA EXPECTED.')
            SGD(IR+1,IIG+J)=FLOTT
         ENDIF
   90    CONTINUE
         SGD(IR+1,IIG+7)=0.0
  100    CALL REDGET(INDIC,NITMA,FLOTT,TEXT4,DFLOTT)
         IF(INDIC.NE.3) CALL XABORT('MACOLD: CHARACTER DATA EXPECTED.')
         IF(TEXT4.EQ.'T') THEN
            CALL REDGET(INDIC,NITMA,SGD(IR+1,IIG+7),TEXT4,DFLOTT)
            IF(INDIC.NE.2) CALL XABORT('MACOLD: REAL DATA EXPECTED.')
            GO TO 100
         ELSE IF(TEXT4.EQ.'DY') THEN
*           LE COEFFICIENT DE DIFFUSION SELON Y EST DIFFERENT.
            CALL REDGET(INDIC,NITMA,SGD(IR+1,IIG+2),TEXT4,DFLOTT)
            IF(INDIC.NE.2) CALL XABORT('MACOLD: REAL DATA EXPECTED.')
            GO TO 100
         ELSE IF(TEXT4.EQ.'DZ') THEN
*           LE COEFFICIENT DE DIFFUSION SELON Z EST DIFFERENT.
            CALL REDGET(INDIC,NITMA,SGD(IR+1,IIG+3),TEXT4,DFLOTT)
            IF(INDIC.NE.2) CALL XABORT('MACOLD: REAL DATA EXPECTED.')
            GO TO 100
         ELSE IF(TEXT4.EQ.'*') THEN
            GO TO 120
         ELSE
            CALL XABORT('MACOLD: INVALID KEY WORD.')
         ENDIF
  120    CONTINUE
         IR=IR+1
         GO TO 80
*
  140    IF(TEXT4.NE.'*') CALL XABORT('MACOLD: * EXPECTED.')
         GO TO 220
      ELSE IF(ITYP.EQ.2) THEN
*        INPUT PERTURBED DIFFUSION COEFFICIENTS AND CROSS SECTIONS.
         DO 170 I=1,MAXMIX
         DO 170 J=1,14
  170    SGD(I,J)=0.0
  180    CALL REDGET(INDIC,NITMA,FLOTT,TEXT4,DFLOTT)
         IF(INDIC.EQ.1) THEN
            I=NITMA
            IF(I.GT.MAXMIX) CALL XABORT('MACOLD: INVALID MIXTURE NUM'
     1      //'BER.')
            DO 210 IG=1,NGRP
            IIG=(IG-1)*7
            DO 190 J=1,6
            IF((J.EQ.2).OR.(J.EQ.3)) THEN
               SGD(I,IIG+J)=SGD(I,IIG+1)
            ELSE
               CALL REDGET(INDIC,NITMA,FLOTT,TEXT4,DFLOTT)
               IF(INDIC.NE.2) CALL XABORT('MACOLD: REAL DATA EXPECTED.')
               SGD(I,IIG+J)=FLOTT
            ENDIF
  190       CONTINUE
  200       CALL REDGET(INDIC,NITMA,FLOTT,TEXT4,DFLOTT)
            IF(INDIC.NE.3) CALL XABORT('MACOLD: CHARACTER DATA EXPECT'
     1      //'ED.')
            IF(TEXT4.EQ.'T') THEN
               CALL REDGET(INDIC,NITMA,SGD(I,IIG+7),TEXT4,DFLOTT)
               IF(INDIC.NE.2) CALL XABORT('MACOLD: REAL DATA EXPECTED.')
               GO TO 200
            ELSE IF(TEXT4.EQ.'DY') THEN
               CALL REDGET(INDIC,NITMA,SGD(I,IIG+2),TEXT4,DFLOTT)
               IF(INDIC.NE.2) CALL XABORT('MACOLD: REAL DATA EXPECTED.')
               GO TO 200
            ELSE IF(TEXT4.EQ.'DZ') THEN
               CALL REDGET(INDIC,NITMA,SGD(I,IIG+3),TEXT4,DFLOTT)
               IF(INDIC.NE.2) CALL XABORT('MACOLD: REAL DATA EXPECTED.')
               GO TO 200
            ELSE IF(TEXT4.EQ.'*') THEN
               GO TO 210
            ELSE
               CALL XABORT('MACOLD: INVALUD KEY-WORD.')
            ENDIF
  210       CONTINUE
         ELSE IF(INDIC.EQ.2) THEN
            CALL XABORT('MACOLD: INTEGER OR CHARACTER DATA EXPECTED.')
         ELSE IF(INDIC.EQ.3) THEN
            IF(TEXT4.NE.'*') CALL XABORT('MACOLD: * EXPECTED.')
            GO TO 220
         ENDIF
         GO TO 180
      ENDIF
*
  220 WRITE(6,300)
      IF(NGRP.EQ.1) THEN
         DO 250 IBM=1,MAXMIX
         WRITE(6,'(5H MIX ,I5)') IBM
         WRITE(6,310) 'DIFFX',SGD(IBM,1)
         IF(SGD(IBM,2).NE.SGD(IBM,1)) THEN
            WRITE(6,310) 'DIFFY',SGD(IBM,2)
         ENDIF
         IF(SGD(IBM,3).NE.SGD(IBM,1)) THEN
            WRITE(6,310) 'DIFFY',SGD(IBM,3)
         ENDIF
         WRITE(6,310) 'TOTAL',SGD(IBM,4)
         IF(SGD(IBM,5).NE.0.0) THEN
           WRITE(6,310) 'NUSIGF',SGD(IBM,5)
         ENDIF
         IF(SGD(IBM,6).NE.0.0) THEN
            WRITE(6,310) 'H-FACTORS',SGD(IBM,6)
         ENDIF
         WRITE(6,'(6X,13HSCAT  1 1 0.0)')
  250    CONTINUE
      ELSE IF(NGRP.EQ.2) THEN
         DO 260 IBM=1,MAXMIX
         WRITE(6,'(5H MIX ,I5)') IBM
         WRITE(6,310) 'DIFFX',SGD(IBM,1),SGD(IBM,8)
         IF((SGD(IBM,2).NE.SGD(IBM,1)).OR.(SGD(IBM,9).NE.SGD(IBM,8)))
     1   THEN
            WRITE(6,310) 'DIFFY',SGD(IBM,2),SGD(IBM,9)
         ENDIF
         IF((SGD(IBM,3).NE.SGD(IBM,1)).OR.(SGD(IBM,10).NE.SGD(IBM,8)))
     1   THEN
            WRITE(6,310) 'DIFFY',SGD(IBM,3),SGD(IBM,10)
         ENDIF
         WRITE(6,310) 'TOTAL',SGD(IBM,4),SGD(IBM,11)
         IF((SGD(IBM,5).NE.0.0).OR.(SGD(IBM,12).NE.0.0)) THEN
           WRITE(6,310) 'NUSIGF',SGD(IBM,5),SGD(IBM,12)
         ENDIF
         IF((SGD(IBM,6).NE.0.0).OR.(SGD(IBM,13).NE.0.0)) THEN
            WRITE(6,310) 'H-FACTORS',SGD(IBM,6),SGD(IBM,13)
         ENDIF
         IF(SGD(IBM,7).NE.0.0) THEN
            WRITE(6,320) SGD(IBM,7),SGD(IBM,14)
         ELSE
            WRITE(6,330) SGD(IBM,14)
         ENDIF
  260    CONTINUE
      ENDIF
      CALL XABORT('MACOLD: GOOD LUCK THE NEXT TIME.')
      RETURN
*
  300 FORMAT(/53H MACOLD: PLEASE USE THE FOLLOWING CROSS SECTION INPUT,
     1 21H AND RERUN YOUR CASE.)
  310 FORMAT(1X,A9,1P,8E14.6/(10X,8E14.6))
  320 FORMAT(6X,9HSCAT  2 2,1P,E14.6,13H 0.0 2 2 0.0 ,E14.6)
  330 FORMAT(6X,21HSCAT  1 1 0.0 2 2 0.0,1P,E14.6)
      END
