*DECK MACXSI
      SUBROUTINE MACXSI (IPLIST,IND,NMIXT,NGRP,NDG,NL,IMPX,NBMIX,JND,
     x TOTAL,ZNUG,CHI,CHDL,OVERV,DIFFX,DIFFY,DIFFZ,H,S,IJJ,NJJ,SCAT,
     x WORK,IPOS)
*
*-----------------------------------------------------------------------
*
* READ CROSS SECTIONS AND STORE THEM IN A LINKED LIST.
*
* INPUT PARAMETERS:
*  IPLIST : ADDRESS OF THE LINKED LIST OR HANDLE TO THE XSM FILE.
*  IND    : =1 CROSS SECTIONS ARE INITIALIZED; =2 ... ARE UPDATED.
*  NMIXT  : MAXIMUM NUMBER OF MATERIAL MIXTURES.
*  NGRP   : NUMBER OF ENERGY GROUPS.
*  NL     : NUMBER OF LEGENDRE ORDERS (=1 FOR ISOTROPIC SCATTERING).
*  IMPX   : PRINT PARAMETER. EQUAL TO ZERO FOR NO PRINT.
*  NDG    : NUMBER OF DELAYED NEUTRON SPECTRUM.
*
* OUTPUT PARAMETER:
*  NBMIX  : MAXIMUM MATERIAL MIXTURE INDEX READ.
*  JND    : =1 ';' ENCOUNTERED; =2 'STEP' ENCOUNTERED.
*
* SCRATCH STORAGE:
*  TOTAL  : DIMENSION TOTAL(NMIXT,NGRP)
*  ZNUG   : DIMENSION ZNUG(NMIXT,NGRP)
*  CHI    : DIMENSION CHI(NMIXT,NGRP)
*  CHDL   : DIMENSION CHDL(NMIXT,NDG,NGRP)
*  OVERV  : DIMENSION OVERV(NMIXT,NGRP)
*  DIFFX  : DIMENSION DIFFX(NMIXT,NGRP)
*  DIFFY  : DIMENSION DIFFY(NMIXT,NGRP)
*  DIFFZ  : DIMENSION DIFFZ(NMIXT,NGRP)
*  H      : DIMENSION H(NMIXT,NGRP)
*  S      : DIMENSION S(NMIXT,NGRP)
*  IJJ    : DIMENSION IJJ(NMIXT,NL,NGRP)
*  NJJ    : DIMENSION NJJ(NMIXT,NL,NGRP)
*  SCAT   : SCAT(NMIXT,NL,NGRP,NGRP)
*  WORK   : WORK(NMIXT*NGRP)
*  IPOS   : IPOS(NMIXT)
*
* NOTE: ANY CROSS SECTION NOT READ IS SET TO ZERO.
*
*-------------------------------------- AUTHOR: A. HEBERT ; 26/07/93 ---
*
      LOGICAL LTO,LFI,LCH,LOV,LDX,LDY,LDZ,LHF,LSC,LSO,LBI
      DOUBLE PRECISION DFLOTT
      CHARACTER CGRPNM*12,CM*2,TEXT4*4,TEXT8*8,TEXT*8
      DIMENSION TOTAL(NMIXT,*),ZNUG(NMIXT,*),CHI(NMIXT,*),
     1 OVERV(NMIXT,*),DIFFX(NMIXT,*),DIFFY(NMIXT,*),DIFFZ(NMIXT,*),
     2 IJJ(NMIXT,NL,*),NJJ(NMIXT,NL,*),SCAT(NMIXT,NL,NGRP,*),H(NMIXT,*),
     3 S(NMIXT,*),WORK(*),IPOS(*),CHDL(NMIXT,NDG,*)
      COMMON BASE(1)
*
      IF(NMIXT.EQ.0) CALL XABORT('MACXSI: ZERO NUMBER OF MIXTURES.')
      IF(NGRP.EQ.0) CALL XABORT('MACXSI: ZERO NUMBER OF GROUPS.')
      IF(IMPX.GT.1) CALL LCMLIB(IPLIST)
      NBMIX=0
      LTO=.FALSE.
      LFI=.FALSE.
      LCH=.FALSE.
      LOV=.FALSE.
      LDX=.FALSE.
      LDY=.FALSE.
      LDZ=.FALSE.
      LHF=.FALSE.
      LSC=.FALSE.
      LSO=.FALSE.
      LBI=.FALSE.
      DO 10 IGR=1,NGRP
      DO 10 IBM=1,NMIXT
      TOTAL(IBM,IGR)=0.0
      ZNUG(IBM,IGR)=0.0
      CHI(IBM,IGR)=0.0
      DIFFX(IBM,IGR)=0.0
      DIFFY(IBM,IGR)=0.0
      DIFFZ(IBM,IGR)=0.0
      H(IBM,IGR)=0.0
      S(IBM,IGR)=0.0
      DO 10 IL=1,NL
      IJJ(IBM,IL,IGR)=IGR
      NJJ(IBM,IL,IGR)=1
      DO 10 JGR=1,NGRP
   10 SCAT(IBM,IL,JGR,IGR)=0.0
      IF(IND.EQ.2) THEN
*        RECOVER THE EXISTING MACROLIB DATA.
         DO 40 JGR=1,NGRP
         WRITE (CGRPNM,'(5HGROUP,I3,1H/,I3)') JGR,NGRP
         CALL LCMSIX(IPLIST,CGRPNM,1)
         CALL LCMLEN(IPLIST,'TOTAL',ILENGT,ITYLCM)
         IF(ILENGT.EQ.NMIXT) THEN
            CALL LCMGET(IPLIST,'TOTAL',TOTAL(1,JGR))
         ELSE IF(ILENGT.NE.0) THEN
            CALL XABORT('MACXSI: INVALID INPUT MACROLIB(1).')
         ENDIF
         CALL LCMLEN(IPLIST,'NUSIGF',ILENGT,ITYLCM)
         IF(ILENGT.EQ.NMIXT) CALL LCMGET(IPLIST,'NUSIGF',ZNUG(1,JGR))
         CALL LCMLEN(IPLIST,'CHI',ILENGT,ITYLCM)
         IF(ILENGT.EQ.NMIXT) CALL LCMGET(IPLIST,'CHI',CHI(1,JGR))
         DO 900 I=1,NDG
         WRITE (TEXT,'(4HCHDL,I3)') I
         CALL LCMLEN(IPLIST,TEXT,ILENGT,ITYLCM)
         IF(ILENGT.EQ.NMIXT) CALL LCMGET(IPLIST,TEXT,CHDL(1,I,JGR))
 900     CONTINUE
         CALL LCMLEN(IPLIST,'OVERV',ILENGT,ITYLCM)
         IF(ILENGT.EQ.NMIXT) CALL LCMGET(IPLIST,'OVERV',OVERV(1,JGR))
         CALL LCMLEN(IPLIST,'DIFFX',ILENGT,ITYLCM)
         IF(ILENGT.EQ.NMIXT) CALL LCMGET(IPLIST,'DIFFX',DIFFX(1,JGR))
         CALL LCMLEN(IPLIST,'DIFFY',ILENGT,ITYLCM)
         IF(ILENGT.EQ.NMIXT) CALL LCMGET(IPLIST,'DIFFY',DIFFY(1,JGR))
         CALL LCMLEN(IPLIST,'DIFFZ',ILENGT,ITYLCM)
         IF(ILENGT.EQ.NMIXT) CALL LCMGET(IPLIST,'DIFFZ',DIFFZ(1,JGR))
         CALL LCMLEN(IPLIST,'H-FACTORS',ILENGT,ITYLCM)
         IF(ILENGT.EQ.NMIXT) CALL LCMGET(IPLIST,'H-FACTORS',H(1,JGR))
         CALL LCMLEN(IPLIST,'FIXE',ILENGT,ITYLCM)
         IF(ILENGT.EQ.NMIXT) CALL LCMGET(IPLIST,'FIXE',S(1,JGR))
         DO 30 IL=1,NL
         WRITE (CM,'(I2)') IL-1
         CALL LCMLEN(IPLIST,'SCAT'//CM,ILENGT,ITYLCM)
         IF(ILENGT.GT.NMIXT*NL*NGRP*NGRP) THEN
            CALL XABORT('MACXSI: INVALID INPUT MACROLIB(2).')
         ELSE IF(ILENGT.GT.0) THEN
            CALL LCMGET(IPLIST,'SCAT'//CM,WORK)
            CALL LCMGET(IPLIST,'NJJ'//CM,NJJ(1,IL,JGR))
            CALL LCMGET(IPLIST,'IJJ'//CM,IJJ(1,IL,JGR))
            IPOSDE=0
            DO 20 IBM=1,NMIXT
            IJJ0=IJJ(IBM,IL,JGR)
            DO 20 IGR=IJJ0,IJJ0-NJJ(IBM,IL,JGR)+1,-1
            IPOSDE=IPOSDE+1
   20       SCAT(IBM,IL,IGR,JGR)=WORK(IPOSDE)
         ENDIF
   30    CONTINUE
         CALL LCMSIX(IPLIST,' ',2)
   40    CONTINUE
      ENDIF
*
   50 CALL REDGET(INDIC,NITMA,FLOTT,TEXT4,DFLOTT)
      IF(INDIC.NE.3) CALL XABORT('MACXSI: CHARACTER DATA EXPECTED(1).')
      IF(TEXT4.EQ.'OLD') THEN
*        CROSS SECTIONS ARE INPUT IN THE OLD TRIVAC-2 FORMAT.
         CALL SETARA(BASE,14*NMIXT,ISGD)
         CALL MACOLD(NMIXT,NGRP,1,BASE(ISGD))
         CALL RLSARA(BASE(ISGD))
      ELSE IF(TEXT4.EQ.'DOLD') THEN
*        CROSS SECTIONS ARE INPUT IN THE OLD TRIVAC-2 FORMAT.
         CALL SETARA(BASE,14*NMIXT,ISGD)
         CALL MACOLD(NMIXT,NGRP,2,BASE(ISGD))
         CALL RLSARA(BASE(ISGD))
      ELSE IF(TEXT4.EQ.'MIX') THEN
   60    CALL REDGET(INDIC,IBM,FLOTT,TEXT4,DFLOTT)
         IF(INDIC.NE.1) CALL XABORT('MACXSI: INTEGER DATA EXPECTED.')
         IF(IBM.GT.NMIXT) CALL XABORT('MACXSI: INVALID MIX INDEX.')
         NBMIX=MAX(NBMIX,IBM)
   70    CALL REDGET(INDIC,NITMA,FLOTT,TEXT8,DFLOTT)
         IF(INDIC.NE.3) CALL XABORT('MACXSI: CHARACTER DATA EXPECTED.')
         IF(TEXT8.EQ.'TOTAL') THEN
            LTO=.TRUE.
            DO 80 IGR=1,NGRP
            CALL REDGET(INDIC,NITMA,TOTAL(IBM,IGR),TEXT4,DFLOTT)
            IF(INDIC.NE.2) CALL XABORT('MACXSI: REAL DATA EXPECTED.')
   80       CONTINUE
         ELSE IF(TEXT8.EQ.'NUSIGF') THEN
            LFI=.TRUE.
            DO 90 IGR=1,NGRP
            CALL REDGET(INDIC,NITMA,ZNUG(IBM,IGR),TEXT4,DFLOTT)
            IF(INDIC.NE.2) CALL XABORT('MACXSI: REAL DATA EXPECTED.')
   90       CONTINUE
         ELSE IF(TEXT8.EQ.'CHI') THEN
            LCH=.TRUE.
            DO 95 IGR=1,NGRP
            CALL REDGET(INDIC,NITMA,CHI(IBM,IGR),TEXT4,DFLOTT)
            IF(INDIC.NE.2) CALL XABORT('MACXSI: REAL DATA EXPECTED.')
   95       CONTINUE
         ELSE IF(TEXT8.EQ.'CHDL') THEN
            LBI=.TRUE.
            DO 995 I=1,NDG
            DO 895 IGR=1,NGRP
            CALL REDGET(INDIC,NITMA,CHDL(IBM,I,IGR),TEXT4,DFLOTT)
            IF(INDIC.NE.2) CALL XABORT('MACXSI: REAL DATA EXPECTED.')
  895       CONTINUE
  995       CONTINUE
         ELSE IF(TEXT8.EQ.'MVEL') THEN
            LOV=.TRUE.
            DO 96 IGR=1,NGRP
            CALL REDGET(INDIC,NITMA,OVERV(IBM,IGR),TEXT4,DFLOTT)
            IF(INDIC.NE.2) CALL XABORT('MACXSI: REAL DATA EXPECTED.')
            IF(OVERV(IBM,IGR).EQ.0.) CALL XABORT('MACXSI: INVALID VELO'
     1      //'CITY VALUE.')
            OVERV(IBM,IGR)=1.0/OVERV(IBM,IGR)
   96       CONTINUE
         ELSE IF(TEXT8.EQ.'DIFFX') THEN
            LDX=.TRUE.
            DO 100 IGR=1,NGRP
            CALL REDGET(INDIC,NITMA,DIFFX(IBM,IGR),TEXT4,DFLOTT)
            IF(INDIC.NE.2) CALL XABORT('MACXSI: REAL DATA EXPECTED.')
  100       CONTINUE
         ELSE IF(TEXT8.EQ.'DIFFY') THEN
            LDY=.TRUE.
            DO 110 IGR=1,NGRP
            CALL REDGET(INDIC,NITMA,DIFFY(IBM,IGR),TEXT4,DFLOTT)
            IF(INDIC.NE.2) CALL XABORT('MACXSI: REAL DATA EXPECTED.')
  110       CONTINUE
         ELSE IF(TEXT8.EQ.'DIFFZ') THEN
            LDZ=.TRUE.
            DO 120 IGR=1,NGRP
            CALL REDGET(INDIC,NITMA,DIFFZ(IBM,IGR),TEXT4,DFLOTT)
            IF(INDIC.NE.2) CALL XABORT('MACXSI: REAL DATA EXPECTED.')
  120       CONTINUE
         ELSE IF(TEXT8.EQ.'H-FACTOR') THEN
            LHF=.TRUE.
            DO 130 IGR=1,NGRP
            CALL REDGET(INDIC,NITMA,H(IBM,IGR),TEXT4,DFLOTT)
            IF(INDIC.NE.2) CALL XABORT('MACXSI: REAL DATA EXPECTED.')
  130       CONTINUE
         ELSE IF(TEXT8.EQ.'SCAT') THEN
            LSC=.TRUE.
            DO 140 IL=1,NL
            DO 140 JGR=1,NGRP
            CALL REDGET(INDIC,NJJ(IBM,IL,JGR),FLOTT,TEXT4,DFLOTT)
            IF(INDIC.NE.1) CALL XABORT('MACXSI: INTEGER DATA EXPECTED.')
            CALL REDGET(INDIC,IJJ(IBM,IL,JGR),FLOTT,TEXT4,DFLOTT)
            IF(INDIC.NE.1) CALL XABORT('MACXSI: INTEGER DATA EXPECTED.')
            IJJ0=IJJ(IBM,IL,JGR)
            DO 140 IGR=IJJ0,IJJ0-NJJ(IBM,IL,JGR)+1,-1
*           SCAT(MIXTURE,LEGENDRE,PRIMARY,SECONDARY)
            CALL REDGET(INDIC,NITMA,SCAT(IBM,IL,IGR,JGR),TEXT4,DFLOTT)
            IF(INDIC.NE.2) CALL XABORT('MACXSI: REAL DATA EXPECTED.')
  140       CONTINUE
         ELSE IF(TEXT8.EQ.'FIXE') THEN
            LSO=.TRUE.
            DO 150 IGR=1,NGRP
            CALL REDGET(INDIC,NITMA,S(IBM,IGR),TEXT4,DFLOTT)
            IF(INDIC.NE.2) CALL XABORT('MACXSI: REAL DATA EXPECTED.')
  150       CONTINUE
         ELSE IF(TEXT8.EQ.'MIX') THEN
            GO TO 60
         ELSE IF(TEXT8.EQ.';') THEN
            JND=1
            GO TO 160
         ELSE IF(TEXT8.EQ.'STEP') THEN
            JND=2
            GO TO 160
         ELSE
            CALL XABORT('MACXSI: INVALID KEY-WORD(1).')
         ENDIF
         GO TO 70
      ELSE
         CALL XABORT('MACXSI: INVALID KEY-WORD(2).')
      ENDIF
      GO TO 50
*
  160 DO 190 JGR=1,NGRP
      WRITE (CGRPNM,'(5HGROUP,I3,1H/,I3)') JGR,NGRP
      CALL LCMSIX(IPLIST,CGRPNM,1)
      IF(LTO) CALL LCMPUT(IPLIST,'TOTAL',NMIXT,2,TOTAL(1,JGR))
      IF(LFI) CALL LCMPUT(IPLIST,'NUSIGF',NMIXT,2,ZNUG(1,JGR))
      IF(LCH) CALL LCMPUT(IPLIST,'CHI',NMIXT,2,CHI(1,JGR))
      IF(LOV) CALL LCMPUT(IPLIST,'OVERV',NMIXT,2,OVERV(1,JGR))
      IF(LDX) CALL LCMPUT(IPLIST,'DIFFX',NMIXT,2,DIFFX(1,JGR))
      IF(LDY) CALL LCMPUT(IPLIST,'DIFFY',NMIXT,2,DIFFY(1,JGR))
      IF(LDZ) CALL LCMPUT(IPLIST,'DIFFZ',NMIXT,2,DIFFZ(1,JGR))
      IF(LHF) CALL LCMPUT(IPLIST,'H-FACTORS',NMIXT,2,H(1,JGR))
      IF(LSO) CALL LCMPUT(IPLIST,'FIXE',NMIXT,2,S(1,JGR))
      IF(LBI) THEN
      DO 901 I=1,NDG
      WRITE (TEXT,'(4HCHDL,I3)') I
      CALL LCMPUT(IPLIST,TEXT,NMIXT,2,CHDL(1,I,JGR))
 901  CONTINUE
      ENDIF
      IF(LSC) THEN
         DO 180 IL=1,NL
         WRITE (CM,'(I2)') IL-1
         IPOSDE=0
         DO 170 IBM=1,NMIXT
         IPOS(IBM)=IPOSDE+1
         DO 170 IGR=IJJ(IBM,IL,JGR),IJJ(IBM,IL,JGR)-NJJ(IBM,IL,JGR)+1,-1
         IPOSDE=IPOSDE+1
  170    WORK(IPOSDE)=SCAT(IBM,IL,IGR,JGR)
         CALL LCMPUT(IPLIST,'SCAT'//CM,IPOSDE,2,WORK)
         CALL LCMPUT(IPLIST,'IPOS'//CM,NMIXT,1,IPOS)
         CALL LCMPUT(IPLIST,'NJJ'//CM,NMIXT,1,NJJ(1,IL,JGR))
         CALL LCMPUT(IPLIST,'IJJ'//CM,NMIXT,1,IJJ(1,IL,JGR))
         CALL LCMPUT(IPLIST,'SIGW'//CM,NMIXT,2,SCAT(1,IL,JGR,JGR))
  180    CONTINUE
      ENDIF
      IF(IMPX.GT.1) CALL LCMLIB(IPLIST)
      CALL LCMSIX(IPLIST,' ',2)
  190 CONTINUE
      IF(IMPX.GT.1) CALL LCMLIB(IPLIST)
      RETURN
      END
