*DECK MAKMAC
      SUBROUTINE MAKMAC (IPMAC2,XSINT,MIX,NMIX,NIND,NAMT,
     +          XSNEO,ITYLM,PRES)
*
**********************************************************************
*
*     THIS SUBROUTINE TREATS AND STORES THE NEW ARRANGED PROPERTIES
*
*     CETTE ROUTINE RANGE UN ENSEMBLE DE SECTIONS EFFICACES
*     APRES TRAITEMENT DANS LA NOUVELLE MACROLIB
*
*     INPUT :
*              XSINT  : REAL
*                       INTIAL XS VECTOR
*                       DIMENSION: NMXOLD.
*              MIX    : INTEGER
*                       MIXTURE INDEX VECTOR PER REGION
*                       DIMENSION: NIND.
*              NMIX   : INTEGER
*                       NUMBER OF MIXTURES IN THE FINAL MACROLIB
*              NIND   : INTEGER
*                       NUMBER OF REGIONS.
*              NAMT   : CHARACTER*12
*                       RECORD NAME OF THE XS TO STORE
*              ITYLM  : INTEGER
*                       VARIABLE TYPE ( INTEGER, REAL)
*              PRES   : LOGICAL
*                       FLAG FOR FUEL MAP.
*                       IF TRUE, MIXTURE INDICE ARE NEGATIVE
*                       FOR FUEL REGIONS
*     OUTPUT :
*              IPMAC2 : INTEGER
*                       ADRESS OF THE FINAL MACROLIB OBJECT
*              XSNEO  : REAL
*                       FINAL VECTOR OF XS.
*                       DIMENSION: NMIX.
*
*
*-------------------------------------- AUTHOR: J. KOCLAS 94/04/10 ---
*                                       MODIFIED: E. VARIN 95/09/10 ---
*
      LOGICAL PRES
      INTEGER NMIX,NIND,CPT
      CHARACTER*12 NAMT
      DIMENSION MIX(*),XSINT(*),XSNEO(*)
*
      CPT = 0
      DO 10 I=1,NIND
         IF(MIX(I).NE.0) THEN
          CPT = CPT + 1
          IF(PRES) THEN
           IF (MIX(I).LT.0) THEN
             J = - MIX(I)
             XSNEO(CPT)=XSINT(J)
           ENDIF
          ELSE
           IF (MIX(I).GT.0) THEN
             J = MIX(I)
             XSNEO(CPT)=XSINT(J)
           ENDIF
          ENDIF
         ENDIF
  10  CONTINUE
      CALL LCMPUT(IPMAC2,NAMT,NMIX,ITYLM,XSNEO)
      RETURN
      END
