*DECK MTBLD
      SUBROUTINE MTBLD(HNAME,IPTRK,IPSYS,ITY)
*
*-----------------------------------------------------------------------
*
* XSM/LCM DRIVER FOR VECBLD.
*
* INPUT PARAMETERS:
*   HNAME : CHARACTER*12 NAME OF THE MATRIX. HNAME(:1) IS 'W', 'X', 'Y',
*           OR 'Z'.
*   IPTRK : L_TRACK POINTER TO THE TRACKING INFORMATION.
*   IPSYS : L_SYSTEM POINTER TO SYSTEM MATRICES.
*     ITY : =1 GATHER BACK ; =2 SCATTER FORTH ;
*           =3 SCATTER FORTH AND STORE THE DIAGONAL ELEMENTS.
*
*-------------------------------------- AUTHOR: A. HEBERT ; 26/10/92 ---
*
      CHARACTER HNAME*(*),TEXT12*12,HSMG*131,HCHAR*1,NAMLCM*12,NAMMY*12
      LOGICAL LCM
      DIMENSION IBASE(1),ITP(30)
      COMMON BASE(1)
      EQUIVALENCE (BASE(1),IBASE(1))
*
* RECOVER TRACKING INFORMATION FROM LCM.
      TEXT12=' '
      CALL LCMNXT(IPTRK,TEXT12,NAMLCM,NAMMY,LCM)
      HCHAR=HNAME(:1)
      CALL LCMGET(IPTRK,'TPARAM',ITP)
      ISEG=ITP(12)
      IMPV=ITP(13)
      CALL LCMLEN(IPTRK,'MU'//HCHAR,LL4,ITYLCM)
      CALL LCMLEN(IPTRK,'NBL'//HCHAR,LON,ITYLCM)
      CALL SETARA(IBASE,LL4,IMU)
      CALL SETARA(IBASE,LON,INBL)
      CALL SETARA(IBASE,LON,ILBL)
      CALL SETARA(IBASE,LL4,IMUV)
      CALL SETARA(IBASE,LL4,IIPV)
      CALL LCMGET(IPTRK,'MU'//HCHAR,IBASE(IMU))
      CALL LCMGET(IPTRK,'NBL'//HCHAR,IBASE(INBL))
      CALL LCMGET(IPTRK,'LBL'//HCHAR,IBASE(ILBL))
      CALL LCMGET(IPTRK,'MUV'//HCHAR,IBASE(IMUV))
      CALL LCMGET(IPTRK,'IPV'//HCHAR,IBASE(IIPV))
*
      TEXT12=HNAME
      IIMAX=IBASE(IMU+LL4-1)
      LBL0=0
      DO 10 I=1,LON
   10 LBL0=LBL0+IBASE(ILBL+I-1)
      IIMAXV=IBASE(IMUV+LBL0-1)*ISEG
      IF(ITY.EQ.1) THEN
*        SUPERVECTORIAL TO SCALAR REBUILD.
         CALL SETARA(BASE,IIMAX,IASS)
         CALL LCMLEN(IPSYS,TEXT12,ILEN,ITYLCM)
         IF(ILEN.NE.IIMAXV) THEN
            WRITE(HSMG,'(38HMTBLD: REBUILD FAILURE 1 IN PROCESSING,
     1      9H MATRIX '',A12,2H''.)') TEXT12
            CALL XABORT(HSMG)
         ENDIF
         IF(LCM) THEN
            IASSV=LCMIOF(IPSYS,TEXT12)
            CALL VECBLD(ISEG,LL4,IBASE(IMU),LON,IBASE(INBL),IBASE(ILBL),
     1      IBASE(IMUV),IBASE(IIPV),1,BASE(IASS),BASE(IASSV),DUMMY)
         ELSE
            CALL SETARA(BASE,IIMAXV,IASSV)
            CALL LCMGET(IPSYS,TEXT12,BASE(IASSV))
            CALL VECBLD(ISEG,LL4,IBASE(IMU),LON,IBASE(INBL),IBASE(ILBL),
     1      IBASE(IMUV),IBASE(IIPV),1,BASE(IASS),BASE(IASSV),DUMMY)
            CALL RLSARA(BASE(IASSV))
         ENDIF
         CALL LCMPOF(IPSYS,TEXT12,IIMAX,2,IASS)
      ELSE IF(ITY.GE.2) THEN
*        SCALAR TO SUPERVECTORIAL REBUILD.
         CALL SETARA(BASE,LBL0*ISEG,IDGV)
         CALL SETARA(BASE,IIMAXV,IASSV)
         CALL LCMLEN(IPSYS,TEXT12,ILEN,ITYLCM)
         IF(ILEN.NE.IIMAX) THEN
            WRITE(HSMG,'(38HMTBLD: REBUILD FAILURE 2 IN PROCESSING,
     1      9H MATRIX '',A12,2H''.)') TEXT12
            CALL XABORT(HSMG)
         ENDIF
         IF(LCM) THEN
            IASS=LCMIOF(IPSYS,TEXT12)
            CALL VECBLD(ISEG,LL4,IBASE(IMU),LON,IBASE(INBL),IBASE(ILBL),
     1      IBASE(IMUV),IBASE(IIPV),2,BASE(IASS),BASE(IASSV),BASE(IDGV))
         ELSE
            CALL SETARA(BASE,IIMAX,IASS)
            CALL LCMGET(IPSYS,TEXT12,BASE(IASS))
            CALL VECBLD(ISEG,LL4,IBASE(IMU),LON,IBASE(INBL),IBASE(ILBL),
     1      IBASE(IMUV),IBASE(IIPV),2,BASE(IASS),BASE(IASSV),BASE(IDGV))
            CALL RLSARA(BASE(IASS))
         ENDIF
         IF(ITY.EQ.3) THEN
            CALL LCMPOF(IPSYS,'D'//TEXT12,LBL0*ISEG,2,IDGV)
         ELSE
            CALL RLSARA(BASE(IDGV))
         ENDIF
         CALL LCMPOF(IPSYS,TEXT12,IIMAXV,2,IASSV)
      ENDIF
      CALL RLSARA(IBASE(IIPV))
      CALL RLSARA(IBASE(IMUV))
      CALL RLSARA(IBASE(ILBL))
      CALL RLSARA(IBASE(INBL))
      CALL RLSARA(IBASE(IMU))
      RETURN
      END
