*DECK MTLDLF
      SUBROUTINE MTLDLF(NAMP,IPTRK,IPSYS,IMPX)
*
*-----------------------------------------------------------------------
*
* XSM/LCM DRIVER FOR THE L-D-L(T) FACTORIZATION OF A SYMMETRIC MATRIX.
* THE FACTORIZED MATRIX IS STORED ON XSM OR LCM UNDER NAME 'I'//NAMP.
*
* INPUT PARAMETERS:
*   NAMP : CHARACTER*12 NAME OF THE COEFFICIENT MATRIX.
*  IPTRK : L_TRACK POINTER TO THE TRACKING INFORMATION.
*  IPSYS : L_SYSTEM POINTER TO SYSTEM MATRICES.
*   IMPX : PRINT FLAG. EQUAL TO ZERO FOR NO PRINT.
*
*-------------------------------------- AUTHOR: A. HEBERT ; 15/05/93 ---
*
      CHARACTER NAMP*(*),HIN*12,HOUT*12,PREFIX(5)*1,NAMLCM*12,NAMMY*12
      LOGICAL LCM
      DIMENSION IBASE(1),ITP(30)
      COMMON BASE(1)
      EQUIVALENCE (BASE(1),IBASE(1))
      PARAMETER (NPREF=5)
      DATA (PREFIX(I),I=1,NPREF)/' ','W','X','Y','Z'/
*
      CALL LCMLEN(IPTRK,'TPARAM',LENGT,ITYLCM)
      IF(LENGT.NE.0) THEN
         CALL LCMGET(IPTRK,'TPARAM',ITP)
         ISEG=ITP(12)
      ELSE
         ISEG=0
      ENDIF
      HOUT=' '
      CALL LCMNXT(IPSYS,HOUT,NAMLCM,NAMMY,LCM)
      DO 40 IS=1,NPREF
      IF(PREFIX(IS).EQ.' ') THEN
         HIN=NAMP
         HOUT='I'//NAMP
      ELSE
         HIN=PREFIX(IS)//NAMP
         HOUT=PREFIX(IS)//'I'//NAMP
      ENDIF
*
* PERFORM FACTORIZATION OF MATRICES.
      CALL LCMLEN(IPSYS,HIN,ILENG,ITYLCM)
      IF(ILENG.GT.0) THEN
         IF(ISEG.EQ.0) THEN
            CALL LCMLEN(IPTRK,'MU'//PREFIX(IS),LMU,ITYLCM)
            CALL SETARA(IBASE,LMU,IMU)
            CALL LCMGET(IPTRK,'MU'//PREFIX(IS),IBASE(IMU))
         ELSE
            CALL LCMLEN(IPTRK,'MUV'//PREFIX(IS),LMU,ITYLCM)
            CALL SETARA(IBASE,LMU,IMU)
            CALL LCMGET(IPTRK,'MUV'//PREFIX(IS),IBASE(IMU))
         ENDIF
         ILEN=IBASE(IMU+LMU-1)
         IF(LCM) THEN
*           IN-CORE STORAGE.
            IF(IMPX.GT.0) WRITE(6,'(/30H MTLDLF: FACTORIZATION OF LCM ,
     1      8HMATRIX '',A12,23H''. CREATION OF MATRIX '',A12,6H'' LOCA,
     2      8HTED IN '',A12,2H''.)') HIN,HOUT,NAMLCM
            IOF1=LCMIOF(IPSYS,HIN)
            CALL SETARA(BASE,ILENG,IOF2)
            DO 10 I=1,ILENG
   10       BASE(IOF2+I-1)=BASE(IOF1+I-1)
            IF(ISEG.EQ.0) THEN
               IF(ILEN.NE.ILENG) CALL XABORT('MTLDLF: INCONSISTENT INF'
     1         //'ORMATION ON LCM (1).')
               CALL ALLDLF(LMU,BASE(IOF2),IBASE(IMU))
            ELSE
               IF(ISEG*ILEN.NE.ILENG) CALL XABORT('MTLDLF: INCONSISTEN'
     1         //'T INFORMATION ON LCM (2).')
               CALL LCMLEN(IPTRK,'NBL'//PREFIX(IS),LON,ITYLCM)
               CALL SETARA(IBASE,LON,INBL)
               CALL SETARA(IBASE,LON,ILBL)
               CALL LCMGET(IPTRK,'NBL'//PREFIX(IS),IBASE(INBL))
               CALL LCMGET(IPTRK,'LBL'//PREFIX(IS),IBASE(ILBL))
               CALL SETARA(BASE,ISEG,IT)
               CALL ALVDLF(BASE(IOF2),IBASE(IMU),ISEG,LON,IBASE(INBL),
     1         IBASE(ILBL),BASE(IT))
               CALL RLSARA(BASE(IT))
               CALL RLSARA(IBASE(ILBL))
               CALL RLSARA(IBASE(INBL))
            ENDIF
         ELSE
*           XSM STORAGE.
            IF(IMPX.GT.0) WRITE(6,'(/30H MTLDLF: FACTORIZATION OF XSM ,
     1      8HMATRIX '',A12,23H''. CREATION OF MATRIX '',A12,6H'' LOCA,
     2      8HTED IN '',A12,2H''.)') HIN,HOUT,NAMLCM
            CALL SETARA(BASE,ILENG,IOF1)
            CALL LCMGET(IPSYS,HIN,BASE(IOF1))
            CALL SETARA(BASE,ILENG,IOF2)
            DO 20 I=1,ILENG
   20       BASE(IOF2+I-1)=BASE(IOF1+I-1)
            IF(ISEG.EQ.0) THEN
               IF(ILEN.NE.ILENG) CALL XABORT('MTLDLF: INCONSISTENT INF'
     1         //'ORMATION ON XSM (1).')
               CALL ALLDLF(LMU,BASE(IOF2),IBASE(IMU))
            ELSE
               IF(ISEG*ILEN.NE.ILENG) CALL XABORT('MTLDLF: INCONSISTEN'
     1         //'T INFORMATION ON XSM (2).')
               CALL LCMLEN(IPTRK,'NBL'//PREFIX(IS),LON,ITYLCM)
               CALL SETARA(IBASE,LON,INBL)
               CALL SETARA(IBASE,LON,ILBL)
               CALL LCMGET(IPTRK,'NBL'//PREFIX(IS),IBASE(INBL))
               CALL LCMGET(IPTRK,'LBL'//PREFIX(IS),IBASE(ILBL))
               CALL SETARA(BASE,ISEG,IT)
               CALL ALVDLF(BASE(IOF2),IBASE(IMU),ISEG,LON,IBASE(INBL),
     1         IBASE(ILBL),BASE(IT))
               CALL RLSARA(BASE(IT))
               CALL RLSARA(IBASE(ILBL))
               CALL RLSARA(IBASE(INBL))
            ENDIF
            CALL RLSARA(BASE(IOF1))
         ENDIF
         CALL RLSARA(IBASE(IMU))
         CALL LCMPOF(IPSYS,HOUT,ILENG,2,IOF2)
      ENDIF
   40 CONTINUE
      RETURN
      END
