*DECK MTOPEN
      SUBROUTINE MTOPEN(IMPX,IPTRK,LL4)
*
*-----------------------------------------------------------------------
*
* EXAMINE AND PRINT INFORMATION RELATED TO THE AUTOMATIC MATRIX
* PROCESSOR (MTLDLS AND MTLDLM).
*
* INPUT PARAMETER:
*   IMPX : PRINT PARAMETER. EQUAL TO ZERO FOR NO PRINT.
*  IPTRK : L_TRACK POINTER TO THE TRACKING INFORMATION.
*
* OUTPUT PARAMETER:
*    LL4 : ORDER OF THE COEFFICIENT MATRIX.
*
*-------------------------------------- AUTHOR: A. HEBERT ; 21/10/92 ---
*
      CHARACTER HSMG*90
      LOGICAL LMU,LMUW,LMUX,LMUY,LMUZ
      DIMENSION ITP(30)
      COMMON IBASE(1)
*
      CALL LCMLEN(IPTRK,'MU',LL40,ITYLCM)
      LMU=(LL40.NE.0).AND.(ITYLCM.EQ.1)
      CALL LCMLEN(IPTRK,'MUW',LL4W,ITYLCM)
      LMUW=(LL4W.NE.0).AND.(ITYLCM.EQ.1)
      CALL LCMLEN(IPTRK,'MUX',LL4X,ITYLCM)
      LMUX=(LL4X.NE.0).AND.(ITYLCM.EQ.1)
      CALL LCMLEN(IPTRK,'MUY',LL4Y,ITYLCM)
      LMUY=(LL4Y.NE.0).AND.(ITYLCM.EQ.1)
      CALL LCMLEN(IPTRK,'MUZ',LL4Z,ITYLCM)
      LMUZ=(LL4Z.NE.0).AND.(ITYLCM.EQ.1)
      IDIM=1
      IF(LMU) THEN
         LL4=LL40
         HSMG='INVERSE POWER METHOD.'
      ELSE IF(LMUW) THEN
         IDIM=2
         IF((.NOT.LMUX).OR.(.NOT.LMUY)) CALL XABORT('MTOPEN: X- OR Y-C'
     1   //'OMPONENT MISSING IN HEXAGONAL GEOMETRY CASE.')
         IF(LMUZ) IDIM=3
         LL4=LL4W
         WRITE(HSMG,'(I1,33H-AXIS HEXAGONAL ADI POWER METHOD.)') IDIM+1
      ELSE IF(LMUX) THEN
         IF(LMUY) IDIM=2
         IF(LMUZ) IDIM=3
         LL4=LL4X
         WRITE(HSMG,'(I1,33H-AXIS CARTESIAN ADI POWER METHOD.)') IDIM
      ELSE IF(LMUY) THEN
         IDIM=2
         IF(LMUZ) IDIM=3
         LL4=LL4Y
         WRITE(HSMG,'(I1,42H-AXIS CARTESIAN ADI POWER METHOD (DIAGONAL,
     1   10H SYMMETRY))') IDIM
      ELSE
         CALL XABORT('MTOPEN: MISSING MU INFO ON LCM.')
      ENDIF
      CALL LCMLEN(IPTRK,'TPARAM',ILENG,ITYLCM)
      IF(ILENG.GT.0) THEN
         CALL LCMGET(IPTRK,'TPARAM',ITP)
         ISEG=ITP(12)
         IMPV=ITP(13)
         LTSW=ITP(14)
         IF((IMPX.GT.0).AND.(ISEG.GT.0)) WRITE(6,'(9X,13HSUPERVECTORIZ,
     1   23HATION OPTION ON. ISEG =,I4,8H  IMPV =,I3,8H  LTSW =,I3)')
     2   ISEG,IMPV,LTSW
      ENDIF
      IF(LL4.LE.0) CALL XABORT('MTOPEN: UNABLE TO FIND THE NUMBER OF U'
     1 //'NKNOWNS.')
      IF(IMPX.GT.0) WRITE(6,'(/29H MTOPEN: NUMBER OF UNKNOWNS =,I8,
     1 2H. ,A90)') LL4,HSMG
      RETURN
      END
