*DECK NEOMAC
      SUBROUTINE NEOMAC(IPMAC,IPMAC2,NL,NGRP,NMXOLD,NMIX,NIND,
     +                   MIX,PRES)
*
**********************************************************************
*
*     THIS SUBROUTINE RECOVERS NUCLEAR PROPERTIES FROM A MACROLIB
*     THEN STORE THEM AS A NEW ONE CONTAINING ONE MIXTURE PER REGION.
*
*     CETTE ROUTINE RECUPERE LES PROPRIETES DANS UNE MACROLIB
*     PUIS LES RANGE COMME UN ENSEMBLE DE PROPRIETES PAR REGION
*     MATERIEL DANS UNE NOUVELLE MACROLIB.
*
*     INPUT  :
*              IPMAC  : INTEGER
*                       ADRESS OF THE INITIAL MACROLIB OBJECT
*              NL     : INTEGER
*                       NUMBER OF LEGENDRE ORDERS FOR SCATTERING XS
*              NGRP   : INTEGER
*                       NUMBER OF ENERGY GROUPS
*              NMXOLD : INTEGER
*                       NUMBER OF MIXTURES IN THE INITIAL MACROLIB
*              NMIX   : INTEGER
*                       NUMBER OF MIXTURES IN THE FINAL MACROLIB
*              MIX    : INTEGER
*                       INDEX OF MATERIAL MIXTURES PER REGION
*                       DIMENSION: NMIX.
*              PRES   : LOGICAL
*                       FLAG FOR FUEL MAP.
*                       IF TRUE, MIXTURE INDICE ARE NEGATIVE
*                       FOR FUEL REGIONS
*
*     OUTPUT :
*              IPMAC2 : INTEGER
*                       ADRESS OF THE FINAL MACROLIB OBJECT
*
*     PROCEDURES CALLED:  MAKMAC, CRESCA
*
*-------------------------------------- AUTHOR: E. VARIN 94/04/10 ---
*
*
      INTEGER NGRP,NMIX,NMXOLD,IBASE(1),NL,MIX,NIND
      INTEGER IPMAC,IPMAC2,JGR,ITOT,ITOT2,ILENGT,ITYLCM,ITLCM2,IL2,
     +        ISCAT,ISCAT2,IWORK,IIPOS,IIJJ,INJJ,IL,IWORK2,IIPOS2,
     +        IIJJ2,INJJ2
      REAL    BASE
      CHARACTER CGRPNM*12,CM*2,NAMT*12,NAMLCM*12,NAMMY*12,FIRST*12
      LOGICAL   LCM,PRES
      DIMENSION MIX(*)
      COMMON BASE(1)
      EQUIVALENCE (BASE(1),IBASE(1))
*
*        RECOVER THE EXISTING MACROLIB DATA AND STORE THE NEW ONE.
*
      CALL SETARA(BASE,NMXOLD*NL*NGRP*NGRP,ISCAT)
      CALL SETARA(BASE,NMIX*NL*NGRP*NGRP,ISCAT2)
      CALL SETARA(BASE,NMXOLD*NGRP,IWORK)
      CALL SETARA(IBASE,NMXOLD,IIPOS)
      CALL SETARA(IBASE,NMXOLD*NL*NGRP,IIJJ)
      CALL SETARA(IBASE,NMXOLD*NL*NGRP,INJJ)
      CALL SETARA(BASE,NMIX*NGRP,IWORK2)
      CALL SETARA(IBASE,NMIX,IIPOS2)
      CALL SETARA(IBASE,NMIX*NL*NGRP,IIJJ2)
      CALL SETARA(IBASE,NMIX*NL*NGRP,INJJ2)
*
      DO 40 JGR=1,NGRP
         WRITE (CGRPNM,'(5HGROUP,I3,1H/,I3)') JGR,NGRP
         CALL LCMSIX(IPMAC,' ',0)
         CALL LCMSIX(IPMAC2,' ',0)
         CALL LCMSIX(IPMAC,CGRPNM,1)
         CALL LCMSIX(IPMAC2,CGRPNM,1)
         NAMT = ' '
         CALL LCMNXT(IPMAC,NAMT,NAMLCM,NAMMY,LCM)
         FIRST = NAMT
  10     CALL LCMLEN(IPMAC,NAMT,ILENGT,ITYLCM)
         IF ((INDEX(NAMT,'SCAT').EQ.0).AND.(INDEX(NAMT,'IJJ').EQ.0)
     +    .AND.(INDEX(NAMT,'NJJ').EQ.0).AND.(INDEX(NAMT,'IPOS').EQ.0)
     +    .AND.(INDEX(NAMT,'SIGW').EQ.0)) THEN
          IF(ILENGT.EQ.NMXOLD) THEN
            CALL SETARA(BASE,ILENGT,ITOT)
            CALL LCMGET(IPMAC,NAMT,BASE(ITOT))
            CALL SETARA(BASE,NMIX,ITOT2)
            IF(PRES) THEN
              CALL LCMLEN(IPMAC2,NAMT,IL2,ITLCM2)
              IF(IL2.NE.0) THEN
               CALL LCMGET(IPMAC2,NAMT,BASE(ITOT2))
              ELSE
               DO 1 I=1,NMIX
                  BASE(ITOT2+I-1) = 0.0
   1           CONTINUE
              ENDIF
            ENDIF
            CALL MAKMAC(IPMAC2,BASE(ITOT),MIX,NMIX,NIND,
     +       NAMT,BASE(ITOT2),ITYLCM,PRES)
            CALL RLSARA(BASE(ITOT))
            CALL RLSARA(BASE(ITOT2))
          ELSEIF (ILENGT.EQ.-1) THEN
            CALL XABORT('NEOMAC: '//NAMT//' IS A DIRECTORY.')
          ELSE IF(ILENGT.NE.0) THEN
           CALL XABORT('NEOMAC: '//NAMT//' INVALID INPUT MACROLIB(1).')
          ENDIF
         ENDIF
         CALL LCMNXT(IPMAC,NAMT,NAMLCM,NAMMY,LCM)
         IF (FIRST.EQ.NAMT) GOTO 20
         GOTO 10
*
  20     DO 30 IL=1,NL
         WRITE (CM,'(I2)') IL-1
         CALL LCMLEN(IPMAC,'SCAT'//CM,ILENGT,ITYLCM)
         IF(ILENGT.GT.NMXOLD*NL*NGRP*NGRP) THEN
            CALL XABORT('NEOMAC : INVALID INPUT MACROLIB(2).')
         ELSE IF(ILENGT.GT.0) THEN
*        RECUPERATION DES BLOCKS SCAT,IJJ,NJJ
            CALL CRESCA(IPMAC,IPMAC2,BASE(ISCAT),BASE(ISCAT2),
     +           BASE(IWORK),IBASE(IIJJ),IBASE(INJJ),IBASE(IIPOS),
     +           BASE(IWORK2),IBASE(IIJJ2),IBASE(INJJ2),IBASE(IIPOS2),
     +           CM,JGR,IL,MIX,NMIX,NIND,NMXOLD,NL,NGRP,PRES)
         ENDIF
   30    CONTINUE
   40 CONTINUE
*
      CALL LCMSIX(IPMAC,' ',0)
      CALL LCMSIX(IPMAC2,' ',0)
      CALL RLSARA(BASE(ISCAT))
      CALL RLSARA(BASE(ISCAT2))
      CALL RLSARA(BASE(IWORK))
      CALL RLSARA(IBASE(IIPOS))
      CALL RLSARA(IBASE(IIJJ))
      CALL RLSARA(IBASE(INJJ))
      CALL RLSARA(BASE(IWORK2))
      CALL RLSARA(IBASE(IIPOS2))
      CALL RLSARA(IBASE(IIJJ2))
      CALL RLSARA(IBASE(INJJ2))
*
      CALL LCMLEN(IPMAC,'VOLUME',ILENGT,ITYLCM)
      IF(ILENGT.EQ.NMXOLD) THEN
        CALL SETARA(BASE,NMXOLD,ITOT)
        CALL SETARA(BASE,NMIX,ITOT2)
        CALL LCMGET(IPMAC,'VOLUME',BASE(ITOT))
        IF(PRES) THEN
          CALL LCMLEN(IPMAC2,'VOLUME',IL2,ITLCM2)
          IF(IL2.NE.0) THEN
            CALL LCMGET(IPMAC2,'VOLUME',BASE(ITOT2))
          ELSE
            DO 2 I=1,NMIX
              BASE(ITOT2+I-1) = 0.0
 2          CONTINUE
          ENDIF
        ENDIF
        CALL MAKMAC(IPMAC2,BASE(ITOT),MIX,NMIX,NIND,
     +    'VOLUME      ',BASE(ITOT2),ITYLCM,PRES)
        CALL RLSARA(BASE(ITOT))
        CALL RLSARA(BASE(ITOT2))
      ELSE IF(ILENGT.NE.0) THEN
        CALL XABORT('NEOMAC: INVALID INPUT MACROLIB(1).')
      ENDIF
*
      RETURN
      END
