*DECK NEWMAC
      SUBROUTINE NEWMAC(NENTRY,HENTRY,IENTRY,JENTRY,KENTRY)
*
**********************************************************************
*
*     THIS MODULE CREATES A NEW LIBRARY WHERE CELL PROPERTIES ARE
*     CORRECTED WITH DEVICE INCREMENTS WHERE NEEDED
*
*     CE MODULE CREE L_MACROLIB3 A PARTIR DES PROPRIETES DE
*     CHAQUE ZONE ET DES POSITIONS DES CONTROLEURS.
*
*     INPUT/OUTPUT PARAMETERS:
*      HMODUL : CHARACTER*12 NAME OF THE MODULE.
*      NENTRY : NUMBER OF LINKED LISTS AND FILES USED BY THE MODULE.
*      HENTRY : CHARACTER*12 NAME OF EACH LINKED LIST OR FILE.
*      IENTRY : =1 LINKED LIST; =2 XSM FILE; =3 SEQUENTIAL BINARY FILE;
*               =4 SEQUENTIAL ASCII FILE; =5 DIRECT ACCESS FILE.
*      JENTRY : =0 THE LINKED LIST OR FILE IS CREATED.
*               =1 THE LINKED LIST OR FILE IS OPEN FOR MODIFICATIONS;
*               =2 THE LINKED LIST OR FILE IS OPEN IN READ-ONLY MODE.
*      KENTRY : FILE UNIT NUMBER OR LINKED LIST ADDRESS.
*
*      DIMENSION HENTRY(NENTRY),IENTRY(NENTRY),JENTRY(NENTRY),
*      KENTRY(NENTRY)
*
*     REQUIRED LINKED-LISTS ARE:
*        KENTRY(1)   : OBJECT TYPE L_MACROLIB IN CREATION
*        KENTRY(2-4) : OBJECT TYPE L_MACROLIB IN READ ONLY MODE
*                                  L_DEVICE   IN READ ONLY MODE
*                                  L_GEOM     IN READ ONLY MODE
*
*     PROCEDURES CALLED:  XSRES, PUTMAC
*
*-------------------------------------- AUTHORS: J. KOCLAS 94/04/10 ---
*                                                E. VARIN
      IMPLICIT NONE
* DRVDRV VARIABLES
      INTEGER NENTRY
      CHARACTER HENTRY(*)*12
      INTEGER IENTRY,JENTRY,KENTRY
      DIMENSION IENTRY(*),JENTRY(*),KENTRY(*)
* SETARA VARIABLES
      REAL BASE
      INTEGER IBASE(1)
      COMMON BASE(1)
      EQUIVALENCE (BASE(1),IBASE(1))
* REDGET TYPES
      INTEGER ITYP,NITMA
      REAL FLOTT
      DOUBLE PRECISION DFLOTT
*
* SIGNATURE INFORMATION
*
      CHARACTER*12 SGNTUR,TEXT
      INTEGER      ISGNTR(3)
*
      INTEGER  IPMAC3,IPLDEV,IPGEO,IPMAC2
*
      INTEGER I,IPRT,I1
* GEOM
      INTEGER STATE(13)
* MAC2
      INTEGER DATAXS(7)
* LOCAL VARIABLES
      INTEGER GEOTYP,NX,NY,NZ,NXP1,NYP1,NZP1,NMXGEO
      INTEGER IMESHX,IMESHY,IMESHZ,IMIX,IHX,IHY,IHZ
      INTEGER NGRP,NMIXT,NL
      REAL    XFACC,XFACP
*
      INTEGER ITOTAL,INUSIG,ICHI,IOVERV,IDIFFX,ISIGF
      INTEGER IDIFFY,IDIFFZ,IH,IIJJ,INJJ,ISCAT,IWORK,IIPOS
      LOGICAL LSIG,LHEX
*
*
*     INPUT PARAMETER VALIDATION
*
      IPMAC2 = 0
      IPLDEV = 0
      IPGEO  = 0
      IF(NENTRY.LT.3) CALL XABORT('NEWMAC: PARAMETER EXPECTED.')
      IF((IENTRY(1).NE.1).AND.(IENTRY(1).NE.2)) CALL XABORT('NEWM'
     + //'AC: LINKED LIST OR XSM FILE EXPECTED AT LHS.')
      IF((JENTRY(1).NE.0).AND.(JENTRY(1).NE.1)) CALL XABORT('NEWM'
     + //'AC: CREATE OR MODIFICATION MODE EXPECTED.')
*
      IPMAC3=KENTRY(1)
*
      DO 5 I=2,NENTRY
        IF((IENTRY(I).EQ.1).OR.(IENTRY(I).EQ.2)) THEN
         CALL LCMSIX(KENTRY(I),' ',0)
         CALL LCMGET(KENTRY(I),'SIGNATURE',ISGNTR)
         WRITE(SGNTUR,'(3A4)') (ISGNTR(I1),I1=1,3)
         IF(JENTRY(I).NE.2) CALL XABORT('INIDEV: READ-ONL'
     +     //'Y MODE EXPECTED FOR OBJECT'//SGNTUR//'.')
         IF (SGNTUR.EQ.'L_DEVICE') THEN
           IF (IPLDEV.EQ.0) IPLDEV=KENTRY(I)
         ELSEIF (SGNTUR.EQ.'L_MACROLIB') THEN
           IF (IPMAC2.EQ.0) IPMAC2=KENTRY(I)
         ELSEIF (SGNTUR.EQ.'L_GEOM') THEN
           IF (IPGEO.EQ.0) IPGEO=KENTRY(I)
         ENDIF
        ENDIF
  5   CONTINUE
      IF ((IPGEO.EQ.0).OR.(IPMAC2.EQ.0)) CALL XABORT('NEWMAC: ILLEGAL'
     +     //' OR MISSING TYPE OF OBJECTS')
*
      IPRT = 1
      LSIG = .FALSE.
      XFACC = 1.0
      XFACP = XFACC
 10   CALL REDGET(ITYP,NITMA,FLOTT,TEXT,DFLOTT)
      IF (ITYP.EQ.3) THEN
        IF (TEXT.EQ.'TYPE') THEN
         CALL REDGET(ITYP,NITMA,FLOTT,TEXT,DFLOTT)
         IF (ITYP.EQ.3) THEN
          IF (TEXT.EQ.'CONTROLLED') THEN
            CALL REDGET(ITYP,NITMA,FLOTT,TEXT,DFLOTT)
            IF (ITYP.EQ.3) THEN
             IF (TEXT.EQ.'XFAC') THEN
              CALL REDGET(ITYP,NITMA,FLOTT,TEXT,DFLOTT)
              IF(ITYP.NE.2) THEN
                CALL XABORT('NEWMAC: REAL DATA EXPECTED')
              ELSE
               XFACC = FLOTT
              ENDIF
             ELSE
              CALL XABORT('NEWMAC: INVALID KEYWORD '//TEXT)
             ENDIF
            ELSE
             CALL XABORT('NEWMAC: CHARACTER DATA EXPECTED')
            ENDIF
           ELSEIF (TEXT.EQ.'PERT') THEN
            CALL REDGET(ITYP,NITMA,FLOTT,TEXT,DFLOTT)
            IF (ITYP.EQ.3) THEN
             IF (TEXT.EQ.'XFAC') THEN
              CALL REDGET(ITYP,NITMA,FLOTT,TEXT,DFLOTT)
              IF(ITYP.NE.2) THEN
                CALL XABORT('NEWMAC: REAL DATA EXPECTED')
              ELSE
               XFACP = FLOTT
              ENDIF
             ELSE
              CALL XABORT('NEWMAC: INVALID KEYWORD '//TEXT)
             ENDIF
            ELSE
             CALL XABORT('NEWMAC: CHARACTER DATA EXPECTED')
            ENDIF
           ELSE
             CALL XABORT('NEWMAC: CHARACTER DATA EXPECTED')
           ENDIF
         ELSE
           CALL XABORT('NEWMAC: CHARACTER DATA EXPECTED')
         ENDIF
        ELSEIF (TEXT.EQ.'EDIT') THEN
           CALL REDGET(ITYP,NITMA,FLOTT,TEXT,DFLOTT)
           IF(ITYP.NE.1) THEN
             CALL XABORT('NEWMAC: INTEGER DATA EXPECTED')
           ELSE
             IPRT = NITMA
           ENDIF
        ELSEIF (TEXT.EQ.'REFL-SIGF') THEN
           LSIG = .TRUE.
        ELSEIF (TEXT.EQ.'NOSIGF') THEN
           LSIG = .FALSE.
        ELSE IF(TEXT.EQ.';') THEN
          GOTO 20
        ELSE
         CALL XABORT('NEWMAC: INVALID KEYWORD '//TEXT)
        ENDIF
      ELSE
        CALL XABORT('NEWMAC: CHARACTER DATA EXPECTED')
      ENDIF
      GOTO 10
*
 20   CALL LCMSIX(IPMAC2,' ',0)
      CALL LCMSIX(IPGEO ,' ',0)
*
* NOW COPY MAC2 TO MAC3
* NB : ONLY THE CROSS-SECTIONS NEED TO BE MODIFIED
*
      CALL LCMEQU(IPMAC2,IPMAC3)
      CALL LCMSIX(IPMAC2,' ',0)
      CALL LCMSIX(IPMAC3,' ',0)
      IF (IPLDEV.EQ.0) THEN
          WRITE(6,*) ' NO DEVICE INFORMATION: MACROLIB3 IS IDENTICAL'
     +            //' TO MACROLIB2.'
          GOTO 100
      ENDIF
* GET DEVICE DATA
      CALL LCMSIX(IPLDEV,' ',0)
      CALL LCMGET(IPLDEV,'HEX',LHEX)
*
      CALL LCMGET(IPMAC2,'IDATAXS',DATAXS)
      NGRP=DATAXS(1)
      NMIXT=DATAXS(2)
      NL=DATAXS(3)
*
      CALL LCMGET(IPGEO,'STATE',STATE)
      GEOTYP=STATE(1)
      NX=STATE(3)
      IF(GEOTYP.EQ.6) THEN
        NX=STATE(2)
      ENDIF
      NY=STATE(4)
      IF(NY.EQ.0) NY=1
      NZ=STATE(5)
      IF(NZ.EQ.0) NZ=1
      NMXGEO=STATE(6)
      IF((LHEX.AND.(GEOTYP.NE.9)).OR.(.NOT.LHEX.AND.(GEOTYP.EQ.9)))
     +    CALL XABORT('NEWMAC: INCOMPATIBLE DEVICE WITH GEOMETRY')
      IF(GEOTYP.LT.5.OR.GEOTYP.EQ.8)
     +    CALL XABORT('NEWMAC: GEOMETRY TYPE NOT SUPPORTED IN NEWMAC')
*
      NXP1=NX+1
      NYP1=NY+1
      NZP1=NZ+1
*
      CALL SETARA(BASE,NXP1,IMESHX)
      CALL SETARA(BASE,NYP1,IMESHY)
      CALL SETARA(BASE,NZP1,IMESHZ)
      CALL SETARA(IBASE,NMXGEO,IMIX)
      CALL SETARA(BASE,NX,IHX)
      CALL SETARA(BASE,NY,IHY)
      CALL SETARA(BASE,NZ,IHZ)
      CALL SETARA(BASE,(NMIXT+1)*NGRP,ITOTAL)
      CALL SETARA(BASE,(NMIXT+1)*NGRP,INUSIG)
      CALL SETARA(BASE,(NMIXT+1)*NGRP,ISIGF)
      CALL SETARA(BASE,(NMIXT+1)*NGRP,ICHI)
      CALL SETARA(BASE,(NMIXT+1)*NGRP,IOVERV)
      CALL SETARA(BASE,(NMIXT+1)*NGRP,IDIFFX)
      CALL SETARA(BASE,(NMIXT+1)*NGRP,IDIFFY)
      CALL SETARA(BASE,(NMIXT+1)*NGRP,IDIFFZ)
      CALL SETARA(BASE,(NMIXT+1)*NGRP,IH)
      CALL SETARA(IBASE,NMIXT*NGRP*NL,IIJJ)
      CALL SETARA(IBASE,NMIXT*NGRP*NL,INJJ)
      CALL SETARA(BASE,(NMIXT+1)*NL*NGRP*NGRP,ISCAT)
      CALL SETARA(BASE,NMIXT*NGRP,IWORK)
      CALL SETARA(IBASE,NMIXT,IIPOS)
*
*     RECOVER UNCORRECTED PROPERTIES
*
      CALL LCMSIX(IPMAC2,' ',0)
      CALL GETMAC(IPMAC2,NMIXT,NGRP,NL,BASE(ITOTAL),BASE(INUSIG),
     1 BASE(ISIGF),BASE(ICHI),BASE(IOVERV),BASE(IDIFFX),BASE(IDIFFY),
     2 BASE(IDIFFZ),BASE(IH),BASE(IIJJ),BASE(INJJ),BASE(ISCAT),
     3 BASE(IWORK),BASE(IIPOS))
*
      CALL XSRES(IPGEO,IPLDEV,LHEX,GEOTYP,NX,NY,NZ,NXP1,NYP1,NZP1,
     1 NMXGEO,NGRP,NMIXT,NL,BASE(IMESHX),BASE(IMESHY),BASE(IMESHZ),
     2 BASE(IHX),BASE(IHY),BASE(IHZ),IBASE(IMIX),BASE(ITOTAL),
     3 BASE(INUSIG),BASE(ISIGF),BASE(IDIFFX),BASE(IDIFFY),BASE(IDIFFZ),
     4 BASE(ISCAT),XFACC,XFACP,LSIG,IPRT)
*
*     STORAGE OF NEW PROPERTIES
*
      CALL PUTMAC(IPMAC3,NMIXT,NGRP,NL,BASE(ITOTAL),BASE(INUSIG),
     1 BASE(ISIGF),BASE(ICHI),BASE(IOVERV),BASE(IDIFFX),BASE(IDIFFY),
     2 BASE(IDIFFZ),BASE(IH),BASE(IIJJ),BASE(INJJ),BASE(ISCAT),
     3 BASE(IWORK),BASE(IIPOS))
*
      CALL RLSARA(BASE(IMESHX))
      CALL RLSARA(BASE(IMESHY))
      CALL RLSARA(BASE(IMESHZ))
      CALL RLSARA(IBASE(IMIX))
      CALL RLSARA(BASE(IHX))
      CALL RLSARA(BASE(IHY))
      CALL RLSARA(BASE(IHZ))
      CALL RLSARA(BASE(ITOTAL))
      CALL RLSARA(BASE(INUSIG))
      CALL RLSARA(BASE(ISIGF))
      CALL RLSARA(BASE(ICHI))
      CALL RLSARA(BASE(IOVERV))
      CALL RLSARA(BASE(IDIFFX))
      CALL RLSARA(BASE(IDIFFY))
      CALL RLSARA(BASE(IDIFFZ))
      CALL RLSARA(BASE(IH))
      CALL RLSARA(IBASE(IIJJ))
      CALL RLSARA(IBASE(INJJ))
      CALL RLSARA(BASE(ISCAT))
      CALL RLSARA(BASE(IWORK))
      CALL RLSARA(IBASE(IIPOS))
*
 100  RETURN
      END
