*DECK OUT
      SUBROUTINE OUT(NENTRY,HENTRY,IENTRY,JENTRY,KENTRY)
*
*-----------------------------------------------------------------------
*
* EDITION MODULE FOR TRIVAC-3.
*
* INPUT/OUTPUT PARAMETERS:
*  NENTRY : NUMBER OF LINKED LISTS OR FILES USED BY THE MODULE.
*  HENTRY : CHARACTER*12 NAME OF EACH LINKED LIST OR FILE.
*  IENTRY : =1 LINKED LIST; =2 XSM FILE; =3 SEQUENTIAL BINARY FILE;
*           =4 SEQUENTIAL ASCII FILE.
*  JENTRY : =0 THE LINKED LIST OR FILE IS CREATED.
*           =1 THE LINKED LIST OR FILE IS OPEN FOR MODIFICATIONS;
*           =2 THE LINKED LIST OR FILE IS OPEN IN READ-ONLY MODE.
*  KENTRY : =FILE UNIT NUMBER; =LINKED LIST ADDRESS OTHERWISE.
*           DIMENSION HENTRY(NENTRY),IENTRY(NENTRY),JENTRY(NENTRY),
*           KENTRY(NENTRY)
*
* LINKED LIST / XSM FILE:
*  HENTRY(1) : CREATE OR MODIFICATION TYPE(L_MACROLIB). => MACROLIB.
*  HENTRY(2) : READ-ONLY TYPE(L_FLUX). => FLUX SOLUTION.
*  HENTRY(3) : READ-ONLY TYPE(L_MACROLIB). => INITIAL MACROLIB.
*  HENTRY(4) : READ-ONLY TYPE(L_BIVAC) OR TYPE(L_TRIVAC). => TRACKING.
*  HENTRY(5) : READ-ONLY TYPE(L_GEOM). => GEOMETRY.
*
*-------------------------------------- AUTHOR: A. HEBERT ; 16/12/93 ---
*                                     MODIFIED: E. VARIN  ; 02/10/96 ---
*
      CHARACTER HENTRY(*)*12,TEXT12*12,TITLE*72,HTRACK*12,HSIGN*12
      DIMENSION IENTRY(*),JENTRY(*),KENTRY(*),IGP(7),IBASE(1),KCHAR(18),
     +          ITP(19)
      COMMON BASE(1)
      EQUIVALENCE (BASE(1),IBASE(1))
*
* PARAMETER VALIDATION.
      IF(NENTRY.LT.5) CALL XABORT('OUT: FIVE PARAMETERS EXPECTED.')
      IF((IENTRY(1).NE.1).AND.(IENTRY(1).NE.2)) CALL XABORT('OUT: LI'
     1 //'NKED LIST OR XSM FILE EXPECTED AT LHS.')
      IF(JENTRY(1).NE.0) CALL XABORT('OUT: ENTRY IN CREATE MODE EXPECT'
     1 //'ED.')
      IF((JENTRY(2).NE.2).OR.((IENTRY(2).NE.1).AND.(IENTRY(2).NE.2)))
     1 CALL XABORT('OUT: LINKED LIST OR XSM FILE IN READ-ONLY MODE E'
     2 //'XPECTED AT FIRST RHS.')
      IF((JENTRY(3).NE.2).OR.((IENTRY(3).NE.1).AND.(IENTRY(3).NE.2)))
     1 CALL XABORT('OUT: LINKED LIST OR XSM FILE IN READ-ONLY MODE E'
     2 //'XPECTED AT SECOND RHS.')
      IF((JENTRY(4).NE.2).OR.((IENTRY(4).NE.1).AND.(IENTRY(4).NE.2)))
     1 CALL XABORT('OUT: LINKED LIST OR XSM FILE IN READ-ONLY MODE E'
     2 //'XPECTED AT THIRD RHS.')
      IF((JENTRY(5).NE.2).OR.((IENTRY(5).NE.1).AND.(IENTRY(5).NE.2)))
     1 CALL XABORT('OUT: LINKED LIST OR XSM FILE IN READ-ONLY MODE E'
     2 //'XPECTED AT FOURTH RHS.')
*
      HSIGN='L_MACROLIB'
      READ(HSIGN,'(3A4)') (KCHAR(I1),I1=1,3)
      CALL LCMPUT(KENTRY(1),'SIGNATURE',3,3,KCHAR)
* L_FLUX
      CALL LCMGET(KENTRY(2),'SIGNATURE',KCHAR)
      WRITE(HSIGN,'(3A4)') (KCHAR(I1),I1=1,3)
      IF(HSIGN.NE.'L_FLUX') THEN
         TEXT12=HENTRY(2)
         CALL XABORT('OUT: SIGNATURE OF '//TEXT12//' IS '//HSIGN//
     1   '. L_FLUX EXPECTED.')
      ENDIF
* L_MACROLIB
      CALL LCMGET(KENTRY(3),'SIGNATURE',KCHAR)
      WRITE(HSIGN,'(3A4)') (KCHAR(I1),I1=1,3)
      IF(HSIGN.NE.'L_MACROLIB') THEN
         TEXT12=HENTRY(3)
         CALL XABORT('OUT: SIGNATURE OF '//TEXT12//' IS '//HSIGN//
     1   '. L_MACROLIB EXPECTED.')
      ENDIF
* L_TRIVAC OR L_BIVAC
      CALL LCMGET(KENTRY(4),'SIGNATURE',KCHAR)
      WRITE(HSIGN,'(3A4)') (KCHAR(I1),I1=1,3)
      IF((HSIGN.NE.'L_BIVAC').AND.(HSIGN.NE.'L_TRIVAC')) THEN
        TEXT12=HENTRY(4)
        CALL XABORT('OUT: SIGNATURE OF '//TEXT12//' IS '//HSIGN//
     1      '. L_BIVAC OR L_TRIVAC EXPECTED.')
      ENDIF
* L_GEOM
      CALL LCMGET(KENTRY(5),'SIGNATURE',KCHAR)
      WRITE(HSIGN,'(3A4)') (KCHAR(I1),I1=1,3)
      IF(HSIGN.NE.'L_GEOM') THEN
         TEXT12=HENTRY(5)
         CALL XABORT('OUT: SIGNATURE OF '//TEXT12//' IS '//HSIGN//
     1   '. L_GEOM EXPECTED.')
      ENDIF
*
      IPMAC2=KENTRY(1)
      IPFLUX=KENTRY(2)
      IPMAC1=KENTRY(3)
      IPTRK=KENTRY(4)
      IPGEOM=KENTRY(5)
*
      CALL LCMGET(IPMAC1,'IDATAXS',IGP)
      NGRP=IGP(1)
      MAXMIX=IGP(2)
*
* RECOVER GENERAL TRACKING INFORMATION.
      CALL LCMGET(IPTRK,'GPARAM',IGP)
      NEL=IGP(1)
      NUN=IGP(2)
      MAXNEL=NEL
      CALL SETARA(IBASE,NEL,IMAT)
      CALL SETARA(BASE,NEL,IVOL)
      CALL SETARA(IBASE,NEL,IIDL)
      CALL LCMGET(IPTRK,'MATCOD',IBASE(IMAT))
      CALL LCMGET(IPTRK,'VOLUME',BASE(IVOL))
      CALL LCMGET(IPTRK,'KEYFLX',IBASE(IIDL))
      CALL LCMLEN(IPTRK,'TITLE',LENGT,ITYLCM)
      IF(LENGT.GT.0) THEN
         CALL LCMGET(IPTRK,'TITLE',KCHAR)
         WRITE(TITLE,'(18A4)') (KCHAR(I),I=1,18)
         CALL LCMPUT(IPMAC2,'TITLE',18,3,KCHAR)
      ELSE
         TITLE='*** NO TITLE PROVIDED ***'
      ENDIF
*
* TEST COMPATIBLE INFORMATIONS BETWEEN OBJECTS
      IF( IGP(4).GT.MAXMIX )CALL XABORT('IQS: NOT ENOUGH PROPERTIES'
     +  //' IN MACROLIB TO BE ADDRESSED BY GEOMETRY')
*
      CALL LCMGET(IPGEOM,'STATE',ITP)
      IF( ITP(7).NE.IGP(4) )CALL XABORT('OUT: TRACKING AND GEOMETRY'
     +   //' HAVE DIFFERENT NUMBER OF MAXIMUM MIXTURES')
      IF( ITP(6).GT.NEL )CALL XABORT('OUT: TRACKING AND GEOMETRY'
     +   //' HAVE INCOMPATIBLE NUMBER OF FINITE ELEMENTS')
*
      CALL LCMGET(IPFLUX,'FLUX-PARAM',IGP)
      IF( IGP(5).NE.0 )CALL XABORT('OUT: UNPERTURBED '
     +   //'FLUX CONTAINS GPT SOLUTION')
      IF( IGP(1).NE.NGRP )CALL XABORT('OUT: MACROLIB '
     +   //' AND FLUX HAVE DIFFERENT NUMBER OF ENERGY GROUPS')
      IF( IGP(2).NE.NUN )CALL XABORT('OUT: FLUX '
     +   //'AND TRACKING HAVE DIFFERENT NUMBER OF UNKNOWS')
*
* FIND TYPE OF TRACKING.
      HTRACK=' '
      CALL LCMLEN(IPTRK,'BPARAM',LENGT,ITYLCM)
      IF(LENGT.GT.0) HTRACK='BIVAC'
      CALL LCMLEN(IPTRK,'TPARAM',LENGT,ITYLCM)
      IF(LENGT.GT.0) HTRACK='TRIVAC'
      IF(HTRACK.EQ.' ') CALL XABORT('OUT: CANNOT FIND TRACKING TYPE.')
*
* EDITION.
      CALL SETARA(BASE,NUN*NGRP,IEVECT)
      CALL SETARA(IBASE,NEL,IIHOM)
      CALL SETARA(BASE,MAXMIX,ISGD)
      CALL OUTDRV(MAXNEL,MAXMIX,IPGEOM,IPMAC1,IPFLUX,IPMAC2,NGRP,NEL,
     1 NUN,HTRACK,IBASE(IMAT),BASE(IVOL),IBASE(IIDL),TITLE,BASE(IEVECT),
     2 IBASE(IIHOM),BASE(ISGD))
      CALL RLSARA(BASE(ISGD))
      CALL RLSARA(IBASE(IIHOM))
      CALL RLSARA(BASE(IEVECT))
*
* RELEASE GENERAL TRACKING INFORMATION.
      CALL RLSARA(IBASE(IIDL))
      CALL RLSARA(BASE(IVOL))
      CALL RLSARA(IBASE(IMAT))
      RETURN
      END
