*DECK OUTAUX
      SUBROUTINE OUTAUX (MAXMIX,IPMAC1,IPMAC2,NGRP,NEL,NUN,NZS,MAT,VOL,
     1 IDL,EVECT,IHOM,IMPX,WORK,IJJ,NJJ,IPOS,RATE,FLINT,GAR,SCAT,WORK2,
     2 OUTR)
*
*-----------------------------------------------------------------------
*
* PERFORM HOMOGENIZATION INTO NZS REGIONS BASED ON AVERAGED FLUXES
* CONTAINED IN EVECT. CREATE AN OUTPUT EXTENDED MACROLIB CONTAINING
* HOMOGENIZED VOLUMES, INTEGRATED FLUXES AND CROSS SECTIONS.
*
* INPUT PARAMETERS:
*  MAXMIX : FIRST DIMENSION OF MATRIX SGD.
*  IPMAC1 : L_MACROLIB POINTER TO THE INPUT MACROLIB.
*  IPMAC2 : L_MACROLIB POINTER TO THE OUTPUT EXTENDED MACROLIB.
*  NGRP   : TOTAL NUMBER OF ENERGY GROUPS.
*  NEL    : NUMBER OF FINITE ELEMENTS.
*  NUN    : NUMBER OF UNKNOWNS PER ENERGY GROUP.
*  NZS    : NUMBER OF HOMOGENIZED REGIONS. NZS=MAX(IHOM(I))
*  MAT    : INDEX-NUMBER OF THE MIXTURE TYPE ASSIGNED TO EACH VOLUME.
*           DIMENSION MAT(NEL)
*  VOL    : VOLUMES. DIMENSION VOL(NEL)
*  IDL    : POSITION OF THE AVERAGE FLUX COMPONENT ASSOCIATED WITH
*           EACH VOLUME. DIMENSION IDL(NEL)
*  EVECT  : UNKNOWNS. DIMENSION EVECT(NUN,NGRP)
*  IHOM   : IHOM(K) IS THE HOMOGENIZED INDEX ASSIGNED TO ELEMENT K.
*           DIMENSION IHOM(NEL)
*  IMPX   : PRINT PARAMETER. EQUAL TO ZERO FOR NO PRINT.
*
* SCRATCH STORAGE:
*  WORK   : DIMENSION WORK(MAX(MAXMIX,NZS)*NGRP)
*  IJJ    : DIMENSION IJJ(MAX(MAXMIX,NZS))
*  NJJ    : DIMENSION NJJ(MAX(MAXMIX,NZS))
*  IPOS   : DIMENSION IPOS(MAX(MAXMIX,NZS))
*  RATE   : DIMENSION RATE(NZS)
*  FLINT  : DIMENSION FLINT(NZS,NGRP)
*  GAR    : DIMENSION GAR(NGRP)
*  SCAT   : DIMENSION SCAT(NZS,NGRP)
*  WORK2  : DIMENSION WORK2(MAXMIX)
*  OUTR   : DIMENSION OUTR(NZS+1,NREAC+3)
*
*--------------------------------------------- A. HEBERT ; 20/07/94 ----
*
      PARAMETER(NREAC=9)
      CHARACTER CGRPNM*12,HREAC(NREAC)*12,TEXT12*12
      DIMENSION MAT(*),VOL(*),IDL(*),EVECT(NUN,*),IHOM(*),WORK(*),
     1 IJJ(*),NJJ(*),IPOS(*),RATE(*),FLINT(NZS,*),GAR(*),SCAT(NZS,*),
     2 WORK2(*),OUTR(NZS+1,*),IDATA(7)
      DATA HREAC/'TOTAL','SIGW 0','NUSIGF','NFTOT','H-FACTORS',
     1 'OVERV','DIFFX','DIFFY','DIFFZ'/
*
      DO 10 IBM=1,NZS
      WORK(IBM)=0.0
      DO 10 IGR=1,NGRP
   10 FLINT(IBM,IGR)=0.0
      DO 30 K=1,NEL
      IBM=IHOM(K)
      IPFL=IDL(K)
      IF((IBM.NE.0).AND.(MAT(K).NE.0).AND.(IPFL.NE.0)) THEN
         WORK(IBM)=WORK(IBM)+VOL(K)
         DO 20 IGR=1,NGRP
   20    FLINT(IBM,IGR)=FLINT(IBM,IGR)+EVECT(IPFL,IGR)*VOL(K)
      ENDIF
   30 CONTINUE
      CALL LCMPUT(IPMAC2,'VOLUME',NZS,2,WORK)
      DO 40 IBM=1,NZS
   40 OUTR(IBM,NREAC+1)=WORK(IBM)
*
      IF(IMPX.GT.1) WRITE(6,'(/35H OUTAUX: REACTION RATE CALCULATION.)')
      DO 280 IGR=1,NGRP
      WRITE (CGRPNM,'(5HGROUP,I3,1H/,I3)') IGR,NGRP
      CALL LCMSIX(IPMAC1,CGRPNM,1)
      CALL LCMSIX(IPMAC2,CGRPNM,1)
      CALL LCMPUT(IPMAC2,'FLUX-INTG',NZS,2,FLINT(1,IGR))
      DO 70 IBM=1,NZS
   70 OUTR(IBM,NREAC+2)=FLINT(IBM,IGR)
*
* CROSS SECTIONS HOMOGENIZATION.
      DO 130 IREAC=1,NREAC
      DO 80 IBM=1,NZS
   80 OUTR(IBM,IREAC)=0.0
      CALL LCMLEN(IPMAC1,HREAC(IREAC),LENGT,ITYLCM)
      IF((HREAC(IREAC).EQ.'H-FACTORS').AND.(LENGT.EQ.0)) THEN
         WRITE(6,'(/47H OUTAUX: *** WARNING *** NO H-FACTORS FOUND ON ,
     1   25HLCM. USE NU*SIGF INSTEAD.)')
         TEXT12='NUSIGF'
         CALL LCMLEN(IPMAC1,'NUSIGF',LENGT,ITYLCM)
      ELSE
         TEXT12=HREAC(IREAC)
      ENDIF
      IF(LENGT.GT.0) THEN
         IF(LENGT.GT.MAXMIX) CALL XABORT('OUTAUX: INVALID LENGTH FOR '//
     1   HREAC(IREAC)//' CROSS SECTIONS.')
         CALL LCMGET(IPMAC1,TEXT12,WORK)
         DO 90 IBM=1,NZS
   90    RATE(IBM)=0.0
         DO 100 K=1,NEL
         IBM=IHOM(K)
         L=MAT(K)
         IPFL=IDL(K)
         IF((IBM.NE.0).AND.(L.NE.0).AND.(IPFL.NE.0)) THEN
            RATE(IBM)=RATE(IBM)+EVECT(IPFL,IGR)*VOL(K)*WORK(L)
         ENDIF
  100    CONTINUE
         DO 120 IBM=1,NZS
         OUTR(IBM,IREAC)=RATE(IBM)
         IF(RATE(IBM).NE.0.0) RATE(IBM)=RATE(IBM)/FLINT(IBM,IGR)
  120    CONTINUE
         CALL LCMPUT(IPMAC2,HREAC(IREAC),NZS,2,RATE)
      ENDIF
  130 CONTINUE
*
* SCATTERING MATRIX HOMOGENIZATION.
      CALL LCMLEN(IPMAC1,'NJJ 0',LENGT,ITYLCM)
      IF(LENGT.GT.0) THEN
         IF(LENGT.GT.MAXMIX) CALL XABORT('OUTAUX: INVALID LENGTH FOR '//
     1   'SCATTERING CROSS SECTIONS.')
         DO 140 JGR=1,NGRP
         DO 140 IBM=1,NZS
  140    SCAT(IBM,JGR)=0.0
         CALL LCMGET(IPMAC1,'NJJ 0',NJJ)
         CALL LCMGET(IPMAC1,'IJJ 0',IJJ)
         CALL LCMGET(IPMAC1,'IPOS 0',IPOS)
         CALL LCMGET(IPMAC1,'SCAT 0',WORK)
         IPOSDE=0
         DO 180 K=1,NEL
         IBM=IHOM(K)
         L=MAT(K)
         IPFL=IDL(K)
         IF((IBM.NE.0).AND.(L.NE.0).AND.(IPFL.NE.0)) THEN
            DO 150 JGR=1,NGRP
  150       GAR(JGR)=0.0
            IPOSDE=IPOS(L)-1
            DO 160 JGR=IJJ(L),IJJ(L)-NJJ(L)+1,-1
            IPOSDE=IPOSDE+1
  160       GAR(JGR)=WORK(IPOSDE)
            DO 170 JGR=1,NGRP
  170       SCAT(IBM,JGR)=SCAT(IBM,JGR)+EVECT(IPFL,JGR)*VOL(K)*GAR(JGR)
         ENDIF
  180    CONTINUE
         DO 200 IBM=1,NZS
         IGMIN=IGR
         IGMAX=IGR
         DO 190 JGR=NGRP,1,-1
         IF(SCAT(IBM,JGR).NE.0.0) THEN
            IGMIN=MIN(IGMIN,JGR)
            IGMAX=MAX(IGMAX,JGR)
            SCAT(IBM,JGR)=SCAT(IBM,JGR)/FLINT(IBM,JGR)
         ENDIF
  190    CONTINUE
         IJJ(IBM)=IGMAX
  200    NJJ(IBM)=IGMAX-IGMIN+1
         IPOSDE=0
         DO 210 IBM=1,NZS
         IPOS(IBM)=IPOSDE+1
         DO 210 JGR=IJJ(IBM),IJJ(IBM)-NJJ(IBM)+1,-1
         IPOSDE=IPOSDE+1
  210    WORK(IPOSDE)=SCAT(IBM,JGR)
         CALL LCMPUT(IPMAC2,'SCAT 0',IPOSDE,2,WORK)
         CALL LCMPUT(IPMAC2,'IPOS 0',NZS,1,IPOS)
         CALL LCMPUT(IPMAC2,'NJJ 0',NZS,1,NJJ)
         CALL LCMPUT(IPMAC2,'IJJ 0',NZS,1,IJJ)
         CALL LCMPUT(IPMAC2,'SIGW 0',NZS,2,SCAT(1,IGR))
      ENDIF
*
* FISSION SPECTRUM HOMOGENIZATION.
      DO 215 IBM=1,NZS
  215 OUTR(IBM,NREAC+3)=0.0
      CALL LCMLEN(IPMAC1,'CHI',LENGT,ITYLCM)
      IF(LENGT.GT.0) THEN
         IF(LENGT.GT.MAXMIX) CALL XABORT('OUTAUX: INVALID LENGTH FOR '//
     1   'FISSION SPECTRUM.')
         CALL LCMGET(IPMAC1,'CHI',WORK)
         CALL LCMGET(IPMAC1,'NUSIGF',WORK2)
         DO 220 IBM=1,NZS
         RATE(IBM)=0.0
  220    SCAT(IBM,1)=0.0
         DO 230 K=1,NEL
         IBM=IHOM(K)
         L=MAT(K)
         IPFL=IDL(K)
         IF((IBM.NE.0).AND.(L.NE.0).AND.(IPFL.NE.0)) THEN
            RATE(IBM)=RATE(IBM)+EVECT(IPFL,IGR)*VOL(K)*WORK(L)*WORK2(L)
            SCAT(IBM,1)=SCAT(IBM,1)+EVECT(IPFL,IGR)*VOL(K)*WORK2(L)
         ENDIF
  230    CONTINUE
         DO 240 IBM=1,NZS
         IF(SCAT(IBM,1).NE.0.0) THEN
            RATE(IBM)=RATE(IBM)/SCAT(IBM,1)
            OUTR(IBM,NREAC+3)=RATE(IBM)
         ENDIF
  240    CONTINUE
         CALL LCMPUT(IPMAC2,'CHI',NZS,2,RATE)
      ENDIF
      CALL LCMSIX(IPMAC2,' ',2)
      CALL LCMSIX(IPMAC1,' ',2)
*
* PRINT THE REACTION RATES:
      IF(IMPX.GT.1) THEN
         DO 250 I=1,NREAC+2
  250    OUTR(NZS+1,I)=0.0
         WRITE(6,500) IGR,'VOLUME     ','FLUX-INTG  ',(HREAC(I),I=1,6),
     1   'CHI        '
         DO 270 IBM=1,NZS
         DO 260 I=1,NREAC+2
  260    OUTR(NZS+1,I)=OUTR(NZS+1,I)+OUTR(IBM,I)
         WRITE(6,510) IBM,OUTR(IBM,NREAC+1),OUTR(IBM,NREAC+2),
     1   (OUTR(IBM,I),I=1,6),OUTR(IBM,NREAC+3)
  270    CONTINUE
         WRITE(6,520) OUTR(NZS+1,NREAC+1),OUTR(NZS+1,NREAC+2),
     1   (OUTR(NZS+1,I),I=1,6)
      ENDIF
  280 CONTINUE
      IDATA(1)=NGRP
      IDATA(2)=NZS
      IDATA(3)=1
      IDATA(4)=1
      IDATA(5)=0
      IDATA(6)=0
      IDATA(7)=0
      CALL LCMPUT(IPMAC2,'IDATAXS',7,1,IDATA)
      RETURN
  500 FORMAT(/' G R O U P   : ',I3/1X,'IHOM',9A14)
  510 FORMAT(1X,I4,1P,9E14.5)
  520 FORMAT(/5H  SUM,1P,8E14.5)
      END
