*DECK PRTPOW
      SUBROUTINE PRTPOW(NCH,NK,NX,NY,NZ,POWR,MIX,NREG,PCHAN,T,
     +                  IXN,IYN,IPRT,FSTH)
*
**********************************************************************
*
*     THIS ROUTINE PRINTS FUEL POWERS PER Z PLANES
*     OR AS A SUM FOR CHANNEL POWERS
*     THIS ROUTINE IS VALID ONLY FOR CARTESIAN GEOMETRY
*
*     CETTE SOUS ROUTINE IMPRIME
*     LES PUISSANCES DE GRAPPE ET DE CANAL
*     LA SEULE GEOMETRIE CONSIDEREE EST CARTESIENNE
*
*
*-------------------------------------- AUTHOR: E. VARIN  95/09/20 ---
*
      IMPLICIT NONE
*
*  LOCAL VARIABLES
*
      INTEGER NCH,NK,NREG,NX,NY,NZ,MIX(NREG),IMAX,IXMAX,IYMAX,IZMAX
      INTEGER IR,I,J,K,P,IPRT,IXN(NX),IYN(NY)
      INTEGER I1,I2,J1,J2
      REAL    POWR(NCH*NK),NUL,PCHAN(NCH),T(NX),PBMAX,PMAX,FSTH
      CHARACTER  XNAME*4,YNAME*4,NAMCHA*8,NAMBUN*8
      CHARACTER  FORM*16,FORM2*17
      CHARACTER*5   VIRT,HIPREC
      CHARACTER*132 VAL
      DATA       VIRT/' '/
      DATA       NUL/0.0/
*
      WRITE(FORM,'(A4,I2,A10)')  '(A2,',NX,'(F5.0,1X))'
      WRITE(FORM2,'(A4,I2,A11)')  '(A4,',NX,'(1X,A4,1X))'
*      WRITE(FORM2,'(A4,I2,A11)')  '(2X,',NX-6,'(1X,A4,1X))'
*
*
*     PRINTING OF POWERS PER BUNDLE ( ONE RADIAL PLAN PER Z AXIS)
*
      PBMAX = 0.0
      DO 95 I=1,NZ
          IF( IPRT.GT.3 ) THEN
              WRITE(6,'(/)')
              WRITE(6,*)
     +         '                    BUNDLE POWERS (kW), PLANE # ',I
              WRITE(6,FORM2) '    ',(IXN(P),P=1,NX)
          ENDIF
          DO 90 J=1,NY
            DO 91 K=1,NX
              IR = (I-1)*NX*NY + (J-1)*NY + K
              IF(MIX(IR).EQ.0) THEN
                T(K) = NUL
              ELSE
                IF( POWR(MIX(IR)).GT.PBMAX )THEN
                   PBMAX = POWR(MIX(IR))
                   IMAX=MIX(IR)
                   IXMAX=K
                   IYMAX=J
                   IZMAX=I
                ENDIF
                T(K) = POWR(MIX(IR))*FSTH
              ENDIF
 91         CONTINUE
            IF( IPRT.GT.3 ) THEN
               WRITE(YNAME,'(A4)') IYN(J)
               WRITE(6,FORM) YNAME(1:2),(T(P),P=1,NX)
            ENDIF
 90       CONTINUE
 95   CONTINUE
      WRITE(XNAME,'(A4)') IXN(IXMAX)
      WRITE(YNAME,'(A4)') IYN(IYMAX)
      WRITE(NAMBUN,'(A1,A4)')  YNAME(1:1),XNAME
*
      DO 1 I=1,NCH
       PCHAN(I) = 0.0
       DO 1 J=1,NK
        IR = (J-1)*NCH + I
        PCHAN(I) = PCHAN(I) + POWR(IR)
 1    CONTINUE
*
      WRITE(6,'(/)')
      WRITE(6,*) '                    CHANNEL POWERS (kW) '
      WRITE(6,FORM2) '    ',(IXN(P),P=1,NX)
      PMAX = 0.0
      DO 9 J=1,NY
       DO 7 I=1,131
         I1 = I
         I2 = I1+1
         VAL(I1:I2)= ' '
   7   CONTINUE
       J1=1
       J2=4
       WRITE(VAL(J1:J2),'(A4)') IYN(J)
       IF(VAL(J1:J1).NE.'-') THEN
       DO 10 K=1,NX
*       DO 10 K=4,NX-3
         J1  = J2+1
         J2  = J1+4
         IR = (J-1)*NY + K
         IF(MIX(IR).EQ.0) THEN
           T(K) = NUL
         ELSE
           IF( PCHAN(MIX(IR)).GT.PMAX )THEN
             PMAX = PCHAN(MIX(IR))
             IMAX=MIX(IR)
             IXMAX=K
             IYMAX=J
           ENDIF
           T(K) = PCHAN(MIX(IR))*FSTH
           WRITE(HIPREC,'(F5.0)') T(K)
           WRITE(VAL(J1:J2),'(A4,1X)') HIPREC(1:4)
         ENDIF
 10    CONTINUE
       WRITE(6,'(1X,A132)') VAL
       ENDIF
 9    CONTINUE
      WRITE(XNAME,'(A4)') IXN(IXMAX)
      WRITE(YNAME,'(A4)') IYN(IYMAX)
      WRITE(NAMCHA,'(A1,A4)')  YNAME(1:1),XNAME
      WRITE(6,1000) 'MAXIMUM CHANNEL POWER',PMAX*FSTH,NAMCHA
      WRITE(6,1100) 'MAXIMUM BUNDLE POWER',PBMAX*FSTH,
     +             NAMBUN(1:4),'PLANE',IZMAX
*
      RETURN
 1000 FORMAT(2X,A21,2X,F5.0,1X,A8)
 1100 FORMAT(2X,A20,2X,F5.0,1X,A4,1X,A5,I2)
      END
