*DECK PUTMAC
      SUBROUTINE PUTMAC (IPLIST,NMIXT,NGRP,NL,TOTAL,ZNUSIG,ZSIGF,
     1   CHI,OVERV,DIFFX,DIFFY,DIFFZ,H,IJJ,NJJ,SCAT,WORK,IPOS)
*
*-----------------------------------------------------------------------
*
*      STORE CROSS SECTIONS IN A NEW LINKED LIST.
*
*      INPUT PARAMETERS:
*        IPLIST : ADDRESS OF THE LINKED LIST OR HANDLE TO THE XSM FILE.
*        NMIXT  : MAXIMUM NUMBER OF MATERIAL MIXTURES.
*        NGRP   : NUMBER OF ENERGY GROUPS.
*        NL     : NUMBER OF LEGENDRE ORDERS (=1 FOR ISOTROPIC SCATTERING
*        IMPX   : PRINT PARAMETER. EQUAL TO ZERO FOR NO PRINT.
*
*      OUTPUT PARAMETER:
*        IPLIST : ADDRESS OF THE LINKED LIST OR HANDLE TO THE XSM FILE T
*                 HAS BEEN MODIFIED
*
*      SCRATCH STORAGE:
*        TOTAL  : DIMENSION TOTAL(NMIXT,NGRP)
*        ZNUSIG : DIMENSION ZNUSIG(NMIXT,NGRP)
*        ZSIGF  : DIMENSION ZSIGF(NMIXT,NGRP)
*        CHI    : DIMENSION CHI(NMIXT,NGRP)
*        OVERV  : DIMENSION OVERV(NMIXT,NGRP)
*        DIFFX  : DIMENSION DIFFX(NMIXT,NGRP)
*        DIFFY  : DIMENSION DIFFY(NMIXT,NGRP)
*        DIFFZ  : DIMENSION DIFFZ(NMIXT,NGRP)
*        H      : DIMENSION H(NMIXT,NGRP)
*        IJJ    : DIMENSION IJJ(NMIXT,NL,NGRP)
*        NJJ    : DIMENSION NJJ(NMIXT,NL,NGRP)
*        SCAT   : SCAT(NMIXT,NL,NGRP,NGRP)
*        WORK   : WORK(NMIXT*NGRP)
*        IPOS   : IPOS(NMIXT)
*
*----MODIFIED BY J. KOCLAS-94/03/12---- AUTHOR: A. HEBERT ; 26/07/93 ---
*            AND E. VARIN-94/10/19
*
*      IMPLICIT NONE
*
      INTEGER IGR,IBM,IL,JGR,ILENGT,IPLIST,ITYLCM,NMIXT,NL,NGRP
      INTEGER IPOSDE
      CHARACTER CGRPNM*12,CM*2
      REAL TOTAL((NMIXT+1),*),ZNUSIG((NMIXT+1),*),ZSIGF((NMIXT+1),*),
     1 CHI((NMIXT+1),*),OVERV((NMIXT+1),*),DIFFX((NMIXT+1),*),
     2 DIFFY((NMIXT+1),*),DIFFZ((NMIXT+1),*),
     3 SCAT((NMIXT+1),NL,NGRP,*),H((NMIXT+1),*),
     4 WORK(*)
      INTEGER IJJ(NMIXT,NL,*),NJJ(NMIXT,NL,*),IPOS(*)
*
*     STORE CROSS SECTIONS IF EXIST
      DO 40 JGR=1,NGRP
*
         WRITE (CGRPNM,'(5HGROUP,I3,1H/,I3)') JGR,NGRP
         CALL LCMSIX(IPLIST,CGRPNM,1)
         CALL LCMLEN(IPLIST,'TOTAL',ILENGT,ITYLCM)
         IF(ILENGT.NE.0) THEN
            CALL LCMPUT(IPLIST,'TOTAL',NMIXT,ITYLCM,TOTAL(1,JGR))
         ELSE
            CALL XABORT('PUTMAC: INVALID INPUT MACROLIB(1).')
         ENDIF
         CALL LCMLEN(IPLIST,'NUSIGF',ILENGT,ITYLCM)
         IF(ILENGT.NE.0)
     +    CALL LCMPUT(IPLIST,'NUSIGF',NMIXT,ITYLCM,ZNUSIG(1,JGR))
         CALL LCMLEN(IPLIST,'NFTOT',ILENGT,ITYLCM)
         IF(ILENGT.NE.0)
     +    CALL LCMPUT(IPLIST,'NFTOT',NMIXT,ITYLCM,ZSIGF(1,JGR))
         CALL LCMLEN(IPLIST,'CHI',ILENGT,ITYLCM)
         IF(ILENGT.NE.0)
     +    CALL LCMPUT(IPLIST,'CHI',NMIXT,ITYLCM,CHI(1,JGR))
         CALL LCMLEN(IPLIST,'OVERV',ILENGT,ITYLCM)
         IF(ILENGT.NE.0)
     +    CALL LCMPUT(IPLIST,'OVERV',NMIXT,ITYLCM,OVERV(1,JGR))
         CALL LCMLEN(IPLIST,'DIFFX',ILENGT,ITYLCM)
         IF(ILENGT.NE.0)
     +    CALL LCMPUT(IPLIST,'DIFFX',NMIXT,ITYLCM,DIFFX(1,JGR))
         CALL LCMLEN(IPLIST,'DIFFY',ILENGT,ITYLCM)
         IF(ILENGT.NE.0)
     +    CALL LCMPUT(IPLIST,'DIFFY',NMIXT,ITYLCM,DIFFY(1,JGR))
         CALL LCMLEN(IPLIST,'DIFFZ',ILENGT,ITYLCM)
         IF(ILENGT.NE.0)
     +    CALL LCMPUT(IPLIST,'DIFFZ',NMIXT,ITYLCM,DIFFZ(1,JGR))
         CALL LCMLEN(IPLIST,'H-FACTORS',ILENGT,ITYLCM)
         IF(ILENGT.NE.0)
     +    CALL LCMPUT(IPLIST,'H-FACTORS',NMIXT,ITYLCM,H(1,JGR))
         DO 30 IL=1,NL
            WRITE (CM,'(I2)') IL-1
            CALL LCMLEN(IPLIST,'SCAT'//CM,ILENGT,ITYLCM)
            IF(ILENGT.NE.0) THEN
               IPOSDE = 0
               DO 20 IBM=1,NMIXT
                  IPOS(IBM) = IPOSDE+1
               DO 20 IGR=IJJ(IBM,IL,JGR),IJJ(IBM,IL,JGR)-
     +              NJJ(IBM,IL,JGR)+1,-1
                  IPOSDE = IPOSDE+1
                  WORK(IPOSDE)=SCAT(IBM,IL,IGR,JGR)
   20          CONTINUE
*
            CALL LCMPUT(IPLIST,'SCAT'//CM,IPOSDE,2,WORK)
            CALL LCMPUT(IPLIST,'IPOS'//CM,NMIXT,1,IPOS)
            CALL LCMPUT(IPLIST,'NJJ'//CM,NMIXT,1,NJJ(1,IL,JGR))
            CALL LCMPUT(IPLIST,'IJJ'//CM,NMIXT,1,IJJ(1,IL,JGR))
            CALL LCMPUT(IPLIST,'SIGW'//CM,NMIXT,2,SCAT(1,IL,JGR,JGR))
            ENDIF
   30    CONTINUE
         CALL LCMSIX(IPLIST,' ',2)
   40    CONTINUE
*
      CALL LCMSIX(IPLIST,' ',0)
*
      RETURN
      END
