*DECK PWCPPF
      SUBROUTINE PWCPPF(NCH,NK,POWRI,POWRTA,CPPF,BPPF,MIX,IXN,IYN,
     +                  NX,NY,NREG,T,CPFZON)
*
**********************************************************************
*
*     THIS SUBROUTINE COMPUTES AND PRINTS CPPF AND BPPF
*     CPPF = MAX OF THE INST. CHANNEL POWER OVER TIME-AVERAGE VALUE
*     BPPF = MAX OF THE INST. BUNDLE POWER OVER TIME-AVERAGE VALUE
*
*     CETTE SOUS ROUTINE CALCULE LE CPPF ET LE BPPF
*     LA SEULE GEOMETRIE CONSIDEREE EST 3D-CARTESIEN
*
*
*-------------------------------------- AUTHOR: E. VARIN  95/11/21 ---
*
      IMPLICIT NONE
*
*  LOCAL VARIABLES
*
      INTEGER I,J,IMAX,JMAX,IY,IX,ICH,K,IR,P,IBPMAX
      INTEGER NCH,NK,NX,NY,NREG,IXN(NX),IYN(NY),MIX(NREG),CPFZON(NCH)
      REAL    POWRI(NCH,NK),POWRTA(NCH,NK),CPPF(NCH),BPPF(NCH,NK)
      REAL    SPOWI,SPOWTA,MAXCP,MAXBP,T(NX)
      CHARACTER  FORM*16,FORM2*17
      CHARACTER  XNAM*4,YNAM*4,NAMCHA*8
      DOUBLE PRECISION  FACT,POW1,POW2,DIFF
*
      WRITE(FORM,'(A4,I2,A10)')  '(A2,',NX,'(F5.0,1X))'
      WRITE(FORM2,'(A4,I2,A11)')  '(A4,',NX,'(1X,A4,1X))'
*
*     CHANNEL POWER CALCULATION
*
      POW1 = 0.0D0
      POW2 = 0.0D0
      DO 40 I=1,NCH
       DO 41 J=1,NK
          POW1 = POW1 + POWRI(I,J)
          POW2 = POW2 + POWRTA(I,J)
  41   CONTINUE
  40  CONTINUE
      DIFF = ABS( POW1 - POW2 )
      IF (DIFF.GT.1.E+3) THEN
        FACT = POW1/POW2
        WRITE(6,*) ' VARIATION IN POWER ',DIFF
        WRITE(6,*) ' REFERENCE POWER',POW2,' NORMALIZED TO ',POW1
        DO 42 I=1,NCH
         DO 43 J=1,NK
            POWRTA(I,J) = POWRTA(I,J) * FACT
  43     CONTINUE
  42    CONTINUE
      ENDIF
*
*     CPPF AND BPPF CALCULATION
*
      DO 95 I=1,NCH
          SPOWI = 0.0
          SPOWTA = 0.0
       DO 96 J=1,NK
          SPOWI = SPOWI + POWRI(I,J)
          SPOWTA = SPOWTA + POWRTA(I,J)
          BPPF(I,J) = POWRI(I,J) / POWRTA(I,J)
 96    CONTINUE
          CPPF(I) = SPOWI/SPOWTA
 95   CONTINUE
*
      MAXCP = 0.0
      MAXBP = 0.0
      DO 110 I=1,NCH
         MAXCP = MAX(MAXCP,CPPF(I))
         IF(MAXCP.EQ.CPPF(I)) THEN
            IMAX = I
         ENDIF
       DO 111 J=1,NK
         MAXBP = MAX(MAXBP,BPPF(I,J))
         IF(MAXBP.EQ.BPPF(I,J)) THEN
            IBPMAX = I
            JMAX = J
         ENDIF
  111  CONTINUE
  110 CONTINUE
*
*     CHANNEL NAMES
*
      DO 20 I=1,NREG
        IF(MIX(I).EQ.IMAX) THEN
           ICH = I
           GOTO 21
        ENDIF
  20  CONTINUE
  21  IY = ICH/NX + 1
      IX = ICH - NX*(IY-1)
*
      WRITE(6,'(/)')
      WRITE(6,*) '                    CHANNEL POWER PEAKING FACTORS '
      WRITE(6,FORM2) '    ',(IXN(P),P=1,NX)
      DO 9 J=1,NY
       DO 10 K=1,NX
         IR = (J-1)*NY + K
         IF(MIX(IR).EQ.0) THEN
           T(K) = 0.0
         ELSE
           T(K) = CPPF(MIX(IR))*1000.
         ENDIF
 10    CONTINUE
       WRITE(YNAM,'(A4)') IYN(J)
       WRITE(6,FORM) YNAM(1:2),(T(P),P=1,NX)
 9    CONTINUE
      WRITE(XNAM,'(A4)') IXN(IX)
      WRITE(YNAM,'(A4)') IYN(IY)
      WRITE(NAMCHA,'(A4,A4)')  YNAM,XNAM
      WRITE(6,'(15HMAXIMAL CPPF = ,F8.6,10H  CHANNEL ,A8)')
     +       MAXCP,NAMCHA
      DO 30 I=1,NREG
        IF(MIX(I).EQ.IBPMAX) THEN
           ICH = I
           GOTO 31
        ENDIF
  30  CONTINUE
  31  IY = ICH/NX + 1
      IX = ICH - NX*(IY-1)
      WRITE(6,*) ' IX ',IX,' IY ',IY,' IMAX ',IBPMAX,' ICH ',ICH
      WRITE(XNAM,'(A4)') IXN(IX)
      WRITE(YNAM,'(A4)') IYN(IY)
      WRITE(NAMCHA,'(A4,A4)')  YNAM,XNAM
      WRITE(6,'(15HMAXIMAL BPPF = ,F8.6,10H  CHANNEL ,A8,1X,I4)')
     +          MAXBP,NAMCHA,JMAX
*
*     COMPUTE MAXIMUM CPPF IN RESTRICTIVE ZONE (CPPF-ZONE)
*
      IMAX = 0
      MAXCP = 0.0
      DO 210 I=1,NCH
        IF(CPFZON(I).NE.0) THEN
         MAXCP = MAX(MAXCP,CPPF(I))
         IF(MAXCP.EQ.CPPF(I)) THEN
            IMAX = I
         ENDIF
        ENDIF
  210 CONTINUE
      IF( IMAX.EQ.0 )CALL XABORT('PWCPPF: PROBLEM IN MAX SEARCH')
*
      WRITE(6,'(/)')
      WRITE(6,*) '                    CHANNEL POWER PEAKING FACTORS '
      WRITE(6,*) '                        IN CPPF ZONE '
      WRITE(6,FORM2) '    ',(IXN(P),P=1,NX)
      DO 69 J=1,NY
       DO 70 K=1,NX
         IR = (J-1)*NY + K
         IF(MIX(IR).EQ.0) THEN
           T(K) = 0.0
         ELSE
           IF( CPFZON(MIX(IR)).NE.0 )THEN
              T(K) = CPPF(MIX(IR))*1000.
           ELSE
              T(K) = 0.0
           ENDIF
         ENDIF
 70    CONTINUE
       WRITE(YNAM,'(A4)') IYN(J)
       WRITE(6,FORM) YNAM(1:2),(T(P),P=1,NX)
 69   CONTINUE
*
      DO 50 I=1,NREG
        IF(MIX(I).EQ.IMAX) THEN
           ICH = I
           GOTO 51
        ENDIF
  50  CONTINUE
  51  IY = ICH/NX + 1
      IX = ICH - NX*(IY-1)
      WRITE(XNAM,'(A4)') IXN(IX)
      WRITE(YNAM,'(A4)') IYN(IY)
      WRITE(NAMCHA,'(A4,A4)')  YNAM,XNAM
      WRITE(6,'(15HMAXIMAL CPPF = ,F8.6,10H  CHANNEL ,A8)')
     +               MAXCP,NAMCHA
*
      RETURN
      END
