*DECK READET
      SUBROUTINE READET(IPLDET,TYPE,NREP,RESPON,IPRT,LHEX)
*
**********************************************************************
*
*     THIS MODULE READS AND STORES DETECTOR DATA
*
*     CETTE ROUTINE LIT ET RANGE LES DONNEES D'UN CONTROLEUR
*
*     INPUT :
*              TYPE   : CHARACTER*12
*                       DETECTOR TYPE NAME
*              NREP   : INTEGER
*                       NUMBER OF VALUES STORED FOR DETECTOR RESPONSE
*              RESPON : REAL
*                       DETECTOR RESPONSES
*              IPRT   : INTEGER
*                       PRINTING FLAG
*              LHEX   : LOGICAL
*                       .TRUE. : HEXAGONAL GEOMETRY
*                       .FALSE. : CARTESIAN GEOMETRY
*     OUTPUT :
*              IPLDET : INTEGER
*                       ADRESS OF DETECT OBJECT
*
*-------------------------------------- AUTHOR: E. VARIN  94/09/30   ---
*
      IMPLICIT NONE
*
      REAL BASE
      INTEGER IBASE(1)
      COMMON BASE(1)
      EQUIVALENCE (BASE(1),IBASE(1))
*
* DETECTEUR STRUCTURE
*
      CHARACTER TYPE*12,NAMDET*12
      INTEGER   I,IPRT,NREP,IHEX,NHEX,IPLDET
      REAL      DEVPOS(6)
      REAL      RESPON(NREP)
      LOGICAL   LHEX
*
      CHARACTER*12 TEXT
      INTEGER ITYP,NITMA
      REAL FLOTT
      DOUBLE PRECISION DFLOTT
*
* READ IN DETECTOR NAME AND PARAMETERS
*
  10  CALL REDGET(ITYP,NITMA,FLOTT,TEXT,DFLOTT)
      IF(ITYP.EQ.3) THEN
        IF (TEXT.EQ.'NAME') THEN
         CALL REDGET(ITYP,NITMA,FLOTT,NAMDET,DFLOTT)
         IF (ITYP.NE.3) CALL XABORT('READET: CHARACTER DATA EXPECTED')
        ELSEIF (TEXT.EQ.'NHEX') THEN
          IF( .NOT.LHEX )CALL XABORT('READET: INVALID KEYWORD NHEX ')
          CALL REDGET(ITYP,NHEX,FLOTT,TEXT,DFLOTT)
          IF (ITYP.NE.1) CALL XABORT('READET: INTEGER DATA EXPECTED')
          CALL SETARA(IBASE,NHEX,IHEX)
          CALL REDGET(ITYP,NITMA,FLOTT,TEXT,DFLOTT)
          IF(ITYP.NE.3) THEN
             CALL XABORT('READET: CHARACTER DATA EXPECTED HEX')
          ELSEIF(TEXT.EQ.'HEX') THEN
            DO 5 I=1,NHEX
              CALL REDGET(ITYP,IBASE(IHEX+I-1),FLOTT,TEXT,DFLOTT)
              IF(ITYP.NE.1)
     +           CALL XABORT('READET: INTEGER DATA EXPECTED FOR HEX')
 5          CONTINUE
          ENDIF
        ELSEIF (TEXT.EQ.'POSITION') THEN
         DO 20 I=1,6
          CALL REDGET(ITYP,NITMA,DEVPOS(I),TEXT,DFLOTT)
          IF (ITYP.NE.2) CALL XABORT('READET: REAL DATA EXPECTED')
  20     CONTINUE
        ELSEIF (TEXT.EQ.'RESP') THEN
         DO 40 I=1,NREP
           CALL REDGET(ITYP,NITMA,RESPON(I),TEXT,DFLOTT)
           IF (ITYP.NE.2) CALL XABORT('READET: REAL DATA EXPECTED')
  40     CONTINUE
        ELSEIF (TEXT.EQ.'ENDN') THEN
          GOTO 30
        ELSE
          CALL XABORT('READET: INVALID KEYWORD '//TEXT)
        ENDIF
      ELSE
         CALL XABORT('READET: CHARACTER DATA EXPECTED')
      ENDIF
      GOTO 10
*
*     STORAGE OF INFORMATION IN DETECT OBJECT
*
  30  CALL LCMSIX(IPLDET,' ',0)
      CALL LCMSIX(IPLDET,TYPE,1)
      CALL LCMSIX(IPLDET,NAMDET,1)
      CALL LCMPUT(IPLDET,'POSITION',6,2,DEVPOS)
      IF( LHEX )CALL LCMPUT(IPLDET,'NHEX',NHEX,1,IBASE(IHEX))
      CALL LCMPUT(IPLDET,'RESPON',NREP,2,RESPON)
      IF( LHEX )CALL RLSARA(IBASE(IHEX))
*
      RETURN
      END
