*DECK READEV
      SUBROUTINE READEV(IPLDEV,TYPE,FAMILY,SEQUEN,MOVDIR,
     +                  DELTA,NGEO,NMIX,MIX,CPT,TOT,LHEX,LMIX)
*
**********************************************************************
*
*     THIS ROUTINE READS AND STORES DEVICE INFORMATION
*
*     CETTE ROUTINE LIT ET RANGE LES DONNEES D'UN CONTROLEUR
*
*     INPUT :
*              NGEO   : INTEGER
*                       TOTAL NUMBER OF REGIONS (ISTATE(7))
*              TOT    : INTEGER
*                       NUMBER OF DESCRIPTOR ALREADY STORED IN DEVICE
*              LHEX   : LOGICAL
*                       = .TRUE. HEXAGONALE 3-D ; = .FALSE. CARTESIAN 3-
*              LMIX   : LOGICAL
*                       = .TRUE. ONLY MIXTURE NUMBERS ARE UPDATED
*                       = .FALSE. ALL DEVICE INFORMATIONS ARE READ
*     OUTPUT :
*              IPLDEV : ENTIER
*                       ADRESSE DE L'OBJET DEVICE
*              TYPE   : CHARACTER*12
*                       DEVICE TYPE NAME
*              FAMILY : CHARACTER*12
*                       DEVICE FAMILY NAME
*              SEQUEN : CHARACTER*12
*                       DEVICE SEQUENCE NAME
*              MOVDIR : CHARACTER*1
*                       DEVICE MOVEMENT AXIS. X, Y OR Z
*              CPT    : ENTIER
*                       NUMBER OF DESCRIPTORS OF THE CURRENT DEVICE
*
*
*-------------------------------------- AUTHOR: J. KOCLAS 94/04/10 ---
*                                      MODIFIED  E. VARIN  95/02/20
      IMPLICIT NONE
*
      INTEGER  IPLDEV,DELTA,NGEO,NMIX,CPT,MIX(*),TOT
C
C DEVICE STRUCTURE
C
      CHARACTER TYPE*12,FAMILY*12,SEQUEN*12,NMDESC*12
      REAL DEVPOS(6)
      REAL MAXPOS(6)
      CHARACTER*4 MOVDIR
      REAL SPEED
      REAL PARAM(2)
      INTEGER MIXNB(2),IMOV
*
      CHARACTER*12 TEXT
      INTEGER      ITYP,NITMA,IPOS,NHEX,MAXHEX,IHEX,I
      REAL         FLOTT
      DOUBLE PRECISION DFLOTT
      LOGICAL      MIXEQ,LHEX,LMIX
*  COMMON BLANK
      REAL BASE
      INTEGER IBASE(1)
      COMMON BASE(1)
      EQUIVALENCE (BASE(1),IBASE(1))
*
      CALL LCMSIX(IPLDEV,' ',0)
C
C READ IN DEVICE TYPE
C
      CALL REDGET(ITYP,NITMA,FLOTT,TEXT,DFLOTT)
      IF(ITYP.NE.3) THEN
       CALL XABORT('READEV: CHARACTER DATA EXPECTED TYPE')
      ELSE
       TYPE = TEXT
      ENDIF
      CALL LCMSIX(IPLDEV,TYPE,1)
C
C READ IN DEVICE FAMILY
C
      CALL REDGET(ITYP,NITMA,FLOTT,TEXT,DFLOTT)
      IF(ITYP.NE.3) THEN
       CALL XABORT('READEV: CHARACTER DATA EXPECTED FAMILY')
      ELSE
       FAMILY = TEXT
      ENDIF
      CALL LCMSIX(IPLDEV,FAMILY,1)
C
C READ IN DEVICE SEQUEN NUMBER
C
      CALL REDGET(ITYP,NITMA,FLOTT,TEXT,DFLOTT)
      IF(ITYP.NE.3) THEN
       CALL XABORT('READEV: CHARACTER DATA EXPECTED SEQUENCE')
      ELSE
       SEQUEN = TEXT
      ENDIF
      CALL LCMSIX(IPLDEV,SEQUEN,1)
C
C READ IN NUMBER OF HEXAGONS AFFECTED
C AND HEXAGONS NUMBERS BETWEEN 1 AND LX
C
      IF (LHEX) THEN
       CALL REDGET(ITYP,NITMA,FLOTT,TEXT,DFLOTT)
       IF(ITYP.NE.3) THEN
          CALL XABORT('READEV: CHARACTER DATA EXPECTED NHEX')
       ELSEIF(TEXT.EQ.'NHEX') THEN
          CALL REDGET(ITYP,NITMA,FLOTT,TEXT,DFLOTT)
          IF(ITYP.NE.1) THEN
            CALL XABORT('READEV: INTEGER DATA EXPECTED FOR NHEX')
          ELSE
             NHEX=NITMA
          ENDIF
       ENDIF
       CALL SETARA(IBASE,NHEX,IHEX)
       CALL REDGET(ITYP,NITMA,FLOTT,TEXT,DFLOTT)
       IF(ITYP.NE.3) THEN
        CALL XABORT('READEV: CHARACTER DATA EXPECTED HEX')
       ELSEIF(TEXT.EQ.'HEX') THEN
        MAXHEX = 0
        DO 5 I=1,NHEX
          CALL REDGET(ITYP,NITMA,FLOTT,TEXT,DFLOTT)
          IF(ITYP.NE.1) THEN
            CALL XABORT('READEV: INTEGER DATA EXPECTED FOR HEX')
          ELSE
             MAXHEX = MAX(MAXHEX,NITMA)
             IBASE(IHEX+I-1) = NITMA
          ENDIF
 5      CONTINUE
        IF(MAXHEX.GT.NGEO) CALL XABORT('READEV: HEXAGON NUMBER GREATER '
     +   //' THAN LX')
        CALL LCMPUT(IPLDEV,'NHEX',NHEX,1,IBASE(IHEX))
        CALL RLSARA(IBASE(IHEX))
       ELSE
         CALL XABORT('READEV: INVALID KEYWORD EXPECTED HEX')
       ENDIF
      ENDIF
C
C READ IN DEVICE MAXIMUM POSITIONS
C ORDER IS XMIN XMAX YMIN YMAX ZMIN ZMAX
C
      IF( LMIX )THEN
        CALL LCMGET(IPLDEV,'POSITION_MAX',MAXPOS)
        CALL LCMGET(IPLDEV,'MOVEMENT_DIR',IMOV)
        WRITE(MOVDIR,'(A4)') IMOV
        CALL LCMGET(IPLDEV,'SPEED',SPEED)
        CALL LCMGET(IPLDEV,'PARAMETERS',PARAM)
      ELSE
        DO 20 IPOS=1,6
         TEXT=' '
         CALL REDGET(ITYP,NITMA,FLOTT,TEXT,DFLOTT)
         IF(ITYP.NE.2) THEN
           CALL XABORT('READEV: REAL DATA EXPECTED')
         ELSE
           MAXPOS(IPOS)=FLOTT
         ENDIF
 20     CONTINUE
        CALL LCMPUT(IPLDEV,'POSITION_MAX',6,2,MAXPOS)
C
C READ IN DEVICE MOVEMENT DIRECTION (X Y OR Z)
C
        TEXT=' '
        CALL REDGET(ITYP,NITMA,FLOTT,TEXT,DFLOTT)
        IF(ITYP.NE.3) THEN
          CALL XABORT('READEV: CHARACTER DATA EXPECTED MOVDIR')
        ELSE
          READ(TEXT,'(1A4)') MOVDIR
        ENDIF
        READ(MOVDIR,'(A4)') IMOV
        CALL LCMPUT(IPLDEV,'MOVEMENT_DIR',1,3,IMOV)
C
C READ IN DEVICE SPEED
C SPEED UNITS DEPENDS ON DEVICE
C
        TEXT=' '
        CALL REDGET(ITYP,NITMA,FLOTT,TEXT,DFLOTT)
        IF(ITYP.NE.2) THEN
          CALL XABORT('READEV: REAL DATA EXPECTED')
        ELSE
          SPEED=FLOTT
        ENDIF
        CALL LCMPUT(IPLDEV,'SPEED',1,2,SPEED)
C
C READ IN DEVICE PARAMETERS
C PARAMETERS DEPEND ON DEVICE
C AND ARE THERE FOR PARTICULAR ANALYSIS NEEDS
C
        DO 30 IPOS=1,2
          TEXT=' '
          CALL REDGET(ITYP,NITMA,FLOTT,TEXT,DFLOTT)
          IF(ITYP.NE.2) THEN
            CALL XABORT('READEV: REAL DATA EXPECTED')
          ELSE
            PARAM(IPOS)=FLOTT
          ENDIF
  30    CONTINUE
        CALL LCMPUT(IPLDEV,'PARAMETERS',2,2,PARAM)
      ENDIF
C
C READ IN DEVICE DESCRIPTION PARTS
C
      CPT = 0
  50  CALL REDGET(ITYP,NITMA,FLOTT,TEXT,DFLOTT)
      MIXEQ = .FALSE.
      IF (ITYP.NE.3) THEN
        CALL XABORT('READEV: CHARACTER DATA EXCEPTED FOR '
     +     //'DEVICE DESCRIPTION')
      ELSE
         IF (TEXT.EQ.'ENDDEV') THEN
            IF (CPT.EQ.0) THEN
             CALL XABORT('READEV: EACH DEVICE NEEDS AT '
     +        //'LEAST ONE DESCRIPTION')
            ENDIF
            GOTO 60
         ELSE
            CPT = CPT + 1
C
C           READ IN DEVICE DESCRIPTION NAME
C
            NMDESC = TEXT
            CALL LCMSIX(IPLDEV,NMDESC,1)
C
C           READ IN DEVICE POSITIONS
C           ORDER IS XMIN XMAX YMIN YMAX ZMIN ZMAX
C
            IF( LMIX )THEN
              CALL LCMGET(IPLDEV,'POSITION',DEVPOS)
            ELSE
            DO 10 IPOS=1,6
             CALL REDGET(ITYP,NITMA,FLOTT,TEXT,DFLOTT)
             IF(ITYP.NE.2) THEN
              CALL XABORT('READEV: REAL DATA EXPECTED')
             ELSE
              DEVPOS(IPOS)=FLOTT
             ENDIF
 10         CONTINUE
            CALL LCMPUT(IPLDEV,'POSITION',6,2,DEVPOS)
            ENDIF
C
C           READ IN DEVICE MIXTURE NUMBER
C
            DO 40 IPOS=1,2
             CALL REDGET(ITYP,NITMA,FLOTT,TEXT,DFLOTT)
             IF(ITYP.NE.1) THEN
              CALL XABORT('READEV: INTEGER DATA EXPECTED')
             ELSE
              MIXNB(IPOS)=NITMA
             ENDIF
  40        CONTINUE
            IF(MIXNB(1).EQ.MIXNB(2))  MIXEQ = .TRUE.
            IF(.NOT.LHEX) THEN
              MIX(NGEO+TOT*DELTA+DELTA*(CPT-1) + 1) = MIXNB(1)
              MIXNB(1) = NMIX + TOT*DELTA + DELTA*(CPT-1) + 1
              IF (MIXNB(2).NE.0) THEN
                MIX(NGEO+TOT*DELTA+DELTA*(CPT-1) + 2) = MIXNB(2)
                IF(MIXEQ) THEN
                  MIXNB(2) = MIXNB(1)
                ELSE
                  MIXNB(2) = NMIX + TOT*DELTA + DELTA*(CPT-1) + 2
                ENDIF
              ENDIF
            ENDIF
            CALL LCMPUT(IPLDEV,'MIX_NUMBER',2,1,MIXNB)
            CALL LCMSIX(IPLDEV,' ',2)
         ENDIF
      ENDIF
      GOTO 50
*
  60  RETURN
      END
