*DECK REFRES
      SUBROUTINE REFRES(NENTRY,HENTRY,IENTRY,JENTRY,KENTRY)
*
*-----------------------------------------------------------------------
*
*     THIS MODULE CREATES AN INDEX BETWEEN FUEL MAP GEOMETRY AND
*     INITIAL GEOMETRY, STORED IN FUEL MAP THE MIXTURE NUMBERS
*     INPUT IN INITIAL GEOMETRY AND MOFIFY INDEX OBJECT WITH
*     RESPECT TO FUEL MAP DEFINITION.
*
*     CE MODULE CREE UN INDEX DES NUMEROS DE COMPO DANS RESEAU
*     ET MODIFIE L_INDEX EN CONSEQUENCE
*
*     INPUT/OUTPUT PARAMETERS:
*      NENTRY : NUMBER OF LINKED LISTS OR FILES USED BY THE MODULE.
*      HENTRY : CHARACTER*12 NAME OF EACH LINKED LIST OR FILE.
*      IENTRY : =1 LINKED LIST; =2 XSM FILE; =3 SEQUENTIAL BINARY FILE;
*               =4 SEQUENTIAL ASCII FILE.
*      JENTRY : =0 THE LINKED LIST OR FILE IS CREATED.
*               =1 THE LINKED LIST OR FILE IS OPEN FOR MODIFICATIONS;
*               =2 THE LINKED LIST OR FILE IS OPEN IN READ-ONLY MODE.
*      KENTRY : =FILE UNIT NUMBER; =LINKED LIST ADDRESS OTHERWISE.
*
*      DIMENSION HENTRY(NENTRY),IENTRY(NENTRY),JENTRY(NENTRY),
*                KENTRY(NENTRY)
*
*     REQUIRED LINKED LISTS ARE :
*        KENTRY(1) : OBJECT TYPE L_MAP IN MODIFICATION MODE
*        KENTRY(2) : OBJECT TYPE L_INDEX IN MODIFICATION MODE
*        KENTRY(3) : OBJECT TYPE L_GEOM IN READ ONLY MODE
*
*     PROCEDURES CALLED :  RESIND, MAKIND
*
*-------------------------------------- AUTHOR: E. VARIN ; 30/08/95 ---
*
*      IMPLICIT NONE
      DOUBLE PRECISION  DFLOTT
      REAL   FLOTT
      CHARACTER HENTRY(*)*12,HSIGN*12,TEXT*12
      DIMENSION IENTRY(*),JENTRY(*),KENTRY(*)
      INTEGER  IPRES,IPIND,IPGEOM,ITYP,NX,NY,NZ,KCHAR(3),
     +         ILONG,NENTRY,ISTGEO(13),ISTRES(13),I,I1,
     +         GEOTYP,IMSX,IMSY,IMSZ,IMIX,IXX,IYY,IZZ,LX,LY,LZ,IIND,
     +         RDATA(6),NK,NCH,INCPO,NIND,IINDX,NITMA
      DIMENSION IBASE(1)
      COMMON BASE(1)
      EQUIVALENCE (BASE(1),IBASE(1))
*
* PARAMETER VALIDATION.
*
      IF(NENTRY.LT.3) CALL XABORT('REFRES: PARAMETER EXPECTED.')
      IPRES = 0
      IPGEOM = 0
      IPIND = 0
      DO 5 I=1,NENTRY
        IF((IENTRY(I).EQ.1).OR.(IENTRY(I).EQ.2)) THEN
         CALL LCMSIX(KENTRY(I),' ',0)
         CALL LCMGET(KENTRY(I),'SIGNATURE',KCHAR)
         WRITE(HSIGN,'(3A4)') (KCHAR(I1),I1=1,3)
         IF (HSIGN.EQ.'L_MAP') THEN
           IF (IPRES.EQ.0) IPRES=KENTRY(I)
           IF(JENTRY(I).NE.1) CALL XABORT('REFRES: MODIFICATION'
     +     //' MODE EXPECTED FOR OBJECT '//HSIGN//'.')
         ELSEIF (HSIGN.EQ.'L_INDEX') THEN
           IF (IPIND.EQ.0) IPIND=KENTRY(I)
           IF(JENTRY(I).NE.1) CALL XABORT('REFRES: MODIFICATION'
     +     //' MODE EXPECTED FOR OBJECT '//HSIGN//'.')
         ELSEIF (HSIGN.EQ.'L_GEOM') THEN
           IF(JENTRY(I).NE.2) CALL XABORT('REFRES: READ-ONL'
     +     //'Y MODE EXPECTED FOR OBJECT '//HSIGN//'.')
           IF (IPGEOM.EQ.0) IPGEOM=KENTRY(I)
         ENDIF
        ENDIF
   5  CONTINUE
      IF((IPRES.EQ.0).OR.(IPGEOM.EQ.0).OR.(IPIND.EQ.0))
     1  CALL XABORT('REFRES: OBJECT MISSING ')
*
*     CREATION OF AN INDEX BETWEEN FUEL AND SOLUTION GEOMETRIES
*
      CALL LCMSIX(IPRES,' ',0)
      CALL LCMGET(IPRES,'RES-DATA',RDATA)
      NK = RDATA(1)
      NCH = RDATA(2)
      CALL LCMLEN(IPRES,'GEO:RES',ILONG,ITYP)
      IF(ILONG.EQ.0) THEN
        CALL XABORT('REFRES: MAP GEOMETRY INFORMATIONS ARE REQUIRED')
      ENDIF
      CALL LCMSIX(IPRES,'GEO:RES',1)
      CALL LCMGET(IPRES,'STATE',ISTRES)
      GEOTYP = ISTRES(1)
      NX = ISTRES(3)
      NY = ISTRES(4)
      NZ = ISTRES(5)
      IF(NY.EQ.0) NY=1
      CALL SETARA(BASE,NX+1,IMSX)
      CALL SETARA(BASE,NY+1,IMSY)
      CALL SETARA(BASE,NZ+1,IMSZ)
      CALL SETARA(IBASE,NX*NY*NZ,IMIX)
      CALL LCMSIX(IPRES,' ',0)
      CALL LCMSIX(IPGEOM,' ',0)
      CALL LCMGET(IPGEOM,'STATE',ISTGEO)
      IF (ISTGEO(1).NE.GEOTYP) THEN
        CALL XABORT('REFRES: MAP AND GEOMETRY UNCOMPATIBLE (1)')
      ELSE
       LX = ISTGEO(3)
       LY = ISTGEO(4)
       LZ = ISTGEO(5)
       IF(LY.EQ.0) LY=1
      ENDIF
      IF ((LX.LT.NX).OR.(LY.LT.NY).OR.(LZ.LT.NZ))
     +    CALL XABORT('REFRES: MAP AND GEOMETRY UNCOMPATIBLE (2)')
      CALL SETARA(BASE,LX+1,IXX)
      CALL SETARA(BASE,LY+1,IYY)
      CALL SETARA(BASE,LZ+1,IZZ)
      CALL SETARA(IBASE,LX*LY*LZ,IIND)
      CALL LCMSIX(IPGEOM,' ',0)
      CALL RESIND(IPRES,IPGEOM,NX,NY,NZ,LX,LY,LZ,NK,NCH,BASE(IMSX),
     +   BASE(IMSY),BASE(IMSZ),BASE(IXX),BASE(IYY),BASE(IZZ),
     +   IBASE(IMIX),IBASE(IIND),GEOTYP)
*
      CALL RLSARA(BASE(IMSX))
      CALL RLSARA(BASE(IMSY))
      CALL RLSARA(BASE(IMSZ))
      CALL RLSARA(IBASE(IMIX))
      CALL RLSARA(BASE(IXX))
      CALL RLSARA(BASE(IYY))
      CALL RLSARA(BASE(IZZ))
*
      CALL SETARA(IBASE,NK*NCH,INCPO)
      CALL LCMSIX(IPIND,' ',0)
      CALL LCMLEN(IPIND,'MIX',NIND,ITYP)
      IF(NIND.EQ.0) THEN
        CALL XABORT('REFRES: L_INDEX INFORMATIONS REQUIRED')
      ENDIF
      IF(NIND.LT.LX*LY*LZ)
     +  CALL XABORT('REFRES: L_GEOM AND L_INDEX INCOMPATIBLE')
      CALL SETARA(IBASE,NIND,IINDX)
      CALL MAKIND(IPRES,IPIND,NIND,NCH,NK,LX,LY,LZ,IBASE(IIND),
     + IBASE(INCPO),IBASE(IINDX))
*
      CALL LCMPUT(IPRES,'INDEX',NK*NCH,1,IBASE(INCPO))
      CALL LCMPUT(IPIND,'MIX',NIND,1,IBASE(IINDX))
      CALL RLSARA(IBASE(INCPO))
      CALL RLSARA(IBASE(IINDX))
      CALL RLSARA(IBASE(IIND))
*
      CALL REDGET(ITYP,NITMA,FLOTT,TEXT,DFLOTT)
      IF (ITYP.EQ.10) GOTO 20
      IF (ITYP.NE.3) THEN
        CALL XABORT('REFRES: CHARACTER DATA EXPECTED')
      ELSE IF(TEXT.NE.';') THEN
        CALL XABORT('REFRES: ; EXPECTED TO END MODULE')
      ENDIF
*
 20   RETURN
      END
