*DECK REFUEL
      SUBROUTINE REFUEL(NENTRY,HENTRY,IENTRY,JENTRY,KENTRY)
*
*-----------------------------------------------------------------------
*
*     THIS MODULE IS USED TO MODIFY THE FUEL BURNUPS ACCORDING TO
*     DIFFERENT MODELS:
*        TIME-AVERAGE MODEL
*        INSTANTANEOUS REFUELING OF CHANNELS
*        CONSTANT EVOLUTION OF BURNUP IN TIME
*        SHUFFLING CHANNELS
*        AGING THEORY
*
*     CE MODULE DETERMINE LES BURNUPS DE CHAQUE SELON LE MODE
*     DE CALCUL (T-A OU SUIVI OU MODELE d'AGE).
*
*     INPUT/OUTPUT PARAMETERS:
*      NENTRY : NUMBER OF LINKED LISTS OR FILES USED BY THE MODULE.
*      HENTRY : CHARACTER*12 NAME OF EACH LINKED LIST OR FILE.
*      IENTRY : =1 LINKED LIST; =2 XSM FILE; =3 SEQUENTIAL BINARY FILE;
*               =4 SEQUENTIAL ASCII FILE.
*      JENTRY : =0 THE LINKED LIST OR FILE IS CREATED.
*               =1 THE LINKED LIST OR FILE IS OPEN FOR MODIFICATIONS;
*               =2 THE LINKED LIST OR FILE IS OPEN IN READ-ONLY MODE.
*      KENTRY : =FILE UNIT NUMBER; =LINKED LIST ADDRESS OTHERWISE.
*
*      DIMENSION HENTRY(NENTRY),IENTRY(NENTRY),JENTRY(NENTRY),
*                KENTRY(NENTRY)
*
*     REQUIRED LINKED LISTS ARE:
*        KENTRY(1) : OBJECT TYPE L_MAP IN MODIFICATION MODE
*        KENTRY(2) : OBJECT TYPE L_TAB IN READ ONLY MODE
*
*     PROCEDURES CALLED: TAWCAL, SHIFTB, SHUFFL,CELLAG,
*                        FOLCAL, RFBEXI, BEXSEL
*
* MODIFIED BY M.T. SISSAOUI 10/10/96
*
*-------------------------------------- AUTHOR: E. VARIN ; 14/09/95 ---
*
      IMPLICIT NONE
      CHARACTER HENTRY(*)*12,TEXT12*12,HSIGN*12,NAMCHA*4,NAMCHA2*4,
     +          NAMTYP*12,UNIT*12
      INTEGER   IENTRY(*),JENTRY(*),KENTRY(*)
      DOUBLE PRECISION DFLOTT
      REAL     FLOTT,TIME,WEIGHT,BASE
      INTEGER  IPRES,IPTAB,KCHAR(3),NITMA,NK,NCH,NZC,
     +         NENTRY,I1,INDIC,ISTATE(13),KTA,KB,IBEX,I,
     +         RDATA(6),IMOD,NX,NY,NZ,IW,IMIX,NREG,
     +         IXN,IYN,IZC,INS,IDIM(4),IW1,IW2,IZONE,IBZC,IPSI,
     +         IFLX,IBURN,INW,IHFAC,IZH,NGRP,NBURN,ICW1,ICW2,IDW,
     +         IIND,IPOWR,IPRT,IBX,IZCNTL,ITAB,MSHT,IPOOL,INAMT,
     +         IWK,IWKS,IBS,IPS,IVS,IIWK,INSS,IPOW,IBASE(1),
     +         NITZ,KRF,KSV,MAXS,NTYP,NS,ICDX,IDX,NSS,ILONG,ITYP,
     +         IALCH,IOLD
      LOGICAL  LSHF
      COMMON BASE(1)
      EQUIVALENCE (BASE(1),IBASE(1))
*
* PARAMETER VALIDATION.
*
      IF(NENTRY.LT.1) CALL XABORT('REFUEL: PARAMETER EXPECTED.')
      IF((IENTRY(1).NE.1).AND.(IENTRY(1).NE.2)) CALL XABORT('REFU'
     + //'EL: LINKED LIST OR XSM FILE EXPECTED AT LHS.')
      IF(JENTRY(1).NE.1) CALL XABORT('REFU'
     + //'EL: MODIFICATION MODE EXPECTED.')
*
*     VERIFICATION OF OBJECTS WITH SIGNATURE
*
      CALL LCMSIX(KENTRY(1),' ',0)
      CALL LCMGET(KENTRY(1),'SIGNATURE',KCHAR)
      WRITE(HSIGN,'(3A4)') (KCHAR(I1),I1=1,3)
      TEXT12=HENTRY(1)
      IF (HSIGN.NE.'L_MAP') CALL XABORT('REFUEL:'
     +  //'SIGNATURE OF '//TEXT12//' IS '//HSIGN//'. '
     +  //'L_MAP EXPECTED.')
      IPRES = KENTRY(1)
      CALL LCMGET(IPRES,'RES-DATA',RDATA)
      NK = RDATA(1)
      NCH = RDATA(2)
      NZC = RDATA(3)
      NGRP = RDATA(4)
      IMOD = RDATA(5)
* ADDED BY M.T.S 15/10/96
      MSHT= RDATA(6)+1
*
*     DATA INPUT READING
*
      NITZ = 4
      NTYP = 0
      IPRT = 1
      KRF = 0
      KSV = 0
      KTA = 0
      KB  = 0
      MAXS = 0
      WEIGHT = 0.0
      LSHF = .TRUE.
 10   CALL REDGET(INDIC,NITMA,FLOTT,TEXT12,DFLOTT)
      IF(INDIC.EQ.10) GOTO 30
      IF(INDIC.NE.3) CALL XABORT('REFUEL: CHARACTER DATA EXPECTED(1).')
 5    IF(TEXT12.EQ.'TAVGC') THEN
        IMOD = 3
        KTA = 1
 2      CALL REDGET(INDIC,NITMA,FLOTT,TEXT12,DFLOTT)
        IF(INDIC.NE.3)
     +   CALL XABORT('REFUEL: CHARACTER DATA EXPECTED(2).')
        IF(TEXT12.EQ.'NS') THEN
          CALL SETARA(IBASE,NZC,INS)
          DO 1 IZC=1,NZC
            CALL REDGET(INDIC,NITMA,FLOTT,TEXT12,DFLOTT)
            IF(INDIC.NE.1)
     +        CALL XABORT('REFUEL: INTEGER DATA EXPECTED(3).')
            IBASE(INS+IZC-1) = NITMA
 1        CONTINUE
        ELSEIF(TEXT12.EQ.'NITZ') THEN
          CALL REDGET(INDIC,NITMA,FLOTT,TEXT12,DFLOTT)
          IF(INDIC.NE.1)
     +     CALL XABORT('REFUEL: INTEGER DATA EXPECTED(3).')
          NITZ = NITMA
        ELSEIF(TEXT12.EQ.'NTYP') THEN
          CALL REDGET(INDIC,NITMA,FLOTT,TEXT12,DFLOTT)
          IF(INDIC.NE.1)
     +     CALL XABORT('REFUEL: INTEGER DATA EXPECTED(3).')
          NTYP = NITMA
        ELSEIF(TEXT12.EQ.'TYPE') THEN
          IF(NTYP.EQ.0) CALL XABORT('REFUEL: FUEL TYPE NUMBER MUST BE'
     +      //' PREVIOUSLY SET')
          CALL SETARA(IBASE,NTYP,ITYP)
          CALL SETARA(IBASE,3*NTYP,INAMT)
          DO 14 I=1,NTYP
            CALL REDGET(INDIC,NITMA,FLOTT,TEXT12,DFLOTT)
            IF(INDIC.NE.1)
     +       CALL XABORT('REFUEL: INTEGER DATA EXPECTED(3).')
            IBASE(ITYP+I-1) = NITMA
            CALL REDGET(INDIC,NITMA,FLOTT,TEXT12,DFLOTT)
            IF(INDIC.NE.3)
     +       CALL XABORT('REFUEL: CHARACTER DATA EXPECTED(3).')
            READ(TEXT12,'(3A4)') (IBASE(INAMT+(I-1)*3+I1-1),I1=1,3)
  14      CONTINUE
          GOTO 20
        ELSE
          GOTO  5
        ENDIF
        GOTO 2
      ELSEIF (TEXT12.EQ.'REFUEL') THEN
           KRF = 1
  3        CALL REDGET(INDIC,NITMA,FLOTT,TEXT12,DFLOTT)
           IF(INDIC.NE.3)
     +      CALL XABORT('REFUEL: CHARACTER DATA EXPECTED(2).')
           IF(TEXT12.EQ.'CHAN') THEN
             CALL REDGET(INDIC,NITMA,FLOTT,NAMCHA,DFLOTT)
             IF(INDIC.NE.3)
     +        CALL XABORT('REFUEL: CHARACTER DATA EXPECTED(2).')
             CALL REDGET(INDIC,NITMA,FLOTT,TEXT12,DFLOTT)
             IF(INDIC.NE.1)
     +         CALL XABORT('REFUEL: INTEGER DATA EXPECTED(3).')
             NS = NITMA
             GOTO 20
           ELSEIF(TEXT12.EQ.'SHF') THEN
               IF(IMOD.NE.4) CALL XABORT('INVALID FUEL MAP FOR'
     +              //' SHIFTING')
               LSHF = .TRUE.
           ELSEIF(TEXT12.EQ.'NOSHF') THEN
               LSHF = .FALSE.
           ELSE
            CALL XABORT('REFUEL: INVALID KEYWORD '//TEXT12)
           ENDIF
           GOTO 3
      ELSEIF (TEXT12.EQ.'NEWFUEL') THEN
           KRF = 3
  8        CALL REDGET(INDIC,NITMA,FLOTT,TEXT12,DFLOTT)
           IF(INDIC.NE.3)
     +      CALL XABORT('REFUEL: CHARACTER DATA EXPECTED(2).')
           IF(TEXT12.EQ.'CHAN') THEN
             CALL REDGET(INDIC,NITMA,FLOTT,NAMCHA,DFLOTT)
             IF(INDIC.NE.3)
     +        CALL XABORT('REFUEL: CHARACTER DATA EXPECTED(2).')
             CALL REDGET(INDIC,NITMA,FLOTT,TEXT12,DFLOTT)
             IF(INDIC.NE.1)
     +         CALL XABORT('REFUEL: INTEGER DATA EXPECTED(3).')
             NS = NITMA
             NSS=ABS(NS)
             CALL SETARA(IBASE,NSS,IDX)
             CALL REDGET(INDIC,NITMA,FLOTT,TEXT12,DFLOTT)
             IF(INDIC.NE.3)
     +        CALL XABORT('REFUEL: CHARACTER DATA EXPECTED(4).')
             IF(TEXT12.EQ.'SOME') THEN
               DO 11 I=1,NSS
                 CALL REDGET(INDIC,NITMA,FLOTT,TEXT12,DFLOTT)
                 IF(INDIC.NE.1)
     +             CALL XABORT('REFUEL: INTEGER DATA EXPECTED(3).')
                 IBASE(IDX+I-1) = NITMA
 11            CONTINUE
             ELSEIF(TEXT12.EQ.'ALL') THEN
               CALL REDGET(INDIC,NITMA,FLOTT,TEXT12,DFLOTT)
               IF(INDIC.NE.1)
     +             CALL XABORT('REFUEL: INTEGER DATA EXPECTED(3).')
               DO 12 I=1,NSS
                 IBASE(IDX+I-1) = NITMA
 12            CONTINUE
             ELSE
               CALL XABORT('REFUEL: INVALID KEYWORD '//TEXT12)
             ENDIF
             GOTO 20
           ELSEIF(TEXT12.EQ.'SHF') THEN
               IF(IMOD.NE.4) CALL XABORT('INVALID FUEL MAP FOR'
     +              //' SHIFTING')
               LSHF = .TRUE.
           ELSEIF(TEXT12.EQ.'NOSHF') THEN
               LSHF = .FALSE.
           ELSE
            CALL XABORT('REFUEL: INVALID KEYWORD '//TEXT12)
           ENDIF
           GOTO 8
      ELSEIF (TEXT12.EQ.'SHUFF') THEN
           IF(IMOD.NE.4) CALL XABORT('REFUEL: WRONG OPTION, '
     +       //'INSTANTANEOUS MODEL REQUIRED')
           KRF = 2
  7        CALL REDGET(INDIC,NITMA,FLOTT,TEXT12,DFLOTT)
           IF(INDIC.NE.3)
     +      CALL XABORT('REFUEL: CHARACTER DATA EXPECTED(2).')
           IF(TEXT12.EQ.'TO') THEN
             CALL REDGET(INDIC,NITMA,FLOTT,NAMCHA2,DFLOTT)
             IF(INDIC.NE.3)
     +        CALL XABORT('REFUEL: CHARACTER DATA EXPECTED(2).')
             IF(IPRT.GT.2)
     +         WRITE(6,*) ' REFUEL: ACTION ',NAMCHA,' TO ',NAMCHA2
             GOTO 20
           ELSEIF(TEXT12.EQ.'CHAN') THEN
             CALL REDGET(INDIC,NITMA,FLOTT,NAMCHA,DFLOTT)
             IF(INDIC.NE.3)
     +        CALL XABORT('REFUEL: CHARACTER DATA EXPECTED(2).')
           ELSE
            CALL XABORT('REFUEL: INVALID KEYWORD '//TEXT12)
           ENDIF
           GOTO 7
      ELSEIF (TEXT12.EQ.'FOLLOW') THEN
         KSV = 1
         CALL REDGET(INDIC,NITMA,FLOTT,TEXT12,DFLOTT)
         IF(INDIC.NE.3)
     +    CALL XABORT('REFUEL: CHARACTER DATA EXPECTED(2).')
         IF(TEXT12.EQ.'TIME') THEN
           CALL REDGET(INDIC,NITMA,FLOTT,TEXT12,DFLOTT)
           IF(INDIC.NE.2)
     +      CALL XABORT('REFUEL: REAL DATA EXPECTED(2).')
           TIME = FLOTT
           CALL REDGET(INDIC,NITMA,FLOTT,TEXT12,DFLOTT)
           IF(INDIC.NE.3)
     +      CALL XABORT('REFUEL: CHARACTER DATA EXPECTED(2).')
           UNIT=TEXT12
           CALL REDGET(INDIC,NITMA,FLOTT,TEXT12,DFLOTT)
           IF(INDIC.NE.3)
     +       CALL XABORT('REFUEL: CHARACTER DATA EXPECTED(2).')
           IF(TEXT12.NE.'WEIGHT')
     +        CALL XABORT('REFUEL: INVALID KEYWORD '//TEXT12)
           CALL REDGET(INDIC,NITMA,WEIGHT,TEXT12,DFLOTT)
           IF(INDIC.NE.2)
     +       CALL XABORT('REFUEL: REAL DATA EXPECTED(3).')
         ELSE
           CALL XABORT('REFUEL: INVALID KEYWORD '//TEXT12)
         ENDIF
         GOTO 20
      ELSE IF(TEXT12.EQ.'BEXIT') THEN
         KB = 1
         IF( IMOD.NE.4 .AND. IMOD.NE.5 )CALL XABORT('REFUEL: INVALID '
     +         //'FUEL MAP FOR EXIT BURNUP CALCULATION')
         GOTO 20
      ELSE IF(TEXT12.EQ.'CELL') THEN
         IF( IMOD.NE.3 )CALL XABORT('REFUEL: PREVIOUS BURNUPS MUST BE'
     +         //' FOR TIME-AVERAGE CORE')
         KTA = 2
         LSHF = .FALSE.
         CALL SETARA(IBASE,NCH,IALCH)
         DO 21 I=1,NCH
           CALL REDGET(INDIC,NITMA,FLOTT,TEXT12,DFLOTT)
           IF(INDIC.NE.1)
     +        CALL XABORT('REFUEL: INTEGER DATA EXPECTED(3).')
           IBASE(IALCH+I-1) = NITMA
 21      CONTINUE
         GOTO 20
      ELSE IF(TEXT12.EQ.'EDIT') THEN
          CALL REDGET(INDIC,IPRT,FLOTT,TEXT12,DFLOTT)
          IF(INDIC.NE.1)
     +     CALL XABORT('REFUEL: INTEGER DATA EXPECTED(3).')
      ELSE IF(TEXT12.EQ.';') THEN
         GOTO 30
      ELSE
         CALL XABORT('REFUEL: INVALID KEYWORD '//TEXT12)
      ENDIF
      GOTO 10
*
*     CALCULATION PART ACCORDING TO OPTION
*
 20   IF(KTA.EQ.1) THEN
*      TIME_AVERAGED CALCULATION
        IF(NENTRY.GE.2 .AND. IENTRY(2).LT.3) THEN
          CALL LCMSIX(KENTRY(2),' ',0)
          CALL LCMGET(KENTRY(2),'SIGNATURE',KCHAR)
          WRITE(HSIGN,'(3A4)') (KCHAR(I1),I1=1,3)
          TEXT12=HENTRY(2)
          IF (HSIGN.NE.'L_TABLE') CALL XABORT('REFUEL:'
     +   //'SIGNATURE OF '//TEXT12//' IS '//HSIGN//'. '
     +   //'L_TAB EXPECTED.')
          IPTAB = KENTRY(2)
        ELSE
           CALL XABORT('REFUEL: L_TAB EXPECTED.')
        ENDIF
        WRITE(NAMTYP,'(3A4)') (IBASE(INAMT+I1-1),I1=1,3)
        CALL LCMSIX(IPTAB,' ',0)
        CALL LCMSIX(IPTAB,NAMTYP,1)
        CALL LCMGET(IPTAB,'IDIM',IDIM)
        IF( NGRP.NE.IDIM(1) )CALL XABORT('REFUEL: DIFFERENT NUMBER OF'
     +    //' ENERGY GROUPS BETWEEN TABLE AND FUEL MAP')
        NBURN = IDIM(2)
        ITAB=IDIM(4)
        CALL LCMSIX(IPTAB,' ',0)
        CALL LCMSIX(IPRES,' ',0)
        CALL LCMSIX(IPRES,'GEO:RES',1)
        CALL LCMGET(IPRES,'STATE',ISTATE)
        IF(ISTATE(1).NE.7) CALL XABORT('REFUEL: 3-D CARTESIAN GEOMETRY'
     +    //' REQUIRED')
        NX = ISTATE(3)
        NY = ISTATE(4)
        NZ = ISTATE(5)
        CALL LCMSIX(IPRES,' ',0)
        CALL SETARA(IBASE,NX*NY*NZ,IMIX)
        CALL SETARA(BASE,NCH*NK,ICW1)
        CALL SETARA(BASE,NCH*NK,ICW2)
        CALL SETARA(BASE,NK,IDW)
        CALL SETARA(BASE,NK,IW1)
        CALL SETARA(BASE,NK,IW2)
        CALL SETARA(IBASE,NK,INW)
        CALL SETARA(IBASE,NCH,IZONE)
        CALL SETARA(IBASE,NCH*NK,IIND)
        CALL SETARA(BASE,NZC,IBZC)
        CALL SETARA(BASE,NCH*NK*NGRP,IFLX)
        CALL SETARA(BASE,NK,IPSI)
        CALL SETARA(BASE,NK*NGRP,IHFAC)
        CALL SETARA(BASE,NBURN*NGRP*2*NTYP,IZH)
        CALL SETARA(BASE,NBURN,IBURN)
        CALL SETARA(IBASE,NCH,INSS)
        CALL TAWCAL(IPRES,IPTAB,NCH,NK,NZC,NBURN,NGRP,IBASE(INS),
     +    NTYP,IBASE(INAMT),IBASE(ITYP),
     +    BASE(IW1),BASE(IW2),IBASE(IZONE),IBASE(INW),BASE(IBZC),
     +    BASE(IFLX),BASE(IPSI),BASE(IHFAC),BASE(IZH),BASE(IBURN),
     +    BASE(ICW1),BASE(ICW2),BASE(IDW),NITZ,IBASE(IIND),
     +    NX,NY,NZ,IBASE(IMIX),IPRT,IBASE(INSS),ITAB)
        CALL RLSARA(IBASE(INSS))
        CALL RLSARA(BASE(IDW))
        CALL RLSARA(IBASE(IMIX))
        CALL RLSARA(BASE(IW1))
        CALL RLSARA(BASE(IW2))
        CALL RLSARA(BASE(ICW1))
        CALL RLSARA(BASE(ICW2))
        CALL RLSARA(IBASE(INW))
        CALL RLSARA(IBASE(IZONE))
        CALL RLSARA(IBASE(IIND))
        CALL RLSARA(BASE(IBZC))
        CALL RLSARA(BASE(IFLX))
        CALL RLSARA(BASE(IPSI))
        CALL RLSARA(BASE(IHFAC))
        CALL RLSARA(BASE(IZH))
        CALL RLSARA(BASE(IBURN))
        CALL RLSARA(IBASE(INS))
        CALL RLSARA(IBASE(ITYP))
        CALL RLSARA(IBASE(INAMT))
        KTA = 0
      ELSEIF(KTA.EQ.2) THEN
        CALL SETARA(BASE,NCH*NK,ICW1)
        CALL SETARA(BASE,NCH*NK,ICW2)
        CALL SETARA(BASE,NK*NCH,IW1)
        CALL SETARA(BASE,NCH,IOLD)
        CALL CELLAG(IPRES,NCH,NK,IMOD,BASE(ICW1),BASE(ICW2),BASE(IOLD),
     +    BASE(IW1),IBASE(IALCH))
        CALL RLSARA(BASE(IW1))
        CALL RLSARA(BASE(ICW1))
        CALL RLSARA(BASE(ICW2))
        CALL RLSARA(BASE(IOLD))
        CALL RLSARA(IBASE(IALCH))
        IMOD = 4
        KTA = 0
      ELSEIF(KRF.GE.1) THEN
        CALL LCMSIX(IPRES,'GEO:RES',1)
        CALL LCMGET(IPRES,'STATE',ISTATE)
        NX = ISTATE(3)
        NY = ISTATE(4)
        NZ = ISTATE(5)
        NREG = ISTATE(6)
        CALL LCMSIX(IPRES,' ',0)
        CALL SETARA(IBASE,NCH,INSS)
        CALL LCMLEN(IPRES,'REFUEL-SCH',ILONG,ITYP)
        IF(ILONG.EQ.0) THEN
          DO 13 I=1,NCH
             IBASE(INSS+I-1) = 0
  13      CONTINUE
        ELSEIF(ILONG.NE.NCH) THEN
          CALL XABORT('REFUEL: REFUEL-SCH HAS NOT THE CORRECT LENGHT')
        ELSE
          CALL LCMGET(IPRES,'REFUEL-SCH',IBASE(INSS))
        ENDIF
        CALL SETARA(BASE,NCH*NK,IW)
        CALL SETARA(IBASE,NX,IXN)
        CALL SETARA(IBASE,NY,IYN)
        CALL SETARA(IBASE,NREG,IMIX)
        CALL SETARA(BASE,NCH*NK*MSHT,IBS)
        CALL SETARA(BASE,NCH*NK*MSHT,IPS)
        CALL SETARA(IBASE,NCH*NK*MSHT,IVS)
        IF(KRF.EQ.1.OR.KRF.EQ.3) THEN
          IF(KRF.EQ.1) CALL SETARA(IBASE,ABS(NS),IDX)
          CALL SETARA(BASE,NCH*NK,IPOW)
          CALL SETARA(IBASE,NCH*NK,ICDX)
          CALL SETARA(BASE,NK*2,IWK)
          CALL SETARA(BASE,NK*2*MSHT,IWKS)
          CALL SETARA(IBASE,NK*2,IIWK)
          CALL SETARA(IBASE,NK,INW)
          CALL SHIFTB(IPRES,NCH,NK,NX,NY,NREG,NAMCHA,NS,MSHT,BASE(IW),
     +              IBASE(IMIX),IBASE(IXN),
     +              IBASE(IYN),IBASE(INW),BASE(IWK),BASE(IBS),BASE(IPS),
     +              IBASE(IVS),BASE(IPOW),IBASE(IIWK),BASE(IWKS),MAXS,
     +              IBASE(INSS),IBASE(IDX),IBASE(ICDX),IPRT,IMOD,
     +              KRF)
          CALL RLSARA(IBASE(IIWK))
          CALL RLSARA(BASE(IWKS))
          CALL RLSARA(BASE(IWK))
          CALL RLSARA(IBASE(INW))
          CALL RLSARA(IBASE(ICDX))
          CALL RLSARA(BASE(IPOW))
          CALL RLSARA(IBASE(IDX))
        ELSEIF(KRF.EQ.2) THEN
          CALL SETARA(BASE,NCH*NK,IPOOL)
          CALL SHUFFL(IPRES,NCH,NK,NX,NY,NREG,MSHT,NAMCHA,NAMCHA2,
     +         BASE(IW),IBASE(IMIX),BASE(IBS),BASE(IPS),
     +         IBASE(IVS),IBASE(IXN),IBASE(IYN),BASE(IPOOL),IPRT)
          CALL RLSARA(BASE(IPOOL))
        ENDIF
        CALL RLSARA(IBASE(IVS))
        CALL RLSARA(BASE(IPS))
        CALL RLSARA(BASE(IBS))
        CALL RLSARA(IBASE(IMIX))
        CALL RLSARA(IBASE(IXN))
        CALL RLSARA(IBASE(IYN))
        CALL RLSARA(BASE(IW))
        CALL RLSARA(IBASE(INSS))
        KRF = 0
      ELSEIF(KSV.EQ.1) THEN
        IF(WEIGHT.EQ.0.0) THEN
          CALL XABORT('REFUEL: URANIUM WEIGHT MUST BE SPECIFIED IN KG')
        ENDIF
        IF(UNIT.EQ.'HOUR') THEN
          TIME = TIME/24.
        ELSE IF(UNIT.EQ.'SEC') THEN
          TIME=TIME/(24.*3600.)
        ELSE IF(UNIT.EQ.'YEAR') THEN
          TIME = TIME*365.
        ELSE
          IF (UNIT.NE.'DAY') CALL XABORT(' REFUEL: WRONG TIME UNIT')
        ENDIF
        CALL SETARA(BASE,NCH*NK,IW)
        CALL SETARA(BASE,NCH*NK,IPOWR)
        CALL FOLCAL(IPRES,NCH,NK,TIME,BASE(IPOWR),BASE(IW),WEIGHT,IMOD)
        CALL RLSARA(BASE(IW))
        CALL RLSARA(BASE(IPOWR))
        KSV = 0
      ELSEIF(KB.EQ.1) THEN
        CALL SETARA(IBASE,NCH,INSS)
        CALL SETARA(IBASE,NK,INS)
        CALL SETARA(BASE,NCH*NK,IBURN)
        CALL SETARA(BASE,NCH,IBEX)
        CALL RFBEXI(IPRES,NCH,NK,BASE(IBEX),BASE(IBURN),IBASE(INSS),
     +          IBASE(INS))
        CALL LCMSIX(IPRES,' ',0)
        CALL LCMSIX(IPRES,'GEO:RES',1)
        CALL LCMGET(IPRES,'STATE',ISTATE)
        CALL LCMSIX(IPRES,' ',0)
        IF(ISTATE(1).NE.7) CALL XABORT('REFUEL: 3-D CARTESIAN GEOMETRY'
     +    //' REQUIRED')
        NX = ISTATE(3)
        NY = ISTATE(4)
        NZ = ISTATE(5)
        CALL SETARA(IBASE,NX*NY*NZ,IMIX)
        CALL SETARA(IBASE,NX,IXN)
        CALL SETARA(IBASE,NY,IYN)
        CALL SETARA(IBASE,NCH,IZCNTL)
        CALL SETARA(IBASE,NCH,IBX)
        CALL BEXSEL(IPRES,NCH,NX,NY,NX*NY*NZ,IBASE(IMIX),
     +              IBASE(IXN),IBASE(IYN),BASE(IBEX),
     +              IBASE(IBX),IBASE(IZCNTL))
        CALL RLSARA(IBASE(IBX))
        CALL RLSARA(IBASE(IZCNTL))
        CALL RLSARA(IBASE(IXN))
        CALL RLSARA(IBASE(IYN))
        CALL RLSARA(IBASE(IMIX))
        CALL RLSARA(BASE(IBEX))
        CALL RLSARA(BASE(IBURN))
        CALL RLSARA(IBASE(INS))
        CALL RLSARA(IBASE(INSS))
      ELSE
        WRITE(6,*) 'NOTHING HAS BEEN COMPUTED, IMOD ',IMOD
      ENDIF
      GOTO 10
*
 30   RDATA(5) = IMOD
C     SET THE TOTAL NUMBER OF BUNDLE SHIFTS
      IF(IMOD.NE.4) MAXS=0
      IF(.NOT.LSHF) MAXS=0
      RDATA(6)=MAXS
      CALL LCMPUT(IPRES,'RES-DATA',6,1,RDATA)
      RETURN
      END
