*DECK SHIFTB
      SUBROUTINE SHIFTB(IPRES,NCH,NK,NX,NY,NREG,NAMCHA,NS,MS,WINT,
     +              MIX,IXN,IYN,NW,WORK,BS,PS,ISFT,POW,IWORK,
     +              WORKS,MAXS,NSS,IND,INDEX,IPRT,IMOD,KRF)
*
*-----------------------------------------------------------------------
*
*  REFUEL A CHANNEL ACCORDING TO A REFUELING MODE
*
*  CALCULE LE NOUVEL ENSEMBLE DE BURNUP PAR GRAPPE SELON LE RECHARGEMENT
*
* INPUT PARAMETERS:
*  IPRES  : ADDRESS OF THE MAP LINKED LIST OR XSM FILE.
*  NCH    : NUMBER OF CHANNELS
*  NK     : NUMBER OF BUNDLES PER CHANNEL
*  NX     : NUMBER OF X MESHES
*  NY     : NUMBER OF Y MESHES
*  NREG   : NUMBER OF REGIONS IN FUEL MAP GEOMETRY
*  NAMCHA : NAME OF THE CHANNEL TO REFUEL
*  NS     : NUMBER OF BUNDLES INSERTED
*  MS     : OLD MAXIMUM OF SHIFT + 1.
*  MIX    : FUEL MAP BUNDLE INDEX. DIMENSION NREG
*  INDEX  : FUEL TYPE INDICE. DIMENSION NCH,NK
*  IND    : FUEL TYPE INDICE IN THE CHANNEL TO REFUEL. DIMENSION NS
*  IMOD   : BURNUP INTEGRATION TYPE.
*
* OUTPUT PARAMETERS:
*  IPRES  : ADDRESS OF THE MAP LINKED LIST OR XSM FILE.
*  MAXS   : MAXIMUM NUMBER OF POWER SHIFT
*
* SCRATCH STORAGE:
*  WORK   : DIMENSION WORK(NK,2)
*  WINT   : DIMENSION WINT(NCH*NK)
*  POW    : DIMENSION POW(NCH*NK)
*  ISFT   : DIMENSION ISFT(NCH*NK)
*  BS     : DIMENSION BS(NCH*NK*MS)
*  PS     : DIMENSION PS(NCH*NK*MS)
*  IWORK  : DIMENSION WORK(NK)
*  WORKS  : DIMENSION WORK(NK,MS,2)
*
* MODIFIED BY M.T. SISSAOUI 10/10/96
*
*-------------------------------------- AUTHOR: E. VARIN 14/09/95 ---
*
      INTEGER    IPRES
      INTEGER    NCH,NK,NX,NY,NS,NREG,ILONG,ITYP,IX,IY,IPRT,IMOD,
     1           MS,IS,MAXS,KS,NSS(NCH),NNS
      REAL       WINT(NCH,NK),WORK(NK,2),BS(NCH,NK,MS),
     1           PS(NCH,NK,MS),POW(NCH,NK),WORKS(NK,MS,2)
      CHARACTER  XNAM*4,YNAM*4,NAMCHA*4,TEXT4*4,CS*2
      INTEGER    MIX(NREG),IXN(NX),IYN(NY),NW(NK),ISFT(NCH,NK),
     1           IWORK(NK,2),INDEX(NCH,NK),IND(*)
      DIMENSION  IBASE(1)
      COMMON     BASE(1)
      EQUIVALENCE(BASE(1),IBASE(1))
*
C LOCAL
      INTEGER I,J
*
      DO 1 I=1,NK
       DO 1 J=1,NCH
         WINT(J,I) = 0.0
         POW(J,I) = 0.0
         DO 2 K=1,MS
           BS(J,I,K)=0.0
           PS(J,I,K)=0.0
  2      CONTINUE
  1   CONTINUE
* RECOVER FUEL BURNUPS
      CALL LCMLEN(IPRES,'BURN-DEB',ILONG,ITYP)
      IF(ILONG.EQ.0) THEN
         CALL XABORT('SHIFTB: INITIAL BURNUP REQUIRED')
      ENDIF
      IF( IMOD.GT.3 .OR. IMOD.LT.2 )THEN
         CALL LCMGET(IPRES,'BURN-DEB',WINT)
      ELSE
         CALL LCMGET(IPRES,'BURN-END',WINT)
      ENDIF
* RECOVER FUEL POWERS
      CALL LCMLEN(IPRES,'POWER-BUN',ILONG,ITYP)
      IF(ILONG.NE.0) THEN
         CALL LCMGET(IPRES,'POWER-BUN',POW)
      ELSE
        CALL XABORT('SHIFTB: POWER-BUN ARE REQUIRED')
      ENDIF
* RECOVER FUEL INDEX
      CALL LCMLEN(IPRES,'INDEX',ILONG,ITYP)
      IF(ILONG.NE.0) THEN
         CALL LCMGET(IPRES,'INDEX',INDEX)
      ELSE
        CALL XABORT('SHIFTB: INDEX ARE REQUIRED')
      ENDIF
*
* RECOVER SHIFT VECTOR
      CALL LCMLEN(IPRES,'ISHIFT',ILS,ITYLCM)
      IF(ILS.NE.0) THEN
        CALL LCMGET(IPRES,'ISHIFT',ISFT(1,1))
        DO 17 I=1,NK
         DO 17 J=1,NCH
            MAXS=MAX(MAXS,ISFT(J,I))
 17     CONTINUE
      ELSE
        MAXS=0
        DO 15 I=1,NK
          DO 15 J=1,NCH
            ISFT(J,I) = 0
 15     CONTINUE
      ENDIF
*
      IF(MAXS.GT.0) THEN
        DO 16 IS=1,MAXS
          WRITE (CS,'(I2)') IS
          CALL LCMGET(IPRES,'BSHIFT'//CS,BS(1,1,IS))
          CALL LCMGET(IPRES,'PSHIFT'//CS,PS(1,1,IS))
 16     CONTINUE
      ENDIF
*
      CALL LCMSIX(IPRES,'GEO:RES',1)
      CALL LCMGET(IPRES,'MIX',MIX)
      CALL LCMSIX(IPRES,' ',0)
      CALL LCMGET(IPRES,'XNAME',IXN)
      CALL LCMGET(IPRES,'YNAME',IYN)
*
*     SEARCH FOR THE CHANNEL NUMBER FROM ITS NAME
*
      TEXT4 = NAMCHA(2:3)
      IX = 1
      IY = 1
      DO 10 I=1,NX
        WRITE(XNAM,'(A4)') IXN(I)
        IF (XNAM.EQ.TEXT4) THEN
           IX = I
           GOTO 11
        ENDIF
  10  CONTINUE
  11  TEXT4 = NAMCHA(1:1)
      DO 20 I=1,NY
        WRITE(YNAM,'(A4)') IYN(I)
        IF (YNAM.EQ.TEXT4) THEN
           IY = I
           GOTO 21
        ENDIF
  20  CONTINUE
*
  21  I = (IY-1)*NX + IX
      ICH = MIX(I)
      IF(ICH.EQ.0) CALL XABORT('SHIFTB: WRONG CHANNEL NAME')
      IF(NSS(ICH).NE.0) THEN
        IF(ABS(NSS(ICH)).NE.ABS(NS))
     +       CALL XABORT('SHIFTB: WRONG REFUELING SCHEME')
        NS = NSS(ICH)
      ENDIF
      IF( IPRT.GT.3 )THEN
        WRITE(6,*) ' REFUELING CHANNEL ',NAMCHA,' IX IY ',IX,IY
        WRITE(6,*) ' REFUELING CHANNEL ',ICH,' SCHEME ',NS
        WRITE(6,*) ' INITIAL BURNUP ',(WINT(ICH,I),I=1,NK)
      ENDIF
*
      NNS = ABS(NS)
      CALL FLSCHM(NNS,NW,0,NK,ICH)
*
      II=0
      DO 30 K=1,NK
         KK = K
         IF (NS.LT.0) THEN
            KK = NK - K + 1
         ENDIF
         KA = NW(K)
*
*------- INSERTION OF A NEW BUNDLE OR REPOSITIONNING
*
         IF (KA.EQ.0) THEN
            II=II+1
            WORK(KK,1) = 0.0
            IWORK(KK,1)=0
            IF( KRF.EQ.1 )THEN
              IWORK(KK,2)=INDEX(ICH,KK)
            ELSE
              IWORK(KK,2)=IND(II)
            ENDIF
            IF(MAXS.GT.0) THEN
              DO 39 IS=1,MAXS
                WORKS(KK,IS,1) = 0.0
                WORKS(KK,IS,2) = 0.0
  39          CONTINUE
            ENDIF
         ELSE
            IF (NS.LT.0) THEN
               KA = NK - KA + 1
            ENDIF
            WORK(KK,1) = WINT(ICH,KA)
            WORK(KK,2) = POW(ICH,KA)
            IWORK(KK,1)= ISFT(ICH,KA)
            IWORK(KK,2)= INDEX(ICH,KA)
            IF(MAXS.GT.0) THEN
              DO 19 IS=1,MAXS
                WORKS(KK,IS,1) = BS(ICH,KA,IS)
                WORKS(KK,IS,2) = PS(ICH,KA,IS)
  19          CONTINUE
            ENDIF
         ENDIF
  30  CONTINUE
*
      DO 40 K=1,NK
        WINT(ICH,K) = WORK(K,1)
        ISFT(ICH,K) = IWORK(K,1)
        INDEX(ICH,K) = IWORK(K,2)
        IF(MAXS.GT.0) THEN
          DO 22 IS=1,MAXS
            BS(ICH,K,IS)=WORKS(K,IS,1)
            PS(ICH,K,IS)=WORKS(K,IS,2)
  22      CONTINUE
        ENDIF
        IF(WORK(K,1).NE.0.0) THEN
          KS=ISFT(ICH,K)+1
          BS(ICH,K,KS)=WINT(ICH,K)
          PS(ICH,K,KS)=WORK(K,2)
          ISFT(ICH,K)=KS
        ENDIF
  40  CONTINUE
*
      MAXS=0
      DO 12 I=1,NK
        DO 12 J=1,NCH
          MAXS=MAX(MAXS,ISFT(J,I))
  12  CONTINUE
*
      IF( IPRT.GT.3 )THEN
        WRITE(6,*) ' SHIFTING BURNUP ',(WINT(ICH,I),I=1,NK)
      ENDIF
*
      CALL LCMSIX(IPRES,' ',0)
      IF(IPRT.GT.3) WRITE(6,*) 'TIME INTEGRATION TYPE ',IMOD
      IF( IMOD.GT.3 .OR. IMOD.LT.2 )THEN
        IF(IPRT.GT.3) WRITE(6,*) ' REFUELLING TYPE DIRECT OR HOMOGENOUS'
        CALL LCMPUT(IPRES,'BURN-DEB',NCH*NK,2,WINT(1,1))
      ELSE
        IF(IPRT.GT.3) WRITE(6,*) ' REFUELLING FINAL BURNUP FOR TAV'
        CALL LCMPUT(IPRES,'BURN-END',NCH*NK,2,WINT(1,1))
      ENDIF
      CALL LCMPUT(IPRES,'INDEX',NCH*NK,1,INDEX(1,1))
* THE FOLLOWING INFORMATION WILL BE USED TO TAKE INTO ACCOUNT
* THE HISTORY OF THE REACTOR
      CALL LCMPUT(IPRES,'ISHIFT',NCH*NK,1,ISFT(1,1))
*
      IF(MAXS.GT.0) THEN
        DO 13 IS=1,MAXS
          WRITE (CS,'(I2)') IS
          CALL LCMPUT(IPRES,'BSHIFT'//CS,NCH*NK,2,BS(1,1,IS))
          CALL LCMPUT(IPRES,'PSHIFT'//CS,NCH*NK,2,PS(1,1,IS))
 13     CONTINUE
      ENDIF
*
      RETURN
      END
