*DECK SHUFFL
      SUBROUTINE SHUFFL(IPRES,NCH,NK,NX,NY,NREG,MS,NAMCHA,NAMCHA2,
     +              WINT,MIX,BS,PS,ISFT,IXN,IYN,POOL,IPRT)
*
*-----------------------------------------------------------------------
*
*  COMPUTE NEW BURNUP VALUES PER CHANNEL AFTER SHUFFLING OF TWO
*
*  CALCULE LE NOUVEL ENSEMBLE DE BURNUP PAR GRAPPE SELON LE SHUFFLING
*
* INPUT PARAMETERS:
*  IPRES  : ADDRESS OF THE MAP LINKED LIST OR XSM FILE.
*  NAMCHA : NAME OF THE CHANNEL TO REFUEL
*  NAMCHA2: NAME OF THE CHANNEL TO REFUEL
*  NS     : NUMBER OF BUNDLES INSERTED
*  MIX    : FUEL MAP BUNDLE INDEX. DIMENSION MIX(NX*NY,*)
*  MS     : MAXIMUM NUMBER OF POWER SHIFT
*
* OUTPUT PARAMETERS:
*  IPRES  : ADDRESS OF THE MAP LINKED LIST OR XSM FILE.
*
*
*
*-------------------------------------- AUTHOR: E. VARIN 11/11/96 ---
*
      IMPLICIT NONE
      INTEGER    IPRES
      INTEGER    NCH,NK,NX,NY,NREG,ILONG,ITYP,IX,IY,IPRT,
     1           ICH1,ICH2,ILS,ITYLCM,IS,MAXS,MS
      REAL       WINT(NCH,NK),POOL(NCH,NK),BS(NCH,NK,MS),
     1           PS(NCH,NK,MS),BASE
      CHARACTER  XNAM*4,YNAM*4,NAMCHA*4,NAMCHA2*4,TEXT4*4,CS*2
      INTEGER    MIX(NREG),IXN(NX),IYN(NY),ISFT(NCH,NK)
      INTEGER    IBASE(1)
      COMMON     BASE(1)
      EQUIVALENCE(BASE(1),IBASE(1))
*
C LOCAL
      INTEGER I,J
*
*     RECOVER INFORMATIONS FROM FUEL MAP OBJECT
*
      DO 1 I=1,NK
       DO 1 J=1,NCH
         WINT(J,I) = 0.0
         ISFT(J,I) = 0
         DO 2 IS=1,MS
           BS(J,I,IS)=0.0
           PS(J,I,IS)=0.0
  2      CONTINUE
  1   CONTINUE
* RECOVER FUEL BURNUPS
      CALL LCMLEN(IPRES,'BURN-DEB',ILONG,ITYP)
      IF(ILONG.EQ.0) THEN
         CALL XABORT('SHUFFL: INITIAL BURNUP REQUIRED')
      ENDIF
      CALL LCMGET(IPRES,'BURN-DEB',WINT(1,1))
* RECOVER SHIFT VECTOR
      MAXS=0
      CALL LCMLEN(IPRES,'ISHIFT',ILS,ITYLCM)
      IF(ILS.NE.0) THEN
        CALL LCMGET(IPRES,'ISHIFT',ISFT(1,1))
        DO 17 I=1,NK
         DO 17 J=1,NCH
            MAXS=MAX(MAXS,ISFT(J,I))
 17     CONTINUE
      ELSE
        MAXS=0
      ENDIF
*
      IF(MAXS.GT.0) THEN
        DO 16 IS=1,MAXS
          WRITE (CS,'(I2)') IS
          CALL LCMGET(IPRES,'BSHIFT'//CS,BS(1,1,IS))
          CALL LCMGET(IPRES,'PSHIFT'//CS,PS(1,1,IS))
 16     CONTINUE
      ENDIF
*
      CALL LCMSIX(IPRES,'GEO:RES',1)
      CALL LCMGET(IPRES,'MIX',MIX)
      CALL LCMSIX(IPRES,' ',0)
      CALL LCMGET(IPRES,'XNAME',IXN)
      CALL LCMGET(IPRES,'YNAME',IYN)
*
*     SEARCH FOR CHANNEL NUMBER TO MOVE
*
      TEXT4 = NAMCHA(2:3)
      IX = 1
      IY = 1
      DO 10 I=1,NX
        WRITE(XNAM,'(A4)') IXN(I)
        IF (XNAM.EQ.TEXT4) THEN
           IX = I
           GOTO 11
        ENDIF
  10  CONTINUE
  11  TEXT4 = NAMCHA(1:1)
      DO 20 I=1,NY
        WRITE(YNAM,'(A4)') IYN(I)
        IF (YNAM.EQ.TEXT4) THEN
           IY = I
           GOTO 21
        ENDIF
  20  CONTINUE
*
  21  I = (IY-1)*NX + IX
      ICH1 = MIX(I)
      IF(ICH1.EQ.0) CALL XABORT('SHUFFL: WRONG CHANNEL NAME')
      IF(IPRT.GT.3) THEN
        WRITE(6,*)
        WRITE(6,*) ' SHUFFLING CHANNEL ',NAMCHA,ICH1
        WRITE(6,*) ' BEFORE ',NAMCHA,(WINT(ICH1,I),I=1,NK)
      ENDIF
*
*     SEARCH FOR CHANNEL NUMBER WHERE TO MOVE
*
      IF(NAMCHA2.NE.'POOL') THEN
        TEXT4 = NAMCHA2(2:3)
        IX = 1
        IY = 1
        DO 30 I=1,NX
          WRITE(XNAM,'(A4)') IXN(I)
          IF (XNAM.EQ.TEXT4) THEN
             IX = I
             GOTO 31
          ENDIF
  30    CONTINUE
  31    TEXT4 = NAMCHA2(1:1)
        DO 40 I=1,NY
          WRITE(YNAM,'(A4)') IYN(I)
          IF (YNAM.EQ.TEXT4) THEN
             IY = I
             GOTO 41
          ENDIF
  40    CONTINUE
*
  41    I = (IY-1)*NX + IX
        ICH2 = MIX(I)
        IF(ICH2.EQ.0) CALL XABORT('SHUFFL: WRONG CHANNEL NAME')
        IF(IPRT.GT.3) THEN
          WRITE(6,*)
          WRITE(6,*) ' SHUFFLING CHANNEL ',NAMCHA2,ICH2
          WRITE(6,*) ' BEFORE ',NAMCHA2,(WINT(ICH2,I),I=1,NK)
        ENDIF
*
*       SHUFFLING
*
        DO 50 I=1,NK
          IF(WINT(ICH2,I).NE.0.0) THEN
             WRITE(6,*) ' BURNUP ',WINT(ICH2,I)
             CALL XABORT('SHUFFL: WRONG POSITION TO SHUFFLE, '
     +          //'CHANNEL NOT EMPTY')
          ENDIF
          WINT(ICH2,I) = WINT(ICH1,I)
          WINT(ICH1,I) = 0.0
          ISFT(ICH2,I) = ISFT(ICH1,I)
          ISFT(ICH1,I) = 0
          IF(MAXS.GT.0) THEN
             DO 56 IS=1,MAXS
               BS(ICH2,I,IS) = BS(ICH1,I,IS)
               PS(ICH2,I,IS) = PS(ICH1,I,IS)
               BS(ICH1,I,IS) = 0.0
               PS(ICH1,I,IS) = 0.0
  56         CONTINUE
          ENDIF
  50    CONTINUE
        IF(IPRT.GT.3) THEN
          WRITE(6,*)
          WRITE(6,*) ' AFTER ',NAMCHA2,(WINT(ICH2,I),I=1,NK)
        ENDIF
      ELSE
        WRITE(6,*) ' CHANNEL TO POOL '
* RECOVER DISCHARGED FUEL BURNUPS
        CALL LCMLEN(IPRES,'BURN-POOL',ILONG,ITYP)
        IF(ILONG.NE.0) THEN
           CALL LCMGET(IPRES,'BURN-POOL',POOL(1,1))
        ENDIF
        DO 51 I=1,NK
          POOL(ICH1,I) = WINT(ICH1,I)
          WINT(ICH1,I) = 0.0
  51    CONTINUE
        CALL LCMPUT(IPRES,'BURN-POOL',NCH*NK,2,POOL(1,1))
      ENDIF
      IF(IPRT.GT.3)
     +    WRITE(6,*) ' AFTER ',NAMCHA,(WINT(ICH1,I),I=1,NK)
*
      CALL LCMSIX(IPRES,' ',0)
      CALL LCMPUT(IPRES,'BURN-DEB',NCH*NK,2,WINT(1,1))
      CALL LCMPUT(IPRES,'ISHIFT',NCH*NK,1,ISFT(1,1))
      IF(MAXS.GT.0) THEN
        DO 53 IS=1,MAXS
          WRITE (CS,'(I2)') IS
          CALL LCMPUT(IPRES,'BSHIFT'//CS,NCH*NK,2,BS(1,1,IS))
          CALL LCMPUT(IPRES,'PSHIFT'//CS,NCH*NK,2,PS(1,1,IS))
 53     CONTINUE
      ENDIF
*
      RETURN
      END
