*DECK SMVAND
      SUBROUTINE SMVAND (DT,RESPON,RESPL)
*
*-----------------------------------------------------------------------
*
*     THIS SUBROUTINE ALLOWS VANADIUM RESPONSE CALCULATIONS
*
*
*     INPUT:
*              DT     : REAL
*                       SIMULATION TIME STEP
*              RESPON : REAL
*                       FLUX AT DETECTOR SITE
*              RESPL  : REAL
*                       OLD DETECTOR RESPONSE
*     OUTPUT:
*              RESPON : REAL
*                       DETECTOR RESONSE
*
*
*     SUBROUTINE FROM SMOKIN-G2,
*        INCORPORATED IN DONJON BY E. VARIN  94/10/10
*
*
*-------------------------------------- AUTHOR: S.ALAOUI --
*
*
      REAL  RESPON,XMULT,VLAMDA,DT,RESPL
*
*     VANADIUM DETECTOR REPONSE
*
      VLAMDA = 1. / 225.
      XMULT = 1.0 + VLAMDA * DT
      XMULT = 1.0 / XMULT
*
      RESPON = XMULT * ( RESPL + DT * VLAMDA * RESPON )
*
      RETURN
      END
