*DECK SRFILT
      SUBROUTINE SRFILT(Y,X,XL,TC,DT,N)
*
*-----------------------------------------------------------------------
*
*     THIS ROUTINE FILTERS THE N VALUES OF X VECTOR FOR TC SECONDS.
*     FORMULATIONS ARE TAKEN FROM THE EXPRESSION OF THE DIFFERENTIAL
*     EQUATION OF A FILTER WITH A LINEAR VARIATION OF X IN DT TIME
*     STEP
*
*     CETTE ROUTINE FILTRE LES N VALEURS DE X
*     PENDANT TC SECONDES
*     FORMULES ETABLIES A PARTIR DE L'EQUATION DIFFERENTIELLE
*     DU FILTRE ET LA VARIATION LINEAIRE DE X DANS L'INTERALLE DT
*
*     INPUT  :
*              Y : REAL
*                  VARIABLES Y(I) AT PREVIOUS TIME
*              X : REAL
*                  VARIABLES TO FILTERED
*             XL : REAL
*                  VARIABLES X(I) AT PREVIOUS TIME
*             TC : REAL
*                  FILTER TIME CONSTANT
*             DT : REAL
*                  TIME STEP BETWEEN TWO CALCULATIONS
*              N : INTEGER
*                  DIMENSION OF THE VECTORS X, XL, Y
*     OUTPUT :
*              Y : REAL
*                  FILTERED VARIABLES Y(I)
*
*     ROUTINE FROM SMOKIN-G2, INCORPORATED IN DONJON
*
*-------------------------------------- AUTHOR: SAID ALAOUI   12/04/85 -
*
      IMPLICIT NONE
      INTEGER  N,I
      REAL     Y(N),X(N),XL(N),TC,DT,AA,A,B,C
*
*     COMPUTE PONDERATION FACTORS FOR Y,X ET XL
*
      AA =  - DT / TC
      A  = EXP ( AA )
      B  = 1. - A
      C  = 1. - B * TC/DT
*
*     COMPUTE NEW Y
*
      DO 10 I=1,N
*
        Y(I)  = A * Y(I) + ( B - C ) * XL(I) + C * X(I)
        XL(I) = X(I)
*
 10   CONTINUE
      RETURN
      END
