*DECK SUBMAC
      SUBROUTINE SUBMAC(IPLIST,IPLISP,IPLISD,LEVEL,NMIXT,NGRP,NDG,NL,
     1 TOTAL,ZNUG,ZSIGF,CHI,CHDL,OVERV,DIFFX,DIFFY,DIFFZ,H,S,IJJ,NJJ,
     2 SCAT,WORK,IPOS,IJJP,NJJP,IPRT,DDIF)
*
*-----------------------------------------------------------------------
*
* READ, SUBSTRACT CROSS SECTIONS AND STORE THEM IN A LINKED LIST.
*
* INPUT PARAMETERS:
*  IPLIST : ADDRESS OF THE LINKED LIST OR HANDLE TO THE XSM FILE.
*  IPLISP : ADDRESS OF THE LINKED LIST OR HANDLE TO THE XSM FILE.
*  NMIXT  : MAXIMUM NUMBER OF MATERIAL MIXTURES.
*  NGRP   : NUMBER OF ENERGY GROUPS.
*  NL     : NUMBER OF LEGENDRE ORDERS (=1 FOR ISOTROPIC SCATTERING).
*  NDG    : NUMBER OF DELAYED NEUTRON SPECTRUM.
*
*
* SCRATCH STORAGE:
*  TOTAL  : DIMENSION TOTAL(NMIXT,NGRP)
*  ZNUG   : DIMENSION ZNUG(NMIXT,NGRP)
*  ZSIGF  : DIMENSION ZSIGF(NMIXT,NGRP)
*  CHI    : DIMENSION CHI(NMIXT,NGRP)
*  CHDL   : DIMENSION CHDL(NMIXT,NDG,NGRP)
*  OVERV  : DIMENSION OVERV(NMIXT,NGRP)
*  DIFFX  : DIMENSION DIFFX(NMIXT,NGRP)
*  DIFFY  : DIMENSION DIFFY(NMIXT,NGRP)
*  DIFFZ  : DIMENSION DIFFZ(NMIXT,NGRP)
*  H      : DIMENSION H(NMIXT,NGRP)
*  S      : DIMENSION S(NMIXT,NGRP)
*  IJJ    : DIMENSION IJJ(NMIXT,NL,NGRP)
*  NJJ    : DIMENSION NJJ(NMIXT,NL,NGRP)
*  SCAT   : SCAT(NMIXT,NL,NGRP,NGRP)
*  WORK   : WORK(NMIXT*NGRP)
*  IPOS   : IPOS(NMIXT)
*
* NOTE: ANY CROSS SECTION NOT READ IS SET TO ZERO.
*
*------------------------------ AUTHOR: M.T. SISSAOUI ; 10/03/95 ---
*                               MODIFIED  E. VARIN ; 27/04/95 ---
*
      LOGICAL LTO,LNFI,LFI,LCH,LOV,LDX,LDY,LDZ,LHF,LSC,LSO,LBI,DDIF
      CHARACTER CGRPNM*12,CM*2,TEXT*8,LEVEL*12
      DIMENSION TOTAL(NMIXT,*),ZNUG(NMIXT,*),ZSIGF(NMIXT,*),
     1 CHI(NMIXT,*),OVERV(NMIXT,*),DIFFX(NMIXT,*),DIFFY(NMIXT,*),
     2 DIFFZ(NMIXT,*),IJJ(NMIXT,NL,*),NJJ(NMIXT,NL,*),
     3 SCAT(NMIXT,NL,NGRP,*),H(NMIXT,*),S(NMIXT,*),WORK(*),IPOS(*),
     4 CHDL(NMIXT,NDG,*),IJJP(NMIXT,NL,*),NJJP(NMIXT,NL,*)
      COMMON BASE(1)
*
      IF(NMIXT.EQ.0) CALL XABORT('MACXSI: ZERO NUMBER OF MIXTURES.')
      IF(NGRP.EQ.0) CALL XABORT('MACXSI: ZERO NUMBER OF GROUPS.')
*
      LTO=.FALSE.
      LFI=.FALSE.
      LNFI=.FALSE.
      LCH=.FALSE.
      LOV=.FALSE.
      LDX=.FALSE.
      LDY=.FALSE.
      LDZ=.FALSE.
      LHF=.FALSE.
      LSC=.FALSE.
      LSO=.FALSE.
      LBI=.FALSE.
*
      DO 10 IGR=1,NGRP
      DO 10 IBM=1,NMIXT
      TOTAL(IBM,IGR)=0.0
      ZNUG(IBM,IGR)=0.0
      ZSIGF(IBM,IGR)=0.0
      DIFFX(IBM,IGR)=0.0
      DIFFY(IBM,IGR)=0.0
      DIFFZ(IBM,IGR)=0.0
      H(IBM,IGR)=0.0
      S(IBM,IGR)=0.0
      DO 10 IL=1,NL
      IJJ(IBM,IL,IGR)=IGR
      NJJ(IBM,IL,IGR)=1
      DO 10 JGR=1,NGRP
   10 SCAT(IBM,IL,JGR,IGR)=0.0
*
*        RECOVER THE PERTURBED DATA
         DO 40 JGR=1,NGRP
         WRITE (CGRPNM,'(5HGROUP,I3,1H/,I3)') JGR,NGRP
         CALL LCMSIX(IPLIST,CGRPNM,1)
         CALL LCMLEN(IPLIST,'TOTAL',ILENGT,ITYLCM)
         IF(ILENGT.EQ.NMIXT) THEN
            CALL LCMGET(IPLIST,'TOTAL',TOTAL(1,JGR))
         ELSE IF(ILENGT.NE.0) THEN
            CALL XABORT('MACXSI: INVALID INPUT MACROLIB(1).')
         ENDIF
         CALL LCMLEN(IPLIST,'NUSIGF',ILENGT,ITYLCM)
         IF(ILENGT.EQ.NMIXT) CALL LCMGET(IPLIST,'NUSIGF',ZNUG(1,JGR))
         CALL LCMLEN(IPLIST,'NFTOT',ILENGT,ITYLCM)
         IF(ILENGT.EQ.NMIXT) CALL LCMGET(IPLIST,'NFTOT',ZSIGF(1,JGR))
         CALL LCMLEN(IPLIST,'CHI',ILENGT,ITYLCM)
         IF(ILENGT.EQ.NMIXT) CALL LCMGET(IPLIST,'CHI',CHI(1,JGR))
         DO 900 I=1,NDG
         WRITE (TEXT,'(4HCHDL,I3)') I
         CALL LCMLEN(IPLIST,TEXT,ILENGT,ITYLCM)
         IF(ILENGT.EQ.NMIXT) CALL LCMGET(IPLIST,TEXT,CHDL(1,I,JGR))
 900     CONTINUE
         CALL LCMLEN(IPLIST,'OVERV',ILENGT,ITYLCM)
         IF(ILENGT.EQ.NMIXT) CALL LCMGET(IPLIST,'OVERV',OVERV(1,JGR))
         CALL LCMLEN(IPLIST,'DIFFX',ILENGT,ITYLCM)
         IF(ILENGT.EQ.NMIXT) CALL LCMGET(IPLIST,'DIFFX',DIFFX(1,JGR))
         CALL LCMLEN(IPLIST,'DIFFY',ILENGT,ITYLCM)
         IF(ILENGT.EQ.NMIXT) CALL LCMGET(IPLIST,'DIFFY',DIFFY(1,JGR))
         CALL LCMLEN(IPLIST,'DIFFZ',ILENGT,ITYLCM)
         IF(ILENGT.EQ.NMIXT) CALL LCMGET(IPLIST,'DIFFZ',DIFFZ(1,JGR))
         CALL LCMLEN(IPLIST,'H-FACTORS',ILENGT,ITYLCM)
         IF(ILENGT.EQ.NMIXT) CALL LCMGET(IPLIST,'H-FACTORS',H(1,JGR))
         CALL LCMLEN(IPLIST,'FIXE',ILENGT,ITYLCM)
         IF(ILENGT.EQ.NMIXT) CALL LCMGET(IPLIST,'FIXE',S(1,JGR))
         DO 30 IL=1,NL
         WRITE (CM,'(I2)') IL-1
         CALL LCMLEN(IPLIST,'SCAT'//CM,ILENGT,ITYLCM)
         IF(ILENGT.GT.NMIXT*NL*NGRP*NGRP) THEN
            CALL XABORT('MACXSI: INVALID INPUT MACROLIB(2).')
         ELSE IF(ILENGT.GT.0) THEN
            CALL LCMGET(IPLIST,'SCAT'//CM,WORK)
            CALL LCMGET(IPLIST,'NJJ'//CM,NJJ(1,IL,JGR))
            CALL LCMGET(IPLIST,'IJJ'//CM,IJJ(1,IL,JGR))
            IPOSDE=0
            DO 20 IBM=1,NMIXT
            IJJ0=IJJ(IBM,IL,JGR)
            DO 20 IGR=IJJ0,IJJ0-NJJ(IBM,IL,JGR)+1,-1
            IPOSDE=IPOSDE+1
   20       SCAT(IBM,IL,IGR,JGR)=WORK(IPOSDE)
         ENDIF
   30    CONTINUE
         CALL LCMSIX(IPLIST,' ',2)
   40  CONTINUE
*
* RECOVER THE UNPERTURBED DATA AND COMPUTE DIFFERENCES
       DO 940 JGR=1,NGRP
         WRITE (CGRPNM,'(5HGROUP,I3,1H/,I3)') JGR,NGRP
         CALL LCMSIX(IPLISP,CGRPNM,1)
         CALL LCMLEN(IPLISP,'TOTAL',ILENGT,ITYLCM)
         IF(ILENGT.EQ.NMIXT) THEN
          CALL SETARA(BASE,ILENGT,ITOT)
          CALL LCMGET(IPLISP,'TOTAL',BASE(ITOT))
          DO 100 IMX=1,ILENGT
           TOTAL(IMX,JGR)=TOTAL(IMX,JGR)-BASE(ITOT-1+IMX)
           IF (TOTAL(IMX,JGR).NE.0.0) THEN
             LTO = .TRUE.
           IF (IPRT.GT.3)
     +       WRITE(6,*) 'SUBMAC TOTAL',TOTAL(IMX,JGR),' NUMERO ',IMX
           ENDIF
 100      CONTINUE
          CALL RLSARA(BASE(ITOT))
         ELSE IF(ILENGT.NE.0) THEN
          CALL XABORT('SUBMAC: INVALID INPUT MACROLIB(1).')
         ENDIF
*
         CALL LCMLEN(IPLISP,'NUSIGF',ILENGT,ITYLCM)
         IF(ILENGT.EQ.NMIXT) THEN
          CALL SETARA(BASE,ILENGT,INUS)
          CALL LCMGET(IPLISP,'NUSIGF',BASE(INUS))
          DO 110 IMX=1,ILENGT
           ZNUG(IMX,JGR)=ZNUG(IMX,JGR)-BASE(INUS-1+IMX)
           IF (ZNUG(IMX,JGR).NE.0.0) THEN
              LNFI = .TRUE.
           IF (IPRT.GT.3)
     +       WRITE(6,*) 'SUBMAC NUSIGF',ZNUG(IMX,JGR),' NUMERO ',IMX
           ENDIF
 110      CONTINUE
          CALL RLSARA(BASE(INUS))
         ENDIF
*
         CALL LCMLEN(IPLISP,'NFTOT',ILENGT,ITYLCM)
         IF(ILENGT.EQ.NMIXT) THEN
          CALL SETARA(BASE,ILENGT,INUS)
          CALL LCMGET(IPLISP,'NFTOT',BASE(INUS))
          DO 111 IMX=1,ILENGT
           ZSIGF(IMX,JGR)=ZSIGF(IMX,JGR)-BASE(INUS-1+IMX)
           IF (ZSIGF(IMX,JGR).NE.0.0) THEN
              LFI = .TRUE.
           ENDIF
 111      CONTINUE
          CALL RLSARA(BASE(INUS))
         ENDIF
*
         CALL LCMLEN(IPLISP,'CHI',ILENGT,ITYLCM)
         IF(ILENGT.EQ.NMIXT) THEN
          CALL SETARA(BASE,ILENGT,ICHI)
          CALL LCMGET(IPLISP,'CHI',BASE(ICHI))
          DO 120 IMX=1,ILENGT
           CHI(IMX,JGR)=CHI(IMX,JGR)-BASE(ICHI-1+IMX)
           IF (CHI(IMX,JGR).NE.0.0) THEN
              LCH = .TRUE.
           ENDIF
 120      CONTINUE
          CALL RLSARA(BASE(ICHI))
         ENDIF
*
         DO 990 I=1,NDG
          WRITE (TEXT,'(4HCHDL,I3)') I
          CALL LCMLEN(IPLISP,TEXT,ILENGT,ITYLCM)
          IF(ILENGT.EQ.NMIXT) THEN
           CALL SETARA(BASE,ILENGT,ICHD)
           CALL LCMGET(IPLISP,TEXT,BASE(ICHD))
           DO 220 IMX=1,ILENGT
            CHDL(IMX,I,JGR)=CHDL(IMX,I,JGR)-BASE(ICHD-1+IMX)
            IF (CHDL(IMX,I,JGR).NE.0.0) THEN
              LBI = .TRUE.
            ENDIF
 220       CONTINUE
           CALL RLSARA(BASE(ICHD))
          ENDIF
 990     CONTINUE
*
         CALL LCMLEN(IPLISP,'OVERV',ILENGT,ITYLCM)
         IF(ILENGT.EQ.NMIXT) THEN
          CALL SETARA(BASE,ILENGT,IOVR)
          CALL LCMGET(IPLISP,'OVERV',BASE(IOVR))
          DO 130 IMX=1,ILENGT
           OVERV(IMX,JGR)=OVERV(IMX,JGR)-BASE(IOVR-1+IMX)
           IF (OVERV(IMX,JGR).NE.0.0) THEN
              LOV = .TRUE.
           ENDIF
 130      CONTINUE
          CALL RLSARA(BASE(IOVR))
         ENDIF
*
         IF( DDIF )THEN
           CALL LCMLEN(IPLISP,'DIFFX',ILENGT,ITYLCM)
           IF(ILENGT.EQ.NMIXT) THEN
             CALL SETARA(BASE,ILENGT,IDFX)
             CALL LCMGET(IPLISP,'DIFFX',BASE(IDFX))
             DO 140 IMX=1,ILENGT
               DIFFX(IMX,JGR)=1./DIFFX(IMX,JGR)-1./BASE(IDFX-1+IMX)
               IF (DIFFX(IMX,JGR).NE.0.0) THEN
                 LDX = .TRUE.
                 DIFFX(IMX,JGR)=1./DIFFX(IMX,JGR)
                 IF (IPRT.GT.3)
     +       WRITE(6,*) 'SUBMAC DIFFX',DIFFX(IMX,JGR),' NUMERO ',IMX
               ENDIF
 140         CONTINUE
             CALL RLSARA(BASE(IDFX))
           ENDIF
*
           CALL LCMLEN(IPLISP,'DIFFY',ILENGT,ITYLCM)
           IF(ILENGT.EQ.NMIXT) THEN
             CALL SETARA(BASE,ILENGT,IDFY)
             CALL LCMGET(IPLISP,'DIFFY',BASE(IDFY))
             DO 150 IMX=1,ILENGT
               DIFFY(IMX,JGR)=1./DIFFY(IMX,JGR)-1./BASE(IDFY-1+IMX)
               IF (DIFFY(IMX,JGR).NE.0.0) THEN
                 DIFFY(IMX,JGR)=1./DIFFY(IMX,JGR)
                 LDY = .TRUE.
               ENDIF
 150         CONTINUE
             CALL RLSARA(BASE(IDFY))
           ENDIF
*
           CALL LCMLEN(IPLISP,'DIFFZ',ILENGT,ITYLCM)
           IF(ILENGT.EQ.NMIXT) THEN
             CALL SETARA(BASE,ILENGT,IDFZ)
             CALL LCMGET(IPLISP,'DIFFZ',BASE(IDFZ))
             DO 160 IMX=1,ILENGT
               DIFFZ(IMX,JGR)=1./DIFFZ(IMX,JGR)-1./BASE(IDFZ-1+IMX)
               IF (DIFFZ(IMX,JGR).NE.0.0) THEN
                 LDZ = .TRUE.
                 DIFFZ(IMX,JGR)=1./DIFFZ(IMX,JGR)
               ENDIF
 160         CONTINUE
             CALL RLSARA(BASE(IDFZ))
           ENDIF
         ENDIF
*
         CALL LCMLEN(IPLISP,'H-FACTORS',ILENGT,ITYLCM)
         IF(ILENGT.EQ.NMIXT) THEN
          CALL SETARA(BASE,ILENGT,IH)
          CALL LCMGET(IPLISP,'H-FACTORS',BASE(IH))
          DO 270 IMX=1,ILENGT
           H(IMX,JGR)=H(IMX,JGR)-BASE(IH-1+IMX)
           IF (H(IMX,JGR).NE.0.0) THEN
            LHF = .TRUE.
            IF (IPRT.GT.2)
     +       WRITE(6,*) 'SUBMAC H',H(IMX,JGR),' NUMERO ',IMX
           ENDIF
 270      CONTINUE
          CALL RLSARA(BASE(IH))
         ENDIF
*
         CALL LCMLEN(IPLISP,'FIXE',ILENGT,ITYLCM)
         IF(ILENGT.EQ.NMIXT) THEN
          CALL SETARA(BASE,ILENGT,IS)
          CALL LCMGET(IPLISP,'FIXE',BASE(IS))
          DO 280 IMX=1,ILENGT
           S(IMX,JGR)=S(IMX,JGR)-BASE(IS-1+IMX)
           IF (S(IMX,JGR).NE.0.0) THEN
            LSO = .TRUE.
           ENDIF
 280      CONTINUE
          CALL RLSARA(BASE(IS))
         ENDIF
*
         DO 930 IL=1,NL
          WRITE (CM,'(I2)') IL-1
          CALL LCMLEN(IPLISP,'SCAT'//CM,ILENGT,ITYLCM)
          IF(ILENGT.GT.NMIXT*NL*NGRP*NGRP) THEN
            CALL XABORT('MACXSI: INVALID INPUT MACROLIB(2).')
          ELSE IF(ILENGT.GT.0) THEN
            CALL LCMGET(IPLISP,'SCAT'//CM,WORK)
            CALL LCMGET(IPLISP,'NJJ'//CM,NJJP(1,IL,JGR))
            CALL LCMGET(IPLISP,'IJJ'//CM,IJJP(1,IL,JGR))
            IPOSDE=0
            DO 920 IBM=1,NMIXT
             IJJ0=IJJP(IBM,IL,JGR)
             IJ=IJJ0-IJJ(IBM,IL,JGR)
             IN=NJJP(IBM,IL,JGR)-NJJ(1,IL,JGR)
             IF(IJ.EQ.0.AND.IN.EQ.0) THEN
              DO 820 IGR=IJJ0,IJJ0-NJJP(IBM,IL,JGR)+1,-1
               IPOSDE=IPOSDE+1
             SCAT(IBM,IL,IGR,JGR)=SCAT(IBM,IL,IGR,JGR) - WORK(IPOSDE)
               IF (SCAT(IBM,IL,IGR,JGR).NE.0.0) THEN
                LSC = .TRUE.
                IF (IPRT.GT.3)
     +  WRITE(6,*) 'SUBMAC SCAT',SCAT(IBM,IL,IGR,JGR),' NUMERO ',IBM
               ENDIF
 820          CONTINUE
             ENDIF
 920        CONTINUE
          ENDIF
 930     CONTINUE
         CALL LCMSIX(IPLISP,' ',2)
  940  CONTINUE
*
* PUT DIFFERENCES CROSS SECTIONS IN IPLISD
*
      IF (LEVEL.NE.' ') CALL LCMSIX(IPLISD,LEVEL,1)
      DO 190 JGR=1,NGRP
        WRITE (CGRPNM,'(5HGROUP,I3,1H/,I3)') JGR,NGRP
        CALL LCMSIX(IPLISD,CGRPNM,1)
        IF(LTO) CALL LCMPUT(IPLISD,'TOTAL',NMIXT,2,TOTAL(1,JGR))
        IF(LNFI) CALL LCMPUT(IPLISD,'NUSIGF',NMIXT,2,ZNUG(1,JGR))
        IF(LFI) CALL LCMPUT(IPLISD,'NFTOT',NMIXT,2,ZSIGF(1,JGR))
        IF(LCH) CALL LCMPUT(IPLISD,'CHI',NMIXT,ITYLCM,CHI(1,JGR))
        IF(LOV) CALL LCMPUT(IPLISD,'OVERV',NMIXT,ITYLCM,OVERV(1,JGR))
        IF(LDX) CALL LCMPUT(IPLISD,'DIFFX',NMIXT,ITYLCM,DIFFX(1,JGR))
        IF(LDY) CALL LCMPUT(IPLISD,'DIFFY',NMIXT,ITYLCM,DIFFY(1,JGR))
        IF(LDZ) CALL LCMPUT(IPLISD,'DIFFZ',NMIXT,ITYLCM,DIFFZ(1,JGR))
        IF(LHF) CALL LCMPUT(IPLISD,'H-FACTORS',NMIXT,ITYLCM,H(1,JGR))
        IF(LSO) CALL LCMPUT(IPLISD,'FIXE',NMIXT,ITYLCM,S(1,JGR))
        IF(LBI) THEN
          DO 901 I=1,NDG
            WRITE (TEXT,'(4HCHDL,I3)') I
            CALL LCMPUT(IPLISD,TEXT,NMIXT,ITYLCM,CHDL(1,I,JGR))
 901      CONTINUE
        ENDIF
        IF(LSC) THEN
         DO 180 IL=1,NL
           WRITE (CM,'(I2)') IL-1
           IPOSDE=0
           DO 170 IBM=1,NMIXT
            IPOS(IBM)=IPOSDE+1
            DO 171 IGR=IJJ(IBM,IL,JGR),
     +        IJJ(IBM,IL,JGR)-NJJ(IBM,IL,JGR)+1,-1
             IPOSDE=IPOSDE+1
             WORK(IPOSDE)=SCAT(IBM,IL,IGR,JGR)
 171        CONTINUE
 170       CONTINUE
           CALL LCMPUT(IPLISD,'SCAT'//CM,IPOSDE,2,WORK)
           CALL LCMPUT(IPLISD,'IPOS'//CM,NMIXT,1,IPOS)
           CALL LCMPUT(IPLISD,'NJJ'//CM,NMIXT,1,NJJ(1,IL,JGR))
           CALL LCMPUT(IPLISD,'IJJ'//CM,NMIXT,1,IJJ(1,IL,JGR))
           CALL LCMPUT(IPLISD,'SIGW'//CM,NMIXT,2,SCAT(1,IL,JGR,JGR))
 180     CONTINUE
        ENDIF
        IF( IPRT.GT.3 )CALL LCMLIB(IPLISD)
        CALL LCMSIX(IPLISD,' ',2)
 190  CONTINUE
      IF( IPRT.GT.1 )CALL LCMLIB(IPLISD)
      RETURN
      END
