*DECK SURPOW
      SUBROUTINE SURPOW(NCH,NK,NZONES,ZONE,POWR,PZONE,IPRT,FSTH)
*
**********************************************************************
*
*     THIS ROUTINE COMPUTES POWERS OF INTEREST ZONES AND PRINTS THEM
*
*     CETTE SOUS ROUTINE CALCULE
*     LES PUISSANCES DE ZONES DE SURVEILLANCE ET LES IMPRIME
*
*
*-------------------------------------- AUTHOR: E. VARIN  96/05/01 ---
*
      IMPLICIT NONE
*
*  LOCAL VARIABLES
*
      INTEGER I,IPRT,IZN,NBU
      INTEGER NCH,NK,NZONES,ZONE(NCH*NK)
      REAL    POWR(NCH*NK),PZONE(NZONES),POW,FSTH
      DOUBLE PRECISION  PTOTC
*
      NBU = NK*NCH
      DO 10 I=1,NZONES
         PZONE(I) = 0.0
 10   CONTINUE
*
      PTOTC = 0.0D0
      DO 30 I=1,NBU
         PTOTC = PTOTC + DBLE(POWR(I))
         IZN = ZONE(I)
         PZONE(IZN) = PZONE(IZN) + POWR(I)*FSTH/1.0E3
  30  CONTINUE
*
*---- TOTAL THERMAL POWER IN MW
*
      POW = PTOTC/1000.
      WRITE(6,*) "TOTAL POWER COMPUTED",POW*FSTH," MW"
*
      WRITE(6,'(/)')
      WRITE(6,*) '                  ZONAL THERMAL POWERS (MW)'
      IF( NZONES.EQ.14 )THEN
        WRITE(6,1000)                3,PZONE(3)
        WRITE(6,1000)               10,PZONE(10)
        WRITE(6,2000) 1,PZONE(1),              6,PZONE(6)
        WRITE(6,2000) 8,PZONE(8),             13,PZONE(13)
        WRITE(6,1000)                4,PZONE(4)
        WRITE(6,1000)               11,PZONE(11)
        WRITE(6,2000) 2,PZONE(2),              7,PZONE(7)
        WRITE(6,2000) 9,PZONE(9),             14,PZONE(14)
        WRITE(6,1000)                5,PZONE(5)
        WRITE(6,1000)               12,PZONE(12)
      ELSE
        DO 40 I=1,NZONES
          WRITE(6,1000) I,PZONE(I)
   40   CONTINUE
      ENDIF
*
*
*---- COMPUTE FRACTION OF POWER IN REFERENCE TO TOTAL POWER
*
      DO 35 I=1,NZONES
         PZONE(I) = PZONE(I)/POW
  35  CONTINUE
*
      WRITE(6,'(/)')
      WRITE(6,*) '       PERCENTAGE OF TOTAL POWER  '
      IF( NZONES.EQ.14 )THEN
        WRITE(6,1500)                3,100.*PZONE(3)
        WRITE(6,1500)               10,100.*PZONE(10)
        WRITE(6,2500) 1,100.*PZONE(1),              6,100.*PZONE(6)
        WRITE(6,2500) 8,100.*PZONE(8),             13,100.*PZONE(13)
        WRITE(6,1500)                4,100.*PZONE(4)
        WRITE(6,1500)               11,100.*PZONE(11)
        WRITE(6,2500) 2,100.*PZONE(2),              7,100.*PZONE(7)
        WRITE(6,2500) 9,100.*PZONE(9),             14,100.*PZONE(14)
        WRITE(6,1500)                5,100.*PZONE(5)
        WRITE(6,1500)               12,100.*PZONE(12)
      ELSE
        DO 50 I=1,NZONES
          WRITE(6,1500) I,100.*PZONE(I)
   50   CONTINUE
      ENDIF
*
 1000 FORMAT(20X,'(',I2,')',F7.2,/)
 2000 FORMAT(5X,'(',I2,')',F7.2,20X,'(',I2,')',F7.2,/)
 1500 FORMAT(20X,'(',I2,')',F7.3,/)
 2500 FORMAT(5X,'(',I2,')',F7.3,20X,'(',I2,')',F7.3,/)
      RETURN
      END
