*DECK TAINTG
      SUBROUTINE TAINTG (NGRP,NBURN,BURN0,BURN1,BURNUP,TOTAL,ZTOTAL)
*
*-----------------------------------------------------------------------
*
* INTEGRATE A XS TABLE TOTAL BETWEEN BURN0 AND BURN1
*
* INPUT PARAMETERS:
*  NGRP   : NUMBER OF ENERGY GROUPS.
*  NBURN  : NUMBER OF TABULATED BURNUP STEPS.
*  BURN0  : USER DEFINED INITIAL BURNUP OR NEUTRON EXPOSURE.
*  BURN1  : USER DEFINED FINAL BURNUP OR NEUTRON EXPOSURE.
*           IF BURN0=BURN1, A SIMPLE INTERPOLATION IS PERFORMED.
*           IF BURN0.LT.BURN1, A TIME AVERAGE CALCULATION IS PERFORMED.
*  BURNUP : BURNUP OR NEUTRON EXPOSURE TABULATION POINTS.
*           DIMENSION BURNUP(NBURN)
*
* INTERPOLATED OUTPUT PARAMETERS:
*  TOTAL  : MACROSCOPIC X-SECTIONS. DIMENSION TOTAL(NGRP)
*
* SCRATCH STORAGE:
*  ZTOTAL : DIMENSION ZTOTAL(2*NGRP*NBURN)
*
*-------------------------------------- AUTHOR: A. HEBERT ; 18/02/94 ---
*-------------------------- MODIFIED : E. VARIN ; 22/09/95 ---
*
      DIMENSION BURNUP(*),TOTAL(*),ZTOTAL(NBURN,NGRP,*),UU(2)
*
* PERFORM TIME AVERAGING.
*        TIME AVERAGE OF THE MACROLIB IS REQUIRED.
      IF(BURN0.GT.BURN1) CALL XABORT('TAINTG: ILLEGAL BURN1')
      IF(BURN1.GT.BURNUP(NBURN)) THEN
        WRITE(6,*) ' XS EN LIMITE BURN1 ',BURN1
        BURN1 = BURNUP(NBURN)
      ENDIF
      DO 110 JGR=1,NGRP
        TOTAL(JGR)=0.0
  110 CONTINUE
      DO 130 I=1,NBURN-1
       IF((BURN0.LT.BURNUP(I+1)).AND.(BURN1.GT.BURNUP(I))) THEN
          A=MAX(BURN0,BURNUP(I))
          B=MIN(BURN1,BURNUP(I+1))
          CC=0.5*(B-A)/(BURN1-BURN0)
          DX=(BURNUP(I+1)-BURNUP(I))
          U1=(A-0.5*(BURNUP(I)+BURNUP(I+1)))/DX
          U2=(B-0.5*(BURNUP(I)+BURNUP(I+1)))/DX
          UU(1)=0.5*(-(U2-U1)*0.577350269189626+U1+U2)
          UU(2)=0.5*((U2-U1)*0.577350269189626+U1+U2)
          DO 120 J=1,2
            H1=3.0*(0.5-UU(J))**2-2.0*(0.5-UU(J))**3
            H2=(0.5-UU(J))**2-(0.5-UU(J))**3
            H3=3.0*(0.5+UU(J))**2-2.0*(0.5+UU(J))**3
            H4=-(0.5+UU(J))**2+(0.5+UU(J))**3
            DO 120 JGR=1,NGRP
            TOTAL(JGR)=TOTAL(JGR)+(H1*ZTOTAL(I,JGR,1)+
     1      H2*ZTOTAL(I,JGR,2)*DX+H3*ZTOTAL(I+1,JGR,1)+
     2      H4*ZTOTAL(I+1,JGR,2)*DX)*CC
  120      CONTINUE
         ENDIF
  130 CONTINUE
*
      RETURN
      END
