*DECK TRIADI
      SUBROUTINE TRIADI (NAMP,IPTRK,IPSYS,LL4,F1,NADI)
*
*-----------------------------------------------------------------------
*
* PERFORM NADI INNER ITERATIONS WITH THE ADI PRECONDITIONNING.
*
* INPUT PARAMETERS:
*   NAMP   : CHARACTER*12 NAME OF THE ADI-SPLITTED MATRIX.
*   IPTRK  : L_TRACK POINTER TO THE TRACKING INFORMATION.
*   IPSYS  : L_SYSTEM POINTER TO SYSTEM MATRICES.
*   LL4    : ORDER OF THE MATRIX.
*   F1     : SOURCE TERM OF THE LINEAR SYSTEM. DIMENSION F1(LL4)
*   NADI   : NUMBER OF INNER ADI ITERATIONS.
*
* OUTPUT PARAMETERS:
*   F1     : APPROACHED SOLUTION OF THE LINEAR SYSTEM. DIMENSION F1(LL4)
*
*--------------------------------------------- A. HEBERT ; 15/01/86 ----
*
      CHARACTER*(*) NAMP
      DIMENSION F1(*)
      COMMON BASE(1)
*
      CALL MTLDLS(NAMP,IPTRK,IPSYS,F1)
      IF(NADI.EQ.1) RETURN
*
      CALL SETARA(BASE,LL4,IGAF)
         DO 10 I=1,LL4
   10    BASE(IGAF+I-1)=F1(I)
         M=1
   20    M=M+1
         CALL SETARA(BASE,LL4,IGAR)
            CALL MTLDLM(NAMP,IPTRK,IPSYS,F1,BASE(IGAR))
            CALL MTLDLS(NAMP,IPTRK,IPSYS,BASE(IGAR))
            DO 30 I=1,LL4
   30       F1(I)=BASE(IGAF+I-1)+(F1(I)-BASE(IGAR+I-1))
         CALL RLSARA(BASE(IGAR))
         IF(M.EQ.NADI) GO TO 40
         GO TO 20
   40 CALL RLSARA(BASE(IGAF))
      RETURN
      END
