*DECK TRIAHD
      SUBROUTINE TRIAHD (NEL,SGD,VOL,MAT,VEC)
*
*-----------------------------------------------------------------------
*
* ASSEMBLY OF A DIAGONAL SYSTEM MATRIX CORRESPONDING TO A SINGLE CROSS
* SECTION TYPE. MESH CENTERED FINITE DIFFERENCE CASE IN HEXAGONAL
* GEOMETRY.
*
* INPUT PARAMETERS:
*  NEL    : TOTAL NUMBER OF FINITE ELEMENTS.
*  SGD    : CROSS SECTION PER MATERIAL MIXTURE. DIMENSION SGD(IR)
*           WHERE IR IS THE MAXIMUM NUMBER OF MATERIAL MIXTURES.
*  VOL    : VOLUMES. DIMENSION VOL(NEL)
*  MAT    : INDEX-NUMBER OF THE MIXTURE TYPE ASSIGNED TO EACH VOLUME.
*           DIMENSION MAT(NEL)
*
* OUTPUT PARAMETER:
*  VEC    : DIAGONAL SYSTEM MATRIX. DIMENSION VEC(NUN)
*
* NOTE: VECTOR VEC SHOULD BE INITIALIZED BY THE CALLING PROGRAM.
*
*------------------------------------- AUTHOR: A. HEBERT ; 23/06/93 ----
*
      DIMENSION VOL(*),MAT(*),SGD(*),VEC(*)
*
      KEL=0
      DO 10 K=1,NEL
      L=MAT(K)
      IF(L.EQ.0) GO TO 10
      KEL=KEL+1
      VOL0=VOL(K)
      IF(VOL0.EQ.0.0) GO TO 10
      VEC(KEL)=VEC(KEL)+SGD(L)*VOL0
   10 CONTINUE
      RETURN
      END
