*DECK TRIAHP
      SUBROUTINE TRIAHP (ISPLH,NEL,LL4,SGD,SIDE,ZZ,VOL,MAT,KN,R,RH,RT,
     1 VEC)
*
*-----------------------------------------------------------------------
*
* ASSEMBLY OF A DIAGONAL SYSTEM MATRIX CORRESPONDING TO A SINGLE CROSS
* SECTION TYPE (PRIMAL FORMULATION) IN HEXAGONAL GEOMETRY.
*
* INPUT PARAMETERS:
*  ISPLH  : =1 FOR COMPLETE HEXAGONS; .GT.1 FOR TRIANGLE MESH-SPLITTING.
*  NEL    : TOTAL NUMBER OF FINITE ELEMENTS.
*  LL4      ORDER OF SYSTEM MATRICES.
*  SGD    : CROSS SECTION PER MATERIAL MIXTURE. DIMENSION SGD(IR)
*           WHERE IR IS THE NUMBER OF MATERIAL MIXTURES.
*  SIDE   : DIDE OF AN HEXAGON.
*  ZZ     : HEIGHT OF EACH HEXAGON. DIMENSION ZZ(NEL)
*  VOL    : VOLUME OF EACH ELEMENT. DIMENSION VOL(NEL)
*  MAT    : MIXTURE INDEX ASSIGNED TO EACH ELEMENT. DIMENSION MAT(NEL)
*  KN     : ELEMENT-ORDERED UNKNOWN LIST. DIMENSION KN(MAXKN) WHERE
*           MAXKN=12*IPAS                       IF ISPLH=1
*           MAXKN=2*(1+ISPLH*(ISPLH-1)*3)*IPAS  ELSE
*  R,RH,RT : UNIT MATRICES. DIMENSION R(2,2),RH(6,6),RT(3,3)
*
* OUTPUT PARAMETER:
*  VEC    : DIAGONAL MATRIX CORRESPONDING TO THE CROSS SECTION TERM.
*           DIMENSION VEC(LL4)
*
* NOTE: VECTOR VEC SHOULD BE INITIALIZED BY THE CALLING PROGRAM.
*
*------------------------------------- AUTHOR: A. HEBERT ; 23/06/93 ----
*
      DOUBLE PRECISION RR,VOL1,RTHG(14,14)
      DIMENSION SGD(*),ZZ(*),VOL(*),MAT(*),KN(*),VEC(*),ILIEN(6,3),
     1 IJ17(14),IJ27(14),IJ16(12),IJ26(12),IJ1(14),IJ2(14),RH2(7,7),
     2 R(2,2),RH(6,6),RT(3,3)
      DATA ILIEN/6*4,2,1,5,6,7,3,1,5,6,7,3,2/
      DATA IJ16,IJ26 /1,2,3,4,5,6,1,2,3,4,5,6,6*1,6*2/
      DATA IJ17,IJ27 /1,2,3,4,5,6,7,1,2,3,4,5,6,7,7*1,7*2/
*
* COMPUTE THE HEXAGONAL MASS (RH2).
      IF(ISPLH.EQ.1) THEN
         LC=6
         DO 20 I=1,2*LC
         IJ1(I)=IJ16(I)
   20    IJ2(I)=IJ26(I)
         DO 40 I=1,LC
         DO 40 J=1,LC
   40    RH2(I,J)=RH(I,J)
      ELSE
         LC=7
         DO 60 I=1,2*LC
         IJ1(I)=IJ17(I)
   60    IJ2(I)=IJ27(I)
         DO 75 I=1,LC
         DO 75 J=1,LC
   75    RH2(I,J)=0.0
         DO 80 K=1,6
         DO 80 I=1,3
         NUMI=ILIEN(K,I)
         DO 80 J=1,3
         NUMJ=ILIEN(K,J)
   80    RH2(NUMI,NUMJ)=RH2(NUMI,NUMJ)+RT(I,J)
      ENDIF
      LL=2*LC
*
* CALCULATION OF 3-D MASS AND STIFFNESS MATRICES FROM TENSORIAL PRODUCT
* OF 1-D AND 2-D MATRICES.
      DO 90 I=1,LL
      I1=IJ1(I)
      I2=IJ2(I)
      DO 90 J=1,LL
      J1=IJ1(J)
      J2=IJ2(J)
   90 RTHG(I,J)=RH2(I1,J1)*R(I2,J2)
*
      NUM1=0
      VOL1=SIDE*SIDE
      DO 160 K=1,NEL
      L=MAT(K)
      IF(L.EQ.0) GO TO 160
      IF(VOL(K).EQ.0.0) GO TO 150
      DO 110 I=1,LL
      INW1=KN(NUM1+I)
      IF(INW1.EQ.0) GO TO 110
      RR=RTHG(I,I)*VOL1*ZZ(K)
      VEC(INW1)=VEC(INW1)+RR*SGD(L)
  110 CONTINUE
  150 NUM1=NUM1+LL
  160 CONTINUE
      RETURN
      END
