*DECK TRIASM
      SUBROUTINE TRIASM(HNAMT,IPTRK,IPSYS,IMPX,MAXMIX,NEL,NUN,IPR,MAT,
     1 VOL,IDL,SGD,XSGD,TITR,ISPARM)
*
*-----------------------------------------------------------------------
*
* ASSEMBLY OF A SINGLE-GROUP SYSTEM MATRIX WITH LEAKAGE AND REMOVAL
* CROSS SECTIONS.
*
* INPUT PARAMETERS:
*   HNAMT  : CHARACTER*11 NAME OF THE MATRIX.
*   IPTRK  : L_TRIVAC POINTER TO THE TRIVAC TRACKING INFORMATION.
*   IPSYS  : L_SYSTEM POINTER TO SYSTEM MATRICES.
*   IMPX   : PRINT PARAMETER. EQUAL TO ZERO FOR NO PRINT.
*   MAXMIX : FIRST DIMENSION FOR MATRICES SGD AND XSGD.
*   NEL    : TOTAL NUMBER OF FINITE ELEMENTS.
*   NUN    : TOTAL NUMBER OF UNKNOWNS PER GROUP.
*   IPR=0  : CALCULATION OF THE SYSTEM MATRICES;
*   IPR=1  : CALCULATION OF THE DERIVATIVE OF THESE MATRICES;
*   IPR=2  : CALCULATION OF THE FIRST VARIATION OF THESE MATRICES;
*   IPR=3  : IDENTICAL TO IPR=2, BUT THESE VARIATION ARE ADDED TO
*            UNPERTURBED SYSTEM MATRICES.
*   MAT    : INDEX-NUMBER OF THE MIXTURE TYPE ASSIGNED TO EACH VOLUME.
*            DIMENSION MAT(NEL)
*   VOL    : VOLUMES. DIMENSION VOL(NEL)
*   IDL    : POSITION OF THE AVERAGE FLUX COMPONENT ASSOCIATED WITH
*            EACH VOLUME. DIMENSION IDL(NEL)
*   SGD    : NUCLEAR PROPERTIES PER MATERIAL MIXTURE.
*   XSGD   : IF IPR.GE.1, XSGD CONTAIN FIRST VARIATIONS OR DERIVATIVES
*            OF NUCLEAR PROPERTIES IN EACH MATERIAL MIXTURE.
*            IF IPR=0, XSGD SHOULD BE EQUIVALENCED WITH SGD. THIS IS
*            OBTAINED USING 'CALL TRIASM(...,IDL,SGD,SGD,TITR)'.
*            DIMENSION SGD(MAXMIX,4),XSGD(MAXMIX,4)
*   TITR   : TITLE.
*   ISPARM : PARAMETERS OF SYSTEM MATRICES.
*
*---------------------------------------------- A. HEBERT 04/06/91 -----
*
      LOGICAL CYLIND,CHEX,DIAG,LSGD,LCM
      CHARACTER HNAMT*(*),TITR*(*),TEXT11*11,NAME*12,NAMLCM*12,NAMMY*12
      DIMENSION MAT(*),VOL(*),IDL(*),SGD(MAXMIX,*),XSGD(MAXMIX,*),
     1 IBASE(1),NCODE(6),ZCODE(6),ITP(19),ISPARM(7)
      COMMON BASE(1)
      EQUIVALENCE (BASE(1),IBASE(1))
*
* RECOVER TRIVAC SPECIFIC TRACKING INFORMATION.
      CALL LCMGET(IPTRK,'TPARAM',ITP)
      ITYPE=ITP(1)
      CYLIND=(ITYPE.EQ.3).OR.(ITYPE.EQ.6)
      CHEX=(ITYPE.EQ.8).OR.(ITYPE.EQ.9)
      IDIM=1
      IF((ITYPE.EQ.5).OR.(ITYPE.EQ.6).OR.(ITYPE.EQ.8)) IDIM=2
      IF((ITYPE.EQ.7).OR.(ITYPE.EQ.9)) IDIM=3
      IHEX=ITP(2)
      DIAG=(ITP(3).EQ.1)
      IELEM=ITP(4)
      ICOL=ITP(5)
      ICHX=ITP(6)
      ISPLH=ITP(7)
      LL4=ITP(8)
      ISPARM(2) = LL4
      LX=ITP(9)
      LY=ITP(10)
      LZ=ITP(11)
      ISEG=ITP(12)
      IMPV=ITP(13)
      NR0=ITP(19)
      CALL LCMLEN(IPTRK,'KN',MAXKN,ITYLCM)
      CALL LCMLEN(IPTRK,'QFR',MAXQF,ITYLCM)
      CALL SETARA(BASE,LX*LY*LZ,IZZ)
      CALL SETARA(IBASE,MAXKN,IKN)
      CALL SETARA(BASE,MAXQF,IQFR)
      CALL SETARA(IBASE,LL4,IIPX)
      CALL LCMGET(IPTRK,'ZZ',BASE(IZZ))
      CALL LCMGET(IPTRK,'KN',IBASE(IKN))
      CALL LCMGET(IPTRK,'QFR',BASE(IQFR))
      CALL LCMGET(IPTRK,'IPX',IBASE(IIPX))
      IF(CHEX) THEN
         CALL LCMGET(IPTRK,'SIDE',SIDE)
         CALL SETARA(IBASE,LL4,IMUW)
         CALL LCMGET(IPTRK,'MUW',IBASE(IMUW))
         CALL SETARA(IBASE,LL4,IIPW)
         CALL LCMGET(IPTRK,'IPW',IBASE(IIPW))
      ELSE
         CALL SETARA(BASE,LX*LY*LZ,IXX)
         CALL SETARA(BASE,LX*LY*LZ,IYY)
         CALL SETARA(BASE,LX*LY*LZ,IDD)
         CALL LCMGET(IPTRK,'XX',BASE(IXX))
         CALL LCMGET(IPTRK,'YY',BASE(IYY))
         CALL LCMGET(IPTRK,'DD',BASE(IDD))
      ENDIF
      IF(IDIM.GE.2) THEN
         CALL SETARA(IBASE,LL4,IMUY)
         CALL SETARA(IBASE,LL4,IIPY)
         CALL LCMGET(IPTRK,'MUY',IBASE(IMUY))
         CALL LCMGET(IPTRK,'IPY',IBASE(IIPY))
      ENDIF
      IF(.NOT.DIAG) THEN
         CALL SETARA(IBASE,LL4,IMUX)
         CALL LCMGET(IPTRK,'MUX',IBASE(IMUX))
      ELSE
         IMUX=IMUY
      ENDIF
      IF(IDIM.EQ.3) THEN
         CALL SETARA(IBASE,LL4,IMUZ)
         CALL SETARA(IBASE,LL4,IIPZ)
         CALL LCMGET(IPTRK,'MUZ',IBASE(IMUZ))
         CALL LCMGET(IPTRK,'IPZ',IBASE(IIPZ))
      ENDIF
*
* RECOVER UNIT MATRICES.
      IF((ICHX.EQ.1).OR.(ICHX.EQ.2)) THEN
         CALL LCMSIX(IPTRK,'BIVCOL',1)
         CALL LCMLEN(IPTRK,'T',LC,ITYLCM)
         CALL SETARA(BASE,LC,IT)
         CALL SETARA(BASE,LC,ITS)
         CALL SETARA(BASE,LC*LC,IR)
         CALL SETARA(BASE,LC*LC,IRS)
         CALL SETARA(BASE,LC*LC,IQ)
         CALL SETARA(BASE,LC*LC,IQS)
         CALL SETARA(BASE,LC*(LC-1),IV)
         CALL SETARA(BASE,36,IRH)
         CALL SETARA(BASE,36,IQH)
         CALL SETARA(BASE,9,IRT)
         CALL SETARA(BASE,9,IQT)
         CALL LCMGET(IPTRK,'T',BASE(IT))
         CALL LCMGET(IPTRK,'TS',BASE(ITS))
         CALL LCMGET(IPTRK,'R',BASE(IR))
         CALL LCMGET(IPTRK,'RS',BASE(IRS))
         CALL LCMGET(IPTRK,'Q',BASE(IQ))
         CALL LCMGET(IPTRK,'QS',BASE(IQS))
         CALL LCMGET(IPTRK,'V',BASE(IV))
         IF((IELEM.EQ.1).AND.(ICOL.LE.2)) THEN
            CALL LCMGET(IPTRK,'RH',BASE(IRH))
            CALL LCMGET(IPTRK,'QH',BASE(IQH))
            CALL LCMGET(IPTRK,'RT',BASE(IRT))
            CALL LCMGET(IPTRK,'QT',BASE(IQT))
         ENDIF
         CALL LCMSIX(IPTRK,' ',2)
      ENDIF
*
      TEXT11=HNAMT
      IF(IMPX.GT.0) WRITE(6,'(/36H TRIASM: ASSEMBLY OF SYMMETRIC MATRI,
     1 3HX '',A11,38H'' IN COMPRESSED DIAGONAL STORAGE MODE.)') TEXT11
      NAME=' '
      CALL LCMNXT(IPSYS,NAME,NAMLCM,NAMMY,LCM)
*
* COMPUTE THE INVERSE CROSS SECTIONS FOR DUAL FINITE ELEMENT CASES.
      IF(ICHX.EQ.2) THEN
         CALL SETARA(BASE,4*MAXMIX,IDSGD)
         IF(IPR.EQ.0) THEN
            DO 5 J=1,4
            DO 5 I=1,MAXMIX
            IF(SGD(I,J).NE.0.) BASE(IDSGD+(J-1)*MAXMIX+I-1)=1.0/SGD(I,J)
    5       CONTINUE
         ELSE IF(IPR.EQ.1) THEN
            DO 10 J=1,4
            DO 10 I=1,MAXMIX
            IF(SGD(I,J).NE.0.0) THEN
               BASE(IDSGD+(J-1)*MAXMIX+I-1)=-XSGD(I,J)/(SGD(I,J)**2)
            ENDIF
   10       CONTINUE
         ELSE
            DO 20 J=1,4
            DO 20 I=1,MAXMIX
            SIGMA=SGD(I,J)+XSGD(I,J)
            IF((SGD(I,J).NE.0.0).AND.(SIGMA.NE.0.0)) THEN
               BASE(IDSGD+(J-1)*MAXMIX+I-1)=1.0/SIGMA-1.0/SGD(I,J)
            ENDIF
   20       CONTINUE
         ENDIF
      ENDIF
*
* DETERMINATION OF THE PERTURBED ELEMENTS AND INCLUSION OF ELEMENTS
* NEIGHBOUR TO PERTURBED ZONES IN MCFD CASES. NON-PERTURBED ELEMENTS
* WILL HAVE BASE(IVOL+K-1)=0.0
      CALL SETARA(BASE,NEL,IVOL)
      IF(IPR.EQ.0) THEN
         DO 25 K=1,NEL
   25    BASE(IVOL+K-1)=VOL(K)
      ELSE
         DO 26 K=1,NEL
   26    BASE(IVOL+K-1)=0.0
         IF((ICHX.EQ.3).OR.(ICHX.EQ.4)) THEN
*           MCFD CASES.
            NUM1=0
            DO 40 L=1,NEL
            IF(MAT(L).EQ.0) GO TO 40
            LSGD=.FALSE.
            DO 30 I=1,4
   30       LSGD=LSGD.OR.(XSGD(MAT(L),I).NE.0.0)
            IF(LSGD) THEN
               BASE(IVOL+L-1)=VOL(L)
               DO 35 I=1,6
               K=IBASE(IKN+(NUM1+I)-1)
               IF(K.GT.0) THEN
                  IF(K.GT.NEL) CALL XABORT('TRIASM: INVALID BOUNDARY E'
     1            //'LEMENT INDEX.')
                  BASE(IVOL+K-1)=VOL(K)
               ENDIF
   35          CONTINUE
            ENDIF
            NUM1=NUM1+6
   40       CONTINUE
         ELSE
            DO 50 L=1,NEL
            IF(MAT(L).EQ.0) GO TO 50
            LSGD=.FALSE.
            DO 45 I=1,4
   45       LSGD=LSGD.OR.(XSGD(MAT(L),I).NE.0.0)
            IF(LSGD) BASE(IVOL+L-1)=VOL(L)
   50       CONTINUE
         ENDIF
      ENDIF
*
* INTRODUCE THE CYLINDER BOUNDARY APPROXIMATION IN CARTESIAN GEOMETRY.
      IF(NR0.GT.0) THEN
         CALL SETARA(BASE,NR0,IRR0)
         CALL LCMGET(IPTRK,'RR0',BASE(IRR0))
         CALL SETARA(BASE,NR0,IXR0)
         CALL LCMGET(IPTRK,'XR0',BASE(IXR0))
         CALL SETARA(BASE,NR0,IANG)
         CALL LCMGET(IPTRK,'ANG',BASE(IANG))
         CALL LCMGET(IPTRK,'NCODE',NCODE)
         CALL LCMGET(IPTRK,'ZCODE',ZCODE)
         CALL SETARA(BASE,LX+1,IXXX)
         CALL SETARA(BASE,LY+1,IYYY)
         CALL SETARA(BASE,LZ+1,IZZZ)
         CALL TRICYL(MAXMIX,IMPX,ICHX,IDIM,LX,LY,LZ,BASE(IXX),BASE(IYY),
     1   BASE(IZZ),VOL,MAT,NCODE,ZCODE,NR0,BASE(IRR0),BASE(IXR0),
     2   BASE(IANG),SGD,BASE(IQFR),BASE(IXXX),BASE(IYYY),BASE(IZZZ))
         CALL RLSARA(BASE(IZZZ))
         CALL RLSARA(BASE(IYYY))
         CALL RLSARA(BASE(IXXX))
         CALL RLSARA(BASE(IANG))
         CALL RLSARA(BASE(IXR0))
         CALL RLSARA(BASE(IRR0))
      ENDIF
*
* ASSEMBLY OF THE ADI SPLITTED SYSTEM MATRICES.
*
* DIMENSION W.
      IF(CHEX) THEN
         IF(((ICHX.EQ.3).OR.(ICHX.EQ.4)).AND.(ISPLH.GT.1)) THEN
            CALL SETARA(IBASE,LL4,IMATN)
            NUM1=0
            DO 2 I=1,LX*LZ
            IF(MAT(I).EQ.0) GO TO 2
            DO 1 J=1,6*(ISPLH-1)**2
            KEL=IBASE(IKN+NUM1+J-1)
   1        IBASE(IMATN+KEL-1)=MAT(I)
            NUM1=NUM1+18*(ISPLH-1)**2+8
   2        CONTINUE
         ENDIF
         IIMAW=IBASE(IMUW+LL4-1)
         ISPARM(4) = IIMAW
         IF(IPR.EQ.3) THEN
            IF(ISEG.GT.0) CALL MTBLD('W'//TEXT11,IPTRK,IPSYS,1)
            IF(LCM) THEN
               IWA=LCMIOF(IPSYS,'W'//TEXT11)
            ELSE
               CALL SETARA(BASE,IIMAW,IWA)
               CALL LCMGET(IPSYS,'W'//TEXT11,BASE(IWA))
            ENDIF
         ELSE
            CALL SETARA(BASE,IIMAW,IWA)
            DO 65 I=1,IIMAW
   65       BASE(IWA+I-1)=0.0
         ENDIF
         IF(ICHX.EQ.1) THEN
*           MESH CORNER FINITE DIFFERENCES IN HEXAGONAL GEOMETRY.
            CALL TRIRWW(MAXMIX,NEL,LL4,VOL,MAT,XSGD,SIDE,BASE(IZZ),
     1      IBASE(IKN),BASE(IQFR),IBASE(IMUW),IBASE(IIPW),BASE(IWA),
     2      ISPLH,BASE(IR),BASE(IQ),BASE(IRH),BASE(IQH),BASE(IRT),
     3      BASE(IQT))
         ELSE IF((ICHX.EQ.3).OR.(ICHX.EQ.4)) THEN
*           MESH CENTERED FINITE DIFFERENCES IN HEXAGONAL GEOMETRY.
            IF(ISPLH.EQ.1) THEN
               CALL SETARA(BASE,NEL,IIGAR)
               CALL TRIMWW(MAXMIX,IDIM,NEL,LL4,VOL,MAT,SGD,XSGD,SIDE,
     1         BASE(IZZ),IBASE(IKN),BASE(IQFR),IBASE(IMUW),IBASE(IIPW),
     2         IPR,BASE(IWA),BASE(IIGAR))
               CALL RLSARA(BASE(IIGAR))
            ELSE
               CALL TRIMTW(ISPLH,MAXMIX,IDIM,NEL,LL4,VOL,MAT,
     1         IBASE(IMATN),SGD,XSGD,SIDE,BASE(IZZ),IBASE(IKN),
     2         BASE(IQFR),IBASE(IMUW),IBASE(IIPW),IPR,BASE(IWA))
            ENDIF
         ENDIF
         CALL LCMPOF(IPSYS,'W'//TEXT11,IIMAW,2,IWA)
      ENDIF
*
* DIMENSION X.
      IIMAX=IBASE(IMUX+LL4-1)
      ISPARM(5) = IIMAX
      IF(IPR.EQ.3) THEN
         IF(.NOT.DIAG) THEN
            IF(ISEG.GT.0) CALL MTBLD('X'//TEXT11,IPTRK,IPSYS,1)
            IF(LCM) THEN
               IXA=LCMIOF(IPSYS,'X'//TEXT11)
            ELSE
               CALL SETARA(BASE,IIMAX,IXA)
               CALL LCMGET(IPSYS,'X'//TEXT11,BASE(IXA))
            ENDIF
         ELSE
            CALL SETARA(BASE,IIMAX,IXA)
            DO 75 I=1,IIMAX
   75       BASE(IXA+I-1)=0.0
         ENDIF
      ELSE
         CALL SETARA(BASE,IIMAX,IXA)
         DO 80 I=1,IIMAX
   80    BASE(IXA+I-1)=0.0
      ENDIF
      IF((ICHX.EQ.1).AND.(.NOT.CHEX)) THEN
         CALL TRIPXX(MAXMIX,NEL,LL4,BASE(IVOL),MAT,XSGD,BASE(IXX),
     1   BASE(IYY),BASE(IZZ),BASE(IDD),IBASE(IKN),BASE(IQFR),
     2   IBASE(IMUX),IBASE(IIPX),CYLIND,LC,BASE(IT),BASE(ITS),BASE(IQ),
     3   BASE(IQS),BASE(IXA))
      ELSE IF((ICHX.EQ.2).AND.(.NOT.CHEX)) THEN
         CALL TRIDXX(MAXMIX,CYLIND,IELEM,ICOL,IDIM,NEL,LL4,MAT,
     1   BASE(IVOL),BASE(IXX),BASE(IYY),BASE(IZZ),BASE(IDD),IBASE(IKN),
     2   BASE(IQFR),XSGD,BASE(IDSGD),IBASE(IMUX),IBASE(IIPX),IPR,LC,
     3   BASE(IR),BASE(IV),BASE(IXA))
      ELSE IF((ICHX.EQ.3).AND.(.NOT.CHEX)) THEN
         CALL SETARA(BASE,NEL,IIGAR)
         CALL TRIMXX(MAXMIX,CYLIND,IELEM,IDIM,NEL,LL4,BASE(IVOL),MAT,
     1   SGD,XSGD,BASE(IXX),BASE(IYY),BASE(IZZ),BASE(IDD),IBASE(IKN),
     2   BASE(IQFR),IBASE(IMUX),IBASE(IIPX),IPR,BASE(IXA),BASE(IIGAR))
         CALL RLSARA(BASE(IIGAR))
      ELSE IF((ICHX.EQ.4).AND.(.NOT.CHEX)) THEN
         CALL SETARA(BASE,NEL,IIGAR)
         CALL TRILXX(MAXMIX,CYLIND,IELEM,IDIM,NEL,LL4,BASE(IVOL),MAT,
     1   SGD,XSGD,BASE(IXX),BASE(IYY),BASE(IZZ),BASE(IDD),IBASE(IKN),
     2   BASE(IQFR),IBASE(IMUX),IBASE(IIPX),IPR,BASE(IXA),BASE(IIGAR))
         CALL RLSARA(BASE(IIGAR))
      ELSE IF((ICHX.EQ.1).AND.CHEX) THEN
*        MESH CORNER FINITE DIFFERENCES IN HEXAGONAL GEOMETRY.
         CALL TRIRWX(MAXMIX,NEL,LL4,VOL,MAT,XSGD,SIDE,BASE(IZZ),
     1   IBASE(IKN),BASE(IQFR),IBASE(IMUX),IBASE(IIPX),BASE(IXA))
      ELSE IF(((ICHX.EQ.3).OR.(ICHX.EQ.4)).AND.CHEX) THEN
*        MESH CENTERED FINITE DIFFERENCES IN HEXAGONAL GEOMETRY.
         IF(ISPLH.EQ.1) THEN
            CALL SETARA(BASE,NEL,IIGAR)
            CALL TRIMWX(MAXMIX,IDIM,NEL,LL4,VOL,MAT,SGD,XSGD,SIDE,
     1      BASE(IZZ),IBASE(IKN),BASE(IQFR),IBASE(IMUX),IBASE(IIPX),
     2      IPR,BASE(IXA),BASE(IIGAR))
            CALL RLSARA(BASE(IIGAR))
         ELSE
            CALL TRIMTX(ISPLH,MAXMIX,IDIM,NEL,LL4,VOL,MAT,IBASE(IMATN),
     1      SGD,XSGD,SIDE,BASE(IZZ),IBASE(IKN),BASE(IQFR),IBASE(IMUX),
     2      IBASE(IIPX),IPR,BASE(IXA))
         ENDIF
      ENDIF
      IF(.NOT.DIAG) THEN
         CALL LCMPOF(IPSYS,'X'//TEXT11,IIMAX,2,IXA)
      ELSE
*        IN DIAGONAL SYMMETRY CASE, DO NOT SAVE THE X-DIRECTED ADI
*        MATRIX COMPONENT SINCE IT IS EQUAL TO THE Y-DIRECTED COMPONENT
         CALL RLSARA(BASE(IXA))
      ENDIF
*
* DIMENSION Y.
      IF(IDIM.GT.1) THEN
         IIMAY=IBASE(IMUY+LL4-1)
         ISPARM(6) = IIMAY
         IF(IPR.EQ.3) THEN
            IF(ISEG.GT.0) CALL MTBLD('Y'//TEXT11,IPTRK,IPSYS,1)
            IF(LCM) THEN
               IYA=LCMIOF(IPSYS,'Y'//TEXT11)
            ELSE
               CALL SETARA(BASE,IIMAX,IYA)
               CALL LCMGET(IPSYS,'Y'//TEXT11,BASE(IYA))
            ENDIF
         ELSE
            CALL SETARA(BASE,IIMAY,IYA)
            DO 85 I=1,IIMAY
   85       BASE(IYA+I-1)=0.0
         ENDIF
         IF((ICHX.EQ.1).AND.(.NOT.CHEX)) THEN
            CALL TRIPXY(MAXMIX,NEL,LL4,BASE(IVOL),MAT,XSGD,BASE(IXX),
     1      BASE(IYY),BASE(IZZ),BASE(IDD),IBASE(IKN),BASE(IQFR),
     2      IBASE(IMUY),IBASE(IIPY),CYLIND,BASE(IYA))
         ELSE IF((ICHX.EQ.2).AND.(.NOT.CHEX)) THEN
            CALL TRIDXY(MAXMIX,CYLIND,IELEM,ICOL,IDIM,NEL,LL4,MAT,
     1      BASE(IVOL),BASE(IXX),BASE(IYY),BASE(IZZ),BASE(IDD),
     2      IBASE(IKN),BASE(IQFR),XSGD,BASE(IDSGD),IBASE(IMUY),
     3      IBASE(IIPY),IPR,LC,BASE(IR),BASE(IV),BASE(IYA))
         ELSE IF((ICHX.EQ.3).AND.(.NOT.CHEX)) THEN
            CALL SETARA(BASE,NEL,IIGAR)
            CALL TRIMXY(MAXMIX,CYLIND,IELEM,IDIM,NEL,LL4,BASE(IVOL),MAT,
     1      SGD,XSGD,BASE(IXX),BASE(IYY),BASE(IZZ),BASE(IDD),IBASE(IKN),
     2      BASE(IQFR),IBASE(IMUY),IBASE(IIPY),IPR,BASE(IYA),
     3      BASE(IIGAR))
            CALL RLSARA(BASE(IIGAR))
         ELSE IF((ICHX.EQ.4).AND.(.NOT.CHEX)) THEN
            CALL SETARA(BASE,NEL,IIGAR)
            CALL TRILXY(MAXMIX,CYLIND,IELEM,IDIM,NEL,LL4,BASE(IVOL),MAT,
     1      SGD,XSGD,BASE(IXX),BASE(IYY),BASE(IZZ),BASE(IDD),IBASE(IKN),
     2      BASE(IQFR),IBASE(IMUY),IBASE(IIPY),IPR,BASE(IYA),
     3      BASE(IIGAR))
            CALL RLSARA(BASE(IIGAR))
         ELSE IF((ICHX.EQ.1).AND.CHEX) THEN
*           MESH CORNER FINITE DIFFERENCES IN HEXAGONAL GEOMETRY.
            CALL TRIRWY(MAXMIX,NEL,LL4,VOL,MAT,XSGD,SIDE,BASE(IZZ),
     1      IBASE(IKN),BASE(IQFR),IBASE(IMUY),IBASE(IIPY),BASE(IYA))
         ELSE IF(((ICHX.EQ.3).OR.(ICHX.EQ.4)).AND.CHEX) THEN
*           MESH CENTERED FINITE DIFFERENCES IN HEXAGONAL GEOMETRY.
            IF(ISPLH.EQ.1) THEN
               CALL SETARA(BASE,NEL,IIGAR)
               CALL TRIMWY(MAXMIX,IDIM,NEL,LL4,VOL,MAT,SGD,XSGD,SIDE,
     1         BASE(IZZ),IBASE(IKN),BASE(IQFR),IBASE(IMUY),IBASE(IIPY),
     2         IPR,BASE(IYA),BASE(IIGAR))
               CALL RLSARA(BASE(IIGAR))
            ELSE
               CALL TRIMTY(ISPLH,MAXMIX,IDIM,NEL,LL4,VOL,MAT,
     1         IBASE(IMATN),SGD,XSGD,SIDE,BASE(IZZ),IBASE(IKN),
     2         BASE(IQFR),IBASE(IMUY),IBASE(IIPY),IPR,BASE(IYA))
            ENDIF
         ENDIF
         CALL LCMPOF(IPSYS,'Y'//TEXT11,IIMAY,2,IYA)
      ENDIF
*
* DIMENSION Z
      IF(IDIM.GT.2) THEN
         IIMAZ=IBASE(IMUZ+LL4-1)
         ISPARM(7) = IIMAZ
         IF(IPR.EQ.3) THEN
            IF(ISEG.GT.0) CALL MTBLD('Z'//TEXT11,IPTRK,IPSYS,1)
            IF(LCM) THEN
               IZA=LCMIOF(IPSYS,'Z'//TEXT11)
            ELSE
               CALL SETARA(BASE,IIMAX,IZA)
               CALL LCMGET(IPSYS,'Z'//TEXT11,BASE(IZA))
            ENDIF
         ELSE
            CALL SETARA(BASE,IIMAZ,IZA)
            DO 90 I=1,IIMAZ
   90       BASE(IZA+I-1)=0.0
         ENDIF
         IF((ICHX.EQ.1).AND.(.NOT.CHEX)) THEN
            CALL TRIPXZ(MAXMIX,NEL,LL4,BASE(IVOL),MAT,XSGD,BASE(IXX),
     1      BASE(IYY),BASE(IZZ),BASE(IDD),IBASE(IKN),BASE(IQFR),
     2      IBASE(IMUZ),IBASE(IIPZ),CYLIND,BASE(IZA))
         ELSE IF((ICHX.EQ.2).AND.(.NOT.CHEX)) THEN
            CALL TRIDXZ(MAXMIX,CYLIND,IELEM,ICOL,IDIM,NEL,LL4,MAT,
     1      BASE(IVOL),BASE(IXX),BASE(IYY),BASE(IZZ),BASE(IDD),
     2      IBASE(IKN),BASE(IQFR),XSGD,BASE(IDSGD),IBASE(IMUZ),
     3      BASE(IIPZ),IPR,LC,BASE(IR),BASE(IV),BASE(IZA))
         ELSE IF((ICHX.EQ.3).AND.(.NOT.CHEX)) THEN
            CALL SETARA(BASE,NEL,IIGAR)
            CALL TRIMXZ(MAXMIX,CYLIND,IELEM,IDIM,NEL,LL4,BASE(IVOL),MAT,
     1      SGD,XSGD,BASE(IXX),BASE(IYY),BASE(IZZ),BASE(IDD),IBASE(IKN),
     2      BASE(IQFR),IBASE(IMUZ),IBASE(IIPZ),IPR,BASE(IZA),
     3      BASE(IIGAR))
            CALL RLSARA(BASE(IIGAR))
         ELSE IF((ICHX.EQ.4).AND.(.NOT.CHEX)) THEN
            CALL SETARA(BASE,NEL,IIGAR)
            CALL TRILXZ(MAXMIX,CYLIND,IELEM,IDIM,NEL,LL4,BASE(IVOL),MAT,
     1      SGD,XSGD,BASE(IXX),BASE(IYY),BASE(IZZ),BASE(IDD),IBASE(IKN),
     2      BASE(IQFR),IBASE(IMUZ),IBASE(IIPZ),IPR,BASE(IZA),
     3      BASE(IIGAR))
            CALL RLSARA(BASE(IIGAR))
         ELSE IF((ICHX.EQ.1).AND.CHEX) THEN
*           MESH CORNER FINITE DIFFERENCES IN HEXAGONAL GEOMETRY.
            CALL TRIRWZ(MAXMIX,NEL,LL4,VOL,MAT,XSGD,SIDE,BASE(IZZ),
     1      IBASE(IKN),BASE(IQFR),IBASE(IMUZ),IBASE(IIPZ),BASE(IZA))
         ELSE IF(((ICHX.EQ.3).OR.(ICHX.EQ.4)).AND.CHEX) THEN
*           MESH CENTERED FINITE DIFFERENCES IN HEXAGONAL GEOMETRY.
            IF(ISPLH.EQ.1) THEN
               CALL SETARA(BASE,NEL,IIGAR)
               CALL TRIMWZ(MAXMIX,IDIM,NEL,LL4,VOL,MAT,SGD,XSGD,SIDE,
     1         BASE(IZZ),IBASE(IKN),BASE(IQFR),IBASE(IMUZ),IBASE(IIPZ),
     2         IPR,BASE(IZA),BASE(IIGAR))
               CALL RLSARA(BASE(IIGAR))
            ELSE
               CALL TRIMTZ(ISPLH,MAXMIX,IDIM,NEL,LL4,VOL,MAT,
     1         IBASE(IMATN),SGD,XSGD,SIDE,BASE(IZZ),IBASE(IKN),
     2         BASE(IQFR),IBASE(IMUZ),IBASE(IIPZ),IPR,BASE(IZA))
            ENDIF
         ENDIF
         CALL LCMPOF(IPSYS,'Z'//TEXT11,IIMAZ,2,IZA)
      ENDIF
      CALL RLSARA(BASE(IVOL))
      IF(ICHX.EQ.2) CALL RLSARA(BASE(IDSGD))
      IF(((ICHX.EQ.3).OR.(ICHX.EQ.4)).AND.(ISPLH.GT.1).AND.CHEX) THEN
         CALL RLSARA(IBASE(IMATN))
      ENDIF
*
* CHECK FOR MATRIX CONSISTENCY.
      CALL TRICHK (TEXT11,IPTRK,IPSYS,IDIM,DIAG,CHEX,IPR,LL4)
*
* PERFORM SUPERVECTORIZATION REBUILD OF THE COEFFICIENT MATRICES.
      IF(ISEG.GT.0) THEN
         IF(CHEX) CALL MTBLD('W'//TEXT11,IPTRK,IPSYS,3)
         IF(.NOT.DIAG) CALL MTBLD('X'//TEXT11,IPTRK,IPSYS,3)
         IF(IDIM.GT.1) CALL MTBLD('Y'//TEXT11,IPTRK,IPSYS,3)
         IF(IDIM.GT.2) CALL MTBLD('Z'//TEXT11,IPTRK,IPSYS,3)
      ENDIF
*
* MATRIX FACTORIZATIONS.
      IF(IPR.EQ.0) THEN
         CALL MTLDLF(TEXT11,IPTRK,IPSYS,IMPX)
      ENDIF
*
* RELEASE UNIT MATRICES.
      IF((ICHX.EQ.1).OR.(ICHX.EQ.2)) THEN
         CALL RLSARA(BASE(IQT))
         CALL RLSARA(BASE(IRT))
         CALL RLSARA(BASE(IQH))
         CALL RLSARA(BASE(IRH))
         CALL RLSARA(BASE(IV))
         CALL RLSARA(BASE(IQS))
         CALL RLSARA(BASE(IQ))
         CALL RLSARA(BASE(IRS))
         CALL RLSARA(BASE(IR))
         CALL RLSARA(BASE(ITS))
         CALL RLSARA(BASE(IT))
      ENDIF
*
* RELEASE TRIVAC SPECIFIC TRACKING INFORMATION.
      CALL RLSARA(IBASE(IIPX))
      CALL RLSARA(BASE(IQFR))
      CALL RLSARA(IBASE(IKN))
      CALL RLSARA(BASE(IZZ))
      IF(CHEX) THEN
         CALL RLSARA(IBASE(IIPW))
         CALL RLSARA(IBASE(IMUW))
      ELSE
         CALL RLSARA(BASE(IDD))
         CALL RLSARA(BASE(IYY))
         CALL RLSARA(BASE(IXX))
      ENDIF
      IF(IDIM.GE.2) THEN
         CALL RLSARA(IBASE(IIPY))
         CALL RLSARA(IBASE(IMUY))
      ENDIF
      IF(.NOT.DIAG) CALL RLSARA(IBASE(IMUX))
      IF(IDIM.EQ.3) THEN
         CALL RLSARA(IBASE(IIPZ))
         CALL RLSARA(IBASE(IMUZ))
      ENDIF
      RETURN
      END
