*DECK TRICHK
      SUBROUTINE TRICHK (HNAMT,IPTRK,IPSYS,IDIM,DIAG,CHEX,IPR,LL4)
*
*-----------------------------------------------------------------------
*
* PARTIAL CONSISTENCY CHECK FOR AN ADI-SPLITTED SYSTEM MATRIX.
*
* INPUT PARAMETERS:
*  HNAMT  : CHARACTER*11 NAME OF THE MATRIX TO CHECK.
*  IPTRK  : L_TRACK POINTER TO THE TRACKING INFORMATION.
*  IPSYS  : L_SYSTEM POINTER TO SYSTEM MATRICES.
*  IDIM   : NUMBER OF DIMENSIONS (1, 2 OR 3).
*  DIAG   : DIAGONAL SYMMETRY FLAG FOR CARTESIAN GEOMETRIES.
*  CHEX   : HEXAGONAL GEOMETRY FLAG.
*  IPR    : IF IPR.NE.0, MATRIX MAY CONTAIN PERTURBATION VALUES.
*  LL4    : ORDER OF SYSTEM MATRICES.
*
*------------------------------------- AUTHOR: A. HEBERT ; 15/12/86 ----
*
      PARAMETER (EPSMAX=1.0E-5)
      CHARACTER HNAMT*(*),TEXT11*11,HSMG*60,TEXT8*8,NAME*12,NAMLCM*12,
     1 NAMMY*12
      LOGICAL DIAG,CHEX,LCM
      COMMON BASE(1)
      DIMENSION IBASE(1)
      EQUIVALENCE (BASE(1),IBASE(1))
      TEXT11=HNAMT
      NAME=' '
      CALL LCMNXT(IPSYS,NAME,NAMLCM,NAMMY,LCM)
*
* DIMENSION X.
      CALL SETARA(BASE,LL4,IXTT1)
      CALL SETARA(IBASE,LL4,IMUX)
      CALL SETARA(IBASE,LL4,IIPX)
      CALL LCMGET(IPTRK,'IPX',IBASE(IIPX))
      IF(LCM) THEN
         IF(.NOT.DIAG) THEN
            CALL LCMGET(IPTRK,'MUX',IBASE(IMUX))
            IXA11=LCMIOF(IPSYS,'X'//TEXT11)
         ELSE
*           DIAGONAL SYMMETRY
            CALL LCMGET(IPTRK,'MUY',IBASE(IMUX))
            IXA11=LCMIOF(IPSYS,'Y'//TEXT11)
         ENDIF
      ELSE
         IF(.NOT.DIAG) THEN
            CALL LCMGET(IPTRK,'MUX',IBASE(IMUX))
            CALL SETARA(BASE,IBASE(IMUX+LL4-1),IXA11)
            CALL LCMGET(IPSYS,'X'//TEXT11,BASE(IXA11))
         ELSE
*           DIAGONAL SYMMETRY
            CALL LCMGET(IPTRK,'MUY',IBASE(IMUX))
            CALL SETARA(BASE,IBASE(IMUX+LL4-1),IXA11)
            CALL LCMGET(IPSYS,'Y'//TEXT11,BASE(IXA11))
         ENDIF
      ENDIF
      DO 10 I=1,LL4
      IGAR=IBASE(IMUX+IBASE(IIPX+I-1)-1)
      BASE(IXTT1+I-1)=BASE(IXA11+IGAR-1)
      IF((IPR.EQ.0).AND.(BASE(IXTT1+I-1).EQ.0.0)) THEN
         WRITE (TEXT8,'(I8)') I
         CALL XABORT('TRICHK: ZERO ELEMENT ON DIAGONAL ELEMENT'//
     1   TEXT8//' OF MATRIX '//TEXT11//'.')
      ENDIF
   10 CONTINUE
      IF(.NOT.LCM) CALL RLSARA(BASE(IXA11))
      CALL RLSARA(IBASE(IIPX))
      CALL RLSARA(IBASE(IMUX))
      IF(IDIM.EQ.1) GO TO 50
*
* DIMENSION W
      IF(CHEX) THEN
         CALL SETARA(IBASE,LL4,IMUW)
         CALL SETARA(IBASE,LL4,IIPW)
         CALL LCMGET(IPTRK,'MUW',IBASE(IMUW))
         CALL LCMGET(IPTRK,'IPW',IBASE(IIPW))
         IF(LCM) THEN
            IWA11=LCMIOF(IPSYS,'W'//TEXT11)
         ELSE
            CALL SETARA(BASE,IBASE(IMUW+LL4-1),IWA11)
            CALL LCMGET(IPSYS,'W'//TEXT11,BASE(IWA11))
         ENDIF
         DO 20 I=1,LL4
         RR=BASE(IXTT1+I-1)
         IGAR=IBASE(IMUW+IBASE(IIPW+I-1)-1)
         IF(ABS(RR-BASE(IWA11+IGAR-1)).GT.ABS(RR)*EPSMAX) THEN
            WRITE(HSMG,'(8H: DIAGX(,I6,3H )=,1P E12.4,7H DIAGW(,I6,
     1      3H )=,E12.4)') I,RR,I,BASE(IWA11+IGAR-1)
            CALL XABORT('TRICHK: W-AXIS INCONSISTENT ASSEMBLY(1)'//HSMG)
         ENDIF
   20    CONTINUE
         IF(.NOT.LCM) CALL RLSARA(BASE(IWA11))
         CALL RLSARA(IBASE(IIPW))
         CALL RLSARA(IBASE(IMUW))
      ENDIF
*
* DIMENSION Y.
      CALL SETARA(IBASE,LL4,IMUY)
      CALL SETARA(IBASE,LL4,IIPY)
      CALL LCMGET(IPTRK,'MUY',IBASE(IMUY))
      CALL LCMGET(IPTRK,'IPY',IBASE(IIPY))
      IF(LCM) THEN
         IYA11=LCMIOF(IPSYS,'Y'//TEXT11)
      ELSE
         CALL SETARA(BASE,IBASE(IMUY+LL4-1),IYA11)
         CALL LCMGET(IPSYS,'Y'//TEXT11,BASE(IYA11))
      ENDIF
      DO 30 I=1,LL4
      RR=BASE(IXTT1+I-1)
      IGAR=IBASE(IMUY+IBASE(IIPY+I-1)-1)
      IF(ABS(RR-BASE(IYA11+IGAR-1)).GT.ABS(RR)*EPSMAX) THEN
         WRITE(HSMG,'(8H: DIAGX(,I6,3H )=,1P E12.4,7H DIAGY(,I6,3H )=,
     1   E12.4)') I,RR,I,BASE(IYA11+IGAR-1)
         CALL XABORT('TRICHK: Y-AXIS INCONSISTENT ASSEMBLY(1)'//HSMG)
      ENDIF
   30 CONTINUE
      IF(.NOT.LCM) CALL RLSARA(BASE(IYA11))
      CALL RLSARA(IBASE(IIPY))
      CALL RLSARA(IBASE(IMUY))
*
* DIMENSION Z
      IF(IDIM.GT.2) THEN
         CALL SETARA(IBASE,LL4,IMUZ)
         CALL SETARA(IBASE,LL4,IIPZ)
         CALL LCMGET(IPTRK,'MUZ',IBASE(IMUZ))
         CALL LCMGET(IPTRK,'IPZ',IBASE(IIPZ))
         IF(LCM) THEN
            IZA11=LCMIOF(IPSYS,'Z'//TEXT11)
         ELSE
            CALL SETARA(BASE,IBASE(IMUZ+LL4-1),IZA11)
            CALL LCMGET(IPSYS,'Z'//TEXT11,BASE(IZA11))
         ENDIF
         DO 40 I=1,LL4
         RR=BASE(IXTT1+I-1)
         IGAR=IBASE(IMUZ+IBASE(IIPZ+I-1)-1)
         IF(ABS(RR-BASE(IZA11+IGAR-1)).GT.ABS(RR)*EPSMAX) THEN
            WRITE(HSMG,'(8H: DIAGX(,I6,3H )=,1P E12.4,7H DIAGZ(,I6,
     1      3H )=,E12.4)') I,RR,I,BASE(IZA11+IGAR-1)
            CALL XABORT('TRICHK: Z-AXIS INCONSISTENT ASSEMBLY(1)'//HSMG)
         ENDIF
   40    CONTINUE
         IF(.NOT.LCM) CALL RLSARA(BASE(IZA11))
         CALL RLSARA(IBASE(IIPZ))
         CALL RLSARA(IBASE(IMUZ))
      ENDIF
   50 CALL RLSARA(BASE(IXTT1))
      RETURN
      END
