*DECK TRIFLX
      SUBROUTINE TRIFLX(IPTRK,NEL,NUN,EVECT,MAT,VOL,IDL)
*
*-----------------------------------------------------------------------
*
* DRIVER FOR THE CALCULATION OF THE AVERAGED FLUX IN TRIVAC.
*
* INPUT PARAMETERS:
*  IPTRK  : L_TRIVAC POINTER TO THE TRIVAC TRACKING INFORMATION.
*  NEL    : TOTAL NUMBER OF FINITE ELEMENTS.
*  NUN    : TOTAL NUMBER OF UNKNOWN PER ENERGY GROUP.
*  EVECT  : VARIATIONAL COEFFICIENTS OF THE FLUX. CONTAINED IN POSITIONS
*           EVECT(1) TO EVECT(LL4). DIMENSION EVECT(NUN)
*  MAT    : MIXTURE INDEX ASSIGNED TO EACH ELEMENT. DIMENSION MAT(NEL)
*  VOL    : VOLUME OF EACH ELEMENT. DIMENSION MAT(NEL)
*  IDL    : POSITION OF THE AVERAGE FLUX COMPONENT ASSOCIATED WITH
*           EACH VOLUME. DIMENSION IDL(NEL)
*
* OUTPUT PARAMETER:
*  EVECT  : AVERAGED FLUXES. CONTAINED IN POSITIONS EVECT(IDL(I))
*           DIMENSION EVECT(NUN)
*
*------------------------------------- AUTHOR: A. HEBERT ; 08/07/86 ----
*
      LOGICAL CYLIND,CHEX
      DIMENSION EVECT(*),MAT(*),VOL(*),IDL(*),ITP(19),IBASE(1)
      COMMON BASE(1)
      EQUIVALENCE (BASE(1),IBASE(1))
*
* RECOVER TRIVAC SPECIFIC TRACKING INFORMATION.
      CALL LCMGET(IPTRK,'TPARAM',ITP)
      ITYPE=ITP(1)
      CYLIND=(ITYPE.EQ.3).OR.(ITYPE.EQ.6)
      CHEX=(ITYPE.EQ.8).OR.(ITYPE.EQ.9)
      IELEM=ITP(4)
      ICHX=ITP(6)
      ISPLH=ITP(7)
      LL4=ITP(8)
      LX=ITP(9)
      LY=ITP(10)
      LZ=ITP(11)
      CALL LCMLEN(IPTRK,'KN',MAXKN,ITYLCM)
      CALL SETARA(IBASE,MAXKN,IKN)
      CALL LCMGET(IPTRK,'KN',IBASE(IKN))
*
      IF((ICHX.EQ.1).AND.(.NOT.CHEX)) THEN
*        LAGRANGIAN FINITE ELEMENTS.
         CALL SETARA(BASE,LX*LY*LZ,IXX)
         CALL SETARA(BASE,LX*LY*LZ,IDD)
         CALL LCMGET(IPTRK,'XX',BASE(IXX))
         CALL LCMGET(IPTRK,'DD',BASE(IDD))
         CALL LCMSIX(IPTRK,'BIVCOL',1)
         CALL LCMLEN(IPTRK,'T',LC,ITYLCM)
         CALL SETARA(BASE,LC,IT)
         CALL SETARA(BASE,LC,ITS)
         CALL LCMGET(IPTRK,'T',BASE(IT))
         CALL LCMGET(IPTRK,'TS',BASE(ITS))
         CALL LCMSIX(IPTRK,' ',2)
         CALL TRIIN2(NEL,LL4,CYLIND,EVECT,BASE(IXX),BASE(IDD),MAT,VOL,
     1   IDL,IBASE(IKN),LC,BASE(IT),BASE(ITS))
         CALL RLSARA(BASE(ITS))
         CALL RLSARA(BASE(IT))
         CALL RLSARA(BASE(IDD))
         CALL RLSARA(BASE(IXX))
      ELSE IF((ICHX.EQ.1).AND.CHEX) THEN
*        MESH CORNER FINITE DIFFERENCES FOR HEXAGONAL GEOMETRY.
         CALL TRIIH2(ISPLH,NEL,EVECT,MAT,VOL,IDL,IBASE(IKN))
      ELSE IF(((ICHX.EQ.3).OR.(ICHX.EQ.4)).AND.CHEX) THEN
*        MESH CENTERED FINITE DIFFERENCES FOR HEXAGONAL GEOMETRY.
         CALL TRIIH1(ISPLH,NEL,LL4,EVECT,MAT,VOL,IDL,IBASE(IKN))
      ENDIF
*
* RELEASE TRIVAC SPECIFIC TRACKING INFORMATION.
      CALL RLSARA(IBASE(IKN))
      RETURN
      END
