*DECK TRIIH1
      SUBROUTINE TRIIH1 (ISPLH,NEL,LL4,EVECT,MAT,VOL,IDL,KN)
*
*-----------------------------------------------------------------------
*
* COMPUTE THE AVERAGED FLUX FOR A LINEAR PRIMAL FORMULATION OF THE
* DIFFUSION EQUATION IN HEXAGONAL GEOMETRY.
*
* INPUT PARAMETERS:
*  ISPLH  : =1 FOR COMPLETE HEXAGONS; .GT.1 FOR TRIANGLE MESH-SPLITTING.
*  IDIM   : NUMBER OF DIMENSIONS.
*  NEL    : TOTAL NUMBER OF FINITE ELEMENTS.
*  LL4    : ORDER OF THE SYSTEM MATRICES.
*  EVECT  : VARIATIONAL COEFFICIENTS OF THE FLUX. CONTAINED IN POSITIONS
*           EVECT(1) TO EVECT(LL4). DIMENSION EVECT(LL4+NEL)
*  MAT    : MIXTURE INDEX ASSIGNED TO EACH ELEMENT. DIMENSION MAT(NEL)
*  VOL    : VOLUME OF EACH ELEMENT. DIMENSION VOL(NEL)
*  IDL    : POSITION OF THE AVERAGE FLUX COMPONENT ASSOCIATED WITH
*           EACH VOLUME. DIMENSION IDL(NEL)
*  KN     : ELEMENT-ORDERED UNKNOWN LIST. DIMENSION KN(MAXKN) WHERE
*           MAXKN=6*(IDIM-1)*NEL                       IF ISPLH=1
*           MAXKN=(IDIM-1)*(1+ISPLH*(ISPLH-1)*3)*NEL   ELSE
*           IDIM=3
*
* OUTPUT PARAMETER:
*  EVECT  : AVERAGED FLUXES. CONTAINED IN POSITIONS EVECT(LL4+1) TO
*           EVECT(LL4+NEL). DIMENSION EVECT(LL4+NEL)
*
*------------------------------------- AUTHOR: A. HEBERT ; 23/06/93 ----
*
      DIMENSION EVECT(*),MAT(*),VOL(*),IDL(*),KN(*)
*
      IF(ISPLH.EQ.1) RETURN
      IVAL=18*(ISPLH-1)**2+8
      NUM1=0
      SS=1.0/REAL(6*(ISPLH-1)**2)
      DO 70 K=1,NEL
      IF(MAT(K).EQ.0) GO TO 70
      EVECT(IDL(K))=0.0
      IF(VOL(K).EQ.0.0) GO TO 60
      DO 50 I=1,6*(ISPLH-1)**2
      IND1=KN(NUM1+I)
      IF(IND1.EQ.0) GO TO 50
      EVECT(IDL(K))=EVECT(IDL(K))+SS*EVECT(IND1)
   50 CONTINUE
   60 NUM1=NUM1+IVAL
   70 CONTINUE
      RETURN
      END
