*DECK TRIIH2
      SUBROUTINE TRIIH2 (ISPLH,NEL,EVECT,MAT,VOL,IDL,KN)
*
*-----------------------------------------------------------------------
*
* CALCULATION OF THE AVERAGED FLUX WITH A LINEAR LAGRANGIAN FINITE
* ELEMENT OR MESH CORNER FINITE DIFFERENCE METHOD IN HEXAGONAL GEOMETRY.
*
* INPUT PARAMETERS:
*  ISPLH  : =1 FOR COMPLETE HEXAGONS; =2 FOR TRIANGULAR MESH-SPLITTING.
*  NEL    : TOTAL NUMBER OF FINITE ELEMENTS.
*  EVECT  : VARIATIONAL COEFFICIENTS OF THE FLUX. CONTAINED IN POSITIONS
*           EVECT(1) TO EVECT(LL4) WHERE LL4 IS THE ORDER OF THE SYSTEM
*           MATRICES. DIMENSION EVECT(NUN)
*  MAT    : MIXTURE INDEX ASSIGNED TO EACH ELEMENT. DIMENSION MAT(NEL)
*  VOL    : VOLUME OF EACH ELEMENT. DIMENSION MAT(NEL)
*  IDL    : POSITION OF THE AVERAGE FLUX COMPONENT ASSOCIATED WITH
*           EACH VOLUME. DIMENSION IDL(NEL)
*  KN     : ELEMENT-ORDERED UNKNOWN LIST. DIMENSION KN(14*NEL)
*
* OUTPUT PARAMETER:
*  EVECT  : AVERAGED FLUXES. CONTAINED IN POSITIONS EVECT(IDL(I))
*           DIMENSION EVECT(NUN)
*
*------------------------------------- AUTHOR: A. HEBERT ; 29/06/93 ----
*
      DIMENSION EVECT(*),MAT(*),VOL(*),IDL(*),KN(*),TH(14)
      DATA TH/3*0.055555555556,0.166666666667,6*0.055555555556,
     1 0.166666666667,3*0.055555555556/
*
      NUM1=0
      IF(ISPLH.EQ.1) THEN
         SS=1.0/12.0
         DO 40 K=1,NEL
         IF(MAT(K).EQ.0) GO TO 40
         EVECT(IDL(K))=0.0
         IF(VOL(K).EQ.0.0) GO TO 30
         DO 20 I=1,12
         IND1=KN(NUM1+I)
         IF(IND1.EQ.0) GO TO 20
         EVECT(IDL(K))=EVECT(IDL(K))+SS*EVECT(IND1)
   20    CONTINUE
   30    NUM1=NUM1+12
   40    CONTINUE
      ELSE IF(ISPLH.EQ.2) THEN
         DO 70 K=1,NEL
         IF(MAT(K).EQ.0) GO TO 70
         EVECT(IDL(K))=0.0
         IF(VOL(K).EQ.0.0) GO TO 60
         DO 50 I=1,14
         IND1=KN(NUM1+I)
         IF(IND1.EQ.0) GO TO 50
         EVECT(IDL(K))=EVECT(IDL(K))+TH(I)*EVECT(IND1)
   50    CONTINUE
   60    NUM1=NUM1+14
   70    CONTINUE
      ENDIF
      RETURN
      END
