*DECK TRIMTD
      SUBROUTINE TRIMTD(ISPLH,NEL,VOL,MAT,SGD,KN,IPW,VEC)
*
*-----------------------------------------------------------------------
*
* ASSEMBLY OF A DIAGONAL SYSTEM MATRIX FOR A MESH CENTERED FINITE DIF-
* FERENCE DISCRETIZATION IN HEXAGONAL GEOMETRY (TRIANGULAR SUB MESHS).
*
* INPUT PARAMETERS:
*  ISPLH  : THE NUMBER OF TRIANGLES IS 6*(ISPLH-1)**2.
*  NEL    : TOTAL NUMBER OF FINITE ELEMENTS.
*  VOL    : VOLUME OF EACH ELEMENT. DIMENSION VOL(NEL)
*  MAT    : MIXTURE INDEX ASSIGNED TO EACH HEXAGON. DIMENSION MAT(NEL)
*  SGD    : NUCLEAR PROPERTIES PER MATERIAL MIXTURES.
*           DIMENSION SGD(IR)
*  KN     : ELEMENT-ORDERED UNKNOWN LIST. DIMENSION KN(8*NEL)
*  IPW    : PERMUTATION MATRICES. DIMENSION IPW(LL4)
*
* OUTPUT PARAMETERS:
*  VEC    : DIAGONAL SYSTEM MATRIX. DIMENSION VEC(LL4)
*
* NOTE: SYSTEM MATRIX SHOULD BE INITIALIZED BY THE CALLING PROGRAM.
*
*----------------------------------- AUTHOR: A. BENABOUD ; 04/12/90 ----
*
      DIMENSION SGD(*),VOL(*),MAT(*),KN(*),IPW(*),VEC(*)
*
* ASSEMBLY OF DIAGONAL MATRIX VEC.
      NUM1 = 0
      NTPH = 6 * (ISPLH-1)**2
      NTPL = 1 + 2 * (ISPLH-1)
      NVT1 = NTPL + 2 * (ISPLH-2) + NTPH / 2
      NVT2 = NTPH - NTPL - (ISPLH-4) * (NTPL+2)
      NVT3 = NTPH - (ISPLH-4) * NTPL
      IVAL = 3*NTPH+8
      IF(ISPLH.EQ.3) NVT2 = NTPH
      IF(ISPLH.LE.3) ISAU =   2*(ISPLH-2)
      IF(ISPLH.GE.4) ISAU =   6*(ISPLH-3)
      ICR = ISAU*(1+2*(ISPLH-2))
      DO 40 K=1,NEL
         L = MAT(K)
         IF(L.EQ.0) GO TO 40
         VOL0 = VOL(K)/NTPH
         IF(VOL0.EQ.0.0) GO TO 30
         DO 20 I = 1,NTPH
*
            CALL TRINEI (3,1,1,ISPLH,ICR,I,KK1,KK2,KK3,KEL,IQF,NUM1,
     >                   NTPH,NTPL,NVT1,NVT2,NVT3,IVAL,KN)
*
            IND1=IPW(KEL)
            VEC(IND1)=VEC(IND1)+SGD(L)*VOL0
   20    CONTINUE
   30    NUM1=NUM1+IVAL
   40 CONTINUE
      RETURN
      END
