*DECK TRIPER
      SUBROUTINE TRIPER (JP,IDIR,IRR,LX,LT4,IP,IENV)
*
*-----------------------------------------------------------------------
*
* COMPUTE THE PERMUTATION VECTORS IN 2-D HEXAGONAL GEOMETRY.
*
* INPUT PARAMETERS:
*  JP     : FIRST INDEX.
*  IDIR   : CHOICE OF DIRECTION (=1: W AXIS ; =2: X AXIS ; =3: Y AXIS).
*  IRR    : INDEX OF THE MATERIAL MIXTURE CORRESPONDING TO EACH HEXAGON.
*           DIMENSION IRR(LX)
*  LX     : NUMBER OF HEXAGONS, INCLUDING VIRTUAL HEXAGONS.
*  LT4    : NUMBER OF NON VIRTUAL HEXAGONS.
*
* OUTPUT PARAMETER:
*  IP     : PERMUTATION VECTOR. DIMENSION IP(LX)
*
*----------------------------------- AUTHOR : A. BENABOUD ; 23/11/90 ___
*
      LOGICAL LPAS
      INTEGER IP(*),IRR(*),IENV(*)
      LPAS = .TRUE.
      DO 10 I=1,LT4
 10   IP(I)=0
      NC = INT((SQRT(REAL((4*LX-1)/3))+1.)/2.)
      IF(IDIR.EQ.1) THEN
         IFACE1 = 3
         IFACE2 = 5
         IFACE3 = 4
      ELSE IF(IDIR.EQ.2) THEN
         IFACE1 = 4
         IFACE2 = 6
         IFACE3 = 5
      ELSE IF(IDIR.EQ.3) THEN
         IFACE1 = 5
         IFACE2 = 1
         IFACE3 = 6
      ELSE
         CALL XABORT ('TRIPER: INVALID DATA')
      ENDIF
      JI = JP
      JS = JP
      KEL = 0
      M = JI + 1
      IF(IRR(JI).GT.0) THEN
         IP(IENV(JI)) = 1
         KEL = KEL + 1
      ENDIF
      IC = JP + NC - 1
 20   IF(KEL.EQ.LT4) RETURN
      IF(JI.EQ.IC) IFACE2 = IDIR + 3
 30   IF(M.LE.LX) THEN
         IF(IRR(M).GT.0) THEN
            KEL = KEL + 1
            IP(IENV(M)) = KEL
         ENDIF
         JI = M
         M = NEIGHB (JI,IFACE1,9,LX,POIDS)
         GOTO 30
      ELSE
 40      JI = NEIGHB (JS,IFACE2,9,LX,POIDS)
         IF(JI.GT.LX.AND.LPAS) THEN
            IFACE2 = IFACE3
            LPAS = .FALSE.
            GO TO 40
         ENDIF
         M  = JI
         JS = JI
         GOTO 20
      ENDIF
      END
