*DECK TRIVAA
      SUBROUTINE TRIVAA(NENTRY,HENTRY,IENTRY,JENTRY,KENTRY)
*
*-----------------------------------------------------------------------
*
* TRIVAC TYPE (3-D/ADI) SYSTEM MATRIX ASSEMBLY MODULE.
*
* INPUT/OUTPUT PARAMETERS:
*  NENTRY : NUMBER OF LINKED LISTS OR FILES USED BY THE MODULE.
*  HENTRY : CHARACTER*12 NAME OF EACH LINKED LIST OR FILE.
*  IENTRY : =1 LINKED LIST; =2 XSM FILE; =3 SEQUENTIAL BINARY FILE;
*           =4 SEQUENTIAL ASCII FILE.
*  JENTRY : =0 THE LINKED LIST OR FILE IS CREATED.
*           =1 THE LINKED LIST OR FILE IS OPEN FOR MODIFICATIONS;
*           =2 THE LINKED LIST OR FILE IS OPEN IN READ-ONLY MODE.
*  KENTRY : =FILE UNIT NUMBER; =LINKED LIST ADDRESS OTHERWISE.
*           DIMENSION HENTRY(NENTRY),IENTRY(NENTRY),JENTRY(NENTRY),
*           KENTRY(NENTRY)
*
* LINKED LIST / XSM FILE:
*  HENTRY(1) : CREATE OR MODIFICATION TYPE(L_SYSTEM).
*  HENTRY(2) : READ-ONLY TYPE(L_MACROLIB) (UNPERTURBED)
*  HENTRY(3) : READ-ONLY LINKED LIST TYPE(L_TRIVAC)
*  HENTRY(4) : OPTIONAL READ-ONLY TYPE(L_MACROLIB) (PERTURBED)
*
*-------------------------------------- AUTHOR: A. HEBERT ; 09/12/93 ---
*
      CHARACTER HENTRY(*)*12,TEXT4*4,TEXT11*12,TEXT12*12,HSMG*131,
     1 TITLE*72,CGRPNM*12
      DOUBLE PRECISION DFLOTT
      DIMENSION IENTRY(*),JENTRY(*),KENTRY(*),IGP(4),IPAR(7),IBASE(1),
     1 KCHAR(18)
      COMMON BASE(1)
      EQUIVALENCE (BASE(1),IBASE(1))
*
* PARAMETER VALIDATION.
      IF(NENTRY.LE.2) CALL XABORT('TRIVAA: THREE PARAMETERS EXPECTED.')
      IF((IENTRY(1).NE.1).AND.(IENTRY(1).NE.2)) CALL XABORT('TRIVAA: LI'
     1 //'NKED LIST OR XSM FILE EXPECTED AT LHS.')
      IF((JENTRY(1).NE.0).AND.(JENTRY(1).NE.1)) CALL XABORT('TRIVAA: EN'
     1 //'TRY IN CREATE OR MODIFICATION MODE EXPECTED.')
      IF((JENTRY(3).NE.2).OR.((IENTRY(3).NE.1).AND.(IENTRY(3).NE.2)))
     1 CALL XABORT('TRIVAA: LINKED LIST OR XSM FILE IN READ-ONLY MODE E'
     2 //'XPECTED AT FIRST RHS.')
      IF((JENTRY(2).NE.2).OR.((IENTRY(2).NE.1).AND.(IENTRY(2).NE.2)))
     1 CALL XABORT('TRIVAA: LINKED LIST OR XSM FILE IN READ-ONLY MODE E'
     2 //'XPECTED AT SECOND RHS.')
      CALL LCMGET(KENTRY(3),'SIGNATURE',KCHAR)
      WRITE(TEXT11,'(3A4)') (KCHAR(I),I=1,3)
      IF(TEXT11.NE.'L_TRIVAC') THEN
         TEXT12=HENTRY(3)
         CALL XABORT('TRIVAA: SIGNATURE OF '//TEXT12//' IS '//TEXT11//
     1   '. L_TRIVAC EXPECTED.')
      ENDIF
      TEXT11='L_SYSTEM'
      IPSYS=KENTRY(1)
      READ(TEXT11,'(3A4)') (KCHAR(I),I=1,3)
      CALL LCMPUT(IPSYS,'SIGNATURE',3,3,KCHAR)
      IPMACR=KENTRY(2)
      IPTRK=KENTRY(3)
*
* RECOVER GENERAL TRACKING INFORMATION.
      CALL LCMGET(IPTRK,'GPARAM',IGP)
      NEL=IGP(1)
      NUN=IGP(2)
      CALL SETARA(IBASE,NEL,IMAT)
      CALL SETARA(BASE,NEL,IVOL)
      CALL SETARA(IBASE,NEL,IIDL)
      CALL LCMGET(IPTRK,'MATCOD',IBASE(IMAT))
      CALL LCMGET(IPTRK,'VOLUME',BASE(IVOL))
      CALL LCMGET(IPTRK,'KEYFLX',IBASE(IIDL))
      CALL LCMLEN(IPTRK,'TITLE',LENGT,ITYLCM)
      IF(LENGT.GT.0) THEN
         CALL LCMGET(IPTRK,'TITLE',KCHAR)
         WRITE(TITLE,'(18A4)') (KCHAR(I),I=1,18)
      ELSE
         TITLE='*** NO TITLE PROVIDED ***'
      ENDIF
*
* RECOVER MACROLIB PARAMETERS.
      CALL LCMGET(IPMACR,'SIGNATURE',KCHAR)
      WRITE(TEXT11,'(3A4)') (KCHAR(I),I=1,3)
      IF(TEXT11.NE.'L_MACROLIB') THEN
         TEXT12=HENTRY(2)
         CALL XABORT('TRIVAA: SIGNATURE OF '//TEXT12//' IS '//TEXT11//
     1   '. L_MACROLIB EXPECTED.')
      ENDIF
      CALL LCMGET(IPMACR,'IDATAXS',IPAR)
      NGRP=IPAR(1)
      MAXMIX=IPAR(2)
      NDG=IPAR(7)
      IF(IGP(4).GT.MAXMIX) THEN
         WRITE(HSMG,'(46HTRIVAA: THE NUMBER OF MIXTURES IN THE TRACKING,
     1   2H (,I5,51H) IS GREATER THAN THE NUMBER OF MIXTURES IN THE MAC,
     2   7HROLIB (,I5,2H).)') IGP(4),MAXMIX
         CALL XABORT(HSMG)
      ELSE IF(IPAR(4).NE.1) THEN
         CALL XABORT('TRIVAA: IDATAXS(4) EXPECTED EQUAL TO 1.')
      ENDIF
*
      IMPX=1
      IASM=0
      IPR=0
   10 CALL REDGET(INDIC,NITMA,FLOTT,TEXT4,DFLOTT)
      IF(INDIC.EQ.10) GO TO 30
      IF(INDIC.NE.3) CALL XABORT('TRIVAA: CHARACTER DATA EXPECTED.')
      IF(TEXT4.EQ.'EDIT') THEN
         CALL REDGET(INDIC,IMPX,FLOTT,TEXT4,DFLOTT)
         IF(INDIC.NE.1) CALL XABORT('TRIVAA: INTEGER DATA EXPECTED(1).')
      ELSE IF(TEXT4.EQ.'SKIP') THEN
*        OPTION TO SKIP THE SYSTEM MATRIX ASSEMBLY (DO NOT SKIP THE
*        LDLT FACTORIZATION).
         IASM=1
      ELSE IF(TEXT4.EQ.'DERI') THEN
         IPR=1
         WRITE(6,'(/43H TRIVAA: USE DERIVATIVE OF SYSTEM MATRICES.)')
      ELSE IF(TEXT4.EQ.'PERT') THEN
         IPR=2
         WRITE(6,'(/41H TRIVAA: PERTURBATION OF SYSTEM MATRICES.)')
      ELSE IF(TEXT4.EQ.'UNIT') THEN
*       COMPUTE THE UNITARY WEIGHTING MATRIX.
        CALL SETARA(BASE,MAXMIX,IUN)
        DO 20 I=1,MAXMIX
   20   BASE(IUN+I-1)=1.0
        CALL TRIDIG('RM',IPTRK,IPSYS,IMPX,NEL,NUN,0,IBASE(IMAT),
     1  BASE(IVOL),IBASE(IIDL),BASE(IUN))
        CALL RLSARA(BASE(IUN))
      ELSE IF(TEXT4.EQ.'OVEL') THEN
*     COMPUTE THE RECIPROCAL NEUTRON VELOCITIES MATRIX.
         DO 105 IGR=1,NGRP
         CALL SETARA(BASE,MAXMIX,IVII)
         WRITE (CGRPNM,'(5HGROUP,I3,1H/,I3)') IGR,NGRP
         CALL LCMSIX(IPMACR,CGRPNM,1)
         CALL LCMLEN(IPMACR,'OVERV',NBMIX,ITYLCM)
         IF(NBMIX.EQ.0) THEN
            CALL XABORT('TRIVAA: NO ''VELOCITY'' INFORMATION.')
         ELSE IF(NBMIX.GT.MAXMIX) THEN
            CALL XABORT('TRIVAA: INVALID LENGTH FOR ''VELOCITY'' IN'
     1      //'FORMATION.')
         ENDIF
         CALL LCMGET(IPMACR,'OVERV',BASE(IVII))
         CALL LCMSIX(IPMACR,' ',2)
         WRITE (CGRPNM,'(1HV,2I3)') IGR,IGR
         CALL TRIDIG(CGRPNM,IPTRK,IPSYS,IMPX,NEL,NUN,0,IBASE(IMAT),
     1   BASE(IVOL),IBASE(IIDL),BASE(IVII))
         CALL RLSARA(BASE(IVII))
  105    CONTINUE
      ELSE IF(TEXT4.EQ.';') THEN
         GO TO 30
      ELSE
         CALL XABORT('TRIVAA: '//TEXT4//' IS AN INVALID KEY WORD.')
      ENDIF
      GO TO 10
   30 IF(IPR.GT.0) THEN
         IF(NENTRY.LE.3) CALL XABORT('TRIVAA: 4 PARAMETERS EXPECTED WIT'
     1   //'H DERI OR PERT OPTIONS.')
         IF((JENTRY(4).NE.2).OR.((IENTRY(4).NE.1).AND.(IENTRY(4).NE.2)))
     1   CALL XABORT('TRIVAA: LINKED LIST OR XSM FILE IN READ-ONLY MODE'
     2   //' EXPECTED AT THIRD RHS.')
         IPMACP=KENTRY(4)
         CALL LCMGET(IPMACP,'SIGNATURE',KCHAR)
         WRITE(TEXT11,'(3A4)') (KCHAR(I),I=1,3)
         IF(TEXT11.NE.'L_MACROLIB') THEN
            TEXT12=HENTRY(4)
            CALL XABORT('TRIVAA: SIGNATURE OF '//TEXT12//' IS '
     1      //TEXT11//'. L_MACROLIB EXPECTED.')
         ENDIF
         CALL LCMGET(IPMACP,'IDATAXS',IPAR)
         IF((IPAR(1).NE.NGRP).OR.(IPAR(2).GT.MAXMIX)) THEN
            WRITE(HSMG,'(43HTRIVAA: INCONSISTENT PERTURBATION MACROLIB ,
     1      1H'',A12,8H''. NGRP=,2I5,8H MAXMIX=,2I9)') HENTRY(4),
     2      IPAR(1),NGRP,IPAR(2),MAXMIX
            CALL XABORT(HSMG)
         ENDIF
      ENDIF
*
* SYSTEM MATRIX ASSEMBLY.
      IF((IASM.EQ.0).AND.(IPR.EQ.0)) THEN
         CALL SETARA(BASE,MAXMIX*4,ISGD)
         CALL SETARA(BASE,MAXMIX*NGRP,IWORK)
         CALL SETARA(BASE,MAXMIX,IIJJ)
         CALL SETARA(BASE,MAXMIX,INJJ)
         CALL SETARA(BASE,MAXMIX,IIPOS)
         CALL TRISYS (IPTRK,IPMACR,IPMACR,IPSYS,IMPX,NGRP,NEL,NUN,IPR,
     1   IBASE(IMAT),BASE(IVOL),IBASE(IIDL),TITLE,MAXMIX,BASE(ISGD),
     2   BASE(ISGD),BASE(IWORK),BASE(IIJJ),BASE(INJJ),BASE(IIPOS),NDG)
         CALL RLSARA(BASE(IIPOS))
         CALL RLSARA(BASE(INJJ))
         CALL RLSARA(BASE(IIJJ))
         CALL RLSARA(BASE(IWORK))
         CALL RLSARA(BASE(ISGD))
      ELSE IF((IASM.EQ.1).AND.(IPR.EQ.0)) THEN
*        PERFORM FACTORIZATION WITHOUT ASSEMBLY.
         DO 40 I=1,NGRP
         WRITE(TEXT11,'(1HA,2I3)') I,I
         CALL MTLDLF(TEXT11,IPTRK,IPSYS,IMPX)
   40    CONTINUE
      ELSE IF(IPR.GT.0) THEN
*        ASSEMBLY OF PERTURBED SYSTEM MATRICES.
         WRITE (CGRPNM,'(8HGROUP  1,1H/,I3)') NGRP
         CALL LCMLEN(IPMACP,CGRPNM,LSTEP,ITYLCM)
         ISTEP=0
   50    IF(LSTEP.EQ.0) THEN
            ISTEP=ISTEP+1
            WRITE(TEXT12,'(4HSTEP,I8)') ISTEP
            CALL LCMLEN(IPMACP,TEXT12,LONG,ITYLCM)
            IF((LONG.EQ.0).AND.(ISTEP.EQ.1)) CALL XABORT('TRIVAA: UNAB'
     1      //'LE TO STEP ON A GROUP OR PERTURBATION DIRECTORY.')
            IF(LONG.EQ.0) GO TO 60
            IF(IMPX.GT.0) WRITE(6,'(/31H TRIVAA: STEP ON PERTURBATION D,
     1      10HIRECTORY '',A12,2H''.)') TEXT12
            CALL LCMSIX(IPSYS,TEXT12,1)
            CALL LCMSIX(IPMACP,TEXT12,1)
         ENDIF
         CALL SETARA(BASE,MAXMIX*4,ISGD)
         CALL SETARA(BASE,MAXMIX*4,IDSGD)
         CALL SETARA(BASE,MAXMIX*NGRP,IWORK)
         CALL SETARA(BASE,MAXMIX,IIJJ)
         CALL SETARA(BASE,MAXMIX,INJJ)
         CALL SETARA(BASE,MAXMIX,IIPOS)
         CALL TRISYS (IPTRK,IPMACR,IPMACP,IPSYS,IMPX,NGRP,NEL,NUN,IPR,
     1   IBASE(IMAT),BASE(IVOL),IBASE(IIDL),TITLE,MAXMIX,BASE(ISGD),
     2   BASE(IDSGD),BASE(IWORK),BASE(IIJJ),BASE(INJJ),BASE(IIPOS),NDG)
         CALL RLSARA(BASE(IIPOS))
         CALL RLSARA(BASE(INJJ))
         CALL RLSARA(BASE(IIJJ))
         CALL RLSARA(BASE(IWORK))
         CALL RLSARA(BASE(IDSGD))
         CALL RLSARA(BASE(ISGD))
         IF(LSTEP.EQ.0) THEN
            CALL LCMSIX(IPSYS,' ',0)
            CALL LCMSIX(IPMACP,' ',0)
            GO TO 50
         ENDIF
      ELSE
         CALL XABORT('TRIVAA: INVALID REQUEST.')
      ENDIF
*
   60 IF(IMPX.GE.3) CALL LCMLIB(IPSYS)
*
* RELEASE GENERAL TRACKING INFORMATION.
      CALL RLSARA(IBASE(IIDL))
      CALL RLSARA(BASE(IVOL))
      CALL RLSARA(IBASE(IMAT))
      RETURN
      END
