*DECK TRIVAT
      SUBROUTINE TRIVAT(NENTRY,HENTRY,IENTRY,JENTRY,KENTRY)
*
*-----------------------------------------------------------------------
*
* TRIVAC TYPE (3-D AND ADI) TRACKING MODULE.
*
* INPUT/OUTPUT PARAMETERS:
*  NENTRY : NUMBER OF LINKED LISTS OR FILES USED BY THE MODULE.
*  HENTRY : CHARACTER*12 NAME OF EACH LINKED LIST OR FILE.
*  IENTRY : =1 LINKED LIST; =2 XSM FILE; =3 SEQUENTIAL BINARY FILE;
*           =4 SEQUENTIAL ASCII FILE.
*  JENTRY : =0 THE LINKED LIST OR FILE IS CREATED.
*           =1 THE LINKED LIST OR FILE IS OPEN FOR MODIFICATIONS;
*           =2 THE LINKED LIST OR FILE IS OPEN IN READ-ONLY MODE.
*  KENTRY : =FILE UNIT NUMBER; =LINKED LIST ADDRESS OTHERWISE.
*           DIMENSION HENTRY(NENTRY),IENTRY(NENTRY),JENTRY(NENTRY),
*           KENTRY(NENTRY)
*
* LINKED LIST / XSM FILE:
*  HENTRY(1) : CREATE OR MODIFICATION TYPE(L_TRIVAC).
*  HENTRY(2) : READ-ONLY TYPE(L_GEOM)
*
*-------------------------------------- AUTHOR: A. HEBERT ; 01/12/93 ---
*
      CHARACTER HENTRY(*)*12,TEXT4*4,TEXT12*12,TITLE*72,HSIGN*12
      DOUBLE PRECISION DFLOTT
      LOGICAL LOG
      DIMENSION IENTRY(*),JENTRY(*),KENTRY(*),ITITL(18),IGP(4),ITP(19),
     1 ISTATE(13),KCHAR(3),NCODE(6)
      COMMON BASE(1)
*
* PARAMETER VALIDATION.
      IF(NENTRY.LE.1) CALL XABORT('TRIVAT: TWO PARAMETERS EXPECTED.')
      IF(IENTRY(1).NE.1) CALL XABORT('TRIVAT: LINKED LIST EXPECTED AT L'
     1 //'HS.')
      IF((JENTRY(1).NE.0).AND.(JENTRY(1).NE.1)) CALL XABORT('TRIVAT: EN'
     1 //'TRY IN CREATE OR MODIFICATION MODE EXPECTED.')
      IF((JENTRY(2).NE.2).OR.((IENTRY(2).NE.1).AND.(IENTRY(2).NE.2)))
     1 CALL XABORT('TRIVAT: LINKED LIST OR XSM FILE IN READ-ONLY MODE E'
     2 //'XPECTED AT RHS.')
      CALL LCMGET(KENTRY(2),'SIGNATURE',KCHAR)
      WRITE(HSIGN,'(3A4)') (KCHAR(I),I=1,3)
      IF(HSIGN.NE.'L_GEOM') THEN
         TEXT12=HENTRY(2)
         CALL XABORT('TRIVAT: SIGNATURE OF '//TEXT12//' IS '//HSIGN//
     1   '. L_GEOM EXPECTED.')
      ENDIF
      HSIGN='L_TRIVAC'
      READ(HSIGN,'(3A4)') (KCHAR(I),I=1,3)
      CALL LCMPUT(KENTRY(1),'SIGNATURE',3,3,KCHAR)
      CALL LCMGET(KENTRY(2),'STATE',ISTATE)
      ITYPE=ISTATE(1)
*
      IMPX=1
      IF(JENTRY(1).EQ.0) THEN
         TITLE=' '
         MAXPTS=ISTATE(6)
         IELEM=1
         ICOL=2
         ICHX=3
         ISPLH=1
         ISEG=0
         IMPV=1
         CALL LCMGET(KENTRY(2),'NCODE',NCODE)
         LOG=.FALSE.
         DO 10 I=1,6
   10    LOG=LOG.OR.(NCODE(I).EQ.3)
         IF(LOG) MAXPTS=2*MAXPTS
      ELSE IF(JENTRY(1).EQ.1) THEN
         CALL LCMGET(KENTRY(1),'SIGNATURE',KCHAR)
         WRITE(HSIGN,'(3A4)') (KCHAR(I),I=1,3)
         IF(HSIGN.NE.'L_TRIVAC') THEN
            TEXT12=HENTRY(1)
            CALL XABORT('TRIVAT: SIGNATURE OF '//TEXT12//' IS '//HSIGN//
     1      '. L_TRIVAC EXPECTED.')
         ENDIF
         CALL LCMGET(KENTRY(1),'GPARAM',IGP)
         CALL LCMGET(KENTRY(1),'TPARAM',ITP)
         MAXPTS=IGP(1)
         IELEM=ITP(4)
         ICOL=ITP(5)
         ICHX=ITP(6)
         ISPLH=ITP(7)
         ISEG=ITP(12)
         IMPV=ITP(13)
      ENDIF
   15 CALL REDGET(INDIC,NITMA,FLOTT,TEXT4,DFLOTT)
      IF(INDIC.EQ.10) GO TO 30
   20 IF(INDIC.NE.3) CALL XABORT('TRIVAT: CHARACTER DATA EXPECTED.')
      IF(TEXT4.EQ.'EDIT') THEN
         CALL REDGET(INDIC,IMPX,FLOTT,TEXT4,DFLOTT)
         IF(INDIC.NE.1) CALL XABORT('TRIVAT: INTEGER DATA EXPECTED(1).')
      ELSE IF(TEXT4.EQ.'TITL') THEN
         CALL REDGET(INDIC,NITMA,FLOTT,TITLE,DFLOTT)
         IF(INDIC.NE.3) CALL XABORT('TRIVAT: TITLE EXPECTED.')
      ELSE IF(TEXT4.EQ.'MAXR') THEN
         CALL REDGET(INDIC,MAXPTS,FLOTT,TEXT4,DFLOTT)
         IF(INDIC.NE.1) CALL XABORT('TRIVAT: INTEGER DATA EXPECTED(2).')
      ELSE IF(TEXT4.EQ.'PRIM') THEN
*        MESH CORNER FINITE DIFFERENCES OR PRIMAL FINITE ELEMENTS.
         IELEM=1
         ICHX=1
         CALL REDGET(INDIC,NITMA,FLOTT,TEXT4,DFLOTT)
         IF(INDIC.EQ.1) THEN
            IELEM=NITMA
         ELSE
            GO TO 20
         ENDIF
         IF((ITYPE.EQ.8).OR.(ITYPE.EQ.9)) THEN
            CALL REDGET(INDIC,ISPLH,FLOTT,TEXT4,DFLOTT)
            IF(INDIC.NE.1) CALL XABORT('TRIVAT: INTEGER DATA EXPECTED.')
         ENDIF
      ELSE IF(TEXT4.EQ.'DUAL') THEN
*        MESH CENTERED FINITE DIFFERENCES OR MIXED-DUAL FINITE ELEMENTS.
         IELEM=1
         ICOL=2
         ICHX=2
         CALL REDGET(INDIC,NITMA,FLOTT,TEXT4,DFLOTT)
         IF(INDIC.EQ.1) THEN
            IELEM=NITMA
            CALL REDGET(INDIC,ICOL,FLOTT,TEXT4,DFLOTT)
            IF(INDIC.NE.1) CALL XABORT('TRIVAT: INTEGER DATA EXPECTED.')
         ELSE
            GO TO 20
         ENDIF
         IF((ITYPE.EQ.8).OR.(ITYPE.EQ.9)) THEN
            CALL REDGET(INDIC,ISPLH,FLOTT,TEXT4,DFLOTT)
            IF(INDIC.NE.1) CALL XABORT('TRIVAT: INTEGER DATA EXPECTED.')
         ENDIF
      ELSE IF(TEXT4.EQ.'MCFD') THEN
*        MESH CENTERED FINITE DIFFERENCES OR NODAL COLLOCATION.
         IELEM=1
         ICHX=3
         CALL REDGET(INDIC,NITMA,FLOTT,TEXT4,DFLOTT)
         IF(INDIC.EQ.1) THEN
            IELEM=NITMA
         ELSE
            GO TO 20
         ENDIF
         IF((ITYPE.EQ.8).OR.(ITYPE.EQ.9)) THEN
            CALL REDGET(INDIC,ISPLH,FLOTT,TEXT4,DFLOTT)
            IF(INDIC.NE.1) CALL XABORT('TRIVAT: INTEGER DATA EXPECTED.')
         ENDIF
      ELSE IF(TEXT4.EQ.'LUMP') THEN
*        NODAL COLLOCATION WITH SERENDIPITY APPROXIMATION.
         IELEM=1
         ICHX=4
         CALL REDGET(INDIC,NITMA,FLOTT,TEXT4,DFLOTT)
         IF(INDIC.EQ.1) THEN
            IELEM=NITMA
         ELSE
            GO TO 20
         ENDIF
         IF((ITYPE.EQ.8).OR.(ITYPE.EQ.9)) THEN
            CALL REDGET(INDIC,ISPLH,FLOTT,TEXT4,DFLOTT)
            IF(INDIC.NE.1) CALL XABORT('TRIVAT: INTEGER DATA EXPECTED.')
         ENDIF
      ELSE IF(TEXT4.EQ.'VECT') THEN
         ISEG=64
         CALL REDGET(INDIC,ISEG,FLOTT,TEXT4,DFLOTT)
         IF(INDIC.NE.1) GO TO 20
         IF(MOD(ISEG,64).NE.0) WRITE(6,'(/25H TRIVAT: ***WARNING*** IS,
     1   27HEG IS NOT A MULTIPLE OF 64.)')
      ELSE IF(TEXT4.EQ.'PRTV') THEN
         CALL REDGET(INDIC,IMPV,FLOTT,TEXT4,DFLOTT)
         IF(INDIC.NE.1) CALL XABORT('TRIVAT: INTEGER DATA EXPECTED.')
      ELSE IF(TEXT4.EQ.';') THEN
         GO TO 30
      ELSE
         CALL XABORT('TRIVAT: '//TEXT4//' IS AN INVALID KEY WORD.')
      ENDIF
      GO TO 15
*
   30 IF(TITLE.NE.' ') THEN
         READ(TITLE,'(18A4)') (ITITL(I),I=1,18)
         CALL LCMPUT(KENTRY(1),'TITLE',18,3,ITITL)
      ENDIF
      IF(IMPX.GT.1) WRITE(6,100) TITLE
*
      IF(MAXPTS.EQ.0) CALL XABORT('TRIVAT: MAXPTS NOT DEFINED.')
      CALL SETARA(BASE,MAXPTS,IMAT)
      CALL SETARA(BASE,MAXPTS,IVOL)
      CALL SETARA(BASE,MAXPTS,IIDL)
      CALL TRITRK (MAXPTS,KENTRY(1),KENTRY(2),IMPX,IELEM,ICOL,ICHX,
     1 ISPLH,ISEG,IMPV,BASE(IMAT),BASE(IVOL),BASE(IIDL))
      CALL RLSARA(BASE(IIDL))
      CALL RLSARA(BASE(IVOL))
      CALL RLSARA(BASE(IMAT))
      RETURN
*
  100 FORMAT(1H1,45HTTTTTTTT RRRRRR  IIIIII VV  VV   AA    CCCCC ,
     1 85(1H*)/47H TTTTTTTT RRRRRRR IIIIII VV  VV  AAAA  CCCCCCC ,
     2 46(1H*),38H MULTIGROUP VERSION.  A. HEBERT (1993)/
     3 46H    TT    RR   RR   II   VV  VV  AAAA  CC   CC/
     4 46H    TT    RRRRR     II   VV  VV AA  AA CC     /
     5 46H    TT    RRRRR     II   VV  VV AAAAAA CC     /
     6 46H    TT    RR RR     II   VV  VV AAAAAA CC   CC/
     7 46H    TT    RR  RR  IIIIII  VVVV  AA  AA CCCCCCC/
     8 46H    TT    RR   RR IIIIII   VV   AA  AA  CCCCC //1X,A72//)
      END
