*DECK USPLIT
      SUBROUTINE USPLIT(NENTRY,HENTRY,IENTRY,JENTRY,KENTRY)
*
*-----------------------------------------------------------------------
*
*     THIS MODULE VERIFIES AND TREATS THE GEOMETRY PREVIOUSLY
*     CREATED AND CONSTRUCTS AN MATERIAL MIXTURE INDEX.
*
*     CE MODULE DECOMPOSE LA GEOMETRIE SELON LE DECOUPAGE DES
*     ZONES DONNE PAR LE MODULE GEO:, IL CONSTRUIT
*     EGALEMENT L'INDEX DES MATERIAUX DES ZONES.
*
*     INPUT/OUTPUT PARAMETERS:
*      NENTRY : NUMBER OF LINKED LISTS OR FILES USED BY THE MODULE.
*      HENTRY : CHARACTER*12 NAME OF EACH LINKED LIST OR FILE.
*      IENTRY : =1 LINKED LIST; =2 XSM FILE; =3 SEQUENTIAL BINARY FILE;
*               =4 SEQUENTIAL ASCII FILE.
*      JENTRY : =0 THE LINKED LIST OR FILE IS CREATED.
*               =1 THE LINKED LIST OR FILE IS OPEN FOR MODIFICATIONS;
*               =2 THE LINKED LIST OR FILE IS OPEN IN READ-ONLY MODE.
*      KENTRY : =FILE UNIT NUMBER; =LINKED LIST ADDRESS OTHERWISE.
*
*      DIMENSION HENTRY(NENTRY),IENTRY(NENTRY),JENTRY(NENTRY),
*                KENTRY(NENTRY)
*
*     REQUIRED LINKED LISTS ARE:
*        KENTRY(1) : OBJECT TYPE L_GEOM IN CREATION MODE
*        KENTRY(2) : OBJECT TYPE L_INDEX IN CREATION MODE
*        KENTRY(3) : OBJECT TYPE L_GEOM IN READ ONLY MODE
*
*     PROCEDURES CALLED:  READ3D
*
*-------------------------------------- AUTHOR: J. KOCLAS ; 10/03/94 ---
*                                               E. VARIN
*
      PARAMETER (MAXCOD=8,MAXHEX=9,MAXTYP=9)
      CHARACTER HENTRY(*)*12,TEXT12*12,HSIGN*12
      DIMENSION IENTRY(*),JENTRY(*),KENTRY(*)
      DOUBLE PRECISION DFLOTT
      INTEGER  CPT,IPGEO2,IPIND,IPGEOM,ITYPE,LX,LY,LZ,KCHAR(3),ISIZE(2)
      DIMENSION ISTATE(13),NCODE(6),ZCODE(6),ICODE(6),IBASE(1)
      COMMON BASE(1)
      EQUIVALENCE (BASE(1),IBASE(1))
*
* PARAMETER VALIDATION.
*
      IF(NENTRY.LT.3) CALL XABORT('USPLIT: PARAMETER EXPECTED.')
      IF((IENTRY(1).NE.1).AND.(IENTRY(1).NE.2)) CALL XABORT('USPL'
     + //'IT: LINKED LIST OR XSM FILE EXPECTED AT LHS.')
      IF((IENTRY(2).NE.1).AND.(IENTRY(2).NE.2)) CALL XABORT('USPL'
     + //'IT: LINKED LIST OR XSM FILE EXPECTED AT LHS.')
      IF(JENTRY(1).NE.0) CALL XABORT('USPL'
     + //'IT: CREATE MODE EXPECTED.')
      IF(JENTRY(2).NE.0) CALL XABORT('USPL'
     + //'IT: CREATE MODE EXPECTED.')
      IF(JENTRY(3).NE.2) CALL XABORT('USPLIT: READ-ONL'
     +  //'Y MODE EXPECTED.')
*
*     VERIFICATION OBJECT TYPES WITH SIGNATURE
*
      IPGEO2 = KENTRY(1)
      IPIND = KENTRY(2)
      CALL LCMSIX(KENTRY(3),' ',0)
      CALL LCMGET(KENTRY(3),'SIGNATURE',KCHAR)
      WRITE(HSIGN,'(3A4)') (KCHAR(I1),I1=1,3)
      TEXT12=HENTRY(3)
      IF (HSIGN.NE.'L_GEOM') CALL XABORT('USPLIT:'
     + //'SIGNATURE OF '//TEXT12//' IS '//HSIGN//'. '
     + //'L_GEOM EXPECTED.')
      IPGEOM = KENTRY(3)
*
*     READ THE MAXIMUM NUMBER OF REGIONS
*
      IMPX = 1
 10   CALL REDGET(INDIC,NITMA,FLOTT,TEXT12,DFLOTT)
      IF(INDIC.NE.3) CALL XABORT('USPLIT: CHARACTER DATA EXPECTED(2).')
      IF(TEXT12.EQ.'MAXR') THEN
         CALL REDGET(INDIC,MAXPTS,FLOTT,TEXT12,DFLOTT)
         IF(INDIC.NE.1) CALL XABORT('USPLIT: INTEGER DATA EXPECTED(2).')
      ELSE IF(TEXT12.EQ.';') THEN
         GOTO 20
      ELSE
         CALL XABORT('USPLIT: INPUT DATA EXPECTED')
      ENDIF
      GOTO 10
*
*     CREATION OF A NEW GEOMETRY GEO2
*
 20   CONTINUE
*
      CALL SETARA(IBASE,MAXPTS,IMAT)
      CALL SETARA(BASE,MAXPTS+1,IXXX)
      CALL SETARA(BASE,MAXPTS+1,IYYY)
      CALL SETARA(BASE,MAXPTS+1,IZZZ)
*
      CALL SETARA(BASE,MAXPTS,IISPLX)
      CALL SETARA(BASE,MAXPTS,IISPLY)
      CALL SETARA(BASE,MAXPTS,IISPLZ)
*
      CALL READGM(MAXPTS,MAXPTS,MAXPTS,MAXPTS,IPGEOM,IHEX,IR,
     1     IBASE(IMAT),ILK,SIDE,BASE(IXXX),BASE(IYYY),BASE(IZZZ),IMPX,
     2     LX,LY,LZ,NEL,NCODE,ZCODE,BASE(IISPLX),BASE(IISPLY),
     3     BASE(IISPLZ))
*
      CALL RLSARA(BASE(IISPLZ))
      CALL RLSARA(BASE(IISPLY))
      CALL RLSARA(BASE(IISPLX))
*
*     STORAGE OF DIMENSIONS IN GEOMETRY
*
      CALL LCMGET(IPGEOM,'STATE',ISTATE)
      ITYPE = ISTATE(1)
*
*     STORE THE MESH COORDINATES.
*
      IF(ITYPE.EQ.2) THEN
*        1-D CARTESIAN GEOMETRY.
         ISTATE(3) = LX
         CALL LCMPUT(IPGEO2,'MESHX',LX+1,2,BASE(IXXX))
      ELSE IF((ITYPE.EQ.3).OR.(ITYPE.EQ.4)) THEN
*        1-D CYLINDRICAL/SPHERICAL GEOMETRY.
         ISTATE(2) = LX
         CALL LCMPUT(IPGEO2,'RADIUS',LX+1,2,BASE(IXXX))
         NCODE(1)=0
      ELSE IF(ITYPE.EQ.5) THEN
*        2-D CARTESIAN GEOMETRY.
         ISTATE(3) = LX
         ISTATE(4) = LY
         CALL LCMPUT(IPGEO2,'MESHX',LX+1,2,BASE(IXXX))
         CALL LCMPUT(IPGEO2,'MESHY',LY+1,2,BASE(IYYY))
      ELSE IF(ITYPE.EQ.6) THEN
*        2-D CYLINDRICAL GEOMETRY.
         ISTATE(2) = LX
         ISTATE(5) = LZ
         CALL LCMPUT(IPGEO2,'RADIUS',LX+1,2,BASE(IXXX))
         CALL LCMPUT(IPGEO2,'MESHZ',LZ+1,2,BASE(IZZZ))
         NCODE(1)=0
      ELSE IF(ITYPE.EQ.7) THEN
*        3-D CARTESIAN GEOMETRY.
         ISTATE(3) = LX
         ISTATE(4) = LY
         ISTATE(5) = LZ
         CALL LCMPUT(IPGEO2,'MESHX',LX+1,2,BASE(IXXX))
         CALL LCMPUT(IPGEO2,'MESHY',LY+1,2,BASE(IYYY))
         CALL LCMPUT(IPGEO2,'MESHZ',LZ+1,2,BASE(IZZZ))
      ELSE IF(ITYPE.EQ.8) THEN
*        2-D HEXAGONAL GEOMETRY.
         CALL LCMPUT(IPGEO2,'SIDE',1,2,SIDE)
         CALL LCMPUT(IPGEO2,'IHEX',1,1,IHEX)
      ELSE IF(ITYPE.EQ.9) THEN
*        3-D HEXAGONAL GEOMETRY.
         ISTATE(5) = LZ
         CALL LCMPUT(IPGEO2,'SIDE',1,2,SIDE)
         CALL LCMPUT(IPGEO2,'IHEX',1,1,IHEX)
         CALL LCMPUT(IPGEO2,'MESHZ',LZ+1,2,BASE(IZZZ))
      ENDIF
*
      CALL LCMPUT(IPGEO2,'NCODE',6,1,NCODE)
      CALL LCMPUT(IPGEO2,'ZCODE',6,2,ZCODE)
      CALL LCMGET(IPGEOM,'ICODE',ICODE)
      CALL LCMPUT(IPGEO2,'ICODE',6,1,ICODE)
*
      CALL LCMLEN(IPGEOM,'XR0',ILONG,ITYP)
      IF (ILONG.NE.0) THEN
         CALL LCMGET(IPGEOM,'XR0',DATA)
         CALL LCMPUT(IPGEO2,'XR0',ILONG,ITYP,DATA)
      ENDIF
      CALL LCMLEN(IPGEOM,'RR0',ILONG,ITYP)
      IF (ILONG.NE.0) THEN
         CALL LCMGET(IPGEOM,'RR0',DATA)
         CALL LCMPUT(IPGEO2,'RR0',ILONG,ITYP,DATA)
      ENDIF
      CALL LCMLEN(IPGEOM,'ANG',ILONG,ITYP)
      IF (ILONG.NE.0) THEN
         CALL LCMGET(IPGEOM,'ANG',DATA)
         CALL LCMPUT(IPGEO2,'ANG',ILONG,ITYP,DATA)
      ENDIF
*
*     CREATION OF L_INDEX
*
      ISIZE(1) = ISTATE(7)
      CALL LCMPUT(IPIND,'MIX',NEL,1,IBASE(IMAT))
      HSIGN='L_INDEX'
      READ(HSIGN,'(3A4)') (KCHAR(I1),I1=1,3)
      CALL LCMPUT(IPIND,'SIGNATURE',3,3,KCHAR)
      CPT = 0
      DO 30 I=1,NEL
         IF (IBASE(IMAT+I-1).NE.0) THEN
            CPT = CPT + 1
            IBASE(IMAT+I-1) = CPT
         ENDIF
  30  CONTINUE
      ISTATE(6) = NEL
      ISTATE(11) = 0
      ISTATE(7) = CPT
      ISIZE(2) = CPT
      CALL LCMPUT(IPIND,'SIZE',2,1,ISIZE)
      CALL LCMPUT(IPGEO2,'STATE',13,1,ISTATE)
      CALL LCMPUT(IPGEO2,'MIX',NEL,1,IBASE(IMAT))
      HSIGN='L_GEOM'
      READ(HSIGN,'(3A4)') (KCHAR(I1),I1=1,3)
      CALL LCMPUT(IPGEO2,'SIGNATURE',3,3,KCHAR)
      CALL RLSARA(BASE(IMAT))
      CALL RLSARA(BASE(IXXX))
      CALL RLSARA(BASE(IYYY))
      CALL RLSARA(BASE(IZZZ))
*
      RETURN
      END
