*DECK VECPER
      SUBROUTINE VECPER(HNAME,IMPV,ISEG,L4,MUIN,LON,LTSW,NBL,LBL,MUV,
     1 IPV)
*
*-----------------------------------------------------------------------
*
* ORDERING OF MATRIX ELEMENTS FOR SUPERVECTORIAL OPERATIONS ON A MATRIX
* IN COMPRESSED DIAGONAL STORAGE MODE.
*
* INPUT PARAMETERS:
*  HNAME : CHARACTER*4 NAME OF THE MATRIX (FOR EDITION PURPOSE ONLY).
*   IMPV : PRINT PARAMETER FOR STATISTICS. EQUAL TO ZERO FOR NO PRINT.
*   ISEG : NUMBER OF ELEMENTS IN A VECTOR REGISTER.
*     L4 : MATRIX ORDER.
*   MUIN : POSITION OF EACH DIAGONAL ELEMENT IN NON-ORDERED MATRIX.
*          DIMENSION MUIN(L4)
*
* OUTPUT PARAMETERS:
*    LON : NUMBER OF GROUPS OF LINEAR SYSTEMS.
*   LTSW : MAXIMUM BANDWIDTH. =2 FOR TRIDIAGONAL SYSTEMS.
*    NBL : NUMBER OF LINEAR SYSTEMS IN EACH GROUP. DIMENSION NBL(LON)
*    LBL : NUMBER OF UNKNOWNS IN EACH GROUP. DIMENSION LBL(LON)
*    MUV : POSITION OF EACH DIAGONAL ELEMENT IN ORDERED MATRIX.
*    IPV : PERMUTATION VECTOR FOR THE ORDERED UNKNOWNS.
*          DIMENSION MUV(L4),IPV(L4)
*
*-------------------------------------- AUTHOR: A. HEBERT ; 13/10/92 ---
*
      CHARACTER HNAME*(*)
      DIMENSION MUIN(*),NBL(*),LBL(*),MUV(*),IPV(*)
      COMMON IBASE(1)
*
* DETERMINE THE TOTAL NUMBER OF LINEAR SYSTEMS AND COMPUTE THE ORDER OF
* EACH OF THEM.
      CALL SETARA(IBASE,L4,ISET)
      IBASE(ISET)=0
      K1=MUIN(1)+1
      DO 10 I=2,L4
      IBASE(ISET+I-1)=0
      K2=MUIN(I)
      DO 5 J=I-K2+K1,I-1
    5 IBASE(ISET+J-1)=1
   10 K1=K2+1
      NSYS=0
      DO 15 I=1,L4
      IPV(I)=0
      MUV(I)=0
      IF(IBASE(ISET+I-1).EQ.0) NSYS=NSYS+1
   15 CONTINUE
      LON=1+(NSYS-1)/ISEG
      IF(IMPV.GE.2) WRITE (6,'(/35H VECPER: NUMBER OF INDEPENDANT LINE,
     1 22HAR SYSTEMS IN MATRIX '',A4,3H'' =,I7/9X,17HNUMBER OF GROUPS ,
     1 19HOF LINEAR SYSTEMS =,I6)') HNAME,NSYS,LON
      CALL SETARA(IBASE,NSYS,IORD)
      CALL SETARA(IBASE,NSYS,IOFSET)
      ISYS=0
      IORD0=0
      IBASE(IOFSET)=1
      DO 20 I=1,L4
      IF(IBASE(ISET+I-1).EQ.0) THEN
         ISYS=ISYS+1
         IBASE(IORD+ISYS-1)=I-IORD0
         IF(I.NE.L4) IBASE(IOFSET+ISYS)=I+1
         IORD0=I
      ENDIF
   20 CONTINUE
      CALL RLSARA(IBASE(ISET))
*
* SORT THE LINEAR SYSTEMS BY DECREASING ORDER.
      CALL SETARA(IBASE,NSYS,ISORT)
      JNEW=NSYS
      DO 25 ISYS=NSYS,1,-1
      IF(IBASE(IORD+ISYS-1).EQ.1) THEN
         IBASE(ISORT+JNEW-1)=ISYS
         JNEW=JNEW-1
      ENDIF
   25 CONTINUE
      INEW=0
   30 IBIG=0
      DO 50 ISYS=1,NSYS
      IF(IBASE(IORD+ISYS-1).EQ.1) GO TO 50
      DO 40 KSYS=1,INEW
      IF(IBASE(ISORT+KSYS-1).EQ.ISYS) GO TO 50
   40 CONTINUE
      IBIG=MAX(IBIG,IBASE(IORD+ISYS-1))
   50 CONTINUE
      IF(IBIG.LE.1) GO TO 70
      DO 60 ISYS=1,NSYS
      IF(IBASE(IORD+ISYS-1).EQ.IBIG) THEN
         INEW=INEW+1
         IBASE(ISORT+INEW-1)=ISYS
      ENDIF
   60 CONTINUE
      GO TO 30
   70 IF(INEW.NE.JNEW) CALL XABORT('VECPER: ALGORITHM FAILURE 1')
      DO 80 I=1,LON
      ISYS=IBASE(ISORT+(I-1)*ISEG)
      NBL(I)=ISEG
   80 LBL(I)=IBASE(IORD+ISYS-1)
      NBL(LON)=NSYS-(LON-1)*ISEG
      IF(IMPV.GE.2) WRITE (6,'(9X,33HMAXIMUM ORDER OF AN INDEPENDANT L,
     1 14HINEAR SYSTEM =,I9)') LBL(1)
      IF(IMPV.GE.3) THEN
         I1=1
         DO 90 I=1,(LON-1)/8+1
         I2=I1+7
         IF(I2.GT.LON) I2=LON
         WRITE (6,200) (J,J=I1,I2)
         WRITE (6,210) (NBL(J),J=I1,I2)
         WRITE (6,220) (LBL(J),J=I1,I2)
   90    I1=I1+8
      ENDIF
*
* COMPUTE THE PERMUTATION MATRIX.
      LBL0=0
      KSYS=0
      DO 105 J=1,LON
      DO 100 K=1,NBL(J)
      KSYS=KSYS+1
      ISYS=IBASE(ISORT+KSYS-1)
      IOF0=IBASE(IOFSET+ISYS-1)
      IOF1=IOF0+IBASE(IORD+ISYS-1)-1
      IF(IOF1.GT.L4) CALL XABORT('VECPER: ALGORITHM FAILURE 2')
      DO 100 I=IOF0,IOF1
  100 IPV(I)=(LBL0+I-IOF0)*ISEG+K
  105 LBL0=LBL0+LBL(J)
      DO 110 I=1,L4
      IF(IPV(I).LE.0) CALL XABORT('VECPER: ALGORITHM FAILURE 3')
      IF(IPV(I).GT.LBL0*ISEG) CALL XABORT('VECPER: ALGORITHM FAILURE 4')
  110 CONTINUE
      L4NEW=0
      DO 115 J=1,LON
  115 L4NEW=L4NEW+LBL(J)*NBL(J)
      IF(IMPV.GE.2) WRITE (6,'(/35H VECPER: INCREASING NUMBER OF UNKNO,
     1 8HWNS FROM,I7,3H TO,I7,11H. FILL-IN =,F7.2,3H %.)') L4,L4NEW,
     2 100.0*(REAL(L4NEW)/REAL(L4)-1.0)
*
* COMPUTE THE VECTORIAL BANDWIDTH.
      LBL0=0
      KSYS=0
      IIMAX=0
      LTSW=0
      MAXNEW=0
      DO 150 J=1,LON
      DO 120 I=1,LBL(J)
  120 MUV(LBL0+I)=1
      DO 130 K=1,NBL(J)
      KSYS=KSYS+1
      ISYS=IBASE(ISORT+KSYS-1)
      IOF0=IBASE(IOFSET+ISYS-1)-1
      DO 130 I=2,IBASE(IORD+ISYS-1)
      IBIG=MUIN(IOF0+I)-MUIN(IOF0+I-1)
      IF(IBIG.GT.MUV(LBL0+I)) MUV(LBL0+I)=IBIG
  130 CONTINUE
      DO 140 I=1,LBL(J)
      LTSW=MAX(LTSW,MUV(LBL0+I))
      IIMAX=IIMAX+MUV(LBL0+I)
  140 MUV(LBL0+I)=IIMAX
      LBL0=LBL0+LBL(J)
  150 MAXNEW=MAXNEW+MUV(LBL0)*NBL(J)
      IF(IMPV.GE.2) WRITE (6,'(/35H VECPER: INCREASING NUMBER OF TERMS,
     1 17H IN MATRICES FROM,I9,3H TO,I9,11H. FILL-IN =,F7.2,3H %./9X,
     2 19HMAXIMUM BANDWIDTH =,I4)') MUIN(L4),MAXNEW,
     3 100.0*(REAL(MAXNEW)/REAL(MUIN(L4))-1.0),LTSW
*
      CALL RLSARA(IBASE(ISORT))
      CALL RLSARA(IBASE(IOFSET))
      CALL RLSARA(IBASE(IORD))
      RETURN
  200 FORMAT (//13H GROUP       ,8(I8,5X,1HI))
  210 FORMAT (  13H NB. SYSTEMS ,8(I8,5X,1HI))
  220 FORMAT (  13H NB. UNKNOWNS,8(I8,5X,1HI))
      END
