*DECK XCOMP
      SUBROUTINE XCOMP(IPFLUX,L4,NUN,VECT,LMPR,B)
*
*-----------------------------------------------------------------------
*
* COMPARE TWO SOLUTIONS AND PRINT THE LOGARITHM OF ERROR.
*
* INPUT PARAMETERS:
*  IPFLUX : L_FLUX POINTER TO THE SOLUTION.
*  L4     : ORDER OF MATRIX SYSTEMS.
*  NUN    : NUMBER OF UNKNOWNS IN EACH ENERGY GROUP.
*  VECT   : UNKNOWN VECTOR. DIMENSION VEC(NUN)
*  LMPR   : .TRUE. TO PRINT THE LOGARITHM VALUE.
*
* OUTPUT PARAMETER:
*  B     : BASE 10 LOGARITHM OF THE ERROR.
*
*-----------------------------------------------------------------------
*
      DIMENSION VECT(*)
      LOGICAL LMPR
      COMMON BASE(1)
      CALL LCMLEN(IPFLUX,'REF',ILONG,ITYLCM)
      IF(ILONG.NE.NUN) CALL XABORT('XCOMP: INVALID LENGTH FOR REF.')
      CALL SETARA(BASE,ILONG,IOF)
      CALL LCMGET(IPFLUX,'REF',BASE(IOF))
      ERR1=0.0
      DO 5 I=1,L4
      IF(ABS(BASE(IOF+I-1)).GT.ERR1) THEN
         IN=I
         ERR1=ABS(BASE(IOF+I-1))
      ENDIF
    5 CONTINUE
      WEIGHT=BASE(IOF+IN-1)/VECT(IN)
      ERR2=0.0
      DO 10 I=1,L4
      ERR2=AMAX1(ERR2,ABS(BASE(IOF+I-1)-VECT(I)*WEIGHT))
   10 CONTINUE
      CALL RLSARA(BASE(IOF))
      A=ERR2/ERR1
      IF(A.GT.0.0) THEN
         B=LOG10(A)
      ELSE
         B=-5.0
      ENDIF
      IF(LMPR) WRITE (6,20) A,B
      RETURN
*
   20 FORMAT (7H ERROR=,1P,E10.2,5X,11HLOG(ERROR)=,E10.2)
      END
