*DECK XSCONS
      SUBROUTINE XSCONS(NENTRY,HENTRY,IENTRY,JENTRY,KENTRY)
*
*-----------------------------------------------------------------------
*
* RECOVER NUCLEAR PROPERTY INFORMATION FROM ONE OR MANY
* COMPO LINKED LISTS OR XSM FILES.
*
* INPUT/OUTPUT PARAMETERS:
*  NENTRY : NUMBER OF LINKED LISTS OR FILES USED BY THE MODULE.
*  HENTRY : CHARACTER*12 NAME OF EACH LINKED LIST OR FILE.
*  IENTRY : =1 LINKED LIST; =2 XSM FILE; =3 SEQUENTIAL BINARY FILE;
*           =4 SEQUENTIAL ASCII FILE.
*  JENTRY : =0 THE LINKED LIST OR FILE IS CREATED.
*           =1 THE LINKED LIST OR FILE IS OPEN FOR MODIFICATIONS;
*           =2 THE LINKED LIST OR FILE IS OPEN IN READ-ONLY MODE.
*  KENTRY : =FILE UNIT NUMBER; =LINKED LIST ADDRESS OTHERWISE.
*           DIMENSION HENTRY(NENTRY),IENTRY(NENTRY),JENTRY(NENTRY),
*           KENTRY(NENTRY)
*
* LINKED LIST / XSM FILE:
*  HENTRY(1) : CREATE OR MODIFICATION TYPE(L_TABLE).
*  HENTRY(I) : READ-ONLY MODE TYPE(L_COMPO).
*
*-------------------------------------- AUTHOR: A. HEBERT ; 16/02/94 ---
*-------------------------------------- MODIFIED: E. VARIN ; 11/08/95 --
*
      CHARACTER HENTRY(*)*12,TEXT4*4,TEXT8*8,TEXT12*12,HSMG*131,
     1 HCOMPO*12,HTYPE*12,HSIGN*12,NAMLCM*12,NAMMY*12,CGRPNM*12
      INTEGER I1,JPLIST
      LOGICAL DERIV,UPS,LCM,INTRP,LBURN
      DOUBLE PRECISION DFLOTT
      DIMENSION IENTRY(*),JENTRY(*),KENTRY(*),KCHAR(3),IPAR(4),IBASE(1)
      COMMON BASE(1)
      EQUIVALENCE(BASE(1),IBASE(1))
*
* PARAMETER VALIDATION.
      IF(NENTRY.LE.1) CALL XABORT('XSCONS: 2 PARAMETER EXPECTED.')
      IF((IENTRY(1).NE.1).AND.(IENTRY(1).NE.2)) CALL XABORT('XSCONS: '
     1 //'TABLE LINKED LIST OR XSM FILE EXPECTED AT LHS.')
      IF((JENTRY(1).NE.0).AND.(JENTRY(1).NE.1)) CALL XABORT('XSCONS: '
     1 //'TABLE IN CREATE OR MODIFICATION MODE EXPECTED.')
      IF((IENTRY(2).NE.1).AND.(IENTRY(2).NE.2)) CALL XABORT('XSCONS: '
     1 //'COMPO LINKED LIST OR XSM FILE EXPECTED AT RHS.')
      IF(JENTRY(2).NE.2) CALL XABORT('XSCONS: COMPO IN READ-ONLY MODE '
     1 //'EXPECTED AT RHS.')
      ITYPE=JENTRY(1)
      IPLIST=KENTRY(1)
*
* RECOVER SOME DATA IN THE FIRST MATERIAL OF THE FIRST COMPO.
      CALL LCMGET(KENTRY(2),'SIGNATURE',KCHAR)
      WRITE(HSIGN,'(3A4)') (KCHAR(I1),I1=1,3)
      IF(HSIGN.NE.'L_COMPO') THEN
         TEXT12=HENTRY(2)
         CALL XABORT('XSCONS: SIGNATURE OF '//TEXT12//' IS '//HSIGN//
     1   '. L_COMPO EXPECTED.')
      ENDIF
      TEXT12='SIGNATURE'
      CALL LCMNXT(KENTRY(2),TEXT12,NAMLCM,NAMMY,LCM)
      IF(TEXT12.EQ.'SIGNATURE')
     1  CALL XABORT('XSCONS: INVALID INPUT COMPO.')
      CALL LCMSIX(KENTRY(2),TEXT12,1)
      CALL LCMGET(KENTRY(2),'PARAM',IPAR)
      CALL LCMSIX(KENTRY(2),' ',2)
      NGRP=IPAR(1)
      NL=IPAR(3)
      IF(NL.GT.1) NL=1
*
* READ THE INPUT DATA.
*     DEFAULT OPTIONS:
      IMPX=1
      IF(ITYPE.EQ.0) THEN
         IND=1
      ELSE IF(ITYPE.EQ.1) THEN
         CALL LCMGET(IPLIST,'SIGNATURE',KCHAR)
         WRITE(HSIGN,'(3A4)') (KCHAR(I1),I1=1,3)
         IF(HSIGN.NE.'L_TABLE') THEN
            TEXT12=HENTRY(1)
            CALL XABORT('XSCONS: SIGNATURE OF '//TEXT12//' IS '//HSIGN//
     1      '. L_TABLE EXPECTED.')
         ENDIF
         IND=2
      ENDIF
*
* READ THE MODULE OPTIONS.
   10 CALL REDGET(INDIC,NITMA,FLOTT,TEXT4,DFLOTT)
      IF(INDIC.NE.3) CALL XABORT('XSCONS: CHARACTER DATA EXPECTED(1).')
   20 IF(TEXT4.EQ.'EDIT') THEN
*        READ THE PRINT INDEX.
         CALL REDGET(INDIC,IMPX,FLOTT,TEXT4,DFLOTT)
         IF(INDIC.NE.1) CALL XABORT('XSCONS: INTEGER DATA EXPECTED(1).')
      ELSE IF(TEXT4.EQ.'READ') THEN
       LBURN=.TRUE.
       INTRP=.FALSE.
       DERIV=.FALSE.
       UPS=.FALSE.
       HTYPE = ' '
   50  CALL REDGET(INDIC,NITMA,FLOTT,TEXT8,DFLOTT)
       IF(INDIC.NE.3) CALL XABORT('XSCONS: CHARACTER DATA EXPECTED.')
   55  IF(TEXT8.EQ.'COMPO') THEN
         CALL REDGET(INDIC,NITMA,FLOTT,TEXT12,DFLOTT)
         IF(INDIC.NE.3) CALL XABORT('XSCONS: CHARACTER DATA EXPECTED.')
         JPLIST=0
         DO 60 I=2,NENTRY
          IF(TEXT12.EQ.HENTRY(I)) THEN
           CALL LCMGET(KENTRY(I),'SIGNATURE',KCHAR)
           WRITE(HSIGN,'(3A4)') (KCHAR(I1),I1=1,3)
           IF(HSIGN.NE.'L_COMPO') THEN
            CALL XABORT('XSCONS: SIGNATURE OF '//TEXT12//' IS '
     1       //HSIGN//'. L_COMPO EXPECTED.')
           ENDIF
           IF((IENTRY(I).NE.1).AND.(IENTRY(I).NE.2)) CALL XABORT('XSCO'
     1      //'NS: COMPO LINKED LIST OR XSM FILE EXPECTED AT RHS.')
           IF(JENTRY(I).NE.2) CALL XABORT('XSCONS: COMPO IN READ-ONLY '
     1      //'MODE EXPECTED AT RHS.')
           HCOMPO=HENTRY(I)
           JPLIST=KENTRY(I)
           IF(IMPX.GT.1) CALL LCMLIB(JPLIST)
           GO TO 50
          ENDIF
   60    CONTINUE
         WRITE(HSMG,'(44HXSCONS: UNABLE TO FIND THE COMPO WITH NAME '',
     1   A12,2H''.)') TEXT12
         CALL XABORT(HSMG)
       ELSE IF(TEXT8.EQ.'TYPE') THEN
         IF(JPLIST.EQ.0) CALL XABORT('XSCONS: COMPO FILE NOT YET DEFIN'
     1   //'ED.')
         CALL REDGET(INDIC,NITMA,FLOTT,HTYPE,DFLOTT)
         IF(INDIC.NE.3) CALL XABORT('XSCONS: CHARACTER DATA EXPECTED.')
         CALL LCMSIX(IPLIST,HTYPE,1)
         CALL REDGET(INDIC,NITMA,FLOTT,TEXT12,DFLOTT)
         IF(INDIC.NE.3) CALL XABORT('XSCONS: CHARACTER DATA EXPECTED.')
         IF(IMPX.GT.0) WRITE(6,'(/27H XSCONS: ACCESS DIRECTORY '',A12,
     1   17H'' IN COMPO FILE '',A12,2H''.)') TEXT12,HCOMPO
         CALL LCMSIX(JPLIST,TEXT12,1)
         IF(IMPX.GT.1) THEN
            CALL LCMLIB(JPLIST)
            CALL LCMLEN(JPLIST,'TITLE',LENGT,ITYXSM)
            CALL SETARA(BASE,LENGT,ITITLE)
            CALL LCMGET(JPLIST,'TITLE',BASE(ITITLE))
            WRITE(6,'(/33H XSCONS: MIXTURE DIRECTORY TITLE:)')
            I2=0
            DO 65 J=0,LENGT/20
            I1=I2+1
            I2=MIN(I1+19,LENGT)
            WRITE(HSMG,'(20A4)') (BASE(ITITLE+I-1),I=I1,I2)
            WRITE(6,'(1X,A80)') HSMG
   65       CONTINUE
            CALL RLSARA(BASE(ITITLE))
         ENDIF
         CALL LCMGET(JPLIST,'PARAM',IPAR)
         IF(IPAR(1).NE.NGRP) THEN
            WRITE(HSMG,'(43HXSCONS: INCONSISTENT NB OF GROUPS. IN MACRO,
     1      5HLIB =,I5,11H IN COMPO =,I5)') NGRP,IPAR(1)
            CALL XABORT(HSMG)
         ELSE IF(IPAR(3).LT.NL) THEN
          WRITE(HSMG,'(43HXSCONS: INCONSISTENT NB OF LEGENDRE ORDERS.,
     1      14H IN MACROLIB =,I5,11H IN COMPO =,I5)') NL,IPAR(3)
            CALL XABORT(HSMG)
         ENDIF
         NISO=IPAR(2)
         NBURN=IPAR(4)
         IF(NBURN.LE.1)
     1    CALL XABORT('XSCONS: BURNUP STEP REQUIRED IN COMPO.')
         CALL REDGET(INDIC,NITMA,FLOTT,TEXT12,DFLOTT)
         IF(INDIC.NE.3) CALL XABORT('XSCONS: CHARACTER DATA EXPECTE'
     1      //'D.')
         IF(TEXT12.EQ.'N/KB') THEN
            LBURN = .FALSE.
         ELSE IF(TEXT12.EQ.'BURNUP') THEN
            LBURN = .TRUE.
         ELSE
            CALL XABORT('XSCONS: BURNUP OR N/KB '
     1        //' KEYWORD EXPECTED.')
         ENDIF
         CALL SETARA(IBASE,3*NISO,IHISO)
         CALL SETARA(IBASE,NISO,IITY)
         CALL SETARA(BASE,NISO,ICONC)
         CALL SETARA(BASE,NGRP+1,IENER)
         CALL LCMGET(JPLIST,'ISOTOPESNAME',IBASE(IHISO))
         CALL LCMGET(JPLIST,'VOLUME',VOLUME)
         CALL LCMPUT(IPLIST,'VOLUME',1,2,VOLUME)
         CALL LCMGET(JPLIST,'ENERGY',BASE(IENER))
         CALL LCMPUT(IPLIST,'ENERGY',NGRP+1,2,BASE(IENER))
         CALL RLSARA(BASE(IENER))
         IBASE(IITY)=2
         DO 70 I=2,NISO
   70    IBASE(IITY+I-1)=0
         IF(NISO.GT.1) THEN
            CALL REDGET(INDIC,NITMA,FLOTT,TEXT12,DFLOTT)
            IF(INDIC.NE.3) CALL XABORT('XSCONS: CHARACTER DATA EXPECTE'
     1      //'D.')
            IF(TEXT12.EQ.'MICRO') THEN
   80          CALL REDGET(INDIC,NITMA,FLOTT,TEXT12,DFLOTT)
               IF(INDIC.NE.3) CALL XABORT('XSCONS: CHARACTER DATA EXPE'
     1         //'CTED.')
               IF(TEXT12.EQ.'ALL') THEN
                  DO 90 I=2,NISO
   90             IBASE(IITY+I-1)=2
               ELSEIF(TEXT12.EQ.'ENDTYP') THEN
                  TEXT8=TEXT12
                  GO TO 55
               ELSE IF(TEXT12.EQ.'UPS') THEN
                  TEXT8=TEXT12
                  GO TO 55
               ELSE IF(TEXT12.EQ.'N/KB') THEN
                  TEXT8=TEXT12
                  GO TO 55
               ELSE IF(TEXT12.EQ.'INTRPL') THEN
                  TEXT8=TEXT12
                  GO TO 55
               ELSE
                  DO 100 I=1,NISO
                  WRITE(CGRPNM,'(3A4)') (IBASE(IHISO+3*(I-1)+J),J=0,2)
                  IF(CGRPNM.EQ.TEXT12) THEN
                     CALL REDGET(INDIC,NITMA,FLOTT,TEXT4,DFLOTT)
                     IF(INDIC.EQ.2) THEN
                        BASE(ICONC+I-1)=FLOTT
                        IBASE(IITY+I-1)=1
                     ELSE IF((INDIC.EQ.3).AND.(TEXT4.EQ.'*')) THEN
                        IBASE(IITY+I-1)=2
                     ELSE
                        CALL XABORT('XSCONS: REAL NUMBER OR * EXPECTED')
                     ENDIF
                     GO TO 80
                  ENDIF
  100             CONTINUE
                  CALL XABORT('XSCONS: UNABLE TO MATCH '//TEXT12//'.')
               ENDIF
            ENDIF
         ENDIF
       ELSE IF(TEXT8.EQ.'ENDTYP') THEN
        IF(HTYPE.EQ.' ') CALL XABORT('XSCONS: TYPE NOT YET DEFINED.')
        CALL SETARA(BASE,2*NGRP*NBURN,ITOTAL)
        CALL SETARA(BASE,2*NGRP*NBURN,IZNUG)
        CALL SETARA(BASE,2*NGRP*NBURN,INUGF)
        CALL SETARA(BASE,2*NGRP*NBURN,ICHI)
        CALL SETARA(BASE,2*NGRP*NBURN,IOVERV)
        CALL SETARA(BASE,2*NGRP*NBURN,IDIFFX)
        CALL SETARA(BASE,2*NGRP*NBURN,IDIFFY)
        CALL SETARA(BASE,2*NGRP*NBURN,IDIFFZ)
        CALL SETARA(BASE,2*NGRP*NBURN,IH)
        CALL SETARA(BASE,2*NL*NGRP*NGRP*NBURN,ISCAT)
        CALL SETARA(BASE,2*NGRP*NBURN,IFLUX)
*
        CALL SETARA(BASE,NBURN,IBURNU)
        CALL SETARA(BASE,NISO,IDENSI)
        CALL XSTAB(IPLIST,JPLIST,NISO,DERIV,UPS,LBURN,NBURN,NGRP,NL,
     1   IMPX,IBASE(IHISO),IBASE(IITY),BASE(ICONC),BASE(ITOTAL),
     2   BASE(IZNUG),BASE(INUGF),BASE(ICHI),BASE(IOVERV),BASE(IDIFFX),
     3   BASE(IDIFFY),BASE(IDIFFZ),BASE(IH),BASE(ISCAT),BASE(IFLUX),
     4   BASE(IBURNU),BASE(IDENSI))
*
        IF(INTRP) THEN
*
*     INTERPOLATION OF XS FOR A  CONSTANT DELTA BURNUP
*
         IF(.NOT.LBURN) CALL XABORT('XSCONS: NO IRRADIATION '
     1     //'INTERPOLATION ALLOWED')
*
*     CONSTRUCTION OF THE NEW BURNUP VECTOR
*
         CALL LCMGET(JPLIST,'BURNUP',BASE(IBURNU))
         TEMP = BASE(IBURNU+NBURN-1)
         TEMP = AINT(TEMP/1000.)
         TEMP = TEMP*1000.
         NBURNF = INT(TEMP/DBURN) + 1
         CALL SETARA(BASE,NBURNF,ITBURN)
         CALL SETARA(BASE,2*NGRP*NBURNF,IZTOTL)
         CALL SETARA(BASE,2*NGRP*NBURNF,IZZNUG)
         CALL SETARA(BASE,2*NGRP*NBURNF,IZNUGF)
         CALL SETARA(BASE,2*NGRP*NBURNF,IZCHI)
         CALL SETARA(BASE,2*NGRP*NBURNF,IZOVER)
         CALL SETARA(BASE,2*NGRP*NBURNF,IZDIFX)
         CALL SETARA(BASE,2*NGRP*NBURNF,IZDIFY)
         CALL SETARA(BASE,2*NGRP*NBURNF,IZDIFZ)
         CALL SETARA(BASE,2*NGRP*NBURNF,IZH)
         CALL SETARA(BASE,2*NL*NGRP*NGRP*NBURNF,IZSCAT)
         CALL SETARA(BASE,2*NGRP*NBURNF,IZFLUX)
*
         CALL XSINTP(IPLIST,NBURN,NGRP,NL,NBURNF,DBURN,IMPX,
     1   BASE(ITOTAL),BASE(IZNUG),BASE(INUGF),BASE(ICHI),BASE(IOVERV),
     2   BASE(IDIFFX),BASE(IDIFFY),BASE(IDIFFZ),BASE(IH),BASE(ISCAT),
     3   BASE(IFLUX),BASE(IBURNU),BASE(ITBURN),
     4   BASE(IZTOTL),BASE(IZZNUG),BASE(IZNUGF),BASE(IZCHI),
     5   BASE(IZOVER),BASE(IZDIFX),BASE(IZDIFY),BASE(IZDIFZ),BASE(IZH),
     6   BASE(IZSCAT),BASE(IZFLUX))
*
         CALL RLSARA(BASE(ITBURN))
         CALL RLSARA(BASE(IZFLUX))
         CALL RLSARA(BASE(IZSCAT))
         CALL RLSARA(BASE(IZH))
         CALL RLSARA(BASE(IZDIFZ))
         CALL RLSARA(BASE(IZDIFY))
         CALL RLSARA(BASE(IZDIFX))
         CALL RLSARA(BASE(IZOVER))
         CALL RLSARA(BASE(IZCHI))
         CALL RLSARA(BASE(IZZNUG))
         CALL RLSARA(BASE(IZNUGF))
         CALL RLSARA(BASE(IZTOTL))
        ENDIF
        CALL RLSARA(BASE(IDENSI))
        CALL RLSARA(BASE(IBURNU))
        CALL RLSARA(BASE(IFLUX))
        CALL RLSARA(BASE(ISCAT))
        CALL RLSARA(BASE(IH))
        CALL RLSARA(BASE(IDIFFZ))
        CALL RLSARA(BASE(IDIFFY))
        CALL RLSARA(BASE(IDIFFX))
        CALL RLSARA(BASE(IOVERV))
        CALL RLSARA(BASE(ICHI))
        CALL RLSARA(BASE(IZNUG))
        CALL RLSARA(BASE(INUGF))
        CALL RLSARA(BASE(ITOTAL))
        CALL RLSARA(BASE(ICONC))
        CALL RLSARA(IBASE(IITY))
        CALL RLSARA(IBASE(IHISO))
        HTYPE = ' '
        CALL LCMSIX(JPLIST,' ',2)
        IF(IMPX.GT.2) CALL LCMLIB(IPLIST)
        CALL LCMSIX(IPLIST,' ',2)
       ELSE IF(TEXT8.EQ.'DERIV') THEN
         DERIV=.TRUE.
       ELSE IF(TEXT8.EQ.'UPS') THEN
           UPS = .TRUE.
       ELSE IF(TEXT8.EQ.'INTRPL') THEN
         INTRP=.TRUE.
         CALL REDGET(INDIC,NITMA,DBURN,TEXT12,DFLOTT)
         IF(INDIC.NE.2) CALL XABORT('XSCONS: REAL DATA EXPECTED.')
       ELSE IF(TEXT8.EQ.';') THEN
        IF(HTYPE.NE.' ') CALL XABORT('XSCONS: NO ENDTYP ENCOUNTERED.')
        GO TO 30
       ELSE
         CALL XABORT('XSCONS: '//TEXT8//' IS AN INVALID KEY-WORD.')
       ENDIF
       GO TO 50
      ELSE
         CALL XABORT('XSCONS: '//TEXT4//' IS AN INVALID KEY-WORD.')
      ENDIF
      GO TO 10
*
   30 IF(ITYPE.EQ.0) THEN
         HSIGN='L_TABLE'
         READ(HSIGN,'(3A4)') (KCHAR(I1),I1=1,3)
         CALL LCMPUT(IPLIST,'SIGNATURE',3,3,KCHAR)
      ENDIF
      RETURN
      END
