*DECK XSINTP
      SUBROUTINE XSINTP(IPLIST,NBURN,NGRP,NL,NBURNF,DBURN,
     1 IMPX,TOTAL,ZNUG,SNUGF,CHI,OVERV,DIFFX,DIFFY,
     2 DIFFZ,H,SCAT,FLUX,BURNUP,TBURN,ZTOTAL,ZNUGF,ZZNUG,ZCHI,
     3 ZOVERV,ZDIFFX,ZDIFFY,ZDIFFZ,ZH,ZSCAT,ZFLUX)
*
*-----------------------------------------------------------------------
*
* RECOVER A COMPO INFORMATIONS
*
* INPUT PARAMETERS:
*  IPLIST : ADDRESS OF THE TABLE LINKED LIST OR XSM FILE.
*  NGRP   : NUMBER OF ENERGY GROUPS.
*  NL     : NUMBER OF LEGENDRE ORDERS (=1 FOR ISOTROPIC SCATTERING).
*  NBURN  : NUMBER OF TABULATED BURNUP STEPS.
*  BURNUP : BURNUP OR NEUTRON EXPOSURE TABULATION POINTS.
*           DIMENSION BURNUP(NBURN)
*
* INTERPOLATED OUTPUT PARAMETERS:
*  ZTOTAL  : TOTAL MACROSCOPIC X-SECTIONS. DIMENSION ZTOTAL(2*NGRP*NBURN
*  ZZNUG   : NU * FISSION MACROSCOPIC X-SECTIONS.
*            DIMENSION ZZNUG(2*NGRP*NBURN)
*  ZNUGF   : FISSION MACROSCOPIC X-SECTIONS.
*            DIMENSION ZNUGF(2*NGRP*NBURN)
*  ZCHI    : FISSION SPECTRUM. DIMENSION ZCHI(2*NGRP*NBURN)
*  ZOVERV  : RECIPROCAL NEUTRON VELOCITIES.
*            DIMENSION ZOVERV(2*NGRP*NBURN)
*  ZDIFFX  : X-DIRECTED DIFFUSION COEFFICIENTS.
*            DIMENSION ZDIFFX(2*NGRP*NBURN)
*  ZDIFFY  : Y-DIRECTED DIFFUSION COEFFICIENTS.
*            DIMENSION ZDIFFY(2*NGRP*NBURN)
*  ZDIFFZ  : Z-DIRECTED DIFFUSION COEFFICIENTS.
*            DIMENSION ZDIFFZ(2*NGRP*NBURN)
*  ZH      : H-FACTORS (KAPPA * FISSION MACROSCOPIC X-SECTIONS).
*           DIMENSION ZH(2*NGRP*NBURN)
*  ZSCAT   : SCATTERING MACROSCOPIC X-SECTIONS.
*           DIMENSION ZSCAT(2*NL*NGRP*NGRP*NBURN)
*  ZFLUX   : INTEGRATED FLUX. DIMENSION ZFLUX(2*NGRP*NBURN)
*
* SCRATCH STORAGE:
*  DENSIT : DIMENSION DENSIT(NISO)
*
*-------------------------------------- AUTHOR: E. VARIN ; 11/09/95 ---
*
      INTEGER IPLIST,IDIM(4),NBURN,NGRP,NL,NBURNF,ISCAT,IZSCAT
      REAL    DBURN,TBURN(NBURNF)
      DIMENSION BURNUP(*),TOTAL(NBURN,NGRP,*),ZNUG(NBURN,NGRP,*),
     1 SNUGF(NBURN,NGRP,*),ZNUGF(NBURNF,NGRP,*),
     3 CHI(NBURN,NGRP,*),OVERV(NBURN,NGRP,*),DIFFX(NBURN,NGRP,*),
     4 DIFFY(NBURN,NGRP,*),DIFFZ(NBURN,NGRP,*),H(NBURN,NGRP,*),
     5 SCAT(NBURN,NL,NGRP,NGRP,*),FLUX(NBURN,NGRP,*),
     1 ZTOTAL(NBURNF,NGRP,*),ZZNUG(NBURNF,NGRP,*),
     3 ZCHI(NBURNF,NGRP,*),ZOVERV(NBURNF,NGRP,*),ZDIFFX(NBURNF,NGRP,*),
     4 ZDIFFY(NBURNF,NGRP,*),ZDIFFZ(NBURNF,NGRP,*),ZH(NBURNF,NGRP,*),
     5 ZSCAT(NBURNF,NL,NGRP,NGRP,*),ZFLUX(NBURNF,NGRP,*)
      COMMON BASE(1)
*
* RECOVER MACROSCOPIC X-SECTION INFO FROM BURNUP DIRECTORIES:
*
      DO 10 IP=1,NBURNF
        TBURN(IP) = BURNUP(1) + (IP-1)*DBURN
  10  CONTINUE
*
      CALL SETARA(BASE,2*NBURNF,IZGAR)
      DO 20 IGR=1,NGRP
        CALL INTRPL(NBURN,NGRP,NBURNF,DBURN,BURNUP,
     +             ZTOTAL,TOTAL,IGR)
        CALL ALDERV(NBURNF,TBURN,ZTOTAL(1,IGR,2),BASE(IZGAR))
        CALL INTRPL(NBURN,NGRP,NBURNF,DBURN,BURNUP,
     +            ZZNUG,ZNUG,IGR)
        CALL ALDERV(NBURNF,TBURN,ZZNUG(1,IGR,2),BASE(IZGAR))
        CALL INTRPL(NBURN,NGRP,NBURNF,DBURN,BURNUP,
     +            ZNUGF,SNUGF,IGR)
        CALL ALDERV(NBURNF,TBURN,ZNUGF(1,IGR,2),BASE(IZGAR))
        CALL INTRPL(NBURN,NGRP,NBURNF,DBURN,BURNUP,
     +            ZCHI,CHI,IGR)
        CALL ALDERV(NBURNF,TBURN,ZCHI(1,IGR,2),BASE(IZGAR))
        CALL INTRPL(NBURN,NGRP,NBURNF,DBURN,BURNUP,
     +            ZOVERV,OVERV,IGR)
        CALL ALDERV(NBURNF,TBURN,ZOVERV(1,IGR,2),BASE(IZGAR))
        CALL INTRPL(NBURN,NGRP,NBURNF,DBURN,BURNUP,
     +            ZDIFFX,DIFFX,IGR)
        CALL ALDERV(NBURNF,TBURN,ZDIFFX(1,IGR,2),BASE(IZGAR))
        CALL INTRPL(NBURN,NGRP,NBURNF,DBURN,BURNUP,
     +            ZDIFFY,DIFFY,IGR)
        CALL ALDERV(NBURNF,TBURN,ZDIFFY(1,IGR,2),BASE(IZGAR))
        CALL INTRPL(NBURN,NGRP,NBURNF,DBURN,BURNUP,
     +            ZDIFFZ,DIFFZ,IGR)
        CALL ALDERV(NBURNF,TBURN,ZDIFFZ(1,IGR,2),BASE(IZGAR))
        CALL INTRPL(NBURN,NGRP,NBURNF,DBURN,BURNUP,
     +            ZH,H,IGR)
        CALL ALDERV(NBURNF,TBURN,ZH(1,IGR,2),BASE(IZGAR))
        CALL INTRPL(NBURN,NGRP,NBURNF,DBURN,BURNUP,
     +            ZFLUX,FLUX,IGR)
        CALL ALDERV(NBURNF,TBURN,ZFLUX(1,IGR,2),BASE(IZGAR))
        DO 30 JGR=1,NGRP
         DO 30 IL=1,NL
          CALL SETARA(BASE,2*NBURN*NGRP,ISCAT)
          CALL SETARA(BASE,2*NBURNF*NGRP,IZSCAT)
          DO 31 J=1,2
          DO 31 IG=1,NGRP
           DO 32 I=1,NBURN
            IS = (J-1)*NGRP*NBURN + (IG-1)*NBURN + I
            BASE(ISCAT+IS-1) = SCAT(I,IL,JGR,IG,J)
 32        CONTINUE
           DO 33 I=1,NBURNF
            IS = (J-1)*NGRP*NBURNF + (IG-1)*NBURNF + I
            BASE(IZSCAT+IS-1) = ZSCAT(I,IL,JGR,IG,J)
 33        CONTINUE
 31       CONTINUE
          CALL INTRPL(NBURN,NGRP,NBURNF,DBURN,BURNUP,
     +            BASE(IZSCAT),BASE(ISCAT),IGR)
          DO 41 J=1,2
          DO 41 IG=1,NGRP
           DO 43 I=1,NBURNF
            IS = (J-1)*NGRP*NBURNF + (IG-1)*NBURNF + I
            ZSCAT(I,IL,JGR,IG,J) = BASE(IZSCAT+IS-1)
 43       CONTINUE
 41       CONTINUE
          CALL ALDERV(NBURNF,TBURN,ZSCAT(1,IL,JGR,IGR,2),BASE(IZGAR))
          CALL RLSARA(BASE(ISCAT))
          CALL RLSARA(BASE(IZSCAT))
 30     CONTINUE
 20   CONTINUE
      CALL RLSARA(BASE(IZGAR))
*
      IDIM(1) = NGRP
      IDIM(2) = NBURNF
      IDIM(3) = NL
      IDIM(4) = 2
      CALL LCMPUT(IPLIST,'IDIM',4,1,IDIM)
      CALL LCMPUT(IPLIST,'BURNUP',NBURNF,2,TBURN)
      CALL LCMPUT(IPLIST,'TOTAL',2*NGRP*NBURNF,2,ZTOTAL)
      CALL LCMPUT(IPLIST,'NUSIGF',2*NGRP*NBURNF,2,ZZNUG)
      CALL LCMPUT(IPLIST,'NFTOT',2*NGRP*NBURNF,2,ZNUGF)
      CALL LCMPUT(IPLIST,'CHI',2*NGRP*NBURNF,2,ZCHI)
      CALL LCMPUT(IPLIST,'OVERV',2*NGRP*NBURNF,2,ZOVERV)
      CALL LCMPUT(IPLIST,'DIFFX',2*NGRP*NBURNF,2,ZDIFFX)
      CALL LCMPUT(IPLIST,'DIFFY',2*NGRP*NBURNF,2,ZDIFFY)
      CALL LCMPUT(IPLIST,'DIFFZ',2*NGRP*NBURNF,2,ZDIFFZ)
      CALL LCMPUT(IPLIST,'H-FACTORS',2*NGRP*NBURNF,2,ZH)
      CALL LCMPUT(IPLIST,'FLUX-INTG',2*NGRP*NBURNF,2,ZFLUX)
      CALL LCMPUT(IPLIST,'SCAT',2*NL*NGRP*NGRP*NBURNF,2,ZSCAT)
*
*
      RETURN
      END
