      SUBROUTINE XSMOP(IPLIST,NAMP,IMP,IMPX)
*
*-----------------------------------------------------------------------
*
* OPEN AN EXISTING OR CREATE A NEW XSM FILE.
*
* THE XSM DATABASE RESULTS FROM THE JUXTAPOSITION OF A HIERARCHICAL
* LOGICAL STRUCTURE INTO A DIRECT ACCESS FILE WITH FIXE LENGTH RECORDS.
* THE DIRECT ACCESS FILE IS FORTRAN-77 COMPATIBLE AND IS MANAGED BY
* KDIGET/PUT/CL. XSMOP/PUT/GET/LEN/SIX/NXT/CL ENTRIES PROVIDE A SET OF
* METHODS TO ACCESS A XSM FILE.
*
* THE LOGICAL STRUCTURE OF A XSM FILE IS MADE OF A ROOT DIRECTORY FOL-
* LOWED BY VARIABLE-LENGTH BLOCKS CONTAINING THE USEFULL INFORMATION.
* EACH TIME A DIRECTORY IS FULL, AN EXTENT IS AUTOMATICALLY CREATED AT
* THE END OF THE FILE, SO THAT THE TOTAL NUMBER OF BLOCKS IN A DIREC-
* TORY IS ONLY LIMITED BY THE MAXIMUM SIZE OF THE DIRECT ACCESS FILE.
* ANY BLOCK CAN CONTAIN A SUB-DIRECTORY IN ORDER TO CREATE A HIERAR-
* CHICAL STRUCTURE.
*
* INPUT PARAMETERS:
*    NAMP : CHARACTER*12 NAME OF THE XSM FILE.
*     IMP : TYPE OF ACCESS.  =0: NEW FILE MODE;
*                            =1: MODIFICATION MODE;
*                            =2: READ ONLY MODE.
*    IMPX : IF IMPX=0, WE SUPPRESS PRINTING ON XSMOP.
*
* OUTPUT PARAMETERS:
*  IPLIST : ADDRESS OF THE HANDLE TO THE XSM FILE.
*    NAMP : CHARACTER*12 NAME OF THE XSM FILE IF IMP=1 OR IMP=2.
*
* HANDLE VARIABLES (ACTIVE DIRECTORY EXTENT):
*  CMT    : CHARACTER*12 NAMES OF THE BLOCKS STORED IN THE ACTIVE
*           DIRECTORY EXTENT.
*  IDIR   : OFFSET OF THE ACTIVE DIRECTORY EXTENT.
*  IOFMAX : DIMENSION OF VECTORS IOFSET,JLONG JTYPE, AND NMT
*  NMT    : NUMBER OF BLOCKS STORED IN THE ACTIVE DIRECTORY EXTENT.
*  LINK   : OFFSET OF THE NEXT DIRECTORY EXTENT. THE LAST EXTENT IS
*           ALWAYS LINKED TO THE FIRST ONE.
*  IROOT  : OFFSET OF AN EXTENT THAT BELONG TO THE PARENT DIRECTORY.
*           EQUAL TO -1 FOR THE ROOT DIRECTORY.
*  MYNAME : NAME OF THE ACTIVE DIRECTORY. MYNAME='/' FOR THE ROOT LEVEL.
*  IOFSET : OFFSET TABLE FOR THE ACTIVE DIRECTORY EXTENT (POSITION OF
*           THE FIRST ELEMENT OF EACH BLOCK IN THE XSM FILE).
*  JLONG  : NUMBER OF INFORMATION ELEMENTS CONTAINED IN EACH BLOCK OF
*           THE ACTIVE DIRECTORY EXTENT.
*  JTYPE  : TYPE OF INFORMATION ELEMENTS CONTAINED IN EACH BLOCK OF THE
*           ACTIVE DIRECTORY EXTENT.
*
*------------------------------------- AUTHOR: A. HEBERT ; 30/09/86 ----
*
      PARAMETER (IOFMAX=30)
      INTEGER PFXSM
      CHARACTER*(*) NAMP
      CHARACTER NAMT*12,HEADER*4,HSMG*131,MYNAME*12,CMT(IOFMAX)*12
      PARAMETER (LXNODE=15+6*IOFMAX)
      PARAMETER (IPRIM=3,IWRD=3,KLONG=5+IWRD+(3+IWRD)*IOFMAX)
*     IPRIM=OFFSET OF THE ROOT DIRECTORY.
*     KLONG=LENGTH OF A DIRECTORY EXTENT IN MEMORY.
      PARAMETER (IHEAD=0,IHNAM=1,IMODIF=4,IIFILE=5,INMT=6,ILINK=7,
     1 IIROOT=8,IIOFS=9,IJLON=9+IOFMAX,IJTYP=9+2*IOFMAX,
     2 IIDIR=9+3*IOFMAX,IIOFT=10+3*IOFMAX,IIMPF=11+3*IOFMAX,
     3 IMYNAM=12+3*IOFMAX,ICMT=15+3*IOFMAX)
      LOGICAL LBASE(1)
      COMMON IBASE(1)
      EQUIVALENCE (IBASE(1),LBASE(1))
*
* OPEN THE XSM FILE.
      NAMT=NAMP
      IF((IMP.LT.0).OR.(IMP.GT.2)) THEN
         WRITE(HSMG,'(23HXSMOP: INVALID ACTION (,I3,15H) ON XSM FILE '',
     1   A12,2H''.)') IMP,NAMT
         CALL XABORT(HSMG)
      ENDIF
      CALL SETARA(IBASE,LXNODE,PFXSM)
      IBASE(PFXSM+IHEAD)=200
      IBASE(PFXSM+IIMPF)=IMP
      READ(NAMT,'(3A4)') (IBASE(PFXSM+IHNAM+I),I=0,2)
      IUNIT=KDROPN(NAMT,IMP,1,0,PFXSM)
      IF(IUNIT.LE.0) THEN
         WRITE(HSMG,'(32HXSMOP: UNABLE TO OPEN XSM FILE '',A12,
     1   8H'' (IER =,I3,2H).)') NAMT,IUNIT
         CALL XABORT(HSMG)
      ENDIF
      IBASE(PFXSM+IIFILE)=IUNIT
      IF(IMPX.GT.1) WRITE (6,'(/23H XSMOP: KDI FILE OPEN =,I5,
     1 8H NAME ='',A12,10H'' ACTION =,I3)') IBASE(PFXSM+IIFILE),NAMT,IMP
      IF(IMP.GE.1) THEN
*        RECOVER THE ROOT DIRECTORY IF THE XSM FILE ALREADY EXISTS.
         CALL KDIGET(IBASE(PFXSM+IIFILE),IBUF,0,1,IRC)
         IF(IRC.NE.0) GO TO 140
         WRITE (HEADER,'(A4)') IBUF
         IF(HEADER.NE.'$XSM') THEN
            WRITE(HSMG,'(33HXSMOP: WRONG HEADER ON XSM FILE '',A12,2H''.
     1      )') NAMT
            CALL XABORT(HSMG)
         ENDIF
         CALL KDIGET(IBASE(PFXSM+IIFILE),IBASE(PFXSM+IIOFT),1,1,IRC)
         IF(IRC.NE.0) GO TO 140
         CALL KDIGET(IBASE(PFXSM+IIFILE),IBASE(PFXSM+IIDIR),2,1,IRC)
         IF(IRC.NE.0) GO TO 140
         CALL XSMDIR(1,IBASE(PFXSM+IIFILE),CMT,IBASE(PFXSM+INMT),
     1   IBASE(PFXSM+ILINK),IBASE(PFXSM+IIROOT),MYNAME,
     2   IBASE(PFXSM+IIOFS),IBASE(PFXSM+IJLON),IBASE(PFXSM+IJTYP),
     3   IBASE(PFXSM+IIDIR))
         READ(MYNAME,'(3A4)') (IBASE(PFXSM+IMYNAM+I),I=0,2)
         DO 10 J=1,IBASE(PFXSM+INMT)
         READ(CMT(J),'(3A4)') (IBASE(PFXSM+ICMT+(J-1)*3+I),I=0,2)
   10    CONTINUE
         LBASE(PFXSM+IMODIF)=.FALSE.
         IF(IMPX.GT.0) WRITE (6,180) NAMP,IBASE(PFXSM+IIOFT),MYNAME
      ELSE
         IBASE(PFXSM+IIMPF)=IMP
         IBASE(PFXSM+IIOFT)=IPRIM+KLONG
         IBASE(PFXSM+IIDIR)=IPRIM
         IBASE(PFXSM+IIROOT)=-1
         IBASE(PFXSM+INMT)=0
         IBASE(PFXSM+ILINK)=IBASE(PFXSM+IIDIR)
         MYNAME='/'
         READ(MYNAME,'(3A4)') (IBASE(PFXSM+IMYNAM+I),I=0,2)
         LBASE(PFXSM+IMODIF)=.TRUE.
         HEADER='$XSM'
         READ (HEADER,'(A4)') IBUF
         CALL KDIPUT(IBASE(PFXSM+IIFILE),IBUF,0,1,IRC)
         IF(IRC.NE.0) GO TO 150
         CALL KDIPUT(IBASE(PFXSM+IIFILE),IBASE(PFXSM+IIOFT),1,1,IRC)
         IF(IRC.NE.0) GO TO 150
         CALL KDIPUT(IBASE(PFXSM+IIFILE),IBASE(PFXSM+IIDIR),2,1,IRC)
         IF(IRC.NE.0) GO TO 150
      ENDIF
      IPLIST=PFXSM
      RETURN
*
  140 WRITE(HSMG,'(23HXSMOP: KDIGET ERROR NB.,I6,14H ON XSM FILE '',A12,
     1 2H''.)') IRC,NAMT
      CALL XABORT(HSMG)
  150 WRITE(HSMG,'(23HXSMOP: KDIPUT ERROR NB.,I6,14H ON XSM FILE '',A12,
     1 2H''.)') IRC,NAMT
      CALL XABORT(HSMG)
  180 FORMAT (/35H XSMOP: XSM FILE RECOVERY. FILE = ',A8,1H'/27X,
     1 28HHIGHEST ATTAINABLE ADDRESS =,I10/27X,20HACTIVE DIRECTORY = ',
     2 A12,1H'/)
      END
