*DECK ALDLFV
      SUBROUTINE ALDLFV (NG,L4,ASS,MU1,T)
*
*-----------------------------------------------------------------------
*
* IN-PLACE L-D-L(T) FACTORIZATION OF *NG* SYMMETRIC POSITIVE DEFINITE
* MATRIX IN COMPRESSED DIAGONAL STORAGE MODE.
*
* INPUT PARAMETERS:
*    L4 : ORDER OF THE COEFFICIENT MATRIX.
*   ASS : COEFFICIENT MATRIX IN COMPRESSED DIAGONAL STORAGE MODE.
*         A(I,J)=ASS(MU1(I)-I+J) IF J.LE.I AND J.GT.I+MU1(I-1)-MU1(I)
*               =A(J,I)          IF I.LT.J
*               =0.0             ELSE
*         DIMENSION ASS(NG,MU1(L4)-MU1(1)+1)
*   MU1 : POSITION OF EACH DIAGONAL ELEMENT IN VECTOR ASS.
*         DIMENSION MU1(L4)
*     T : WORKING-SPACE VECTOR. DIMENSION T(NG,2)
*
* OUTPUT PARAMETER:
*   ASS : LU FACTORS.
*
*-------------------------------------- MODIFY: R. ROY ;    17/09/96 ---
*
      IMPLICIT NONE
      INTEGER NG,L4,MU1(*)
      DOUBLE PRECISION ASS(NG,*),T(NG,2)
      INTEGER IG,K,K1,KM,KMM,KLL,I,IM,IMIN,J,I1
      DO 20 IG= 1,NG
         ASS(IG,MU1(1))=1.D0/ASS(IG,MU1(1))
   20 CONTINUE
      IF( L4.NE.1 )THEN
         DO 10 K=2,L4
            KLL= K-1
            K1= MU1(K)-K
            KM= MU1(K-1)+1-K1
            KMM= KM+1
            IF (KMM-K) 4,3,7
 4          CONTINUE
            DO 2 I=KMM,KLL
               DO 21 IG=1,NG
                  T(IG,1)=ASS(IG,K1+I)
                  ASS(IG,K1+I)=0.0D0
                  T(IG,2)=0.0D0
   21          CONTINUE
               I1=MU1(I)-I
               IM=MU1(I-1)+1-I1
               IMIN=MAX0(IM,KM)
               DO 5 J=IMIN,I
                 DO 22 IG=1,NG
                    T(IG,2)=T(IG,2)+ASS(IG,K1+J)*ASS(IG,I1+J)
   22             CONTINUE
 5             CONTINUE
               DO 23 IG=1,NG
                  ASS(IG,K1+I)=T(IG,1)-T(IG,2)
   23          CONTINUE
 2          CONTINUE
 3          CONTINUE
            DO 24 IG=1,NG
               T(IG,2)=0.0D0
   24       CONTINUE
            DO 6 I=KM,KLL
               DO 25 IG=1,NG
                  T(IG,1)=ASS(IG,K1+I)
                  ASS(IG,K1+I)=T(IG,1)*ASS(IG,MU1(I))
                  T(IG,2)=T(IG,2)+T(IG,1)*ASS(IG,K1+I)
   25          CONTINUE
 6          CONTINUE
            DO 26 IG=1,NG
               ASS(IG,MU1(K))=ASS(IG,MU1(K))-T(IG,2)
   26       CONTINUE
 7          CONTINUE
            DO 27 IG=1,NG
               ASS(IG,MU1(K))=1.D0/ASS(IG,MU1(K))
   27       CONTINUE
 10      CONTINUE
      ENDIF
      RETURN
      END
