*DECK IQSFG
      SUBROUTINE IQSFG (N,Y,F,NGRP,P00,P01,P10,P11,PB00,PB01,PB10,PB11,
     1 R0CPC,TERM,AB,B,DERCON,R0,DERLOG,PR)
C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C      KAPS AND RENTROP INTEGRATION METHOD FOR STIFF SYSTEMS OF
C      ORDINARY DIFFERENTIAL EQUATIONS
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C     THIS SUBROUTINE COMPUTES THE  VECTOR  F(Y)= DY/DT  FOR THE GQS
C     METHOD AND THETA METHOD FOR PRECURSOR EQUATIONS.
C     INPUT PARAMETERS :
C
C     Y                : AMPLITUDE EQUATIONS
C     N                : NUMBER OF EQUATIONS
C     NGRP             : NUMBER OF ENERGY GROUP
C     OUTPUT PARAMETERS:
C     F                :  THE FIRST DERIVATIVE OF Y
C     WORK SPACE MEMORY:
C     PR               : DIMENSION PR(2*NGRP)
C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC AUTHOR: M.T. SISSAOUI ; 15/09/94 CCC
C
      DOUBLE PRECISION Y(N), F(N)
      COMMON BB(1)
      COMMON/CPCOM/ DTMACR,DMCM1,IDECR,IBETA,NDG,ITRAN,BETATD,DRHO
      DOUBLE PRECISION PB00(NGRP,NGRP),PB01(NGRP,NGRP),
     x PB10(NGRP,NGRP),PB11(NGRP,NGRP),
     x P00(NGRP,NGRP), P01(NGRP,NGRP), P10(NGRP,NGRP),
     x P11(NGRP,NGRP),R0CPC(NGRP),TERM(NGRP)
      DOUBLE PRECISION  DTMACR,DMCM1
      DOUBLE PRECISION  AB(NGRP,NGRP),B(NGRP,NGRP),DERCON(NGRP),
     x R0(NGRP),DERLOG(NGRP),PR(NGRP)
      DOUBLE PRECISION  D0,D1,D0D0,D0D1,D1D1,BETATD,DRHO
C
C DETERMINATION OF THE TIME FUNCTIONS
      D1 = Y(N)*DMCM1
      D0 = 1.0D0 - D1
      IF(ITRAN.EQ.2) THEN
        D0D0 = D0*D0
        D0D1 = D0*D1
        D1D1 = D1*D1
        DO 100 J=1,NGRP
        DO 100 I=1,NGRP
          B(I,J) = PB00(I,J)*D0  +PB01(I,J)*D1  +
     x             PB10(I,J)*D0D1+PB11(I,J)*D1D1
            AB(I,J)= P00(I,J)*D0   +P01(I,J)*D1+
     x               P10(I,J)*D0D1 +P11(I,J)*D1D1
100     CONTINUE
      ELSE IF(ITRAN.EQ.1) THEN
        D0D0 = D0
        D0D1 = D1
        D1D1 = 1.0D0
        DO 110 J=1,NGRP
        DO 110 I=1,NGRP
          B(I,J)=PB00(I,J)*D0 +PB01(I,J)*D1+
     x          PB10(I,J)*D0  +PB11(I,J)*D1
           AB(I,J)=P00(I,J)*D0 +P01(I,J)*D1+
     x           P10(I,J)*D0   +P11(I,J)*D1
110     CONTINUE
      ELSE
        D0D0 = D0
        D0D1 = D1
        D1D1 = 1.0D0
      ENDIF
C
      DO 201 I=1,NGRP
      DERCON(I) = ( TERM(I) - 1.D0/R0CPC(I) )/DTMACR
      R0(I)     = 1.D0/(1.D0/R0CPC(I) + DERCON(I)*Y(N))
      DERLOG(I) = DERCON(I)*R0(I)
 201  CONTINUE
*      DERCON(2) = ( TERM(2) - 1.D0/R0CPC(2) )/DTMACR
*      R0(2)     = 1.D0/(1.D0/R0CPC(2) + DERCON(2)*Y(N))
*      DERLOG(2) = DERCON(2)*R0(2)
C
C COMPUTE THE DERIVATIVE OF THE PRECURSORS CONSENTRATION
      DO 104 IGR=1,NGRP
      PR(IGR)=0.0D0
 104    CONTINUE
      DO 250 II=1,N
      F(II)=0.0D0
 250  CONTINUE
      DO 10 I = 1, NDG
      DO 105 IGR=1,NGRP
      INP=(IGR-1)*NDG
      DO 101 J=1,NGRP
       F(I + NGRP +INP) = F(I + NGRP +INP) +
     x DBLE(BB(IBETA-1+I))*B(IGR,J)*Y(J)*R0(IGR)
101    CONTINUE
       F(I + NGRP +INP) = F(I + NGRP +INP) -
     x DBLE(BB(IDECR-1+I))*Y(I+NGRP+INP)-
     x DERLOG(IGR)*Y(I+NGRP+INP)
       PR(IGR)=PR(IGR)+
     x  DBLE(BB(IDECR-1+I))*Y(I+NGRP+INP)
105    CONTINUE
10    CONTINUE
C
C COMPUTE THE DERIVATIVE OF THE AMPLITUDE
      DO 102 IGR=1,NGRP
      DO 103 JGR=1,NGRP
      F(IGR)= F(IGR) + AB(IGR,JGR)*R0(IGR)*Y(JGR)
 103    CONTINUE
      F(IGR)=F(IGR)-DERLOG(IGR)*Y(IGR)+PR(IGR)
 102    CONTINUE
C
C COMPUTE THE DERIVATIVE OF GAMMA(i)
      TEMP1 = Y(N) - DTMACR
      DO 21 IGR=1,NGRP
      IND1=NGRP*(NDG+1)+3*NDG*(IGR-1)
      IND2=NGRP*(NDG+1)+3*NDG*(IGR-1)+NDG
      IND3=NGRP*(NDG+1)+3*NDG*(IGR-1)+2*NDG
      DO 20 I=1, NDG
        TEMP2 = Y(IGR)*EXP(DBLE(BB(IDECR - 1 + I))*TEMP1)
        F(I + IND1) = TEMP2*D0D0
        F(I + IND2) = TEMP2*D0D1
        F(I + IND3) = TEMP2*D1D1
20    CONTINUE
21    CONTINUE
C COMPUTE THE DERIVATIVE OF THE TIME FUNCTION DTAU/DT=1
      F(N)=1.D0
C
      RETURN
      END
