*DECK IQSFI
       SUBROUTINE IQSFI (N,Y,F,NGRP,
     x P00,P01,P10,P11,PB00,PB01,PB10,PB11,R0CPC,TERM)
C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C      KAPS AND RENTROP INTEGRATION METHOD FOR STIFF SYSTEMS OF
C      ORDINARY DIFFERENTIAL EQUATIONS
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C     THIS SUBROUTINE COMPUTES THE  VECTOR  F(Y)= DY/DT FOR THE IQS
C     METHOD AND GAMMA METHOD FOR PRECURSORS.
C     INPUT PARAMETERS :
C
C     Y                : AMPLITUDE EQUATIONS
C     N                : NUMBER OF EQUATIONS
C     NGRP             : NUMBER OF ENERGY GROUPS
C     OUTPUT PARAMETERS:
C     F                : THE FIRST DERIVATIVE OF Y
C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC AUTHOR: M.T. SISSAOUI; 15/01/94 CCCCCC
C
      DOUBLE PRECISION Y(N), F(N)
      COMMON BB(1)
      COMMON/CPCOM/DTMACR,DMCM1,
     x IDECR,IBETA,NDG,ITRAN,BETATD,DRHO
      DOUBLE PRECISION PB00(NGRP,NGRP),PB01(NGRP,NGRP),
     x PB10(NGRP,NGRP),PB11(NGRP,NGRP),
     x P00(NGRP,NGRP), P01(NGRP,NGRP), P10(NGRP,NGRP),
     x P11(NGRP,NGRP),R0CPC(NGRP),TERM(NGRP)
      DOUBLE PRECISION  DTMACR,DMCM1
      DOUBLE PRECISION D0,D1,D0D0,D0D1,D1D1,TEMP,TEMPA,TEMPB,TEMP1,
     1                 TEMP2
      DOUBLE PRECISION R0,DERCON
      DOUBLE PRECISION AGEN0,AGEN1,RHO0,RHO1,BETATD,DRHO
C
C DETERMINATION  OF THE TIME FUNCTION
      D1 = Y(N)*DMCM1
      D0 = 1.0 - D1
      IF(ITRAN.EQ.2) THEN
        D0D0 = D0*D0
        D0D1 = D0*D1
        D1D1 = D1*D1
        TEMPA = 0.0
        TEMPB = 0.0
        DO 100 J=1,NGRP
        DO 100 I=1,NGRP
          TEMPB=PB00(I,J)*D0  +PB01(I,J)*D1  +
     &          PB10(I,J)*D0D1+PB11(I,J)*D1D1+ TEMPB
           TEMPA=P00(I,J)*D0   +P01(I,J)*D1   +
     &           P10(I,J)*D0D1 +P11(I,J)*D1D1 + TEMPA
100     CONTINUE
        DERCON = ( TERM(1)- 1.D0/R0CPC(1) )/DTMACR
*        DERCON = ( TERM- 1.D0/R0CPC(1) )/DTMACR
        R0     = 1.D0/(1.D0/R0CPC(1) + DERCON*Y(N))
        DERLOG = DERCON*R0
      ELSE IF(ITRAN.EQ.1) THEN
        D0D0 = D0
        D0D1 = D1
        D1D1 = 1.0
        TEMPA = 0.0
        TEMPB = 0.0
        DO 110 J=1,NGRP
        DO 110 I=1,NGRP
          TEMPB=PB00(I,J)*D0  +PB01(I,J)*D1  +
     &          PB10(I,J)*D0  +PB11(I,J)*D1  + TEMPB
           TEMPA=P00(I,J)*D0   +P01(I,J)*D1   +
     &           P10(I,J)*D0   +P11(I,J)*D1   + TEMPA
110     CONTINUE
        DERCON = ( TERM(1)- 1.D0/R0CPC(1) )/DTMACR
        R0     = 1.D0/(1.D0/R0CPC(1) + DERCON*Y(N))
        DERLOG = DERCON*R0
      ELSE IF(ITRAN.EQ. 3) THEN
        D0D0 = D0
        D0D1 = 0.D0
        D1D1 = D1
*       COMPUTE INITIAL REACTIVITY AND FINAL REACTIVITY
        AGEN0= 0.D0
        AGEN1= 0.D0
        RHO0 = 0.D0
        RHO1 = 0.D0
        DO 200 J=1,NGRP
         DO 200 I=1,NGRP
          AGEN0=PB00(I,J)     + AGEN0
          AGEN1=PB01(I,J)     + PB11(I,J)     + AGEN1
           RHO0 =P00(I,J)     + RHO0
           RHO1 =P01(I,J)     + P11(I,J)      + RHO1
200     CONTINUE
        RHO0 = (RHO0 + BETATD*AGEN0)/AGEN0
        RHO1 = (RHO1 + BETATD*AGEN1)/AGEN1
        IF( Y(N).EQ. 0.D0) THEN
          WRITE(6,*) ' INITIAL REACTIVITY = ',RHO0
          WRITE(6,*) ' INITIAL GENERATION = ',TERM(1)/AGEN0
          WRITE(6,*) '         REACTIVITY = ',RHO1
          WRITE(6,*) '         GENERATION = ',TERM(1)/AGEN1
          WRITE(6,*) '                NDG = ',NDG
        ENDIF
        TEMPA =(RHO0*D0 + RHO1*D1 - BETATD)*AGEN1
        TEMPB = AGEN1
        R0    = 1.D0/TERM(1)
        DERLOG =0.D0
*       DERCON = ( TERM(1)- 1.D0/R0CPC(1) )/DTMACR
*       DERLOG = DERCON*R0
      ELSE
        CALL XABORT('IQSFI: OPTION NOT SUPPPORTED.')
      ENDIF
C
C COMPUTE THE DERIVATIVE OF THE PRECURSORS CONSENTRATION
      TEMP = 0.0
      DO 10 I = 1, NDG
        F(I + 2) =  DBLE(BB(IBETA-1+I))*TEMPB*Y(1)*R0
     1            - (DBLE(BB(IDECR- 1+I))+DERLOG)*Y(I + 2)
        TEMP      = (DBLE(BB(IDECR- 1+I)))*Y(I + 2) + TEMP
10    CONTINUE
C
C COMPUTE THE DERIVATIVE OF THE AMPLITUDE
      F(1) =  ((TEMPA-DRHO)*R0-DERLOG)*Y(1)    + TEMP
      F(2) =  0.D0
      IOFF1 =   NDG+2
      IOFF2 = 2*NDG+2
      IOFF3 = 3*NDG+2
      TEMP1 = Y(N) - DTMACR
C
C  COMPUTE THE DERIVATIVE OF THE TIME DTAU/DT=1
       F(N)=1.D0
C
C COMPUTE THE DERIVATIVE OF GAMMA(i)
      DO 20 I=1, NDG
        TEMP2 = Y(1)*EXP(DBLE(BB(IDECR - 1 + I))*TEMP1)
        F(I + IOFF1) = TEMP2*D0D0
        F(I + IOFF2) = TEMP2*D0D1
        F(I + IOFF3) = TEMP2*D1D1
20    CONTINUE
      RETURN
      END
