*DECK IQSFPG
      SUBROUTINE IQSFPG (N,Y,FP,NGRP,P00,P01,P10,P11,PB00,PB01,PB10,
     1 PB11,R0CPC,TERM,AB,ABV,B,BV,DERCON,R0,DERLOG,R0V,DERLOGV)
C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C      KAPS AND RENTROP INTEGRATION METHOD FOR STIFF SYSTEMS OF
C      ORDINARY DIFFERENTIAL EQUATIONS
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C     THIS SUBROUTINE COMPUTES THE JACOBIAN MATRIX FOR THE GQS METHOD.
C     THE MATRIX HAS THE FOLLOWING FORM:
C                    FP(Y) = DF(Y)/DY
C     INPUT PARAMETERS :
C
C     Y                : AMPLITUDE EQUATIONS
C     N                : NUMBER OF EQUATIONS
C     NGRP             : NUMBER OF ENERGY GROUPS
C     OUTPUT PARAMETERS:
C     FP               : JACOBIAN ( N X N ) MATRIX
C
CCCCCCCCCCCCCCCCCCCCCCCCCCCC AUTHOR: M.T. SISSAOUI; 15/09/94  CCCCCCC
C
      DOUBLE PRECISION Y(N), FP(N,N)
      COMMON BB(1)
      COMMON/CPCOM/ DTMACR,DMCM1,IDECR,
     x              IBETA,NDG,ITRAN,BETATD,DRHO
      DOUBLE PRECISION PB00(NGRP,NGRP),PB01(NGRP,NGRP),
     x PB10(NGRP,NGRP),PB11(NGRP,NGRP),
     x P00(NGRP,NGRP), P01(NGRP,NGRP), P10(NGRP,NGRP),
     x P11(NGRP,NGRP),R0CPC(NGRP),TERM(NGRP)
      DOUBLE PRECISION DTMACR,DMCM1,BETATD,DRHO
      DOUBLE PRECISION  AB(NGRP,NGRP),B(NGRP,NGRP),
     x ABV(NGRP,NGRP),BV(NGRP,NGRP),DERCON(NGRP),R0(NGRP),
     x DERLOG(NGRP),R0V(NGRP),DERLOGV(NGRP)
      DOUBLE PRECISION  D0,D1,D0D0,D0D1,D1D1,DV0,DV1,D0DV0,
     x D0DV1,D1DV1,TEMP1,TEMP2,TEMP21,TEMP2V
C
C DETERMINATION OF THE TIME FUNCTIONS
      D1 = Y(N)*DMCM1
      D0 = 1.0D0 - D1
      DV1 = 1.D0*DMCM1
      DV0 = -1.D0*DMCM1
      IF(ITRAN.EQ.2) THEN
        D0D0 = D0*D0
        D0D1 = D0*D1
        D1D1 = D1*D1
        D0DV0 = 2*DV0*D0
        D0DV1 = DV0*D1+D0*DV1
        D1DV1 = 2*DV1*D1
        DO 100 J=1,NGRP
        DO 100 I=1,NGRP
          B(I,J) = PB00(I,J)*D0  +PB01(I,J)*D1  +
     &             PB10(I,J)*D0D1+PB11(I,J)*D1D1
          BV(I,J) = PB00(I,J)*DV0  +PB01(I,J)*DV1  +
     &             PB10(I,J)*D0DV1+PB11(I,J)*D1DV1
            AB(I,J)= P00(I,J)*D0   +P01(I,J)*D1+
     &               P10(I,J)*D0D1 +P11(I,J)*D1D1
            ABV(I,J)= P00(I,J)*DV0   +P01(I,J)*DV1+
     &               P10(I,J)*D0DV1 +P11(I,J)*D1DV1
100     CONTINUE
      ELSE IF(ITRAN.EQ.1) THEN
        D0D0 = D0
        D0D1 = D1
        D1D1 = 1.0D0
        D0DV0 = DV0
        D0DV1 = DV1
        D1DV1 = 0.0
        DO 110 J=1,NGRP
        DO 110 I=1,NGRP
          B(I,J)=PB00(I,J)*D0 +PB01(I,J)*D1+
     &          PB10(I,J)*D0  +PB11(I,J)*D1
          BV(I,J)=PB00(I,J)*DV0 +PB01(I,J)*DV1+
     &          PB10(I,J)*DV0  +PB11(I,J)*DV1
           AB(I,J)=P00(I,J)*D0 +P01(I,J)*D1+
     &           P10(I,J)*D0   +P11(I,J)*D1
           ABV(I,J)=P00(I,J)*DV0 +P01(I,J)*DV1+
     &           P10(I,J)*DV0   +P11(I,J)*DV1
110     CONTINUE
      ELSE
        D0D0 = D0
        D0D1 = D1
        D1D1 = 1.0D0
      ENDIF
C
      DO 201 I=1,NGRP
      DERCON(I) = ( TERM(I) - 1.D0/R0CPC(I) )/DTMACR
      R0(I)     = 1.D0/(1.D0/R0CPC(I) + DERCON(I)*Y(N))
      R0V(I)     = (1.D0/R0CPC(I) + DERCON(I)*Y(N))**2
        R0V(I)     = -DERCON(I)/R0V(I)
      DERLOG(I) = DERCON(I)*R0(I)
      DERLOGV(I) = DERCON(I)*R0V(I)
 201  CONTINUE
      TEMP = 0.0D0
C
C COMPUTE THE JACOBIAN MATRIX
       DO IN=1,N
       DO JN=1,N
       FP(IN,JN)=0.0D0
       ENDDO
       ENDDO
C PRECURSORS
      DO 10 I = 1, NDG
      DO 105 IGR=1,NGRP
      INP=(IGR-1)*NDG+NGRP
      DO 101 J=1,NGRP
      INJ=(J-1)*NDG+NGRP
      FP(I+INP,J)= DBLE(BB(IBETA-1+I))*B(IGR,J)*R0(IGR)
      FP(IGR,I+INJ)= DBLE(BB(IDECR-1+I))
      FP(I+INP,I+INJ)=-(DBLE(BB(IDECR-1+I))+DERLOG(IGR))
      FP(I+INP,N)=DBLE(BB(IBETA-1+I))*BV(IGR,J)*Y(J)*R0(IGR)+
     x  DBLE(BB(IBETA-1+I))*B(IGR,J)*Y(J)*R0V(IGR)+
     x  DERLOGV(IGR)*Y(I+INJ)+FP(I+INP,N)
101   CONTINUE
105   CONTINUE
10    CONTINUE
C AMPLITUDES
      DO 103 IGR=1,NGRP
      DO 104 JGR=1,NGRP
      FP(IGR,JGR)= AB(IGR,JGR)*R0(IGR)
      FP(IGR,N) = ABV(IGR,JGR)*R0(IGR)*Y(JGR)+
     x AB(IGR,JGR)*R0V(IGR)*Y(JGR)+FP(IGR,N)
      IF(IGR.EQ.JGR) THEN
      FP(IGR,JGR)=FP(IGR,JGR)-DERLOG(IGR)
      FP(IGR,N)=FP(IGR,N)-DERLOG(IGR)*Y(IGR)
      ENDIF
 104  CONTINUE
 103  CONTINUE
C GAMMA(I) TERMS
      TEMP1 = Y(N) - DTMACR
      DO 21 IGR=1,NGRP
      IND1=NGRP*(NDG+1)+3*NDG*(IGR-1)
      IND2=NGRP*(NDG+1)+3*NDG*(IGR-1)+NDG
      IND3=NGRP*(NDG+1)+3*NDG*(IGR-1)+2*NDG
      DO 20 I=1, NDG
        TEMP2 = 1.0D0*EXP(DBLE(BB(IDECR - 1 + I))*TEMP1)
        TEMP21 = Y(IGR)*EXP(DBLE(BB(IDECR - 1 + I))*TEMP1)
        TEMP2V = TEMP21*DBLE(BB(IDECR - 1 + I))
        FP(I + IND1,IGR) = TEMP2*D0D0
        FP(I + IND2,IGR) = TEMP2*D0D1
        FP(I + IND3,IGR) = TEMP2*D1D1
        FP(I + IND1,N) = TEMP21*D0DV0+TEMP2V*D0D0
        FP(I + IND2,N) = TEMP21*D0DV1+TEMP2V*D0D1
        FP(I + IND3,N) = TEMP21*D1DV1+TEMP2V*D1D1
20    CONTINUE
21    CONTINUE
      RETURN
      END
