*DECK IQSFPI
       SUBROUTINE IQSFPI (N,Y,FP,NGRP,
     x P00,P01,P10,P11,PB00,PB01,PB10,PB11,R0CPC,TERM)
C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C      KAPS AND RENTROP INTEGRATION METHOD FOR STIFF SYSTEMS OF
C      ORDINARY DIFFERENTIAL EQUATIONS
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C     THIS SUBROUTINE COMPUTES THE JACOBIAN MATRIX FOR IQS METHOD
C     AND GAMME METHOD FOR PRECURSORS.
C     THE MATRIX HAS THE FOLLOWING FORM:
C                    FP(Y) = DF(Y)/DY
C     INPUT PARAMETERS :
C
C     Y                : AMPLITUDE EQUATIONS
C     N                : NUMBER OF EQUATIONS
C     NGRP             : NUMBER OF ENERGY GROUPS
C     OUTPUT PARAMETERS:
C     FP               : JACOBIAN (NXN) MATRIX
C
CCCCCCCCCCCCCCCCCCCCCCCCCC AUTHOR: M.T. SISSAOUI ; 15/01/94 CCCCCCCCCC
C
      DOUBLE PRECISION  Y(N), FP(N,N)
      COMMON BB(1)
      COMMON/CPCOM/DTMACR,DMCM1,
     x IDECR,IBETA,NDG,ITRAN,BETATD,DRHO
      DOUBLE PRECISION PB00(NGRP,NGRP),PB01(NGRP,NGRP),
     x PB10(NGRP,NGRP),PB11(NGRP,NGRP),
     x P00(NGRP,NGRP), P01(NGRP,NGRP), P10(NGRP,NGRP),
     x P11(NGRP,NGRP),R0CPC(NGRP),TERM(NGRP)
      DOUBLE PRECISION DTMACR,DMCM1
      DOUBLE PRECISION D0,D1,D0D0,D0D1,D1D1,TEMP,TEMPA,TEMPB,TEMP1,
     1                 TEMP2,DV0,DV1,TEMPBV,TEMPAV,TEMP2V,
     1                 TEMP21
      DOUBLE PRECISION R0,DERCON,R0V,DERLOG,DERLOGV,D0DV0,D0DV1,D1DV1
      DOUBLE PRECISION AGEN0,AGEN1,RHO0,RHO1,BETATD,DRHO
C
C DETERMINATION  OF THE TIME FUNCTION
      D1 = Y(N)*DMCM1
      DV1 = 1.D0*DMCM1
      D0 = 1.0 - D1
      DV0 = -1.D0*DMCM1
      IF(ITRAN.EQ.2) THEN
        D0D0 = D0*D0
        D0D1 = D0*D1
        D1D1 = D1*D1
        D0DV0 = 2*DV0*D0
        D0DV1 = DV0*D1+D0*DV1
        D1DV1 = 2*DV1*D1
        TEMPA = 0.0
        TEMPB = 0.0
        TEMPAV = 0.0
        TEMPBV = 0.0
        DO 100 J=1,NGRP
        DO 100 I=1,NGRP
          TEMPB=PB00(I,J)*D0  +PB01(I,J)*D1  +
     &          PB10(I,J)*D0D1+PB11(I,J)*D1D1+ TEMPB
          TEMPBV=PB00(I,J)*DV0  +PB01(I,J)*DV1  +
     &          PB10(I,J)*(DV0*D1+D0*DV1)
     &         +PB11(I,J)*2*DV1*D1+ TEMPBV
           TEMPA=P00(I,J)*D0   +P01(I,J)*D1   +
     &           P10(I,J)*D0D1 +P11(I,J)*D1D1 + TEMPA
           TEMPAV=P00(I,J)*DV0   +P01(I,J)*DV1   +
     &           P10(I,J)*(DV0*D1+D0*DV1)
     &           +P11(I,J)*2*DV1*D1 + TEMPAV
100     CONTINUE
        DERCON = ( TERM(1)- 1.D0/R0CPC(1) )/DTMACR
        R0     = 1.D0/(1.D0/R0CPC(1) + DERCON*Y(N))
        R0V     = (1.D0/R0CPC(1) + DERCON*Y(N))**2
        R0V     = -DERCON/R0V
        DERLOG = DERCON*R0
        DERLOGV = DERCON*R0V
      ELSE IF(ITRAN.EQ.1) THEN
        D0D0 = D0
        D0D1 = D1
        D1D1 = 1.0
        D0DV0 = DV0
        D0DV1 = DV1
        D1DV1 = 0.0
        TEMPA = 0.0
        TEMPB = 0.0
        TEMPAV = 0.0
        TEMPBV = 0.0
        DO 110 J=1,NGRP
        DO 110 I=1,NGRP
          TEMPB=PB00(I,J)*D0  +PB01(I,J)*D1  +
     &          PB10(I,J)*D0  +PB11(I,J)*D1  + TEMPB
           TEMPBV=PB00(I,J)*DV0  +PB01(I,J)*DV1  +
     &          PB10(I,J)*DV0  +PB11(I,J)*DV1  + TEMPBV
           TEMPA=P00(I,J)*D0   +P01(I,J)*D1   +
     &           P10(I,J)*D0   +P11(I,J)*D1   + TEMPA
           TEMPAV=P00(I,J)*DV0   +P01(I,J)*DV1   +
     &           P10(I,J)*DV0   +P11(I,J)*DV1   + TEMPAV
110     CONTINUE
        DERCON = ( TERM(1)- 1.D0/R0CPC(1) )/DTMACR
        R0     = 1.D0/(1.D0/R0CPC(1) + DERCON*Y(N))
        DERLOG = DERCON*R0
        R0V     = (1.D0/R0CPC(1) + DERCON*Y(N))**2
        R0V     = -DERCON/R0V
        DERLOGV = DERCON*R0V
      ELSE IF(ITRAN.EQ. 3) THEN
        D0D0 = D0
        D0D1 = 0.D0
        D1D1 = D1
        D0DV0 = DV0
        D0DV1 = 0.D0
        D1DV1 = DV1
*       COMPUTE INITIAL REACTIVITY AND FINAL REACTIVITY
        AGEN0= 0.D0
        AGEN1= 0.D0
        RHO0 = 0.D0
        RHO1 = 0.D0
        DO 200 J=1,NGRP
        DO 200 I=1,NGRP
          AGEN0=PB00(I,J)     + AGEN0
          AGEN1=PB01(I,J)     + PB11(I,J)     + AGEN1
           RHO0 =P00(I,J)     + RHO0
           RHO1 =P01(I,J)     + P11(I,J)      + RHO1
200     CONTINUE
        RHO0 = (RHO0 + BETATD*AGEN0)/AGEN0
        RHO1 = (RHO1 + BETATD*AGEN1)/AGEN1
        IF( Y(N).EQ. 0.D0) THEN
          WRITE(6,*) ' INITIAL REACTIVITY = ',RHO0
          WRITE(6,*) ' INITIAL GENERATION = ',TERM(1)/AGEN0
          WRITE(6,*) '         REACTIVITY = ',RHO1
          WRITE(6,*) '         GENERATION = ',TERM(1)/AGEN1
          WRITE(6,*) '                NDG = ',NDG
        ENDIF
        TEMPA =(RHO0*D0 + RHO1*D1 - BETATD)*AGEN1
        TEMPAV =(RHO0*DV0 + RHO1*DV1 - BETATD)*AGEN1
        TEMPB = AGEN1
        TEMPBV = 0.D0
        R0    = 1.D0/TERM(1)
        R0V    =0.D0
        DERLOG =0.D0
        DERLOGV =0.D0
      ELSE
        CALL XABORT('IQSFPI: OPTION NOT SUPPPORTED(FYPSIS).')
      ENDIF
C
C COMPUTE THE JACOBIAN MATRIX
       DO IN=1,N
       DO JN=1,N
       FP(IN,JN)=0.0
       ENDDO
       ENDDO
      TEMP = 0.0
C
C   PRECURSORS
      DO 11 I = 1, NDG
        FP(I+2,1)=  DBLE(BB(IBETA-1+I))*TEMPB*R0
        FP(1,I + 2)= DBLE(BB(IDECR- 1+I))
        FP(I+2,I+2)=- (DBLE(BB(IDECR- 1+I))+DERLOG)
        FP(I+2,N)=DBLE(BB(IBETA-1+I))*TEMPBV*Y(1)*R0
     1            + DBLE(BB(IBETA-1+I))*TEMPB*Y(1)*R0V
     1            - DERLOGV*Y(I + 2)
        TEMP      = (DBLE(BB(IDECR- 1+I)))*Y(I + 2) + TEMP
11    CONTINUE
C
C   AMPLITUDE
      FP(1,1) =  ((TEMPA-DRHO)*R0-DERLOG)
      FP(1,N)=(TEMPAV*R0+TEMPA*R0V-DERLOGV)*Y(1)
      TEMP  =  ((TEMPA-DRHO)*R0-DERLOG)*Y(1)    + TEMP
      IOFF1 =   NDG+2
      IOFF2 = 2*NDG+2
      IOFF3 = 3*NDG+2
      TEMP1 = Y(N) - DTMACR
C
C  GAMMA(I) TERMS
      DO I=1, NDG
        TEMP2 = EXP(DBLE(BB(IDECR - 1 + I))*TEMP1)
        FP(I + IOFF1,1) = TEMP2*D0D0
        FP(I + IOFF2,1) = TEMP2*D0D1
        FP(I + IOFF3,1) = TEMP2*D1D1
        TEMP21 = Y(1)*EXP(DBLE(BB(IDECR - 1 + I))*TEMP1)
        TEMP2V = TEMP21*DBLE(BB(IDECR - 1 + I))
        FP(I + IOFF1,N) = TEMP2V*D0D0+TEMP21*D0DV0
        FP(I + IOFF2,N) = TEMP2V*D0D1+TEMP21*D0DV1
        FP(I + IOFF3,N) = TEMP2V*D1D1+TEMP21*D1DV1
      ENDDO
      RETURN
      END
