*DECK IQSPRE
      SUBROUTINE IQSPRE(IPSYS0,IPSYSP,NDG,BETA,DECRAT,DTMACR,L4,EVECT,
     1 DVECT,FKEFF,ITRANB,Y,X00A1,XCPC1,X11A1,
     2 PRECP,ISW,PREC,DELSRC,NGRP,QSM,NT,LBI)
C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C                                                                      C
C   ***************************************************************    C
C   *     CALCUL CONCENTRATION PRECURSEURS ET SOURCE RETARDEE     *    C
C   ***************************************************************    C
C                                                                      C
C INPUT PARAMETERS:                                                    C
C                                                                      C
C  IPSYSP : L_SYSTEM POINTER TO DELTA SYSTEM MATRICES.                 C
C  IPSYS0 : L_SYSTEM POINTER TO UNPERTURBED SYSTEM MATRICES.           C
C  NDG    : TOTAL NUMBER OF DELAYED NEUTRON GROUPS.                    C
C  LBI    : LOGICAL VARIABLE FOR NEUTRON FISSION SPECTRUM.             C
C  BETA   : DELAYED NEUTRON FRACTION FOR EACH GROUP.                   C
C  DECRAT : DELAYED NEUTRON DECAY RATE FOR EACH GROUP.                 C
C  L4     : TOTAL NUMBER OF UNKOWNS PER GROUP.                         C
C  EVECT  : DIMENSION EVECT(NUN,NGRP)                                  C
C  DVECT  : DIMENSION DVECT(NUN,NGRP)                                  C
C  DTMACR :                                                            C
C  ITRANB :   ITRANB=0 AUCUNE VARIATION DES SECTION EFF. DE FISSION    C
C             ITRANB=1 VARIATION EN STEP DES SECTION EFF. DE FISSION   C
C             ITRANB=2 VARIATION LINEAIRE DES SECTION EFF. DE FISSION  C
C  ISW    :   ISW=1  SOURCE UPDATE                                     C
C         :   ISW.NE.1 PRECURSOR UPDATE                                C
C                                                                      C
C OUTPUT PARAMETERS:                                                   C
C                                                                      C
C  PREC   : PRECURSORS CONCENTRATIONS; DIMENSION PREC(L4,NDG,NGRP).    C
C  DELSRC : DELAYED SOURCE; DIMENSION DELSRC(L4,NGRP).                 C
C                                                                      C
C SCRATCH STORAGE:                                                     C
C  PRECP  : DIMENSION PRECP(L4,NDG,NGRP).                              C
C  X00A1  : DIMENSION X00A1(NDG,NGRP).                                 C
C  XCPC1  : DIMENSION XCPC1(NDG,NGRP).                                 C
C  XCPC1  : DIMENSION XCPC1(NDG,NGRP).                                 C
C                                                                      C
CCCCC                                                                  C
C MODIFIED BY M.T. SISSAOUI ; 28/07/94                                 C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC AUTEUR: G. PEPIN ; 07/05/87 CCCCC
C
      DIMENSION BETA(NDG),DECRAT(NDG),EVECT(L4,NGRP),PREC(L4,NDG,NGRP)
     2         ,DVECT(L4,NGRP),DELSRC(L4,NGRP),PRECP(L4,NDG,NGRP)
      DOUBLE PRECISION X00A1(NDG,NGRP),XCPC1(NDG,NGRP),X11A1(NDG,NGRP)
     3                 ,Y(NT)
      DOUBLE PRECISION Y00A1,YCPC1,Y11A1
      DOUBLE PRECISION TEMP1,TEMP2,BETDEC
      CHARACTER*12 NAME,NAMLCM,NAMMY,NAMB
      LOGICAL LCM,LCM0,QSM,LBI
      COMMON BASE(1)
C ON CALCULE LE SOURCE DONC ON LE MET A ZERO
C ICI ON DEVRAIT PERMUTER LA BOUCLE  ET .EQ.2......
       DO 200 IGR=1,NGRP
       IND1=NGRP*(NDG+1)+3*NDG*(IGR-1)
      IND2=NGRP*(NDG+1)+3*NDG*(IGR-1)+NDG
      IND3=NGRP*(NDG+1)+3*NDG*(IGR-1)+2*NDG
      IND=3*(IGR-1)*NDG
      DO 201 I=1,NDG
      IF(QSM) THEN
      X00A1(I,IGR)= Y(I+2+NDG)
      XCPC1(I,IGR)= Y(I+2+2*NDG)
      X11A1(I,IGR)= Y(I+2+3*NDG)
      ELSE
      X00A1(I,IGR)= Y(I+IND1)
      XCPC1(I,IGR)= Y(I+IND2)
      X11A1(I,IGR)= Y(I+IND3)
      ENDIF
      DO 202 J=1,L4
      EX = EXP(-DECRAT(I)*DTMACR)
      PRECP(J,I,IGR)=DBLE(PREC(J,I,IGR)*EX)
 202  CONTINUE
 201  CONTINUE
 200  CONTINUE
* SET  DELSRC TO ZERO
      DO 161 IGR=1,NGRP
      DO 151 I=1,L4
 151  DELSRC(I,IGR)  =  0.0
 161  CONTINUE
****
      NAME=' '
      CALL LCMNXT(IPSYSP,NAME,NAMLCM,NAMMY,LCM)
      NAME=' '
      CALL LCMNXT(IPSYS0,NAME,NAMLCM,NAMMY,LCM0)
*
      IF(ITRANB.EQ.1 .OR.  ITRANB.EQ.0 ) THEN
      WRITE(6,*) ' USING STEP UPDATE'
      IF(ITRANB.EQ.0) WRITE(6,*) ' OPTION NOT WORKING'
*                  DELAYED SOURCE FOR STEP TRANSIENT
*                  *********************************
      IF( ISW.EQ.1 ) THEN
       IF(LBI) THEN
       DO 832 IGR= 1,NGRP
       DO 905 I=1,NDG
       BETDEC =  DBLE(BETA(I)*DECRAT(I))
       TEMP1= BETDEC*X00A1(I,IGR)
*
      DO 933 JGR=1,NGRP
      WRITE(NAMB,'(1HB,I3,I3,I3)') I,IGR,JGR
      CALL LCMLEN(IPSYSP,NAMB,LENGB,ITYLCM)
      IF(LCM) THEN
*        IN-CORE STORAGE.
         IF(LENGB.GT.0) I1B=LCMIOF(IPSYSP,NAMB)
      ELSE
*        XSM STORAGE.
         IF(LENGB.GT.0) CALL SETARA(BASE,LENGB,I1B)
         IF(LENGB.GT.0) CALL LCMGET(IPSYSP,NAMB,BASE(I1B))
      ENDIF
        IF(LENGB.GT.0) THEN
        DO 910 J=1,L4
        DELSRC(J,IGR)=DELSRC(J,IGR)+
     x  (TEMP1*DBLE(BASE(I1B-1+J)*EVECT(J,JGR)))/FKEFF
 910     CONTINUE
        IF(.NOT.LCM) THEN
        CALL RLSARA(BASE(I1B))
        ENDIF
        ENDIF
 933    CONTINUE
 905    CONTINUE
*
        DO 915 I=1,NDG
        EX = EXP(-DECRAT(I)*DTMACR)*DECRAT(I)
        DO 915 J=1,L4
        DELSRC(J,IGR)=DBLE(PREC(J,I,IGR)*EX)+DELSRC(J,IGR)
 915     CONTINUE
 832    CONTINUE
***
       ELSE
***
       DO 132 IGR= 1,NGRP
       TEMP1 = 0.D0
       TEMP2 = 0.D0
       DO 5 I=1,NDG
       BETDEC =  DBLE(BETA(I)*DECRAT(I))
       TEMP1= BETDEC*X00A1(I,IGR)+TEMP1
 5     CONTINUE
*
      DO 33 JGR=1,NGRP
      WRITE(NAMB,'(1HB,I3,I3)') IGR,JGR
      CALL LCMLEN(IPSYSP,NAMB,LENGB,ITYLCM)
      IF(LCM) THEN
*        IN-CORE STORAGE.
         IF(LENGB.GT.0) I1B=LCMIOF(IPSYSP,NAMB)
      ELSE
*        XSM STORAGE.
         IF(LENGB.GT.0) CALL SETARA(BASE,LENGB,I1B)
         IF(LENGB.GT.0) CALL LCMGET(IPSYSP,NAMB,BASE(I1B))
      ENDIF
        IF(LENGB.GT.0) THEN
        DO 10 I=1,L4
        DELSRC(I,IGR)=DELSRC(I,IGR)+
     x  (TEMP1*DBLE(BASE(I1B-1+I)*EVECT(I,JGR)))/FKEFF
 10     CONTINUE
        IF(.NOT.LCM) THEN
        CALL RLSARA(BASE(I1B))
        ENDIF
        ENDIF
 33     CONTINUE
*
        DO 15 I=1,NDG
        EX = EXP(-DECRAT(I)*DTMACR)*DECRAT(I)
        DO 15 J=1,L4
        DELSRC(J,IGR)=DBLE(PREC(J,I,IGR)*EX)+DELSRC(J,IGR)
 15     CONTINUE
 132    CONTINUE
***
        ENDIF
***
       ELSE
*                  UPDATE PRECURSOR STEP TRANSIENT
*                  *******************************
         DO 21 IGR=1,NGRP
         DO 22 JGR=1,NGRP
         DO 820 I=1,NDG
         IF(LBI) THEN
         WRITE(NAMB,'(1HB,I3,I3,I3)') I,IGR,JGR
         ELSE
         WRITE(NAMB,'(1HB,I3,I3)') IGR,JGR
         ENDIF
         CALL LCMLEN(IPSYSP,NAMB,LENGB,ITYLCM)
      IF(LCM) THEN
*        IN-CORE STORAGE.
         IF(LENGB.GT.0) I1B=LCMIOF(IPSYSP,NAMB)
      ELSE
*        XSM STORAGE.
         IF(LENGB.GT.0) CALL SETARA(BASE,LENGB,I1B)
         IF(LENGB.GT.0) CALL LCMGET(IPSYSP,NAMB,BASE(I1B))
      ENDIF
         IF(LENGB.GT.0) THEN
         DO 20 J=1,L4
         EX = EXP(-DECRAT(I)*DTMACR)
         Y00A1 = X00A1(I,IGR)*BETA(I)
         YCPC1 = XCPC1(I,IGR)*BETA(I)
         PRECP(J,I,IGR)=PRECP(J,I,IGR)  +
     &   (Y00A1*DBLE(BASE(I1B-1+J)*EVECT(J,JGR))
     &   +YCPC1*DBLE(BASE(I1B-1+J)*DVECT(J,JGR)))/FKEFF
 20      CONTINUE
          IF(.NOT.LCM) THEN
          CALL RLSARA(BASE(I1B))
          ENDIF
         ENDIF
 820     CONTINUE
  22     CONTINUE
  21     CONTINUE
       DO 110  J=1,L4
       DO 110  I=1,NDG
       DO 110  IGR=1,NGRP
       PREC(J,I,IGR)=PRECP(J,I,IGR)
 110   CONTINUE
       ENDIF
      ELSE
*                  DELAYED SOURCE FOR RAMP TRANSIENT
*                  *********************************
*
      IF( ISW.EQ.1 ) THEN
        TEMP1 = 0.D0
        TEMP2 = 0.D0
* COMPUTE THE DELAYED SOURCE
        IF(LBI) THEN
        DO 931 IGR=1,NGRP
        DO 950 I=1,NDG
        BETDEC = DBLE(BETA(I)*DECRAT(I))
        TEMP1= BETDEC*X00A1(I,IGR)
        TEMP2= BETDEC*XCPC1(I,IGR)
*
        DO 932 JGR=1,NGRP
        WRITE(NAMB,'(1HB,I3,I3,I3)') I,IGR,JGR
        CALL LCMLEN(IPSYSP,NAMB,LENGB,ITYLCM)
        CALL LCMLEN(IPSYS0,NAMB,LENGB0,ITYLCM)
      IF(LCM) THEN
*        IN-CORE STORAGE.
         IF(LENGB.GT.0) I1B=LCMIOF(IPSYSP,NAMB)
      ELSE
*        XSM STORAGE.
         IF(LENGB.GT.0) CALL SETARA(BASE,LENGB,I1B)
         IF(LENGB.GT.0) CALL LCMGET(IPSYSP,NAMB,BASE(I1B))
      ENDIF
      IF(LCM0) THEN
*        IN-CORE STORAGE.
          IF(LENGB0.GT.0) I0B=LCMIOF(IPSYS0,NAMB)
      ELSE
*        XSM STORAGE.
         IF(LENGB0.GT.0) CALL SETARA(BASE,LENGB0,I0B)
         IF(LENGB0.GT.0) CALL LCMGET(IPSYS0,NAMB,BASE(I0B))
      ENDIF
         IF(LENGB0.GT.0) THEN
        DO 955 J=1,L4
 955     DELSRC(J,IGR)=TEMP1*DBLE(BASE(I0B-1+J)*EVECT(J,JGR))/FKEFF+
     &              DELSRC(J,IGR)
         IF(.NOT.LCM0) THEN
         CALL RLSARA(BASE(I0B))
         ENDIF
        ENDIF
         IF(LENGB.GT.0) THEN
        DO 977 J=1,L4
 977     DELSRC(J,IGR)=TEMP2*DBLE(BASE(I1B-1+J)*EVECT(J,JGR))/FKEFF+
     &              DELSRC(J,IGR)
         IF(.NOT.LCM) THEN
        CALL RLSARA(BASE(I1B))
         ENDIF
        ENDIF
  932    CONTINUE
  950    CONTINUE
C
        DO 960 I=1,NDG
        EX = EXP(-DECRAT(I)*DTMACR)*DECRAT(I)
        DO 960 J=1,L4
        DELSRC(J,IGR) = DBLE(PREC(J,I,IGR)*EX)+DELSRC(J,IGR)
 960     CONTINUE
 931     CONTINUE
***
        ELSE
***
        DO 31 IGR=1,NGRP
        TEMP1 = 0.D0
        TEMP2 = 0.D0
        DO 50 I=1,NDG
        BETDEC = DBLE(BETA(I)*DECRAT(I))
        TEMP1= BETDEC*X00A1(I,IGR)+TEMP1
        TEMP2= BETDEC*XCPC1(I,IGR)+TEMP2
 50     CONTINUE
*
        DO 32 JGR=1,NGRP
        WRITE(NAMB,'(1HB,I3,I3)') IGR,JGR
        CALL LCMLEN(IPSYSP,NAMB,LENGB,ITYLCM)
        CALL LCMLEN(IPSYS0,NAMB,LENGB0,ITYLCM)
      IF(LCM) THEN
*        IN-CORE STORAGE.
         IF(LENGB.GT.0) I1B=LCMIOF(IPSYSP,NAMB)
      ELSE
*        XSM STORAGE.
         IF(LENGB.GT.0) CALL SETARA(BASE,LENGB,I1B)
         IF(LENGB.GT.0) CALL LCMGET(IPSYSP,NAMB,BASE(I1B))
      ENDIF
      IF(LCM0) THEN
*        IN-CORE STORAGE.
          IF(LENGB0.GT.0) I0B=LCMIOF(IPSYS0,NAMB)
      ELSE
*        XSM STORAGE.
         IF(LENGB0.GT.0) CALL SETARA(BASE,LENGB0,I0B)
         IF(LENGB0.GT.0) CALL LCMGET(IPSYS0,NAMB,BASE(I0B))
      ENDIF
         IF(LENGB0.GT.0) THEN
        DO 55 I=1,L4
 55     DELSRC(I,IGR)=TEMP1*DBLE(BASE(I0B-1+I)*EVECT(I,JGR))/FKEFF+
     &              DELSRC(I,IGR)
         IF(.NOT.LCM0) THEN
         CALL RLSARA(BASE(I0B))
         ENDIF
        ENDIF
         IF(LENGB.GT.0) THEN
        DO 77 I=1,L4
 77     DELSRC(I,IGR)=TEMP2*DBLE(BASE(I1B-1+I)*EVECT(I,JGR))/FKEFF+
     &              DELSRC(I,IGR)
         IF(.NOT.LCM) THEN
        CALL RLSARA(BASE(I1B))
         ENDIF
        ENDIF
  32    CONTINUE
C
        DO 60 I=1,NDG
        EX = EXP(-DECRAT(I)*DTMACR)*DECRAT(I)
        DO 60 J=1,L4
        DELSRC(J,IGR) = DBLE(PREC(J,I,IGR)*EX)+DELSRC(J,IGR)
 60     CONTINUE
 31     CONTINUE
***
        ENDIF
***
*******
       ELSE
*                  UPDATE PRECURSOR RAMP TRANSIENT
*                  *******************************
       DO 61 IGR=1,NGRP
       DO 70 I=1,NDG
       EX = EXP(-DECRAT(I)*DTMACR)
       Y00A1 = X00A1(I,IGR)*BETA(I)
       YCPC1 = XCPC1(I,IGR)*BETA(I)
       Y11A1 = X11A1(I,IGR)*BETA(I)
       DO 62 JGR=1,NGRP
       IF(LBI) THEN
       WRITE(NAMB,'(1HB,I3,I3,I3)')I,IGR,JGR
       ELSE
       WRITE(NAMB,'(1HB,I3,I3)') IGR,JGR
       ENDIF
       CALL LCMLEN(IPSYSP,NAMB,LENGB,ITYLCM)
       CALL LCMLEN(IPSYS0,NAMB,LENGB0,ITYLCM)
      IF(LCM) THEN
*        IN-CORE STORAGE.
         IF(LENGB.GT.0) I1B=LCMIOF(IPSYSP,NAMB)
      ELSE
*        XSM STORAGE.
         IF(LENGB.GT.0) CALL SETARA(BASE,LENGB,I1B)
         IF(LENGB.GT.0) CALL LCMGET(IPSYSP,NAMB,BASE(I1B))
      ENDIF
      IF(LCM0) THEN
*        IN-CORE STORAGE.
          IF(LENGB0.GT.0) I0B=LCMIOF(IPSYS0,NAMB)
      ELSE
*        XSM STORAGE.
         IF(LENGB0.GT.0) CALL SETARA(BASE,LENGB0,I0B)
         IF(LENGB0.GT.0) CALL LCMGET(IPSYS0,NAMB,BASE(I0B))
      ENDIF
         IF(LENGB0.GT.0) THEN
         DO 71 J=1,L4
         PRECP(J,I,IGR) = PRECP(J,I,IGR)  +
     &   (Y00A1*DBLE(BASE(I0B-1+J)*EVECT(J,JGR)) +
     &   YCPC1*DBLE(BASE(I0B-1+J)*DVECT(J,JGR)))/FKEFF
 71      CONTINUE
          IF(.NOT.LCM0) THEN
          CALL RLSARA(BASE(I0B))
          ENDIF
         ENDIF
         IF(LENGB.GT.0) THEN
         DO 72 J=1,L4
         PRECP(J,I,IGR) = PRECP(J,I,IGR)  +
     &   (YCPC1*DBLE(BASE(I1B-1+J)*EVECT(J,JGR))+
     &   Y11A1*DBLE(BASE(I1B-1+J)*DVECT(J,JGR)))/FKEFF
 72      CONTINUE
          IF(.NOT.LCM) THEN
          CALL RLSARA(BASE(I1B))
          ENDIF
         ENDIF
 62      CONTINUE
 70      CONTINUE
 61      CONTINUE
       DO 100  J=1,L4
       DO 100  I=1,NDG
       DO 100  IGR=1,NGRP
       PREC(J,I,IGR)=PRECP(J,I,IGR)
 100   CONTINUE
       ENDIF
      ENDIF
      RETURN
      END
