*DECK IQSQSM
      SUBROUTINE IQSQSM (IPTRK,IPSYS,IPLIS0,NUN,RM,
     1 DVECT,FKEFF,GRAD,GRAD1,GAR,GAR1,GAR2,SOURC,ICL1,ICL2,IMPX,
     2 TITR,EPS2,NADI,MAXX0,DELSRC,EVECT,ADECT,DTMACR,
     3 AMPLD,VM,AMP,BETAT,ATFO,ATOF,SOUR,GAMMA,SIGMA,
     4 IERR,RENORM,FIXCON,VELO,V,NGRP,FRES,FRESN,D2F,RAPQ,LTETA,
     x NDG,LBI)
C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C                                                                      C
C     *********************************************************        C
C     * CALCUL DE LA FONCTION DE FORME POUR UNE APPROXIMATION *        C
C     *                   QUASISTATIQUE.                      *        C
C     *********************************************************        C
C                                                                      C
C . METHODE PRECONDITIONNEE DES PUISSANCES ;                           C
C . ACCELERATION A DEUX PARAMETRES ;                                   C
C . ACCELERATION VARIATIONNELLE PAR SYMETRISATION.                     C
C                                                                      C
C REMARQUES.                                                           C
C   THIS SUBROUTINE COMPUTES THE FLUX OR ADJOINT DISTRIBTIONS          C
C   FOR A TRANSIENT CASE. THE EQUATION TO BE SOLVED HAS THE            C
C   FORM:      (A * 1/K*B) * X = S                                     C
C   MATHEMATICALLY KNOWN AS A FIXED SOURCE PROBLEM. HERE THE           C
C   K(KEFF) IS KNOWN APRORI ,BUT IS ALLOWED TO VARY IN ORDER           C
C   COUNTER-ACT NUMERICAL EFFECT THAT IMPEDE CONVERGENCE.              C
C   OPTIONS:                                                           C
C         1) FIXED SOURCE ACCELERATION OR LINEARIZED ACCELERATION      C
C         2) OBEY CONTRAINT DURING SOLUTION                            C
C                                                                      C
C PARAMETRES D'ENTREES                                                 C
C                                                                      C
C NUN     : NOMBRE TOTAL D'INCONNUES (COEFFICIENTS VARIATIONNELS) PAR  C
C           GROUPE D'ENERGIE. ORDRE DES SYSTEMES MATRICIELS.           C
C RM      : MATRICE UNITAIRE DE PONDERATION; DIMENSION RM(NUN).        C
C V       : MATRICE CORRESPONDANT A L'INVERSE DE LA VITESSE.           C
C VELO    : VARIABLE LOGIQUE POUR  'V' OU 'VM'.                        C
C           DIMENSION A12(NUN),A21(NUN),B11(NUN),B12(NUN),RM(NUN)      C
C ICL1    : NOMBRE D'ITERATIONS LIBRES PAR CYCLE D'ACCELERATION.       C
C ICL2    : NOMBRE D'ITERATIONS ACCELEREES PAR CYCLE D'ACCELERATION.   C
C IMPX    : AUCUNE IMPRESSION SI IMPX=0 ; IMPRESSION DE LA VALEUR      C
C           PROPRE SI IMPX=1 ; IMPRESSIONS DES ITERATIONS SI IMPX=2 ;  C
C           IMPRESSIONS DES VECTEURS PROPRES SI IMPX=3.                C
C DVECT   : ESTIME INITIAL DE LA FONCTION DE FORME;                    C
C           DIMENSION DVECT(NUN,NGRP).                                 C
C TITR    : TITRE DU CAS.                                              C
C EPS2    : CRITERE DE CONVERGENCE POUR LE FLUX.                       C
C NADI    : NOMBRE D'ITERATIONS ADI PAR EXTERNE.                       C
C MAXX0   : NOMBRE MAXIMUM D'ITERATIONS EXTERNES.                      C
C DELSRC  : DIMENSION DELSCR(NUN.NGRP).                                C
C EVECT   : DIMENSION EVECT(NUN,NGRP).                                 C
C ADECT   : DIMENSION ADECT(NUN,NGRP).                                 C
C DTMACR  : REACTIVITY TIME STEP.                                      C
C AMPLD   : DERIVEE LOGARITHMIQUE DE L'AMPLIUDE.                       C
C VM      : VITESSES DES NEUTRONS PAR GROUPE; DIMENSION VM(NGRP).      C
C AMP     : AMPLITUDE                                                  C
C BETAT   : FRACTION DE NEUTRONS RETARDES                              C
C ATFO    : CONSTANTE DE NORMALISATION DES FONCTIONS DE FORME.         C
C  NDG    : NUMBER OF DELAYED NEUTRON GROUPS.                          C
C  LBI    : LOGICAL VARIABLE FOR NEUTRON FISSION SPECTRUM.             C
C                                                                      C
C PARAMETRES DE SORTIES                                                C
C                                                                      C
C DVECT   : FONCTION DE FORME APRES CONVERGENCE.                       C
C                                                                      C
C ESPACE MEMOIRE DE TRAVAIL                                            C
C                                                                      C
C GRAD, GRAD1     : DIMENSION GRAD(NUN,NGRP),GRAD(NUN,NGRP)            C
C GAR, GAR1, GAR2 : DIMENSION GAR(NUN,NGRP),GAR1(NUN,NGRP),            C
C                   GAR2(NUN,NGRP)                                     C
C SOURC,SOUR      : DIMENSION SOURC(NUN,NGRP),SOUR(NUN,NGRP)           C
CCC                                                                    C
C MODIFIED BY M.T. SISSAOUI ; 28/07/94                                 C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC AUTEUR: A. HEBERT ; 15/01/86 CCCC
C
      CHARACTER*(*) TITR
      CHARACTER*12 NAMA,NAMB,NAME,NAMLCM,NAMMY
      LOGICAL LOGTES,FIXCON,RENORM,VELO,LCM,LCM0,LTETA,LBI
      REAL IQSNRM
      DOUBLE PRECISION DDELN1,DDELD1,ZNORM
      DOUBLE PRECISION EVAL,D2F(2,3),ALP,BET
      DOUBLE PRECISION AMP(NGRP),AMPLD(NGRP),GAMMA(NGRP,NDG),
     x SIGMA(NGRP,NDG),SIGMAT
      DOUBLE PRECISION RES,FRES(NGRP),TRES,FRESN(NGRP),TRESN
      DIMENSION RM(NUN),
     1 DVECT(NUN,NGRP),GRAD(NUN,NGRP),GRAD1(NUN,NGRP),GAR(NUN,NGRP),
     1 GAR1(NUN,NGRP),GAR2(NUN,NGRP),
     2 SOURC(NUN,NGRP),DELSRC(NUN,NGRP),EVECT(NUN,NGRP),
     2 ADECT(NUN,NGRP),VM(NGRP),ATFO(NGRP),ATOF(NGRP),
     3 SOUR(NUN,NGRP),V(NUN,NGRP),RAPQ(NDG)
       COMMON BASE(1)
      DATA EPSMIN,MMAXX/1.0E-8,250/
C     LA VALEUR DE EPSMIN EST FIXEE EN FONCTION DU MOT DE 32 BITS.
      MAXX=MIN(MAXX0,MMAXX)
      ICL3=ICL1+ICL2
      IERR = 0
      TEST = 0.
      NAME=' '
      CALL LCMNXT(IPSYS,NAME,NAMLCM,NAMMY,LCM)
      NAME=' '
      CALL LCMNXT(IPLIS0,NAME,NAMLCM,NAMMY,LCM0)
C
      CALL MTOPEN(IMPX,IPTRK,LL4)
      IF(LL4.GT.NUN) CALL XABORT('IQSQSM: INVALID NUMBER OF UNKNOWNS.')
* SET THE MATRICES TO ZERO
      DO 686 IGR=1,NGRP
      DO 687 I=1,LL4
      GRAD1(I,IGR)=0.0
      GAR2(I,IGR)=0.0
      SOUR(I,IGR)=0.0
 687  CONTINUE
 686  CONTINUE
       IF(VELO) THEN
         DO 421 IGR=1,NGRP
         DO 401 I=1,LL4
       SOURC(I,IGR)=-V(I,IGR)*EVECT(I,IGR)/DTMACR-DELSRC(I,IGR)/AMP(1)
 401   CONTINUE
 421   CONTINUE
        FACTV=AMPLD(1)+1.0/DTMACR
       ELSE
       DO 422 IGR=1,NGRP
      DO 40 I=1,LL4
      SOURC(I,IGR)=-RM(I)*EVECT(I,IGR)/(DTMACR*VM(IGR))
     1  -DELSRC(I,IGR)/AMP(1)
 40   CONTINUE
      FACT=AMPLD(1)+1.0/DTMACR
 422   CONTINUE
       ENDIF
*
       IF(LBI) THEN
       EVAL=1.0-BETAT
       SIGMAT=0.0
       ELSE
        IF(LTETA) THEN
        EVAL=1.0-BETAT+RAPQ(1)
        SIGMAT=0.0
        ELSE
        EVAL=1.0-BETAT+GAMMA(1,1)/AMP(1)
        SIGMAT=SIGMA(1,1)/AMP(1)
        ENDIF
       ENDIF
*     WRITE OUT RELATIVE VECTOR SIZES
      DO 300 IGR=1,NGRP
      DELSN = IQSNRM(DELSRC(1,IGR),LL4)
      DO 301 JGR=1,NGRP
      WRITE(NAMB,'(1HB,I3,I3)') IGR,JGR
      CALL LCMLEN(IPSYS,NAMB,LENGB,ITYLCM)
         IF(LCM) THEN
*        IN-CORE STORAGE.
          IF(LENGB.GT.0) IBB1=LCMIOF(IPSYS,NAMB)
      ELSE
*        XSM STORAGE.
         IF(LENGB.GT.0) CALL SETARA(BASE,LENGB,IBB1)
         IF(LENGB.GT.0) CALL LCMGET(IPSYS,NAMB,BASE(IBB1))
      ENDIF
       IF(LENGB.GT.0) THEN
      DO 999 I=1,LL4
      SOUR(I,JGR)=BASE(IBB1-1+I)*DVECT(I,JGR)/FKEFF
 999   CONTINUE
        IF(.NOT.LCM) THEN
        CALL RLSARA(BASE(IBB1))
        ENDIF
      B11SN=IQSNRM(SOUR(1,JGR),LL4)
      IF(IMPX.GE.1) THEN
         WRITE (6,600) NADI
         WRITE(6,*) '  ANSWER NORMALIZED TO CONTRAINT      ',RENORM
         WRITE(6,*) '  ITERATIONS FORCED TO OBEY CONSTRAINT',FIXCON
      ENDIF
      IF(IMPX.GE.2) THEN
         WRITE(6,*) ' SUMMARY OF TERM MAGNITUDES '
         WRITE(6,*) '        DELAYED SOURCE =',DELSN
         WRITE(6,*) 'B',IGR,JGR,'*DVECT',JGR,'     =',B11SN
      ENDIF
       ENDIF
 301   CONTINUE
 300   CONTINUE
       IF(IMPX.GE.2) THEN
         WRITE (6,610)
      ENDIF
C
C STRATEGIE ITERATIVE.
      ICL1B=ICL1
      EPS3=EPS2
      M=0
  130 M=M+1
C
C
      DO 302 IGR=1,NGRP
      DO 5 I=1,LL4
    5  SOUR(I,IGR)=SOURC(I,IGR)
 302  CONTINUE
C
      DO 310 IGR= 1,NGRP
      WRITE(NAMA,'(1HA,I3,I3)') IGR,IGR
      CALL MTLDLM(NAMA,IPTRK,IPSYS,DVECT(1,IGR),GAR(1,IGR))
 310  CONTINUE
      DO 312 IGR= 1,NGRP
      DO 313 JGR=1,NGRP
      WRITE(NAMA,'(1HA,I3,I3)') IGR,JGR
      CALL LCMLEN(IPSYS,NAMA,LENGA,ITYLCM)
      IF(LCM) THEN
*        IN-CORE STORAGE.
          IF(LENGA.GT.0) I1A=LCMIOF(IPSYS,NAMA)
      ELSE
*        XSM STORAGE.
         IF(LENGA.GT.0) CALL SETARA(BASE,LENGA,I1A)
         IF(LENGA.GT.0) CALL LCMGET(IPSYS,NAMA,BASE(I1A))
      ENDIF
      IF(IGR.NE.JGR.AND.LENGA.GT.0) THEN
      DO 201 I=1,LL4
      GAR(I,IGR)=GAR(I,IGR)-BASE(I1A-1+I)*DVECT(I,JGR)
 201  CONTINUE
      IF(.NOT.LCM) THEN
      CALL RLSARA(BASE(I1A))
      ENDIF
      ENDIF
 313  CONTINUE
      IF(VELO) THEN
      DO 457 I=1,LL4
      GAR(I,IGR)=GAR(I,IGR)+FACTV*V(I,IGR)*DVECT(I,IGR)
 457  CONTINUE
      ELSE
      DO 458 I=1,LL4
      GAR(I,IGR)=GAR(I,IGR)+FACT*RM(I)*DVECT(I,IGR)/VM(IGR)
 458  CONTINUE
      ENDIF
 312  CONTINUE
*                *******************************
         DO 321 IGR=1,NGRP
         DO 322 JGR=1,NGRP
          WRITE(NAMB,'(1HB,I3,I3)') IGR,JGR
          CALL LCMLEN(IPLIS0,NAMB,LENGB0,ITYLCM)
          CALL LCMLEN(IPSYS,NAMB,LENGB,ITYLCM)
         IF(LCM) THEN
*        IN-CORE STORAGE.
          IF(LENGB.GT.0) I1B=LCMIOF(IPSYS,NAMB)
      ELSE
*        XSM STORAGE.
         IF(LENGB.GT.0) CALL SETARA(BASE,LENGB,I1B)
         IF(LENGB.GT.0) CALL LCMGET(IPSYS,NAMB,BASE(I1B))
      ENDIF
         IF(LCM0) THEN
*        IN-CORE STORAGE.
          IF(LENGB0.GT.0) I0B=LCMIOF(IPLIS0,NAMB)
         ELSE
*        XSM STORAGE.
         IF(LENGB0.GT.0) CALL SETARA(BASE,LENGB0,I0B)
         IF(LENGB0.GT.0) CALL LCMGET(IPLIS0,NAMB,BASE(I0B))
         ENDIF
        IF(LENGB.GT.0) THEN
        DO 161 I=1,LL4
161     GAR(I,IGR)=GAR(I,IGR)-EVAL*(BASE(I1B-1+I)*DVECT(I,JGR))/FKEFF
        IF(.NOT.LCM) THEN
        CALL RLSARA(BASE(I1B))
        ENDIF
        ENDIF
        IF(LENGB0.GT.0) THEN
        DO 753 I=1,LL4
 753    GAR(I,IGR)=GAR(I,IGR)-SIGMAT*(BASE(I0B-1+I)*DVECT(I,JGR))/FKEFF
        IF(.NOT.LCM0) THEN
        CALL RLSARA(BASE(I0B))
        ENDIF
        ENDIF
*
        IF(LBI) THEN
         IF(LTETA) THEN
        DO 900 II=1,NDG
        WRITE(NAMB,'(1HB,I3,I3,I3)') II,IGR,JGR
          CALL LCMLEN(IPSYS,NAMB,LENGB,ITYLCM)
         IF(LCM) THEN
*        IN-CORE STORAGE.
          IF(LENGB.GT.0) I1B=LCMIOF(IPSYS,NAMB)
      ELSE
*        XSM STORAGE.
         IF(LENGB.GT.0) CALL SETARA(BASE,LENGB,I1B)
         IF(LENGB.GT.0) CALL LCMGET(IPSYS,NAMB,BASE(I1B))
      ENDIF
        IF(LENGB.GT.0) THEN
        DO 861 I=1,LL4
        GAR(I,IGR)=GAR(I,IGR)-
     x  RAPQ(II)*(BASE(I1B-1+I)*DVECT(I,JGR))/FKEFF
 861    CONTINUE
        IF(.NOT.LCM) THEN
        CALL RLSARA(BASE(I1B))
        ENDIF
        ENDIF
 900    CONTINUE
         ELSE
         DO 991 II=1,NDG
         WRITE(NAMB,'(1HB,I3,I3,I3)') II,IGR,JGR
          CALL LCMLEN(IPLIS0,NAMB,LENGB0,ITYLCM)
          CALL LCMLEN(IPSYS,NAMB,LENGB,ITYLCM)
         IF(LCM) THEN
*        IN-CORE STORAGE.
          IF(LENGB.GT.0) I1B=LCMIOF(IPSYS,NAMB)
      ELSE
*        XSM STORAGE.
         IF(LENGB.GT.0) CALL SETARA(BASE,LENGB,I1B)
         IF(LENGB.GT.0) CALL LCMGET(IPSYS,NAMB,BASE(I1B))
      ENDIF
         IF(LCM0) THEN
*        IN-CORE STORAGE.
          IF(LENGB0.GT.0) I0B=LCMIOF(IPLIS0,NAMB)
         ELSE
*        XSM STORAGE.
         IF(LENGB0.GT.0) CALL SETARA(BASE,LENGB0,I0B)
         IF(LENGB0.GT.0) CALL LCMGET(IPLIS0,NAMB,BASE(I0B))
         ENDIF
        IF(LENGB.GT.0) THEN
        DO 561 I=1,LL4
        GAR(I,IGR)=GAR(I,IGR)-
     x   GAMMA(1,II)*(BASE(I1B-1+I)*DVECT(I,JGR))/(FKEFF*AMP(1))
 561    CONTINUE
        IF(.NOT.LCM) THEN
        CALL RLSARA(BASE(I1B))
        ENDIF
        ENDIF
        IF(LENGB0.GT.0) THEN
        DO 553 I=1,LL4
        GAR(I,IGR)=GAR(I,IGR)-
     x  SIGMA(1,II)*(BASE(I0B-1+I)*DVECT(I,JGR))/(FKEFF*AMP(1))
 553    CONTINUE
        IF(.NOT.LCM0) THEN
        CALL RLSARA(BASE(I0B))
        ENDIF
        ENDIF
 991    CONTINUE
        ENDIF
*
        ENDIF
*
 322    CONTINUE
 321    CONTINUE
C
C METHODE PRECONDITIONNEE DES PUISSANCES.
      DO 275 IGR=1,NGRP
      WRITE(NAMA,'(1HA,I3,I3)') IGR,IGR
      DO 170 I=1,LL4
  170 GRAD(I,IGR)=-GAR(I,IGR)-SOUR(I,IGR)
C
      DO 74 IJ=1,NGRP
      FRES(IJ) = 0.D0
  74  CONTINUE
      DO 810 I=1,LL4
        FRES(IGR) = FRES(IGR) + GRAD(I,IGR)*GRAD(I,IGR)
 810   CONTINUE
      FRESN(IGR) =  IQSNRM(DVECT(1,IGR),LL4)
      FRES(IGR)  =  FRES(IGR)/(FRESN(IGR))**2
 275  CONTINUE
C
      DO 699 IGR=1,NGRP
      NREC=IGR-1
      IF(NREC.EQ.0) GO TO 693
      DO 691 JGR=1,NREC
      WRITE(NAMA,'(1HA,I3,I3)') IGR,JGR
      CALL LCMLEN(IPSYS,NAMA,LENGA,ITYLCM)
      IF(LCM) THEN
*        IN-CORE STORAGE.
          IF(LENGA.GT.0) I1A=LCMIOF(IPSYS,NAMA)
      ELSE
*        XSM STORAGE.
         IF(LENGA.GT.0) CALL SETARA(BASE,LENGA,I1A)
         IF(LENGA.GT.0) CALL LCMGET(IPSYS,NAMA,BASE(I1A))
      ENDIF
      IF(LENGA.GT.0) THEN
      DO 190 I=1,LL4
  190 GRAD(I,IGR)=BASE(I1A-1+I)*GRAD(I,JGR)+GRAD(I,IGR)
      IF(.NOT.LCM) THEN
      CALL RLSARA(BASE(I1A))
      ENDIF
      ENDIF
  691 CONTINUE
  693 WRITE(NAMA,'(1HA,I3,I3)') IGR,IGR
      IF(NADI.EQ.1) THEN
         CALL MTLDLS(NAMA,IPTRK,IPSYS,GRAD(1,IGR))
      ELSE
         CALL TRIADI(NAMA,IPTRK,IPSYS,LL4,GRAD(1,IGR),NADI)
      ENDIF
  699 CONTINUE
C
      TRES = 0.D0
      TRESN = 0.D0
       DO 695 IGR=1,NGRP
        TRES = TRES +FRES(IGR)*(FRESN(IGR))**2
        TRESN= TRESN + (FRESN(IGR))**2
  695  CONTINUE
       RES =SQRT(TRES/TRESN)
* USER HAS SPECIFIED CONSTRAINT TO BE OBEYED
      IF(FIXCON ) THEN
         CALL SETARA(BASE,2*NGRP,IVT1)
         CALL SETARA(BASE,2*NGRP,IVT2)
         CALL SETARA(BASE,2*NGRP,IVT3)
        CALL IQSANG(ANGLE,CONTAM,GRAD,ADECT,RM,
     1   VM,LL4,VELO,V,NGRP,BASE(IVT1),BASE(IVT2),BASE(IVT3))
        CALL RLSARA(BASE(IVT3))
        CALL RLSARA(BASE(IVT2))
        CALL RLSARA(BASE(IVT1))
C
        IF(VELO) THEN
         DO 471 IGR=1,NGRP
         DO 461 I=1,LL4
          GRAD(I,IGR)=GRAD(I,IGR)-CONTAM*ADECT(I,IGR)*V(I,IGR)
461     CONTINUE
 471    CONTINUE
         ELSE
        DO 470 IGR=1,NGRP
        DO 460 I=1,LL4
        GRAD(I,IGR)=GRAD(I,IGR)-CONTAM*ADECT(I,IGR)*RM(I)/VM(IGR)
460     CONTINUE
 470    CONTINUE
         ENDIF
      ENDIF
C
C CALCUL DU DEPLACEMENT.
C     CALCUL DES FACTEURS D'ACCELERATION ALP ET BET.
      ALP=1.0D0
      BET=0.0D0
      DO 210 I=1,2
      DO 210 J=1,3
  210 D2F(I,J)=0.0D0
      DO 381 IGR= 1,NGRP
      WRITE(NAMA,'(1HA,I3,I3)') IGR,IGR
      CALL MTLDLM(NAMA,IPTRK,IPSYS,GRAD(1,IGR),GAR1(1,IGR))
 381  CONTINUE
C
      DO 352 IGR= 1,NGRP
      DO 353 JGR=1,NGRP
      WRITE(NAMA,'(1HA,I3,I3)') IGR,JGR
      CALL LCMLEN(IPSYS,NAMA,LENGA,ITYLCM)
      IF(LCM) THEN
*        IN-CORE STORAGE.
          IF(LENGA.GT.0) I1A=LCMIOF(IPSYS,NAMA)
      ELSE
*        XSM STORAGE.
         IF(LENGA.GT.0) CALL SETARA(BASE,LENGA,I1A)
         IF(LENGA.GT.0) CALL LCMGET(IPSYS,NAMA,BASE(I1A))
      ENDIF
      IF(IGR.NE.JGR.AND.LENGA.GT.0) THEN
      DO 251 I=1,LL4
      GAR1(I,IGR) = GAR1(I,IGR) -BASE(I1A-1+I)*GRAD(I,JGR)
 251  CONTINUE
      IF(.NOT.LCM) THEN
      CALL RLSARA(BASE(I1A))
      ENDIF
      ENDIF
 353  CONTINUE
      IF(VELO) THEN
      DO 459 I=1,LL4
      GAR1(I,IGR) = GAR1(I,IGR)+FACTV*V(I,IGR)*GRAD(I,IGR)
 459  CONTINUE
      ELSE
      DO 453 I=1,LL4
      GAR1(I,IGR)=GAR1(I,IGR)+FACT*RM(I)*GRAD(I,IGR)/VM(IGR)
 453  CONTINUE
      ENDIF
 352  CONTINUE
      DO 361 IGR=1,NGRP
         DO 362 JGR=1,NGRP
          WRITE(NAMB,'(1HB,I3,I3)') IGR,JGR
          CALL LCMLEN(IPLIS0,NAMB,LENGB0,ITYLCM)
          CALL LCMLEN(IPSYS,NAMB,LENGB,ITYLCM)
         IF(LCM) THEN
*        IN-CORE STORAGE.
          IF(LENGB.GT.0) I1B=LCMIOF(IPSYS,NAMB)
         ELSE
*        XSM STORAGE.
         IF(LENGB.GT.0) CALL SETARA(BASE,LENGB,I1B)
         IF(LENGB.GT.0) CALL LCMGET(IPSYS,NAMB,BASE(I1B))
         ENDIF
         IF(LCM0) THEN
*        IN-CORE STORAGE.
          IF(LENGB0.GT.0) I0B=LCMIOF(IPLIS0,NAMB)
         ELSE
*        XSM STORAGE.
         IF(LENGB0.GT.0) CALL SETARA(BASE,LENGB0,I0B)
         IF(LENGB0.GT.0) CALL LCMGET(IPLIS0,NAMB,BASE(I0B))
         ENDIF
        IF(LENGB.GT.0) THEN
        DO 961 I=1,LL4
        GAR1(I,IGR)=GAR1(I,IGR)-EVAL*(BASE(I1B-1+I)*GRAD(I,JGR))/FKEFF
 961     CONTINUE
        IF(.NOT.LCM) THEN
        CALL RLSARA(BASE(I1B))
        ENDIF
        ENDIF
        IF(LENGB0.GT.0) THEN
        DO 751 I=1,LL4
        GAR1(I,IGR) = GAR1(I,IGR)
     x               - SIGMAT*(BASE(I0B-1+I)*GRAD(I,JGR))/FKEFF
 751    CONTINUE
        IF(.NOT.LCM0) THEN
        CALL RLSARA(BASE(I0B))
        ENDIF
        ENDIF
*
        IF(LBI) THEN
         IF(LTETA) THEN
         DO 981 II=1,NDG
         WRITE(NAMB,'(1HB,I3,I3,I3)') II,IGR,JGR
          CALL LCMLEN(IPSYS,NAMB,LENGB,ITYLCM)
         IF(LCM) THEN
*        IN-CORE STORAGE.
          IF(LENGB.GT.0) I1B=LCMIOF(IPSYS,NAMB)
         ELSE
*        XSM STORAGE.
         IF(LENGB.GT.0) CALL SETARA(BASE,LENGB,I1B)
         IF(LENGB.GT.0) CALL LCMGET(IPSYS,NAMB,BASE(I1B))
         ENDIF
        IF(LENGB.GT.0) THEN
        DO 469 I=1,LL4
        GAR1(I,IGR)=GAR1(I,IGR)-
     x  RAPQ(II)*(BASE(I1B-1+I)*GRAD(I,JGR))/FKEFF
 469    CONTINUE
        IF(.NOT.LCM) THEN
        CALL RLSARA(BASE(I1B))
        ENDIF
        ENDIF
 981    CONTINUE
*
         ELSE
*
         DO 802 II=1,NDG
         WRITE(NAMB,'(1HB,I3,I3,I3)') II,IGR,JGR
          CALL LCMLEN(IPLIS0,NAMB,LENGB0,ITYLCM)
          CALL LCMLEN(IPSYS,NAMB,LENGB,ITYLCM)
         IF(LCM) THEN
*        IN-CORE STORAGE.
          IF(LENGB.GT.0) I1B=LCMIOF(IPSYS,NAMB)
         ELSE
*        XSM STORAGE.
         IF(LENGB.GT.0) CALL SETARA(BASE,LENGB,I1B)
         IF(LENGB.GT.0) CALL LCMGET(IPSYS,NAMB,BASE(I1B))
         ENDIF
         IF(LCM0) THEN
*        IN-CORE STORAGE.
          IF(LENGB0.GT.0) I0B=LCMIOF(IPLIS0,NAMB)
         ELSE
*        XSM STORAGE.
         IF(LENGB0.GT.0) CALL SETARA(BASE,LENGB0,I0B)
         IF(LENGB0.GT.0) CALL LCMGET(IPLIS0,NAMB,BASE(I0B))
         ENDIF
        IF(LENGB.GT.0) THEN
        DO 969 I=1,LL4
        GAR1(I,IGR)=GAR1(I,IGR)-
     x   GAMMA(1,II)*(BASE(I1B-1+I)*GRAD(I,JGR))/(FKEFF*AMP(1))
 969     CONTINUE
        IF(.NOT.LCM) THEN
        CALL RLSARA(BASE(I1B))
        ENDIF
        ENDIF
        IF(LENGB0.GT.0) THEN
        DO 731 I=1,LL4
        GAR1(I,IGR) = GAR1(I,IGR)-
     x  SIGMA(1,II)*(BASE(I0B-1+I)*GRAD(I,JGR))/(FKEFF*AMP(1))
 731    CONTINUE
        IF(.NOT.LCM0) THEN
        CALL RLSARA(BASE(I0B))
        ENDIF
        ENDIF
 802    CONTINUE
         ENDIF
        ENDIF
*
 362    CONTINUE
 361    CONTINUE
      IF(1+MOD(M-1,ICL1B+ICL2).GT.ICL1B) THEN
         DO 635 IGR=1,NGRP
         DO 230 I=1,LL4
         D2F(1,1)=D2F(1,1)+GAR1(I,IGR)**2
         D2F(1,2)=D2F(1,2)+GAR1(I,IGR)*GAR2(I,IGR)
         D2F(2,2)=D2F(2,2)+GAR2(I,IGR)**2
         D2F(1,3)=D2F(1,3)-(GAR(I,IGR)+SOUR(I,IGR))*GAR1(I,IGR)
         D2F(2,3)=D2F(2,3)-(GAR(I,IGR)+SOUR(I,IGR))*GAR2(I,IGR)
  230   CONTINUE
  635   CONTINUE
         D2F(2,1)=D2F(1,2)
C        RESOLUTION DU SYSTEME LINEAIRE.
         CALL ALSBD(2,1,D2F,IER,2)
         IF(IER.NE.0) CALL XABORT('IQSQSM: SINGULAR MATRIX.')
         ALP=D2F(1,3)
         BET=D2F(2,3)/ALP
         IF((ALP.LT.1.0D0).AND.(ALP.GT.0.0D0)) THEN
            ALP=1.0D0
            BET=0.0D0
         ELSE IF(ALP.LE.0.0D0) THEN
            ICL1B=MAXX
            ALP=1.0D0
            BET=0.0D0
         ENDIF
         DO 636 IGR=1,NGRP
         DO 270 I=1,LL4
         GRAD(I,IGR)=ALP*(GRAD(I,IGR)+BET*GRAD1(I,IGR))
         GAR1(I,IGR)=ALP*(GAR1(I,IGR)+BET*GAR2(I,IGR))
  270    CONTINUE
  636    CONTINUE
      ENDIF
*  COMPUTE ANGLE BETWEEN GRAD AND CONSTRAINT
         CALL SETARA(BASE,2*NGRP,IVT1)
         CALL SETARA(BASE,2*NGRP,IVT2)
         CALL SETARA(BASE,2*NGRP,IVT3)
        CALL IQSANG(ANGLE,CONTAM,GRAD,ADECT,RM,
     1   VM,LL4,VELO,V,NGRP,BASE(IVT1),BASE(IVT2),BASE(IVT3))
        CALL RLSARA(BASE(IVT3))
        CALL RLSARA(BASE(IVT2))
        CALL RLSARA(BASE(IVT1))
C
      LOGTES=(M.LT.ICL1B).OR.(MOD(M,ICL1B+ICL2).EQ.ICL1B)
      IF(LOGTES) THEN
         DELN1=0.0
         DELN2=0.0
         DELD1=0.0
         DELD2=0.0
         DELT=0.0
         DO 637 IGR=1,NGRP
         DO 430 I=1,LL4
         DELN1=MAX(DELN1,ABS(GRAD(I,IGR)))
         DVECT(I,IGR)=DVECT(I,IGR)+GRAD(I,IGR)
         DELD1=MAX(DELD1,ABS(DVECT(I,IGR)))
         GAR(I,IGR)=GAR(I,IGR)+GAR1(I,IGR)
         GRAD1(I,IGR)=GRAD(I,IGR)
         GAR2(I,IGR)=GAR1(I,IGR)
         IF(DELD1.NE.0.0) DELT=MAX(DELT,DELN1/DELD1)
 430      CONTINUE
 637      CONTINUE
         DDELN1=0.0D0
         DDELD1=0.0D0
          IF(VELO) THEN
           DO 641 IGR=1,NGRP
            DO 952 I=1,LL4
           DDELN1=DDELN1+ADECT(I,IGR)*V(I,IGR)*DVECT(I,IGR)
  952    CONTINUE
  641    CONTINUE
         ATOF(1)=DDELN1
           ELSE
         DO 642 IGR=1,NGRP
         DO 942 I=1,LL4
         DDELN1=DDELN1+ADECT(I,IGR)*RM(I)*DVECT(I,IGR)/VM(IGR)
  942    CONTINUE
  642    CONTINUE
         ATOF(1)=DDELN1
           ENDIF
         ZNORM=ATFO(1)/ATOF(1)
         IF(IMPX.GE.2)THEN
          WRITE (6,620) M,ALP,BET,RES,DELT,ANGLE,ZNORM
          DO 877 IGR=1,NGRP
            WRITE(6,*)' NORM RES  ',SQRT(FRES(IGR)),' GRP  ',IGR
 877      CONTINUE
         ENDIF
C
         IF(DELT.LT.EPS3 .AND. M.GE.1) GO TO 550
      ELSE
         DO 643 IGR=1,NGRP
         DO 440 I=1,LL4
         DVECT(I,IGR)=DVECT(I,IGR)+GRAD(I,IGR)
         GAR(I,IGR)=GAR(I,IGR)+GAR1(I,IGR)
         GRAD1(I,IGR)=GRAD(I,IGR)
  440    GAR2(I,IGR)=GAR1(I,IGR)
  643    CONTINUE
         DDELN1=0.0D0
         DDELD1=0.0D0
          IF(VELO) THEN
          DO 644 IGR=1,NGRP
            DO 951 I=1,LL4
           DDELN1=DDELN1+ADECT(I,IGR)*V(I,IGR)*DVECT(I,IGR)
  951    CONTINUE
  644    CONTINUE
         ATOF(1)=DDELN1
           ELSE
         DO 645 IGR=1,NGRP
         DO 941 I=1,LL4
         DDELN1=DDELN1+ADECT(I,IGR)*RM(I)*DVECT(I,IGR)/VM(IGR)
  941    CONTINUE
  645    CONTINUE
         ATOF(1)=DDELN1
           ENDIF
         ZNORM=ATFO(1)/ATOF(1)
         IF(IMPX.GE.2) THEN
           WRITE(6,620)M,ALP,BET,RES,-999.,ANGLE,ZNORM
           DO 878 IGR=1,NGRP
             WRITE(6,*)' NORM RES  ',SQRT(FRES(IGR)),' GRP  ',IGR
 878       CONTINUE
         ENDIF
      ENDIF
      IF(M.EQ.1) TEST=DELT
      IF((M.GT.20).AND.(DELT.GT.TEST)) CALL XABORT('IQSQSM: CONVERGENC'
     1 //'E FAILURE.')
      IF(M.GE.MAXX) THEN
         WRITE (6,710)
         IERR = 1
         GO TO 550
      ENDIF
      IF(MOD(M,35).EQ.0) THEN
****     EPS3=MAX(EPS3/SQRT(10.0),EPSMIN)
****     WRITE (6,720) EPS3
      ENDIF
      GO TO 130
C
  550 CONTINUE
C
C ON FORCE LA CONTRAINTE
      DDELN1=0.0D0
      DDELD1=0.0D0
      IF(VELO) THEN
        DO 646 IGR=1,NGRP
          DO 945 I=1,LL4
             DDELN1=DDELN1+ADECT(I,IGR)*V(I,IGR)*DVECT(I,IGR)
 945      CONTINUE
 646    CONTINUE
        ATOF(1)=DDELN1
      ELSE
        DO 647 IGR=1,NGRP
         DO 940 I=1,LL4
           DDELN1=DDELN1+ADECT(I,IGR)*RM(I)*DVECT(I,IGR)/VM(IGR)
 940     CONTINUE
 647    CONTINUE
        ATOF(1)=DDELN1
      ENDIF
      IF(IMPX.GE.1 ) THEN
        WRITE(6,*) ' CONSTRAINT GRP1 =',DDELN1,'  GRP2=',DDELD1
        WRITE(6,*) '            RATIO=',DDELN1/DDELD1
      ENDIF
      ZNORM=ATFO(1)/ATOF(1)
      IF(IMPX.EQ.2) WRITE(6,630) ZNORM
      IF(RENORM ) THEN
        IF(IMPX.GE.2) WRITE(6,*) ' **** FLUX BEING NORMALIZED BY FACTO'
     1     //'R ',ZNORM
        DO 648 IGR=1,NGRP
        DO 950 I=1,LL4
  950   DVECT(I,IGR)=DVECT(I,IGR)*ZNORM
  648   CONTINUE
      ELSE
        IF(IMPX.GE.2) WRITE(6,*) ' **** FLUX WILL NOT BE NORMALI'
     1         //'ZED BY ',ZNORM
      ENDIF
      IF(IMPX.EQ.3 ) THEN
        WRITE(6,*) ' RESIUDAL AT END OF ITERATIONS'
        DO 649 IGR=1,NGRP
          WRITE(6,*)'GROUP',IGR
          WRITE (6,690) 'GROUP   ',(GRAD(I,IGR),I=1,LL4)
  649   CONTINUE
        RESIDD =SQRT(TRES)
        WRITE(6,*)' **** TOTAL RESIDUAL IS ',RESIDD*AMP(1),
     1       ' /AMP=',RESIDD
      ENDIF
C
C EDITION DE LA SOLUTION.
      IF(IMPX.EQ.3) THEN
        DO 681 IGR=1,NGRP
          WRITE(6,*)'GROUP  ',IGR
          WRITE (6,690) 'GROUP   ',(DVECT(I,IGR),I=1,LL4)
 681    CONTINUE
      ENDIF
      RETURN
C
  600 FORMAT (1H0/68H STRATEGIE ITERATIVE PAR LA METHODE PRECONDITIONNEE
     1 DES PUISSANCES (,I2,39H ITERATIONS ADI PAR ITERATION EXTERNE).)
  610 FORMAT (//11X,5HALPHA,3X,4HBETA,6X,
     1 10HNORM RESID   ,4X,10HPRECISION    ,4X,7HANGLE    ,
     2 '  NORMALIZATION')
  620 FORMAT (1X,I3,4X,2F8.3,3(1P,E12.2,1X),4(1X,E10.3) )
  630 FORMAT (/' FACTEUR DE RENORMALISATION = ',F12.5)
  650 FORMAT (/52H TEMPS UTILISE POUR LES RESOLUTIONS DE SYSTEME APRES,
     1 16H DECOMPOSITION =,F9.3/
     2 15X,41HPOUR LE CALCUL DES PRODUITS BILINEAIRES =,F9.3)
  660 FORMAT (//20H VARIATION DE KEFF =,E16.10/)
  690 FORMAT (//19H FONCTION DE FORME ,A9//(5X,8E14.5))
  710 FORMAT (/37H NOMBRE MAXIMUM D'ITERATIONS ATTEINT.)
  720 FORMAT (/46H RESERREMENT DU CRITERE DE CONVERGENCE A EPS =,
     1 1P,E10.2/)
 1000 FORMAT(' CHANGE IN K-EFF :',E12.5)
 1010 FORMAT(/' THE NORMALIZATION FACTOR IS ',E12.5,
     1 ' AS THE CONSTRAINT FUNCTION IS ',E12.5)
 2000 FORMAT(/' WARNING ***** CHANGE IN K-EFF TOO LARGE=',E12.5)
      END
